/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

































#include "../P2ElementwiseDiffusionParametricP2Map.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseDiffusionParametricP2Map::computeInverseDiagonalOperatorValues_P2ElementwiseDiffusionParametricP2Map_macro_3D( real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t * RESTRICT  _data_micromesh_edge_0, real_t * RESTRICT  _data_micromesh_edge_1, real_t * RESTRICT  _data_micromesh_edge_2, real_t * RESTRICT  _data_micromesh_vertex_0, real_t * RESTRICT  _data_micromesh_vertex_1, real_t * RESTRICT  _data_micromesh_vertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_kernel_op_0 = 0.55278640450004202;
       const real_t tmp_kernel_op_1 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_2 = 0.55278640450004202;
       const real_t tmp_kernel_op_3 = 2.3416407864998736;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_2 + tmp_kernel_op_3;
       const real_t tmp_kernel_op_5 = -tmp_kernel_op_4 + 2.8944271909999157;
       const real_t tmp_kernel_op_7 = tmp_kernel_op_0 + tmp_kernel_op_4 - 3.0;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_2 - 1.0;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_0 - 4.0;
       const real_t tmp_kernel_op_13 = -tmp_kernel_op_12 - tmp_kernel_op_3 - 1.105572809000084;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_3 - 1.0;
       const real_t tmp_kernel_op_26 = -tmp_kernel_op_12 - tmp_kernel_op_2 - 4.6832815729997472;
       const real_t tmp_kernel_op_51 = 0.55278640450004202;
       const real_t tmp_kernel_op_52 = tmp_kernel_op_51 - 1.0;
       const real_t tmp_kernel_op_53 = 2.3416407864998736;
       const real_t tmp_kernel_op_54 = 0.55278640450004202;
       const real_t tmp_kernel_op_55 = tmp_kernel_op_53 + tmp_kernel_op_54;
       const real_t tmp_kernel_op_56 = -tmp_kernel_op_55 + 2.8944271909999157;
       const real_t tmp_kernel_op_58 = tmp_kernel_op_51 + tmp_kernel_op_55 - 3.0;
       const real_t tmp_kernel_op_62 = tmp_kernel_op_53 - 1.0;
       const real_t tmp_kernel_op_63 = tmp_kernel_op_51 - 4.0;
       const real_t tmp_kernel_op_64 = -tmp_kernel_op_54 - tmp_kernel_op_63 - 4.6832815729997472;
       const real_t tmp_kernel_op_76 = tmp_kernel_op_54 - 1.0;
       const real_t tmp_kernel_op_77 = -tmp_kernel_op_53 - tmp_kernel_op_63 - 1.105572809000084;
       const real_t tmp_kernel_op_102 = 2.3416407864998736;
       const real_t tmp_kernel_op_103 = tmp_kernel_op_102 - 1.0;
       const real_t tmp_kernel_op_104 = 0.55278640450004202;
       const real_t tmp_kernel_op_105 = 0.55278640450004202;
       const real_t tmp_kernel_op_106 = tmp_kernel_op_104 + tmp_kernel_op_105;
       const real_t tmp_kernel_op_107 = -tmp_kernel_op_106 - 0.68328157299974723;
       const real_t tmp_kernel_op_109 = tmp_kernel_op_102 + tmp_kernel_op_106 - 3.0;
       const real_t tmp_kernel_op_113 = tmp_kernel_op_104 - 1.0;
       const real_t tmp_kernel_op_114 = tmp_kernel_op_102 - 4.0;
       const real_t tmp_kernel_op_115 = -tmp_kernel_op_105 - tmp_kernel_op_114 - 1.105572809000084;
       const real_t tmp_kernel_op_127 = tmp_kernel_op_105 - 1.0;
       const real_t tmp_kernel_op_128 = -tmp_kernel_op_104 - tmp_kernel_op_114 - 1.105572809000084;
       const real_t tmp_kernel_op_153 = 0.55278640450004202;
       const real_t tmp_kernel_op_154 = tmp_kernel_op_153 - 1.0;
       const real_t tmp_kernel_op_155 = 0.55278640450004202;
       const real_t tmp_kernel_op_156 = 0.55278640450004202;
       const real_t tmp_kernel_op_157 = tmp_kernel_op_155 + tmp_kernel_op_156;
       const real_t tmp_kernel_op_158 = -tmp_kernel_op_157 + 2.8944271909999157;
       const real_t tmp_kernel_op_160 = tmp_kernel_op_153 + tmp_kernel_op_157 - 3.0;
       const real_t tmp_kernel_op_164 = tmp_kernel_op_155 - 1.0;
       const real_t tmp_kernel_op_165 = tmp_kernel_op_153 - 4.0;
       const real_t tmp_kernel_op_166 = -tmp_kernel_op_156 - tmp_kernel_op_165 - 1.105572809000084;
       const real_t tmp_kernel_op_178 = tmp_kernel_op_156 - 1.0;
       const real_t tmp_kernel_op_179 = -tmp_kernel_op_155 - tmp_kernel_op_165 - 1.105572809000084;
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_57 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_59 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_60 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_57),tmp_kernel_op_60);
                const __m256d tmp_kernel_op_65 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_65),tmp_kernel_op_67);
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_68);
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_57),tmp_kernel_op_59),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_73 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_67),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_74 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_78),tmp_kernel_op_80);
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_78),tmp_kernel_op_79),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_65),tmp_kernel_op_66),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_80),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_60),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_89 = _mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,tmp_kernel_op_81),_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),tmp_kernel_op_87));
                const __m256d tmp_kernel_op_91 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_87));
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_95 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_83),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_87),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_90))));
                const __m256d tmp_kernel_op_108 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)),tmp_kernel_op_110);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_108),tmp_kernel_op_111);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_117 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_116),tmp_kernel_op_118);
                const __m256d tmp_kernel_op_120 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_119);
                const __m256d tmp_kernel_op_121 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_108),tmp_kernel_op_110),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_118),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_120);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_129),tmp_kernel_op_131);
                const __m256d tmp_kernel_op_133 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_129),tmp_kernel_op_130),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_116),tmp_kernel_op_117),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_131),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_111),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_138);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_136)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_139),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),tmp_kernel_op_138));
                const __m256d tmp_kernel_op_142 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_138));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_146 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_134),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_135),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_141))));
                const __m256d tmp_kernel_op_159 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155)),tmp_kernel_op_161);
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_159),tmp_kernel_op_162);
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)),tmp_kernel_op_168);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_167),tmp_kernel_op_169);
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_159),tmp_kernel_op_161),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_175 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_169),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_175);
                const __m256d tmp_kernel_op_177 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_180),tmp_kernel_op_182);
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_180),tmp_kernel_op_181),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_167),tmp_kernel_op_168),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_182),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_189 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_162),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_191 = _mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_189);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_183),_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_187)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_191),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),tmp_kernel_op_189));
                const __m256d tmp_kernel_op_193 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192);
                const __m256d tmp_kernel_op_194 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_190,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_196 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_187);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_185),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_189),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_199 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_189),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_185),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_186),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_202 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_192))));
                const __m256d tmp_kernel_op_204 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_206 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_207 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_211 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_214 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_24);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_232 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_249 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_252);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_230);
                const __m256d tmp_kernel_op_266 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_271 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_285 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_288 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_293 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_296 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_299 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_244);
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)))))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_145),tmp_kernel_op_209),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148),tmp_kernel_op_209)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_209)))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_196),tmp_kernel_op_211),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_199),tmp_kernel_op_211)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_202),tmp_kernel_op_211)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_144),tmp_kernel_op_214),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_147),tmp_kernel_op_214)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_214))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_195),tmp_kernel_op_215),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_198),tmp_kernel_op_215)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_201),tmp_kernel_op_215)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45))),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_126),tmp_kernel_op_218),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_146),tmp_kernel_op_218)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149),tmp_kernel_op_218))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_177),tmp_kernel_op_219),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_197),tmp_kernel_op_219)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_200),tmp_kernel_op_219)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98)))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223),_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225),_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227),_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231),_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233),_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235),_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239),_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241),_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243),_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247),_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249),_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251),_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254),_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256),_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258),_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261),_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263),_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265),_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268),_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270),_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272),_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275),_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277),_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279),_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281),_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283),_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285),_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287),_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289),_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291),_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293),_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295),_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297),_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299),_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301),_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303),_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_46 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_49 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_57 = -micromesh_dof_7*tmp_kernel_op_54;
                const real_t tmp_kernel_op_59 = micromesh_dof_0*tmp_kernel_op_58;
                const real_t tmp_kernel_op_60 = -micromesh_dof_8*tmp_kernel_op_53 + tmp_kernel_op_59;
                const real_t tmp_kernel_op_61 = micromesh_dof_1*tmp_kernel_op_52 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_53 + micromesh_dof_9*tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_60;
                const real_t tmp_kernel_op_65 = -micromesh_dof_19*tmp_kernel_op_51;
                const real_t tmp_kernel_op_66 = micromesh_dof_10*tmp_kernel_op_58;
                const real_t tmp_kernel_op_67 = -micromesh_dof_17*tmp_kernel_op_54 + tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = micromesh_dof_12*tmp_kernel_op_62 + micromesh_dof_14*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_51 + micromesh_dof_18*tmp_kernel_op_64 + tmp_kernel_op_65 + tmp_kernel_op_67;
                const real_t tmp_kernel_op_69 = tmp_kernel_op_61*tmp_kernel_op_68;
                const real_t tmp_kernel_op_70 = -micromesh_dof_9*tmp_kernel_op_51;
                const real_t tmp_kernel_op_71 = micromesh_dof_2*tmp_kernel_op_62 + micromesh_dof_4*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_51 + micromesh_dof_8*tmp_kernel_op_64 + tmp_kernel_op_57 + tmp_kernel_op_59 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = -micromesh_dof_18*tmp_kernel_op_53;
                const real_t tmp_kernel_op_73 = micromesh_dof_11*tmp_kernel_op_52 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_53 + micromesh_dof_19*tmp_kernel_op_56 + tmp_kernel_op_67 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_74 = tmp_kernel_op_71*tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = tmp_kernel_op_69 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_78 = -micromesh_dof_28*tmp_kernel_op_53;
                const real_t tmp_kernel_op_79 = micromesh_dof_20*tmp_kernel_op_58;
                const real_t tmp_kernel_op_80 = -micromesh_dof_29*tmp_kernel_op_51 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = micromesh_dof_23*tmp_kernel_op_76 + micromesh_dof_24*tmp_kernel_op_53 + micromesh_dof_25*tmp_kernel_op_51 + micromesh_dof_27*tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_80;
                const real_t tmp_kernel_op_82 = -micromesh_dof_27*tmp_kernel_op_54;
                const real_t tmp_kernel_op_83 = micromesh_dof_21*tmp_kernel_op_52 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_53 + micromesh_dof_29*tmp_kernel_op_56 + tmp_kernel_op_78 + tmp_kernel_op_79 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_13*tmp_kernel_op_76 + micromesh_dof_14*tmp_kernel_op_53 + micromesh_dof_15*tmp_kernel_op_51 + micromesh_dof_17*tmp_kernel_op_77 + tmp_kernel_op_65 + tmp_kernel_op_66 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_85 = tmp_kernel_op_71*tmp_kernel_op_84;
                const real_t tmp_kernel_op_86 = micromesh_dof_22*tmp_kernel_op_62 + micromesh_dof_24*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_51 + micromesh_dof_28*tmp_kernel_op_64 + tmp_kernel_op_80 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_87 = micromesh_dof_3*tmp_kernel_op_76 + micromesh_dof_4*tmp_kernel_op_53 + micromesh_dof_5*tmp_kernel_op_51 + micromesh_dof_7*tmp_kernel_op_77 + tmp_kernel_op_60 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_61*tmp_kernel_op_84;
                const real_t tmp_kernel_op_89 = tmp_kernel_op_68*tmp_kernel_op_87;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_69*tmp_kernel_op_81 + tmp_kernel_op_73*tmp_kernel_op_86*tmp_kernel_op_87 - tmp_kernel_op_74*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_85 - tmp_kernel_op_83*tmp_kernel_op_89 - tmp_kernel_op_86*tmp_kernel_op_88;
                const real_t tmp_kernel_op_91 = 1.0 / (tmp_kernel_op_90);
                const real_t tmp_kernel_op_92 = tmp_kernel_op_58*tmp_kernel_op_91;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_73*tmp_kernel_op_87 - tmp_kernel_op_88;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_85 - tmp_kernel_op_89;
                const real_t tmp_kernel_op_95 = -tmp_kernel_op_61*tmp_kernel_op_86 + tmp_kernel_op_71*tmp_kernel_op_83;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_61*tmp_kernel_op_81 - tmp_kernel_op_83*tmp_kernel_op_87;
                const real_t tmp_kernel_op_97 = -tmp_kernel_op_71*tmp_kernel_op_81 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_98 = -tmp_kernel_op_68*tmp_kernel_op_83 + tmp_kernel_op_73*tmp_kernel_op_86;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_73*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_84;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_68*tmp_kernel_op_81 - tmp_kernel_op_84*tmp_kernel_op_86;
                const real_t tmp_kernel_op_101 = 0.041666666666666657*abs(tmp_kernel_op_90);
                const real_t tmp_kernel_op_108 = -micromesh_dof_7*tmp_kernel_op_105;
                const real_t tmp_kernel_op_110 = micromesh_dof_0*tmp_kernel_op_109;
                const real_t tmp_kernel_op_111 = -micromesh_dof_8*tmp_kernel_op_104 + tmp_kernel_op_110;
                const real_t tmp_kernel_op_112 = micromesh_dof_1*tmp_kernel_op_103 + micromesh_dof_5*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_104 + micromesh_dof_9*tmp_kernel_op_107 + tmp_kernel_op_108 + tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = -micromesh_dof_19*tmp_kernel_op_102;
                const real_t tmp_kernel_op_117 = micromesh_dof_10*tmp_kernel_op_109;
                const real_t tmp_kernel_op_118 = -micromesh_dof_17*tmp_kernel_op_105 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_119 = micromesh_dof_12*tmp_kernel_op_113 + micromesh_dof_14*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_102 + micromesh_dof_18*tmp_kernel_op_115 + tmp_kernel_op_116 + tmp_kernel_op_118;
                const real_t tmp_kernel_op_120 = tmp_kernel_op_112*tmp_kernel_op_119;
                const real_t tmp_kernel_op_121 = -micromesh_dof_9*tmp_kernel_op_102;
                const real_t tmp_kernel_op_122 = micromesh_dof_2*tmp_kernel_op_113 + micromesh_dof_4*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_102 + micromesh_dof_8*tmp_kernel_op_115 + tmp_kernel_op_108 + tmp_kernel_op_110 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_123 = -micromesh_dof_18*tmp_kernel_op_104;
                const real_t tmp_kernel_op_124 = micromesh_dof_11*tmp_kernel_op_103 + micromesh_dof_15*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_104 + micromesh_dof_19*tmp_kernel_op_107 + tmp_kernel_op_118 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_122*tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_120 - tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = -micromesh_dof_28*tmp_kernel_op_104;
                const real_t tmp_kernel_op_130 = micromesh_dof_20*tmp_kernel_op_109;
                const real_t tmp_kernel_op_131 = -micromesh_dof_29*tmp_kernel_op_102 + tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = micromesh_dof_23*tmp_kernel_op_127 + micromesh_dof_24*tmp_kernel_op_104 + micromesh_dof_25*tmp_kernel_op_102 + micromesh_dof_27*tmp_kernel_op_128 + tmp_kernel_op_129 + tmp_kernel_op_131;
                const real_t tmp_kernel_op_133 = -micromesh_dof_27*tmp_kernel_op_105;
                const real_t tmp_kernel_op_134 = micromesh_dof_21*tmp_kernel_op_103 + micromesh_dof_25*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_104 + micromesh_dof_29*tmp_kernel_op_107 + tmp_kernel_op_129 + tmp_kernel_op_130 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = micromesh_dof_13*tmp_kernel_op_127 + micromesh_dof_14*tmp_kernel_op_104 + micromesh_dof_15*tmp_kernel_op_102 + micromesh_dof_17*tmp_kernel_op_128 + tmp_kernel_op_116 + tmp_kernel_op_117 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_136 = tmp_kernel_op_122*tmp_kernel_op_135;
                const real_t tmp_kernel_op_137 = micromesh_dof_22*tmp_kernel_op_113 + micromesh_dof_24*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_102 + micromesh_dof_28*tmp_kernel_op_115 + tmp_kernel_op_131 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_138 = micromesh_dof_3*tmp_kernel_op_127 + micromesh_dof_4*tmp_kernel_op_104 + micromesh_dof_5*tmp_kernel_op_102 + micromesh_dof_7*tmp_kernel_op_128 + tmp_kernel_op_111 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_139 = tmp_kernel_op_112*tmp_kernel_op_135;
                const real_t tmp_kernel_op_140 = tmp_kernel_op_119*tmp_kernel_op_138;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_120*tmp_kernel_op_132 + tmp_kernel_op_124*tmp_kernel_op_137*tmp_kernel_op_138 - tmp_kernel_op_125*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_136 - tmp_kernel_op_134*tmp_kernel_op_140 - tmp_kernel_op_137*tmp_kernel_op_139;
                const real_t tmp_kernel_op_142 = 1.0 / (tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_109*tmp_kernel_op_142;
                const real_t tmp_kernel_op_144 = tmp_kernel_op_124*tmp_kernel_op_138 - tmp_kernel_op_139;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_136 - tmp_kernel_op_140;
                const real_t tmp_kernel_op_146 = -tmp_kernel_op_112*tmp_kernel_op_137 + tmp_kernel_op_122*tmp_kernel_op_134;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_112*tmp_kernel_op_132 - tmp_kernel_op_134*tmp_kernel_op_138;
                const real_t tmp_kernel_op_148 = -tmp_kernel_op_122*tmp_kernel_op_132 + tmp_kernel_op_137*tmp_kernel_op_138;
                const real_t tmp_kernel_op_149 = -tmp_kernel_op_119*tmp_kernel_op_134 + tmp_kernel_op_124*tmp_kernel_op_137;
                const real_t tmp_kernel_op_150 = -tmp_kernel_op_124*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_135;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_119*tmp_kernel_op_132 - tmp_kernel_op_135*tmp_kernel_op_137;
                const real_t tmp_kernel_op_152 = 0.041666666666666657*abs(tmp_kernel_op_141);
                const real_t tmp_kernel_op_159 = -micromesh_dof_7*tmp_kernel_op_156;
                const real_t tmp_kernel_op_161 = micromesh_dof_0*tmp_kernel_op_160;
                const real_t tmp_kernel_op_162 = -micromesh_dof_8*tmp_kernel_op_155 + tmp_kernel_op_161;
                const real_t tmp_kernel_op_163 = micromesh_dof_1*tmp_kernel_op_154 + micromesh_dof_5*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_155 + micromesh_dof_9*tmp_kernel_op_158 + tmp_kernel_op_159 + tmp_kernel_op_162;
                const real_t tmp_kernel_op_167 = -micromesh_dof_19*tmp_kernel_op_153;
                const real_t tmp_kernel_op_168 = micromesh_dof_10*tmp_kernel_op_160;
                const real_t tmp_kernel_op_169 = -micromesh_dof_17*tmp_kernel_op_156 + tmp_kernel_op_168;
                const real_t tmp_kernel_op_170 = micromesh_dof_12*tmp_kernel_op_164 + micromesh_dof_14*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_153 + micromesh_dof_18*tmp_kernel_op_166 + tmp_kernel_op_167 + tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_163*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = -micromesh_dof_9*tmp_kernel_op_153;
                const real_t tmp_kernel_op_173 = micromesh_dof_2*tmp_kernel_op_164 + micromesh_dof_4*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_153 + micromesh_dof_8*tmp_kernel_op_166 + tmp_kernel_op_159 + tmp_kernel_op_161 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_174 = -micromesh_dof_18*tmp_kernel_op_155;
                const real_t tmp_kernel_op_175 = micromesh_dof_11*tmp_kernel_op_154 + micromesh_dof_15*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_155 + micromesh_dof_19*tmp_kernel_op_158 + tmp_kernel_op_169 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_173*tmp_kernel_op_175;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_171 - tmp_kernel_op_176;
                const real_t tmp_kernel_op_180 = -micromesh_dof_28*tmp_kernel_op_155;
                const real_t tmp_kernel_op_181 = micromesh_dof_20*tmp_kernel_op_160;
                const real_t tmp_kernel_op_182 = -micromesh_dof_29*tmp_kernel_op_153 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = micromesh_dof_23*tmp_kernel_op_178 + micromesh_dof_24*tmp_kernel_op_155 + micromesh_dof_25*tmp_kernel_op_153 + micromesh_dof_27*tmp_kernel_op_179 + tmp_kernel_op_180 + tmp_kernel_op_182;
                const real_t tmp_kernel_op_184 = -micromesh_dof_27*tmp_kernel_op_156;
                const real_t tmp_kernel_op_185 = micromesh_dof_21*tmp_kernel_op_154 + micromesh_dof_25*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_155 + micromesh_dof_29*tmp_kernel_op_158 + tmp_kernel_op_180 + tmp_kernel_op_181 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = micromesh_dof_13*tmp_kernel_op_178 + micromesh_dof_14*tmp_kernel_op_155 + micromesh_dof_15*tmp_kernel_op_153 + micromesh_dof_17*tmp_kernel_op_179 + tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_173*tmp_kernel_op_186;
                const real_t tmp_kernel_op_188 = micromesh_dof_22*tmp_kernel_op_164 + micromesh_dof_24*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_153 + micromesh_dof_28*tmp_kernel_op_166 + tmp_kernel_op_182 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_189 = micromesh_dof_3*tmp_kernel_op_178 + micromesh_dof_4*tmp_kernel_op_155 + micromesh_dof_5*tmp_kernel_op_153 + micromesh_dof_7*tmp_kernel_op_179 + tmp_kernel_op_162 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_163*tmp_kernel_op_186;
                const real_t tmp_kernel_op_191 = tmp_kernel_op_170*tmp_kernel_op_189;
                const real_t tmp_kernel_op_192 = tmp_kernel_op_171*tmp_kernel_op_183 + tmp_kernel_op_175*tmp_kernel_op_188*tmp_kernel_op_189 - tmp_kernel_op_176*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_187 - tmp_kernel_op_185*tmp_kernel_op_191 - tmp_kernel_op_188*tmp_kernel_op_190;
                const real_t tmp_kernel_op_193 = 1.0 / (tmp_kernel_op_192);
                const real_t tmp_kernel_op_194 = tmp_kernel_op_160*tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = tmp_kernel_op_175*tmp_kernel_op_189 - tmp_kernel_op_190;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_187 - tmp_kernel_op_191;
                const real_t tmp_kernel_op_197 = -tmp_kernel_op_163*tmp_kernel_op_188 + tmp_kernel_op_173*tmp_kernel_op_185;
                const real_t tmp_kernel_op_198 = tmp_kernel_op_163*tmp_kernel_op_183 - tmp_kernel_op_185*tmp_kernel_op_189;
                const real_t tmp_kernel_op_199 = -tmp_kernel_op_173*tmp_kernel_op_183 + tmp_kernel_op_188*tmp_kernel_op_189;
                const real_t tmp_kernel_op_200 = -tmp_kernel_op_170*tmp_kernel_op_185 + tmp_kernel_op_175*tmp_kernel_op_188;
                const real_t tmp_kernel_op_201 = -tmp_kernel_op_175*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_186;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_170*tmp_kernel_op_183 - tmp_kernel_op_186*tmp_kernel_op_188;
                const real_t tmp_kernel_op_203 = 0.041666666666666657*abs(tmp_kernel_op_192);
                const real_t tmp_kernel_op_204 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39)*16.0;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_206 = 1.0 / (tmp_kernel_op_90*tmp_kernel_op_90)*16.0;
                const real_t tmp_kernel_op_207 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_208 = 1.0 / (tmp_kernel_op_141*tmp_kernel_op_141)*16.0;
                const real_t tmp_kernel_op_209 = tmp_kernel_op_208*0.11249999999999996;
                const real_t tmp_kernel_op_210 = 1.0 / (tmp_kernel_op_192*tmp_kernel_op_192)*16.0;
                const real_t tmp_kernel_op_211 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_206*0.11249999999999996;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_204*0.11249999999999996;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_24;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_222*tmp_kernel_op_42;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_220*tmp_kernel_op_44;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_222*tmp_kernel_op_45;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_220*tmp_kernel_op_47;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_222*tmp_kernel_op_48;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_91*0.5854101966249684;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_228*tmp_kernel_op_75;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_230*tmp_kernel_op_93;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_228*tmp_kernel_op_95;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_230*tmp_kernel_op_96;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_228*tmp_kernel_op_98;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_230*tmp_kernel_op_99;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_126*tmp_kernel_op_236;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_144*tmp_kernel_op_238;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_146*tmp_kernel_op_236;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_147*tmp_kernel_op_238;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_149*tmp_kernel_op_236;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_150*tmp_kernel_op_238;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_177*tmp_kernel_op_244;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_195*tmp_kernel_op_246;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_197*tmp_kernel_op_244;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_198*tmp_kernel_op_246;
                const real_t tmp_kernel_op_250 = tmp_kernel_op_200*tmp_kernel_op_244;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_201*tmp_kernel_op_246;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_24*tmp_kernel_op_252;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_222*tmp_kernel_op_43;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_252*tmp_kernel_op_44;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_222*tmp_kernel_op_46;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_252*tmp_kernel_op_47;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_222*tmp_kernel_op_49;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_259*tmp_kernel_op_75;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_230*tmp_kernel_op_94;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_259*tmp_kernel_op_95;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_230*tmp_kernel_op_97;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_259*tmp_kernel_op_98;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_100*tmp_kernel_op_230;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_142*0.5854101966249684;
                const real_t tmp_kernel_op_267 = tmp_kernel_op_126*tmp_kernel_op_266;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_145*tmp_kernel_op_238;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_146*tmp_kernel_op_266;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_148*tmp_kernel_op_238;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_149*tmp_kernel_op_266;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_151*tmp_kernel_op_238;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_177*tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_196*tmp_kernel_op_246;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_197*tmp_kernel_op_273;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_199*tmp_kernel_op_246;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_200*tmp_kernel_op_273;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_202*tmp_kernel_op_246;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_252*tmp_kernel_op_42;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_220*tmp_kernel_op_43;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_252*tmp_kernel_op_45;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_220*tmp_kernel_op_46;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_252*tmp_kernel_op_48;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_220*tmp_kernel_op_49;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_259*tmp_kernel_op_93;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_228*tmp_kernel_op_94;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_259*tmp_kernel_op_96;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_228*tmp_kernel_op_97;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_259*tmp_kernel_op_99;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_100*tmp_kernel_op_228;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_144*tmp_kernel_op_266;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_145*tmp_kernel_op_236;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_147*tmp_kernel_op_266;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_148*tmp_kernel_op_236;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_150*tmp_kernel_op_266;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_151*tmp_kernel_op_236;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_195*tmp_kernel_op_273;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_196*tmp_kernel_op_244;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_198*tmp_kernel_op_273;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_199*tmp_kernel_op_244;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_201*tmp_kernel_op_273;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_202*tmp_kernel_op_244;
                const real_t elMatDiag_0 = tmp_kernel_op_101*(((tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)*(tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)) + ((tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)*(tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)) + ((tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97)*(tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97))) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)*(tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)) + ((tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)*(tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)) + ((tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151)*(tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151))) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)*(tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)) + ((tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)*(tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)) + ((tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202)*(tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202))) + tmp_kernel_op_50*(((tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)*(tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)) + ((tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)*(tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)) + ((tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)*(tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)));
                const real_t elMatDiag_1 = tmp_kernel_op_101*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_207 + tmp_kernel_op_207*(tmp_kernel_op_94*tmp_kernel_op_94) + tmp_kernel_op_207*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_152*((tmp_kernel_op_145*tmp_kernel_op_145)*tmp_kernel_op_209 + (tmp_kernel_op_148*tmp_kernel_op_148)*tmp_kernel_op_209 + (tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_209) + tmp_kernel_op_203*((tmp_kernel_op_196*tmp_kernel_op_196)*tmp_kernel_op_211 + (tmp_kernel_op_199*tmp_kernel_op_199)*tmp_kernel_op_211 + (tmp_kernel_op_202*tmp_kernel_op_202)*tmp_kernel_op_211) + tmp_kernel_op_50*(tmp_kernel_op_205*(tmp_kernel_op_43*tmp_kernel_op_43) + tmp_kernel_op_205*(tmp_kernel_op_46*tmp_kernel_op_46) + tmp_kernel_op_205*(tmp_kernel_op_49*tmp_kernel_op_49));
                const real_t elMatDiag_2 = tmp_kernel_op_101*(tmp_kernel_op_213*(tmp_kernel_op_93*tmp_kernel_op_93) + tmp_kernel_op_213*(tmp_kernel_op_96*tmp_kernel_op_96) + tmp_kernel_op_213*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_152*((tmp_kernel_op_144*tmp_kernel_op_144)*tmp_kernel_op_214 + (tmp_kernel_op_147*tmp_kernel_op_147)*tmp_kernel_op_214 + (tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_214) + tmp_kernel_op_203*((tmp_kernel_op_195*tmp_kernel_op_195)*tmp_kernel_op_215 + (tmp_kernel_op_198*tmp_kernel_op_198)*tmp_kernel_op_215 + (tmp_kernel_op_201*tmp_kernel_op_201)*tmp_kernel_op_215) + tmp_kernel_op_50*(tmp_kernel_op_212*(tmp_kernel_op_42*tmp_kernel_op_42) + tmp_kernel_op_212*(tmp_kernel_op_45*tmp_kernel_op_45) + tmp_kernel_op_212*(tmp_kernel_op_48*tmp_kernel_op_48));
                const real_t elMatDiag_3 = tmp_kernel_op_101*(tmp_kernel_op_217*(tmp_kernel_op_75*tmp_kernel_op_75) + tmp_kernel_op_217*(tmp_kernel_op_95*tmp_kernel_op_95) + tmp_kernel_op_217*(tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_152*((tmp_kernel_op_126*tmp_kernel_op_126)*tmp_kernel_op_218 + (tmp_kernel_op_146*tmp_kernel_op_146)*tmp_kernel_op_218 + (tmp_kernel_op_149*tmp_kernel_op_149)*tmp_kernel_op_218) + tmp_kernel_op_203*((tmp_kernel_op_177*tmp_kernel_op_177)*tmp_kernel_op_219 + (tmp_kernel_op_197*tmp_kernel_op_197)*tmp_kernel_op_219 + (tmp_kernel_op_200*tmp_kernel_op_200)*tmp_kernel_op_219) + tmp_kernel_op_50*(tmp_kernel_op_216*(tmp_kernel_op_24*tmp_kernel_op_24) + tmp_kernel_op_216*(tmp_kernel_op_44*tmp_kernel_op_44) + tmp_kernel_op_216*(tmp_kernel_op_47*tmp_kernel_op_47));
                const real_t elMatDiag_4 = tmp_kernel_op_101*(((tmp_kernel_op_229 + tmp_kernel_op_231)*(tmp_kernel_op_229 + tmp_kernel_op_231))*16.0 + ((tmp_kernel_op_232 + tmp_kernel_op_233)*(tmp_kernel_op_232 + tmp_kernel_op_233))*16.0 + ((tmp_kernel_op_234 + tmp_kernel_op_235)*(tmp_kernel_op_234 + tmp_kernel_op_235))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_237 + tmp_kernel_op_239)*(tmp_kernel_op_237 + tmp_kernel_op_239))*16.0 + ((tmp_kernel_op_240 + tmp_kernel_op_241)*(tmp_kernel_op_240 + tmp_kernel_op_241))*16.0 + ((tmp_kernel_op_242 + tmp_kernel_op_243)*(tmp_kernel_op_242 + tmp_kernel_op_243))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_245 + tmp_kernel_op_247)*(tmp_kernel_op_245 + tmp_kernel_op_247))*16.0 + ((tmp_kernel_op_248 + tmp_kernel_op_249)*(tmp_kernel_op_248 + tmp_kernel_op_249))*16.0 + ((tmp_kernel_op_250 + tmp_kernel_op_251)*(tmp_kernel_op_250 + tmp_kernel_op_251))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_221 + tmp_kernel_op_223)*(tmp_kernel_op_221 + tmp_kernel_op_223))*16.0 + ((tmp_kernel_op_224 + tmp_kernel_op_225)*(tmp_kernel_op_224 + tmp_kernel_op_225))*16.0 + ((tmp_kernel_op_226 + tmp_kernel_op_227)*(tmp_kernel_op_226 + tmp_kernel_op_227))*16.0);
                const real_t elMatDiag_5 = tmp_kernel_op_101*(((tmp_kernel_op_260 + tmp_kernel_op_261)*(tmp_kernel_op_260 + tmp_kernel_op_261))*16.0 + ((tmp_kernel_op_262 + tmp_kernel_op_263)*(tmp_kernel_op_262 + tmp_kernel_op_263))*16.0 + ((tmp_kernel_op_264 + tmp_kernel_op_265)*(tmp_kernel_op_264 + tmp_kernel_op_265))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_267 + tmp_kernel_op_268)*(tmp_kernel_op_267 + tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_269 + tmp_kernel_op_270)*(tmp_kernel_op_269 + tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_271 + tmp_kernel_op_272)*(tmp_kernel_op_271 + tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_274 + tmp_kernel_op_275)*(tmp_kernel_op_274 + tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_276 + tmp_kernel_op_277)*(tmp_kernel_op_276 + tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_278 + tmp_kernel_op_279)*(tmp_kernel_op_278 + tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_253 + tmp_kernel_op_254)*(tmp_kernel_op_253 + tmp_kernel_op_254))*16.0 + ((tmp_kernel_op_255 + tmp_kernel_op_256)*(tmp_kernel_op_255 + tmp_kernel_op_256))*16.0 + ((tmp_kernel_op_257 + tmp_kernel_op_258)*(tmp_kernel_op_257 + tmp_kernel_op_258))*16.0);
                const real_t elMatDiag_6 = tmp_kernel_op_101*(((tmp_kernel_op_286 + tmp_kernel_op_287)*(tmp_kernel_op_286 + tmp_kernel_op_287))*16.0 + ((tmp_kernel_op_288 + tmp_kernel_op_289)*(tmp_kernel_op_288 + tmp_kernel_op_289))*16.0 + ((tmp_kernel_op_290 + tmp_kernel_op_291)*(tmp_kernel_op_290 + tmp_kernel_op_291))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_292 + tmp_kernel_op_293)*(tmp_kernel_op_292 + tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_294 + tmp_kernel_op_295)*(tmp_kernel_op_294 + tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_296 + tmp_kernel_op_297)*(tmp_kernel_op_296 + tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_298 + tmp_kernel_op_299)*(tmp_kernel_op_298 + tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_300 + tmp_kernel_op_301)*(tmp_kernel_op_300 + tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_302 + tmp_kernel_op_303)*(tmp_kernel_op_302 + tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_280 + tmp_kernel_op_281)*(tmp_kernel_op_280 + tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_282 + tmp_kernel_op_283)*(tmp_kernel_op_282 + tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_284 + tmp_kernel_op_285)*(tmp_kernel_op_284 + tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_7 = tmp_kernel_op_101*(((-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25)*(-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25))*16.0 + ((-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25)*(-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25))*16.0 + ((-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25)*(-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268)*(tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275)*(tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254)*(-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254))*16.0 + ((-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25)*(-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25))*16.0 + ((-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25)*(-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25))*16.0);
                const real_t elMatDiag_8 = tmp_kernel_op_101*(((-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25)*(-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25))*16.0 + ((-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25))*16.0 + ((-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_9 = tmp_kernel_op_101*(((-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290)*(tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25))*16.0);
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_57 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_59 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_60 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_57),tmp_kernel_op_60);
                const __m256d tmp_kernel_op_65 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_65),tmp_kernel_op_67);
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_68);
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_57),tmp_kernel_op_59),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_73 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_67),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_74 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_78),tmp_kernel_op_80);
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_78),tmp_kernel_op_79),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_65),tmp_kernel_op_66),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_80),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_60),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_89 = _mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,tmp_kernel_op_81),_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),tmp_kernel_op_87));
                const __m256d tmp_kernel_op_91 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_87));
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_95 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_83),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_87),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_90))));
                const __m256d tmp_kernel_op_108 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)),tmp_kernel_op_110);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_108),tmp_kernel_op_111);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_117 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_116),tmp_kernel_op_118);
                const __m256d tmp_kernel_op_120 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_119);
                const __m256d tmp_kernel_op_121 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_108),tmp_kernel_op_110),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_118),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_120);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_129),tmp_kernel_op_131);
                const __m256d tmp_kernel_op_133 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_129),tmp_kernel_op_130),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_116),tmp_kernel_op_117),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_131),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_111),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_138);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_136)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_139),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),tmp_kernel_op_138));
                const __m256d tmp_kernel_op_142 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_138));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_146 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_134),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_135),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_141))));
                const __m256d tmp_kernel_op_159 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155)),tmp_kernel_op_161);
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_159),tmp_kernel_op_162);
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)),tmp_kernel_op_168);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_167),tmp_kernel_op_169);
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_159),tmp_kernel_op_161),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_175 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_169),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_175);
                const __m256d tmp_kernel_op_177 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_180),tmp_kernel_op_182);
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_180),tmp_kernel_op_181),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_167),tmp_kernel_op_168),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_182),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_189 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_162),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_191 = _mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_189);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_183),_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_187)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_191),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),tmp_kernel_op_189));
                const __m256d tmp_kernel_op_193 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192);
                const __m256d tmp_kernel_op_194 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_190,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_196 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_187);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_185),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_189),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_199 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_189),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_185),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_186),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_202 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_192))));
                const __m256d tmp_kernel_op_204 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_206 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_207 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_211 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_214 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_24);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_232 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_249 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_252);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_230);
                const __m256d tmp_kernel_op_266 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_271 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_285 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_288 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_293 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_296 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_299 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_244);
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)))))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_145),tmp_kernel_op_209),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148),tmp_kernel_op_209)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_209)))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_196),tmp_kernel_op_211),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_199),tmp_kernel_op_211)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_202),tmp_kernel_op_211)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_144),tmp_kernel_op_214),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_147),tmp_kernel_op_214)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_214))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_195),tmp_kernel_op_215),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_198),tmp_kernel_op_215)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_201),tmp_kernel_op_215)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45))),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_126),tmp_kernel_op_218),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_146),tmp_kernel_op_218)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149),tmp_kernel_op_218))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_177),tmp_kernel_op_219),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_197),tmp_kernel_op_219)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_200),tmp_kernel_op_219)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98)))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223),_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225),_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227),_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231),_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233),_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235),_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239),_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241),_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243),_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247),_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249),_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251),_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254),_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256),_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258),_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261),_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263),_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265),_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268),_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270),_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272),_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275),_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277),_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279),_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281),_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283),_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285),_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287),_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289),_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291),_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293),_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295),_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297),_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299),_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301),_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303),_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_46 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_49 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_57 = -micromesh_dof_7*tmp_kernel_op_54;
                const real_t tmp_kernel_op_59 = micromesh_dof_0*tmp_kernel_op_58;
                const real_t tmp_kernel_op_60 = -micromesh_dof_8*tmp_kernel_op_53 + tmp_kernel_op_59;
                const real_t tmp_kernel_op_61 = micromesh_dof_1*tmp_kernel_op_52 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_53 + micromesh_dof_9*tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_60;
                const real_t tmp_kernel_op_65 = -micromesh_dof_19*tmp_kernel_op_51;
                const real_t tmp_kernel_op_66 = micromesh_dof_10*tmp_kernel_op_58;
                const real_t tmp_kernel_op_67 = -micromesh_dof_17*tmp_kernel_op_54 + tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = micromesh_dof_12*tmp_kernel_op_62 + micromesh_dof_14*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_51 + micromesh_dof_18*tmp_kernel_op_64 + tmp_kernel_op_65 + tmp_kernel_op_67;
                const real_t tmp_kernel_op_69 = tmp_kernel_op_61*tmp_kernel_op_68;
                const real_t tmp_kernel_op_70 = -micromesh_dof_9*tmp_kernel_op_51;
                const real_t tmp_kernel_op_71 = micromesh_dof_2*tmp_kernel_op_62 + micromesh_dof_4*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_51 + micromesh_dof_8*tmp_kernel_op_64 + tmp_kernel_op_57 + tmp_kernel_op_59 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = -micromesh_dof_18*tmp_kernel_op_53;
                const real_t tmp_kernel_op_73 = micromesh_dof_11*tmp_kernel_op_52 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_53 + micromesh_dof_19*tmp_kernel_op_56 + tmp_kernel_op_67 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_74 = tmp_kernel_op_71*tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = tmp_kernel_op_69 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_78 = -micromesh_dof_28*tmp_kernel_op_53;
                const real_t tmp_kernel_op_79 = micromesh_dof_20*tmp_kernel_op_58;
                const real_t tmp_kernel_op_80 = -micromesh_dof_29*tmp_kernel_op_51 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = micromesh_dof_23*tmp_kernel_op_76 + micromesh_dof_24*tmp_kernel_op_53 + micromesh_dof_25*tmp_kernel_op_51 + micromesh_dof_27*tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_80;
                const real_t tmp_kernel_op_82 = -micromesh_dof_27*tmp_kernel_op_54;
                const real_t tmp_kernel_op_83 = micromesh_dof_21*tmp_kernel_op_52 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_53 + micromesh_dof_29*tmp_kernel_op_56 + tmp_kernel_op_78 + tmp_kernel_op_79 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_13*tmp_kernel_op_76 + micromesh_dof_14*tmp_kernel_op_53 + micromesh_dof_15*tmp_kernel_op_51 + micromesh_dof_17*tmp_kernel_op_77 + tmp_kernel_op_65 + tmp_kernel_op_66 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_85 = tmp_kernel_op_71*tmp_kernel_op_84;
                const real_t tmp_kernel_op_86 = micromesh_dof_22*tmp_kernel_op_62 + micromesh_dof_24*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_51 + micromesh_dof_28*tmp_kernel_op_64 + tmp_kernel_op_80 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_87 = micromesh_dof_3*tmp_kernel_op_76 + micromesh_dof_4*tmp_kernel_op_53 + micromesh_dof_5*tmp_kernel_op_51 + micromesh_dof_7*tmp_kernel_op_77 + tmp_kernel_op_60 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_61*tmp_kernel_op_84;
                const real_t tmp_kernel_op_89 = tmp_kernel_op_68*tmp_kernel_op_87;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_69*tmp_kernel_op_81 + tmp_kernel_op_73*tmp_kernel_op_86*tmp_kernel_op_87 - tmp_kernel_op_74*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_85 - tmp_kernel_op_83*tmp_kernel_op_89 - tmp_kernel_op_86*tmp_kernel_op_88;
                const real_t tmp_kernel_op_91 = 1.0 / (tmp_kernel_op_90);
                const real_t tmp_kernel_op_92 = tmp_kernel_op_58*tmp_kernel_op_91;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_73*tmp_kernel_op_87 - tmp_kernel_op_88;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_85 - tmp_kernel_op_89;
                const real_t tmp_kernel_op_95 = -tmp_kernel_op_61*tmp_kernel_op_86 + tmp_kernel_op_71*tmp_kernel_op_83;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_61*tmp_kernel_op_81 - tmp_kernel_op_83*tmp_kernel_op_87;
                const real_t tmp_kernel_op_97 = -tmp_kernel_op_71*tmp_kernel_op_81 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_98 = -tmp_kernel_op_68*tmp_kernel_op_83 + tmp_kernel_op_73*tmp_kernel_op_86;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_73*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_84;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_68*tmp_kernel_op_81 - tmp_kernel_op_84*tmp_kernel_op_86;
                const real_t tmp_kernel_op_101 = 0.041666666666666657*abs(tmp_kernel_op_90);
                const real_t tmp_kernel_op_108 = -micromesh_dof_7*tmp_kernel_op_105;
                const real_t tmp_kernel_op_110 = micromesh_dof_0*tmp_kernel_op_109;
                const real_t tmp_kernel_op_111 = -micromesh_dof_8*tmp_kernel_op_104 + tmp_kernel_op_110;
                const real_t tmp_kernel_op_112 = micromesh_dof_1*tmp_kernel_op_103 + micromesh_dof_5*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_104 + micromesh_dof_9*tmp_kernel_op_107 + tmp_kernel_op_108 + tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = -micromesh_dof_19*tmp_kernel_op_102;
                const real_t tmp_kernel_op_117 = micromesh_dof_10*tmp_kernel_op_109;
                const real_t tmp_kernel_op_118 = -micromesh_dof_17*tmp_kernel_op_105 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_119 = micromesh_dof_12*tmp_kernel_op_113 + micromesh_dof_14*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_102 + micromesh_dof_18*tmp_kernel_op_115 + tmp_kernel_op_116 + tmp_kernel_op_118;
                const real_t tmp_kernel_op_120 = tmp_kernel_op_112*tmp_kernel_op_119;
                const real_t tmp_kernel_op_121 = -micromesh_dof_9*tmp_kernel_op_102;
                const real_t tmp_kernel_op_122 = micromesh_dof_2*tmp_kernel_op_113 + micromesh_dof_4*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_102 + micromesh_dof_8*tmp_kernel_op_115 + tmp_kernel_op_108 + tmp_kernel_op_110 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_123 = -micromesh_dof_18*tmp_kernel_op_104;
                const real_t tmp_kernel_op_124 = micromesh_dof_11*tmp_kernel_op_103 + micromesh_dof_15*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_104 + micromesh_dof_19*tmp_kernel_op_107 + tmp_kernel_op_118 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_122*tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_120 - tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = -micromesh_dof_28*tmp_kernel_op_104;
                const real_t tmp_kernel_op_130 = micromesh_dof_20*tmp_kernel_op_109;
                const real_t tmp_kernel_op_131 = -micromesh_dof_29*tmp_kernel_op_102 + tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = micromesh_dof_23*tmp_kernel_op_127 + micromesh_dof_24*tmp_kernel_op_104 + micromesh_dof_25*tmp_kernel_op_102 + micromesh_dof_27*tmp_kernel_op_128 + tmp_kernel_op_129 + tmp_kernel_op_131;
                const real_t tmp_kernel_op_133 = -micromesh_dof_27*tmp_kernel_op_105;
                const real_t tmp_kernel_op_134 = micromesh_dof_21*tmp_kernel_op_103 + micromesh_dof_25*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_104 + micromesh_dof_29*tmp_kernel_op_107 + tmp_kernel_op_129 + tmp_kernel_op_130 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = micromesh_dof_13*tmp_kernel_op_127 + micromesh_dof_14*tmp_kernel_op_104 + micromesh_dof_15*tmp_kernel_op_102 + micromesh_dof_17*tmp_kernel_op_128 + tmp_kernel_op_116 + tmp_kernel_op_117 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_136 = tmp_kernel_op_122*tmp_kernel_op_135;
                const real_t tmp_kernel_op_137 = micromesh_dof_22*tmp_kernel_op_113 + micromesh_dof_24*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_102 + micromesh_dof_28*tmp_kernel_op_115 + tmp_kernel_op_131 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_138 = micromesh_dof_3*tmp_kernel_op_127 + micromesh_dof_4*tmp_kernel_op_104 + micromesh_dof_5*tmp_kernel_op_102 + micromesh_dof_7*tmp_kernel_op_128 + tmp_kernel_op_111 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_139 = tmp_kernel_op_112*tmp_kernel_op_135;
                const real_t tmp_kernel_op_140 = tmp_kernel_op_119*tmp_kernel_op_138;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_120*tmp_kernel_op_132 + tmp_kernel_op_124*tmp_kernel_op_137*tmp_kernel_op_138 - tmp_kernel_op_125*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_136 - tmp_kernel_op_134*tmp_kernel_op_140 - tmp_kernel_op_137*tmp_kernel_op_139;
                const real_t tmp_kernel_op_142 = 1.0 / (tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_109*tmp_kernel_op_142;
                const real_t tmp_kernel_op_144 = tmp_kernel_op_124*tmp_kernel_op_138 - tmp_kernel_op_139;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_136 - tmp_kernel_op_140;
                const real_t tmp_kernel_op_146 = -tmp_kernel_op_112*tmp_kernel_op_137 + tmp_kernel_op_122*tmp_kernel_op_134;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_112*tmp_kernel_op_132 - tmp_kernel_op_134*tmp_kernel_op_138;
                const real_t tmp_kernel_op_148 = -tmp_kernel_op_122*tmp_kernel_op_132 + tmp_kernel_op_137*tmp_kernel_op_138;
                const real_t tmp_kernel_op_149 = -tmp_kernel_op_119*tmp_kernel_op_134 + tmp_kernel_op_124*tmp_kernel_op_137;
                const real_t tmp_kernel_op_150 = -tmp_kernel_op_124*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_135;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_119*tmp_kernel_op_132 - tmp_kernel_op_135*tmp_kernel_op_137;
                const real_t tmp_kernel_op_152 = 0.041666666666666657*abs(tmp_kernel_op_141);
                const real_t tmp_kernel_op_159 = -micromesh_dof_7*tmp_kernel_op_156;
                const real_t tmp_kernel_op_161 = micromesh_dof_0*tmp_kernel_op_160;
                const real_t tmp_kernel_op_162 = -micromesh_dof_8*tmp_kernel_op_155 + tmp_kernel_op_161;
                const real_t tmp_kernel_op_163 = micromesh_dof_1*tmp_kernel_op_154 + micromesh_dof_5*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_155 + micromesh_dof_9*tmp_kernel_op_158 + tmp_kernel_op_159 + tmp_kernel_op_162;
                const real_t tmp_kernel_op_167 = -micromesh_dof_19*tmp_kernel_op_153;
                const real_t tmp_kernel_op_168 = micromesh_dof_10*tmp_kernel_op_160;
                const real_t tmp_kernel_op_169 = -micromesh_dof_17*tmp_kernel_op_156 + tmp_kernel_op_168;
                const real_t tmp_kernel_op_170 = micromesh_dof_12*tmp_kernel_op_164 + micromesh_dof_14*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_153 + micromesh_dof_18*tmp_kernel_op_166 + tmp_kernel_op_167 + tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_163*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = -micromesh_dof_9*tmp_kernel_op_153;
                const real_t tmp_kernel_op_173 = micromesh_dof_2*tmp_kernel_op_164 + micromesh_dof_4*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_153 + micromesh_dof_8*tmp_kernel_op_166 + tmp_kernel_op_159 + tmp_kernel_op_161 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_174 = -micromesh_dof_18*tmp_kernel_op_155;
                const real_t tmp_kernel_op_175 = micromesh_dof_11*tmp_kernel_op_154 + micromesh_dof_15*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_155 + micromesh_dof_19*tmp_kernel_op_158 + tmp_kernel_op_169 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_173*tmp_kernel_op_175;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_171 - tmp_kernel_op_176;
                const real_t tmp_kernel_op_180 = -micromesh_dof_28*tmp_kernel_op_155;
                const real_t tmp_kernel_op_181 = micromesh_dof_20*tmp_kernel_op_160;
                const real_t tmp_kernel_op_182 = -micromesh_dof_29*tmp_kernel_op_153 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = micromesh_dof_23*tmp_kernel_op_178 + micromesh_dof_24*tmp_kernel_op_155 + micromesh_dof_25*tmp_kernel_op_153 + micromesh_dof_27*tmp_kernel_op_179 + tmp_kernel_op_180 + tmp_kernel_op_182;
                const real_t tmp_kernel_op_184 = -micromesh_dof_27*tmp_kernel_op_156;
                const real_t tmp_kernel_op_185 = micromesh_dof_21*tmp_kernel_op_154 + micromesh_dof_25*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_155 + micromesh_dof_29*tmp_kernel_op_158 + tmp_kernel_op_180 + tmp_kernel_op_181 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = micromesh_dof_13*tmp_kernel_op_178 + micromesh_dof_14*tmp_kernel_op_155 + micromesh_dof_15*tmp_kernel_op_153 + micromesh_dof_17*tmp_kernel_op_179 + tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_173*tmp_kernel_op_186;
                const real_t tmp_kernel_op_188 = micromesh_dof_22*tmp_kernel_op_164 + micromesh_dof_24*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_153 + micromesh_dof_28*tmp_kernel_op_166 + tmp_kernel_op_182 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_189 = micromesh_dof_3*tmp_kernel_op_178 + micromesh_dof_4*tmp_kernel_op_155 + micromesh_dof_5*tmp_kernel_op_153 + micromesh_dof_7*tmp_kernel_op_179 + tmp_kernel_op_162 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_163*tmp_kernel_op_186;
                const real_t tmp_kernel_op_191 = tmp_kernel_op_170*tmp_kernel_op_189;
                const real_t tmp_kernel_op_192 = tmp_kernel_op_171*tmp_kernel_op_183 + tmp_kernel_op_175*tmp_kernel_op_188*tmp_kernel_op_189 - tmp_kernel_op_176*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_187 - tmp_kernel_op_185*tmp_kernel_op_191 - tmp_kernel_op_188*tmp_kernel_op_190;
                const real_t tmp_kernel_op_193 = 1.0 / (tmp_kernel_op_192);
                const real_t tmp_kernel_op_194 = tmp_kernel_op_160*tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = tmp_kernel_op_175*tmp_kernel_op_189 - tmp_kernel_op_190;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_187 - tmp_kernel_op_191;
                const real_t tmp_kernel_op_197 = -tmp_kernel_op_163*tmp_kernel_op_188 + tmp_kernel_op_173*tmp_kernel_op_185;
                const real_t tmp_kernel_op_198 = tmp_kernel_op_163*tmp_kernel_op_183 - tmp_kernel_op_185*tmp_kernel_op_189;
                const real_t tmp_kernel_op_199 = -tmp_kernel_op_173*tmp_kernel_op_183 + tmp_kernel_op_188*tmp_kernel_op_189;
                const real_t tmp_kernel_op_200 = -tmp_kernel_op_170*tmp_kernel_op_185 + tmp_kernel_op_175*tmp_kernel_op_188;
                const real_t tmp_kernel_op_201 = -tmp_kernel_op_175*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_186;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_170*tmp_kernel_op_183 - tmp_kernel_op_186*tmp_kernel_op_188;
                const real_t tmp_kernel_op_203 = 0.041666666666666657*abs(tmp_kernel_op_192);
                const real_t tmp_kernel_op_204 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39)*16.0;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_206 = 1.0 / (tmp_kernel_op_90*tmp_kernel_op_90)*16.0;
                const real_t tmp_kernel_op_207 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_208 = 1.0 / (tmp_kernel_op_141*tmp_kernel_op_141)*16.0;
                const real_t tmp_kernel_op_209 = tmp_kernel_op_208*0.11249999999999996;
                const real_t tmp_kernel_op_210 = 1.0 / (tmp_kernel_op_192*tmp_kernel_op_192)*16.0;
                const real_t tmp_kernel_op_211 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_206*0.11249999999999996;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_204*0.11249999999999996;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_24;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_222*tmp_kernel_op_42;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_220*tmp_kernel_op_44;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_222*tmp_kernel_op_45;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_220*tmp_kernel_op_47;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_222*tmp_kernel_op_48;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_91*0.5854101966249684;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_228*tmp_kernel_op_75;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_230*tmp_kernel_op_93;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_228*tmp_kernel_op_95;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_230*tmp_kernel_op_96;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_228*tmp_kernel_op_98;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_230*tmp_kernel_op_99;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_126*tmp_kernel_op_236;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_144*tmp_kernel_op_238;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_146*tmp_kernel_op_236;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_147*tmp_kernel_op_238;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_149*tmp_kernel_op_236;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_150*tmp_kernel_op_238;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_177*tmp_kernel_op_244;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_195*tmp_kernel_op_246;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_197*tmp_kernel_op_244;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_198*tmp_kernel_op_246;
                const real_t tmp_kernel_op_250 = tmp_kernel_op_200*tmp_kernel_op_244;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_201*tmp_kernel_op_246;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_24*tmp_kernel_op_252;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_222*tmp_kernel_op_43;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_252*tmp_kernel_op_44;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_222*tmp_kernel_op_46;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_252*tmp_kernel_op_47;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_222*tmp_kernel_op_49;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_259*tmp_kernel_op_75;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_230*tmp_kernel_op_94;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_259*tmp_kernel_op_95;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_230*tmp_kernel_op_97;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_259*tmp_kernel_op_98;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_100*tmp_kernel_op_230;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_142*0.5854101966249684;
                const real_t tmp_kernel_op_267 = tmp_kernel_op_126*tmp_kernel_op_266;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_145*tmp_kernel_op_238;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_146*tmp_kernel_op_266;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_148*tmp_kernel_op_238;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_149*tmp_kernel_op_266;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_151*tmp_kernel_op_238;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_177*tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_196*tmp_kernel_op_246;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_197*tmp_kernel_op_273;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_199*tmp_kernel_op_246;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_200*tmp_kernel_op_273;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_202*tmp_kernel_op_246;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_252*tmp_kernel_op_42;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_220*tmp_kernel_op_43;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_252*tmp_kernel_op_45;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_220*tmp_kernel_op_46;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_252*tmp_kernel_op_48;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_220*tmp_kernel_op_49;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_259*tmp_kernel_op_93;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_228*tmp_kernel_op_94;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_259*tmp_kernel_op_96;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_228*tmp_kernel_op_97;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_259*tmp_kernel_op_99;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_100*tmp_kernel_op_228;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_144*tmp_kernel_op_266;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_145*tmp_kernel_op_236;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_147*tmp_kernel_op_266;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_148*tmp_kernel_op_236;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_150*tmp_kernel_op_266;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_151*tmp_kernel_op_236;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_195*tmp_kernel_op_273;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_196*tmp_kernel_op_244;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_198*tmp_kernel_op_273;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_199*tmp_kernel_op_244;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_201*tmp_kernel_op_273;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_202*tmp_kernel_op_244;
                const real_t elMatDiag_0 = tmp_kernel_op_101*(((tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)*(tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)) + ((tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)*(tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)) + ((tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97)*(tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97))) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)*(tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)) + ((tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)*(tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)) + ((tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151)*(tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151))) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)*(tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)) + ((tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)*(tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)) + ((tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202)*(tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202))) + tmp_kernel_op_50*(((tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)*(tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)) + ((tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)*(tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)) + ((tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)*(tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)));
                const real_t elMatDiag_1 = tmp_kernel_op_101*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_207 + tmp_kernel_op_207*(tmp_kernel_op_94*tmp_kernel_op_94) + tmp_kernel_op_207*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_152*((tmp_kernel_op_145*tmp_kernel_op_145)*tmp_kernel_op_209 + (tmp_kernel_op_148*tmp_kernel_op_148)*tmp_kernel_op_209 + (tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_209) + tmp_kernel_op_203*((tmp_kernel_op_196*tmp_kernel_op_196)*tmp_kernel_op_211 + (tmp_kernel_op_199*tmp_kernel_op_199)*tmp_kernel_op_211 + (tmp_kernel_op_202*tmp_kernel_op_202)*tmp_kernel_op_211) + tmp_kernel_op_50*(tmp_kernel_op_205*(tmp_kernel_op_43*tmp_kernel_op_43) + tmp_kernel_op_205*(tmp_kernel_op_46*tmp_kernel_op_46) + tmp_kernel_op_205*(tmp_kernel_op_49*tmp_kernel_op_49));
                const real_t elMatDiag_2 = tmp_kernel_op_101*(tmp_kernel_op_213*(tmp_kernel_op_93*tmp_kernel_op_93) + tmp_kernel_op_213*(tmp_kernel_op_96*tmp_kernel_op_96) + tmp_kernel_op_213*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_152*((tmp_kernel_op_144*tmp_kernel_op_144)*tmp_kernel_op_214 + (tmp_kernel_op_147*tmp_kernel_op_147)*tmp_kernel_op_214 + (tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_214) + tmp_kernel_op_203*((tmp_kernel_op_195*tmp_kernel_op_195)*tmp_kernel_op_215 + (tmp_kernel_op_198*tmp_kernel_op_198)*tmp_kernel_op_215 + (tmp_kernel_op_201*tmp_kernel_op_201)*tmp_kernel_op_215) + tmp_kernel_op_50*(tmp_kernel_op_212*(tmp_kernel_op_42*tmp_kernel_op_42) + tmp_kernel_op_212*(tmp_kernel_op_45*tmp_kernel_op_45) + tmp_kernel_op_212*(tmp_kernel_op_48*tmp_kernel_op_48));
                const real_t elMatDiag_3 = tmp_kernel_op_101*(tmp_kernel_op_217*(tmp_kernel_op_75*tmp_kernel_op_75) + tmp_kernel_op_217*(tmp_kernel_op_95*tmp_kernel_op_95) + tmp_kernel_op_217*(tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_152*((tmp_kernel_op_126*tmp_kernel_op_126)*tmp_kernel_op_218 + (tmp_kernel_op_146*tmp_kernel_op_146)*tmp_kernel_op_218 + (tmp_kernel_op_149*tmp_kernel_op_149)*tmp_kernel_op_218) + tmp_kernel_op_203*((tmp_kernel_op_177*tmp_kernel_op_177)*tmp_kernel_op_219 + (tmp_kernel_op_197*tmp_kernel_op_197)*tmp_kernel_op_219 + (tmp_kernel_op_200*tmp_kernel_op_200)*tmp_kernel_op_219) + tmp_kernel_op_50*(tmp_kernel_op_216*(tmp_kernel_op_24*tmp_kernel_op_24) + tmp_kernel_op_216*(tmp_kernel_op_44*tmp_kernel_op_44) + tmp_kernel_op_216*(tmp_kernel_op_47*tmp_kernel_op_47));
                const real_t elMatDiag_4 = tmp_kernel_op_101*(((tmp_kernel_op_229 + tmp_kernel_op_231)*(tmp_kernel_op_229 + tmp_kernel_op_231))*16.0 + ((tmp_kernel_op_232 + tmp_kernel_op_233)*(tmp_kernel_op_232 + tmp_kernel_op_233))*16.0 + ((tmp_kernel_op_234 + tmp_kernel_op_235)*(tmp_kernel_op_234 + tmp_kernel_op_235))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_237 + tmp_kernel_op_239)*(tmp_kernel_op_237 + tmp_kernel_op_239))*16.0 + ((tmp_kernel_op_240 + tmp_kernel_op_241)*(tmp_kernel_op_240 + tmp_kernel_op_241))*16.0 + ((tmp_kernel_op_242 + tmp_kernel_op_243)*(tmp_kernel_op_242 + tmp_kernel_op_243))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_245 + tmp_kernel_op_247)*(tmp_kernel_op_245 + tmp_kernel_op_247))*16.0 + ((tmp_kernel_op_248 + tmp_kernel_op_249)*(tmp_kernel_op_248 + tmp_kernel_op_249))*16.0 + ((tmp_kernel_op_250 + tmp_kernel_op_251)*(tmp_kernel_op_250 + tmp_kernel_op_251))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_221 + tmp_kernel_op_223)*(tmp_kernel_op_221 + tmp_kernel_op_223))*16.0 + ((tmp_kernel_op_224 + tmp_kernel_op_225)*(tmp_kernel_op_224 + tmp_kernel_op_225))*16.0 + ((tmp_kernel_op_226 + tmp_kernel_op_227)*(tmp_kernel_op_226 + tmp_kernel_op_227))*16.0);
                const real_t elMatDiag_5 = tmp_kernel_op_101*(((tmp_kernel_op_260 + tmp_kernel_op_261)*(tmp_kernel_op_260 + tmp_kernel_op_261))*16.0 + ((tmp_kernel_op_262 + tmp_kernel_op_263)*(tmp_kernel_op_262 + tmp_kernel_op_263))*16.0 + ((tmp_kernel_op_264 + tmp_kernel_op_265)*(tmp_kernel_op_264 + tmp_kernel_op_265))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_267 + tmp_kernel_op_268)*(tmp_kernel_op_267 + tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_269 + tmp_kernel_op_270)*(tmp_kernel_op_269 + tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_271 + tmp_kernel_op_272)*(tmp_kernel_op_271 + tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_274 + tmp_kernel_op_275)*(tmp_kernel_op_274 + tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_276 + tmp_kernel_op_277)*(tmp_kernel_op_276 + tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_278 + tmp_kernel_op_279)*(tmp_kernel_op_278 + tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_253 + tmp_kernel_op_254)*(tmp_kernel_op_253 + tmp_kernel_op_254))*16.0 + ((tmp_kernel_op_255 + tmp_kernel_op_256)*(tmp_kernel_op_255 + tmp_kernel_op_256))*16.0 + ((tmp_kernel_op_257 + tmp_kernel_op_258)*(tmp_kernel_op_257 + tmp_kernel_op_258))*16.0);
                const real_t elMatDiag_6 = tmp_kernel_op_101*(((tmp_kernel_op_286 + tmp_kernel_op_287)*(tmp_kernel_op_286 + tmp_kernel_op_287))*16.0 + ((tmp_kernel_op_288 + tmp_kernel_op_289)*(tmp_kernel_op_288 + tmp_kernel_op_289))*16.0 + ((tmp_kernel_op_290 + tmp_kernel_op_291)*(tmp_kernel_op_290 + tmp_kernel_op_291))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_292 + tmp_kernel_op_293)*(tmp_kernel_op_292 + tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_294 + tmp_kernel_op_295)*(tmp_kernel_op_294 + tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_296 + tmp_kernel_op_297)*(tmp_kernel_op_296 + tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_298 + tmp_kernel_op_299)*(tmp_kernel_op_298 + tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_300 + tmp_kernel_op_301)*(tmp_kernel_op_300 + tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_302 + tmp_kernel_op_303)*(tmp_kernel_op_302 + tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_280 + tmp_kernel_op_281)*(tmp_kernel_op_280 + tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_282 + tmp_kernel_op_283)*(tmp_kernel_op_282 + tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_284 + tmp_kernel_op_285)*(tmp_kernel_op_284 + tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_7 = tmp_kernel_op_101*(((-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25)*(-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25))*16.0 + ((-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25)*(-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25))*16.0 + ((-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25)*(-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268)*(tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275)*(tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254)*(-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254))*16.0 + ((-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25)*(-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25))*16.0 + ((-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25)*(-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25))*16.0);
                const real_t elMatDiag_8 = tmp_kernel_op_101*(((-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25)*(-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25))*16.0 + ((-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25))*16.0 + ((-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_9 = tmp_kernel_op_101*(((-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290)*(tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25))*16.0);
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_57 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_59 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_60 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_57),tmp_kernel_op_60);
                const __m256d tmp_kernel_op_65 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_65),tmp_kernel_op_67);
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_68);
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_57),tmp_kernel_op_59),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_73 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_67),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_74 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_78),tmp_kernel_op_80);
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_78),tmp_kernel_op_79),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_65),tmp_kernel_op_66),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_80),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_60),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_89 = _mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,tmp_kernel_op_81),_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),tmp_kernel_op_87));
                const __m256d tmp_kernel_op_91 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_87));
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_95 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_83),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_87),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_90))));
                const __m256d tmp_kernel_op_108 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)),tmp_kernel_op_110);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_108),tmp_kernel_op_111);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_117 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_116),tmp_kernel_op_118);
                const __m256d tmp_kernel_op_120 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_119);
                const __m256d tmp_kernel_op_121 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_108),tmp_kernel_op_110),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_118),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_120);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_129),tmp_kernel_op_131);
                const __m256d tmp_kernel_op_133 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_129),tmp_kernel_op_130),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_116),tmp_kernel_op_117),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_131),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_111),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_138);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_136)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_139),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),tmp_kernel_op_138));
                const __m256d tmp_kernel_op_142 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_138));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_146 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_134),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_135),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_141))));
                const __m256d tmp_kernel_op_159 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155)),tmp_kernel_op_161);
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_159),tmp_kernel_op_162);
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)),tmp_kernel_op_168);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_167),tmp_kernel_op_169);
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_159),tmp_kernel_op_161),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_175 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_169),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_175);
                const __m256d tmp_kernel_op_177 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_180),tmp_kernel_op_182);
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_180),tmp_kernel_op_181),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_167),tmp_kernel_op_168),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_182),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_189 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_162),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_191 = _mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_189);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_183),_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_187)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_191),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),tmp_kernel_op_189));
                const __m256d tmp_kernel_op_193 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192);
                const __m256d tmp_kernel_op_194 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_190,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_196 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_187);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_185),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_189),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_199 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_189),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_185),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_186),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_202 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_192))));
                const __m256d tmp_kernel_op_204 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_206 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_207 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_211 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_214 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_24);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_232 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_249 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_252);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_230);
                const __m256d tmp_kernel_op_266 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_271 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_285 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_288 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_293 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_296 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_299 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_244);
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)))))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_145),tmp_kernel_op_209),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148),tmp_kernel_op_209)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_209)))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_196),tmp_kernel_op_211),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_199),tmp_kernel_op_211)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_202),tmp_kernel_op_211)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_144),tmp_kernel_op_214),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_147),tmp_kernel_op_214)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_214))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_195),tmp_kernel_op_215),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_198),tmp_kernel_op_215)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_201),tmp_kernel_op_215)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45))),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_126),tmp_kernel_op_218),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_146),tmp_kernel_op_218)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149),tmp_kernel_op_218))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_177),tmp_kernel_op_219),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_197),tmp_kernel_op_219)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_200),tmp_kernel_op_219)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98)))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223),_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225),_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227),_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231),_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233),_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235),_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239),_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241),_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243),_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247),_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249),_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251),_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254),_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256),_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258),_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261),_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263),_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265),_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268),_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270),_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272),_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275),_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277),_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279),_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281),_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283),_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285),_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287),_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289),_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291),_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293),_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295),_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297),_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299),_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301),_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303),_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_46 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_49 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_57 = -micromesh_dof_7*tmp_kernel_op_54;
                const real_t tmp_kernel_op_59 = micromesh_dof_0*tmp_kernel_op_58;
                const real_t tmp_kernel_op_60 = -micromesh_dof_8*tmp_kernel_op_53 + tmp_kernel_op_59;
                const real_t tmp_kernel_op_61 = micromesh_dof_1*tmp_kernel_op_52 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_53 + micromesh_dof_9*tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_60;
                const real_t tmp_kernel_op_65 = -micromesh_dof_19*tmp_kernel_op_51;
                const real_t tmp_kernel_op_66 = micromesh_dof_10*tmp_kernel_op_58;
                const real_t tmp_kernel_op_67 = -micromesh_dof_17*tmp_kernel_op_54 + tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = micromesh_dof_12*tmp_kernel_op_62 + micromesh_dof_14*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_51 + micromesh_dof_18*tmp_kernel_op_64 + tmp_kernel_op_65 + tmp_kernel_op_67;
                const real_t tmp_kernel_op_69 = tmp_kernel_op_61*tmp_kernel_op_68;
                const real_t tmp_kernel_op_70 = -micromesh_dof_9*tmp_kernel_op_51;
                const real_t tmp_kernel_op_71 = micromesh_dof_2*tmp_kernel_op_62 + micromesh_dof_4*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_51 + micromesh_dof_8*tmp_kernel_op_64 + tmp_kernel_op_57 + tmp_kernel_op_59 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = -micromesh_dof_18*tmp_kernel_op_53;
                const real_t tmp_kernel_op_73 = micromesh_dof_11*tmp_kernel_op_52 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_53 + micromesh_dof_19*tmp_kernel_op_56 + tmp_kernel_op_67 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_74 = tmp_kernel_op_71*tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = tmp_kernel_op_69 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_78 = -micromesh_dof_28*tmp_kernel_op_53;
                const real_t tmp_kernel_op_79 = micromesh_dof_20*tmp_kernel_op_58;
                const real_t tmp_kernel_op_80 = -micromesh_dof_29*tmp_kernel_op_51 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = micromesh_dof_23*tmp_kernel_op_76 + micromesh_dof_24*tmp_kernel_op_53 + micromesh_dof_25*tmp_kernel_op_51 + micromesh_dof_27*tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_80;
                const real_t tmp_kernel_op_82 = -micromesh_dof_27*tmp_kernel_op_54;
                const real_t tmp_kernel_op_83 = micromesh_dof_21*tmp_kernel_op_52 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_53 + micromesh_dof_29*tmp_kernel_op_56 + tmp_kernel_op_78 + tmp_kernel_op_79 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_13*tmp_kernel_op_76 + micromesh_dof_14*tmp_kernel_op_53 + micromesh_dof_15*tmp_kernel_op_51 + micromesh_dof_17*tmp_kernel_op_77 + tmp_kernel_op_65 + tmp_kernel_op_66 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_85 = tmp_kernel_op_71*tmp_kernel_op_84;
                const real_t tmp_kernel_op_86 = micromesh_dof_22*tmp_kernel_op_62 + micromesh_dof_24*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_51 + micromesh_dof_28*tmp_kernel_op_64 + tmp_kernel_op_80 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_87 = micromesh_dof_3*tmp_kernel_op_76 + micromesh_dof_4*tmp_kernel_op_53 + micromesh_dof_5*tmp_kernel_op_51 + micromesh_dof_7*tmp_kernel_op_77 + tmp_kernel_op_60 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_61*tmp_kernel_op_84;
                const real_t tmp_kernel_op_89 = tmp_kernel_op_68*tmp_kernel_op_87;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_69*tmp_kernel_op_81 + tmp_kernel_op_73*tmp_kernel_op_86*tmp_kernel_op_87 - tmp_kernel_op_74*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_85 - tmp_kernel_op_83*tmp_kernel_op_89 - tmp_kernel_op_86*tmp_kernel_op_88;
                const real_t tmp_kernel_op_91 = 1.0 / (tmp_kernel_op_90);
                const real_t tmp_kernel_op_92 = tmp_kernel_op_58*tmp_kernel_op_91;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_73*tmp_kernel_op_87 - tmp_kernel_op_88;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_85 - tmp_kernel_op_89;
                const real_t tmp_kernel_op_95 = -tmp_kernel_op_61*tmp_kernel_op_86 + tmp_kernel_op_71*tmp_kernel_op_83;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_61*tmp_kernel_op_81 - tmp_kernel_op_83*tmp_kernel_op_87;
                const real_t tmp_kernel_op_97 = -tmp_kernel_op_71*tmp_kernel_op_81 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_98 = -tmp_kernel_op_68*tmp_kernel_op_83 + tmp_kernel_op_73*tmp_kernel_op_86;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_73*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_84;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_68*tmp_kernel_op_81 - tmp_kernel_op_84*tmp_kernel_op_86;
                const real_t tmp_kernel_op_101 = 0.041666666666666657*abs(tmp_kernel_op_90);
                const real_t tmp_kernel_op_108 = -micromesh_dof_7*tmp_kernel_op_105;
                const real_t tmp_kernel_op_110 = micromesh_dof_0*tmp_kernel_op_109;
                const real_t tmp_kernel_op_111 = -micromesh_dof_8*tmp_kernel_op_104 + tmp_kernel_op_110;
                const real_t tmp_kernel_op_112 = micromesh_dof_1*tmp_kernel_op_103 + micromesh_dof_5*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_104 + micromesh_dof_9*tmp_kernel_op_107 + tmp_kernel_op_108 + tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = -micromesh_dof_19*tmp_kernel_op_102;
                const real_t tmp_kernel_op_117 = micromesh_dof_10*tmp_kernel_op_109;
                const real_t tmp_kernel_op_118 = -micromesh_dof_17*tmp_kernel_op_105 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_119 = micromesh_dof_12*tmp_kernel_op_113 + micromesh_dof_14*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_102 + micromesh_dof_18*tmp_kernel_op_115 + tmp_kernel_op_116 + tmp_kernel_op_118;
                const real_t tmp_kernel_op_120 = tmp_kernel_op_112*tmp_kernel_op_119;
                const real_t tmp_kernel_op_121 = -micromesh_dof_9*tmp_kernel_op_102;
                const real_t tmp_kernel_op_122 = micromesh_dof_2*tmp_kernel_op_113 + micromesh_dof_4*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_102 + micromesh_dof_8*tmp_kernel_op_115 + tmp_kernel_op_108 + tmp_kernel_op_110 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_123 = -micromesh_dof_18*tmp_kernel_op_104;
                const real_t tmp_kernel_op_124 = micromesh_dof_11*tmp_kernel_op_103 + micromesh_dof_15*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_104 + micromesh_dof_19*tmp_kernel_op_107 + tmp_kernel_op_118 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_122*tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_120 - tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = -micromesh_dof_28*tmp_kernel_op_104;
                const real_t tmp_kernel_op_130 = micromesh_dof_20*tmp_kernel_op_109;
                const real_t tmp_kernel_op_131 = -micromesh_dof_29*tmp_kernel_op_102 + tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = micromesh_dof_23*tmp_kernel_op_127 + micromesh_dof_24*tmp_kernel_op_104 + micromesh_dof_25*tmp_kernel_op_102 + micromesh_dof_27*tmp_kernel_op_128 + tmp_kernel_op_129 + tmp_kernel_op_131;
                const real_t tmp_kernel_op_133 = -micromesh_dof_27*tmp_kernel_op_105;
                const real_t tmp_kernel_op_134 = micromesh_dof_21*tmp_kernel_op_103 + micromesh_dof_25*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_104 + micromesh_dof_29*tmp_kernel_op_107 + tmp_kernel_op_129 + tmp_kernel_op_130 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = micromesh_dof_13*tmp_kernel_op_127 + micromesh_dof_14*tmp_kernel_op_104 + micromesh_dof_15*tmp_kernel_op_102 + micromesh_dof_17*tmp_kernel_op_128 + tmp_kernel_op_116 + tmp_kernel_op_117 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_136 = tmp_kernel_op_122*tmp_kernel_op_135;
                const real_t tmp_kernel_op_137 = micromesh_dof_22*tmp_kernel_op_113 + micromesh_dof_24*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_102 + micromesh_dof_28*tmp_kernel_op_115 + tmp_kernel_op_131 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_138 = micromesh_dof_3*tmp_kernel_op_127 + micromesh_dof_4*tmp_kernel_op_104 + micromesh_dof_5*tmp_kernel_op_102 + micromesh_dof_7*tmp_kernel_op_128 + tmp_kernel_op_111 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_139 = tmp_kernel_op_112*tmp_kernel_op_135;
                const real_t tmp_kernel_op_140 = tmp_kernel_op_119*tmp_kernel_op_138;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_120*tmp_kernel_op_132 + tmp_kernel_op_124*tmp_kernel_op_137*tmp_kernel_op_138 - tmp_kernel_op_125*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_136 - tmp_kernel_op_134*tmp_kernel_op_140 - tmp_kernel_op_137*tmp_kernel_op_139;
                const real_t tmp_kernel_op_142 = 1.0 / (tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_109*tmp_kernel_op_142;
                const real_t tmp_kernel_op_144 = tmp_kernel_op_124*tmp_kernel_op_138 - tmp_kernel_op_139;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_136 - tmp_kernel_op_140;
                const real_t tmp_kernel_op_146 = -tmp_kernel_op_112*tmp_kernel_op_137 + tmp_kernel_op_122*tmp_kernel_op_134;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_112*tmp_kernel_op_132 - tmp_kernel_op_134*tmp_kernel_op_138;
                const real_t tmp_kernel_op_148 = -tmp_kernel_op_122*tmp_kernel_op_132 + tmp_kernel_op_137*tmp_kernel_op_138;
                const real_t tmp_kernel_op_149 = -tmp_kernel_op_119*tmp_kernel_op_134 + tmp_kernel_op_124*tmp_kernel_op_137;
                const real_t tmp_kernel_op_150 = -tmp_kernel_op_124*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_135;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_119*tmp_kernel_op_132 - tmp_kernel_op_135*tmp_kernel_op_137;
                const real_t tmp_kernel_op_152 = 0.041666666666666657*abs(tmp_kernel_op_141);
                const real_t tmp_kernel_op_159 = -micromesh_dof_7*tmp_kernel_op_156;
                const real_t tmp_kernel_op_161 = micromesh_dof_0*tmp_kernel_op_160;
                const real_t tmp_kernel_op_162 = -micromesh_dof_8*tmp_kernel_op_155 + tmp_kernel_op_161;
                const real_t tmp_kernel_op_163 = micromesh_dof_1*tmp_kernel_op_154 + micromesh_dof_5*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_155 + micromesh_dof_9*tmp_kernel_op_158 + tmp_kernel_op_159 + tmp_kernel_op_162;
                const real_t tmp_kernel_op_167 = -micromesh_dof_19*tmp_kernel_op_153;
                const real_t tmp_kernel_op_168 = micromesh_dof_10*tmp_kernel_op_160;
                const real_t tmp_kernel_op_169 = -micromesh_dof_17*tmp_kernel_op_156 + tmp_kernel_op_168;
                const real_t tmp_kernel_op_170 = micromesh_dof_12*tmp_kernel_op_164 + micromesh_dof_14*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_153 + micromesh_dof_18*tmp_kernel_op_166 + tmp_kernel_op_167 + tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_163*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = -micromesh_dof_9*tmp_kernel_op_153;
                const real_t tmp_kernel_op_173 = micromesh_dof_2*tmp_kernel_op_164 + micromesh_dof_4*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_153 + micromesh_dof_8*tmp_kernel_op_166 + tmp_kernel_op_159 + tmp_kernel_op_161 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_174 = -micromesh_dof_18*tmp_kernel_op_155;
                const real_t tmp_kernel_op_175 = micromesh_dof_11*tmp_kernel_op_154 + micromesh_dof_15*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_155 + micromesh_dof_19*tmp_kernel_op_158 + tmp_kernel_op_169 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_173*tmp_kernel_op_175;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_171 - tmp_kernel_op_176;
                const real_t tmp_kernel_op_180 = -micromesh_dof_28*tmp_kernel_op_155;
                const real_t tmp_kernel_op_181 = micromesh_dof_20*tmp_kernel_op_160;
                const real_t tmp_kernel_op_182 = -micromesh_dof_29*tmp_kernel_op_153 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = micromesh_dof_23*tmp_kernel_op_178 + micromesh_dof_24*tmp_kernel_op_155 + micromesh_dof_25*tmp_kernel_op_153 + micromesh_dof_27*tmp_kernel_op_179 + tmp_kernel_op_180 + tmp_kernel_op_182;
                const real_t tmp_kernel_op_184 = -micromesh_dof_27*tmp_kernel_op_156;
                const real_t tmp_kernel_op_185 = micromesh_dof_21*tmp_kernel_op_154 + micromesh_dof_25*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_155 + micromesh_dof_29*tmp_kernel_op_158 + tmp_kernel_op_180 + tmp_kernel_op_181 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = micromesh_dof_13*tmp_kernel_op_178 + micromesh_dof_14*tmp_kernel_op_155 + micromesh_dof_15*tmp_kernel_op_153 + micromesh_dof_17*tmp_kernel_op_179 + tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_173*tmp_kernel_op_186;
                const real_t tmp_kernel_op_188 = micromesh_dof_22*tmp_kernel_op_164 + micromesh_dof_24*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_153 + micromesh_dof_28*tmp_kernel_op_166 + tmp_kernel_op_182 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_189 = micromesh_dof_3*tmp_kernel_op_178 + micromesh_dof_4*tmp_kernel_op_155 + micromesh_dof_5*tmp_kernel_op_153 + micromesh_dof_7*tmp_kernel_op_179 + tmp_kernel_op_162 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_163*tmp_kernel_op_186;
                const real_t tmp_kernel_op_191 = tmp_kernel_op_170*tmp_kernel_op_189;
                const real_t tmp_kernel_op_192 = tmp_kernel_op_171*tmp_kernel_op_183 + tmp_kernel_op_175*tmp_kernel_op_188*tmp_kernel_op_189 - tmp_kernel_op_176*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_187 - tmp_kernel_op_185*tmp_kernel_op_191 - tmp_kernel_op_188*tmp_kernel_op_190;
                const real_t tmp_kernel_op_193 = 1.0 / (tmp_kernel_op_192);
                const real_t tmp_kernel_op_194 = tmp_kernel_op_160*tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = tmp_kernel_op_175*tmp_kernel_op_189 - tmp_kernel_op_190;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_187 - tmp_kernel_op_191;
                const real_t tmp_kernel_op_197 = -tmp_kernel_op_163*tmp_kernel_op_188 + tmp_kernel_op_173*tmp_kernel_op_185;
                const real_t tmp_kernel_op_198 = tmp_kernel_op_163*tmp_kernel_op_183 - tmp_kernel_op_185*tmp_kernel_op_189;
                const real_t tmp_kernel_op_199 = -tmp_kernel_op_173*tmp_kernel_op_183 + tmp_kernel_op_188*tmp_kernel_op_189;
                const real_t tmp_kernel_op_200 = -tmp_kernel_op_170*tmp_kernel_op_185 + tmp_kernel_op_175*tmp_kernel_op_188;
                const real_t tmp_kernel_op_201 = -tmp_kernel_op_175*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_186;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_170*tmp_kernel_op_183 - tmp_kernel_op_186*tmp_kernel_op_188;
                const real_t tmp_kernel_op_203 = 0.041666666666666657*abs(tmp_kernel_op_192);
                const real_t tmp_kernel_op_204 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39)*16.0;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_206 = 1.0 / (tmp_kernel_op_90*tmp_kernel_op_90)*16.0;
                const real_t tmp_kernel_op_207 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_208 = 1.0 / (tmp_kernel_op_141*tmp_kernel_op_141)*16.0;
                const real_t tmp_kernel_op_209 = tmp_kernel_op_208*0.11249999999999996;
                const real_t tmp_kernel_op_210 = 1.0 / (tmp_kernel_op_192*tmp_kernel_op_192)*16.0;
                const real_t tmp_kernel_op_211 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_206*0.11249999999999996;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_204*0.11249999999999996;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_24;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_222*tmp_kernel_op_42;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_220*tmp_kernel_op_44;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_222*tmp_kernel_op_45;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_220*tmp_kernel_op_47;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_222*tmp_kernel_op_48;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_91*0.5854101966249684;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_228*tmp_kernel_op_75;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_230*tmp_kernel_op_93;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_228*tmp_kernel_op_95;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_230*tmp_kernel_op_96;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_228*tmp_kernel_op_98;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_230*tmp_kernel_op_99;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_126*tmp_kernel_op_236;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_144*tmp_kernel_op_238;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_146*tmp_kernel_op_236;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_147*tmp_kernel_op_238;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_149*tmp_kernel_op_236;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_150*tmp_kernel_op_238;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_177*tmp_kernel_op_244;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_195*tmp_kernel_op_246;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_197*tmp_kernel_op_244;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_198*tmp_kernel_op_246;
                const real_t tmp_kernel_op_250 = tmp_kernel_op_200*tmp_kernel_op_244;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_201*tmp_kernel_op_246;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_24*tmp_kernel_op_252;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_222*tmp_kernel_op_43;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_252*tmp_kernel_op_44;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_222*tmp_kernel_op_46;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_252*tmp_kernel_op_47;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_222*tmp_kernel_op_49;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_259*tmp_kernel_op_75;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_230*tmp_kernel_op_94;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_259*tmp_kernel_op_95;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_230*tmp_kernel_op_97;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_259*tmp_kernel_op_98;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_100*tmp_kernel_op_230;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_142*0.5854101966249684;
                const real_t tmp_kernel_op_267 = tmp_kernel_op_126*tmp_kernel_op_266;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_145*tmp_kernel_op_238;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_146*tmp_kernel_op_266;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_148*tmp_kernel_op_238;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_149*tmp_kernel_op_266;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_151*tmp_kernel_op_238;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_177*tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_196*tmp_kernel_op_246;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_197*tmp_kernel_op_273;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_199*tmp_kernel_op_246;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_200*tmp_kernel_op_273;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_202*tmp_kernel_op_246;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_252*tmp_kernel_op_42;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_220*tmp_kernel_op_43;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_252*tmp_kernel_op_45;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_220*tmp_kernel_op_46;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_252*tmp_kernel_op_48;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_220*tmp_kernel_op_49;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_259*tmp_kernel_op_93;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_228*tmp_kernel_op_94;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_259*tmp_kernel_op_96;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_228*tmp_kernel_op_97;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_259*tmp_kernel_op_99;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_100*tmp_kernel_op_228;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_144*tmp_kernel_op_266;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_145*tmp_kernel_op_236;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_147*tmp_kernel_op_266;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_148*tmp_kernel_op_236;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_150*tmp_kernel_op_266;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_151*tmp_kernel_op_236;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_195*tmp_kernel_op_273;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_196*tmp_kernel_op_244;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_198*tmp_kernel_op_273;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_199*tmp_kernel_op_244;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_201*tmp_kernel_op_273;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_202*tmp_kernel_op_244;
                const real_t elMatDiag_0 = tmp_kernel_op_101*(((tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)*(tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)) + ((tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)*(tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)) + ((tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97)*(tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97))) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)*(tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)) + ((tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)*(tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)) + ((tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151)*(tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151))) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)*(tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)) + ((tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)*(tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)) + ((tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202)*(tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202))) + tmp_kernel_op_50*(((tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)*(tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)) + ((tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)*(tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)) + ((tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)*(tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)));
                const real_t elMatDiag_1 = tmp_kernel_op_101*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_207 + tmp_kernel_op_207*(tmp_kernel_op_94*tmp_kernel_op_94) + tmp_kernel_op_207*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_152*((tmp_kernel_op_145*tmp_kernel_op_145)*tmp_kernel_op_209 + (tmp_kernel_op_148*tmp_kernel_op_148)*tmp_kernel_op_209 + (tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_209) + tmp_kernel_op_203*((tmp_kernel_op_196*tmp_kernel_op_196)*tmp_kernel_op_211 + (tmp_kernel_op_199*tmp_kernel_op_199)*tmp_kernel_op_211 + (tmp_kernel_op_202*tmp_kernel_op_202)*tmp_kernel_op_211) + tmp_kernel_op_50*(tmp_kernel_op_205*(tmp_kernel_op_43*tmp_kernel_op_43) + tmp_kernel_op_205*(tmp_kernel_op_46*tmp_kernel_op_46) + tmp_kernel_op_205*(tmp_kernel_op_49*tmp_kernel_op_49));
                const real_t elMatDiag_2 = tmp_kernel_op_101*(tmp_kernel_op_213*(tmp_kernel_op_93*tmp_kernel_op_93) + tmp_kernel_op_213*(tmp_kernel_op_96*tmp_kernel_op_96) + tmp_kernel_op_213*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_152*((tmp_kernel_op_144*tmp_kernel_op_144)*tmp_kernel_op_214 + (tmp_kernel_op_147*tmp_kernel_op_147)*tmp_kernel_op_214 + (tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_214) + tmp_kernel_op_203*((tmp_kernel_op_195*tmp_kernel_op_195)*tmp_kernel_op_215 + (tmp_kernel_op_198*tmp_kernel_op_198)*tmp_kernel_op_215 + (tmp_kernel_op_201*tmp_kernel_op_201)*tmp_kernel_op_215) + tmp_kernel_op_50*(tmp_kernel_op_212*(tmp_kernel_op_42*tmp_kernel_op_42) + tmp_kernel_op_212*(tmp_kernel_op_45*tmp_kernel_op_45) + tmp_kernel_op_212*(tmp_kernel_op_48*tmp_kernel_op_48));
                const real_t elMatDiag_3 = tmp_kernel_op_101*(tmp_kernel_op_217*(tmp_kernel_op_75*tmp_kernel_op_75) + tmp_kernel_op_217*(tmp_kernel_op_95*tmp_kernel_op_95) + tmp_kernel_op_217*(tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_152*((tmp_kernel_op_126*tmp_kernel_op_126)*tmp_kernel_op_218 + (tmp_kernel_op_146*tmp_kernel_op_146)*tmp_kernel_op_218 + (tmp_kernel_op_149*tmp_kernel_op_149)*tmp_kernel_op_218) + tmp_kernel_op_203*((tmp_kernel_op_177*tmp_kernel_op_177)*tmp_kernel_op_219 + (tmp_kernel_op_197*tmp_kernel_op_197)*tmp_kernel_op_219 + (tmp_kernel_op_200*tmp_kernel_op_200)*tmp_kernel_op_219) + tmp_kernel_op_50*(tmp_kernel_op_216*(tmp_kernel_op_24*tmp_kernel_op_24) + tmp_kernel_op_216*(tmp_kernel_op_44*tmp_kernel_op_44) + tmp_kernel_op_216*(tmp_kernel_op_47*tmp_kernel_op_47));
                const real_t elMatDiag_4 = tmp_kernel_op_101*(((tmp_kernel_op_229 + tmp_kernel_op_231)*(tmp_kernel_op_229 + tmp_kernel_op_231))*16.0 + ((tmp_kernel_op_232 + tmp_kernel_op_233)*(tmp_kernel_op_232 + tmp_kernel_op_233))*16.0 + ((tmp_kernel_op_234 + tmp_kernel_op_235)*(tmp_kernel_op_234 + tmp_kernel_op_235))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_237 + tmp_kernel_op_239)*(tmp_kernel_op_237 + tmp_kernel_op_239))*16.0 + ((tmp_kernel_op_240 + tmp_kernel_op_241)*(tmp_kernel_op_240 + tmp_kernel_op_241))*16.0 + ((tmp_kernel_op_242 + tmp_kernel_op_243)*(tmp_kernel_op_242 + tmp_kernel_op_243))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_245 + tmp_kernel_op_247)*(tmp_kernel_op_245 + tmp_kernel_op_247))*16.0 + ((tmp_kernel_op_248 + tmp_kernel_op_249)*(tmp_kernel_op_248 + tmp_kernel_op_249))*16.0 + ((tmp_kernel_op_250 + tmp_kernel_op_251)*(tmp_kernel_op_250 + tmp_kernel_op_251))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_221 + tmp_kernel_op_223)*(tmp_kernel_op_221 + tmp_kernel_op_223))*16.0 + ((tmp_kernel_op_224 + tmp_kernel_op_225)*(tmp_kernel_op_224 + tmp_kernel_op_225))*16.0 + ((tmp_kernel_op_226 + tmp_kernel_op_227)*(tmp_kernel_op_226 + tmp_kernel_op_227))*16.0);
                const real_t elMatDiag_5 = tmp_kernel_op_101*(((tmp_kernel_op_260 + tmp_kernel_op_261)*(tmp_kernel_op_260 + tmp_kernel_op_261))*16.0 + ((tmp_kernel_op_262 + tmp_kernel_op_263)*(tmp_kernel_op_262 + tmp_kernel_op_263))*16.0 + ((tmp_kernel_op_264 + tmp_kernel_op_265)*(tmp_kernel_op_264 + tmp_kernel_op_265))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_267 + tmp_kernel_op_268)*(tmp_kernel_op_267 + tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_269 + tmp_kernel_op_270)*(tmp_kernel_op_269 + tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_271 + tmp_kernel_op_272)*(tmp_kernel_op_271 + tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_274 + tmp_kernel_op_275)*(tmp_kernel_op_274 + tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_276 + tmp_kernel_op_277)*(tmp_kernel_op_276 + tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_278 + tmp_kernel_op_279)*(tmp_kernel_op_278 + tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_253 + tmp_kernel_op_254)*(tmp_kernel_op_253 + tmp_kernel_op_254))*16.0 + ((tmp_kernel_op_255 + tmp_kernel_op_256)*(tmp_kernel_op_255 + tmp_kernel_op_256))*16.0 + ((tmp_kernel_op_257 + tmp_kernel_op_258)*(tmp_kernel_op_257 + tmp_kernel_op_258))*16.0);
                const real_t elMatDiag_6 = tmp_kernel_op_101*(((tmp_kernel_op_286 + tmp_kernel_op_287)*(tmp_kernel_op_286 + tmp_kernel_op_287))*16.0 + ((tmp_kernel_op_288 + tmp_kernel_op_289)*(tmp_kernel_op_288 + tmp_kernel_op_289))*16.0 + ((tmp_kernel_op_290 + tmp_kernel_op_291)*(tmp_kernel_op_290 + tmp_kernel_op_291))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_292 + tmp_kernel_op_293)*(tmp_kernel_op_292 + tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_294 + tmp_kernel_op_295)*(tmp_kernel_op_294 + tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_296 + tmp_kernel_op_297)*(tmp_kernel_op_296 + tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_298 + tmp_kernel_op_299)*(tmp_kernel_op_298 + tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_300 + tmp_kernel_op_301)*(tmp_kernel_op_300 + tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_302 + tmp_kernel_op_303)*(tmp_kernel_op_302 + tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_280 + tmp_kernel_op_281)*(tmp_kernel_op_280 + tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_282 + tmp_kernel_op_283)*(tmp_kernel_op_282 + tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_284 + tmp_kernel_op_285)*(tmp_kernel_op_284 + tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_7 = tmp_kernel_op_101*(((-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25)*(-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25))*16.0 + ((-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25)*(-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25))*16.0 + ((-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25)*(-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268)*(tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275)*(tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254)*(-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254))*16.0 + ((-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25)*(-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25))*16.0 + ((-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25)*(-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25))*16.0);
                const real_t elMatDiag_8 = tmp_kernel_op_101*(((-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25)*(-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25))*16.0 + ((-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25))*16.0 + ((-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_9 = tmp_kernel_op_101*(((-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290)*(tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25))*16.0);
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_57 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_59 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_60 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_57),tmp_kernel_op_60);
                const __m256d tmp_kernel_op_65 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_65),tmp_kernel_op_67);
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_68);
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_57),tmp_kernel_op_59),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_73 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_67),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_74 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_78),tmp_kernel_op_80);
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_78),tmp_kernel_op_79),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_65),tmp_kernel_op_66),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_80),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_60),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_89 = _mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,tmp_kernel_op_81),_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),tmp_kernel_op_87));
                const __m256d tmp_kernel_op_91 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_87));
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_95 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_83),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_87),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_90))));
                const __m256d tmp_kernel_op_108 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)),tmp_kernel_op_110);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_108),tmp_kernel_op_111);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_117 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_116),tmp_kernel_op_118);
                const __m256d tmp_kernel_op_120 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_119);
                const __m256d tmp_kernel_op_121 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_108),tmp_kernel_op_110),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_118),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_120);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_129),tmp_kernel_op_131);
                const __m256d tmp_kernel_op_133 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_129),tmp_kernel_op_130),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_116),tmp_kernel_op_117),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_131),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_111),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_138);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_136)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_139),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),tmp_kernel_op_138));
                const __m256d tmp_kernel_op_142 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_138));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_146 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_134),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_135),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_141))));
                const __m256d tmp_kernel_op_159 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155)),tmp_kernel_op_161);
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_159),tmp_kernel_op_162);
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)),tmp_kernel_op_168);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_167),tmp_kernel_op_169);
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_159),tmp_kernel_op_161),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_175 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_169),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_175);
                const __m256d tmp_kernel_op_177 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_180),tmp_kernel_op_182);
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_180),tmp_kernel_op_181),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_167),tmp_kernel_op_168),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_182),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_189 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_162),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_191 = _mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_189);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_183),_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_187)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_191),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),tmp_kernel_op_189));
                const __m256d tmp_kernel_op_193 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192);
                const __m256d tmp_kernel_op_194 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_190,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_196 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_187);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_185),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_189),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_199 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_189),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_185),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_186),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_202 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_192))));
                const __m256d tmp_kernel_op_204 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_206 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_207 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_211 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_214 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_24);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_232 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_249 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_252);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_230);
                const __m256d tmp_kernel_op_266 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_271 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_285 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_288 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_293 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_296 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_299 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_244);
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)))))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_145),tmp_kernel_op_209),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148),tmp_kernel_op_209)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_209)))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_196),tmp_kernel_op_211),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_199),tmp_kernel_op_211)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_202),tmp_kernel_op_211)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_144),tmp_kernel_op_214),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_147),tmp_kernel_op_214)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_214))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_195),tmp_kernel_op_215),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_198),tmp_kernel_op_215)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_201),tmp_kernel_op_215)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45))),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_126),tmp_kernel_op_218),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_146),tmp_kernel_op_218)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149),tmp_kernel_op_218))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_177),tmp_kernel_op_219),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_197),tmp_kernel_op_219)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_200),tmp_kernel_op_219)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98)))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223),_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225),_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227),_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231),_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233),_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235),_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239),_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241),_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243),_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247),_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249),_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251),_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254),_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256),_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258),_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261),_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263),_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265),_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268),_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270),_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272),_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275),_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277),_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279),_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281),_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283),_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285),_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287),_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289),_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291),_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293),_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295),_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297),_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299),_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301),_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303),_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_46 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_49 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_57 = -micromesh_dof_7*tmp_kernel_op_54;
                const real_t tmp_kernel_op_59 = micromesh_dof_0*tmp_kernel_op_58;
                const real_t tmp_kernel_op_60 = -micromesh_dof_8*tmp_kernel_op_53 + tmp_kernel_op_59;
                const real_t tmp_kernel_op_61 = micromesh_dof_1*tmp_kernel_op_52 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_53 + micromesh_dof_9*tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_60;
                const real_t tmp_kernel_op_65 = -micromesh_dof_19*tmp_kernel_op_51;
                const real_t tmp_kernel_op_66 = micromesh_dof_10*tmp_kernel_op_58;
                const real_t tmp_kernel_op_67 = -micromesh_dof_17*tmp_kernel_op_54 + tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = micromesh_dof_12*tmp_kernel_op_62 + micromesh_dof_14*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_51 + micromesh_dof_18*tmp_kernel_op_64 + tmp_kernel_op_65 + tmp_kernel_op_67;
                const real_t tmp_kernel_op_69 = tmp_kernel_op_61*tmp_kernel_op_68;
                const real_t tmp_kernel_op_70 = -micromesh_dof_9*tmp_kernel_op_51;
                const real_t tmp_kernel_op_71 = micromesh_dof_2*tmp_kernel_op_62 + micromesh_dof_4*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_51 + micromesh_dof_8*tmp_kernel_op_64 + tmp_kernel_op_57 + tmp_kernel_op_59 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = -micromesh_dof_18*tmp_kernel_op_53;
                const real_t tmp_kernel_op_73 = micromesh_dof_11*tmp_kernel_op_52 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_53 + micromesh_dof_19*tmp_kernel_op_56 + tmp_kernel_op_67 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_74 = tmp_kernel_op_71*tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = tmp_kernel_op_69 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_78 = -micromesh_dof_28*tmp_kernel_op_53;
                const real_t tmp_kernel_op_79 = micromesh_dof_20*tmp_kernel_op_58;
                const real_t tmp_kernel_op_80 = -micromesh_dof_29*tmp_kernel_op_51 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = micromesh_dof_23*tmp_kernel_op_76 + micromesh_dof_24*tmp_kernel_op_53 + micromesh_dof_25*tmp_kernel_op_51 + micromesh_dof_27*tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_80;
                const real_t tmp_kernel_op_82 = -micromesh_dof_27*tmp_kernel_op_54;
                const real_t tmp_kernel_op_83 = micromesh_dof_21*tmp_kernel_op_52 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_53 + micromesh_dof_29*tmp_kernel_op_56 + tmp_kernel_op_78 + tmp_kernel_op_79 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_13*tmp_kernel_op_76 + micromesh_dof_14*tmp_kernel_op_53 + micromesh_dof_15*tmp_kernel_op_51 + micromesh_dof_17*tmp_kernel_op_77 + tmp_kernel_op_65 + tmp_kernel_op_66 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_85 = tmp_kernel_op_71*tmp_kernel_op_84;
                const real_t tmp_kernel_op_86 = micromesh_dof_22*tmp_kernel_op_62 + micromesh_dof_24*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_51 + micromesh_dof_28*tmp_kernel_op_64 + tmp_kernel_op_80 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_87 = micromesh_dof_3*tmp_kernel_op_76 + micromesh_dof_4*tmp_kernel_op_53 + micromesh_dof_5*tmp_kernel_op_51 + micromesh_dof_7*tmp_kernel_op_77 + tmp_kernel_op_60 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_61*tmp_kernel_op_84;
                const real_t tmp_kernel_op_89 = tmp_kernel_op_68*tmp_kernel_op_87;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_69*tmp_kernel_op_81 + tmp_kernel_op_73*tmp_kernel_op_86*tmp_kernel_op_87 - tmp_kernel_op_74*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_85 - tmp_kernel_op_83*tmp_kernel_op_89 - tmp_kernel_op_86*tmp_kernel_op_88;
                const real_t tmp_kernel_op_91 = 1.0 / (tmp_kernel_op_90);
                const real_t tmp_kernel_op_92 = tmp_kernel_op_58*tmp_kernel_op_91;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_73*tmp_kernel_op_87 - tmp_kernel_op_88;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_85 - tmp_kernel_op_89;
                const real_t tmp_kernel_op_95 = -tmp_kernel_op_61*tmp_kernel_op_86 + tmp_kernel_op_71*tmp_kernel_op_83;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_61*tmp_kernel_op_81 - tmp_kernel_op_83*tmp_kernel_op_87;
                const real_t tmp_kernel_op_97 = -tmp_kernel_op_71*tmp_kernel_op_81 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_98 = -tmp_kernel_op_68*tmp_kernel_op_83 + tmp_kernel_op_73*tmp_kernel_op_86;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_73*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_84;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_68*tmp_kernel_op_81 - tmp_kernel_op_84*tmp_kernel_op_86;
                const real_t tmp_kernel_op_101 = 0.041666666666666657*abs(tmp_kernel_op_90);
                const real_t tmp_kernel_op_108 = -micromesh_dof_7*tmp_kernel_op_105;
                const real_t tmp_kernel_op_110 = micromesh_dof_0*tmp_kernel_op_109;
                const real_t tmp_kernel_op_111 = -micromesh_dof_8*tmp_kernel_op_104 + tmp_kernel_op_110;
                const real_t tmp_kernel_op_112 = micromesh_dof_1*tmp_kernel_op_103 + micromesh_dof_5*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_104 + micromesh_dof_9*tmp_kernel_op_107 + tmp_kernel_op_108 + tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = -micromesh_dof_19*tmp_kernel_op_102;
                const real_t tmp_kernel_op_117 = micromesh_dof_10*tmp_kernel_op_109;
                const real_t tmp_kernel_op_118 = -micromesh_dof_17*tmp_kernel_op_105 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_119 = micromesh_dof_12*tmp_kernel_op_113 + micromesh_dof_14*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_102 + micromesh_dof_18*tmp_kernel_op_115 + tmp_kernel_op_116 + tmp_kernel_op_118;
                const real_t tmp_kernel_op_120 = tmp_kernel_op_112*tmp_kernel_op_119;
                const real_t tmp_kernel_op_121 = -micromesh_dof_9*tmp_kernel_op_102;
                const real_t tmp_kernel_op_122 = micromesh_dof_2*tmp_kernel_op_113 + micromesh_dof_4*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_102 + micromesh_dof_8*tmp_kernel_op_115 + tmp_kernel_op_108 + tmp_kernel_op_110 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_123 = -micromesh_dof_18*tmp_kernel_op_104;
                const real_t tmp_kernel_op_124 = micromesh_dof_11*tmp_kernel_op_103 + micromesh_dof_15*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_104 + micromesh_dof_19*tmp_kernel_op_107 + tmp_kernel_op_118 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_122*tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_120 - tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = -micromesh_dof_28*tmp_kernel_op_104;
                const real_t tmp_kernel_op_130 = micromesh_dof_20*tmp_kernel_op_109;
                const real_t tmp_kernel_op_131 = -micromesh_dof_29*tmp_kernel_op_102 + tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = micromesh_dof_23*tmp_kernel_op_127 + micromesh_dof_24*tmp_kernel_op_104 + micromesh_dof_25*tmp_kernel_op_102 + micromesh_dof_27*tmp_kernel_op_128 + tmp_kernel_op_129 + tmp_kernel_op_131;
                const real_t tmp_kernel_op_133 = -micromesh_dof_27*tmp_kernel_op_105;
                const real_t tmp_kernel_op_134 = micromesh_dof_21*tmp_kernel_op_103 + micromesh_dof_25*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_104 + micromesh_dof_29*tmp_kernel_op_107 + tmp_kernel_op_129 + tmp_kernel_op_130 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = micromesh_dof_13*tmp_kernel_op_127 + micromesh_dof_14*tmp_kernel_op_104 + micromesh_dof_15*tmp_kernel_op_102 + micromesh_dof_17*tmp_kernel_op_128 + tmp_kernel_op_116 + tmp_kernel_op_117 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_136 = tmp_kernel_op_122*tmp_kernel_op_135;
                const real_t tmp_kernel_op_137 = micromesh_dof_22*tmp_kernel_op_113 + micromesh_dof_24*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_102 + micromesh_dof_28*tmp_kernel_op_115 + tmp_kernel_op_131 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_138 = micromesh_dof_3*tmp_kernel_op_127 + micromesh_dof_4*tmp_kernel_op_104 + micromesh_dof_5*tmp_kernel_op_102 + micromesh_dof_7*tmp_kernel_op_128 + tmp_kernel_op_111 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_139 = tmp_kernel_op_112*tmp_kernel_op_135;
                const real_t tmp_kernel_op_140 = tmp_kernel_op_119*tmp_kernel_op_138;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_120*tmp_kernel_op_132 + tmp_kernel_op_124*tmp_kernel_op_137*tmp_kernel_op_138 - tmp_kernel_op_125*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_136 - tmp_kernel_op_134*tmp_kernel_op_140 - tmp_kernel_op_137*tmp_kernel_op_139;
                const real_t tmp_kernel_op_142 = 1.0 / (tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_109*tmp_kernel_op_142;
                const real_t tmp_kernel_op_144 = tmp_kernel_op_124*tmp_kernel_op_138 - tmp_kernel_op_139;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_136 - tmp_kernel_op_140;
                const real_t tmp_kernel_op_146 = -tmp_kernel_op_112*tmp_kernel_op_137 + tmp_kernel_op_122*tmp_kernel_op_134;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_112*tmp_kernel_op_132 - tmp_kernel_op_134*tmp_kernel_op_138;
                const real_t tmp_kernel_op_148 = -tmp_kernel_op_122*tmp_kernel_op_132 + tmp_kernel_op_137*tmp_kernel_op_138;
                const real_t tmp_kernel_op_149 = -tmp_kernel_op_119*tmp_kernel_op_134 + tmp_kernel_op_124*tmp_kernel_op_137;
                const real_t tmp_kernel_op_150 = -tmp_kernel_op_124*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_135;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_119*tmp_kernel_op_132 - tmp_kernel_op_135*tmp_kernel_op_137;
                const real_t tmp_kernel_op_152 = 0.041666666666666657*abs(tmp_kernel_op_141);
                const real_t tmp_kernel_op_159 = -micromesh_dof_7*tmp_kernel_op_156;
                const real_t tmp_kernel_op_161 = micromesh_dof_0*tmp_kernel_op_160;
                const real_t tmp_kernel_op_162 = -micromesh_dof_8*tmp_kernel_op_155 + tmp_kernel_op_161;
                const real_t tmp_kernel_op_163 = micromesh_dof_1*tmp_kernel_op_154 + micromesh_dof_5*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_155 + micromesh_dof_9*tmp_kernel_op_158 + tmp_kernel_op_159 + tmp_kernel_op_162;
                const real_t tmp_kernel_op_167 = -micromesh_dof_19*tmp_kernel_op_153;
                const real_t tmp_kernel_op_168 = micromesh_dof_10*tmp_kernel_op_160;
                const real_t tmp_kernel_op_169 = -micromesh_dof_17*tmp_kernel_op_156 + tmp_kernel_op_168;
                const real_t tmp_kernel_op_170 = micromesh_dof_12*tmp_kernel_op_164 + micromesh_dof_14*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_153 + micromesh_dof_18*tmp_kernel_op_166 + tmp_kernel_op_167 + tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_163*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = -micromesh_dof_9*tmp_kernel_op_153;
                const real_t tmp_kernel_op_173 = micromesh_dof_2*tmp_kernel_op_164 + micromesh_dof_4*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_153 + micromesh_dof_8*tmp_kernel_op_166 + tmp_kernel_op_159 + tmp_kernel_op_161 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_174 = -micromesh_dof_18*tmp_kernel_op_155;
                const real_t tmp_kernel_op_175 = micromesh_dof_11*tmp_kernel_op_154 + micromesh_dof_15*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_155 + micromesh_dof_19*tmp_kernel_op_158 + tmp_kernel_op_169 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_173*tmp_kernel_op_175;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_171 - tmp_kernel_op_176;
                const real_t tmp_kernel_op_180 = -micromesh_dof_28*tmp_kernel_op_155;
                const real_t tmp_kernel_op_181 = micromesh_dof_20*tmp_kernel_op_160;
                const real_t tmp_kernel_op_182 = -micromesh_dof_29*tmp_kernel_op_153 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = micromesh_dof_23*tmp_kernel_op_178 + micromesh_dof_24*tmp_kernel_op_155 + micromesh_dof_25*tmp_kernel_op_153 + micromesh_dof_27*tmp_kernel_op_179 + tmp_kernel_op_180 + tmp_kernel_op_182;
                const real_t tmp_kernel_op_184 = -micromesh_dof_27*tmp_kernel_op_156;
                const real_t tmp_kernel_op_185 = micromesh_dof_21*tmp_kernel_op_154 + micromesh_dof_25*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_155 + micromesh_dof_29*tmp_kernel_op_158 + tmp_kernel_op_180 + tmp_kernel_op_181 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = micromesh_dof_13*tmp_kernel_op_178 + micromesh_dof_14*tmp_kernel_op_155 + micromesh_dof_15*tmp_kernel_op_153 + micromesh_dof_17*tmp_kernel_op_179 + tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_173*tmp_kernel_op_186;
                const real_t tmp_kernel_op_188 = micromesh_dof_22*tmp_kernel_op_164 + micromesh_dof_24*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_153 + micromesh_dof_28*tmp_kernel_op_166 + tmp_kernel_op_182 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_189 = micromesh_dof_3*tmp_kernel_op_178 + micromesh_dof_4*tmp_kernel_op_155 + micromesh_dof_5*tmp_kernel_op_153 + micromesh_dof_7*tmp_kernel_op_179 + tmp_kernel_op_162 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_163*tmp_kernel_op_186;
                const real_t tmp_kernel_op_191 = tmp_kernel_op_170*tmp_kernel_op_189;
                const real_t tmp_kernel_op_192 = tmp_kernel_op_171*tmp_kernel_op_183 + tmp_kernel_op_175*tmp_kernel_op_188*tmp_kernel_op_189 - tmp_kernel_op_176*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_187 - tmp_kernel_op_185*tmp_kernel_op_191 - tmp_kernel_op_188*tmp_kernel_op_190;
                const real_t tmp_kernel_op_193 = 1.0 / (tmp_kernel_op_192);
                const real_t tmp_kernel_op_194 = tmp_kernel_op_160*tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = tmp_kernel_op_175*tmp_kernel_op_189 - tmp_kernel_op_190;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_187 - tmp_kernel_op_191;
                const real_t tmp_kernel_op_197 = -tmp_kernel_op_163*tmp_kernel_op_188 + tmp_kernel_op_173*tmp_kernel_op_185;
                const real_t tmp_kernel_op_198 = tmp_kernel_op_163*tmp_kernel_op_183 - tmp_kernel_op_185*tmp_kernel_op_189;
                const real_t tmp_kernel_op_199 = -tmp_kernel_op_173*tmp_kernel_op_183 + tmp_kernel_op_188*tmp_kernel_op_189;
                const real_t tmp_kernel_op_200 = -tmp_kernel_op_170*tmp_kernel_op_185 + tmp_kernel_op_175*tmp_kernel_op_188;
                const real_t tmp_kernel_op_201 = -tmp_kernel_op_175*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_186;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_170*tmp_kernel_op_183 - tmp_kernel_op_186*tmp_kernel_op_188;
                const real_t tmp_kernel_op_203 = 0.041666666666666657*abs(tmp_kernel_op_192);
                const real_t tmp_kernel_op_204 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39)*16.0;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_206 = 1.0 / (tmp_kernel_op_90*tmp_kernel_op_90)*16.0;
                const real_t tmp_kernel_op_207 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_208 = 1.0 / (tmp_kernel_op_141*tmp_kernel_op_141)*16.0;
                const real_t tmp_kernel_op_209 = tmp_kernel_op_208*0.11249999999999996;
                const real_t tmp_kernel_op_210 = 1.0 / (tmp_kernel_op_192*tmp_kernel_op_192)*16.0;
                const real_t tmp_kernel_op_211 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_206*0.11249999999999996;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_204*0.11249999999999996;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_24;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_222*tmp_kernel_op_42;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_220*tmp_kernel_op_44;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_222*tmp_kernel_op_45;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_220*tmp_kernel_op_47;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_222*tmp_kernel_op_48;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_91*0.5854101966249684;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_228*tmp_kernel_op_75;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_230*tmp_kernel_op_93;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_228*tmp_kernel_op_95;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_230*tmp_kernel_op_96;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_228*tmp_kernel_op_98;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_230*tmp_kernel_op_99;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_126*tmp_kernel_op_236;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_144*tmp_kernel_op_238;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_146*tmp_kernel_op_236;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_147*tmp_kernel_op_238;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_149*tmp_kernel_op_236;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_150*tmp_kernel_op_238;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_177*tmp_kernel_op_244;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_195*tmp_kernel_op_246;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_197*tmp_kernel_op_244;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_198*tmp_kernel_op_246;
                const real_t tmp_kernel_op_250 = tmp_kernel_op_200*tmp_kernel_op_244;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_201*tmp_kernel_op_246;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_24*tmp_kernel_op_252;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_222*tmp_kernel_op_43;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_252*tmp_kernel_op_44;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_222*tmp_kernel_op_46;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_252*tmp_kernel_op_47;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_222*tmp_kernel_op_49;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_259*tmp_kernel_op_75;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_230*tmp_kernel_op_94;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_259*tmp_kernel_op_95;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_230*tmp_kernel_op_97;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_259*tmp_kernel_op_98;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_100*tmp_kernel_op_230;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_142*0.5854101966249684;
                const real_t tmp_kernel_op_267 = tmp_kernel_op_126*tmp_kernel_op_266;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_145*tmp_kernel_op_238;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_146*tmp_kernel_op_266;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_148*tmp_kernel_op_238;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_149*tmp_kernel_op_266;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_151*tmp_kernel_op_238;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_177*tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_196*tmp_kernel_op_246;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_197*tmp_kernel_op_273;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_199*tmp_kernel_op_246;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_200*tmp_kernel_op_273;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_202*tmp_kernel_op_246;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_252*tmp_kernel_op_42;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_220*tmp_kernel_op_43;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_252*tmp_kernel_op_45;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_220*tmp_kernel_op_46;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_252*tmp_kernel_op_48;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_220*tmp_kernel_op_49;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_259*tmp_kernel_op_93;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_228*tmp_kernel_op_94;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_259*tmp_kernel_op_96;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_228*tmp_kernel_op_97;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_259*tmp_kernel_op_99;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_100*tmp_kernel_op_228;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_144*tmp_kernel_op_266;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_145*tmp_kernel_op_236;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_147*tmp_kernel_op_266;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_148*tmp_kernel_op_236;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_150*tmp_kernel_op_266;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_151*tmp_kernel_op_236;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_195*tmp_kernel_op_273;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_196*tmp_kernel_op_244;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_198*tmp_kernel_op_273;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_199*tmp_kernel_op_244;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_201*tmp_kernel_op_273;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_202*tmp_kernel_op_244;
                const real_t elMatDiag_0 = tmp_kernel_op_101*(((tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)*(tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)) + ((tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)*(tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)) + ((tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97)*(tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97))) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)*(tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)) + ((tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)*(tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)) + ((tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151)*(tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151))) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)*(tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)) + ((tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)*(tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)) + ((tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202)*(tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202))) + tmp_kernel_op_50*(((tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)*(tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)) + ((tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)*(tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)) + ((tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)*(tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)));
                const real_t elMatDiag_1 = tmp_kernel_op_101*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_207 + tmp_kernel_op_207*(tmp_kernel_op_94*tmp_kernel_op_94) + tmp_kernel_op_207*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_152*((tmp_kernel_op_145*tmp_kernel_op_145)*tmp_kernel_op_209 + (tmp_kernel_op_148*tmp_kernel_op_148)*tmp_kernel_op_209 + (tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_209) + tmp_kernel_op_203*((tmp_kernel_op_196*tmp_kernel_op_196)*tmp_kernel_op_211 + (tmp_kernel_op_199*tmp_kernel_op_199)*tmp_kernel_op_211 + (tmp_kernel_op_202*tmp_kernel_op_202)*tmp_kernel_op_211) + tmp_kernel_op_50*(tmp_kernel_op_205*(tmp_kernel_op_43*tmp_kernel_op_43) + tmp_kernel_op_205*(tmp_kernel_op_46*tmp_kernel_op_46) + tmp_kernel_op_205*(tmp_kernel_op_49*tmp_kernel_op_49));
                const real_t elMatDiag_2 = tmp_kernel_op_101*(tmp_kernel_op_213*(tmp_kernel_op_93*tmp_kernel_op_93) + tmp_kernel_op_213*(tmp_kernel_op_96*tmp_kernel_op_96) + tmp_kernel_op_213*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_152*((tmp_kernel_op_144*tmp_kernel_op_144)*tmp_kernel_op_214 + (tmp_kernel_op_147*tmp_kernel_op_147)*tmp_kernel_op_214 + (tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_214) + tmp_kernel_op_203*((tmp_kernel_op_195*tmp_kernel_op_195)*tmp_kernel_op_215 + (tmp_kernel_op_198*tmp_kernel_op_198)*tmp_kernel_op_215 + (tmp_kernel_op_201*tmp_kernel_op_201)*tmp_kernel_op_215) + tmp_kernel_op_50*(tmp_kernel_op_212*(tmp_kernel_op_42*tmp_kernel_op_42) + tmp_kernel_op_212*(tmp_kernel_op_45*tmp_kernel_op_45) + tmp_kernel_op_212*(tmp_kernel_op_48*tmp_kernel_op_48));
                const real_t elMatDiag_3 = tmp_kernel_op_101*(tmp_kernel_op_217*(tmp_kernel_op_75*tmp_kernel_op_75) + tmp_kernel_op_217*(tmp_kernel_op_95*tmp_kernel_op_95) + tmp_kernel_op_217*(tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_152*((tmp_kernel_op_126*tmp_kernel_op_126)*tmp_kernel_op_218 + (tmp_kernel_op_146*tmp_kernel_op_146)*tmp_kernel_op_218 + (tmp_kernel_op_149*tmp_kernel_op_149)*tmp_kernel_op_218) + tmp_kernel_op_203*((tmp_kernel_op_177*tmp_kernel_op_177)*tmp_kernel_op_219 + (tmp_kernel_op_197*tmp_kernel_op_197)*tmp_kernel_op_219 + (tmp_kernel_op_200*tmp_kernel_op_200)*tmp_kernel_op_219) + tmp_kernel_op_50*(tmp_kernel_op_216*(tmp_kernel_op_24*tmp_kernel_op_24) + tmp_kernel_op_216*(tmp_kernel_op_44*tmp_kernel_op_44) + tmp_kernel_op_216*(tmp_kernel_op_47*tmp_kernel_op_47));
                const real_t elMatDiag_4 = tmp_kernel_op_101*(((tmp_kernel_op_229 + tmp_kernel_op_231)*(tmp_kernel_op_229 + tmp_kernel_op_231))*16.0 + ((tmp_kernel_op_232 + tmp_kernel_op_233)*(tmp_kernel_op_232 + tmp_kernel_op_233))*16.0 + ((tmp_kernel_op_234 + tmp_kernel_op_235)*(tmp_kernel_op_234 + tmp_kernel_op_235))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_237 + tmp_kernel_op_239)*(tmp_kernel_op_237 + tmp_kernel_op_239))*16.0 + ((tmp_kernel_op_240 + tmp_kernel_op_241)*(tmp_kernel_op_240 + tmp_kernel_op_241))*16.0 + ((tmp_kernel_op_242 + tmp_kernel_op_243)*(tmp_kernel_op_242 + tmp_kernel_op_243))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_245 + tmp_kernel_op_247)*(tmp_kernel_op_245 + tmp_kernel_op_247))*16.0 + ((tmp_kernel_op_248 + tmp_kernel_op_249)*(tmp_kernel_op_248 + tmp_kernel_op_249))*16.0 + ((tmp_kernel_op_250 + tmp_kernel_op_251)*(tmp_kernel_op_250 + tmp_kernel_op_251))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_221 + tmp_kernel_op_223)*(tmp_kernel_op_221 + tmp_kernel_op_223))*16.0 + ((tmp_kernel_op_224 + tmp_kernel_op_225)*(tmp_kernel_op_224 + tmp_kernel_op_225))*16.0 + ((tmp_kernel_op_226 + tmp_kernel_op_227)*(tmp_kernel_op_226 + tmp_kernel_op_227))*16.0);
                const real_t elMatDiag_5 = tmp_kernel_op_101*(((tmp_kernel_op_260 + tmp_kernel_op_261)*(tmp_kernel_op_260 + tmp_kernel_op_261))*16.0 + ((tmp_kernel_op_262 + tmp_kernel_op_263)*(tmp_kernel_op_262 + tmp_kernel_op_263))*16.0 + ((tmp_kernel_op_264 + tmp_kernel_op_265)*(tmp_kernel_op_264 + tmp_kernel_op_265))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_267 + tmp_kernel_op_268)*(tmp_kernel_op_267 + tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_269 + tmp_kernel_op_270)*(tmp_kernel_op_269 + tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_271 + tmp_kernel_op_272)*(tmp_kernel_op_271 + tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_274 + tmp_kernel_op_275)*(tmp_kernel_op_274 + tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_276 + tmp_kernel_op_277)*(tmp_kernel_op_276 + tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_278 + tmp_kernel_op_279)*(tmp_kernel_op_278 + tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_253 + tmp_kernel_op_254)*(tmp_kernel_op_253 + tmp_kernel_op_254))*16.0 + ((tmp_kernel_op_255 + tmp_kernel_op_256)*(tmp_kernel_op_255 + tmp_kernel_op_256))*16.0 + ((tmp_kernel_op_257 + tmp_kernel_op_258)*(tmp_kernel_op_257 + tmp_kernel_op_258))*16.0);
                const real_t elMatDiag_6 = tmp_kernel_op_101*(((tmp_kernel_op_286 + tmp_kernel_op_287)*(tmp_kernel_op_286 + tmp_kernel_op_287))*16.0 + ((tmp_kernel_op_288 + tmp_kernel_op_289)*(tmp_kernel_op_288 + tmp_kernel_op_289))*16.0 + ((tmp_kernel_op_290 + tmp_kernel_op_291)*(tmp_kernel_op_290 + tmp_kernel_op_291))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_292 + tmp_kernel_op_293)*(tmp_kernel_op_292 + tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_294 + tmp_kernel_op_295)*(tmp_kernel_op_294 + tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_296 + tmp_kernel_op_297)*(tmp_kernel_op_296 + tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_298 + tmp_kernel_op_299)*(tmp_kernel_op_298 + tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_300 + tmp_kernel_op_301)*(tmp_kernel_op_300 + tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_302 + tmp_kernel_op_303)*(tmp_kernel_op_302 + tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_280 + tmp_kernel_op_281)*(tmp_kernel_op_280 + tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_282 + tmp_kernel_op_283)*(tmp_kernel_op_282 + tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_284 + tmp_kernel_op_285)*(tmp_kernel_op_284 + tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_7 = tmp_kernel_op_101*(((-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25)*(-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25))*16.0 + ((-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25)*(-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25))*16.0 + ((-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25)*(-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268)*(tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275)*(tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254)*(-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254))*16.0 + ((-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25)*(-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25))*16.0 + ((-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25)*(-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25))*16.0);
                const real_t elMatDiag_8 = tmp_kernel_op_101*(((-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25)*(-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25))*16.0 + ((-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25))*16.0 + ((-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_9 = tmp_kernel_op_101*(((-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290)*(tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25))*16.0);
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_57 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_59 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_60 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_57),tmp_kernel_op_60);
                const __m256d tmp_kernel_op_65 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_65),tmp_kernel_op_67);
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_68);
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_57),tmp_kernel_op_59),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_73 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_67),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_74 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_78),tmp_kernel_op_80);
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_78),tmp_kernel_op_79),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_65),tmp_kernel_op_66),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_80),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_60),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_89 = _mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,tmp_kernel_op_81),_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),tmp_kernel_op_87));
                const __m256d tmp_kernel_op_91 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_87));
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_95 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_83),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_87),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_90))));
                const __m256d tmp_kernel_op_108 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)),tmp_kernel_op_110);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_108),tmp_kernel_op_111);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_117 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_116),tmp_kernel_op_118);
                const __m256d tmp_kernel_op_120 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_119);
                const __m256d tmp_kernel_op_121 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_108),tmp_kernel_op_110),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_118),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_120);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_129),tmp_kernel_op_131);
                const __m256d tmp_kernel_op_133 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_129),tmp_kernel_op_130),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_116),tmp_kernel_op_117),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_131),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_111),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_138);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_136)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_139),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),tmp_kernel_op_138));
                const __m256d tmp_kernel_op_142 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_138));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_146 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_134),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_135),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_141))));
                const __m256d tmp_kernel_op_159 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155)),tmp_kernel_op_161);
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_159),tmp_kernel_op_162);
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)),tmp_kernel_op_168);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_167),tmp_kernel_op_169);
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_159),tmp_kernel_op_161),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_175 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_169),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_175);
                const __m256d tmp_kernel_op_177 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_180),tmp_kernel_op_182);
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_180),tmp_kernel_op_181),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_167),tmp_kernel_op_168),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_182),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_189 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_162),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_191 = _mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_189);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_183),_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_187)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_191),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),tmp_kernel_op_189));
                const __m256d tmp_kernel_op_193 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192);
                const __m256d tmp_kernel_op_194 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_190,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_196 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_187);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_185),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_189),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_199 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_189),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_185),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_186),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_202 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_192))));
                const __m256d tmp_kernel_op_204 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_206 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_207 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_211 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_214 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_24);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_232 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_249 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_252);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_230);
                const __m256d tmp_kernel_op_266 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_271 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_285 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_288 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_293 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_296 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_299 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_244);
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)))))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_145),tmp_kernel_op_209),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148),tmp_kernel_op_209)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_209)))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_196),tmp_kernel_op_211),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_199),tmp_kernel_op_211)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_202),tmp_kernel_op_211)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_144),tmp_kernel_op_214),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_147),tmp_kernel_op_214)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_214))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_195),tmp_kernel_op_215),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_198),tmp_kernel_op_215)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_201),tmp_kernel_op_215)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45))),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_126),tmp_kernel_op_218),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_146),tmp_kernel_op_218)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149),tmp_kernel_op_218))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_177),tmp_kernel_op_219),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_197),tmp_kernel_op_219)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_200),tmp_kernel_op_219)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98)))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223),_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225),_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227),_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231),_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233),_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235),_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239),_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241),_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243),_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247),_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249),_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251),_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254),_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256),_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258),_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261),_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263),_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265),_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268),_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270),_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272),_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275),_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277),_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279),_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281),_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283),_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285),_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287),_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289),_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291),_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293),_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295),_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297),_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299),_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301),_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303),_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_46 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_49 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_57 = -micromesh_dof_7*tmp_kernel_op_54;
                const real_t tmp_kernel_op_59 = micromesh_dof_0*tmp_kernel_op_58;
                const real_t tmp_kernel_op_60 = -micromesh_dof_8*tmp_kernel_op_53 + tmp_kernel_op_59;
                const real_t tmp_kernel_op_61 = micromesh_dof_1*tmp_kernel_op_52 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_53 + micromesh_dof_9*tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_60;
                const real_t tmp_kernel_op_65 = -micromesh_dof_19*tmp_kernel_op_51;
                const real_t tmp_kernel_op_66 = micromesh_dof_10*tmp_kernel_op_58;
                const real_t tmp_kernel_op_67 = -micromesh_dof_17*tmp_kernel_op_54 + tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = micromesh_dof_12*tmp_kernel_op_62 + micromesh_dof_14*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_51 + micromesh_dof_18*tmp_kernel_op_64 + tmp_kernel_op_65 + tmp_kernel_op_67;
                const real_t tmp_kernel_op_69 = tmp_kernel_op_61*tmp_kernel_op_68;
                const real_t tmp_kernel_op_70 = -micromesh_dof_9*tmp_kernel_op_51;
                const real_t tmp_kernel_op_71 = micromesh_dof_2*tmp_kernel_op_62 + micromesh_dof_4*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_51 + micromesh_dof_8*tmp_kernel_op_64 + tmp_kernel_op_57 + tmp_kernel_op_59 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = -micromesh_dof_18*tmp_kernel_op_53;
                const real_t tmp_kernel_op_73 = micromesh_dof_11*tmp_kernel_op_52 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_53 + micromesh_dof_19*tmp_kernel_op_56 + tmp_kernel_op_67 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_74 = tmp_kernel_op_71*tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = tmp_kernel_op_69 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_78 = -micromesh_dof_28*tmp_kernel_op_53;
                const real_t tmp_kernel_op_79 = micromesh_dof_20*tmp_kernel_op_58;
                const real_t tmp_kernel_op_80 = -micromesh_dof_29*tmp_kernel_op_51 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = micromesh_dof_23*tmp_kernel_op_76 + micromesh_dof_24*tmp_kernel_op_53 + micromesh_dof_25*tmp_kernel_op_51 + micromesh_dof_27*tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_80;
                const real_t tmp_kernel_op_82 = -micromesh_dof_27*tmp_kernel_op_54;
                const real_t tmp_kernel_op_83 = micromesh_dof_21*tmp_kernel_op_52 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_53 + micromesh_dof_29*tmp_kernel_op_56 + tmp_kernel_op_78 + tmp_kernel_op_79 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_13*tmp_kernel_op_76 + micromesh_dof_14*tmp_kernel_op_53 + micromesh_dof_15*tmp_kernel_op_51 + micromesh_dof_17*tmp_kernel_op_77 + tmp_kernel_op_65 + tmp_kernel_op_66 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_85 = tmp_kernel_op_71*tmp_kernel_op_84;
                const real_t tmp_kernel_op_86 = micromesh_dof_22*tmp_kernel_op_62 + micromesh_dof_24*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_51 + micromesh_dof_28*tmp_kernel_op_64 + tmp_kernel_op_80 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_87 = micromesh_dof_3*tmp_kernel_op_76 + micromesh_dof_4*tmp_kernel_op_53 + micromesh_dof_5*tmp_kernel_op_51 + micromesh_dof_7*tmp_kernel_op_77 + tmp_kernel_op_60 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_61*tmp_kernel_op_84;
                const real_t tmp_kernel_op_89 = tmp_kernel_op_68*tmp_kernel_op_87;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_69*tmp_kernel_op_81 + tmp_kernel_op_73*tmp_kernel_op_86*tmp_kernel_op_87 - tmp_kernel_op_74*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_85 - tmp_kernel_op_83*tmp_kernel_op_89 - tmp_kernel_op_86*tmp_kernel_op_88;
                const real_t tmp_kernel_op_91 = 1.0 / (tmp_kernel_op_90);
                const real_t tmp_kernel_op_92 = tmp_kernel_op_58*tmp_kernel_op_91;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_73*tmp_kernel_op_87 - tmp_kernel_op_88;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_85 - tmp_kernel_op_89;
                const real_t tmp_kernel_op_95 = -tmp_kernel_op_61*tmp_kernel_op_86 + tmp_kernel_op_71*tmp_kernel_op_83;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_61*tmp_kernel_op_81 - tmp_kernel_op_83*tmp_kernel_op_87;
                const real_t tmp_kernel_op_97 = -tmp_kernel_op_71*tmp_kernel_op_81 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_98 = -tmp_kernel_op_68*tmp_kernel_op_83 + tmp_kernel_op_73*tmp_kernel_op_86;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_73*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_84;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_68*tmp_kernel_op_81 - tmp_kernel_op_84*tmp_kernel_op_86;
                const real_t tmp_kernel_op_101 = 0.041666666666666657*abs(tmp_kernel_op_90);
                const real_t tmp_kernel_op_108 = -micromesh_dof_7*tmp_kernel_op_105;
                const real_t tmp_kernel_op_110 = micromesh_dof_0*tmp_kernel_op_109;
                const real_t tmp_kernel_op_111 = -micromesh_dof_8*tmp_kernel_op_104 + tmp_kernel_op_110;
                const real_t tmp_kernel_op_112 = micromesh_dof_1*tmp_kernel_op_103 + micromesh_dof_5*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_104 + micromesh_dof_9*tmp_kernel_op_107 + tmp_kernel_op_108 + tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = -micromesh_dof_19*tmp_kernel_op_102;
                const real_t tmp_kernel_op_117 = micromesh_dof_10*tmp_kernel_op_109;
                const real_t tmp_kernel_op_118 = -micromesh_dof_17*tmp_kernel_op_105 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_119 = micromesh_dof_12*tmp_kernel_op_113 + micromesh_dof_14*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_102 + micromesh_dof_18*tmp_kernel_op_115 + tmp_kernel_op_116 + tmp_kernel_op_118;
                const real_t tmp_kernel_op_120 = tmp_kernel_op_112*tmp_kernel_op_119;
                const real_t tmp_kernel_op_121 = -micromesh_dof_9*tmp_kernel_op_102;
                const real_t tmp_kernel_op_122 = micromesh_dof_2*tmp_kernel_op_113 + micromesh_dof_4*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_102 + micromesh_dof_8*tmp_kernel_op_115 + tmp_kernel_op_108 + tmp_kernel_op_110 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_123 = -micromesh_dof_18*tmp_kernel_op_104;
                const real_t tmp_kernel_op_124 = micromesh_dof_11*tmp_kernel_op_103 + micromesh_dof_15*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_104 + micromesh_dof_19*tmp_kernel_op_107 + tmp_kernel_op_118 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_122*tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_120 - tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = -micromesh_dof_28*tmp_kernel_op_104;
                const real_t tmp_kernel_op_130 = micromesh_dof_20*tmp_kernel_op_109;
                const real_t tmp_kernel_op_131 = -micromesh_dof_29*tmp_kernel_op_102 + tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = micromesh_dof_23*tmp_kernel_op_127 + micromesh_dof_24*tmp_kernel_op_104 + micromesh_dof_25*tmp_kernel_op_102 + micromesh_dof_27*tmp_kernel_op_128 + tmp_kernel_op_129 + tmp_kernel_op_131;
                const real_t tmp_kernel_op_133 = -micromesh_dof_27*tmp_kernel_op_105;
                const real_t tmp_kernel_op_134 = micromesh_dof_21*tmp_kernel_op_103 + micromesh_dof_25*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_104 + micromesh_dof_29*tmp_kernel_op_107 + tmp_kernel_op_129 + tmp_kernel_op_130 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = micromesh_dof_13*tmp_kernel_op_127 + micromesh_dof_14*tmp_kernel_op_104 + micromesh_dof_15*tmp_kernel_op_102 + micromesh_dof_17*tmp_kernel_op_128 + tmp_kernel_op_116 + tmp_kernel_op_117 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_136 = tmp_kernel_op_122*tmp_kernel_op_135;
                const real_t tmp_kernel_op_137 = micromesh_dof_22*tmp_kernel_op_113 + micromesh_dof_24*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_102 + micromesh_dof_28*tmp_kernel_op_115 + tmp_kernel_op_131 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_138 = micromesh_dof_3*tmp_kernel_op_127 + micromesh_dof_4*tmp_kernel_op_104 + micromesh_dof_5*tmp_kernel_op_102 + micromesh_dof_7*tmp_kernel_op_128 + tmp_kernel_op_111 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_139 = tmp_kernel_op_112*tmp_kernel_op_135;
                const real_t tmp_kernel_op_140 = tmp_kernel_op_119*tmp_kernel_op_138;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_120*tmp_kernel_op_132 + tmp_kernel_op_124*tmp_kernel_op_137*tmp_kernel_op_138 - tmp_kernel_op_125*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_136 - tmp_kernel_op_134*tmp_kernel_op_140 - tmp_kernel_op_137*tmp_kernel_op_139;
                const real_t tmp_kernel_op_142 = 1.0 / (tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_109*tmp_kernel_op_142;
                const real_t tmp_kernel_op_144 = tmp_kernel_op_124*tmp_kernel_op_138 - tmp_kernel_op_139;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_136 - tmp_kernel_op_140;
                const real_t tmp_kernel_op_146 = -tmp_kernel_op_112*tmp_kernel_op_137 + tmp_kernel_op_122*tmp_kernel_op_134;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_112*tmp_kernel_op_132 - tmp_kernel_op_134*tmp_kernel_op_138;
                const real_t tmp_kernel_op_148 = -tmp_kernel_op_122*tmp_kernel_op_132 + tmp_kernel_op_137*tmp_kernel_op_138;
                const real_t tmp_kernel_op_149 = -tmp_kernel_op_119*tmp_kernel_op_134 + tmp_kernel_op_124*tmp_kernel_op_137;
                const real_t tmp_kernel_op_150 = -tmp_kernel_op_124*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_135;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_119*tmp_kernel_op_132 - tmp_kernel_op_135*tmp_kernel_op_137;
                const real_t tmp_kernel_op_152 = 0.041666666666666657*abs(tmp_kernel_op_141);
                const real_t tmp_kernel_op_159 = -micromesh_dof_7*tmp_kernel_op_156;
                const real_t tmp_kernel_op_161 = micromesh_dof_0*tmp_kernel_op_160;
                const real_t tmp_kernel_op_162 = -micromesh_dof_8*tmp_kernel_op_155 + tmp_kernel_op_161;
                const real_t tmp_kernel_op_163 = micromesh_dof_1*tmp_kernel_op_154 + micromesh_dof_5*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_155 + micromesh_dof_9*tmp_kernel_op_158 + tmp_kernel_op_159 + tmp_kernel_op_162;
                const real_t tmp_kernel_op_167 = -micromesh_dof_19*tmp_kernel_op_153;
                const real_t tmp_kernel_op_168 = micromesh_dof_10*tmp_kernel_op_160;
                const real_t tmp_kernel_op_169 = -micromesh_dof_17*tmp_kernel_op_156 + tmp_kernel_op_168;
                const real_t tmp_kernel_op_170 = micromesh_dof_12*tmp_kernel_op_164 + micromesh_dof_14*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_153 + micromesh_dof_18*tmp_kernel_op_166 + tmp_kernel_op_167 + tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_163*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = -micromesh_dof_9*tmp_kernel_op_153;
                const real_t tmp_kernel_op_173 = micromesh_dof_2*tmp_kernel_op_164 + micromesh_dof_4*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_153 + micromesh_dof_8*tmp_kernel_op_166 + tmp_kernel_op_159 + tmp_kernel_op_161 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_174 = -micromesh_dof_18*tmp_kernel_op_155;
                const real_t tmp_kernel_op_175 = micromesh_dof_11*tmp_kernel_op_154 + micromesh_dof_15*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_155 + micromesh_dof_19*tmp_kernel_op_158 + tmp_kernel_op_169 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_173*tmp_kernel_op_175;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_171 - tmp_kernel_op_176;
                const real_t tmp_kernel_op_180 = -micromesh_dof_28*tmp_kernel_op_155;
                const real_t tmp_kernel_op_181 = micromesh_dof_20*tmp_kernel_op_160;
                const real_t tmp_kernel_op_182 = -micromesh_dof_29*tmp_kernel_op_153 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = micromesh_dof_23*tmp_kernel_op_178 + micromesh_dof_24*tmp_kernel_op_155 + micromesh_dof_25*tmp_kernel_op_153 + micromesh_dof_27*tmp_kernel_op_179 + tmp_kernel_op_180 + tmp_kernel_op_182;
                const real_t tmp_kernel_op_184 = -micromesh_dof_27*tmp_kernel_op_156;
                const real_t tmp_kernel_op_185 = micromesh_dof_21*tmp_kernel_op_154 + micromesh_dof_25*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_155 + micromesh_dof_29*tmp_kernel_op_158 + tmp_kernel_op_180 + tmp_kernel_op_181 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = micromesh_dof_13*tmp_kernel_op_178 + micromesh_dof_14*tmp_kernel_op_155 + micromesh_dof_15*tmp_kernel_op_153 + micromesh_dof_17*tmp_kernel_op_179 + tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_173*tmp_kernel_op_186;
                const real_t tmp_kernel_op_188 = micromesh_dof_22*tmp_kernel_op_164 + micromesh_dof_24*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_153 + micromesh_dof_28*tmp_kernel_op_166 + tmp_kernel_op_182 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_189 = micromesh_dof_3*tmp_kernel_op_178 + micromesh_dof_4*tmp_kernel_op_155 + micromesh_dof_5*tmp_kernel_op_153 + micromesh_dof_7*tmp_kernel_op_179 + tmp_kernel_op_162 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_163*tmp_kernel_op_186;
                const real_t tmp_kernel_op_191 = tmp_kernel_op_170*tmp_kernel_op_189;
                const real_t tmp_kernel_op_192 = tmp_kernel_op_171*tmp_kernel_op_183 + tmp_kernel_op_175*tmp_kernel_op_188*tmp_kernel_op_189 - tmp_kernel_op_176*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_187 - tmp_kernel_op_185*tmp_kernel_op_191 - tmp_kernel_op_188*tmp_kernel_op_190;
                const real_t tmp_kernel_op_193 = 1.0 / (tmp_kernel_op_192);
                const real_t tmp_kernel_op_194 = tmp_kernel_op_160*tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = tmp_kernel_op_175*tmp_kernel_op_189 - tmp_kernel_op_190;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_187 - tmp_kernel_op_191;
                const real_t tmp_kernel_op_197 = -tmp_kernel_op_163*tmp_kernel_op_188 + tmp_kernel_op_173*tmp_kernel_op_185;
                const real_t tmp_kernel_op_198 = tmp_kernel_op_163*tmp_kernel_op_183 - tmp_kernel_op_185*tmp_kernel_op_189;
                const real_t tmp_kernel_op_199 = -tmp_kernel_op_173*tmp_kernel_op_183 + tmp_kernel_op_188*tmp_kernel_op_189;
                const real_t tmp_kernel_op_200 = -tmp_kernel_op_170*tmp_kernel_op_185 + tmp_kernel_op_175*tmp_kernel_op_188;
                const real_t tmp_kernel_op_201 = -tmp_kernel_op_175*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_186;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_170*tmp_kernel_op_183 - tmp_kernel_op_186*tmp_kernel_op_188;
                const real_t tmp_kernel_op_203 = 0.041666666666666657*abs(tmp_kernel_op_192);
                const real_t tmp_kernel_op_204 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39)*16.0;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_206 = 1.0 / (tmp_kernel_op_90*tmp_kernel_op_90)*16.0;
                const real_t tmp_kernel_op_207 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_208 = 1.0 / (tmp_kernel_op_141*tmp_kernel_op_141)*16.0;
                const real_t tmp_kernel_op_209 = tmp_kernel_op_208*0.11249999999999996;
                const real_t tmp_kernel_op_210 = 1.0 / (tmp_kernel_op_192*tmp_kernel_op_192)*16.0;
                const real_t tmp_kernel_op_211 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_206*0.11249999999999996;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_204*0.11249999999999996;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_24;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_222*tmp_kernel_op_42;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_220*tmp_kernel_op_44;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_222*tmp_kernel_op_45;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_220*tmp_kernel_op_47;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_222*tmp_kernel_op_48;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_91*0.5854101966249684;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_228*tmp_kernel_op_75;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_230*tmp_kernel_op_93;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_228*tmp_kernel_op_95;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_230*tmp_kernel_op_96;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_228*tmp_kernel_op_98;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_230*tmp_kernel_op_99;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_126*tmp_kernel_op_236;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_144*tmp_kernel_op_238;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_146*tmp_kernel_op_236;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_147*tmp_kernel_op_238;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_149*tmp_kernel_op_236;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_150*tmp_kernel_op_238;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_177*tmp_kernel_op_244;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_195*tmp_kernel_op_246;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_197*tmp_kernel_op_244;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_198*tmp_kernel_op_246;
                const real_t tmp_kernel_op_250 = tmp_kernel_op_200*tmp_kernel_op_244;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_201*tmp_kernel_op_246;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_24*tmp_kernel_op_252;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_222*tmp_kernel_op_43;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_252*tmp_kernel_op_44;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_222*tmp_kernel_op_46;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_252*tmp_kernel_op_47;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_222*tmp_kernel_op_49;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_259*tmp_kernel_op_75;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_230*tmp_kernel_op_94;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_259*tmp_kernel_op_95;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_230*tmp_kernel_op_97;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_259*tmp_kernel_op_98;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_100*tmp_kernel_op_230;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_142*0.5854101966249684;
                const real_t tmp_kernel_op_267 = tmp_kernel_op_126*tmp_kernel_op_266;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_145*tmp_kernel_op_238;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_146*tmp_kernel_op_266;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_148*tmp_kernel_op_238;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_149*tmp_kernel_op_266;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_151*tmp_kernel_op_238;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_177*tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_196*tmp_kernel_op_246;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_197*tmp_kernel_op_273;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_199*tmp_kernel_op_246;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_200*tmp_kernel_op_273;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_202*tmp_kernel_op_246;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_252*tmp_kernel_op_42;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_220*tmp_kernel_op_43;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_252*tmp_kernel_op_45;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_220*tmp_kernel_op_46;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_252*tmp_kernel_op_48;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_220*tmp_kernel_op_49;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_259*tmp_kernel_op_93;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_228*tmp_kernel_op_94;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_259*tmp_kernel_op_96;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_228*tmp_kernel_op_97;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_259*tmp_kernel_op_99;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_100*tmp_kernel_op_228;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_144*tmp_kernel_op_266;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_145*tmp_kernel_op_236;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_147*tmp_kernel_op_266;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_148*tmp_kernel_op_236;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_150*tmp_kernel_op_266;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_151*tmp_kernel_op_236;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_195*tmp_kernel_op_273;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_196*tmp_kernel_op_244;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_198*tmp_kernel_op_273;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_199*tmp_kernel_op_244;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_201*tmp_kernel_op_273;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_202*tmp_kernel_op_244;
                const real_t elMatDiag_0 = tmp_kernel_op_101*(((tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)*(tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)) + ((tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)*(tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)) + ((tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97)*(tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97))) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)*(tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)) + ((tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)*(tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)) + ((tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151)*(tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151))) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)*(tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)) + ((tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)*(tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)) + ((tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202)*(tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202))) + tmp_kernel_op_50*(((tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)*(tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)) + ((tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)*(tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)) + ((tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)*(tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)));
                const real_t elMatDiag_1 = tmp_kernel_op_101*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_207 + tmp_kernel_op_207*(tmp_kernel_op_94*tmp_kernel_op_94) + tmp_kernel_op_207*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_152*((tmp_kernel_op_145*tmp_kernel_op_145)*tmp_kernel_op_209 + (tmp_kernel_op_148*tmp_kernel_op_148)*tmp_kernel_op_209 + (tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_209) + tmp_kernel_op_203*((tmp_kernel_op_196*tmp_kernel_op_196)*tmp_kernel_op_211 + (tmp_kernel_op_199*tmp_kernel_op_199)*tmp_kernel_op_211 + (tmp_kernel_op_202*tmp_kernel_op_202)*tmp_kernel_op_211) + tmp_kernel_op_50*(tmp_kernel_op_205*(tmp_kernel_op_43*tmp_kernel_op_43) + tmp_kernel_op_205*(tmp_kernel_op_46*tmp_kernel_op_46) + tmp_kernel_op_205*(tmp_kernel_op_49*tmp_kernel_op_49));
                const real_t elMatDiag_2 = tmp_kernel_op_101*(tmp_kernel_op_213*(tmp_kernel_op_93*tmp_kernel_op_93) + tmp_kernel_op_213*(tmp_kernel_op_96*tmp_kernel_op_96) + tmp_kernel_op_213*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_152*((tmp_kernel_op_144*tmp_kernel_op_144)*tmp_kernel_op_214 + (tmp_kernel_op_147*tmp_kernel_op_147)*tmp_kernel_op_214 + (tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_214) + tmp_kernel_op_203*((tmp_kernel_op_195*tmp_kernel_op_195)*tmp_kernel_op_215 + (tmp_kernel_op_198*tmp_kernel_op_198)*tmp_kernel_op_215 + (tmp_kernel_op_201*tmp_kernel_op_201)*tmp_kernel_op_215) + tmp_kernel_op_50*(tmp_kernel_op_212*(tmp_kernel_op_42*tmp_kernel_op_42) + tmp_kernel_op_212*(tmp_kernel_op_45*tmp_kernel_op_45) + tmp_kernel_op_212*(tmp_kernel_op_48*tmp_kernel_op_48));
                const real_t elMatDiag_3 = tmp_kernel_op_101*(tmp_kernel_op_217*(tmp_kernel_op_75*tmp_kernel_op_75) + tmp_kernel_op_217*(tmp_kernel_op_95*tmp_kernel_op_95) + tmp_kernel_op_217*(tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_152*((tmp_kernel_op_126*tmp_kernel_op_126)*tmp_kernel_op_218 + (tmp_kernel_op_146*tmp_kernel_op_146)*tmp_kernel_op_218 + (tmp_kernel_op_149*tmp_kernel_op_149)*tmp_kernel_op_218) + tmp_kernel_op_203*((tmp_kernel_op_177*tmp_kernel_op_177)*tmp_kernel_op_219 + (tmp_kernel_op_197*tmp_kernel_op_197)*tmp_kernel_op_219 + (tmp_kernel_op_200*tmp_kernel_op_200)*tmp_kernel_op_219) + tmp_kernel_op_50*(tmp_kernel_op_216*(tmp_kernel_op_24*tmp_kernel_op_24) + tmp_kernel_op_216*(tmp_kernel_op_44*tmp_kernel_op_44) + tmp_kernel_op_216*(tmp_kernel_op_47*tmp_kernel_op_47));
                const real_t elMatDiag_4 = tmp_kernel_op_101*(((tmp_kernel_op_229 + tmp_kernel_op_231)*(tmp_kernel_op_229 + tmp_kernel_op_231))*16.0 + ((tmp_kernel_op_232 + tmp_kernel_op_233)*(tmp_kernel_op_232 + tmp_kernel_op_233))*16.0 + ((tmp_kernel_op_234 + tmp_kernel_op_235)*(tmp_kernel_op_234 + tmp_kernel_op_235))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_237 + tmp_kernel_op_239)*(tmp_kernel_op_237 + tmp_kernel_op_239))*16.0 + ((tmp_kernel_op_240 + tmp_kernel_op_241)*(tmp_kernel_op_240 + tmp_kernel_op_241))*16.0 + ((tmp_kernel_op_242 + tmp_kernel_op_243)*(tmp_kernel_op_242 + tmp_kernel_op_243))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_245 + tmp_kernel_op_247)*(tmp_kernel_op_245 + tmp_kernel_op_247))*16.0 + ((tmp_kernel_op_248 + tmp_kernel_op_249)*(tmp_kernel_op_248 + tmp_kernel_op_249))*16.0 + ((tmp_kernel_op_250 + tmp_kernel_op_251)*(tmp_kernel_op_250 + tmp_kernel_op_251))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_221 + tmp_kernel_op_223)*(tmp_kernel_op_221 + tmp_kernel_op_223))*16.0 + ((tmp_kernel_op_224 + tmp_kernel_op_225)*(tmp_kernel_op_224 + tmp_kernel_op_225))*16.0 + ((tmp_kernel_op_226 + tmp_kernel_op_227)*(tmp_kernel_op_226 + tmp_kernel_op_227))*16.0);
                const real_t elMatDiag_5 = tmp_kernel_op_101*(((tmp_kernel_op_260 + tmp_kernel_op_261)*(tmp_kernel_op_260 + tmp_kernel_op_261))*16.0 + ((tmp_kernel_op_262 + tmp_kernel_op_263)*(tmp_kernel_op_262 + tmp_kernel_op_263))*16.0 + ((tmp_kernel_op_264 + tmp_kernel_op_265)*(tmp_kernel_op_264 + tmp_kernel_op_265))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_267 + tmp_kernel_op_268)*(tmp_kernel_op_267 + tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_269 + tmp_kernel_op_270)*(tmp_kernel_op_269 + tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_271 + tmp_kernel_op_272)*(tmp_kernel_op_271 + tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_274 + tmp_kernel_op_275)*(tmp_kernel_op_274 + tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_276 + tmp_kernel_op_277)*(tmp_kernel_op_276 + tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_278 + tmp_kernel_op_279)*(tmp_kernel_op_278 + tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_253 + tmp_kernel_op_254)*(tmp_kernel_op_253 + tmp_kernel_op_254))*16.0 + ((tmp_kernel_op_255 + tmp_kernel_op_256)*(tmp_kernel_op_255 + tmp_kernel_op_256))*16.0 + ((tmp_kernel_op_257 + tmp_kernel_op_258)*(tmp_kernel_op_257 + tmp_kernel_op_258))*16.0);
                const real_t elMatDiag_6 = tmp_kernel_op_101*(((tmp_kernel_op_286 + tmp_kernel_op_287)*(tmp_kernel_op_286 + tmp_kernel_op_287))*16.0 + ((tmp_kernel_op_288 + tmp_kernel_op_289)*(tmp_kernel_op_288 + tmp_kernel_op_289))*16.0 + ((tmp_kernel_op_290 + tmp_kernel_op_291)*(tmp_kernel_op_290 + tmp_kernel_op_291))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_292 + tmp_kernel_op_293)*(tmp_kernel_op_292 + tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_294 + tmp_kernel_op_295)*(tmp_kernel_op_294 + tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_296 + tmp_kernel_op_297)*(tmp_kernel_op_296 + tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_298 + tmp_kernel_op_299)*(tmp_kernel_op_298 + tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_300 + tmp_kernel_op_301)*(tmp_kernel_op_300 + tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_302 + tmp_kernel_op_303)*(tmp_kernel_op_302 + tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_280 + tmp_kernel_op_281)*(tmp_kernel_op_280 + tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_282 + tmp_kernel_op_283)*(tmp_kernel_op_282 + tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_284 + tmp_kernel_op_285)*(tmp_kernel_op_284 + tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_7 = tmp_kernel_op_101*(((-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25)*(-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25))*16.0 + ((-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25)*(-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25))*16.0 + ((-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25)*(-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268)*(tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275)*(tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254)*(-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254))*16.0 + ((-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25)*(-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25))*16.0 + ((-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25)*(-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25))*16.0);
                const real_t elMatDiag_8 = tmp_kernel_op_101*(((-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25)*(-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25))*16.0 + ((-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25))*16.0 + ((-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_9 = tmp_kernel_op_101*(((-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290)*(tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25))*16.0);
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_57 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_59 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_60 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_57),tmp_kernel_op_60);
                const __m256d tmp_kernel_op_65 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_65),tmp_kernel_op_67);
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_68);
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_57),tmp_kernel_op_59),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_73 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_67),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_74 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53));
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_78),tmp_kernel_op_80);
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),tmp_kernel_op_78),tmp_kernel_op_79),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_65),tmp_kernel_op_66),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),tmp_kernel_op_80),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),tmp_kernel_op_60),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_84);
                const __m256d tmp_kernel_op_89 = _mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,tmp_kernel_op_81),_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),tmp_kernel_op_87));
                const __m256d tmp_kernel_op_91 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58));
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_87));
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_95 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_83),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_87),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_83,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_73,tmp_kernel_op_81),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_68,tmp_kernel_op_81),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_90))));
                const __m256d tmp_kernel_op_108 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)),tmp_kernel_op_110);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_108),tmp_kernel_op_111);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_117 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_116),tmp_kernel_op_118);
                const __m256d tmp_kernel_op_120 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_119);
                const __m256d tmp_kernel_op_121 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_108),tmp_kernel_op_110),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_118),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_120);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_129),tmp_kernel_op_131);
                const __m256d tmp_kernel_op_133 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105));
                const __m256d tmp_kernel_op_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),tmp_kernel_op_129),tmp_kernel_op_130),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_116),tmp_kernel_op_117),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),tmp_kernel_op_131),tmp_kernel_op_133);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),tmp_kernel_op_111),tmp_kernel_op_121);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_135);
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_138);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_136)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_139),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),tmp_kernel_op_138));
                const __m256d tmp_kernel_op_142 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_138));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_146 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_134),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_122,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_137),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_135),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_132),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_141))));
                const __m256d tmp_kernel_op_159 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155)),tmp_kernel_op_161);
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_159),tmp_kernel_op_162);
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)),tmp_kernel_op_168);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_167),tmp_kernel_op_169);
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153));
                const __m256d tmp_kernel_op_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_159),tmp_kernel_op_161),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_175 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_169),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_175);
                const __m256d tmp_kernel_op_177 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_180),tmp_kernel_op_182);
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),tmp_kernel_op_180),tmp_kernel_op_181),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_167),tmp_kernel_op_168),tmp_kernel_op_174);
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),tmp_kernel_op_182),tmp_kernel_op_184);
                const __m256d tmp_kernel_op_189 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153,tmp_kernel_op_153)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178,tmp_kernel_op_178))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),tmp_kernel_op_162),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_186);
                const __m256d tmp_kernel_op_191 = _mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_189);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_183),_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_187)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_191),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),tmp_kernel_op_189));
                const __m256d tmp_kernel_op_193 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192);
                const __m256d tmp_kernel_op_194 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_190,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_196 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_187);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_185),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_189),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_199 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_188,tmp_kernel_op_189),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_188),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_185),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_186),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_183),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_202 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_183),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_188),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_192))));
                const __m256d tmp_kernel_op_204 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_206 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_90)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_207 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_141)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_192)),_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_211 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_214 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_204,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_208,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_24);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_232 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_249 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_252);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_44);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_95);
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_98);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_230);
                const __m256d tmp_kernel_op_266 = _mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_271 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_238);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_193,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_246);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48);
                const __m256d tmp_kernel_op_285 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_93);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_94);
                const __m256d tmp_kernel_op_288 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_228,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_293 = _mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_296 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_266);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_236);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_299 = _mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_244);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_244);
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_98)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_97))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_143),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_146),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_147)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_148)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_151)))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_194),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_197),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_199)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_201)),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_202)))))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(tmp_kernel_op_207,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_145),tmp_kernel_op_209),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148),tmp_kernel_op_209)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_209)))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_196),tmp_kernel_op_211),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_199),tmp_kernel_op_211)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_202),tmp_kernel_op_211)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(tmp_kernel_op_205,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_144,tmp_kernel_op_144),tmp_kernel_op_214),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_147),tmp_kernel_op_214)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_214))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_195),tmp_kernel_op_215),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_198,tmp_kernel_op_198),tmp_kernel_op_215)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_201,tmp_kernel_op_201),tmp_kernel_op_215)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45))),_mm256_mul_pd(tmp_kernel_op_212,_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_213,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_126),tmp_kernel_op_218),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_146,tmp_kernel_op_146),tmp_kernel_op_218)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149),tmp_kernel_op_218))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_177),tmp_kernel_op_219),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_197),tmp_kernel_op_219)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,tmp_kernel_op_200),tmp_kernel_op_219)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(tmp_kernel_op_216,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(tmp_kernel_op_217,_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98)))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223),_mm256_add_pd(tmp_kernel_op_221,tmp_kernel_op_223)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225),_mm256_add_pd(tmp_kernel_op_224,tmp_kernel_op_225)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227),_mm256_add_pd(tmp_kernel_op_226,tmp_kernel_op_227)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231),_mm256_add_pd(tmp_kernel_op_229,tmp_kernel_op_231)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233),_mm256_add_pd(tmp_kernel_op_232,tmp_kernel_op_233)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235),_mm256_add_pd(tmp_kernel_op_234,tmp_kernel_op_235)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239),_mm256_add_pd(tmp_kernel_op_237,tmp_kernel_op_239)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241),_mm256_add_pd(tmp_kernel_op_240,tmp_kernel_op_241)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243),_mm256_add_pd(tmp_kernel_op_242,tmp_kernel_op_243)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247),_mm256_add_pd(tmp_kernel_op_245,tmp_kernel_op_247)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249),_mm256_add_pd(tmp_kernel_op_248,tmp_kernel_op_249)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251),_mm256_add_pd(tmp_kernel_op_250,tmp_kernel_op_251)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254),_mm256_add_pd(tmp_kernel_op_253,tmp_kernel_op_254)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256),_mm256_add_pd(tmp_kernel_op_255,tmp_kernel_op_256)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258),_mm256_add_pd(tmp_kernel_op_257,tmp_kernel_op_258)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261),_mm256_add_pd(tmp_kernel_op_260,tmp_kernel_op_261)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263),_mm256_add_pd(tmp_kernel_op_262,tmp_kernel_op_263)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265),_mm256_add_pd(tmp_kernel_op_264,tmp_kernel_op_265)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268),_mm256_add_pd(tmp_kernel_op_267,tmp_kernel_op_268)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270),_mm256_add_pd(tmp_kernel_op_269,tmp_kernel_op_270)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272),_mm256_add_pd(tmp_kernel_op_271,tmp_kernel_op_272)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275),_mm256_add_pd(tmp_kernel_op_274,tmp_kernel_op_275)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277),_mm256_add_pd(tmp_kernel_op_276,tmp_kernel_op_277)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279),_mm256_add_pd(tmp_kernel_op_278,tmp_kernel_op_279)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281),_mm256_add_pd(tmp_kernel_op_280,tmp_kernel_op_281)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283),_mm256_add_pd(tmp_kernel_op_282,tmp_kernel_op_283)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285),_mm256_add_pd(tmp_kernel_op_284,tmp_kernel_op_285)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287),_mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289),_mm256_add_pd(tmp_kernel_op_288,tmp_kernel_op_289)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291),_mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_291)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293),_mm256_add_pd(tmp_kernel_op_292,tmp_kernel_op_293)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295),_mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297),_mm256_add_pd(tmp_kernel_op_296,tmp_kernel_op_297)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299),_mm256_add_pd(tmp_kernel_op_298,tmp_kernel_op_299)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301),_mm256_add_pd(tmp_kernel_op_300,tmp_kernel_op_301)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303),_mm256_add_pd(tmp_kernel_op_302,tmp_kernel_op_303)),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_254,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_256,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_44),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_258,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_261,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_263,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_95),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_265,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_98),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_142),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_241,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_146),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_149),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_247,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_193),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_249,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_277,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_197),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_200),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_226,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_285,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_48),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_93),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_232,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_289,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_291,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_293,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_144),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_147),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_245,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_299,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_195),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_248,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_198),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_250,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_201),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_253,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_280,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_282,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_257,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_260,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_262,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_288,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_91,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_264,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_91),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_152,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_267,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_145),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_269,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_296,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_274,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_196),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_300,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_199),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_278,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_302,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_46 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_49 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_57 = -micromesh_dof_7*tmp_kernel_op_54;
                const real_t tmp_kernel_op_59 = micromesh_dof_0*tmp_kernel_op_58;
                const real_t tmp_kernel_op_60 = -micromesh_dof_8*tmp_kernel_op_53 + tmp_kernel_op_59;
                const real_t tmp_kernel_op_61 = micromesh_dof_1*tmp_kernel_op_52 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_53 + micromesh_dof_9*tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_60;
                const real_t tmp_kernel_op_65 = -micromesh_dof_19*tmp_kernel_op_51;
                const real_t tmp_kernel_op_66 = micromesh_dof_10*tmp_kernel_op_58;
                const real_t tmp_kernel_op_67 = -micromesh_dof_17*tmp_kernel_op_54 + tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = micromesh_dof_12*tmp_kernel_op_62 + micromesh_dof_14*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_51 + micromesh_dof_18*tmp_kernel_op_64 + tmp_kernel_op_65 + tmp_kernel_op_67;
                const real_t tmp_kernel_op_69 = tmp_kernel_op_61*tmp_kernel_op_68;
                const real_t tmp_kernel_op_70 = -micromesh_dof_9*tmp_kernel_op_51;
                const real_t tmp_kernel_op_71 = micromesh_dof_2*tmp_kernel_op_62 + micromesh_dof_4*tmp_kernel_op_54 + micromesh_dof_6*tmp_kernel_op_51 + micromesh_dof_8*tmp_kernel_op_64 + tmp_kernel_op_57 + tmp_kernel_op_59 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = -micromesh_dof_18*tmp_kernel_op_53;
                const real_t tmp_kernel_op_73 = micromesh_dof_11*tmp_kernel_op_52 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_16*tmp_kernel_op_53 + micromesh_dof_19*tmp_kernel_op_56 + tmp_kernel_op_67 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_74 = tmp_kernel_op_71*tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = tmp_kernel_op_69 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_78 = -micromesh_dof_28*tmp_kernel_op_53;
                const real_t tmp_kernel_op_79 = micromesh_dof_20*tmp_kernel_op_58;
                const real_t tmp_kernel_op_80 = -micromesh_dof_29*tmp_kernel_op_51 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = micromesh_dof_23*tmp_kernel_op_76 + micromesh_dof_24*tmp_kernel_op_53 + micromesh_dof_25*tmp_kernel_op_51 + micromesh_dof_27*tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_80;
                const real_t tmp_kernel_op_82 = -micromesh_dof_27*tmp_kernel_op_54;
                const real_t tmp_kernel_op_83 = micromesh_dof_21*tmp_kernel_op_52 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_53 + micromesh_dof_29*tmp_kernel_op_56 + tmp_kernel_op_78 + tmp_kernel_op_79 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_13*tmp_kernel_op_76 + micromesh_dof_14*tmp_kernel_op_53 + micromesh_dof_15*tmp_kernel_op_51 + micromesh_dof_17*tmp_kernel_op_77 + tmp_kernel_op_65 + tmp_kernel_op_66 + tmp_kernel_op_72;
                const real_t tmp_kernel_op_85 = tmp_kernel_op_71*tmp_kernel_op_84;
                const real_t tmp_kernel_op_86 = micromesh_dof_22*tmp_kernel_op_62 + micromesh_dof_24*tmp_kernel_op_54 + micromesh_dof_26*tmp_kernel_op_51 + micromesh_dof_28*tmp_kernel_op_64 + tmp_kernel_op_80 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_87 = micromesh_dof_3*tmp_kernel_op_76 + micromesh_dof_4*tmp_kernel_op_53 + micromesh_dof_5*tmp_kernel_op_51 + micromesh_dof_7*tmp_kernel_op_77 + tmp_kernel_op_60 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_61*tmp_kernel_op_84;
                const real_t tmp_kernel_op_89 = tmp_kernel_op_68*tmp_kernel_op_87;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_69*tmp_kernel_op_81 + tmp_kernel_op_73*tmp_kernel_op_86*tmp_kernel_op_87 - tmp_kernel_op_74*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_85 - tmp_kernel_op_83*tmp_kernel_op_89 - tmp_kernel_op_86*tmp_kernel_op_88;
                const real_t tmp_kernel_op_91 = 1.0 / (tmp_kernel_op_90);
                const real_t tmp_kernel_op_92 = tmp_kernel_op_58*tmp_kernel_op_91;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_73*tmp_kernel_op_87 - tmp_kernel_op_88;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_85 - tmp_kernel_op_89;
                const real_t tmp_kernel_op_95 = -tmp_kernel_op_61*tmp_kernel_op_86 + tmp_kernel_op_71*tmp_kernel_op_83;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_61*tmp_kernel_op_81 - tmp_kernel_op_83*tmp_kernel_op_87;
                const real_t tmp_kernel_op_97 = -tmp_kernel_op_71*tmp_kernel_op_81 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_98 = -tmp_kernel_op_68*tmp_kernel_op_83 + tmp_kernel_op_73*tmp_kernel_op_86;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_73*tmp_kernel_op_81 + tmp_kernel_op_83*tmp_kernel_op_84;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_68*tmp_kernel_op_81 - tmp_kernel_op_84*tmp_kernel_op_86;
                const real_t tmp_kernel_op_101 = 0.041666666666666657*abs(tmp_kernel_op_90);
                const real_t tmp_kernel_op_108 = -micromesh_dof_7*tmp_kernel_op_105;
                const real_t tmp_kernel_op_110 = micromesh_dof_0*tmp_kernel_op_109;
                const real_t tmp_kernel_op_111 = -micromesh_dof_8*tmp_kernel_op_104 + tmp_kernel_op_110;
                const real_t tmp_kernel_op_112 = micromesh_dof_1*tmp_kernel_op_103 + micromesh_dof_5*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_104 + micromesh_dof_9*tmp_kernel_op_107 + tmp_kernel_op_108 + tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = -micromesh_dof_19*tmp_kernel_op_102;
                const real_t tmp_kernel_op_117 = micromesh_dof_10*tmp_kernel_op_109;
                const real_t tmp_kernel_op_118 = -micromesh_dof_17*tmp_kernel_op_105 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_119 = micromesh_dof_12*tmp_kernel_op_113 + micromesh_dof_14*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_102 + micromesh_dof_18*tmp_kernel_op_115 + tmp_kernel_op_116 + tmp_kernel_op_118;
                const real_t tmp_kernel_op_120 = tmp_kernel_op_112*tmp_kernel_op_119;
                const real_t tmp_kernel_op_121 = -micromesh_dof_9*tmp_kernel_op_102;
                const real_t tmp_kernel_op_122 = micromesh_dof_2*tmp_kernel_op_113 + micromesh_dof_4*tmp_kernel_op_105 + micromesh_dof_6*tmp_kernel_op_102 + micromesh_dof_8*tmp_kernel_op_115 + tmp_kernel_op_108 + tmp_kernel_op_110 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_123 = -micromesh_dof_18*tmp_kernel_op_104;
                const real_t tmp_kernel_op_124 = micromesh_dof_11*tmp_kernel_op_103 + micromesh_dof_15*tmp_kernel_op_105 + micromesh_dof_16*tmp_kernel_op_104 + micromesh_dof_19*tmp_kernel_op_107 + tmp_kernel_op_118 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_122*tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_120 - tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = -micromesh_dof_28*tmp_kernel_op_104;
                const real_t tmp_kernel_op_130 = micromesh_dof_20*tmp_kernel_op_109;
                const real_t tmp_kernel_op_131 = -micromesh_dof_29*tmp_kernel_op_102 + tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = micromesh_dof_23*tmp_kernel_op_127 + micromesh_dof_24*tmp_kernel_op_104 + micromesh_dof_25*tmp_kernel_op_102 + micromesh_dof_27*tmp_kernel_op_128 + tmp_kernel_op_129 + tmp_kernel_op_131;
                const real_t tmp_kernel_op_133 = -micromesh_dof_27*tmp_kernel_op_105;
                const real_t tmp_kernel_op_134 = micromesh_dof_21*tmp_kernel_op_103 + micromesh_dof_25*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_104 + micromesh_dof_29*tmp_kernel_op_107 + tmp_kernel_op_129 + tmp_kernel_op_130 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = micromesh_dof_13*tmp_kernel_op_127 + micromesh_dof_14*tmp_kernel_op_104 + micromesh_dof_15*tmp_kernel_op_102 + micromesh_dof_17*tmp_kernel_op_128 + tmp_kernel_op_116 + tmp_kernel_op_117 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_136 = tmp_kernel_op_122*tmp_kernel_op_135;
                const real_t tmp_kernel_op_137 = micromesh_dof_22*tmp_kernel_op_113 + micromesh_dof_24*tmp_kernel_op_105 + micromesh_dof_26*tmp_kernel_op_102 + micromesh_dof_28*tmp_kernel_op_115 + tmp_kernel_op_131 + tmp_kernel_op_133;
                const real_t tmp_kernel_op_138 = micromesh_dof_3*tmp_kernel_op_127 + micromesh_dof_4*tmp_kernel_op_104 + micromesh_dof_5*tmp_kernel_op_102 + micromesh_dof_7*tmp_kernel_op_128 + tmp_kernel_op_111 + tmp_kernel_op_121;
                const real_t tmp_kernel_op_139 = tmp_kernel_op_112*tmp_kernel_op_135;
                const real_t tmp_kernel_op_140 = tmp_kernel_op_119*tmp_kernel_op_138;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_120*tmp_kernel_op_132 + tmp_kernel_op_124*tmp_kernel_op_137*tmp_kernel_op_138 - tmp_kernel_op_125*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_136 - tmp_kernel_op_134*tmp_kernel_op_140 - tmp_kernel_op_137*tmp_kernel_op_139;
                const real_t tmp_kernel_op_142 = 1.0 / (tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_109*tmp_kernel_op_142;
                const real_t tmp_kernel_op_144 = tmp_kernel_op_124*tmp_kernel_op_138 - tmp_kernel_op_139;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_136 - tmp_kernel_op_140;
                const real_t tmp_kernel_op_146 = -tmp_kernel_op_112*tmp_kernel_op_137 + tmp_kernel_op_122*tmp_kernel_op_134;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_112*tmp_kernel_op_132 - tmp_kernel_op_134*tmp_kernel_op_138;
                const real_t tmp_kernel_op_148 = -tmp_kernel_op_122*tmp_kernel_op_132 + tmp_kernel_op_137*tmp_kernel_op_138;
                const real_t tmp_kernel_op_149 = -tmp_kernel_op_119*tmp_kernel_op_134 + tmp_kernel_op_124*tmp_kernel_op_137;
                const real_t tmp_kernel_op_150 = -tmp_kernel_op_124*tmp_kernel_op_132 + tmp_kernel_op_134*tmp_kernel_op_135;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_119*tmp_kernel_op_132 - tmp_kernel_op_135*tmp_kernel_op_137;
                const real_t tmp_kernel_op_152 = 0.041666666666666657*abs(tmp_kernel_op_141);
                const real_t tmp_kernel_op_159 = -micromesh_dof_7*tmp_kernel_op_156;
                const real_t tmp_kernel_op_161 = micromesh_dof_0*tmp_kernel_op_160;
                const real_t tmp_kernel_op_162 = -micromesh_dof_8*tmp_kernel_op_155 + tmp_kernel_op_161;
                const real_t tmp_kernel_op_163 = micromesh_dof_1*tmp_kernel_op_154 + micromesh_dof_5*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_155 + micromesh_dof_9*tmp_kernel_op_158 + tmp_kernel_op_159 + tmp_kernel_op_162;
                const real_t tmp_kernel_op_167 = -micromesh_dof_19*tmp_kernel_op_153;
                const real_t tmp_kernel_op_168 = micromesh_dof_10*tmp_kernel_op_160;
                const real_t tmp_kernel_op_169 = -micromesh_dof_17*tmp_kernel_op_156 + tmp_kernel_op_168;
                const real_t tmp_kernel_op_170 = micromesh_dof_12*tmp_kernel_op_164 + micromesh_dof_14*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_153 + micromesh_dof_18*tmp_kernel_op_166 + tmp_kernel_op_167 + tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_163*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = -micromesh_dof_9*tmp_kernel_op_153;
                const real_t tmp_kernel_op_173 = micromesh_dof_2*tmp_kernel_op_164 + micromesh_dof_4*tmp_kernel_op_156 + micromesh_dof_6*tmp_kernel_op_153 + micromesh_dof_8*tmp_kernel_op_166 + tmp_kernel_op_159 + tmp_kernel_op_161 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_174 = -micromesh_dof_18*tmp_kernel_op_155;
                const real_t tmp_kernel_op_175 = micromesh_dof_11*tmp_kernel_op_154 + micromesh_dof_15*tmp_kernel_op_156 + micromesh_dof_16*tmp_kernel_op_155 + micromesh_dof_19*tmp_kernel_op_158 + tmp_kernel_op_169 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_173*tmp_kernel_op_175;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_171 - tmp_kernel_op_176;
                const real_t tmp_kernel_op_180 = -micromesh_dof_28*tmp_kernel_op_155;
                const real_t tmp_kernel_op_181 = micromesh_dof_20*tmp_kernel_op_160;
                const real_t tmp_kernel_op_182 = -micromesh_dof_29*tmp_kernel_op_153 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = micromesh_dof_23*tmp_kernel_op_178 + micromesh_dof_24*tmp_kernel_op_155 + micromesh_dof_25*tmp_kernel_op_153 + micromesh_dof_27*tmp_kernel_op_179 + tmp_kernel_op_180 + tmp_kernel_op_182;
                const real_t tmp_kernel_op_184 = -micromesh_dof_27*tmp_kernel_op_156;
                const real_t tmp_kernel_op_185 = micromesh_dof_21*tmp_kernel_op_154 + micromesh_dof_25*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_155 + micromesh_dof_29*tmp_kernel_op_158 + tmp_kernel_op_180 + tmp_kernel_op_181 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = micromesh_dof_13*tmp_kernel_op_178 + micromesh_dof_14*tmp_kernel_op_155 + micromesh_dof_15*tmp_kernel_op_153 + micromesh_dof_17*tmp_kernel_op_179 + tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_174;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_173*tmp_kernel_op_186;
                const real_t tmp_kernel_op_188 = micromesh_dof_22*tmp_kernel_op_164 + micromesh_dof_24*tmp_kernel_op_156 + micromesh_dof_26*tmp_kernel_op_153 + micromesh_dof_28*tmp_kernel_op_166 + tmp_kernel_op_182 + tmp_kernel_op_184;
                const real_t tmp_kernel_op_189 = micromesh_dof_3*tmp_kernel_op_178 + micromesh_dof_4*tmp_kernel_op_155 + micromesh_dof_5*tmp_kernel_op_153 + micromesh_dof_7*tmp_kernel_op_179 + tmp_kernel_op_162 + tmp_kernel_op_172;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_163*tmp_kernel_op_186;
                const real_t tmp_kernel_op_191 = tmp_kernel_op_170*tmp_kernel_op_189;
                const real_t tmp_kernel_op_192 = tmp_kernel_op_171*tmp_kernel_op_183 + tmp_kernel_op_175*tmp_kernel_op_188*tmp_kernel_op_189 - tmp_kernel_op_176*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_187 - tmp_kernel_op_185*tmp_kernel_op_191 - tmp_kernel_op_188*tmp_kernel_op_190;
                const real_t tmp_kernel_op_193 = 1.0 / (tmp_kernel_op_192);
                const real_t tmp_kernel_op_194 = tmp_kernel_op_160*tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = tmp_kernel_op_175*tmp_kernel_op_189 - tmp_kernel_op_190;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_187 - tmp_kernel_op_191;
                const real_t tmp_kernel_op_197 = -tmp_kernel_op_163*tmp_kernel_op_188 + tmp_kernel_op_173*tmp_kernel_op_185;
                const real_t tmp_kernel_op_198 = tmp_kernel_op_163*tmp_kernel_op_183 - tmp_kernel_op_185*tmp_kernel_op_189;
                const real_t tmp_kernel_op_199 = -tmp_kernel_op_173*tmp_kernel_op_183 + tmp_kernel_op_188*tmp_kernel_op_189;
                const real_t tmp_kernel_op_200 = -tmp_kernel_op_170*tmp_kernel_op_185 + tmp_kernel_op_175*tmp_kernel_op_188;
                const real_t tmp_kernel_op_201 = -tmp_kernel_op_175*tmp_kernel_op_183 + tmp_kernel_op_185*tmp_kernel_op_186;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_170*tmp_kernel_op_183 - tmp_kernel_op_186*tmp_kernel_op_188;
                const real_t tmp_kernel_op_203 = 0.041666666666666657*abs(tmp_kernel_op_192);
                const real_t tmp_kernel_op_204 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39)*16.0;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_206 = 1.0 / (tmp_kernel_op_90*tmp_kernel_op_90)*16.0;
                const real_t tmp_kernel_op_207 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_208 = 1.0 / (tmp_kernel_op_141*tmp_kernel_op_141)*16.0;
                const real_t tmp_kernel_op_209 = tmp_kernel_op_208*0.11249999999999996;
                const real_t tmp_kernel_op_210 = 1.0 / (tmp_kernel_op_192*tmp_kernel_op_192)*16.0;
                const real_t tmp_kernel_op_211 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_204*0.012500000000000002;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_206*0.11249999999999996;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_204*0.11249999999999996;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_206*0.012500000000000002;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_208*0.012500000000000002;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_210*0.012500000000000002;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_24;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_222*tmp_kernel_op_42;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_220*tmp_kernel_op_44;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_222*tmp_kernel_op_45;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_220*tmp_kernel_op_47;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_222*tmp_kernel_op_48;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_91*0.5854101966249684;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_228*tmp_kernel_op_75;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_230*tmp_kernel_op_93;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_228*tmp_kernel_op_95;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_230*tmp_kernel_op_96;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_228*tmp_kernel_op_98;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_230*tmp_kernel_op_99;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_126*tmp_kernel_op_236;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_142*0.1381966011250105;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_144*tmp_kernel_op_238;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_146*tmp_kernel_op_236;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_147*tmp_kernel_op_238;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_149*tmp_kernel_op_236;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_150*tmp_kernel_op_238;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_177*tmp_kernel_op_244;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_195*tmp_kernel_op_246;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_197*tmp_kernel_op_244;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_198*tmp_kernel_op_246;
                const real_t tmp_kernel_op_250 = tmp_kernel_op_200*tmp_kernel_op_244;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_201*tmp_kernel_op_246;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_24*tmp_kernel_op_252;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_222*tmp_kernel_op_43;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_252*tmp_kernel_op_44;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_222*tmp_kernel_op_46;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_252*tmp_kernel_op_47;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_222*tmp_kernel_op_49;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_91*0.1381966011250105;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_259*tmp_kernel_op_75;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_230*tmp_kernel_op_94;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_259*tmp_kernel_op_95;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_230*tmp_kernel_op_97;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_259*tmp_kernel_op_98;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_100*tmp_kernel_op_230;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_142*0.5854101966249684;
                const real_t tmp_kernel_op_267 = tmp_kernel_op_126*tmp_kernel_op_266;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_145*tmp_kernel_op_238;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_146*tmp_kernel_op_266;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_148*tmp_kernel_op_238;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_149*tmp_kernel_op_266;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_151*tmp_kernel_op_238;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_193*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_177*tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_196*tmp_kernel_op_246;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_197*tmp_kernel_op_273;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_199*tmp_kernel_op_246;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_200*tmp_kernel_op_273;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_202*tmp_kernel_op_246;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_252*tmp_kernel_op_42;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_220*tmp_kernel_op_43;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_252*tmp_kernel_op_45;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_220*tmp_kernel_op_46;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_252*tmp_kernel_op_48;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_220*tmp_kernel_op_49;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_259*tmp_kernel_op_93;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_228*tmp_kernel_op_94;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_259*tmp_kernel_op_96;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_228*tmp_kernel_op_97;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_259*tmp_kernel_op_99;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_100*tmp_kernel_op_228;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_144*tmp_kernel_op_266;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_145*tmp_kernel_op_236;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_147*tmp_kernel_op_266;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_148*tmp_kernel_op_236;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_150*tmp_kernel_op_266;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_151*tmp_kernel_op_236;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_195*tmp_kernel_op_273;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_196*tmp_kernel_op_244;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_198*tmp_kernel_op_273;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_199*tmp_kernel_op_244;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_201*tmp_kernel_op_273;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_202*tmp_kernel_op_244;
                const real_t elMatDiag_0 = tmp_kernel_op_101*(((tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)*(tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_98 + tmp_kernel_op_92*tmp_kernel_op_99)) + ((tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)*(tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_92*tmp_kernel_op_93 + tmp_kernel_op_92*tmp_kernel_op_94)) + ((tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97)*(tmp_kernel_op_92*tmp_kernel_op_95 + tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_92*tmp_kernel_op_97))) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)*(tmp_kernel_op_126*tmp_kernel_op_143 + tmp_kernel_op_143*tmp_kernel_op_144 + tmp_kernel_op_143*tmp_kernel_op_145)) + ((tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)*(tmp_kernel_op_143*tmp_kernel_op_146 + tmp_kernel_op_143*tmp_kernel_op_147 + tmp_kernel_op_143*tmp_kernel_op_148)) + ((tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151)*(tmp_kernel_op_143*tmp_kernel_op_149 + tmp_kernel_op_143*tmp_kernel_op_150 + tmp_kernel_op_143*tmp_kernel_op_151))) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)*(tmp_kernel_op_177*tmp_kernel_op_194 + tmp_kernel_op_194*tmp_kernel_op_195 + tmp_kernel_op_194*tmp_kernel_op_196)) + ((tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)*(tmp_kernel_op_194*tmp_kernel_op_197 + tmp_kernel_op_194*tmp_kernel_op_198 + tmp_kernel_op_194*tmp_kernel_op_199)) + ((tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202)*(tmp_kernel_op_194*tmp_kernel_op_200 + tmp_kernel_op_194*tmp_kernel_op_201 + tmp_kernel_op_194*tmp_kernel_op_202))) + tmp_kernel_op_50*(((tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)*(tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43)) + ((tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)*(tmp_kernel_op_41*tmp_kernel_op_44 + tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46)) + ((tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)*(tmp_kernel_op_41*tmp_kernel_op_47 + tmp_kernel_op_41*tmp_kernel_op_48 + tmp_kernel_op_41*tmp_kernel_op_49)));
                const real_t elMatDiag_1 = tmp_kernel_op_101*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_207 + tmp_kernel_op_207*(tmp_kernel_op_94*tmp_kernel_op_94) + tmp_kernel_op_207*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_152*((tmp_kernel_op_145*tmp_kernel_op_145)*tmp_kernel_op_209 + (tmp_kernel_op_148*tmp_kernel_op_148)*tmp_kernel_op_209 + (tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_209) + tmp_kernel_op_203*((tmp_kernel_op_196*tmp_kernel_op_196)*tmp_kernel_op_211 + (tmp_kernel_op_199*tmp_kernel_op_199)*tmp_kernel_op_211 + (tmp_kernel_op_202*tmp_kernel_op_202)*tmp_kernel_op_211) + tmp_kernel_op_50*(tmp_kernel_op_205*(tmp_kernel_op_43*tmp_kernel_op_43) + tmp_kernel_op_205*(tmp_kernel_op_46*tmp_kernel_op_46) + tmp_kernel_op_205*(tmp_kernel_op_49*tmp_kernel_op_49));
                const real_t elMatDiag_2 = tmp_kernel_op_101*(tmp_kernel_op_213*(tmp_kernel_op_93*tmp_kernel_op_93) + tmp_kernel_op_213*(tmp_kernel_op_96*tmp_kernel_op_96) + tmp_kernel_op_213*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_152*((tmp_kernel_op_144*tmp_kernel_op_144)*tmp_kernel_op_214 + (tmp_kernel_op_147*tmp_kernel_op_147)*tmp_kernel_op_214 + (tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_214) + tmp_kernel_op_203*((tmp_kernel_op_195*tmp_kernel_op_195)*tmp_kernel_op_215 + (tmp_kernel_op_198*tmp_kernel_op_198)*tmp_kernel_op_215 + (tmp_kernel_op_201*tmp_kernel_op_201)*tmp_kernel_op_215) + tmp_kernel_op_50*(tmp_kernel_op_212*(tmp_kernel_op_42*tmp_kernel_op_42) + tmp_kernel_op_212*(tmp_kernel_op_45*tmp_kernel_op_45) + tmp_kernel_op_212*(tmp_kernel_op_48*tmp_kernel_op_48));
                const real_t elMatDiag_3 = tmp_kernel_op_101*(tmp_kernel_op_217*(tmp_kernel_op_75*tmp_kernel_op_75) + tmp_kernel_op_217*(tmp_kernel_op_95*tmp_kernel_op_95) + tmp_kernel_op_217*(tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_152*((tmp_kernel_op_126*tmp_kernel_op_126)*tmp_kernel_op_218 + (tmp_kernel_op_146*tmp_kernel_op_146)*tmp_kernel_op_218 + (tmp_kernel_op_149*tmp_kernel_op_149)*tmp_kernel_op_218) + tmp_kernel_op_203*((tmp_kernel_op_177*tmp_kernel_op_177)*tmp_kernel_op_219 + (tmp_kernel_op_197*tmp_kernel_op_197)*tmp_kernel_op_219 + (tmp_kernel_op_200*tmp_kernel_op_200)*tmp_kernel_op_219) + tmp_kernel_op_50*(tmp_kernel_op_216*(tmp_kernel_op_24*tmp_kernel_op_24) + tmp_kernel_op_216*(tmp_kernel_op_44*tmp_kernel_op_44) + tmp_kernel_op_216*(tmp_kernel_op_47*tmp_kernel_op_47));
                const real_t elMatDiag_4 = tmp_kernel_op_101*(((tmp_kernel_op_229 + tmp_kernel_op_231)*(tmp_kernel_op_229 + tmp_kernel_op_231))*16.0 + ((tmp_kernel_op_232 + tmp_kernel_op_233)*(tmp_kernel_op_232 + tmp_kernel_op_233))*16.0 + ((tmp_kernel_op_234 + tmp_kernel_op_235)*(tmp_kernel_op_234 + tmp_kernel_op_235))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_237 + tmp_kernel_op_239)*(tmp_kernel_op_237 + tmp_kernel_op_239))*16.0 + ((tmp_kernel_op_240 + tmp_kernel_op_241)*(tmp_kernel_op_240 + tmp_kernel_op_241))*16.0 + ((tmp_kernel_op_242 + tmp_kernel_op_243)*(tmp_kernel_op_242 + tmp_kernel_op_243))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_245 + tmp_kernel_op_247)*(tmp_kernel_op_245 + tmp_kernel_op_247))*16.0 + ((tmp_kernel_op_248 + tmp_kernel_op_249)*(tmp_kernel_op_248 + tmp_kernel_op_249))*16.0 + ((tmp_kernel_op_250 + tmp_kernel_op_251)*(tmp_kernel_op_250 + tmp_kernel_op_251))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_221 + tmp_kernel_op_223)*(tmp_kernel_op_221 + tmp_kernel_op_223))*16.0 + ((tmp_kernel_op_224 + tmp_kernel_op_225)*(tmp_kernel_op_224 + tmp_kernel_op_225))*16.0 + ((tmp_kernel_op_226 + tmp_kernel_op_227)*(tmp_kernel_op_226 + tmp_kernel_op_227))*16.0);
                const real_t elMatDiag_5 = tmp_kernel_op_101*(((tmp_kernel_op_260 + tmp_kernel_op_261)*(tmp_kernel_op_260 + tmp_kernel_op_261))*16.0 + ((tmp_kernel_op_262 + tmp_kernel_op_263)*(tmp_kernel_op_262 + tmp_kernel_op_263))*16.0 + ((tmp_kernel_op_264 + tmp_kernel_op_265)*(tmp_kernel_op_264 + tmp_kernel_op_265))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_267 + tmp_kernel_op_268)*(tmp_kernel_op_267 + tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_269 + tmp_kernel_op_270)*(tmp_kernel_op_269 + tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_271 + tmp_kernel_op_272)*(tmp_kernel_op_271 + tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_274 + tmp_kernel_op_275)*(tmp_kernel_op_274 + tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_276 + tmp_kernel_op_277)*(tmp_kernel_op_276 + tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_278 + tmp_kernel_op_279)*(tmp_kernel_op_278 + tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_253 + tmp_kernel_op_254)*(tmp_kernel_op_253 + tmp_kernel_op_254))*16.0 + ((tmp_kernel_op_255 + tmp_kernel_op_256)*(tmp_kernel_op_255 + tmp_kernel_op_256))*16.0 + ((tmp_kernel_op_257 + tmp_kernel_op_258)*(tmp_kernel_op_257 + tmp_kernel_op_258))*16.0);
                const real_t elMatDiag_6 = tmp_kernel_op_101*(((tmp_kernel_op_286 + tmp_kernel_op_287)*(tmp_kernel_op_286 + tmp_kernel_op_287))*16.0 + ((tmp_kernel_op_288 + tmp_kernel_op_289)*(tmp_kernel_op_288 + tmp_kernel_op_289))*16.0 + ((tmp_kernel_op_290 + tmp_kernel_op_291)*(tmp_kernel_op_290 + tmp_kernel_op_291))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_292 + tmp_kernel_op_293)*(tmp_kernel_op_292 + tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_294 + tmp_kernel_op_295)*(tmp_kernel_op_294 + tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_296 + tmp_kernel_op_297)*(tmp_kernel_op_296 + tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_298 + tmp_kernel_op_299)*(tmp_kernel_op_298 + tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_300 + tmp_kernel_op_301)*(tmp_kernel_op_300 + tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_302 + tmp_kernel_op_303)*(tmp_kernel_op_302 + tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_280 + tmp_kernel_op_281)*(tmp_kernel_op_280 + tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_282 + tmp_kernel_op_283)*(tmp_kernel_op_282 + tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_284 + tmp_kernel_op_285)*(tmp_kernel_op_284 + tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_7 = tmp_kernel_op_101*(((-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25)*(-tmp_kernel_op_231 - tmp_kernel_op_261 + tmp_kernel_op_75*tmp_kernel_op_77*tmp_kernel_op_91*0.25))*16.0 + ((-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25)*(-tmp_kernel_op_233 - tmp_kernel_op_263 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_95*0.25))*16.0 + ((-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25)*(-tmp_kernel_op_235 - tmp_kernel_op_265 + tmp_kernel_op_77*tmp_kernel_op_91*tmp_kernel_op_98*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268)*(tmp_kernel_op_126*tmp_kernel_op_128*tmp_kernel_op_142*0.25 - tmp_kernel_op_239 - tmp_kernel_op_268))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_146*0.25 - tmp_kernel_op_241 - tmp_kernel_op_270))*16.0 + ((tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272)*(tmp_kernel_op_128*tmp_kernel_op_142*tmp_kernel_op_149*0.25 - tmp_kernel_op_243 - tmp_kernel_op_272))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275)*(tmp_kernel_op_177*tmp_kernel_op_179*tmp_kernel_op_193*0.25 - tmp_kernel_op_247 - tmp_kernel_op_275))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_197*0.25 - tmp_kernel_op_249 - tmp_kernel_op_277))*16.0 + ((tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279)*(tmp_kernel_op_179*tmp_kernel_op_193*tmp_kernel_op_200*0.25 - tmp_kernel_op_251 - tmp_kernel_op_279))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254)*(-tmp_kernel_op_223 + tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_254))*16.0 + ((-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25)*(-tmp_kernel_op_225 - tmp_kernel_op_256 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_44*0.25))*16.0 + ((-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25)*(-tmp_kernel_op_227 - tmp_kernel_op_258 + tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_47*0.25))*16.0);
                const real_t elMatDiag_8 = tmp_kernel_op_101*(((-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25)*(-tmp_kernel_op_229 - tmp_kernel_op_287 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_93*0.25))*16.0 + ((-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_232 - tmp_kernel_op_289 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_96*0.25))*16.0 + ((-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_234 - tmp_kernel_op_291 + tmp_kernel_op_64*tmp_kernel_op_91*tmp_kernel_op_99*0.25))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_144*0.25 - tmp_kernel_op_237 - tmp_kernel_op_293))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_147*0.25 - tmp_kernel_op_240 - tmp_kernel_op_295))*16.0 + ((tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297)*(tmp_kernel_op_115*tmp_kernel_op_142*tmp_kernel_op_150*0.25 - tmp_kernel_op_242 - tmp_kernel_op_297))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_195*0.25 - tmp_kernel_op_245 - tmp_kernel_op_299))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_198*0.25 - tmp_kernel_op_248 - tmp_kernel_op_301))*16.0 + ((tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303)*(tmp_kernel_op_166*tmp_kernel_op_193*tmp_kernel_op_201*0.25 - tmp_kernel_op_250 - tmp_kernel_op_303))*16.0) + tmp_kernel_op_50*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_221 - tmp_kernel_op_281))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_224 - tmp_kernel_op_283))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_48*0.25 - tmp_kernel_op_226 - tmp_kernel_op_285))*16.0);
                const real_t elMatDiag_9 = tmp_kernel_op_101*(((-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_260 - tmp_kernel_op_286 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_262 - tmp_kernel_op_288 + tmp_kernel_op_56*tmp_kernel_op_91*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290)*(tmp_kernel_op_100*tmp_kernel_op_56*tmp_kernel_op_91*0.25 - tmp_kernel_op_264 - tmp_kernel_op_290))*16.0) + tmp_kernel_op_152*(((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_145*0.25 - tmp_kernel_op_267 - tmp_kernel_op_292))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_148*0.25 - tmp_kernel_op_269 - tmp_kernel_op_294))*16.0 + ((tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296)*(tmp_kernel_op_107*tmp_kernel_op_142*tmp_kernel_op_151*0.25 - tmp_kernel_op_271 - tmp_kernel_op_296))*16.0) + tmp_kernel_op_203*(((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_196*0.25 - tmp_kernel_op_274 - tmp_kernel_op_298))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_199*0.25 - tmp_kernel_op_276 - tmp_kernel_op_300))*16.0 + ((tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302)*(tmp_kernel_op_158*tmp_kernel_op_193*tmp_kernel_op_202*0.25 - tmp_kernel_op_278 - tmp_kernel_op_302))*16.0) + tmp_kernel_op_50*(((-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_253 - tmp_kernel_op_280 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_255 - tmp_kernel_op_282 + tmp_kernel_op_40*tmp_kernel_op_46*tmp_kernel_op_5*0.25))*16.0 + ((-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25)*(-tmp_kernel_op_257 - tmp_kernel_op_284 + tmp_kernel_op_40*tmp_kernel_op_49*tmp_kernel_op_5*0.25))*16.0);
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
