/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ToP1ElementwiseDivergenceIcosahedralShellMap_0_2.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ToP1ElementwiseDivergenceIcosahedralShellMap_0_2::apply_P2ToP1ElementwiseDivergenceIcosahedralShellMap_0_2_macro_3D( real_t * RESTRICT  _data_dst, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_blending_op_5 = rayVertex_1 - refVertex_1;
       const real_t tmp_blending_op_6 = -rayVertex_0;
       const real_t tmp_blending_op_7 = -forVertex_0 - tmp_blending_op_6;
       const real_t tmp_blending_op_8 = rayVertex_2 - thrVertex_2;
       const real_t tmp_blending_op_9 = tmp_blending_op_7*tmp_blending_op_8;
       const real_t tmp_blending_op_10 = rayVertex_2 - refVertex_2;
       const real_t tmp_blending_op_11 = rayVertex_1 - thrVertex_1;
       const real_t tmp_blending_op_12 = tmp_blending_op_11*tmp_blending_op_7;
       const real_t tmp_blending_op_13 = -rayVertex_1;
       const real_t tmp_blending_op_14 = -forVertex_1 - tmp_blending_op_13;
       const real_t tmp_blending_op_15 = rayVertex_0 - thrVertex_0;
       const real_t tmp_blending_op_16 = rayVertex_0 - refVertex_0;
       const real_t tmp_blending_op_17 = -rayVertex_2;
       const real_t tmp_blending_op_18 = -forVertex_2 - tmp_blending_op_17;
       const real_t tmp_blending_op_19 = tmp_blending_op_14*tmp_blending_op_8;
       const real_t tmp_blending_op_20 = tmp_blending_op_15*tmp_blending_op_18;
       const real_t tmp_blending_op_21 = -tmp_blending_op_10*tmp_blending_op_12 + tmp_blending_op_10*tmp_blending_op_14*tmp_blending_op_15 + tmp_blending_op_11*tmp_blending_op_16*tmp_blending_op_18 - tmp_blending_op_16*tmp_blending_op_19 - tmp_blending_op_20*tmp_blending_op_5 + tmp_blending_op_5*tmp_blending_op_9;
       const real_t tmp_blending_op_22 = radRayVertex*tmp_blending_op_21;
       const real_t tmp_blending_op_23 = radRayVertex - radRefVertex;
       const real_t tmp_blending_op_40 = tmp_blending_op_23*(-tmp_blending_op_12 + tmp_blending_op_14*tmp_blending_op_15);
       const real_t tmp_blending_op_41 = 1.0 / (tmp_blending_op_21)*1.0;
       const real_t tmp_blending_op_43 = tmp_blending_op_15*tmp_blending_op_18 - tmp_blending_op_9;
       const real_t tmp_blending_op_47 = tmp_blending_op_11*tmp_blending_op_18 - tmp_blending_op_19;
       const real_t tmp_blending_op_51 = -tmp_blending_op_23*tmp_blending_op_43;
       const real_t tmp_blending_op_53 = tmp_blending_op_23*tmp_blending_op_47;
       const real_t tmp_blending_op_74 = tmp_blending_op_23*tmp_blending_op_43;
       const real_t tmp_kernel_op_0 = 0.55278640450004202;
       const real_t tmp_kernel_op_1 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_5 = 0.55278640450004202;
       const real_t tmp_kernel_op_6 = tmp_kernel_op_5 - 1.0;
       const real_t tmp_kernel_op_10 = 2.3416407864998736;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_10 - 1.0;
       const real_t tmp_kernel_op_15 = 0.55278640450004202;
       const real_t tmp_kernel_op_16 = tmp_kernel_op_15 - 1.0;
       const real_t tmp_kernel_op_20 = 0.55278640450004202;
       const real_t tmp_kernel_op_21 = tmp_kernel_op_20 - 1.0;
       const real_t tmp_kernel_op_23 = 2.3416407864998736;
       const real_t tmp_kernel_op_24 = tmp_kernel_op_23 - 1.0;
       const real_t tmp_kernel_op_26 = 0.55278640450004202;
       const real_t tmp_kernel_op_27 = tmp_kernel_op_26 - 1.0;
       const real_t tmp_kernel_op_29 = 0.55278640450004202;
       const real_t tmp_kernel_op_30 = tmp_kernel_op_29 - 1.0;
       const real_t tmp_kernel_op_32 = 2.3416407864998736;
       const real_t tmp_kernel_op_33 = tmp_kernel_op_32 - 1.0;
       const real_t tmp_kernel_op_35 = 0.55278640450004202;
       const real_t tmp_kernel_op_36 = tmp_kernel_op_35 - 1.0;
       const real_t tmp_kernel_op_38 = 0.55278640450004202;
       const real_t tmp_kernel_op_39 = tmp_kernel_op_38 - 1.0;
       const real_t tmp_kernel_op_41 = 0.55278640450004202;
       const real_t tmp_kernel_op_42 = tmp_kernel_op_41 - 1.0;
       const real_t tmp_kernel_op_44 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_45 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_46 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_47 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_48 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_49 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_51 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_52 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_53 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_54 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_55 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_56 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_58 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_59 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_60 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_61 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_62 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_63 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_65 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_66 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_67 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_68 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_69 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_70 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_72 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_73 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_74 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_75 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_76 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_77 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_79 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_80 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_81 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_82 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_83 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_84 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_86 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_87 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_88 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_89 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_90 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_91 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_93 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_94 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_95 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_96 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_97 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_98 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_100 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_101 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_102 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_103 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_104 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_105 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_107 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_108 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_109 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_110 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_111 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_112 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_114 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_115 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_116 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_117 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_118 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_119 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_121 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_122 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_123 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_124 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_125 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_126 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_128 = tmp_kernel_op_0 + tmp_kernel_op_20;
       const real_t tmp_kernel_op_129 = -tmp_kernel_op_128 - 0.68328157299974723;
       const real_t tmp_kernel_op_131 = tmp_kernel_op_23 + tmp_kernel_op_5;
       const real_t tmp_kernel_op_132 = -tmp_kernel_op_131 + 2.8944271909999157;
       const real_t tmp_kernel_op_134 = tmp_kernel_op_10 + tmp_kernel_op_26;
       const real_t tmp_kernel_op_135 = -tmp_kernel_op_134 + 2.8944271909999157;
       const real_t tmp_kernel_op_137 = tmp_kernel_op_15 + tmp_kernel_op_29;
       const real_t tmp_kernel_op_138 = -tmp_kernel_op_137 + 2.8944271909999157;
       const real_t tmp_kernel_op_140 = tmp_kernel_op_32 - 4.0;
       const real_t tmp_kernel_op_141 = -tmp_kernel_op_0 - tmp_kernel_op_140 - 1.105572809000084;
       const real_t tmp_kernel_op_143 = tmp_kernel_op_35 - 4.0;
       const real_t tmp_kernel_op_144 = -tmp_kernel_op_143 - tmp_kernel_op_5 - 4.6832815729997472;
       const real_t tmp_kernel_op_146 = tmp_kernel_op_38 - 4.0;
       const real_t tmp_kernel_op_147 = -tmp_kernel_op_10 - tmp_kernel_op_146 - 1.105572809000084;
       const real_t tmp_kernel_op_149 = tmp_kernel_op_41 - 4.0;
       const real_t tmp_kernel_op_150 = -tmp_kernel_op_149 - tmp_kernel_op_15 - 1.105572809000084;
       const real_t tmp_kernel_op_152 = -tmp_kernel_op_140 - tmp_kernel_op_20 - 1.105572809000084;
       const real_t tmp_kernel_op_154 = -tmp_kernel_op_143 - tmp_kernel_op_23 - 1.105572809000084;
       const real_t tmp_kernel_op_156 = -tmp_kernel_op_146 - tmp_kernel_op_26 - 4.6832815729997472;
       const real_t tmp_kernel_op_158 = -tmp_kernel_op_149 - tmp_kernel_op_29 - 1.105572809000084;
       const real_t tmp_kernel_op_160 = tmp_kernel_op_128 + tmp_kernel_op_32 - 3.0;
       const real_t tmp_kernel_op_162 = tmp_kernel_op_131 + tmp_kernel_op_35 - 3.0;
       const real_t tmp_kernel_op_164 = tmp_kernel_op_134 + tmp_kernel_op_38 - 3.0;
       const real_t tmp_kernel_op_166 = tmp_kernel_op_137 + tmp_kernel_op_41 - 3.0;
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_3,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),jac_blending_2_1_q_3));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3)));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_2,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),jac_blending_2_1_q_2));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2)));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_1,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),jac_blending_2_1_q_1));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1)));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_0,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),jac_blending_2_1_q_0));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0)));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)));
                const __m256d tmp_kernel_op_3 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_4 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_9 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_12 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)));
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)));
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)));
                const __m256d tmp_kernel_op_25 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)));
                const __m256d tmp_kernel_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)));
                const __m256d tmp_kernel_op_31 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_34 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)));
                const __m256d tmp_kernel_op_37 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60),_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62),_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65),_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72),_mm256_set_pd(tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83),_mm256_set_pd(tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86),_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93),_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95),_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97),_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100),_mm256_set_pd(tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102),_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111),_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116),_mm256_set_pd(tmp_kernel_op_117,tmp_kernel_op_117,tmp_kernel_op_117,tmp_kernel_op_117))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118),_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123),_mm256_set_pd(tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125),_mm256_set_pd(tmp_kernel_op_126,tmp_kernel_op_126,tmp_kernel_op_126,tmp_kernel_op_126))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_117,tmp_kernel_op_117,tmp_kernel_op_117,tmp_kernel_op_117)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_126,tmp_kernel_op_126,tmp_kernel_op_126,tmp_kernel_op_126)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_165 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_167 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_175 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_19))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_14),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_2,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_148),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_165),_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_28),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_31)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_25,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_40),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_34,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_37,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_64),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_99)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_78)),_mm256_mul_pd(tmp_kernel_op_85,tmp_kernel_op_9))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_171))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_170),_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_7)),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_99))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_175))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_174),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_175)),_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_99))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_179))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_178),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_179)),_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_99))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5854101966249684 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5854101966249684 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5854101966249684 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.5854101966249684 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.5854101966249684 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.5854101966249684 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.5854101966249684;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.5854101966249684;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.5854101966249684;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t tmp_blending_op_58 = jac_blending_0_2_q_3*jac_blending_1_1_q_3;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_55 = jac_blending_0_1_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_59 = jac_blending_0_2_q_3*jac_blending_1_0_q_3*jac_blending_2_1_q_3 + jac_blending_2_0_q_3*tmp_blending_op_55 - jac_blending_2_0_q_3*tmp_blending_op_58 - jac_blending_2_1_q_3*tmp_blending_op_56 + jac_blending_2_2_q_3*tmp_blending_op_54 - jac_blending_2_2_q_3*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_60*(jac_blending_0_2_q_3*jac_blending_1_0_q_3 - tmp_blending_op_56);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t tmp_blending_op_85 = jac_blending_0_2_q_2*jac_blending_1_1_q_2;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_82 = jac_blending_0_1_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_86 = jac_blending_0_2_q_2*jac_blending_1_0_q_2*jac_blending_2_1_q_2 + jac_blending_2_0_q_2*tmp_blending_op_82 - jac_blending_2_0_q_2*tmp_blending_op_85 - jac_blending_2_1_q_2*tmp_blending_op_83 + jac_blending_2_2_q_2*tmp_blending_op_81 - jac_blending_2_2_q_2*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_87*(jac_blending_0_2_q_2*jac_blending_1_0_q_2 - tmp_blending_op_83);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t tmp_blending_op_111 = jac_blending_0_2_q_1*jac_blending_1_1_q_1;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_108 = jac_blending_0_1_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_112 = jac_blending_0_2_q_1*jac_blending_1_0_q_1*jac_blending_2_1_q_1 + jac_blending_2_0_q_1*tmp_blending_op_108 - jac_blending_2_0_q_1*tmp_blending_op_111 - jac_blending_2_1_q_1*tmp_blending_op_109 + jac_blending_2_2_q_1*tmp_blending_op_107 - jac_blending_2_2_q_1*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_113*(jac_blending_0_2_q_1*jac_blending_1_0_q_1 - tmp_blending_op_109);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t tmp_blending_op_137 = jac_blending_0_2_q_0*jac_blending_1_1_q_0;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_134 = jac_blending_0_1_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_138 = jac_blending_0_2_q_0*jac_blending_1_0_q_0*jac_blending_2_1_q_0 + jac_blending_2_0_q_0*tmp_blending_op_134 - jac_blending_2_0_q_0*tmp_blending_op_137 - jac_blending_2_1_q_0*tmp_blending_op_135 + jac_blending_2_2_q_0*tmp_blending_op_133 - jac_blending_2_2_q_0*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_139*(jac_blending_0_2_q_0*jac_blending_1_0_q_0 - tmp_blending_op_135);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_2 = -jac_affine_inv_0_0_WHITE_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_1_WHITE_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_2_WHITE_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_1;
                const real_t tmp_kernel_op_3 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_0*0.041666666666666657;
                const real_t tmp_kernel_op_4 = tmp_kernel_op_3*0.13819660112501053;
                const real_t tmp_kernel_op_7 = -jac_affine_inv_0_0_WHITE_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_1_WHITE_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_2_WHITE_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_6;
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_1*0.041666666666666657;
                const real_t tmp_kernel_op_9 = tmp_kernel_op_8*0.13819660112501056;
                const real_t tmp_kernel_op_12 = -jac_affine_inv_0_0_WHITE_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_1_WHITE_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_2_WHITE_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_11;
                const real_t tmp_kernel_op_13 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_2*0.041666666666666657;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_13*0.13819660112501056;
                const real_t tmp_kernel_op_17 = -jac_affine_inv_0_0_WHITE_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_1_WHITE_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_2_WHITE_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_3*0.041666666666666657;
                const real_t tmp_kernel_op_19 = tmp_kernel_op_18*0.5854101966249684;
                const real_t tmp_kernel_op_22 = -jac_affine_inv_1_0_WHITE_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_1_WHITE_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_2_WHITE_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_21;
                const real_t tmp_kernel_op_25 = -jac_affine_inv_1_0_WHITE_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_1_WHITE_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_2_WHITE_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_24;
                const real_t tmp_kernel_op_28 = -jac_affine_inv_1_0_WHITE_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_1_WHITE_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_2_WHITE_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_27;
                const real_t tmp_kernel_op_31 = -jac_affine_inv_1_0_WHITE_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_1_WHITE_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_2_WHITE_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_30;
                const real_t tmp_kernel_op_34 = -jac_affine_inv_2_0_WHITE_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_1_WHITE_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_2_WHITE_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_33;
                const real_t tmp_kernel_op_37 = -jac_affine_inv_2_0_WHITE_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_1_WHITE_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_2_WHITE_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_36;
                const real_t tmp_kernel_op_40 = -jac_affine_inv_2_0_WHITE_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_1_WHITE_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_2_WHITE_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_39;
                const real_t tmp_kernel_op_43 = -jac_affine_inv_2_0_WHITE_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_1_WHITE_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_2_WHITE_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_50 = -jac_blending_inv_0_2_q_0*(tmp_kernel_op_44 + tmp_kernel_op_45) - jac_blending_inv_1_2_q_0*(tmp_kernel_op_46 + tmp_kernel_op_47) - jac_blending_inv_2_2_q_0*(tmp_kernel_op_48 + tmp_kernel_op_49);
                const real_t tmp_kernel_op_57 = -jac_blending_inv_0_2_q_1*(tmp_kernel_op_51 + tmp_kernel_op_52) - jac_blending_inv_1_2_q_1*(tmp_kernel_op_53 + tmp_kernel_op_54) - jac_blending_inv_2_2_q_1*(tmp_kernel_op_55 + tmp_kernel_op_56);
                const real_t tmp_kernel_op_64 = -jac_blending_inv_0_2_q_2*(tmp_kernel_op_58 + tmp_kernel_op_59) - jac_blending_inv_1_2_q_2*(tmp_kernel_op_60 + tmp_kernel_op_61) - jac_blending_inv_2_2_q_2*(tmp_kernel_op_62 + tmp_kernel_op_63);
                const real_t tmp_kernel_op_71 = -jac_blending_inv_0_2_q_3*(tmp_kernel_op_65 + tmp_kernel_op_66) - jac_blending_inv_1_2_q_3*(tmp_kernel_op_67 + tmp_kernel_op_68) - jac_blending_inv_2_2_q_3*(tmp_kernel_op_69 + tmp_kernel_op_70);
                const real_t tmp_kernel_op_78 = -jac_blending_inv_0_2_q_0*(tmp_kernel_op_72 + tmp_kernel_op_73) - jac_blending_inv_1_2_q_0*(tmp_kernel_op_74 + tmp_kernel_op_75) - jac_blending_inv_2_2_q_0*(tmp_kernel_op_76 + tmp_kernel_op_77);
                const real_t tmp_kernel_op_85 = -jac_blending_inv_0_2_q_1*(tmp_kernel_op_79 + tmp_kernel_op_80) - jac_blending_inv_1_2_q_1*(tmp_kernel_op_81 + tmp_kernel_op_82) - jac_blending_inv_2_2_q_1*(tmp_kernel_op_83 + tmp_kernel_op_84);
                const real_t tmp_kernel_op_92 = -jac_blending_inv_0_2_q_2*(tmp_kernel_op_86 + tmp_kernel_op_87) - jac_blending_inv_1_2_q_2*(tmp_kernel_op_88 + tmp_kernel_op_89) - jac_blending_inv_2_2_q_2*(tmp_kernel_op_90 + tmp_kernel_op_91);
                const real_t tmp_kernel_op_99 = -jac_blending_inv_0_2_q_3*(tmp_kernel_op_93 + tmp_kernel_op_94) - jac_blending_inv_1_2_q_3*(tmp_kernel_op_95 + tmp_kernel_op_96) - jac_blending_inv_2_2_q_3*(tmp_kernel_op_97 + tmp_kernel_op_98);
                const real_t tmp_kernel_op_106 = -jac_blending_inv_0_2_q_0*(tmp_kernel_op_100 + tmp_kernel_op_101) - jac_blending_inv_1_2_q_0*(tmp_kernel_op_102 + tmp_kernel_op_103) - jac_blending_inv_2_2_q_0*(tmp_kernel_op_104 + tmp_kernel_op_105);
                const real_t tmp_kernel_op_113 = -jac_blending_inv_0_2_q_1*(tmp_kernel_op_107 + tmp_kernel_op_108) - jac_blending_inv_1_2_q_1*(tmp_kernel_op_109 + tmp_kernel_op_110) - jac_blending_inv_2_2_q_1*(tmp_kernel_op_111 + tmp_kernel_op_112);
                const real_t tmp_kernel_op_120 = -jac_blending_inv_0_2_q_2*(tmp_kernel_op_114 + tmp_kernel_op_115) - jac_blending_inv_1_2_q_2*(tmp_kernel_op_116 + tmp_kernel_op_117) - jac_blending_inv_2_2_q_2*(tmp_kernel_op_118 + tmp_kernel_op_119);
                const real_t tmp_kernel_op_127 = -jac_blending_inv_0_2_q_3*(tmp_kernel_op_121 + tmp_kernel_op_122) - jac_blending_inv_1_2_q_3*(tmp_kernel_op_123 + tmp_kernel_op_124) - jac_blending_inv_2_2_q_3*(tmp_kernel_op_125 + tmp_kernel_op_126);
                const real_t tmp_kernel_op_130 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_129 - tmp_kernel_op_44 - tmp_kernel_op_72) - jac_blending_inv_1_2_q_0*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_129 - tmp_kernel_op_46 - tmp_kernel_op_74) - jac_blending_inv_2_2_q_0*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_129 - tmp_kernel_op_48 - tmp_kernel_op_76);
                const real_t tmp_kernel_op_133 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_132 - tmp_kernel_op_51 - tmp_kernel_op_79) - jac_blending_inv_1_2_q_1*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_132 - tmp_kernel_op_53 - tmp_kernel_op_81) - jac_blending_inv_2_2_q_1*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_132 - tmp_kernel_op_55 - tmp_kernel_op_83);
                const real_t tmp_kernel_op_136 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_135 - tmp_kernel_op_58 - tmp_kernel_op_86) - jac_blending_inv_1_2_q_2*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_135 - tmp_kernel_op_60 - tmp_kernel_op_88) - jac_blending_inv_2_2_q_2*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_135 - tmp_kernel_op_62 - tmp_kernel_op_90);
                const real_t tmp_kernel_op_139 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_138 - tmp_kernel_op_65 - tmp_kernel_op_93) - jac_blending_inv_1_2_q_3*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_138 - tmp_kernel_op_67 - tmp_kernel_op_95) - jac_blending_inv_2_2_q_3*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_138 - tmp_kernel_op_69 - tmp_kernel_op_97);
                const real_t tmp_kernel_op_142 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_141 - tmp_kernel_op_100 - tmp_kernel_op_45) - jac_blending_inv_1_2_q_0*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_141 - tmp_kernel_op_102 - tmp_kernel_op_47) - jac_blending_inv_2_2_q_0*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_141 - tmp_kernel_op_104 - tmp_kernel_op_49);
                const real_t tmp_kernel_op_145 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_144 - tmp_kernel_op_107 - tmp_kernel_op_52) - jac_blending_inv_1_2_q_1*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_144 - tmp_kernel_op_109 - tmp_kernel_op_54) - jac_blending_inv_2_2_q_1*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_144 - tmp_kernel_op_111 - tmp_kernel_op_56);
                const real_t tmp_kernel_op_148 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_147 - tmp_kernel_op_114 - tmp_kernel_op_59) - jac_blending_inv_1_2_q_2*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_147 - tmp_kernel_op_116 - tmp_kernel_op_61) - jac_blending_inv_2_2_q_2*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_147 - tmp_kernel_op_118 - tmp_kernel_op_63);
                const real_t tmp_kernel_op_151 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_150 - tmp_kernel_op_121 - tmp_kernel_op_66) - jac_blending_inv_1_2_q_3*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_150 - tmp_kernel_op_123 - tmp_kernel_op_68) - jac_blending_inv_2_2_q_3*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_150 - tmp_kernel_op_125 - tmp_kernel_op_70);
                const real_t tmp_kernel_op_153 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_152 - tmp_kernel_op_101 - tmp_kernel_op_73) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_152 - tmp_kernel_op_103 - tmp_kernel_op_75) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_152 - tmp_kernel_op_105 - tmp_kernel_op_77);
                const real_t tmp_kernel_op_155 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_154 - tmp_kernel_op_108 - tmp_kernel_op_80) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_154 - tmp_kernel_op_110 - tmp_kernel_op_82) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_154 - tmp_kernel_op_112 - tmp_kernel_op_84);
                const real_t tmp_kernel_op_157 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_156 - tmp_kernel_op_115 - tmp_kernel_op_87) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_156 - tmp_kernel_op_117 - tmp_kernel_op_89) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_156 - tmp_kernel_op_119 - tmp_kernel_op_91);
                const real_t tmp_kernel_op_159 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_158 - tmp_kernel_op_122 - tmp_kernel_op_94) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_158 - tmp_kernel_op_124 - tmp_kernel_op_96) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_158 - tmp_kernel_op_126 - tmp_kernel_op_98);
                const real_t tmp_kernel_op_161 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_160 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_160 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_160) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_160 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_160 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_160) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_160 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_160 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_160);
                const real_t tmp_kernel_op_163 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_162 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_162 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_162) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_162 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_162 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_162) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_162 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_162 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_162);
                const real_t tmp_kernel_op_165 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_164 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_164 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_164) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_164 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_164 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_164) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_164 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_164 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_164);
                const real_t tmp_kernel_op_167 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_166 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_166 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_166) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_166 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_166 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_166) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_166 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_166 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_166);
                const real_t tmp_kernel_op_168 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_169 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_170 = tmp_kernel_op_13*0.5854101966249684;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_173 = tmp_kernel_op_8*0.5854101966249684;
                const real_t tmp_kernel_op_174 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_175 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_3*0.5854101966249684;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_18*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_14*tmp_kernel_op_165 + tmp_kernel_op_161*tmp_kernel_op_4 + tmp_kernel_op_163*tmp_kernel_op_9 + tmp_kernel_op_167*tmp_kernel_op_19) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_14 + tmp_kernel_op_17*tmp_kernel_op_19 + tmp_kernel_op_2*tmp_kernel_op_4 + tmp_kernel_op_7*tmp_kernel_op_9) + src_dof_2*(tmp_kernel_op_14*tmp_kernel_op_28 + tmp_kernel_op_19*tmp_kernel_op_31 + tmp_kernel_op_22*tmp_kernel_op_4 + tmp_kernel_op_25*tmp_kernel_op_9) + src_dof_3*(tmp_kernel_op_14*tmp_kernel_op_40 + tmp_kernel_op_19*tmp_kernel_op_43 + tmp_kernel_op_34*tmp_kernel_op_4 + tmp_kernel_op_37*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_14*tmp_kernel_op_64 + tmp_kernel_op_19*tmp_kernel_op_71 + tmp_kernel_op_4*tmp_kernel_op_50 + tmp_kernel_op_57*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_14*tmp_kernel_op_92 + tmp_kernel_op_19*tmp_kernel_op_99 + tmp_kernel_op_4*tmp_kernel_op_78 + tmp_kernel_op_85*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_4 + tmp_kernel_op_113*tmp_kernel_op_9 + tmp_kernel_op_120*tmp_kernel_op_14 + tmp_kernel_op_127*tmp_kernel_op_19) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_4 + tmp_kernel_op_133*tmp_kernel_op_9 + tmp_kernel_op_136*tmp_kernel_op_14 + tmp_kernel_op_139*tmp_kernel_op_19) + src_dof_8*(tmp_kernel_op_14*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_4 + tmp_kernel_op_145*tmp_kernel_op_9 + tmp_kernel_op_151*tmp_kernel_op_19) + src_dof_9*(tmp_kernel_op_14*tmp_kernel_op_157 + tmp_kernel_op_153*tmp_kernel_op_4 + tmp_kernel_op_155*tmp_kernel_op_9 + tmp_kernel_op_159*tmp_kernel_op_19);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_168 + tmp_kernel_op_163*tmp_kernel_op_169 + tmp_kernel_op_165*tmp_kernel_op_170 + tmp_kernel_op_167*tmp_kernel_op_171) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_170 + tmp_kernel_op_168*tmp_kernel_op_2 + tmp_kernel_op_169*tmp_kernel_op_7 + tmp_kernel_op_17*tmp_kernel_op_171) + src_dof_2*(tmp_kernel_op_168*tmp_kernel_op_22 + tmp_kernel_op_169*tmp_kernel_op_25 + tmp_kernel_op_170*tmp_kernel_op_28 + tmp_kernel_op_171*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_168*tmp_kernel_op_34 + tmp_kernel_op_169*tmp_kernel_op_37 + tmp_kernel_op_170*tmp_kernel_op_40 + tmp_kernel_op_171*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_168*tmp_kernel_op_50 + tmp_kernel_op_169*tmp_kernel_op_57 + tmp_kernel_op_170*tmp_kernel_op_64 + tmp_kernel_op_171*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_168*tmp_kernel_op_78 + tmp_kernel_op_169*tmp_kernel_op_85 + tmp_kernel_op_170*tmp_kernel_op_92 + tmp_kernel_op_171*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_168 + tmp_kernel_op_113*tmp_kernel_op_169 + tmp_kernel_op_120*tmp_kernel_op_170 + tmp_kernel_op_127*tmp_kernel_op_171) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_168 + tmp_kernel_op_133*tmp_kernel_op_169 + tmp_kernel_op_136*tmp_kernel_op_170 + tmp_kernel_op_139*tmp_kernel_op_171) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_168 + tmp_kernel_op_145*tmp_kernel_op_169 + tmp_kernel_op_148*tmp_kernel_op_170 + tmp_kernel_op_151*tmp_kernel_op_171) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_168 + tmp_kernel_op_155*tmp_kernel_op_169 + tmp_kernel_op_157*tmp_kernel_op_170 + tmp_kernel_op_159*tmp_kernel_op_171);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_172 + tmp_kernel_op_163*tmp_kernel_op_173 + tmp_kernel_op_165*tmp_kernel_op_174 + tmp_kernel_op_167*tmp_kernel_op_175) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_174 + tmp_kernel_op_17*tmp_kernel_op_175 + tmp_kernel_op_172*tmp_kernel_op_2 + tmp_kernel_op_173*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_172*tmp_kernel_op_22 + tmp_kernel_op_173*tmp_kernel_op_25 + tmp_kernel_op_174*tmp_kernel_op_28 + tmp_kernel_op_175*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_172*tmp_kernel_op_34 + tmp_kernel_op_173*tmp_kernel_op_37 + tmp_kernel_op_174*tmp_kernel_op_40 + tmp_kernel_op_175*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_172*tmp_kernel_op_50 + tmp_kernel_op_173*tmp_kernel_op_57 + tmp_kernel_op_174*tmp_kernel_op_64 + tmp_kernel_op_175*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_172*tmp_kernel_op_78 + tmp_kernel_op_173*tmp_kernel_op_85 + tmp_kernel_op_174*tmp_kernel_op_92 + tmp_kernel_op_175*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_172 + tmp_kernel_op_113*tmp_kernel_op_173 + tmp_kernel_op_120*tmp_kernel_op_174 + tmp_kernel_op_127*tmp_kernel_op_175) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_172 + tmp_kernel_op_133*tmp_kernel_op_173 + tmp_kernel_op_136*tmp_kernel_op_174 + tmp_kernel_op_139*tmp_kernel_op_175) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_172 + tmp_kernel_op_145*tmp_kernel_op_173 + tmp_kernel_op_148*tmp_kernel_op_174 + tmp_kernel_op_151*tmp_kernel_op_175) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_172 + tmp_kernel_op_155*tmp_kernel_op_173 + tmp_kernel_op_157*tmp_kernel_op_174 + tmp_kernel_op_159*tmp_kernel_op_175);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_176 + tmp_kernel_op_163*tmp_kernel_op_177 + tmp_kernel_op_165*tmp_kernel_op_178 + tmp_kernel_op_167*tmp_kernel_op_179) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_178 + tmp_kernel_op_17*tmp_kernel_op_179 + tmp_kernel_op_176*tmp_kernel_op_2 + tmp_kernel_op_177*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_176*tmp_kernel_op_22 + tmp_kernel_op_177*tmp_kernel_op_25 + tmp_kernel_op_178*tmp_kernel_op_28 + tmp_kernel_op_179*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_176*tmp_kernel_op_34 + tmp_kernel_op_177*tmp_kernel_op_37 + tmp_kernel_op_178*tmp_kernel_op_40 + tmp_kernel_op_179*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_176*tmp_kernel_op_50 + tmp_kernel_op_177*tmp_kernel_op_57 + tmp_kernel_op_178*tmp_kernel_op_64 + tmp_kernel_op_179*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_176*tmp_kernel_op_78 + tmp_kernel_op_177*tmp_kernel_op_85 + tmp_kernel_op_178*tmp_kernel_op_92 + tmp_kernel_op_179*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_176 + tmp_kernel_op_113*tmp_kernel_op_177 + tmp_kernel_op_120*tmp_kernel_op_178 + tmp_kernel_op_127*tmp_kernel_op_179) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_176 + tmp_kernel_op_133*tmp_kernel_op_177 + tmp_kernel_op_136*tmp_kernel_op_178 + tmp_kernel_op_139*tmp_kernel_op_179) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_176 + tmp_kernel_op_145*tmp_kernel_op_177 + tmp_kernel_op_148*tmp_kernel_op_178 + tmp_kernel_op_151*tmp_kernel_op_179) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_176 + tmp_kernel_op_155*tmp_kernel_op_177 + tmp_kernel_op_157*tmp_kernel_op_178 + tmp_kernel_op_159*tmp_kernel_op_179);
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const real_t tmp_moved_constant_0 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_1 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_2 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_3 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_4 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_5 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_6 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_7 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_8 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_9 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_10 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_11 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_12 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_13 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_14 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_15 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_16 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_17 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_18 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_19 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_20 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_21 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_22 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_23 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_24 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_25 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_26 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_27 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_28 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_29 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_30 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_31 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_32 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_33 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_34 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_35 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_36 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_37 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_38 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_39 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_40 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_41 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_42 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_43 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_44 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_45 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_46 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_47 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_48 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_49 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_50 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_51 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_52 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_53 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_54 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_55 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_56 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_57 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_58 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_59 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_60 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_61 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_62 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_63 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_64 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_65 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_66 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_67 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_68 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_69 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_70 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_71 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_15;
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_3,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),jac_blending_2_1_q_3));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3)));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_2,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),jac_blending_2_1_q_2));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2)));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_1,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),jac_blending_2_1_q_1));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1)));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_0,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),jac_blending_2_1_q_0));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0)));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)));
                const __m256d tmp_kernel_op_3 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d tmp_kernel_op_4 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d tmp_kernel_op_9 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_12 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)));
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)));
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)));
                const __m256d tmp_kernel_op_25 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)));
                const __m256d tmp_kernel_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)));
                const __m256d tmp_kernel_op_31 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_34 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)));
                const __m256d tmp_kernel_op_37 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0),_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2),_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4),_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10),_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6),_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8),_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12),_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14),_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16),_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18),_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20),_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22),_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24),_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26),_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28),_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32),_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34),_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38),_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40),_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42),_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46),_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48),_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50),_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52),_mm256_set_pd(tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54),_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56),_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58),_mm256_set_pd(tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60),_mm256_set_pd(tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62),_mm256_set_pd(tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64),_mm256_set_pd(tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66),_mm256_set_pd(tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68),_mm256_set_pd(tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70),_mm256_set_pd(tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_165 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_167 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_175 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_19))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_14),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_2,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_148),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_165),_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_28),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_31)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_25,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_40),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_34,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_37,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_64),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_99)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_78)),_mm256_mul_pd(tmp_kernel_op_85,tmp_kernel_op_9))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_171))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_170),_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_7)),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_99))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_175))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_174),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_175)),_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_99))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_179))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_178),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_179)),_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_99))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5854101966249684 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5854101966249684 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5854101966249684 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.5854101966249684 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.5854101966249684 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.5854101966249684 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.5854101966249684;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.5854101966249684;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.5854101966249684;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t tmp_blending_op_58 = jac_blending_0_2_q_3*jac_blending_1_1_q_3;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_55 = jac_blending_0_1_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_59 = jac_blending_0_2_q_3*jac_blending_1_0_q_3*jac_blending_2_1_q_3 + jac_blending_2_0_q_3*tmp_blending_op_55 - jac_blending_2_0_q_3*tmp_blending_op_58 - jac_blending_2_1_q_3*tmp_blending_op_56 + jac_blending_2_2_q_3*tmp_blending_op_54 - jac_blending_2_2_q_3*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_60*(jac_blending_0_2_q_3*jac_blending_1_0_q_3 - tmp_blending_op_56);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t tmp_blending_op_85 = jac_blending_0_2_q_2*jac_blending_1_1_q_2;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_82 = jac_blending_0_1_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_86 = jac_blending_0_2_q_2*jac_blending_1_0_q_2*jac_blending_2_1_q_2 + jac_blending_2_0_q_2*tmp_blending_op_82 - jac_blending_2_0_q_2*tmp_blending_op_85 - jac_blending_2_1_q_2*tmp_blending_op_83 + jac_blending_2_2_q_2*tmp_blending_op_81 - jac_blending_2_2_q_2*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_87*(jac_blending_0_2_q_2*jac_blending_1_0_q_2 - tmp_blending_op_83);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t tmp_blending_op_111 = jac_blending_0_2_q_1*jac_blending_1_1_q_1;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_108 = jac_blending_0_1_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_112 = jac_blending_0_2_q_1*jac_blending_1_0_q_1*jac_blending_2_1_q_1 + jac_blending_2_0_q_1*tmp_blending_op_108 - jac_blending_2_0_q_1*tmp_blending_op_111 - jac_blending_2_1_q_1*tmp_blending_op_109 + jac_blending_2_2_q_1*tmp_blending_op_107 - jac_blending_2_2_q_1*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_113*(jac_blending_0_2_q_1*jac_blending_1_0_q_1 - tmp_blending_op_109);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t tmp_blending_op_137 = jac_blending_0_2_q_0*jac_blending_1_1_q_0;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_134 = jac_blending_0_1_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_138 = jac_blending_0_2_q_0*jac_blending_1_0_q_0*jac_blending_2_1_q_0 + jac_blending_2_0_q_0*tmp_blending_op_134 - jac_blending_2_0_q_0*tmp_blending_op_137 - jac_blending_2_1_q_0*tmp_blending_op_135 + jac_blending_2_2_q_0*tmp_blending_op_133 - jac_blending_2_2_q_0*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_139*(jac_blending_0_2_q_0*jac_blending_1_0_q_0 - tmp_blending_op_135);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_kernel_op_2 = -jac_affine_inv_0_0_WHITE_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_1_WHITE_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_2_WHITE_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_1;
                const real_t tmp_kernel_op_3 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_0*0.041666666666666657;
                const real_t tmp_kernel_op_4 = tmp_kernel_op_3*0.13819660112501053;
                const real_t tmp_kernel_op_7 = -jac_affine_inv_0_0_WHITE_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_1_WHITE_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_2_WHITE_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_6;
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_1*0.041666666666666657;
                const real_t tmp_kernel_op_9 = tmp_kernel_op_8*0.13819660112501056;
                const real_t tmp_kernel_op_12 = -jac_affine_inv_0_0_WHITE_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_1_WHITE_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_2_WHITE_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_11;
                const real_t tmp_kernel_op_13 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_2*0.041666666666666657;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_13*0.13819660112501056;
                const real_t tmp_kernel_op_17 = -jac_affine_inv_0_0_WHITE_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_1_WHITE_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_2_WHITE_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_3*0.041666666666666657;
                const real_t tmp_kernel_op_19 = tmp_kernel_op_18*0.5854101966249684;
                const real_t tmp_kernel_op_22 = -jac_affine_inv_1_0_WHITE_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_1_WHITE_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_2_WHITE_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_21;
                const real_t tmp_kernel_op_25 = -jac_affine_inv_1_0_WHITE_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_1_WHITE_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_2_WHITE_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_24;
                const real_t tmp_kernel_op_28 = -jac_affine_inv_1_0_WHITE_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_1_WHITE_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_2_WHITE_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_27;
                const real_t tmp_kernel_op_31 = -jac_affine_inv_1_0_WHITE_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_1_WHITE_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_2_WHITE_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_30;
                const real_t tmp_kernel_op_34 = -jac_affine_inv_2_0_WHITE_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_1_WHITE_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_2_WHITE_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_33;
                const real_t tmp_kernel_op_37 = -jac_affine_inv_2_0_WHITE_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_1_WHITE_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_2_WHITE_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_36;
                const real_t tmp_kernel_op_40 = -jac_affine_inv_2_0_WHITE_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_1_WHITE_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_2_WHITE_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_39;
                const real_t tmp_kernel_op_43 = -jac_affine_inv_2_0_WHITE_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_1_WHITE_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_2_WHITE_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_50 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_0 + tmp_moved_constant_1) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_2 + tmp_moved_constant_3) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_4 + tmp_moved_constant_5);
                const real_t tmp_kernel_op_57 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_6 + tmp_moved_constant_7) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_8 + tmp_moved_constant_9) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_10 + tmp_moved_constant_11);
                const real_t tmp_kernel_op_64 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_12 + tmp_moved_constant_13) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_14 + tmp_moved_constant_15) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_16 + tmp_moved_constant_17);
                const real_t tmp_kernel_op_71 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_18 + tmp_moved_constant_19) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_20 + tmp_moved_constant_21) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_22 + tmp_moved_constant_23);
                const real_t tmp_kernel_op_78 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_24 + tmp_moved_constant_25) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_26 + tmp_moved_constant_27) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_28 + tmp_moved_constant_29);
                const real_t tmp_kernel_op_85 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_30 + tmp_moved_constant_31) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_32 + tmp_moved_constant_33) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_34 + tmp_moved_constant_35);
                const real_t tmp_kernel_op_92 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_36 + tmp_moved_constant_37) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_38 + tmp_moved_constant_39) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_40 + tmp_moved_constant_41);
                const real_t tmp_kernel_op_99 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_42 + tmp_moved_constant_43) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_44 + tmp_moved_constant_45) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_46 + tmp_moved_constant_47);
                const real_t tmp_kernel_op_106 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_48 + tmp_moved_constant_49) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_50 + tmp_moved_constant_51) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_52 + tmp_moved_constant_53);
                const real_t tmp_kernel_op_113 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_54 + tmp_moved_constant_55) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_56 + tmp_moved_constant_57) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_58 + tmp_moved_constant_59);
                const real_t tmp_kernel_op_120 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_60 + tmp_moved_constant_61) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_62 + tmp_moved_constant_63) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_64 + tmp_moved_constant_65);
                const real_t tmp_kernel_op_127 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_66 + tmp_moved_constant_67) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_68 + tmp_moved_constant_69) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_70 + tmp_moved_constant_71);
                const real_t tmp_kernel_op_130 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_129 - tmp_moved_constant_0 - tmp_moved_constant_24) - jac_blending_inv_1_2_q_0*(jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_129 - tmp_moved_constant_2 - tmp_moved_constant_26) - jac_blending_inv_2_2_q_0*(jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_129 - tmp_moved_constant_28 - tmp_moved_constant_4);
                const real_t tmp_kernel_op_133 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_132 - tmp_moved_constant_30 - tmp_moved_constant_6) - jac_blending_inv_1_2_q_1*(jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_132 - tmp_moved_constant_32 - tmp_moved_constant_8) - jac_blending_inv_2_2_q_1*(jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_132 - tmp_moved_constant_10 - tmp_moved_constant_34);
                const real_t tmp_kernel_op_136 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_135 - tmp_moved_constant_12 - tmp_moved_constant_36) - jac_blending_inv_1_2_q_2*(jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_135 - tmp_moved_constant_14 - tmp_moved_constant_38) - jac_blending_inv_2_2_q_2*(jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_135 - tmp_moved_constant_16 - tmp_moved_constant_40);
                const real_t tmp_kernel_op_139 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_138 - tmp_moved_constant_18 - tmp_moved_constant_42) - jac_blending_inv_1_2_q_3*(jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_138 - tmp_moved_constant_20 - tmp_moved_constant_44) - jac_blending_inv_2_2_q_3*(jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_138 - tmp_moved_constant_22 - tmp_moved_constant_46);
                const real_t tmp_kernel_op_142 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_141 - tmp_moved_constant_1 - tmp_moved_constant_48) - jac_blending_inv_1_2_q_0*(jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_141 - tmp_moved_constant_3 - tmp_moved_constant_50) - jac_blending_inv_2_2_q_0*(jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_141 - tmp_moved_constant_5 - tmp_moved_constant_52);
                const real_t tmp_kernel_op_145 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_144 - tmp_moved_constant_54 - tmp_moved_constant_7) - jac_blending_inv_1_2_q_1*(jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_144 - tmp_moved_constant_56 - tmp_moved_constant_9) - jac_blending_inv_2_2_q_1*(jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_144 - tmp_moved_constant_11 - tmp_moved_constant_58);
                const real_t tmp_kernel_op_148 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_147 - tmp_moved_constant_13 - tmp_moved_constant_60) - jac_blending_inv_1_2_q_2*(jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_147 - tmp_moved_constant_15 - tmp_moved_constant_62) - jac_blending_inv_2_2_q_2*(jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_147 - tmp_moved_constant_17 - tmp_moved_constant_64);
                const real_t tmp_kernel_op_151 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_150 - tmp_moved_constant_19 - tmp_moved_constant_66) - jac_blending_inv_1_2_q_3*(jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_150 - tmp_moved_constant_21 - tmp_moved_constant_68) - jac_blending_inv_2_2_q_3*(jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_150 - tmp_moved_constant_23 - tmp_moved_constant_70);
                const real_t tmp_kernel_op_153 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_152 - tmp_moved_constant_25 - tmp_moved_constant_49) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_152 - tmp_moved_constant_27 - tmp_moved_constant_51) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_152 - tmp_moved_constant_29 - tmp_moved_constant_53);
                const real_t tmp_kernel_op_155 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_154 - tmp_moved_constant_31 - tmp_moved_constant_55) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_154 - tmp_moved_constant_33 - tmp_moved_constant_57) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_154 - tmp_moved_constant_35 - tmp_moved_constant_59);
                const real_t tmp_kernel_op_157 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_156 - tmp_moved_constant_37 - tmp_moved_constant_61) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_156 - tmp_moved_constant_39 - tmp_moved_constant_63) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_156 - tmp_moved_constant_41 - tmp_moved_constant_65);
                const real_t tmp_kernel_op_159 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_158 - tmp_moved_constant_43 - tmp_moved_constant_67) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_158 - tmp_moved_constant_45 - tmp_moved_constant_69) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_158 - tmp_moved_constant_47 - tmp_moved_constant_71);
                const real_t tmp_kernel_op_161 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_160) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_160) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_160);
                const real_t tmp_kernel_op_163 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_162) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_162) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_162);
                const real_t tmp_kernel_op_165 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_164) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_164) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_164);
                const real_t tmp_kernel_op_167 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_166) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_166) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_166);
                const real_t tmp_kernel_op_168 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_169 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_170 = tmp_kernel_op_13*0.5854101966249684;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_173 = tmp_kernel_op_8*0.5854101966249684;
                const real_t tmp_kernel_op_174 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_175 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_3*0.5854101966249684;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_18*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_14*tmp_kernel_op_165 + tmp_kernel_op_161*tmp_kernel_op_4 + tmp_kernel_op_163*tmp_kernel_op_9 + tmp_kernel_op_167*tmp_kernel_op_19) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_14 + tmp_kernel_op_17*tmp_kernel_op_19 + tmp_kernel_op_2*tmp_kernel_op_4 + tmp_kernel_op_7*tmp_kernel_op_9) + src_dof_2*(tmp_kernel_op_14*tmp_kernel_op_28 + tmp_kernel_op_19*tmp_kernel_op_31 + tmp_kernel_op_22*tmp_kernel_op_4 + tmp_kernel_op_25*tmp_kernel_op_9) + src_dof_3*(tmp_kernel_op_14*tmp_kernel_op_40 + tmp_kernel_op_19*tmp_kernel_op_43 + tmp_kernel_op_34*tmp_kernel_op_4 + tmp_kernel_op_37*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_14*tmp_kernel_op_64 + tmp_kernel_op_19*tmp_kernel_op_71 + tmp_kernel_op_4*tmp_kernel_op_50 + tmp_kernel_op_57*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_14*tmp_kernel_op_92 + tmp_kernel_op_19*tmp_kernel_op_99 + tmp_kernel_op_4*tmp_kernel_op_78 + tmp_kernel_op_85*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_4 + tmp_kernel_op_113*tmp_kernel_op_9 + tmp_kernel_op_120*tmp_kernel_op_14 + tmp_kernel_op_127*tmp_kernel_op_19) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_4 + tmp_kernel_op_133*tmp_kernel_op_9 + tmp_kernel_op_136*tmp_kernel_op_14 + tmp_kernel_op_139*tmp_kernel_op_19) + src_dof_8*(tmp_kernel_op_14*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_4 + tmp_kernel_op_145*tmp_kernel_op_9 + tmp_kernel_op_151*tmp_kernel_op_19) + src_dof_9*(tmp_kernel_op_14*tmp_kernel_op_157 + tmp_kernel_op_153*tmp_kernel_op_4 + tmp_kernel_op_155*tmp_kernel_op_9 + tmp_kernel_op_159*tmp_kernel_op_19);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_168 + tmp_kernel_op_163*tmp_kernel_op_169 + tmp_kernel_op_165*tmp_kernel_op_170 + tmp_kernel_op_167*tmp_kernel_op_171) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_170 + tmp_kernel_op_168*tmp_kernel_op_2 + tmp_kernel_op_169*tmp_kernel_op_7 + tmp_kernel_op_17*tmp_kernel_op_171) + src_dof_2*(tmp_kernel_op_168*tmp_kernel_op_22 + tmp_kernel_op_169*tmp_kernel_op_25 + tmp_kernel_op_170*tmp_kernel_op_28 + tmp_kernel_op_171*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_168*tmp_kernel_op_34 + tmp_kernel_op_169*tmp_kernel_op_37 + tmp_kernel_op_170*tmp_kernel_op_40 + tmp_kernel_op_171*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_168*tmp_kernel_op_50 + tmp_kernel_op_169*tmp_kernel_op_57 + tmp_kernel_op_170*tmp_kernel_op_64 + tmp_kernel_op_171*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_168*tmp_kernel_op_78 + tmp_kernel_op_169*tmp_kernel_op_85 + tmp_kernel_op_170*tmp_kernel_op_92 + tmp_kernel_op_171*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_168 + tmp_kernel_op_113*tmp_kernel_op_169 + tmp_kernel_op_120*tmp_kernel_op_170 + tmp_kernel_op_127*tmp_kernel_op_171) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_168 + tmp_kernel_op_133*tmp_kernel_op_169 + tmp_kernel_op_136*tmp_kernel_op_170 + tmp_kernel_op_139*tmp_kernel_op_171) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_168 + tmp_kernel_op_145*tmp_kernel_op_169 + tmp_kernel_op_148*tmp_kernel_op_170 + tmp_kernel_op_151*tmp_kernel_op_171) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_168 + tmp_kernel_op_155*tmp_kernel_op_169 + tmp_kernel_op_157*tmp_kernel_op_170 + tmp_kernel_op_159*tmp_kernel_op_171);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_172 + tmp_kernel_op_163*tmp_kernel_op_173 + tmp_kernel_op_165*tmp_kernel_op_174 + tmp_kernel_op_167*tmp_kernel_op_175) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_174 + tmp_kernel_op_17*tmp_kernel_op_175 + tmp_kernel_op_172*tmp_kernel_op_2 + tmp_kernel_op_173*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_172*tmp_kernel_op_22 + tmp_kernel_op_173*tmp_kernel_op_25 + tmp_kernel_op_174*tmp_kernel_op_28 + tmp_kernel_op_175*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_172*tmp_kernel_op_34 + tmp_kernel_op_173*tmp_kernel_op_37 + tmp_kernel_op_174*tmp_kernel_op_40 + tmp_kernel_op_175*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_172*tmp_kernel_op_50 + tmp_kernel_op_173*tmp_kernel_op_57 + tmp_kernel_op_174*tmp_kernel_op_64 + tmp_kernel_op_175*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_172*tmp_kernel_op_78 + tmp_kernel_op_173*tmp_kernel_op_85 + tmp_kernel_op_174*tmp_kernel_op_92 + tmp_kernel_op_175*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_172 + tmp_kernel_op_113*tmp_kernel_op_173 + tmp_kernel_op_120*tmp_kernel_op_174 + tmp_kernel_op_127*tmp_kernel_op_175) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_172 + tmp_kernel_op_133*tmp_kernel_op_173 + tmp_kernel_op_136*tmp_kernel_op_174 + tmp_kernel_op_139*tmp_kernel_op_175) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_172 + tmp_kernel_op_145*tmp_kernel_op_173 + tmp_kernel_op_148*tmp_kernel_op_174 + tmp_kernel_op_151*tmp_kernel_op_175) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_172 + tmp_kernel_op_155*tmp_kernel_op_173 + tmp_kernel_op_157*tmp_kernel_op_174 + tmp_kernel_op_159*tmp_kernel_op_175);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_176 + tmp_kernel_op_163*tmp_kernel_op_177 + tmp_kernel_op_165*tmp_kernel_op_178 + tmp_kernel_op_167*tmp_kernel_op_179) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_178 + tmp_kernel_op_17*tmp_kernel_op_179 + tmp_kernel_op_176*tmp_kernel_op_2 + tmp_kernel_op_177*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_176*tmp_kernel_op_22 + tmp_kernel_op_177*tmp_kernel_op_25 + tmp_kernel_op_178*tmp_kernel_op_28 + tmp_kernel_op_179*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_176*tmp_kernel_op_34 + tmp_kernel_op_177*tmp_kernel_op_37 + tmp_kernel_op_178*tmp_kernel_op_40 + tmp_kernel_op_179*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_176*tmp_kernel_op_50 + tmp_kernel_op_177*tmp_kernel_op_57 + tmp_kernel_op_178*tmp_kernel_op_64 + tmp_kernel_op_179*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_176*tmp_kernel_op_78 + tmp_kernel_op_177*tmp_kernel_op_85 + tmp_kernel_op_178*tmp_kernel_op_92 + tmp_kernel_op_179*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_176 + tmp_kernel_op_113*tmp_kernel_op_177 + tmp_kernel_op_120*tmp_kernel_op_178 + tmp_kernel_op_127*tmp_kernel_op_179) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_176 + tmp_kernel_op_133*tmp_kernel_op_177 + tmp_kernel_op_136*tmp_kernel_op_178 + tmp_kernel_op_139*tmp_kernel_op_179) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_176 + tmp_kernel_op_145*tmp_kernel_op_177 + tmp_kernel_op_148*tmp_kernel_op_178 + tmp_kernel_op_151*tmp_kernel_op_179) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_176 + tmp_kernel_op_155*tmp_kernel_op_177 + tmp_kernel_op_157*tmp_kernel_op_178 + tmp_kernel_op_159*tmp_kernel_op_179);
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const real_t tmp_moved_constant_72 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_73 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_74 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_75 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_76 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_77 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_78 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_79 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_80 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_81 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_82 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_83 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_84 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_85 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_86 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_87 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_88 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_89 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_90 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_91 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_92 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_93 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_94 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_95 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_96 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_97 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_98 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_99 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_100 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_101 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_102 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_103 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_104 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_105 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_106 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_107 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_108 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_109 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_110 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_111 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_112 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_113 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_114 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_115 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_116 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_117 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_118 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_119 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_120 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_121 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_122 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_123 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_124 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_125 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_126 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_127 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_128 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_129 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_130 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_131 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_132 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_133 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_134 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_135 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_136 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_137 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_138 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_139 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_140 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_141 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_142 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_143 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_15;
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_3,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),jac_blending_2_1_q_3));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3)));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_2,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),jac_blending_2_1_q_2));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2)));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_1,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),jac_blending_2_1_q_1));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1)));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_0,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),jac_blending_2_1_q_0));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0)));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)));
                const __m256d tmp_kernel_op_3 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d tmp_kernel_op_4 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d tmp_kernel_op_9 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_12 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)));
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)));
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)));
                const __m256d tmp_kernel_op_25 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)));
                const __m256d tmp_kernel_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)));
                const __m256d tmp_kernel_op_31 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_34 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)));
                const __m256d tmp_kernel_op_37 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72),_mm256_set_pd(tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74),_mm256_set_pd(tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76),_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80),_mm256_set_pd(tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82),_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86),_mm256_set_pd(tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88),_mm256_set_pd(tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_90,tmp_moved_constant_90,tmp_moved_constant_90,tmp_moved_constant_90),_mm256_set_pd(tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92),_mm256_set_pd(tmp_moved_constant_93,tmp_moved_constant_93,tmp_moved_constant_93,tmp_moved_constant_93))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94),_mm256_set_pd(tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100),_mm256_set_pd(tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_96,tmp_moved_constant_96,tmp_moved_constant_96,tmp_moved_constant_96),_mm256_set_pd(tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98),_mm256_set_pd(tmp_moved_constant_99,tmp_moved_constant_99,tmp_moved_constant_99,tmp_moved_constant_99))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_102,tmp_moved_constant_102,tmp_moved_constant_102,tmp_moved_constant_102),_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104),_mm256_set_pd(tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106),_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_108,tmp_moved_constant_108,tmp_moved_constant_108,tmp_moved_constant_108),_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110),_mm256_set_pd(tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112),_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_114,tmp_moved_constant_114,tmp_moved_constant_114,tmp_moved_constant_114),_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116),_mm256_set_pd(tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118),_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120),_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122),_mm256_set_pd(tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124),_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_126,tmp_moved_constant_126,tmp_moved_constant_126,tmp_moved_constant_126),_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128),_mm256_set_pd(tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130),_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_132,tmp_moved_constant_132,tmp_moved_constant_132,tmp_moved_constant_132),_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134),_mm256_set_pd(tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136),_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_138,tmp_moved_constant_138,tmp_moved_constant_138,tmp_moved_constant_138),_mm256_set_pd(tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140),_mm256_set_pd(tmp_moved_constant_141,tmp_moved_constant_141,tmp_moved_constant_141,tmp_moved_constant_141))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142),_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_96,tmp_moved_constant_96,tmp_moved_constant_96,tmp_moved_constant_96))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_102,tmp_moved_constant_102,tmp_moved_constant_102,tmp_moved_constant_102)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_108,tmp_moved_constant_108,tmp_moved_constant_108,tmp_moved_constant_108)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_114,tmp_moved_constant_114,tmp_moved_constant_114,tmp_moved_constant_114)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_90,tmp_moved_constant_90,tmp_moved_constant_90,tmp_moved_constant_90))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_126,tmp_moved_constant_126,tmp_moved_constant_126,tmp_moved_constant_126)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_132,tmp_moved_constant_132,tmp_moved_constant_132,tmp_moved_constant_132)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_138,tmp_moved_constant_138,tmp_moved_constant_138,tmp_moved_constant_138)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_93,tmp_moved_constant_93,tmp_moved_constant_93,tmp_moved_constant_93))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_99,tmp_moved_constant_99,tmp_moved_constant_99,tmp_moved_constant_99))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_141,tmp_moved_constant_141,tmp_moved_constant_141,tmp_moved_constant_141))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_165 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_167 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_175 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_19))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_14),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_2,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_148),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_165),_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_28),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_31)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_25,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_40),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_34,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_37,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_64),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_99)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_78)),_mm256_mul_pd(tmp_kernel_op_85,tmp_kernel_op_9))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_171))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_170),_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_7)),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_99))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_175))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_174),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_175)),_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_99))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_179))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_178),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_179)),_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_99))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5854101966249684 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5854101966249684 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5854101966249684 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.5854101966249684 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.5854101966249684 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.5854101966249684 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.5854101966249684;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.5854101966249684;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.5854101966249684;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t tmp_blending_op_58 = jac_blending_0_2_q_3*jac_blending_1_1_q_3;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_55 = jac_blending_0_1_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_59 = jac_blending_0_2_q_3*jac_blending_1_0_q_3*jac_blending_2_1_q_3 + jac_blending_2_0_q_3*tmp_blending_op_55 - jac_blending_2_0_q_3*tmp_blending_op_58 - jac_blending_2_1_q_3*tmp_blending_op_56 + jac_blending_2_2_q_3*tmp_blending_op_54 - jac_blending_2_2_q_3*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_60*(jac_blending_0_2_q_3*jac_blending_1_0_q_3 - tmp_blending_op_56);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t tmp_blending_op_85 = jac_blending_0_2_q_2*jac_blending_1_1_q_2;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_82 = jac_blending_0_1_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_86 = jac_blending_0_2_q_2*jac_blending_1_0_q_2*jac_blending_2_1_q_2 + jac_blending_2_0_q_2*tmp_blending_op_82 - jac_blending_2_0_q_2*tmp_blending_op_85 - jac_blending_2_1_q_2*tmp_blending_op_83 + jac_blending_2_2_q_2*tmp_blending_op_81 - jac_blending_2_2_q_2*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_87*(jac_blending_0_2_q_2*jac_blending_1_0_q_2 - tmp_blending_op_83);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t tmp_blending_op_111 = jac_blending_0_2_q_1*jac_blending_1_1_q_1;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_108 = jac_blending_0_1_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_112 = jac_blending_0_2_q_1*jac_blending_1_0_q_1*jac_blending_2_1_q_1 + jac_blending_2_0_q_1*tmp_blending_op_108 - jac_blending_2_0_q_1*tmp_blending_op_111 - jac_blending_2_1_q_1*tmp_blending_op_109 + jac_blending_2_2_q_1*tmp_blending_op_107 - jac_blending_2_2_q_1*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_113*(jac_blending_0_2_q_1*jac_blending_1_0_q_1 - tmp_blending_op_109);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t tmp_blending_op_137 = jac_blending_0_2_q_0*jac_blending_1_1_q_0;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_134 = jac_blending_0_1_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_138 = jac_blending_0_2_q_0*jac_blending_1_0_q_0*jac_blending_2_1_q_0 + jac_blending_2_0_q_0*tmp_blending_op_134 - jac_blending_2_0_q_0*tmp_blending_op_137 - jac_blending_2_1_q_0*tmp_blending_op_135 + jac_blending_2_2_q_0*tmp_blending_op_133 - jac_blending_2_2_q_0*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_139*(jac_blending_0_2_q_0*jac_blending_1_0_q_0 - tmp_blending_op_135);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_2 = -jac_affine_inv_0_0_BLUE_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_1_BLUE_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_2_BLUE_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_1;
                const real_t tmp_kernel_op_3 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_0*0.041666666666666657;
                const real_t tmp_kernel_op_4 = tmp_kernel_op_3*0.13819660112501053;
                const real_t tmp_kernel_op_7 = -jac_affine_inv_0_0_BLUE_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_1_BLUE_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_2_BLUE_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_6;
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_1*0.041666666666666657;
                const real_t tmp_kernel_op_9 = tmp_kernel_op_8*0.13819660112501056;
                const real_t tmp_kernel_op_12 = -jac_affine_inv_0_0_BLUE_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_1_BLUE_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_2_BLUE_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_11;
                const real_t tmp_kernel_op_13 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_2*0.041666666666666657;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_13*0.13819660112501056;
                const real_t tmp_kernel_op_17 = -jac_affine_inv_0_0_BLUE_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_1_BLUE_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_2_BLUE_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_3*0.041666666666666657;
                const real_t tmp_kernel_op_19 = tmp_kernel_op_18*0.5854101966249684;
                const real_t tmp_kernel_op_22 = -jac_affine_inv_1_0_BLUE_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_1_BLUE_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_2_BLUE_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_21;
                const real_t tmp_kernel_op_25 = -jac_affine_inv_1_0_BLUE_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_1_BLUE_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_2_BLUE_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_24;
                const real_t tmp_kernel_op_28 = -jac_affine_inv_1_0_BLUE_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_1_BLUE_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_2_BLUE_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_27;
                const real_t tmp_kernel_op_31 = -jac_affine_inv_1_0_BLUE_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_1_BLUE_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_2_BLUE_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_30;
                const real_t tmp_kernel_op_34 = -jac_affine_inv_2_0_BLUE_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_1_BLUE_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_2_BLUE_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_33;
                const real_t tmp_kernel_op_37 = -jac_affine_inv_2_0_BLUE_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_1_BLUE_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_2_BLUE_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_36;
                const real_t tmp_kernel_op_40 = -jac_affine_inv_2_0_BLUE_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_1_BLUE_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_2_BLUE_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_39;
                const real_t tmp_kernel_op_43 = -jac_affine_inv_2_0_BLUE_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_1_BLUE_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_2_BLUE_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_50 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_72 + tmp_moved_constant_73) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_74 + tmp_moved_constant_75) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_76 + tmp_moved_constant_77);
                const real_t tmp_kernel_op_57 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_78 + tmp_moved_constant_79) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_80 + tmp_moved_constant_81) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_82 + tmp_moved_constant_83);
                const real_t tmp_kernel_op_64 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_84 + tmp_moved_constant_85) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_86 + tmp_moved_constant_87) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_88 + tmp_moved_constant_89);
                const real_t tmp_kernel_op_71 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_90 + tmp_moved_constant_91) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_92 + tmp_moved_constant_93) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_94 + tmp_moved_constant_95);
                const real_t tmp_kernel_op_78 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_96 + tmp_moved_constant_97) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_98 + tmp_moved_constant_99) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_100 + tmp_moved_constant_101);
                const real_t tmp_kernel_op_85 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_102 + tmp_moved_constant_103) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_104 + tmp_moved_constant_105) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_106 + tmp_moved_constant_107);
                const real_t tmp_kernel_op_92 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_108 + tmp_moved_constant_109) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_110 + tmp_moved_constant_111) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_112 + tmp_moved_constant_113);
                const real_t tmp_kernel_op_99 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_114 + tmp_moved_constant_115) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_116 + tmp_moved_constant_117) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_118 + tmp_moved_constant_119);
                const real_t tmp_kernel_op_106 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_120 + tmp_moved_constant_121) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_122 + tmp_moved_constant_123) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_124 + tmp_moved_constant_125);
                const real_t tmp_kernel_op_113 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_126 + tmp_moved_constant_127) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_128 + tmp_moved_constant_129) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_130 + tmp_moved_constant_131);
                const real_t tmp_kernel_op_120 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_132 + tmp_moved_constant_133) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_134 + tmp_moved_constant_135) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_136 + tmp_moved_constant_137);
                const real_t tmp_kernel_op_127 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_138 + tmp_moved_constant_139) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_140 + tmp_moved_constant_141) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_142 + tmp_moved_constant_143);
                const real_t tmp_kernel_op_130 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_129 - tmp_moved_constant_72 - tmp_moved_constant_96) - jac_blending_inv_1_2_q_0*(jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_129 - tmp_moved_constant_74 - tmp_moved_constant_98) - jac_blending_inv_2_2_q_0*(jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_129 - tmp_moved_constant_100 - tmp_moved_constant_76);
                const real_t tmp_kernel_op_133 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_132 - tmp_moved_constant_102 - tmp_moved_constant_78) - jac_blending_inv_1_2_q_1*(jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_132 - tmp_moved_constant_104 - tmp_moved_constant_80) - jac_blending_inv_2_2_q_1*(jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_132 - tmp_moved_constant_106 - tmp_moved_constant_82);
                const real_t tmp_kernel_op_136 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_135 - tmp_moved_constant_108 - tmp_moved_constant_84) - jac_blending_inv_1_2_q_2*(jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_135 - tmp_moved_constant_110 - tmp_moved_constant_86) - jac_blending_inv_2_2_q_2*(jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_135 - tmp_moved_constant_112 - tmp_moved_constant_88);
                const real_t tmp_kernel_op_139 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_138 - tmp_moved_constant_114 - tmp_moved_constant_90) - jac_blending_inv_1_2_q_3*(jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_138 - tmp_moved_constant_116 - tmp_moved_constant_92) - jac_blending_inv_2_2_q_3*(jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_138 - tmp_moved_constant_118 - tmp_moved_constant_94);
                const real_t tmp_kernel_op_142 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_141 - tmp_moved_constant_120 - tmp_moved_constant_73) - jac_blending_inv_1_2_q_0*(jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_141 - tmp_moved_constant_122 - tmp_moved_constant_75) - jac_blending_inv_2_2_q_0*(jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_141 - tmp_moved_constant_124 - tmp_moved_constant_77);
                const real_t tmp_kernel_op_145 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_144 - tmp_moved_constant_126 - tmp_moved_constant_79) - jac_blending_inv_1_2_q_1*(jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_144 - tmp_moved_constant_128 - tmp_moved_constant_81) - jac_blending_inv_2_2_q_1*(jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_144 - tmp_moved_constant_130 - tmp_moved_constant_83);
                const real_t tmp_kernel_op_148 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_147 - tmp_moved_constant_132 - tmp_moved_constant_85) - jac_blending_inv_1_2_q_2*(jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_147 - tmp_moved_constant_134 - tmp_moved_constant_87) - jac_blending_inv_2_2_q_2*(jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_147 - tmp_moved_constant_136 - tmp_moved_constant_89);
                const real_t tmp_kernel_op_151 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_150 - tmp_moved_constant_138 - tmp_moved_constant_91) - jac_blending_inv_1_2_q_3*(jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_150 - tmp_moved_constant_140 - tmp_moved_constant_93) - jac_blending_inv_2_2_q_3*(jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_150 - tmp_moved_constant_142 - tmp_moved_constant_95);
                const real_t tmp_kernel_op_153 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_152 - tmp_moved_constant_121 - tmp_moved_constant_97) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_152 - tmp_moved_constant_123 - tmp_moved_constant_99) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_152 - tmp_moved_constant_101 - tmp_moved_constant_125);
                const real_t tmp_kernel_op_155 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_154 - tmp_moved_constant_103 - tmp_moved_constant_127) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_154 - tmp_moved_constant_105 - tmp_moved_constant_129) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_154 - tmp_moved_constant_107 - tmp_moved_constant_131);
                const real_t tmp_kernel_op_157 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_156 - tmp_moved_constant_109 - tmp_moved_constant_133) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_156 - tmp_moved_constant_111 - tmp_moved_constant_135) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_156 - tmp_moved_constant_113 - tmp_moved_constant_137);
                const real_t tmp_kernel_op_159 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_158 - tmp_moved_constant_115 - tmp_moved_constant_139) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_158 - tmp_moved_constant_117 - tmp_moved_constant_141) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_158 - tmp_moved_constant_119 - tmp_moved_constant_143);
                const real_t tmp_kernel_op_161 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_160 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_160 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_160) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_160 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_160 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_160) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_160 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_160 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_160);
                const real_t tmp_kernel_op_163 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_162 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_162 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_162) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_162 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_162 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_162) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_162 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_162 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_162);
                const real_t tmp_kernel_op_165 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_164 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_164 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_164) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_164 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_164 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_164) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_164 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_164 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_164);
                const real_t tmp_kernel_op_167 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_166 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_166 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_166) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_166 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_166 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_166) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_166 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_166 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_166);
                const real_t tmp_kernel_op_168 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_169 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_170 = tmp_kernel_op_13*0.5854101966249684;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_173 = tmp_kernel_op_8*0.5854101966249684;
                const real_t tmp_kernel_op_174 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_175 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_3*0.5854101966249684;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_18*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_14*tmp_kernel_op_165 + tmp_kernel_op_161*tmp_kernel_op_4 + tmp_kernel_op_163*tmp_kernel_op_9 + tmp_kernel_op_167*tmp_kernel_op_19) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_14 + tmp_kernel_op_17*tmp_kernel_op_19 + tmp_kernel_op_2*tmp_kernel_op_4 + tmp_kernel_op_7*tmp_kernel_op_9) + src_dof_2*(tmp_kernel_op_14*tmp_kernel_op_28 + tmp_kernel_op_19*tmp_kernel_op_31 + tmp_kernel_op_22*tmp_kernel_op_4 + tmp_kernel_op_25*tmp_kernel_op_9) + src_dof_3*(tmp_kernel_op_14*tmp_kernel_op_40 + tmp_kernel_op_19*tmp_kernel_op_43 + tmp_kernel_op_34*tmp_kernel_op_4 + tmp_kernel_op_37*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_14*tmp_kernel_op_64 + tmp_kernel_op_19*tmp_kernel_op_71 + tmp_kernel_op_4*tmp_kernel_op_50 + tmp_kernel_op_57*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_14*tmp_kernel_op_92 + tmp_kernel_op_19*tmp_kernel_op_99 + tmp_kernel_op_4*tmp_kernel_op_78 + tmp_kernel_op_85*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_4 + tmp_kernel_op_113*tmp_kernel_op_9 + tmp_kernel_op_120*tmp_kernel_op_14 + tmp_kernel_op_127*tmp_kernel_op_19) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_4 + tmp_kernel_op_133*tmp_kernel_op_9 + tmp_kernel_op_136*tmp_kernel_op_14 + tmp_kernel_op_139*tmp_kernel_op_19) + src_dof_8*(tmp_kernel_op_14*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_4 + tmp_kernel_op_145*tmp_kernel_op_9 + tmp_kernel_op_151*tmp_kernel_op_19) + src_dof_9*(tmp_kernel_op_14*tmp_kernel_op_157 + tmp_kernel_op_153*tmp_kernel_op_4 + tmp_kernel_op_155*tmp_kernel_op_9 + tmp_kernel_op_159*tmp_kernel_op_19);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_168 + tmp_kernel_op_163*tmp_kernel_op_169 + tmp_kernel_op_165*tmp_kernel_op_170 + tmp_kernel_op_167*tmp_kernel_op_171) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_170 + tmp_kernel_op_168*tmp_kernel_op_2 + tmp_kernel_op_169*tmp_kernel_op_7 + tmp_kernel_op_17*tmp_kernel_op_171) + src_dof_2*(tmp_kernel_op_168*tmp_kernel_op_22 + tmp_kernel_op_169*tmp_kernel_op_25 + tmp_kernel_op_170*tmp_kernel_op_28 + tmp_kernel_op_171*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_168*tmp_kernel_op_34 + tmp_kernel_op_169*tmp_kernel_op_37 + tmp_kernel_op_170*tmp_kernel_op_40 + tmp_kernel_op_171*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_168*tmp_kernel_op_50 + tmp_kernel_op_169*tmp_kernel_op_57 + tmp_kernel_op_170*tmp_kernel_op_64 + tmp_kernel_op_171*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_168*tmp_kernel_op_78 + tmp_kernel_op_169*tmp_kernel_op_85 + tmp_kernel_op_170*tmp_kernel_op_92 + tmp_kernel_op_171*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_168 + tmp_kernel_op_113*tmp_kernel_op_169 + tmp_kernel_op_120*tmp_kernel_op_170 + tmp_kernel_op_127*tmp_kernel_op_171) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_168 + tmp_kernel_op_133*tmp_kernel_op_169 + tmp_kernel_op_136*tmp_kernel_op_170 + tmp_kernel_op_139*tmp_kernel_op_171) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_168 + tmp_kernel_op_145*tmp_kernel_op_169 + tmp_kernel_op_148*tmp_kernel_op_170 + tmp_kernel_op_151*tmp_kernel_op_171) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_168 + tmp_kernel_op_155*tmp_kernel_op_169 + tmp_kernel_op_157*tmp_kernel_op_170 + tmp_kernel_op_159*tmp_kernel_op_171);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_172 + tmp_kernel_op_163*tmp_kernel_op_173 + tmp_kernel_op_165*tmp_kernel_op_174 + tmp_kernel_op_167*tmp_kernel_op_175) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_174 + tmp_kernel_op_17*tmp_kernel_op_175 + tmp_kernel_op_172*tmp_kernel_op_2 + tmp_kernel_op_173*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_172*tmp_kernel_op_22 + tmp_kernel_op_173*tmp_kernel_op_25 + tmp_kernel_op_174*tmp_kernel_op_28 + tmp_kernel_op_175*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_172*tmp_kernel_op_34 + tmp_kernel_op_173*tmp_kernel_op_37 + tmp_kernel_op_174*tmp_kernel_op_40 + tmp_kernel_op_175*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_172*tmp_kernel_op_50 + tmp_kernel_op_173*tmp_kernel_op_57 + tmp_kernel_op_174*tmp_kernel_op_64 + tmp_kernel_op_175*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_172*tmp_kernel_op_78 + tmp_kernel_op_173*tmp_kernel_op_85 + tmp_kernel_op_174*tmp_kernel_op_92 + tmp_kernel_op_175*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_172 + tmp_kernel_op_113*tmp_kernel_op_173 + tmp_kernel_op_120*tmp_kernel_op_174 + tmp_kernel_op_127*tmp_kernel_op_175) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_172 + tmp_kernel_op_133*tmp_kernel_op_173 + tmp_kernel_op_136*tmp_kernel_op_174 + tmp_kernel_op_139*tmp_kernel_op_175) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_172 + tmp_kernel_op_145*tmp_kernel_op_173 + tmp_kernel_op_148*tmp_kernel_op_174 + tmp_kernel_op_151*tmp_kernel_op_175) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_172 + tmp_kernel_op_155*tmp_kernel_op_173 + tmp_kernel_op_157*tmp_kernel_op_174 + tmp_kernel_op_159*tmp_kernel_op_175);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_176 + tmp_kernel_op_163*tmp_kernel_op_177 + tmp_kernel_op_165*tmp_kernel_op_178 + tmp_kernel_op_167*tmp_kernel_op_179) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_178 + tmp_kernel_op_17*tmp_kernel_op_179 + tmp_kernel_op_176*tmp_kernel_op_2 + tmp_kernel_op_177*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_176*tmp_kernel_op_22 + tmp_kernel_op_177*tmp_kernel_op_25 + tmp_kernel_op_178*tmp_kernel_op_28 + tmp_kernel_op_179*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_176*tmp_kernel_op_34 + tmp_kernel_op_177*tmp_kernel_op_37 + tmp_kernel_op_178*tmp_kernel_op_40 + tmp_kernel_op_179*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_176*tmp_kernel_op_50 + tmp_kernel_op_177*tmp_kernel_op_57 + tmp_kernel_op_178*tmp_kernel_op_64 + tmp_kernel_op_179*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_176*tmp_kernel_op_78 + tmp_kernel_op_177*tmp_kernel_op_85 + tmp_kernel_op_178*tmp_kernel_op_92 + tmp_kernel_op_179*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_176 + tmp_kernel_op_113*tmp_kernel_op_177 + tmp_kernel_op_120*tmp_kernel_op_178 + tmp_kernel_op_127*tmp_kernel_op_179) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_176 + tmp_kernel_op_133*tmp_kernel_op_177 + tmp_kernel_op_136*tmp_kernel_op_178 + tmp_kernel_op_139*tmp_kernel_op_179) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_176 + tmp_kernel_op_145*tmp_kernel_op_177 + tmp_kernel_op_148*tmp_kernel_op_178 + tmp_kernel_op_151*tmp_kernel_op_179) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_176 + tmp_kernel_op_155*tmp_kernel_op_177 + tmp_kernel_op_157*tmp_kernel_op_178 + tmp_kernel_op_159*tmp_kernel_op_179);
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const real_t tmp_moved_constant_144 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_145 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_146 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_147 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_148 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_149 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_150 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_151 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_152 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_153 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_154 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_155 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_156 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_157 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_158 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_159 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_160 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_161 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_162 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_163 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_164 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_165 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_166 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_167 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_168 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_169 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_170 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_171 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_172 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_173 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_174 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_175 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_176 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_177 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_178 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_179 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_180 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_181 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_182 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_183 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_184 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_185 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_186 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_187 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_188 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_189 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_190 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_191 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_192 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_193 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_194 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_195 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_196 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_197 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_198 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_199 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_200 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_201 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_202 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_203 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_204 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_205 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_206 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_207 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_208 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_209 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_210 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_211 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_212 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_213 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_214 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_215 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_15;
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_3,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),jac_blending_2_1_q_3));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3)));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_2,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),jac_blending_2_1_q_2));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2)));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_1,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),jac_blending_2_1_q_1));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1)));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_0,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),jac_blending_2_1_q_0));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0)));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)));
                const __m256d tmp_kernel_op_3 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d tmp_kernel_op_4 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d tmp_kernel_op_9 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_12 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)));
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)));
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)));
                const __m256d tmp_kernel_op_25 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)));
                const __m256d tmp_kernel_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)));
                const __m256d tmp_kernel_op_31 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_34 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)));
                const __m256d tmp_kernel_op_37 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_144,tmp_moved_constant_144,tmp_moved_constant_144,tmp_moved_constant_144),_mm256_set_pd(tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146),_mm256_set_pd(tmp_moved_constant_147,tmp_moved_constant_147,tmp_moved_constant_147,tmp_moved_constant_147))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148),_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_150,tmp_moved_constant_150,tmp_moved_constant_150,tmp_moved_constant_150),_mm256_set_pd(tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152),_mm256_set_pd(tmp_moved_constant_153,tmp_moved_constant_153,tmp_moved_constant_153,tmp_moved_constant_153))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154),_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_156,tmp_moved_constant_156,tmp_moved_constant_156,tmp_moved_constant_156),_mm256_set_pd(tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158),_mm256_set_pd(tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160),_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162),_mm256_set_pd(tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164),_mm256_set_pd(tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166),_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168),_mm256_set_pd(tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170),_mm256_set_pd(tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172),_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174),_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176),_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178),_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180),_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182),_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184),_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186),_mm256_set_pd(tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188),_mm256_set_pd(tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190),_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192),_mm256_set_pd(tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194),_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196),_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198),_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200),_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202),_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204),_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208),_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210),_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212),_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214),_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_144,tmp_moved_constant_144,tmp_moved_constant_144,tmp_moved_constant_144)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_150,tmp_moved_constant_150,tmp_moved_constant_150,tmp_moved_constant_150)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_156,tmp_moved_constant_156,tmp_moved_constant_156,tmp_moved_constant_156)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_147,tmp_moved_constant_147,tmp_moved_constant_147,tmp_moved_constant_147)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_153,tmp_moved_constant_153,tmp_moved_constant_153,tmp_moved_constant_153)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_165 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_167 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_175 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_19))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_14),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_2,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_148),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_165),_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_28),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_31)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_25,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_40),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_34,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_37,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_64),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_99)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_78)),_mm256_mul_pd(tmp_kernel_op_85,tmp_kernel_op_9))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_171))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_170),_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_7)),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_99))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_175))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_174),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_175)),_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_99))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_179))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_178),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_179)),_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_99))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5854101966249684 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5854101966249684 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5854101966249684 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.5854101966249684 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.5854101966249684 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.5854101966249684 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.5854101966249684;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.5854101966249684;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.5854101966249684;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t tmp_blending_op_58 = jac_blending_0_2_q_3*jac_blending_1_1_q_3;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_55 = jac_blending_0_1_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_59 = jac_blending_0_2_q_3*jac_blending_1_0_q_3*jac_blending_2_1_q_3 + jac_blending_2_0_q_3*tmp_blending_op_55 - jac_blending_2_0_q_3*tmp_blending_op_58 - jac_blending_2_1_q_3*tmp_blending_op_56 + jac_blending_2_2_q_3*tmp_blending_op_54 - jac_blending_2_2_q_3*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_60*(jac_blending_0_2_q_3*jac_blending_1_0_q_3 - tmp_blending_op_56);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t tmp_blending_op_85 = jac_blending_0_2_q_2*jac_blending_1_1_q_2;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_82 = jac_blending_0_1_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_86 = jac_blending_0_2_q_2*jac_blending_1_0_q_2*jac_blending_2_1_q_2 + jac_blending_2_0_q_2*tmp_blending_op_82 - jac_blending_2_0_q_2*tmp_blending_op_85 - jac_blending_2_1_q_2*tmp_blending_op_83 + jac_blending_2_2_q_2*tmp_blending_op_81 - jac_blending_2_2_q_2*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_87*(jac_blending_0_2_q_2*jac_blending_1_0_q_2 - tmp_blending_op_83);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t tmp_blending_op_111 = jac_blending_0_2_q_1*jac_blending_1_1_q_1;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_108 = jac_blending_0_1_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_112 = jac_blending_0_2_q_1*jac_blending_1_0_q_1*jac_blending_2_1_q_1 + jac_blending_2_0_q_1*tmp_blending_op_108 - jac_blending_2_0_q_1*tmp_blending_op_111 - jac_blending_2_1_q_1*tmp_blending_op_109 + jac_blending_2_2_q_1*tmp_blending_op_107 - jac_blending_2_2_q_1*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_113*(jac_blending_0_2_q_1*jac_blending_1_0_q_1 - tmp_blending_op_109);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t tmp_blending_op_137 = jac_blending_0_2_q_0*jac_blending_1_1_q_0;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_134 = jac_blending_0_1_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_138 = jac_blending_0_2_q_0*jac_blending_1_0_q_0*jac_blending_2_1_q_0 + jac_blending_2_0_q_0*tmp_blending_op_134 - jac_blending_2_0_q_0*tmp_blending_op_137 - jac_blending_2_1_q_0*tmp_blending_op_135 + jac_blending_2_2_q_0*tmp_blending_op_133 - jac_blending_2_2_q_0*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_139*(jac_blending_0_2_q_0*jac_blending_1_0_q_0 - tmp_blending_op_135);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_2 = -jac_affine_inv_0_0_BLUE_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_1_BLUE_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_2_BLUE_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_1;
                const real_t tmp_kernel_op_3 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_0*0.041666666666666657;
                const real_t tmp_kernel_op_4 = tmp_kernel_op_3*0.13819660112501053;
                const real_t tmp_kernel_op_7 = -jac_affine_inv_0_0_BLUE_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_1_BLUE_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_2_BLUE_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_6;
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_1*0.041666666666666657;
                const real_t tmp_kernel_op_9 = tmp_kernel_op_8*0.13819660112501056;
                const real_t tmp_kernel_op_12 = -jac_affine_inv_0_0_BLUE_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_1_BLUE_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_2_BLUE_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_11;
                const real_t tmp_kernel_op_13 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_2*0.041666666666666657;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_13*0.13819660112501056;
                const real_t tmp_kernel_op_17 = -jac_affine_inv_0_0_BLUE_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_1_BLUE_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_2_BLUE_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_3*0.041666666666666657;
                const real_t tmp_kernel_op_19 = tmp_kernel_op_18*0.5854101966249684;
                const real_t tmp_kernel_op_22 = -jac_affine_inv_1_0_BLUE_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_1_BLUE_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_2_BLUE_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_21;
                const real_t tmp_kernel_op_25 = -jac_affine_inv_1_0_BLUE_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_1_BLUE_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_2_BLUE_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_24;
                const real_t tmp_kernel_op_28 = -jac_affine_inv_1_0_BLUE_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_1_BLUE_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_2_BLUE_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_27;
                const real_t tmp_kernel_op_31 = -jac_affine_inv_1_0_BLUE_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_1_BLUE_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_2_BLUE_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_30;
                const real_t tmp_kernel_op_34 = -jac_affine_inv_2_0_BLUE_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_1_BLUE_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_2_BLUE_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_33;
                const real_t tmp_kernel_op_37 = -jac_affine_inv_2_0_BLUE_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_1_BLUE_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_2_BLUE_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_36;
                const real_t tmp_kernel_op_40 = -jac_affine_inv_2_0_BLUE_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_1_BLUE_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_2_BLUE_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_39;
                const real_t tmp_kernel_op_43 = -jac_affine_inv_2_0_BLUE_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_1_BLUE_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_2_BLUE_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_50 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_144 + tmp_moved_constant_145) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_146 + tmp_moved_constant_147) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_148 + tmp_moved_constant_149);
                const real_t tmp_kernel_op_57 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_150 + tmp_moved_constant_151) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_152 + tmp_moved_constant_153) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_154 + tmp_moved_constant_155);
                const real_t tmp_kernel_op_64 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_156 + tmp_moved_constant_157) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_158 + tmp_moved_constant_159) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_160 + tmp_moved_constant_161);
                const real_t tmp_kernel_op_71 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_162 + tmp_moved_constant_163) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_164 + tmp_moved_constant_165) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_166 + tmp_moved_constant_167);
                const real_t tmp_kernel_op_78 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_168 + tmp_moved_constant_169) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_170 + tmp_moved_constant_171) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_172 + tmp_moved_constant_173);
                const real_t tmp_kernel_op_85 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_174 + tmp_moved_constant_175) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_176 + tmp_moved_constant_177) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_178 + tmp_moved_constant_179);
                const real_t tmp_kernel_op_92 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_180 + tmp_moved_constant_181) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_182 + tmp_moved_constant_183) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_184 + tmp_moved_constant_185);
                const real_t tmp_kernel_op_99 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_186 + tmp_moved_constant_187) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_188 + tmp_moved_constant_189) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_190 + tmp_moved_constant_191);
                const real_t tmp_kernel_op_106 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_192 + tmp_moved_constant_193) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_194 + tmp_moved_constant_195) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_196 + tmp_moved_constant_197);
                const real_t tmp_kernel_op_113 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_198 + tmp_moved_constant_199) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_200 + tmp_moved_constant_201) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_202 + tmp_moved_constant_203);
                const real_t tmp_kernel_op_120 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_204 + tmp_moved_constant_205) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_206 + tmp_moved_constant_207) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_208 + tmp_moved_constant_209);
                const real_t tmp_kernel_op_127 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_210 + tmp_moved_constant_211) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_212 + tmp_moved_constant_213) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_214 + tmp_moved_constant_215);
                const real_t tmp_kernel_op_130 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_129 - tmp_moved_constant_144 - tmp_moved_constant_168) - jac_blending_inv_1_2_q_0*(jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_129 - tmp_moved_constant_146 - tmp_moved_constant_170) - jac_blending_inv_2_2_q_0*(jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_129 - tmp_moved_constant_148 - tmp_moved_constant_172);
                const real_t tmp_kernel_op_133 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_132 - tmp_moved_constant_150 - tmp_moved_constant_174) - jac_blending_inv_1_2_q_1*(jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_132 - tmp_moved_constant_152 - tmp_moved_constant_176) - jac_blending_inv_2_2_q_1*(jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_132 - tmp_moved_constant_154 - tmp_moved_constant_178);
                const real_t tmp_kernel_op_136 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_135 - tmp_moved_constant_156 - tmp_moved_constant_180) - jac_blending_inv_1_2_q_2*(jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_135 - tmp_moved_constant_158 - tmp_moved_constant_182) - jac_blending_inv_2_2_q_2*(jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_135 - tmp_moved_constant_160 - tmp_moved_constant_184);
                const real_t tmp_kernel_op_139 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_138 - tmp_moved_constant_162 - tmp_moved_constant_186) - jac_blending_inv_1_2_q_3*(jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_138 - tmp_moved_constant_164 - tmp_moved_constant_188) - jac_blending_inv_2_2_q_3*(jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_138 - tmp_moved_constant_166 - tmp_moved_constant_190);
                const real_t tmp_kernel_op_142 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_141 - tmp_moved_constant_145 - tmp_moved_constant_192) - jac_blending_inv_1_2_q_0*(jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_141 - tmp_moved_constant_147 - tmp_moved_constant_194) - jac_blending_inv_2_2_q_0*(jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_141 - tmp_moved_constant_149 - tmp_moved_constant_196);
                const real_t tmp_kernel_op_145 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_144 - tmp_moved_constant_151 - tmp_moved_constant_198) - jac_blending_inv_1_2_q_1*(jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_144 - tmp_moved_constant_153 - tmp_moved_constant_200) - jac_blending_inv_2_2_q_1*(jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_144 - tmp_moved_constant_155 - tmp_moved_constant_202);
                const real_t tmp_kernel_op_148 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_147 - tmp_moved_constant_157 - tmp_moved_constant_204) - jac_blending_inv_1_2_q_2*(jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_147 - tmp_moved_constant_159 - tmp_moved_constant_206) - jac_blending_inv_2_2_q_2*(jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_147 - tmp_moved_constant_161 - tmp_moved_constant_208);
                const real_t tmp_kernel_op_151 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_150 - tmp_moved_constant_163 - tmp_moved_constant_210) - jac_blending_inv_1_2_q_3*(jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_150 - tmp_moved_constant_165 - tmp_moved_constant_212) - jac_blending_inv_2_2_q_3*(jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_150 - tmp_moved_constant_167 - tmp_moved_constant_214);
                const real_t tmp_kernel_op_153 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_152 - tmp_moved_constant_169 - tmp_moved_constant_193) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_152 - tmp_moved_constant_171 - tmp_moved_constant_195) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_152 - tmp_moved_constant_173 - tmp_moved_constant_197);
                const real_t tmp_kernel_op_155 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_154 - tmp_moved_constant_175 - tmp_moved_constant_199) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_154 - tmp_moved_constant_177 - tmp_moved_constant_201) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_154 - tmp_moved_constant_179 - tmp_moved_constant_203);
                const real_t tmp_kernel_op_157 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_156 - tmp_moved_constant_181 - tmp_moved_constant_205) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_156 - tmp_moved_constant_183 - tmp_moved_constant_207) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_156 - tmp_moved_constant_185 - tmp_moved_constant_209);
                const real_t tmp_kernel_op_159 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_158 - tmp_moved_constant_187 - tmp_moved_constant_211) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_158 - tmp_moved_constant_189 - tmp_moved_constant_213) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_158 - tmp_moved_constant_191 - tmp_moved_constant_215);
                const real_t tmp_kernel_op_161 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_160) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_160) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_160);
                const real_t tmp_kernel_op_163 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_162) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_162) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_162);
                const real_t tmp_kernel_op_165 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_164) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_164) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_164);
                const real_t tmp_kernel_op_167 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_166) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_166) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_166);
                const real_t tmp_kernel_op_168 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_169 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_170 = tmp_kernel_op_13*0.5854101966249684;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_173 = tmp_kernel_op_8*0.5854101966249684;
                const real_t tmp_kernel_op_174 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_175 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_3*0.5854101966249684;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_18*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_14*tmp_kernel_op_165 + tmp_kernel_op_161*tmp_kernel_op_4 + tmp_kernel_op_163*tmp_kernel_op_9 + tmp_kernel_op_167*tmp_kernel_op_19) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_14 + tmp_kernel_op_17*tmp_kernel_op_19 + tmp_kernel_op_2*tmp_kernel_op_4 + tmp_kernel_op_7*tmp_kernel_op_9) + src_dof_2*(tmp_kernel_op_14*tmp_kernel_op_28 + tmp_kernel_op_19*tmp_kernel_op_31 + tmp_kernel_op_22*tmp_kernel_op_4 + tmp_kernel_op_25*tmp_kernel_op_9) + src_dof_3*(tmp_kernel_op_14*tmp_kernel_op_40 + tmp_kernel_op_19*tmp_kernel_op_43 + tmp_kernel_op_34*tmp_kernel_op_4 + tmp_kernel_op_37*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_14*tmp_kernel_op_64 + tmp_kernel_op_19*tmp_kernel_op_71 + tmp_kernel_op_4*tmp_kernel_op_50 + tmp_kernel_op_57*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_14*tmp_kernel_op_92 + tmp_kernel_op_19*tmp_kernel_op_99 + tmp_kernel_op_4*tmp_kernel_op_78 + tmp_kernel_op_85*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_4 + tmp_kernel_op_113*tmp_kernel_op_9 + tmp_kernel_op_120*tmp_kernel_op_14 + tmp_kernel_op_127*tmp_kernel_op_19) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_4 + tmp_kernel_op_133*tmp_kernel_op_9 + tmp_kernel_op_136*tmp_kernel_op_14 + tmp_kernel_op_139*tmp_kernel_op_19) + src_dof_8*(tmp_kernel_op_14*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_4 + tmp_kernel_op_145*tmp_kernel_op_9 + tmp_kernel_op_151*tmp_kernel_op_19) + src_dof_9*(tmp_kernel_op_14*tmp_kernel_op_157 + tmp_kernel_op_153*tmp_kernel_op_4 + tmp_kernel_op_155*tmp_kernel_op_9 + tmp_kernel_op_159*tmp_kernel_op_19);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_168 + tmp_kernel_op_163*tmp_kernel_op_169 + tmp_kernel_op_165*tmp_kernel_op_170 + tmp_kernel_op_167*tmp_kernel_op_171) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_170 + tmp_kernel_op_168*tmp_kernel_op_2 + tmp_kernel_op_169*tmp_kernel_op_7 + tmp_kernel_op_17*tmp_kernel_op_171) + src_dof_2*(tmp_kernel_op_168*tmp_kernel_op_22 + tmp_kernel_op_169*tmp_kernel_op_25 + tmp_kernel_op_170*tmp_kernel_op_28 + tmp_kernel_op_171*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_168*tmp_kernel_op_34 + tmp_kernel_op_169*tmp_kernel_op_37 + tmp_kernel_op_170*tmp_kernel_op_40 + tmp_kernel_op_171*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_168*tmp_kernel_op_50 + tmp_kernel_op_169*tmp_kernel_op_57 + tmp_kernel_op_170*tmp_kernel_op_64 + tmp_kernel_op_171*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_168*tmp_kernel_op_78 + tmp_kernel_op_169*tmp_kernel_op_85 + tmp_kernel_op_170*tmp_kernel_op_92 + tmp_kernel_op_171*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_168 + tmp_kernel_op_113*tmp_kernel_op_169 + tmp_kernel_op_120*tmp_kernel_op_170 + tmp_kernel_op_127*tmp_kernel_op_171) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_168 + tmp_kernel_op_133*tmp_kernel_op_169 + tmp_kernel_op_136*tmp_kernel_op_170 + tmp_kernel_op_139*tmp_kernel_op_171) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_168 + tmp_kernel_op_145*tmp_kernel_op_169 + tmp_kernel_op_148*tmp_kernel_op_170 + tmp_kernel_op_151*tmp_kernel_op_171) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_168 + tmp_kernel_op_155*tmp_kernel_op_169 + tmp_kernel_op_157*tmp_kernel_op_170 + tmp_kernel_op_159*tmp_kernel_op_171);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_172 + tmp_kernel_op_163*tmp_kernel_op_173 + tmp_kernel_op_165*tmp_kernel_op_174 + tmp_kernel_op_167*tmp_kernel_op_175) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_174 + tmp_kernel_op_17*tmp_kernel_op_175 + tmp_kernel_op_172*tmp_kernel_op_2 + tmp_kernel_op_173*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_172*tmp_kernel_op_22 + tmp_kernel_op_173*tmp_kernel_op_25 + tmp_kernel_op_174*tmp_kernel_op_28 + tmp_kernel_op_175*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_172*tmp_kernel_op_34 + tmp_kernel_op_173*tmp_kernel_op_37 + tmp_kernel_op_174*tmp_kernel_op_40 + tmp_kernel_op_175*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_172*tmp_kernel_op_50 + tmp_kernel_op_173*tmp_kernel_op_57 + tmp_kernel_op_174*tmp_kernel_op_64 + tmp_kernel_op_175*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_172*tmp_kernel_op_78 + tmp_kernel_op_173*tmp_kernel_op_85 + tmp_kernel_op_174*tmp_kernel_op_92 + tmp_kernel_op_175*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_172 + tmp_kernel_op_113*tmp_kernel_op_173 + tmp_kernel_op_120*tmp_kernel_op_174 + tmp_kernel_op_127*tmp_kernel_op_175) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_172 + tmp_kernel_op_133*tmp_kernel_op_173 + tmp_kernel_op_136*tmp_kernel_op_174 + tmp_kernel_op_139*tmp_kernel_op_175) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_172 + tmp_kernel_op_145*tmp_kernel_op_173 + tmp_kernel_op_148*tmp_kernel_op_174 + tmp_kernel_op_151*tmp_kernel_op_175) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_172 + tmp_kernel_op_155*tmp_kernel_op_173 + tmp_kernel_op_157*tmp_kernel_op_174 + tmp_kernel_op_159*tmp_kernel_op_175);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_176 + tmp_kernel_op_163*tmp_kernel_op_177 + tmp_kernel_op_165*tmp_kernel_op_178 + tmp_kernel_op_167*tmp_kernel_op_179) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_178 + tmp_kernel_op_17*tmp_kernel_op_179 + tmp_kernel_op_176*tmp_kernel_op_2 + tmp_kernel_op_177*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_176*tmp_kernel_op_22 + tmp_kernel_op_177*tmp_kernel_op_25 + tmp_kernel_op_178*tmp_kernel_op_28 + tmp_kernel_op_179*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_176*tmp_kernel_op_34 + tmp_kernel_op_177*tmp_kernel_op_37 + tmp_kernel_op_178*tmp_kernel_op_40 + tmp_kernel_op_179*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_176*tmp_kernel_op_50 + tmp_kernel_op_177*tmp_kernel_op_57 + tmp_kernel_op_178*tmp_kernel_op_64 + tmp_kernel_op_179*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_176*tmp_kernel_op_78 + tmp_kernel_op_177*tmp_kernel_op_85 + tmp_kernel_op_178*tmp_kernel_op_92 + tmp_kernel_op_179*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_176 + tmp_kernel_op_113*tmp_kernel_op_177 + tmp_kernel_op_120*tmp_kernel_op_178 + tmp_kernel_op_127*tmp_kernel_op_179) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_176 + tmp_kernel_op_133*tmp_kernel_op_177 + tmp_kernel_op_136*tmp_kernel_op_178 + tmp_kernel_op_139*tmp_kernel_op_179) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_176 + tmp_kernel_op_145*tmp_kernel_op_177 + tmp_kernel_op_148*tmp_kernel_op_178 + tmp_kernel_op_151*tmp_kernel_op_179) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_176 + tmp_kernel_op_155*tmp_kernel_op_177 + tmp_kernel_op_157*tmp_kernel_op_178 + tmp_kernel_op_159*tmp_kernel_op_179);
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const real_t tmp_moved_constant_216 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_217 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_218 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_219 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_220 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_221 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_222 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_223 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_224 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_225 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_226 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_227 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_228 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_229 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_230 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_231 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_232 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_233 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_234 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_235 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_236 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_237 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_238 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_239 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_240 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_241 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_242 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_243 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_244 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_245 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_246 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_247 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_248 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_249 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_250 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_251 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_252 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_253 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_254 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_255 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_256 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_257 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_258 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_259 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_260 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_261 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_262 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_263 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_264 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_265 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_266 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_267 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_268 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_269 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_270 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_271 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_272 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_273 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_274 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_275 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_276 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_277 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_278 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_279 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_280 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_281 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_282 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_283 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_284 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_285 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_286 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_287 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_15;
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_3,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),jac_blending_2_1_q_3));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3)));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_2,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),jac_blending_2_1_q_2));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2)));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_1,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),jac_blending_2_1_q_1));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1)));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_0,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),jac_blending_2_1_q_0));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0)));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)));
                const __m256d tmp_kernel_op_3 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d tmp_kernel_op_4 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d tmp_kernel_op_9 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_12 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)));
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)));
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)));
                const __m256d tmp_kernel_op_25 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)));
                const __m256d tmp_kernel_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)));
                const __m256d tmp_kernel_op_31 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_34 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)));
                const __m256d tmp_kernel_op_37 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216),_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218),_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220),_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222),_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224),_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226),_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228),_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230),_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232),_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234),_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236),_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238),_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242),_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244),_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248),_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250),_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254),_mm256_set_pd(tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256),_mm256_set_pd(tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258),_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260),_mm256_set_pd(tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262),_mm256_set_pd(tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264),_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266),_mm256_set_pd(tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268),_mm256_set_pd(tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270),_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272),_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274),_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276),_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278),_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280),_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282),_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284),_mm256_set_pd(tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286),_mm256_set_pd(tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_165 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_167 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_175 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_19))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_14),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_2,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_148),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_165),_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_28),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_31)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_25,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_40),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_34,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_37,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_64),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_99)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_78)),_mm256_mul_pd(tmp_kernel_op_85,tmp_kernel_op_9))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_171))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_170),_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_7)),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_99))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_175))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_174),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_175)),_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_99))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_179))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_178),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_179)),_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_99))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5854101966249684 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5854101966249684 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5854101966249684 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.5854101966249684 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.5854101966249684 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.5854101966249684 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.5854101966249684;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.5854101966249684;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.5854101966249684;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t tmp_blending_op_58 = jac_blending_0_2_q_3*jac_blending_1_1_q_3;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_55 = jac_blending_0_1_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_59 = jac_blending_0_2_q_3*jac_blending_1_0_q_3*jac_blending_2_1_q_3 + jac_blending_2_0_q_3*tmp_blending_op_55 - jac_blending_2_0_q_3*tmp_blending_op_58 - jac_blending_2_1_q_3*tmp_blending_op_56 + jac_blending_2_2_q_3*tmp_blending_op_54 - jac_blending_2_2_q_3*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_60*(jac_blending_0_2_q_3*jac_blending_1_0_q_3 - tmp_blending_op_56);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t tmp_blending_op_85 = jac_blending_0_2_q_2*jac_blending_1_1_q_2;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_82 = jac_blending_0_1_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_86 = jac_blending_0_2_q_2*jac_blending_1_0_q_2*jac_blending_2_1_q_2 + jac_blending_2_0_q_2*tmp_blending_op_82 - jac_blending_2_0_q_2*tmp_blending_op_85 - jac_blending_2_1_q_2*tmp_blending_op_83 + jac_blending_2_2_q_2*tmp_blending_op_81 - jac_blending_2_2_q_2*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_87*(jac_blending_0_2_q_2*jac_blending_1_0_q_2 - tmp_blending_op_83);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t tmp_blending_op_111 = jac_blending_0_2_q_1*jac_blending_1_1_q_1;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_108 = jac_blending_0_1_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_112 = jac_blending_0_2_q_1*jac_blending_1_0_q_1*jac_blending_2_1_q_1 + jac_blending_2_0_q_1*tmp_blending_op_108 - jac_blending_2_0_q_1*tmp_blending_op_111 - jac_blending_2_1_q_1*tmp_blending_op_109 + jac_blending_2_2_q_1*tmp_blending_op_107 - jac_blending_2_2_q_1*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_113*(jac_blending_0_2_q_1*jac_blending_1_0_q_1 - tmp_blending_op_109);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t tmp_blending_op_137 = jac_blending_0_2_q_0*jac_blending_1_1_q_0;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_134 = jac_blending_0_1_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_138 = jac_blending_0_2_q_0*jac_blending_1_0_q_0*jac_blending_2_1_q_0 + jac_blending_2_0_q_0*tmp_blending_op_134 - jac_blending_2_0_q_0*tmp_blending_op_137 - jac_blending_2_1_q_0*tmp_blending_op_135 + jac_blending_2_2_q_0*tmp_blending_op_133 - jac_blending_2_2_q_0*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_139*(jac_blending_0_2_q_0*jac_blending_1_0_q_0 - tmp_blending_op_135);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_2 = -jac_affine_inv_0_0_GREEN_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_1_GREEN_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_2_GREEN_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_1;
                const real_t tmp_kernel_op_3 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_0*0.041666666666666657;
                const real_t tmp_kernel_op_4 = tmp_kernel_op_3*0.13819660112501053;
                const real_t tmp_kernel_op_7 = -jac_affine_inv_0_0_GREEN_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_1_GREEN_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_2_GREEN_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_6;
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_1*0.041666666666666657;
                const real_t tmp_kernel_op_9 = tmp_kernel_op_8*0.13819660112501056;
                const real_t tmp_kernel_op_12 = -jac_affine_inv_0_0_GREEN_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_1_GREEN_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_2_GREEN_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_11;
                const real_t tmp_kernel_op_13 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_2*0.041666666666666657;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_13*0.13819660112501056;
                const real_t tmp_kernel_op_17 = -jac_affine_inv_0_0_GREEN_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_1_GREEN_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_2_GREEN_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_3*0.041666666666666657;
                const real_t tmp_kernel_op_19 = tmp_kernel_op_18*0.5854101966249684;
                const real_t tmp_kernel_op_22 = -jac_affine_inv_1_0_GREEN_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_1_GREEN_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_2_GREEN_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_21;
                const real_t tmp_kernel_op_25 = -jac_affine_inv_1_0_GREEN_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_1_GREEN_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_2_GREEN_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_24;
                const real_t tmp_kernel_op_28 = -jac_affine_inv_1_0_GREEN_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_1_GREEN_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_2_GREEN_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_27;
                const real_t tmp_kernel_op_31 = -jac_affine_inv_1_0_GREEN_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_1_GREEN_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_2_GREEN_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_30;
                const real_t tmp_kernel_op_34 = -jac_affine_inv_2_0_GREEN_UP*jac_blending_inv_0_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_1_GREEN_UP*jac_blending_inv_1_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_2_GREEN_UP*jac_blending_inv_2_2_q_0*tmp_kernel_op_33;
                const real_t tmp_kernel_op_37 = -jac_affine_inv_2_0_GREEN_UP*jac_blending_inv_0_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_1_GREEN_UP*jac_blending_inv_1_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_2_GREEN_UP*jac_blending_inv_2_2_q_1*tmp_kernel_op_36;
                const real_t tmp_kernel_op_40 = -jac_affine_inv_2_0_GREEN_UP*jac_blending_inv_0_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_1_GREEN_UP*jac_blending_inv_1_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_2_GREEN_UP*jac_blending_inv_2_2_q_2*tmp_kernel_op_39;
                const real_t tmp_kernel_op_43 = -jac_affine_inv_2_0_GREEN_UP*jac_blending_inv_0_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_1_GREEN_UP*jac_blending_inv_1_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_2_GREEN_UP*jac_blending_inv_2_2_q_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_50 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_216 + tmp_moved_constant_217) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_218 + tmp_moved_constant_219) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_220 + tmp_moved_constant_221);
                const real_t tmp_kernel_op_57 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_222 + tmp_moved_constant_223) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_224 + tmp_moved_constant_225) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_226 + tmp_moved_constant_227);
                const real_t tmp_kernel_op_64 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_228 + tmp_moved_constant_229) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_230 + tmp_moved_constant_231) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_232 + tmp_moved_constant_233);
                const real_t tmp_kernel_op_71 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_234 + tmp_moved_constant_235) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_236 + tmp_moved_constant_237) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_238 + tmp_moved_constant_239);
                const real_t tmp_kernel_op_78 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_240 + tmp_moved_constant_241) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_242 + tmp_moved_constant_243) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_244 + tmp_moved_constant_245);
                const real_t tmp_kernel_op_85 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_246 + tmp_moved_constant_247) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_248 + tmp_moved_constant_249) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_250 + tmp_moved_constant_251);
                const real_t tmp_kernel_op_92 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_252 + tmp_moved_constant_253) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_254 + tmp_moved_constant_255) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_256 + tmp_moved_constant_257);
                const real_t tmp_kernel_op_99 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_258 + tmp_moved_constant_259) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_260 + tmp_moved_constant_261) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_262 + tmp_moved_constant_263);
                const real_t tmp_kernel_op_106 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_264 + tmp_moved_constant_265) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_266 + tmp_moved_constant_267) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_268 + tmp_moved_constant_269);
                const real_t tmp_kernel_op_113 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_270 + tmp_moved_constant_271) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_272 + tmp_moved_constant_273) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_274 + tmp_moved_constant_275);
                const real_t tmp_kernel_op_120 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_276 + tmp_moved_constant_277) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_278 + tmp_moved_constant_279) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_280 + tmp_moved_constant_281);
                const real_t tmp_kernel_op_127 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_282 + tmp_moved_constant_283) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_284 + tmp_moved_constant_285) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_286 + tmp_moved_constant_287);
                const real_t tmp_kernel_op_130 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_129 - tmp_moved_constant_216 - tmp_moved_constant_240) - jac_blending_inv_1_2_q_0*(jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_129 - tmp_moved_constant_218 - tmp_moved_constant_242) - jac_blending_inv_2_2_q_0*(jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_129 - tmp_moved_constant_220 - tmp_moved_constant_244);
                const real_t tmp_kernel_op_133 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_132 - tmp_moved_constant_222 - tmp_moved_constant_246) - jac_blending_inv_1_2_q_1*(jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_132 - tmp_moved_constant_224 - tmp_moved_constant_248) - jac_blending_inv_2_2_q_1*(jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_132 - tmp_moved_constant_226 - tmp_moved_constant_250);
                const real_t tmp_kernel_op_136 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_135 - tmp_moved_constant_228 - tmp_moved_constant_252) - jac_blending_inv_1_2_q_2*(jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_135 - tmp_moved_constant_230 - tmp_moved_constant_254) - jac_blending_inv_2_2_q_2*(jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_135 - tmp_moved_constant_232 - tmp_moved_constant_256);
                const real_t tmp_kernel_op_139 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_138 - tmp_moved_constant_234 - tmp_moved_constant_258) - jac_blending_inv_1_2_q_3*(jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_138 - tmp_moved_constant_236 - tmp_moved_constant_260) - jac_blending_inv_2_2_q_3*(jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_138 - tmp_moved_constant_238 - tmp_moved_constant_262);
                const real_t tmp_kernel_op_142 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_141 - tmp_moved_constant_217 - tmp_moved_constant_264) - jac_blending_inv_1_2_q_0*(jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_141 - tmp_moved_constant_219 - tmp_moved_constant_266) - jac_blending_inv_2_2_q_0*(jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_141 - tmp_moved_constant_221 - tmp_moved_constant_268);
                const real_t tmp_kernel_op_145 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_144 - tmp_moved_constant_223 - tmp_moved_constant_270) - jac_blending_inv_1_2_q_1*(jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_144 - tmp_moved_constant_225 - tmp_moved_constant_272) - jac_blending_inv_2_2_q_1*(jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_144 - tmp_moved_constant_227 - tmp_moved_constant_274);
                const real_t tmp_kernel_op_148 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_147 - tmp_moved_constant_229 - tmp_moved_constant_276) - jac_blending_inv_1_2_q_2*(jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_147 - tmp_moved_constant_231 - tmp_moved_constant_278) - jac_blending_inv_2_2_q_2*(jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_147 - tmp_moved_constant_233 - tmp_moved_constant_280);
                const real_t tmp_kernel_op_151 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_150 - tmp_moved_constant_235 - tmp_moved_constant_282) - jac_blending_inv_1_2_q_3*(jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_150 - tmp_moved_constant_237 - tmp_moved_constant_284) - jac_blending_inv_2_2_q_3*(jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_150 - tmp_moved_constant_239 - tmp_moved_constant_286);
                const real_t tmp_kernel_op_153 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_152 - tmp_moved_constant_241 - tmp_moved_constant_265) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_152 - tmp_moved_constant_243 - tmp_moved_constant_267) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_152 - tmp_moved_constant_245 - tmp_moved_constant_269);
                const real_t tmp_kernel_op_155 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_154 - tmp_moved_constant_247 - tmp_moved_constant_271) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_154 - tmp_moved_constant_249 - tmp_moved_constant_273) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_154 - tmp_moved_constant_251 - tmp_moved_constant_275);
                const real_t tmp_kernel_op_157 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_156 - tmp_moved_constant_253 - tmp_moved_constant_277) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_156 - tmp_moved_constant_255 - tmp_moved_constant_279) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_156 - tmp_moved_constant_257 - tmp_moved_constant_281);
                const real_t tmp_kernel_op_159 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_158 - tmp_moved_constant_259 - tmp_moved_constant_283) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_158 - tmp_moved_constant_261 - tmp_moved_constant_285) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_158 - tmp_moved_constant_263 - tmp_moved_constant_287);
                const real_t tmp_kernel_op_161 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_160 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_160 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_160) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_160 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_160 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_160) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_160 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_160 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_160);
                const real_t tmp_kernel_op_163 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_162 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_162 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_162) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_162 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_162 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_162) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_162 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_162 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_162);
                const real_t tmp_kernel_op_165 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_164 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_164 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_164) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_164 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_164 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_164) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_164 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_164 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_164);
                const real_t tmp_kernel_op_167 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_166 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_166 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_166) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_166 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_166 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_166) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_166 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_166 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_166);
                const real_t tmp_kernel_op_168 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_169 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_170 = tmp_kernel_op_13*0.5854101966249684;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_173 = tmp_kernel_op_8*0.5854101966249684;
                const real_t tmp_kernel_op_174 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_175 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_3*0.5854101966249684;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_18*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_14*tmp_kernel_op_165 + tmp_kernel_op_161*tmp_kernel_op_4 + tmp_kernel_op_163*tmp_kernel_op_9 + tmp_kernel_op_167*tmp_kernel_op_19) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_14 + tmp_kernel_op_17*tmp_kernel_op_19 + tmp_kernel_op_2*tmp_kernel_op_4 + tmp_kernel_op_7*tmp_kernel_op_9) + src_dof_2*(tmp_kernel_op_14*tmp_kernel_op_28 + tmp_kernel_op_19*tmp_kernel_op_31 + tmp_kernel_op_22*tmp_kernel_op_4 + tmp_kernel_op_25*tmp_kernel_op_9) + src_dof_3*(tmp_kernel_op_14*tmp_kernel_op_40 + tmp_kernel_op_19*tmp_kernel_op_43 + tmp_kernel_op_34*tmp_kernel_op_4 + tmp_kernel_op_37*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_14*tmp_kernel_op_64 + tmp_kernel_op_19*tmp_kernel_op_71 + tmp_kernel_op_4*tmp_kernel_op_50 + tmp_kernel_op_57*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_14*tmp_kernel_op_92 + tmp_kernel_op_19*tmp_kernel_op_99 + tmp_kernel_op_4*tmp_kernel_op_78 + tmp_kernel_op_85*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_4 + tmp_kernel_op_113*tmp_kernel_op_9 + tmp_kernel_op_120*tmp_kernel_op_14 + tmp_kernel_op_127*tmp_kernel_op_19) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_4 + tmp_kernel_op_133*tmp_kernel_op_9 + tmp_kernel_op_136*tmp_kernel_op_14 + tmp_kernel_op_139*tmp_kernel_op_19) + src_dof_8*(tmp_kernel_op_14*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_4 + tmp_kernel_op_145*tmp_kernel_op_9 + tmp_kernel_op_151*tmp_kernel_op_19) + src_dof_9*(tmp_kernel_op_14*tmp_kernel_op_157 + tmp_kernel_op_153*tmp_kernel_op_4 + tmp_kernel_op_155*tmp_kernel_op_9 + tmp_kernel_op_159*tmp_kernel_op_19);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_168 + tmp_kernel_op_163*tmp_kernel_op_169 + tmp_kernel_op_165*tmp_kernel_op_170 + tmp_kernel_op_167*tmp_kernel_op_171) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_170 + tmp_kernel_op_168*tmp_kernel_op_2 + tmp_kernel_op_169*tmp_kernel_op_7 + tmp_kernel_op_17*tmp_kernel_op_171) + src_dof_2*(tmp_kernel_op_168*tmp_kernel_op_22 + tmp_kernel_op_169*tmp_kernel_op_25 + tmp_kernel_op_170*tmp_kernel_op_28 + tmp_kernel_op_171*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_168*tmp_kernel_op_34 + tmp_kernel_op_169*tmp_kernel_op_37 + tmp_kernel_op_170*tmp_kernel_op_40 + tmp_kernel_op_171*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_168*tmp_kernel_op_50 + tmp_kernel_op_169*tmp_kernel_op_57 + tmp_kernel_op_170*tmp_kernel_op_64 + tmp_kernel_op_171*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_168*tmp_kernel_op_78 + tmp_kernel_op_169*tmp_kernel_op_85 + tmp_kernel_op_170*tmp_kernel_op_92 + tmp_kernel_op_171*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_168 + tmp_kernel_op_113*tmp_kernel_op_169 + tmp_kernel_op_120*tmp_kernel_op_170 + tmp_kernel_op_127*tmp_kernel_op_171) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_168 + tmp_kernel_op_133*tmp_kernel_op_169 + tmp_kernel_op_136*tmp_kernel_op_170 + tmp_kernel_op_139*tmp_kernel_op_171) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_168 + tmp_kernel_op_145*tmp_kernel_op_169 + tmp_kernel_op_148*tmp_kernel_op_170 + tmp_kernel_op_151*tmp_kernel_op_171) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_168 + tmp_kernel_op_155*tmp_kernel_op_169 + tmp_kernel_op_157*tmp_kernel_op_170 + tmp_kernel_op_159*tmp_kernel_op_171);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_172 + tmp_kernel_op_163*tmp_kernel_op_173 + tmp_kernel_op_165*tmp_kernel_op_174 + tmp_kernel_op_167*tmp_kernel_op_175) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_174 + tmp_kernel_op_17*tmp_kernel_op_175 + tmp_kernel_op_172*tmp_kernel_op_2 + tmp_kernel_op_173*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_172*tmp_kernel_op_22 + tmp_kernel_op_173*tmp_kernel_op_25 + tmp_kernel_op_174*tmp_kernel_op_28 + tmp_kernel_op_175*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_172*tmp_kernel_op_34 + tmp_kernel_op_173*tmp_kernel_op_37 + tmp_kernel_op_174*tmp_kernel_op_40 + tmp_kernel_op_175*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_172*tmp_kernel_op_50 + tmp_kernel_op_173*tmp_kernel_op_57 + tmp_kernel_op_174*tmp_kernel_op_64 + tmp_kernel_op_175*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_172*tmp_kernel_op_78 + tmp_kernel_op_173*tmp_kernel_op_85 + tmp_kernel_op_174*tmp_kernel_op_92 + tmp_kernel_op_175*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_172 + tmp_kernel_op_113*tmp_kernel_op_173 + tmp_kernel_op_120*tmp_kernel_op_174 + tmp_kernel_op_127*tmp_kernel_op_175) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_172 + tmp_kernel_op_133*tmp_kernel_op_173 + tmp_kernel_op_136*tmp_kernel_op_174 + tmp_kernel_op_139*tmp_kernel_op_175) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_172 + tmp_kernel_op_145*tmp_kernel_op_173 + tmp_kernel_op_148*tmp_kernel_op_174 + tmp_kernel_op_151*tmp_kernel_op_175) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_172 + tmp_kernel_op_155*tmp_kernel_op_173 + tmp_kernel_op_157*tmp_kernel_op_174 + tmp_kernel_op_159*tmp_kernel_op_175);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_176 + tmp_kernel_op_163*tmp_kernel_op_177 + tmp_kernel_op_165*tmp_kernel_op_178 + tmp_kernel_op_167*tmp_kernel_op_179) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_178 + tmp_kernel_op_17*tmp_kernel_op_179 + tmp_kernel_op_176*tmp_kernel_op_2 + tmp_kernel_op_177*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_176*tmp_kernel_op_22 + tmp_kernel_op_177*tmp_kernel_op_25 + tmp_kernel_op_178*tmp_kernel_op_28 + tmp_kernel_op_179*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_176*tmp_kernel_op_34 + tmp_kernel_op_177*tmp_kernel_op_37 + tmp_kernel_op_178*tmp_kernel_op_40 + tmp_kernel_op_179*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_176*tmp_kernel_op_50 + tmp_kernel_op_177*tmp_kernel_op_57 + tmp_kernel_op_178*tmp_kernel_op_64 + tmp_kernel_op_179*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_176*tmp_kernel_op_78 + tmp_kernel_op_177*tmp_kernel_op_85 + tmp_kernel_op_178*tmp_kernel_op_92 + tmp_kernel_op_179*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_176 + tmp_kernel_op_113*tmp_kernel_op_177 + tmp_kernel_op_120*tmp_kernel_op_178 + tmp_kernel_op_127*tmp_kernel_op_179) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_176 + tmp_kernel_op_133*tmp_kernel_op_177 + tmp_kernel_op_136*tmp_kernel_op_178 + tmp_kernel_op_139*tmp_kernel_op_179) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_176 + tmp_kernel_op_145*tmp_kernel_op_177 + tmp_kernel_op_148*tmp_kernel_op_178 + tmp_kernel_op_151*tmp_kernel_op_179) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_176 + tmp_kernel_op_155*tmp_kernel_op_177 + tmp_kernel_op_157*tmp_kernel_op_178 + tmp_kernel_op_159*tmp_kernel_op_179);
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const real_t tmp_moved_constant_288 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_289 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_290 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_291 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_292 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_293 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_294 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_295 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_296 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_297 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_298 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_299 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_300 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_301 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_302 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_303 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_304 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_305 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_306 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_307 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_308 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_309 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_310 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_311 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_312 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_313 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_314 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_315 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_316 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_317 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_318 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_319 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_320 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_321 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_322 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_323 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_324 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_325 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_326 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_327 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_328 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_329 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_330 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_331 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_332 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_333 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_334 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_335 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_336 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_337 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_338 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_339 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_340 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_341 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_342 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_343 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_344 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_345 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_346 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_347 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_348 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_349 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_350 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_351 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_352 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_353 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_354 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_355 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_356 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_357 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_358 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_359 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_15;
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_3,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_3,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),jac_blending_2_1_q_3));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3)));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_2,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_2,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),jac_blending_2_1_q_2));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2)));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_1,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_1,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),jac_blending_2_1_q_1));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1)));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0_q_0,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_1_q_0,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),jac_blending_2_1_q_0));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0)));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)));
                const __m256d tmp_kernel_op_3 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d tmp_kernel_op_4 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d tmp_kernel_op_9 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_12 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)));
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)));
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21,tmp_kernel_op_21)));
                const __m256d tmp_kernel_op_25 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)));
                const __m256d tmp_kernel_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27)));
                const __m256d tmp_kernel_op_31 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_34 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)));
                const __m256d tmp_kernel_op_37 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288),_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290),_mm256_set_pd(tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294),_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296),_mm256_set_pd(tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306),_mm256_set_pd(tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308),_mm256_set_pd(tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310),_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_312,tmp_moved_constant_312,tmp_moved_constant_312,tmp_moved_constant_312),_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314),_mm256_set_pd(tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316),_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_318,tmp_moved_constant_318,tmp_moved_constant_318,tmp_moved_constant_318),_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320),_mm256_set_pd(tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322),_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_324,tmp_moved_constant_324,tmp_moved_constant_324,tmp_moved_constant_324),_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326),_mm256_set_pd(tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328),_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_330,tmp_moved_constant_330,tmp_moved_constant_330,tmp_moved_constant_330),_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332),_mm256_set_pd(tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334),_mm256_set_pd(tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336),_mm256_set_pd(tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338),_mm256_set_pd(tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340),_mm256_set_pd(tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342),_mm256_set_pd(tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344),_mm256_set_pd(tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346),_mm256_set_pd(tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348),_mm256_set_pd(tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350),_mm256_set_pd(tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352),_mm256_set_pd(tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354),_mm256_set_pd(tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356),_mm256_set_pd(tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358),_mm256_set_pd(tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_312,tmp_moved_constant_312,tmp_moved_constant_312,tmp_moved_constant_312))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_318,tmp_moved_constant_318,tmp_moved_constant_318,tmp_moved_constant_318))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132,tmp_kernel_op_132)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_324,tmp_moved_constant_324,tmp_moved_constant_324,tmp_moved_constant_324))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135,tmp_kernel_op_135)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_330,tmp_moved_constant_330,tmp_moved_constant_330,tmp_moved_constant_330))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138,tmp_kernel_op_138)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141,tmp_kernel_op_141)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144,tmp_kernel_op_144)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147,tmp_kernel_op_147)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150,tmp_kernel_op_150)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156,tmp_kernel_op_156)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_165 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_167 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166)))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_172 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_175 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_18,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_19))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_14),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_2,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_4),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_14)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_148),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_165),_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_9)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_28),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_31)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_25,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_40),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_43)),_mm256_mul_pd(tmp_kernel_op_34,tmp_kernel_op_4)),_mm256_mul_pd(tmp_kernel_op_37,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_64),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_9)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_92),_mm256_mul_pd(tmp_kernel_op_19,tmp_kernel_op_99)),_mm256_mul_pd(tmp_kernel_op_4,tmp_kernel_op_78)),_mm256_mul_pd(tmp_kernel_op_85,tmp_kernel_op_9))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_171))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_170),_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_7)),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_168),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_169)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_170)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_171)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_168,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_170,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_99))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_175))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_174),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_175)),_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_172),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_173)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_174)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_175)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_173,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_175,tmp_kernel_op_99))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_120,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_179))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_178),_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_179)),_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_2)),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_7)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_145,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_176),_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_177)),_mm256_mul_pd(tmp_kernel_op_165,tmp_kernel_op_178)),_mm256_mul_pd(tmp_kernel_op_167,tmp_kernel_op_179)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_22),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_28)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_31)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_34),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_37)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_40)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_43)))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_50),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_57)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_64)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_176,tmp_kernel_op_78),_mm256_mul_pd(tmp_kernel_op_177,tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_178,tmp_kernel_op_92)),_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_99))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5854101966249684 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5854101966249684 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5854101966249684 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.5854101966249684 + tmp_blending_op_2*0.1381966011250105;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.5854101966249684 + tmp_blending_op_27*0.1381966011250105;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.5854101966249684 + tmp_blending_op_32*0.1381966011250105;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.1381966011250105 + tmp_blending_op_1*0.1381966011250105 + tmp_blending_op_2*0.5854101966249684;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.1381966011250105 + tmp_blending_op_26*0.1381966011250105 + tmp_blending_op_27*0.5854101966249684;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.1381966011250105 + tmp_blending_op_31*0.1381966011250105 + tmp_blending_op_32*0.5854101966249684;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t tmp_blending_op_58 = jac_blending_0_2_q_3*jac_blending_1_1_q_3;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_55 = jac_blending_0_1_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_3*jac_blending_1_2_q_3;
                const real_t tmp_blending_op_59 = jac_blending_0_2_q_3*jac_blending_1_0_q_3*jac_blending_2_1_q_3 + jac_blending_2_0_q_3*tmp_blending_op_55 - jac_blending_2_0_q_3*tmp_blending_op_58 - jac_blending_2_1_q_3*tmp_blending_op_56 + jac_blending_2_2_q_3*tmp_blending_op_54 - jac_blending_2_2_q_3*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_60*(jac_blending_0_2_q_3*jac_blending_1_0_q_3 - tmp_blending_op_56);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t tmp_blending_op_85 = jac_blending_0_2_q_2*jac_blending_1_1_q_2;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_82 = jac_blending_0_1_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_2*jac_blending_1_2_q_2;
                const real_t tmp_blending_op_86 = jac_blending_0_2_q_2*jac_blending_1_0_q_2*jac_blending_2_1_q_2 + jac_blending_2_0_q_2*tmp_blending_op_82 - jac_blending_2_0_q_2*tmp_blending_op_85 - jac_blending_2_1_q_2*tmp_blending_op_83 + jac_blending_2_2_q_2*tmp_blending_op_81 - jac_blending_2_2_q_2*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_87*(jac_blending_0_2_q_2*jac_blending_1_0_q_2 - tmp_blending_op_83);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t tmp_blending_op_111 = jac_blending_0_2_q_1*jac_blending_1_1_q_1;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_108 = jac_blending_0_1_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_1*jac_blending_1_2_q_1;
                const real_t tmp_blending_op_112 = jac_blending_0_2_q_1*jac_blending_1_0_q_1*jac_blending_2_1_q_1 + jac_blending_2_0_q_1*tmp_blending_op_108 - jac_blending_2_0_q_1*tmp_blending_op_111 - jac_blending_2_1_q_1*tmp_blending_op_109 + jac_blending_2_2_q_1*tmp_blending_op_107 - jac_blending_2_2_q_1*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_113*(jac_blending_0_2_q_1*jac_blending_1_0_q_1 - tmp_blending_op_109);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t tmp_blending_op_137 = jac_blending_0_2_q_0*jac_blending_1_1_q_0;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_134 = jac_blending_0_1_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_0*jac_blending_1_2_q_0;
                const real_t tmp_blending_op_138 = jac_blending_0_2_q_0*jac_blending_1_0_q_0*jac_blending_2_1_q_0 + jac_blending_2_0_q_0*tmp_blending_op_134 - jac_blending_2_0_q_0*tmp_blending_op_137 - jac_blending_2_1_q_0*tmp_blending_op_135 + jac_blending_2_2_q_0*tmp_blending_op_133 - jac_blending_2_2_q_0*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_139*(jac_blending_0_2_q_0*jac_blending_1_0_q_0 - tmp_blending_op_135);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_2 = -jac_affine_inv_0_0_GREEN_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_1_GREEN_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_1 - jac_affine_inv_0_2_GREEN_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_1;
                const real_t tmp_kernel_op_3 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_0*0.041666666666666657;
                const real_t tmp_kernel_op_4 = tmp_kernel_op_3*0.13819660112501053;
                const real_t tmp_kernel_op_7 = -jac_affine_inv_0_0_GREEN_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_1_GREEN_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_6 - jac_affine_inv_0_2_GREEN_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_6;
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_1*0.041666666666666657;
                const real_t tmp_kernel_op_9 = tmp_kernel_op_8*0.13819660112501056;
                const real_t tmp_kernel_op_12 = -jac_affine_inv_0_0_GREEN_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_1_GREEN_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_11 - jac_affine_inv_0_2_GREEN_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_11;
                const real_t tmp_kernel_op_13 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_2*0.041666666666666657;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_13*0.13819660112501056;
                const real_t tmp_kernel_op_17 = -jac_affine_inv_0_0_GREEN_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_1_GREEN_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_16 - jac_affine_inv_0_2_GREEN_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_3*0.041666666666666657;
                const real_t tmp_kernel_op_19 = tmp_kernel_op_18*0.5854101966249684;
                const real_t tmp_kernel_op_22 = -jac_affine_inv_1_0_GREEN_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_1_GREEN_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_21 - jac_affine_inv_1_2_GREEN_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_21;
                const real_t tmp_kernel_op_25 = -jac_affine_inv_1_0_GREEN_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_1_GREEN_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_24 - jac_affine_inv_1_2_GREEN_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_24;
                const real_t tmp_kernel_op_28 = -jac_affine_inv_1_0_GREEN_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_1_GREEN_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_27 - jac_affine_inv_1_2_GREEN_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_27;
                const real_t tmp_kernel_op_31 = -jac_affine_inv_1_0_GREEN_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_1_GREEN_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_30 - jac_affine_inv_1_2_GREEN_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_30;
                const real_t tmp_kernel_op_34 = -jac_affine_inv_2_0_GREEN_DOWN*jac_blending_inv_0_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_1_GREEN_DOWN*jac_blending_inv_1_2_q_0*tmp_kernel_op_33 - jac_affine_inv_2_2_GREEN_DOWN*jac_blending_inv_2_2_q_0*tmp_kernel_op_33;
                const real_t tmp_kernel_op_37 = -jac_affine_inv_2_0_GREEN_DOWN*jac_blending_inv_0_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_1_GREEN_DOWN*jac_blending_inv_1_2_q_1*tmp_kernel_op_36 - jac_affine_inv_2_2_GREEN_DOWN*jac_blending_inv_2_2_q_1*tmp_kernel_op_36;
                const real_t tmp_kernel_op_40 = -jac_affine_inv_2_0_GREEN_DOWN*jac_blending_inv_0_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_1_GREEN_DOWN*jac_blending_inv_1_2_q_2*tmp_kernel_op_39 - jac_affine_inv_2_2_GREEN_DOWN*jac_blending_inv_2_2_q_2*tmp_kernel_op_39;
                const real_t tmp_kernel_op_43 = -jac_affine_inv_2_0_GREEN_DOWN*jac_blending_inv_0_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_1_GREEN_DOWN*jac_blending_inv_1_2_q_3*tmp_kernel_op_42 - jac_affine_inv_2_2_GREEN_DOWN*jac_blending_inv_2_2_q_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_50 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_288 + tmp_moved_constant_289) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_290 + tmp_moved_constant_291) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_292 + tmp_moved_constant_293);
                const real_t tmp_kernel_op_57 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_294 + tmp_moved_constant_295) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_296 + tmp_moved_constant_297) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_298 + tmp_moved_constant_299);
                const real_t tmp_kernel_op_64 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_300 + tmp_moved_constant_301) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_302 + tmp_moved_constant_303) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_304 + tmp_moved_constant_305);
                const real_t tmp_kernel_op_71 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_306 + tmp_moved_constant_307) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_308 + tmp_moved_constant_309) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_310 + tmp_moved_constant_311);
                const real_t tmp_kernel_op_78 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_312 + tmp_moved_constant_313) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_314 + tmp_moved_constant_315) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_316 + tmp_moved_constant_317);
                const real_t tmp_kernel_op_85 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_318 + tmp_moved_constant_319) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_320 + tmp_moved_constant_321) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_322 + tmp_moved_constant_323);
                const real_t tmp_kernel_op_92 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_324 + tmp_moved_constant_325) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_326 + tmp_moved_constant_327) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_328 + tmp_moved_constant_329);
                const real_t tmp_kernel_op_99 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_330 + tmp_moved_constant_331) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_332 + tmp_moved_constant_333) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_334 + tmp_moved_constant_335);
                const real_t tmp_kernel_op_106 = -jac_blending_inv_0_2_q_0*(tmp_moved_constant_336 + tmp_moved_constant_337) - jac_blending_inv_1_2_q_0*(tmp_moved_constant_338 + tmp_moved_constant_339) - jac_blending_inv_2_2_q_0*(tmp_moved_constant_340 + tmp_moved_constant_341);
                const real_t tmp_kernel_op_113 = -jac_blending_inv_0_2_q_1*(tmp_moved_constant_342 + tmp_moved_constant_343) - jac_blending_inv_1_2_q_1*(tmp_moved_constant_344 + tmp_moved_constant_345) - jac_blending_inv_2_2_q_1*(tmp_moved_constant_346 + tmp_moved_constant_347);
                const real_t tmp_kernel_op_120 = -jac_blending_inv_0_2_q_2*(tmp_moved_constant_348 + tmp_moved_constant_349) - jac_blending_inv_1_2_q_2*(tmp_moved_constant_350 + tmp_moved_constant_351) - jac_blending_inv_2_2_q_2*(tmp_moved_constant_352 + tmp_moved_constant_353);
                const real_t tmp_kernel_op_127 = -jac_blending_inv_0_2_q_3*(tmp_moved_constant_354 + tmp_moved_constant_355) - jac_blending_inv_1_2_q_3*(tmp_moved_constant_356 + tmp_moved_constant_357) - jac_blending_inv_2_2_q_3*(tmp_moved_constant_358 + tmp_moved_constant_359);
                const real_t tmp_kernel_op_130 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_129 - tmp_moved_constant_288 - tmp_moved_constant_312) - jac_blending_inv_1_2_q_0*(jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_129 - tmp_moved_constant_290 - tmp_moved_constant_314) - jac_blending_inv_2_2_q_0*(jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_129 - tmp_moved_constant_292 - tmp_moved_constant_316);
                const real_t tmp_kernel_op_133 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_132 - tmp_moved_constant_294 - tmp_moved_constant_318) - jac_blending_inv_1_2_q_1*(jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_132 - tmp_moved_constant_296 - tmp_moved_constant_320) - jac_blending_inv_2_2_q_1*(jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_132 - tmp_moved_constant_298 - tmp_moved_constant_322);
                const real_t tmp_kernel_op_136 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_135 - tmp_moved_constant_300 - tmp_moved_constant_324) - jac_blending_inv_1_2_q_2*(jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_135 - tmp_moved_constant_302 - tmp_moved_constant_326) - jac_blending_inv_2_2_q_2*(jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_135 - tmp_moved_constant_304 - tmp_moved_constant_328);
                const real_t tmp_kernel_op_139 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_138 - tmp_moved_constant_306 - tmp_moved_constant_330) - jac_blending_inv_1_2_q_3*(jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_138 - tmp_moved_constant_308 - tmp_moved_constant_332) - jac_blending_inv_2_2_q_3*(jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_138 - tmp_moved_constant_310 - tmp_moved_constant_334);
                const real_t tmp_kernel_op_142 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_141 - tmp_moved_constant_289 - tmp_moved_constant_336) - jac_blending_inv_1_2_q_0*(jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_141 - tmp_moved_constant_291 - tmp_moved_constant_338) - jac_blending_inv_2_2_q_0*(jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_141 - tmp_moved_constant_293 - tmp_moved_constant_340);
                const real_t tmp_kernel_op_145 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_144 - tmp_moved_constant_295 - tmp_moved_constant_342) - jac_blending_inv_1_2_q_1*(jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_144 - tmp_moved_constant_297 - tmp_moved_constant_344) - jac_blending_inv_2_2_q_1*(jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_144 - tmp_moved_constant_299 - tmp_moved_constant_346);
                const real_t tmp_kernel_op_148 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_147 - tmp_moved_constant_301 - tmp_moved_constant_348) - jac_blending_inv_1_2_q_2*(jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_147 - tmp_moved_constant_303 - tmp_moved_constant_350) - jac_blending_inv_2_2_q_2*(jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_147 - tmp_moved_constant_305 - tmp_moved_constant_352);
                const real_t tmp_kernel_op_151 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_150 - tmp_moved_constant_307 - tmp_moved_constant_354) - jac_blending_inv_1_2_q_3*(jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_150 - tmp_moved_constant_309 - tmp_moved_constant_356) - jac_blending_inv_2_2_q_3*(jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_150 - tmp_moved_constant_311 - tmp_moved_constant_358);
                const real_t tmp_kernel_op_153 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_152 - tmp_moved_constant_313 - tmp_moved_constant_337) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_152 - tmp_moved_constant_315 - tmp_moved_constant_339) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_152 - tmp_moved_constant_317 - tmp_moved_constant_341);
                const real_t tmp_kernel_op_155 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_154 - tmp_moved_constant_319 - tmp_moved_constant_343) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_154 - tmp_moved_constant_321 - tmp_moved_constant_345) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_154 - tmp_moved_constant_323 - tmp_moved_constant_347);
                const real_t tmp_kernel_op_157 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_156 - tmp_moved_constant_325 - tmp_moved_constant_349) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_156 - tmp_moved_constant_327 - tmp_moved_constant_351) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_156 - tmp_moved_constant_329 - tmp_moved_constant_353);
                const real_t tmp_kernel_op_159 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_158 - tmp_moved_constant_331 - tmp_moved_constant_355) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_158 - tmp_moved_constant_333 - tmp_moved_constant_357) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_158 - tmp_moved_constant_335 - tmp_moved_constant_359);
                const real_t tmp_kernel_op_161 = -jac_blending_inv_0_2_q_0*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_160) - jac_blending_inv_1_2_q_0*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_160) - jac_blending_inv_2_2_q_0*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_160 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_160 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_160);
                const real_t tmp_kernel_op_163 = -jac_blending_inv_0_2_q_1*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_162) - jac_blending_inv_1_2_q_1*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_162) - jac_blending_inv_2_2_q_1*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_162 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_162 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_162);
                const real_t tmp_kernel_op_165 = -jac_blending_inv_0_2_q_2*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_164) - jac_blending_inv_1_2_q_2*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_164) - jac_blending_inv_2_2_q_2*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_164 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_164 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_164);
                const real_t tmp_kernel_op_167 = -jac_blending_inv_0_2_q_3*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_166) - jac_blending_inv_1_2_q_3*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_166) - jac_blending_inv_2_2_q_3*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_166 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_166 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_166);
                const real_t tmp_kernel_op_168 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_169 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_170 = tmp_kernel_op_13*0.5854101966249684;
                const real_t tmp_kernel_op_171 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_3*0.1381966011250105;
                const real_t tmp_kernel_op_173 = tmp_kernel_op_8*0.5854101966249684;
                const real_t tmp_kernel_op_174 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_175 = tmp_kernel_op_18*0.1381966011250105;
                const real_t tmp_kernel_op_176 = tmp_kernel_op_3*0.5854101966249684;
                const real_t tmp_kernel_op_177 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_13*0.1381966011250105;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_18*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_14*tmp_kernel_op_165 + tmp_kernel_op_161*tmp_kernel_op_4 + tmp_kernel_op_163*tmp_kernel_op_9 + tmp_kernel_op_167*tmp_kernel_op_19) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_14 + tmp_kernel_op_17*tmp_kernel_op_19 + tmp_kernel_op_2*tmp_kernel_op_4 + tmp_kernel_op_7*tmp_kernel_op_9) + src_dof_2*(tmp_kernel_op_14*tmp_kernel_op_28 + tmp_kernel_op_19*tmp_kernel_op_31 + tmp_kernel_op_22*tmp_kernel_op_4 + tmp_kernel_op_25*tmp_kernel_op_9) + src_dof_3*(tmp_kernel_op_14*tmp_kernel_op_40 + tmp_kernel_op_19*tmp_kernel_op_43 + tmp_kernel_op_34*tmp_kernel_op_4 + tmp_kernel_op_37*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_14*tmp_kernel_op_64 + tmp_kernel_op_19*tmp_kernel_op_71 + tmp_kernel_op_4*tmp_kernel_op_50 + tmp_kernel_op_57*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_14*tmp_kernel_op_92 + tmp_kernel_op_19*tmp_kernel_op_99 + tmp_kernel_op_4*tmp_kernel_op_78 + tmp_kernel_op_85*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_4 + tmp_kernel_op_113*tmp_kernel_op_9 + tmp_kernel_op_120*tmp_kernel_op_14 + tmp_kernel_op_127*tmp_kernel_op_19) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_4 + tmp_kernel_op_133*tmp_kernel_op_9 + tmp_kernel_op_136*tmp_kernel_op_14 + tmp_kernel_op_139*tmp_kernel_op_19) + src_dof_8*(tmp_kernel_op_14*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_4 + tmp_kernel_op_145*tmp_kernel_op_9 + tmp_kernel_op_151*tmp_kernel_op_19) + src_dof_9*(tmp_kernel_op_14*tmp_kernel_op_157 + tmp_kernel_op_153*tmp_kernel_op_4 + tmp_kernel_op_155*tmp_kernel_op_9 + tmp_kernel_op_159*tmp_kernel_op_19);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_168 + tmp_kernel_op_163*tmp_kernel_op_169 + tmp_kernel_op_165*tmp_kernel_op_170 + tmp_kernel_op_167*tmp_kernel_op_171) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_170 + tmp_kernel_op_168*tmp_kernel_op_2 + tmp_kernel_op_169*tmp_kernel_op_7 + tmp_kernel_op_17*tmp_kernel_op_171) + src_dof_2*(tmp_kernel_op_168*tmp_kernel_op_22 + tmp_kernel_op_169*tmp_kernel_op_25 + tmp_kernel_op_170*tmp_kernel_op_28 + tmp_kernel_op_171*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_168*tmp_kernel_op_34 + tmp_kernel_op_169*tmp_kernel_op_37 + tmp_kernel_op_170*tmp_kernel_op_40 + tmp_kernel_op_171*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_168*tmp_kernel_op_50 + tmp_kernel_op_169*tmp_kernel_op_57 + tmp_kernel_op_170*tmp_kernel_op_64 + tmp_kernel_op_171*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_168*tmp_kernel_op_78 + tmp_kernel_op_169*tmp_kernel_op_85 + tmp_kernel_op_170*tmp_kernel_op_92 + tmp_kernel_op_171*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_168 + tmp_kernel_op_113*tmp_kernel_op_169 + tmp_kernel_op_120*tmp_kernel_op_170 + tmp_kernel_op_127*tmp_kernel_op_171) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_168 + tmp_kernel_op_133*tmp_kernel_op_169 + tmp_kernel_op_136*tmp_kernel_op_170 + tmp_kernel_op_139*tmp_kernel_op_171) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_168 + tmp_kernel_op_145*tmp_kernel_op_169 + tmp_kernel_op_148*tmp_kernel_op_170 + tmp_kernel_op_151*tmp_kernel_op_171) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_168 + tmp_kernel_op_155*tmp_kernel_op_169 + tmp_kernel_op_157*tmp_kernel_op_170 + tmp_kernel_op_159*tmp_kernel_op_171);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_172 + tmp_kernel_op_163*tmp_kernel_op_173 + tmp_kernel_op_165*tmp_kernel_op_174 + tmp_kernel_op_167*tmp_kernel_op_175) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_174 + tmp_kernel_op_17*tmp_kernel_op_175 + tmp_kernel_op_172*tmp_kernel_op_2 + tmp_kernel_op_173*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_172*tmp_kernel_op_22 + tmp_kernel_op_173*tmp_kernel_op_25 + tmp_kernel_op_174*tmp_kernel_op_28 + tmp_kernel_op_175*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_172*tmp_kernel_op_34 + tmp_kernel_op_173*tmp_kernel_op_37 + tmp_kernel_op_174*tmp_kernel_op_40 + tmp_kernel_op_175*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_172*tmp_kernel_op_50 + tmp_kernel_op_173*tmp_kernel_op_57 + tmp_kernel_op_174*tmp_kernel_op_64 + tmp_kernel_op_175*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_172*tmp_kernel_op_78 + tmp_kernel_op_173*tmp_kernel_op_85 + tmp_kernel_op_174*tmp_kernel_op_92 + tmp_kernel_op_175*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_172 + tmp_kernel_op_113*tmp_kernel_op_173 + tmp_kernel_op_120*tmp_kernel_op_174 + tmp_kernel_op_127*tmp_kernel_op_175) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_172 + tmp_kernel_op_133*tmp_kernel_op_173 + tmp_kernel_op_136*tmp_kernel_op_174 + tmp_kernel_op_139*tmp_kernel_op_175) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_172 + tmp_kernel_op_145*tmp_kernel_op_173 + tmp_kernel_op_148*tmp_kernel_op_174 + tmp_kernel_op_151*tmp_kernel_op_175) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_172 + tmp_kernel_op_155*tmp_kernel_op_173 + tmp_kernel_op_157*tmp_kernel_op_174 + tmp_kernel_op_159*tmp_kernel_op_175);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_161*tmp_kernel_op_176 + tmp_kernel_op_163*tmp_kernel_op_177 + tmp_kernel_op_165*tmp_kernel_op_178 + tmp_kernel_op_167*tmp_kernel_op_179) + src_dof_1*(tmp_kernel_op_12*tmp_kernel_op_178 + tmp_kernel_op_17*tmp_kernel_op_179 + tmp_kernel_op_176*tmp_kernel_op_2 + tmp_kernel_op_177*tmp_kernel_op_7) + src_dof_2*(tmp_kernel_op_176*tmp_kernel_op_22 + tmp_kernel_op_177*tmp_kernel_op_25 + tmp_kernel_op_178*tmp_kernel_op_28 + tmp_kernel_op_179*tmp_kernel_op_31) + src_dof_3*(tmp_kernel_op_176*tmp_kernel_op_34 + tmp_kernel_op_177*tmp_kernel_op_37 + tmp_kernel_op_178*tmp_kernel_op_40 + tmp_kernel_op_179*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_176*tmp_kernel_op_50 + tmp_kernel_op_177*tmp_kernel_op_57 + tmp_kernel_op_178*tmp_kernel_op_64 + tmp_kernel_op_179*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_176*tmp_kernel_op_78 + tmp_kernel_op_177*tmp_kernel_op_85 + tmp_kernel_op_178*tmp_kernel_op_92 + tmp_kernel_op_179*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_106*tmp_kernel_op_176 + tmp_kernel_op_113*tmp_kernel_op_177 + tmp_kernel_op_120*tmp_kernel_op_178 + tmp_kernel_op_127*tmp_kernel_op_179) + src_dof_7*(tmp_kernel_op_130*tmp_kernel_op_176 + tmp_kernel_op_133*tmp_kernel_op_177 + tmp_kernel_op_136*tmp_kernel_op_178 + tmp_kernel_op_139*tmp_kernel_op_179) + src_dof_8*(tmp_kernel_op_142*tmp_kernel_op_176 + tmp_kernel_op_145*tmp_kernel_op_177 + tmp_kernel_op_148*tmp_kernel_op_178 + tmp_kernel_op_151*tmp_kernel_op_179) + src_dof_9*(tmp_kernel_op_153*tmp_kernel_op_176 + tmp_kernel_op_155*tmp_kernel_op_177 + tmp_kernel_op_157*tmp_kernel_op_178 + tmp_kernel_op_159*tmp_kernel_op_179);
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
