/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2VectorToP1ElementwiseDivergence.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorToP1ElementwiseDivergence::apply_P2VectorToP1ElementwiseDivergence_macro_3D( real_t * RESTRICT  _data_dst, real_t * RESTRICT  _data_src_edge_0, real_t * RESTRICT  _data_src_edge_1, real_t * RESTRICT  _data_src_edge_2, real_t * RESTRICT  _data_src_vertex_0, real_t * RESTRICT  _data_src_vertex_1, real_t * RESTRICT  _data_src_vertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_kernel_op_0 = 0.55278640450004202;
       const real_t tmp_kernel_op_1 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_2 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_2*0.13819660112501053;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_1*tmp_kernel_op_3;
       const real_t tmp_kernel_op_5 = 0.55278640450004202;
       const real_t tmp_kernel_op_6 = tmp_kernel_op_5 - 1.0;
       const real_t tmp_kernel_op_7 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_8 = tmp_kernel_op_7*0.13819660112501056;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_6*tmp_kernel_op_8;
       const real_t tmp_kernel_op_10 = 2.3416407864998736;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_10 - 1.0;
       const real_t tmp_kernel_op_12 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_13 = tmp_kernel_op_12*0.13819660112501056;
       const real_t tmp_kernel_op_14 = tmp_kernel_op_11*tmp_kernel_op_13;
       const real_t tmp_kernel_op_15 = 0.55278640450004202;
       const real_t tmp_kernel_op_16 = tmp_kernel_op_15 - 1.0;
       const real_t tmp_kernel_op_17 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_18 = tmp_kernel_op_17*0.5854101966249684;
       const real_t tmp_kernel_op_19 = tmp_kernel_op_16*tmp_kernel_op_18;
       const real_t tmp_kernel_op_20 = 0.55278640450004202;
       const real_t tmp_kernel_op_21 = tmp_kernel_op_20 - 1.0;
       const real_t tmp_kernel_op_22 = tmp_kernel_op_21*tmp_kernel_op_3;
       const real_t tmp_kernel_op_23 = 2.3416407864998736;
       const real_t tmp_kernel_op_24 = tmp_kernel_op_23 - 1.0;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_24*tmp_kernel_op_8;
       const real_t tmp_kernel_op_26 = 0.55278640450004202;
       const real_t tmp_kernel_op_27 = tmp_kernel_op_26 - 1.0;
       const real_t tmp_kernel_op_28 = tmp_kernel_op_13*tmp_kernel_op_27;
       const real_t tmp_kernel_op_29 = 0.55278640450004202;
       const real_t tmp_kernel_op_30 = tmp_kernel_op_29 - 1.0;
       const real_t tmp_kernel_op_31 = tmp_kernel_op_18*tmp_kernel_op_30;
       const real_t tmp_kernel_op_32 = 2.3416407864998736;
       const real_t tmp_kernel_op_33 = tmp_kernel_op_32 - 1.0;
       const real_t tmp_kernel_op_34 = tmp_kernel_op_3*tmp_kernel_op_33;
       const real_t tmp_kernel_op_35 = 0.55278640450004202;
       const real_t tmp_kernel_op_36 = tmp_kernel_op_35 - 1.0;
       const real_t tmp_kernel_op_37 = tmp_kernel_op_36*tmp_kernel_op_8;
       const real_t tmp_kernel_op_38 = 0.55278640450004202;
       const real_t tmp_kernel_op_39 = tmp_kernel_op_38 - 1.0;
       const real_t tmp_kernel_op_40 = tmp_kernel_op_13*tmp_kernel_op_39;
       const real_t tmp_kernel_op_41 = 0.55278640450004202;
       const real_t tmp_kernel_op_42 = tmp_kernel_op_41 - 1.0;
       const real_t tmp_kernel_op_43 = tmp_kernel_op_18*tmp_kernel_op_42;
       const real_t tmp_kernel_op_44 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_45 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_46 = -tmp_kernel_op_44 - tmp_kernel_op_45;
       const real_t tmp_kernel_op_47 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_48 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_49 = -tmp_kernel_op_47 - tmp_kernel_op_48;
       const real_t tmp_kernel_op_50 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_51 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_52 = -tmp_kernel_op_50 - tmp_kernel_op_51;
       const real_t tmp_kernel_op_53 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_54 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_55 = -tmp_kernel_op_53 - tmp_kernel_op_54;
       const real_t tmp_kernel_op_56 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_57 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_58 = -tmp_kernel_op_56 - tmp_kernel_op_57;
       const real_t tmp_kernel_op_59 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_60 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_61 = -tmp_kernel_op_59 - tmp_kernel_op_60;
       const real_t tmp_kernel_op_62 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_63 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_64 = -tmp_kernel_op_62 - tmp_kernel_op_63;
       const real_t tmp_kernel_op_65 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_66 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_67 = -tmp_kernel_op_65 - tmp_kernel_op_66;
       const real_t tmp_kernel_op_68 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_69 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_70 = -tmp_kernel_op_68 - tmp_kernel_op_69;
       const real_t tmp_kernel_op_71 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_72 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_73 = -tmp_kernel_op_71 - tmp_kernel_op_72;
       const real_t tmp_kernel_op_74 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_75 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_76 = -tmp_kernel_op_74 - tmp_kernel_op_75;
       const real_t tmp_kernel_op_77 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_78 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_79 = -tmp_kernel_op_77 - tmp_kernel_op_78;
       const real_t tmp_kernel_op_80 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_81 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_82 = -tmp_kernel_op_80 - tmp_kernel_op_81;
       const real_t tmp_kernel_op_83 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_84 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_85 = -tmp_kernel_op_83 - tmp_kernel_op_84;
       const real_t tmp_kernel_op_86 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_87 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_88 = -tmp_kernel_op_86 - tmp_kernel_op_87;
       const real_t tmp_kernel_op_89 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_90 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_91 = -tmp_kernel_op_89 - tmp_kernel_op_90;
       const real_t tmp_kernel_op_92 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_93 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_94 = -tmp_kernel_op_92 - tmp_kernel_op_93;
       const real_t tmp_kernel_op_95 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_96 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_97 = -tmp_kernel_op_95 - tmp_kernel_op_96;
       const real_t tmp_kernel_op_98 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_99 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_100 = -tmp_kernel_op_98 - tmp_kernel_op_99;
       const real_t tmp_kernel_op_101 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_102 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_103 = -tmp_kernel_op_101 - tmp_kernel_op_102;
       const real_t tmp_kernel_op_104 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_105 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_106 = -tmp_kernel_op_104 - tmp_kernel_op_105;
       const real_t tmp_kernel_op_107 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_108 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_109 = -tmp_kernel_op_107 - tmp_kernel_op_108;
       const real_t tmp_kernel_op_110 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_111 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_112 = -tmp_kernel_op_110 - tmp_kernel_op_111;
       const real_t tmp_kernel_op_113 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_114 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_115 = -tmp_kernel_op_113 - tmp_kernel_op_114;
       const real_t tmp_kernel_op_116 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_117 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_118 = -tmp_kernel_op_116 - tmp_kernel_op_117;
       const real_t tmp_kernel_op_119 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_120 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_121 = -tmp_kernel_op_119 - tmp_kernel_op_120;
       const real_t tmp_kernel_op_122 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_123 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_124 = -tmp_kernel_op_122 - tmp_kernel_op_123;
       const real_t tmp_kernel_op_125 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_126 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_127 = -tmp_kernel_op_125 - tmp_kernel_op_126;
       const real_t tmp_kernel_op_128 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_32;
       const real_t tmp_kernel_op_129 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_130 = -tmp_kernel_op_128 - tmp_kernel_op_129;
       const real_t tmp_kernel_op_131 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_35;
       const real_t tmp_kernel_op_132 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_133 = -tmp_kernel_op_131 - tmp_kernel_op_132;
       const real_t tmp_kernel_op_134 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_135 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_136 = -tmp_kernel_op_134 - tmp_kernel_op_135;
       const real_t tmp_kernel_op_137 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_41;
       const real_t tmp_kernel_op_138 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_139 = -tmp_kernel_op_137 - tmp_kernel_op_138;
       const real_t tmp_kernel_op_140 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_141 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_142 = -tmp_kernel_op_140 - tmp_kernel_op_141;
       const real_t tmp_kernel_op_143 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_144 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_5;
       const real_t tmp_kernel_op_145 = -tmp_kernel_op_143 - tmp_kernel_op_144;
       const real_t tmp_kernel_op_146 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_147 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_148 = -tmp_kernel_op_146 - tmp_kernel_op_147;
       const real_t tmp_kernel_op_149 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_150 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_151 = -tmp_kernel_op_149 - tmp_kernel_op_150;
       const real_t tmp_kernel_op_152 = tmp_kernel_op_0 + tmp_kernel_op_20;
       const real_t tmp_kernel_op_153 = -tmp_kernel_op_152 - 0.68328157299974723;
       const real_t tmp_kernel_op_154 = -jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_153 + tmp_kernel_op_44 + tmp_kernel_op_56;
       const real_t tmp_kernel_op_155 = tmp_kernel_op_23 + tmp_kernel_op_5;
       const real_t tmp_kernel_op_156 = -tmp_kernel_op_155 + 2.8944271909999157;
       const real_t tmp_kernel_op_157 = -jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_156 + tmp_kernel_op_47 + tmp_kernel_op_59;
       const real_t tmp_kernel_op_158 = tmp_kernel_op_10 + tmp_kernel_op_26;
       const real_t tmp_kernel_op_159 = -tmp_kernel_op_158 + 2.8944271909999157;
       const real_t tmp_kernel_op_160 = -jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_159 + tmp_kernel_op_50 + tmp_kernel_op_62;
       const real_t tmp_kernel_op_161 = tmp_kernel_op_15 + tmp_kernel_op_29;
       const real_t tmp_kernel_op_162 = -tmp_kernel_op_161 + 2.8944271909999157;
       const real_t tmp_kernel_op_163 = -jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_162 + tmp_kernel_op_53 + tmp_kernel_op_65;
       const real_t tmp_kernel_op_164 = tmp_kernel_op_32 - 4.0;
       const real_t tmp_kernel_op_165 = -tmp_kernel_op_0 - tmp_kernel_op_164 - 1.105572809000084;
       const real_t tmp_kernel_op_166 = -jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_165 + tmp_kernel_op_45 + tmp_kernel_op_68;
       const real_t tmp_kernel_op_167 = tmp_kernel_op_35 - 4.0;
       const real_t tmp_kernel_op_168 = -tmp_kernel_op_167 - tmp_kernel_op_5 - 4.6832815729997472;
       const real_t tmp_kernel_op_169 = -jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_168 + tmp_kernel_op_48 + tmp_kernel_op_71;
       const real_t tmp_kernel_op_170 = tmp_kernel_op_38 - 4.0;
       const real_t tmp_kernel_op_171 = -tmp_kernel_op_10 - tmp_kernel_op_170 - 1.105572809000084;
       const real_t tmp_kernel_op_172 = -jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_171 + tmp_kernel_op_51 + tmp_kernel_op_74;
       const real_t tmp_kernel_op_173 = tmp_kernel_op_41 - 4.0;
       const real_t tmp_kernel_op_174 = -tmp_kernel_op_15 - tmp_kernel_op_173 - 1.105572809000084;
       const real_t tmp_kernel_op_175 = -jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_174 + tmp_kernel_op_54 + tmp_kernel_op_77;
       const real_t tmp_kernel_op_176 = -tmp_kernel_op_164 - tmp_kernel_op_20 - 1.105572809000084;
       const real_t tmp_kernel_op_177 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_176 + tmp_kernel_op_57 + tmp_kernel_op_69;
       const real_t tmp_kernel_op_178 = -tmp_kernel_op_167 - tmp_kernel_op_23 - 1.105572809000084;
       const real_t tmp_kernel_op_179 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_178 + tmp_kernel_op_60 + tmp_kernel_op_72;
       const real_t tmp_kernel_op_180 = -tmp_kernel_op_170 - tmp_kernel_op_26 - 4.6832815729997472;
       const real_t tmp_kernel_op_181 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_180 + tmp_kernel_op_63 + tmp_kernel_op_75;
       const real_t tmp_kernel_op_182 = -tmp_kernel_op_173 - tmp_kernel_op_29 - 1.105572809000084;
       const real_t tmp_kernel_op_183 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_182 + tmp_kernel_op_66 + tmp_kernel_op_78;
       const real_t tmp_kernel_op_184 = -jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_153 + tmp_kernel_op_80 + tmp_kernel_op_92;
       const real_t tmp_kernel_op_185 = -jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_156 + tmp_kernel_op_83 + tmp_kernel_op_95;
       const real_t tmp_kernel_op_186 = -jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_159 + tmp_kernel_op_86 + tmp_kernel_op_98;
       const real_t tmp_kernel_op_187 = -jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_162 + tmp_kernel_op_101 + tmp_kernel_op_89;
       const real_t tmp_kernel_op_188 = -jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_165 + tmp_kernel_op_104 + tmp_kernel_op_81;
       const real_t tmp_kernel_op_189 = -jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_168 + tmp_kernel_op_107 + tmp_kernel_op_84;
       const real_t tmp_kernel_op_190 = -jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_171 + tmp_kernel_op_110 + tmp_kernel_op_87;
       const real_t tmp_kernel_op_191 = -jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_174 + tmp_kernel_op_113 + tmp_kernel_op_90;
       const real_t tmp_kernel_op_192 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_176 + tmp_kernel_op_105 + tmp_kernel_op_93;
       const real_t tmp_kernel_op_193 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_178 + tmp_kernel_op_108 + tmp_kernel_op_96;
       const real_t tmp_kernel_op_194 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_180 + tmp_kernel_op_111 + tmp_kernel_op_99;
       const real_t tmp_kernel_op_195 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_182 + tmp_kernel_op_102 + tmp_kernel_op_114;
       const real_t tmp_kernel_op_196 = -jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_153 + tmp_kernel_op_116 + tmp_kernel_op_128;
       const real_t tmp_kernel_op_197 = -jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_156 + tmp_kernel_op_119 + tmp_kernel_op_131;
       const real_t tmp_kernel_op_198 = -jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_159 + tmp_kernel_op_122 + tmp_kernel_op_134;
       const real_t tmp_kernel_op_199 = -jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_162 + tmp_kernel_op_125 + tmp_kernel_op_137;
       const real_t tmp_kernel_op_200 = -jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_165 + tmp_kernel_op_117 + tmp_kernel_op_140;
       const real_t tmp_kernel_op_201 = -jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_168 + tmp_kernel_op_120 + tmp_kernel_op_143;
       const real_t tmp_kernel_op_202 = -jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_171 + tmp_kernel_op_123 + tmp_kernel_op_146;
       const real_t tmp_kernel_op_203 = -jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_174 + tmp_kernel_op_126 + tmp_kernel_op_149;
       const real_t tmp_kernel_op_204 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_176 + tmp_kernel_op_129 + tmp_kernel_op_141;
       const real_t tmp_kernel_op_205 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_178 + tmp_kernel_op_132 + tmp_kernel_op_144;
       const real_t tmp_kernel_op_206 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_180 + tmp_kernel_op_135 + tmp_kernel_op_147;
       const real_t tmp_kernel_op_207 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_182 + tmp_kernel_op_138 + tmp_kernel_op_150;
       const real_t tmp_kernel_op_208 = tmp_kernel_op_152 + tmp_kernel_op_32 - 3.0;
       const real_t tmp_kernel_op_209 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_208;
       const real_t tmp_kernel_op_210 = tmp_kernel_op_155 + tmp_kernel_op_35 - 3.0;
       const real_t tmp_kernel_op_211 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_210;
       const real_t tmp_kernel_op_212 = tmp_kernel_op_158 + tmp_kernel_op_38 - 3.0;
       const real_t tmp_kernel_op_213 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_212;
       const real_t tmp_kernel_op_214 = tmp_kernel_op_161 + tmp_kernel_op_41 - 3.0;
       const real_t tmp_kernel_op_215 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_214;
       const real_t tmp_kernel_op_216 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_208;
       const real_t tmp_kernel_op_217 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_210;
       const real_t tmp_kernel_op_218 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_212;
       const real_t tmp_kernel_op_219 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_214;
       const real_t tmp_kernel_op_220 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_208;
       const real_t tmp_kernel_op_221 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_210;
       const real_t tmp_kernel_op_222 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_212;
       const real_t tmp_kernel_op_223 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_214;
       const real_t tmp_kernel_op_224 = tmp_kernel_op_2*0.1381966011250105;
       const real_t tmp_kernel_op_225 = tmp_kernel_op_1*tmp_kernel_op_224;
       const real_t tmp_kernel_op_226 = tmp_kernel_op_7*0.1381966011250105;
       const real_t tmp_kernel_op_227 = tmp_kernel_op_226*tmp_kernel_op_6;
       const real_t tmp_kernel_op_228 = tmp_kernel_op_12*0.5854101966249684;
       const real_t tmp_kernel_op_229 = tmp_kernel_op_11*tmp_kernel_op_228;
       const real_t tmp_kernel_op_230 = tmp_kernel_op_17*0.1381966011250105;
       const real_t tmp_kernel_op_231 = tmp_kernel_op_16*tmp_kernel_op_230;
       const real_t tmp_kernel_op_232 = tmp_kernel_op_21*tmp_kernel_op_224;
       const real_t tmp_kernel_op_233 = tmp_kernel_op_226*tmp_kernel_op_24;
       const real_t tmp_kernel_op_234 = tmp_kernel_op_228*tmp_kernel_op_27;
       const real_t tmp_kernel_op_235 = tmp_kernel_op_230*tmp_kernel_op_30;
       const real_t tmp_kernel_op_236 = tmp_kernel_op_224*tmp_kernel_op_33;
       const real_t tmp_kernel_op_237 = tmp_kernel_op_226*tmp_kernel_op_36;
       const real_t tmp_kernel_op_238 = tmp_kernel_op_228*tmp_kernel_op_39;
       const real_t tmp_kernel_op_239 = tmp_kernel_op_230*tmp_kernel_op_42;
       const real_t tmp_kernel_op_240 = tmp_kernel_op_2*0.1381966011250105;
       const real_t tmp_kernel_op_241 = tmp_kernel_op_1*tmp_kernel_op_240;
       const real_t tmp_kernel_op_242 = tmp_kernel_op_7*0.5854101966249684;
       const real_t tmp_kernel_op_243 = tmp_kernel_op_242*tmp_kernel_op_6;
       const real_t tmp_kernel_op_244 = tmp_kernel_op_12*0.1381966011250105;
       const real_t tmp_kernel_op_245 = tmp_kernel_op_11*tmp_kernel_op_244;
       const real_t tmp_kernel_op_246 = tmp_kernel_op_17*0.1381966011250105;
       const real_t tmp_kernel_op_247 = tmp_kernel_op_16*tmp_kernel_op_246;
       const real_t tmp_kernel_op_248 = tmp_kernel_op_21*tmp_kernel_op_240;
       const real_t tmp_kernel_op_249 = tmp_kernel_op_24*tmp_kernel_op_242;
       const real_t tmp_kernel_op_250 = tmp_kernel_op_244*tmp_kernel_op_27;
       const real_t tmp_kernel_op_251 = tmp_kernel_op_246*tmp_kernel_op_30;
       const real_t tmp_kernel_op_252 = tmp_kernel_op_240*tmp_kernel_op_33;
       const real_t tmp_kernel_op_253 = tmp_kernel_op_242*tmp_kernel_op_36;
       const real_t tmp_kernel_op_254 = tmp_kernel_op_244*tmp_kernel_op_39;
       const real_t tmp_kernel_op_255 = tmp_kernel_op_246*tmp_kernel_op_42;
       const real_t tmp_kernel_op_256 = tmp_kernel_op_2*0.5854101966249684;
       const real_t tmp_kernel_op_257 = tmp_kernel_op_1*tmp_kernel_op_256;
       const real_t tmp_kernel_op_258 = tmp_kernel_op_7*0.1381966011250105;
       const real_t tmp_kernel_op_259 = tmp_kernel_op_258*tmp_kernel_op_6;
       const real_t tmp_kernel_op_260 = tmp_kernel_op_12*0.1381966011250105;
       const real_t tmp_kernel_op_261 = tmp_kernel_op_11*tmp_kernel_op_260;
       const real_t tmp_kernel_op_262 = tmp_kernel_op_17*0.1381966011250105;
       const real_t tmp_kernel_op_263 = tmp_kernel_op_16*tmp_kernel_op_262;
       const real_t tmp_kernel_op_264 = tmp_kernel_op_21*tmp_kernel_op_256;
       const real_t tmp_kernel_op_265 = tmp_kernel_op_24*tmp_kernel_op_258;
       const real_t tmp_kernel_op_266 = tmp_kernel_op_260*tmp_kernel_op_27;
       const real_t tmp_kernel_op_267 = tmp_kernel_op_262*tmp_kernel_op_30;
       const real_t tmp_kernel_op_268 = tmp_kernel_op_256*tmp_kernel_op_33;
       const real_t tmp_kernel_op_269 = tmp_kernel_op_258*tmp_kernel_op_36;
       const real_t tmp_kernel_op_270 = tmp_kernel_op_260*tmp_kernel_op_39;
       const real_t tmp_kernel_op_271 = tmp_kernel_op_262*tmp_kernel_op_42;
       const real_t tmp_moved_constant_30 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_31 = tmp_moved_constant_30*0.13819660112501053;
       const real_t tmp_moved_constant_32 = tmp_kernel_op_1*tmp_moved_constant_31;
       const real_t tmp_moved_constant_33 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_34 = tmp_moved_constant_33*0.13819660112501056;
       const real_t tmp_moved_constant_35 = tmp_kernel_op_6*tmp_moved_constant_34;
       const real_t tmp_moved_constant_36 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_37 = tmp_moved_constant_36*0.13819660112501056;
       const real_t tmp_moved_constant_38 = tmp_kernel_op_11*tmp_moved_constant_37;
       const real_t tmp_moved_constant_39 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_40 = tmp_moved_constant_39*0.5854101966249684;
       const real_t tmp_moved_constant_41 = tmp_kernel_op_16*tmp_moved_constant_40;
       const real_t tmp_moved_constant_42 = tmp_kernel_op_21*tmp_moved_constant_31;
       const real_t tmp_moved_constant_43 = tmp_kernel_op_24*tmp_moved_constant_34;
       const real_t tmp_moved_constant_44 = tmp_kernel_op_27*tmp_moved_constant_37;
       const real_t tmp_moved_constant_45 = tmp_kernel_op_30*tmp_moved_constant_40;
       const real_t tmp_moved_constant_46 = tmp_kernel_op_33*tmp_moved_constant_31;
       const real_t tmp_moved_constant_47 = tmp_kernel_op_36*tmp_moved_constant_34;
       const real_t tmp_moved_constant_48 = tmp_kernel_op_39*tmp_moved_constant_37;
       const real_t tmp_moved_constant_49 = tmp_kernel_op_42*tmp_moved_constant_40;
       const real_t tmp_moved_constant_50 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_51 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_52 = -tmp_moved_constant_50 - tmp_moved_constant_51;
       const real_t tmp_moved_constant_53 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_54 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_55 = -tmp_moved_constant_53 - tmp_moved_constant_54;
       const real_t tmp_moved_constant_56 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_57 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_58 = -tmp_moved_constant_56 - tmp_moved_constant_57;
       const real_t tmp_moved_constant_59 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_60 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_61 = -tmp_moved_constant_59 - tmp_moved_constant_60;
       const real_t tmp_moved_constant_62 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_63 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_64 = -tmp_moved_constant_62 - tmp_moved_constant_63;
       const real_t tmp_moved_constant_65 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_66 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_67 = -tmp_moved_constant_65 - tmp_moved_constant_66;
       const real_t tmp_moved_constant_68 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_69 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_70 = -tmp_moved_constant_68 - tmp_moved_constant_69;
       const real_t tmp_moved_constant_71 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_72 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_73 = -tmp_moved_constant_71 - tmp_moved_constant_72;
       const real_t tmp_moved_constant_74 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_75 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_76 = -tmp_moved_constant_74 - tmp_moved_constant_75;
       const real_t tmp_moved_constant_77 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_78 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_79 = -tmp_moved_constant_77 - tmp_moved_constant_78;
       const real_t tmp_moved_constant_80 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_81 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_82 = -tmp_moved_constant_80 - tmp_moved_constant_81;
       const real_t tmp_moved_constant_83 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_84 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_85 = -tmp_moved_constant_83 - tmp_moved_constant_84;
       const real_t tmp_moved_constant_86 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_87 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_88 = -tmp_moved_constant_86 - tmp_moved_constant_87;
       const real_t tmp_moved_constant_89 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_90 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_91 = -tmp_moved_constant_89 - tmp_moved_constant_90;
       const real_t tmp_moved_constant_92 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_93 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_94 = -tmp_moved_constant_92 - tmp_moved_constant_93;
       const real_t tmp_moved_constant_95 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_96 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_97 = -tmp_moved_constant_95 - tmp_moved_constant_96;
       const real_t tmp_moved_constant_98 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_99 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_100 = -tmp_moved_constant_98 - tmp_moved_constant_99;
       const real_t tmp_moved_constant_101 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_102 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_103 = -tmp_moved_constant_101 - tmp_moved_constant_102;
       const real_t tmp_moved_constant_104 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_105 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_106 = -tmp_moved_constant_104 - tmp_moved_constant_105;
       const real_t tmp_moved_constant_107 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_108 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_109 = -tmp_moved_constant_107 - tmp_moved_constant_108;
       const real_t tmp_moved_constant_110 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_111 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_112 = -tmp_moved_constant_110 - tmp_moved_constant_111;
       const real_t tmp_moved_constant_113 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_114 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_115 = -tmp_moved_constant_113 - tmp_moved_constant_114;
       const real_t tmp_moved_constant_116 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_117 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_118 = -tmp_moved_constant_116 - tmp_moved_constant_117;
       const real_t tmp_moved_constant_119 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_120 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_121 = -tmp_moved_constant_119 - tmp_moved_constant_120;
       const real_t tmp_moved_constant_122 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_123 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_124 = -tmp_moved_constant_122 - tmp_moved_constant_123;
       const real_t tmp_moved_constant_125 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_126 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_127 = -tmp_moved_constant_125 - tmp_moved_constant_126;
       const real_t tmp_moved_constant_128 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_129 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_130 = -tmp_moved_constant_128 - tmp_moved_constant_129;
       const real_t tmp_moved_constant_131 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_132 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_133 = -tmp_moved_constant_131 - tmp_moved_constant_132;
       const real_t tmp_moved_constant_134 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_135 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_136 = -tmp_moved_constant_134 - tmp_moved_constant_135;
       const real_t tmp_moved_constant_137 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_138 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_139 = -tmp_moved_constant_137 - tmp_moved_constant_138;
       const real_t tmp_moved_constant_140 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_141 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_142 = -tmp_moved_constant_140 - tmp_moved_constant_141;
       const real_t tmp_moved_constant_143 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_144 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_145 = -tmp_moved_constant_143 - tmp_moved_constant_144;
       const real_t tmp_moved_constant_146 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_147 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_148 = -tmp_moved_constant_146 - tmp_moved_constant_147;
       const real_t tmp_moved_constant_149 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_150 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_151 = -tmp_moved_constant_149 - tmp_moved_constant_150;
       const real_t tmp_moved_constant_152 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_153 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_154 = -tmp_moved_constant_152 - tmp_moved_constant_153;
       const real_t tmp_moved_constant_155 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_156 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_157 = -tmp_moved_constant_155 - tmp_moved_constant_156;
       const real_t tmp_moved_constant_158 = -jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_50 + tmp_moved_constant_62;
       const real_t tmp_moved_constant_159 = -jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_53 + tmp_moved_constant_65;
       const real_t tmp_moved_constant_160 = -jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_56 + tmp_moved_constant_68;
       const real_t tmp_moved_constant_161 = -jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_59 + tmp_moved_constant_71;
       const real_t tmp_moved_constant_162 = -jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_51 + tmp_moved_constant_74;
       const real_t tmp_moved_constant_163 = -jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_54 + tmp_moved_constant_77;
       const real_t tmp_moved_constant_164 = -jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_57 + tmp_moved_constant_80;
       const real_t tmp_moved_constant_165 = -jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_60 + tmp_moved_constant_83;
       const real_t tmp_moved_constant_166 = -jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_63 + tmp_moved_constant_75;
       const real_t tmp_moved_constant_167 = -jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_66 + tmp_moved_constant_78;
       const real_t tmp_moved_constant_168 = -jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_69 + tmp_moved_constant_81;
       const real_t tmp_moved_constant_169 = -jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_72 + tmp_moved_constant_84;
       const real_t tmp_moved_constant_170 = -jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_86 + tmp_moved_constant_98;
       const real_t tmp_moved_constant_171 = -jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_101 + tmp_moved_constant_89;
       const real_t tmp_moved_constant_172 = -jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_104 + tmp_moved_constant_92;
       const real_t tmp_moved_constant_173 = -jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_107 + tmp_moved_constant_95;
       const real_t tmp_moved_constant_174 = -jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_110 + tmp_moved_constant_87;
       const real_t tmp_moved_constant_175 = -jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_113 + tmp_moved_constant_90;
       const real_t tmp_moved_constant_176 = -jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_116 + tmp_moved_constant_93;
       const real_t tmp_moved_constant_177 = -jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_119 + tmp_moved_constant_96;
       const real_t tmp_moved_constant_178 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_111 + tmp_moved_constant_99;
       const real_t tmp_moved_constant_179 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_102 + tmp_moved_constant_114;
       const real_t tmp_moved_constant_180 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_105 + tmp_moved_constant_117;
       const real_t tmp_moved_constant_181 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_108 + tmp_moved_constant_120;
       const real_t tmp_moved_constant_182 = -jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_122 + tmp_moved_constant_134;
       const real_t tmp_moved_constant_183 = -jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_125 + tmp_moved_constant_137;
       const real_t tmp_moved_constant_184 = -jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_128 + tmp_moved_constant_140;
       const real_t tmp_moved_constant_185 = -jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_131 + tmp_moved_constant_143;
       const real_t tmp_moved_constant_186 = -jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_123 + tmp_moved_constant_146;
       const real_t tmp_moved_constant_187 = -jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_126 + tmp_moved_constant_149;
       const real_t tmp_moved_constant_188 = -jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_129 + tmp_moved_constant_152;
       const real_t tmp_moved_constant_189 = -jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_132 + tmp_moved_constant_155;
       const real_t tmp_moved_constant_190 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_135 + tmp_moved_constant_147;
       const real_t tmp_moved_constant_191 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_138 + tmp_moved_constant_150;
       const real_t tmp_moved_constant_192 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_141 + tmp_moved_constant_153;
       const real_t tmp_moved_constant_193 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_144 + tmp_moved_constant_156;
       const real_t tmp_moved_constant_194 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_195 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_196 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_197 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_198 = -jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_199 = -jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_200 = -jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_201 = -jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_202 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_203 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_204 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_205 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_206 = tmp_moved_constant_30*0.1381966011250105;
       const real_t tmp_moved_constant_207 = tmp_kernel_op_1*tmp_moved_constant_206;
       const real_t tmp_moved_constant_208 = tmp_moved_constant_33*0.1381966011250105;
       const real_t tmp_moved_constant_209 = tmp_kernel_op_6*tmp_moved_constant_208;
       const real_t tmp_moved_constant_210 = tmp_moved_constant_36*0.5854101966249684;
       const real_t tmp_moved_constant_211 = tmp_kernel_op_11*tmp_moved_constant_210;
       const real_t tmp_moved_constant_212 = tmp_moved_constant_39*0.1381966011250105;
       const real_t tmp_moved_constant_213 = tmp_kernel_op_16*tmp_moved_constant_212;
       const real_t tmp_moved_constant_214 = tmp_kernel_op_21*tmp_moved_constant_206;
       const real_t tmp_moved_constant_215 = tmp_kernel_op_24*tmp_moved_constant_208;
       const real_t tmp_moved_constant_216 = tmp_kernel_op_27*tmp_moved_constant_210;
       const real_t tmp_moved_constant_217 = tmp_kernel_op_30*tmp_moved_constant_212;
       const real_t tmp_moved_constant_218 = tmp_kernel_op_33*tmp_moved_constant_206;
       const real_t tmp_moved_constant_219 = tmp_kernel_op_36*tmp_moved_constant_208;
       const real_t tmp_moved_constant_220 = tmp_kernel_op_39*tmp_moved_constant_210;
       const real_t tmp_moved_constant_221 = tmp_kernel_op_42*tmp_moved_constant_212;
       const real_t tmp_moved_constant_222 = tmp_moved_constant_30*0.1381966011250105;
       const real_t tmp_moved_constant_223 = tmp_kernel_op_1*tmp_moved_constant_222;
       const real_t tmp_moved_constant_224 = tmp_moved_constant_33*0.5854101966249684;
       const real_t tmp_moved_constant_225 = tmp_kernel_op_6*tmp_moved_constant_224;
       const real_t tmp_moved_constant_226 = tmp_moved_constant_36*0.1381966011250105;
       const real_t tmp_moved_constant_227 = tmp_kernel_op_11*tmp_moved_constant_226;
       const real_t tmp_moved_constant_228 = tmp_moved_constant_39*0.1381966011250105;
       const real_t tmp_moved_constant_229 = tmp_kernel_op_16*tmp_moved_constant_228;
       const real_t tmp_moved_constant_230 = tmp_kernel_op_21*tmp_moved_constant_222;
       const real_t tmp_moved_constant_231 = tmp_kernel_op_24*tmp_moved_constant_224;
       const real_t tmp_moved_constant_232 = tmp_kernel_op_27*tmp_moved_constant_226;
       const real_t tmp_moved_constant_233 = tmp_kernel_op_30*tmp_moved_constant_228;
       const real_t tmp_moved_constant_234 = tmp_kernel_op_33*tmp_moved_constant_222;
       const real_t tmp_moved_constant_235 = tmp_kernel_op_36*tmp_moved_constant_224;
       const real_t tmp_moved_constant_236 = tmp_kernel_op_39*tmp_moved_constant_226;
       const real_t tmp_moved_constant_237 = tmp_kernel_op_42*tmp_moved_constant_228;
       const real_t tmp_moved_constant_238 = tmp_moved_constant_30*0.5854101966249684;
       const real_t tmp_moved_constant_239 = tmp_kernel_op_1*tmp_moved_constant_238;
       const real_t tmp_moved_constant_240 = tmp_moved_constant_33*0.1381966011250105;
       const real_t tmp_moved_constant_241 = tmp_kernel_op_6*tmp_moved_constant_240;
       const real_t tmp_moved_constant_242 = tmp_moved_constant_36*0.1381966011250105;
       const real_t tmp_moved_constant_243 = tmp_kernel_op_11*tmp_moved_constant_242;
       const real_t tmp_moved_constant_244 = tmp_moved_constant_39*0.1381966011250105;
       const real_t tmp_moved_constant_245 = tmp_kernel_op_16*tmp_moved_constant_244;
       const real_t tmp_moved_constant_246 = tmp_kernel_op_21*tmp_moved_constant_238;
       const real_t tmp_moved_constant_247 = tmp_kernel_op_24*tmp_moved_constant_240;
       const real_t tmp_moved_constant_248 = tmp_kernel_op_27*tmp_moved_constant_242;
       const real_t tmp_moved_constant_249 = tmp_kernel_op_30*tmp_moved_constant_244;
       const real_t tmp_moved_constant_250 = tmp_kernel_op_33*tmp_moved_constant_238;
       const real_t tmp_moved_constant_251 = tmp_kernel_op_36*tmp_moved_constant_240;
       const real_t tmp_moved_constant_252 = tmp_kernel_op_39*tmp_moved_constant_242;
       const real_t tmp_moved_constant_253 = tmp_kernel_op_42*tmp_moved_constant_244;
       const real_t tmp_moved_constant_288 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_289 = tmp_moved_constant_288*0.13819660112501053;
       const real_t tmp_moved_constant_290 = tmp_kernel_op_1*tmp_moved_constant_289;
       const real_t tmp_moved_constant_291 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_292 = tmp_moved_constant_291*0.13819660112501056;
       const real_t tmp_moved_constant_293 = tmp_kernel_op_6*tmp_moved_constant_292;
       const real_t tmp_moved_constant_294 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_295 = tmp_moved_constant_294*0.13819660112501056;
       const real_t tmp_moved_constant_296 = tmp_kernel_op_11*tmp_moved_constant_295;
       const real_t tmp_moved_constant_297 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_298 = tmp_moved_constant_297*0.5854101966249684;
       const real_t tmp_moved_constant_299 = tmp_kernel_op_16*tmp_moved_constant_298;
       const real_t tmp_moved_constant_300 = tmp_kernel_op_21*tmp_moved_constant_289;
       const real_t tmp_moved_constant_301 = tmp_kernel_op_24*tmp_moved_constant_292;
       const real_t tmp_moved_constant_302 = tmp_kernel_op_27*tmp_moved_constant_295;
       const real_t tmp_moved_constant_303 = tmp_kernel_op_30*tmp_moved_constant_298;
       const real_t tmp_moved_constant_304 = tmp_kernel_op_33*tmp_moved_constant_289;
       const real_t tmp_moved_constant_305 = tmp_kernel_op_36*tmp_moved_constant_292;
       const real_t tmp_moved_constant_306 = tmp_kernel_op_39*tmp_moved_constant_295;
       const real_t tmp_moved_constant_307 = tmp_kernel_op_42*tmp_moved_constant_298;
       const real_t tmp_moved_constant_308 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_309 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_310 = -tmp_moved_constant_308 - tmp_moved_constant_309;
       const real_t tmp_moved_constant_311 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_312 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_313 = -tmp_moved_constant_311 - tmp_moved_constant_312;
       const real_t tmp_moved_constant_314 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_315 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_316 = -tmp_moved_constant_314 - tmp_moved_constant_315;
       const real_t tmp_moved_constant_317 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_318 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_319 = -tmp_moved_constant_317 - tmp_moved_constant_318;
       const real_t tmp_moved_constant_320 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_321 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_322 = -tmp_moved_constant_320 - tmp_moved_constant_321;
       const real_t tmp_moved_constant_323 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_324 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_325 = -tmp_moved_constant_323 - tmp_moved_constant_324;
       const real_t tmp_moved_constant_326 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_327 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_328 = -tmp_moved_constant_326 - tmp_moved_constant_327;
       const real_t tmp_moved_constant_329 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_330 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_331 = -tmp_moved_constant_329 - tmp_moved_constant_330;
       const real_t tmp_moved_constant_332 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_333 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_334 = -tmp_moved_constant_332 - tmp_moved_constant_333;
       const real_t tmp_moved_constant_335 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_336 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_337 = -tmp_moved_constant_335 - tmp_moved_constant_336;
       const real_t tmp_moved_constant_338 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_339 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_340 = -tmp_moved_constant_338 - tmp_moved_constant_339;
       const real_t tmp_moved_constant_341 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_342 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_343 = -tmp_moved_constant_341 - tmp_moved_constant_342;
       const real_t tmp_moved_constant_344 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_345 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_346 = -tmp_moved_constant_344 - tmp_moved_constant_345;
       const real_t tmp_moved_constant_347 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_348 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_349 = -tmp_moved_constant_347 - tmp_moved_constant_348;
       const real_t tmp_moved_constant_350 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_351 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_352 = -tmp_moved_constant_350 - tmp_moved_constant_351;
       const real_t tmp_moved_constant_353 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_354 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_355 = -tmp_moved_constant_353 - tmp_moved_constant_354;
       const real_t tmp_moved_constant_356 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_357 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_358 = -tmp_moved_constant_356 - tmp_moved_constant_357;
       const real_t tmp_moved_constant_359 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_360 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_361 = -tmp_moved_constant_359 - tmp_moved_constant_360;
       const real_t tmp_moved_constant_362 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_363 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_364 = -tmp_moved_constant_362 - tmp_moved_constant_363;
       const real_t tmp_moved_constant_365 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_366 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_367 = -tmp_moved_constant_365 - tmp_moved_constant_366;
       const real_t tmp_moved_constant_368 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_369 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_370 = -tmp_moved_constant_368 - tmp_moved_constant_369;
       const real_t tmp_moved_constant_371 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_372 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_373 = -tmp_moved_constant_371 - tmp_moved_constant_372;
       const real_t tmp_moved_constant_374 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_375 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_376 = -tmp_moved_constant_374 - tmp_moved_constant_375;
       const real_t tmp_moved_constant_377 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_378 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_379 = -tmp_moved_constant_377 - tmp_moved_constant_378;
       const real_t tmp_moved_constant_380 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_381 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_382 = -tmp_moved_constant_380 - tmp_moved_constant_381;
       const real_t tmp_moved_constant_383 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_384 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_385 = -tmp_moved_constant_383 - tmp_moved_constant_384;
       const real_t tmp_moved_constant_386 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_387 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_388 = -tmp_moved_constant_386 - tmp_moved_constant_387;
       const real_t tmp_moved_constant_389 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_390 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_391 = -tmp_moved_constant_389 - tmp_moved_constant_390;
       const real_t tmp_moved_constant_392 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_393 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_394 = -tmp_moved_constant_392 - tmp_moved_constant_393;
       const real_t tmp_moved_constant_395 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_396 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_397 = -tmp_moved_constant_395 - tmp_moved_constant_396;
       const real_t tmp_moved_constant_398 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_399 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_400 = -tmp_moved_constant_398 - tmp_moved_constant_399;
       const real_t tmp_moved_constant_401 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_402 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_403 = -tmp_moved_constant_401 - tmp_moved_constant_402;
       const real_t tmp_moved_constant_404 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_405 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_406 = -tmp_moved_constant_404 - tmp_moved_constant_405;
       const real_t tmp_moved_constant_407 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_408 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_409 = -tmp_moved_constant_407 - tmp_moved_constant_408;
       const real_t tmp_moved_constant_410 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_411 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_412 = -tmp_moved_constant_410 - tmp_moved_constant_411;
       const real_t tmp_moved_constant_413 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_414 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_415 = -tmp_moved_constant_413 - tmp_moved_constant_414;
       const real_t tmp_moved_constant_416 = -jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_153 + tmp_moved_constant_308 + tmp_moved_constant_320;
       const real_t tmp_moved_constant_417 = -jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_156 + tmp_moved_constant_311 + tmp_moved_constant_323;
       const real_t tmp_moved_constant_418 = -jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_159 + tmp_moved_constant_314 + tmp_moved_constant_326;
       const real_t tmp_moved_constant_419 = -jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_162 + tmp_moved_constant_317 + tmp_moved_constant_329;
       const real_t tmp_moved_constant_420 = -jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_165 + tmp_moved_constant_309 + tmp_moved_constant_332;
       const real_t tmp_moved_constant_421 = -jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_168 + tmp_moved_constant_312 + tmp_moved_constant_335;
       const real_t tmp_moved_constant_422 = -jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_171 + tmp_moved_constant_315 + tmp_moved_constant_338;
       const real_t tmp_moved_constant_423 = -jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_174 + tmp_moved_constant_318 + tmp_moved_constant_341;
       const real_t tmp_moved_constant_424 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_176 + tmp_moved_constant_321 + tmp_moved_constant_333;
       const real_t tmp_moved_constant_425 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_178 + tmp_moved_constant_324 + tmp_moved_constant_336;
       const real_t tmp_moved_constant_426 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_180 + tmp_moved_constant_327 + tmp_moved_constant_339;
       const real_t tmp_moved_constant_427 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_182 + tmp_moved_constant_330 + tmp_moved_constant_342;
       const real_t tmp_moved_constant_428 = -jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_153 + tmp_moved_constant_344 + tmp_moved_constant_356;
       const real_t tmp_moved_constant_429 = -jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_156 + tmp_moved_constant_347 + tmp_moved_constant_359;
       const real_t tmp_moved_constant_430 = -jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_159 + tmp_moved_constant_350 + tmp_moved_constant_362;
       const real_t tmp_moved_constant_431 = -jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_162 + tmp_moved_constant_353 + tmp_moved_constant_365;
       const real_t tmp_moved_constant_432 = -jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_165 + tmp_moved_constant_345 + tmp_moved_constant_368;
       const real_t tmp_moved_constant_433 = -jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_168 + tmp_moved_constant_348 + tmp_moved_constant_371;
       const real_t tmp_moved_constant_434 = -jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_171 + tmp_moved_constant_351 + tmp_moved_constant_374;
       const real_t tmp_moved_constant_435 = -jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_174 + tmp_moved_constant_354 + tmp_moved_constant_377;
       const real_t tmp_moved_constant_436 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_176 + tmp_moved_constant_357 + tmp_moved_constant_369;
       const real_t tmp_moved_constant_437 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_178 + tmp_moved_constant_360 + tmp_moved_constant_372;
       const real_t tmp_moved_constant_438 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_180 + tmp_moved_constant_363 + tmp_moved_constant_375;
       const real_t tmp_moved_constant_439 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_182 + tmp_moved_constant_366 + tmp_moved_constant_378;
       const real_t tmp_moved_constant_440 = -jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_153 + tmp_moved_constant_380 + tmp_moved_constant_392;
       const real_t tmp_moved_constant_441 = -jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_156 + tmp_moved_constant_383 + tmp_moved_constant_395;
       const real_t tmp_moved_constant_442 = -jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_159 + tmp_moved_constant_386 + tmp_moved_constant_398;
       const real_t tmp_moved_constant_443 = -jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_162 + tmp_moved_constant_389 + tmp_moved_constant_401;
       const real_t tmp_moved_constant_444 = -jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_165 + tmp_moved_constant_381 + tmp_moved_constant_404;
       const real_t tmp_moved_constant_445 = -jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_168 + tmp_moved_constant_384 + tmp_moved_constant_407;
       const real_t tmp_moved_constant_446 = -jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_171 + tmp_moved_constant_387 + tmp_moved_constant_410;
       const real_t tmp_moved_constant_447 = -jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_174 + tmp_moved_constant_390 + tmp_moved_constant_413;
       const real_t tmp_moved_constant_448 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_176 + tmp_moved_constant_393 + tmp_moved_constant_405;
       const real_t tmp_moved_constant_449 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_178 + tmp_moved_constant_396 + tmp_moved_constant_408;
       const real_t tmp_moved_constant_450 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_180 + tmp_moved_constant_399 + tmp_moved_constant_411;
       const real_t tmp_moved_constant_451 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_182 + tmp_moved_constant_402 + tmp_moved_constant_414;
       const real_t tmp_moved_constant_452 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_208;
       const real_t tmp_moved_constant_453 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_210;
       const real_t tmp_moved_constant_454 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_212;
       const real_t tmp_moved_constant_455 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_214;
       const real_t tmp_moved_constant_456 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_208;
       const real_t tmp_moved_constant_457 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_210;
       const real_t tmp_moved_constant_458 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_212;
       const real_t tmp_moved_constant_459 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_214;
       const real_t tmp_moved_constant_460 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_208;
       const real_t tmp_moved_constant_461 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_210;
       const real_t tmp_moved_constant_462 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_212;
       const real_t tmp_moved_constant_463 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_214;
       const real_t tmp_moved_constant_464 = tmp_moved_constant_288*0.1381966011250105;
       const real_t tmp_moved_constant_465 = tmp_kernel_op_1*tmp_moved_constant_464;
       const real_t tmp_moved_constant_466 = tmp_moved_constant_291*0.1381966011250105;
       const real_t tmp_moved_constant_467 = tmp_kernel_op_6*tmp_moved_constant_466;
       const real_t tmp_moved_constant_468 = tmp_moved_constant_294*0.5854101966249684;
       const real_t tmp_moved_constant_469 = tmp_kernel_op_11*tmp_moved_constant_468;
       const real_t tmp_moved_constant_470 = tmp_moved_constant_297*0.1381966011250105;
       const real_t tmp_moved_constant_471 = tmp_kernel_op_16*tmp_moved_constant_470;
       const real_t tmp_moved_constant_472 = tmp_kernel_op_21*tmp_moved_constant_464;
       const real_t tmp_moved_constant_473 = tmp_kernel_op_24*tmp_moved_constant_466;
       const real_t tmp_moved_constant_474 = tmp_kernel_op_27*tmp_moved_constant_468;
       const real_t tmp_moved_constant_475 = tmp_kernel_op_30*tmp_moved_constant_470;
       const real_t tmp_moved_constant_476 = tmp_kernel_op_33*tmp_moved_constant_464;
       const real_t tmp_moved_constant_477 = tmp_kernel_op_36*tmp_moved_constant_466;
       const real_t tmp_moved_constant_478 = tmp_kernel_op_39*tmp_moved_constant_468;
       const real_t tmp_moved_constant_479 = tmp_kernel_op_42*tmp_moved_constant_470;
       const real_t tmp_moved_constant_480 = tmp_moved_constant_288*0.1381966011250105;
       const real_t tmp_moved_constant_481 = tmp_kernel_op_1*tmp_moved_constant_480;
       const real_t tmp_moved_constant_482 = tmp_moved_constant_291*0.5854101966249684;
       const real_t tmp_moved_constant_483 = tmp_kernel_op_6*tmp_moved_constant_482;
       const real_t tmp_moved_constant_484 = tmp_moved_constant_294*0.1381966011250105;
       const real_t tmp_moved_constant_485 = tmp_kernel_op_11*tmp_moved_constant_484;
       const real_t tmp_moved_constant_486 = tmp_moved_constant_297*0.1381966011250105;
       const real_t tmp_moved_constant_487 = tmp_kernel_op_16*tmp_moved_constant_486;
       const real_t tmp_moved_constant_488 = tmp_kernel_op_21*tmp_moved_constant_480;
       const real_t tmp_moved_constant_489 = tmp_kernel_op_24*tmp_moved_constant_482;
       const real_t tmp_moved_constant_490 = tmp_kernel_op_27*tmp_moved_constant_484;
       const real_t tmp_moved_constant_491 = tmp_kernel_op_30*tmp_moved_constant_486;
       const real_t tmp_moved_constant_492 = tmp_kernel_op_33*tmp_moved_constant_480;
       const real_t tmp_moved_constant_493 = tmp_kernel_op_36*tmp_moved_constant_482;
       const real_t tmp_moved_constant_494 = tmp_kernel_op_39*tmp_moved_constant_484;
       const real_t tmp_moved_constant_495 = tmp_kernel_op_42*tmp_moved_constant_486;
       const real_t tmp_moved_constant_496 = tmp_moved_constant_288*0.5854101966249684;
       const real_t tmp_moved_constant_497 = tmp_kernel_op_1*tmp_moved_constant_496;
       const real_t tmp_moved_constant_498 = tmp_moved_constant_291*0.1381966011250105;
       const real_t tmp_moved_constant_499 = tmp_kernel_op_6*tmp_moved_constant_498;
       const real_t tmp_moved_constant_500 = tmp_moved_constant_294*0.1381966011250105;
       const real_t tmp_moved_constant_501 = tmp_kernel_op_11*tmp_moved_constant_500;
       const real_t tmp_moved_constant_502 = tmp_moved_constant_297*0.1381966011250105;
       const real_t tmp_moved_constant_503 = tmp_kernel_op_16*tmp_moved_constant_502;
       const real_t tmp_moved_constant_504 = tmp_kernel_op_21*tmp_moved_constant_496;
       const real_t tmp_moved_constant_505 = tmp_kernel_op_24*tmp_moved_constant_498;
       const real_t tmp_moved_constant_506 = tmp_kernel_op_27*tmp_moved_constant_500;
       const real_t tmp_moved_constant_507 = tmp_kernel_op_30*tmp_moved_constant_502;
       const real_t tmp_moved_constant_508 = tmp_kernel_op_33*tmp_moved_constant_496;
       const real_t tmp_moved_constant_509 = tmp_kernel_op_36*tmp_moved_constant_498;
       const real_t tmp_moved_constant_510 = tmp_kernel_op_39*tmp_moved_constant_500;
       const real_t tmp_moved_constant_511 = tmp_kernel_op_42*tmp_moved_constant_502;
       const real_t tmp_moved_constant_546 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_547 = tmp_moved_constant_546*0.13819660112501053;
       const real_t tmp_moved_constant_548 = tmp_kernel_op_1*tmp_moved_constant_547;
       const real_t tmp_moved_constant_549 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_550 = tmp_moved_constant_549*0.13819660112501056;
       const real_t tmp_moved_constant_551 = tmp_kernel_op_6*tmp_moved_constant_550;
       const real_t tmp_moved_constant_552 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_553 = tmp_moved_constant_552*0.13819660112501056;
       const real_t tmp_moved_constant_554 = tmp_kernel_op_11*tmp_moved_constant_553;
       const real_t tmp_moved_constant_555 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_556 = tmp_moved_constant_555*0.5854101966249684;
       const real_t tmp_moved_constant_557 = tmp_kernel_op_16*tmp_moved_constant_556;
       const real_t tmp_moved_constant_558 = tmp_kernel_op_21*tmp_moved_constant_547;
       const real_t tmp_moved_constant_559 = tmp_kernel_op_24*tmp_moved_constant_550;
       const real_t tmp_moved_constant_560 = tmp_kernel_op_27*tmp_moved_constant_553;
       const real_t tmp_moved_constant_561 = tmp_kernel_op_30*tmp_moved_constant_556;
       const real_t tmp_moved_constant_562 = tmp_kernel_op_33*tmp_moved_constant_547;
       const real_t tmp_moved_constant_563 = tmp_kernel_op_36*tmp_moved_constant_550;
       const real_t tmp_moved_constant_564 = tmp_kernel_op_39*tmp_moved_constant_553;
       const real_t tmp_moved_constant_565 = tmp_kernel_op_42*tmp_moved_constant_556;
       const real_t tmp_moved_constant_566 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_567 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_568 = -tmp_moved_constant_566 - tmp_moved_constant_567;
       const real_t tmp_moved_constant_569 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_570 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_571 = -tmp_moved_constant_569 - tmp_moved_constant_570;
       const real_t tmp_moved_constant_572 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_573 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_574 = -tmp_moved_constant_572 - tmp_moved_constant_573;
       const real_t tmp_moved_constant_575 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_576 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_577 = -tmp_moved_constant_575 - tmp_moved_constant_576;
       const real_t tmp_moved_constant_578 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_579 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_580 = -tmp_moved_constant_578 - tmp_moved_constant_579;
       const real_t tmp_moved_constant_581 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_582 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_583 = -tmp_moved_constant_581 - tmp_moved_constant_582;
       const real_t tmp_moved_constant_584 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_585 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_586 = -tmp_moved_constant_584 - tmp_moved_constant_585;
       const real_t tmp_moved_constant_587 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_588 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_589 = -tmp_moved_constant_587 - tmp_moved_constant_588;
       const real_t tmp_moved_constant_590 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_591 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_592 = -tmp_moved_constant_590 - tmp_moved_constant_591;
       const real_t tmp_moved_constant_593 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_594 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_595 = -tmp_moved_constant_593 - tmp_moved_constant_594;
       const real_t tmp_moved_constant_596 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_597 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_598 = -tmp_moved_constant_596 - tmp_moved_constant_597;
       const real_t tmp_moved_constant_599 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_600 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_601 = -tmp_moved_constant_599 - tmp_moved_constant_600;
       const real_t tmp_moved_constant_602 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_603 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_604 = -tmp_moved_constant_602 - tmp_moved_constant_603;
       const real_t tmp_moved_constant_605 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_606 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_607 = -tmp_moved_constant_605 - tmp_moved_constant_606;
       const real_t tmp_moved_constant_608 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_609 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_610 = -tmp_moved_constant_608 - tmp_moved_constant_609;
       const real_t tmp_moved_constant_611 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_612 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_613 = -tmp_moved_constant_611 - tmp_moved_constant_612;
       const real_t tmp_moved_constant_614 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_615 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_616 = -tmp_moved_constant_614 - tmp_moved_constant_615;
       const real_t tmp_moved_constant_617 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_618 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_619 = -tmp_moved_constant_617 - tmp_moved_constant_618;
       const real_t tmp_moved_constant_620 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_621 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_622 = -tmp_moved_constant_620 - tmp_moved_constant_621;
       const real_t tmp_moved_constant_623 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_624 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_625 = -tmp_moved_constant_623 - tmp_moved_constant_624;
       const real_t tmp_moved_constant_626 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_627 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_628 = -tmp_moved_constant_626 - tmp_moved_constant_627;
       const real_t tmp_moved_constant_629 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_630 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_631 = -tmp_moved_constant_629 - tmp_moved_constant_630;
       const real_t tmp_moved_constant_632 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_633 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_634 = -tmp_moved_constant_632 - tmp_moved_constant_633;
       const real_t tmp_moved_constant_635 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_636 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_637 = -tmp_moved_constant_635 - tmp_moved_constant_636;
       const real_t tmp_moved_constant_638 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_639 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_640 = -tmp_moved_constant_638 - tmp_moved_constant_639;
       const real_t tmp_moved_constant_641 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_642 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_643 = -tmp_moved_constant_641 - tmp_moved_constant_642;
       const real_t tmp_moved_constant_644 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_645 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_646 = -tmp_moved_constant_644 - tmp_moved_constant_645;
       const real_t tmp_moved_constant_647 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_648 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_649 = -tmp_moved_constant_647 - tmp_moved_constant_648;
       const real_t tmp_moved_constant_650 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_651 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_652 = -tmp_moved_constant_650 - tmp_moved_constant_651;
       const real_t tmp_moved_constant_653 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_654 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_655 = -tmp_moved_constant_653 - tmp_moved_constant_654;
       const real_t tmp_moved_constant_656 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_657 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_658 = -tmp_moved_constant_656 - tmp_moved_constant_657;
       const real_t tmp_moved_constant_659 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_660 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_661 = -tmp_moved_constant_659 - tmp_moved_constant_660;
       const real_t tmp_moved_constant_662 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_663 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_664 = -tmp_moved_constant_662 - tmp_moved_constant_663;
       const real_t tmp_moved_constant_665 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_666 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_667 = -tmp_moved_constant_665 - tmp_moved_constant_666;
       const real_t tmp_moved_constant_668 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_669 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_670 = -tmp_moved_constant_668 - tmp_moved_constant_669;
       const real_t tmp_moved_constant_671 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_672 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_673 = -tmp_moved_constant_671 - tmp_moved_constant_672;
       const real_t tmp_moved_constant_674 = -jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_566 + tmp_moved_constant_578;
       const real_t tmp_moved_constant_675 = -jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_569 + tmp_moved_constant_581;
       const real_t tmp_moved_constant_676 = -jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_572 + tmp_moved_constant_584;
       const real_t tmp_moved_constant_677 = -jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_575 + tmp_moved_constant_587;
       const real_t tmp_moved_constant_678 = -jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_567 + tmp_moved_constant_590;
       const real_t tmp_moved_constant_679 = -jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_570 + tmp_moved_constant_593;
       const real_t tmp_moved_constant_680 = -jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_573 + tmp_moved_constant_596;
       const real_t tmp_moved_constant_681 = -jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_576 + tmp_moved_constant_599;
       const real_t tmp_moved_constant_682 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_579 + tmp_moved_constant_591;
       const real_t tmp_moved_constant_683 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_582 + tmp_moved_constant_594;
       const real_t tmp_moved_constant_684 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_585 + tmp_moved_constant_597;
       const real_t tmp_moved_constant_685 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_588 + tmp_moved_constant_600;
       const real_t tmp_moved_constant_686 = -jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_602 + tmp_moved_constant_614;
       const real_t tmp_moved_constant_687 = -jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_605 + tmp_moved_constant_617;
       const real_t tmp_moved_constant_688 = -jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_608 + tmp_moved_constant_620;
       const real_t tmp_moved_constant_689 = -jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_611 + tmp_moved_constant_623;
       const real_t tmp_moved_constant_690 = -jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_603 + tmp_moved_constant_626;
       const real_t tmp_moved_constant_691 = -jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_606 + tmp_moved_constant_629;
       const real_t tmp_moved_constant_692 = -jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_609 + tmp_moved_constant_632;
       const real_t tmp_moved_constant_693 = -jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_612 + tmp_moved_constant_635;
       const real_t tmp_moved_constant_694 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_615 + tmp_moved_constant_627;
       const real_t tmp_moved_constant_695 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_618 + tmp_moved_constant_630;
       const real_t tmp_moved_constant_696 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_621 + tmp_moved_constant_633;
       const real_t tmp_moved_constant_697 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_624 + tmp_moved_constant_636;
       const real_t tmp_moved_constant_698 = -jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_638 + tmp_moved_constant_650;
       const real_t tmp_moved_constant_699 = -jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_641 + tmp_moved_constant_653;
       const real_t tmp_moved_constant_700 = -jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_644 + tmp_moved_constant_656;
       const real_t tmp_moved_constant_701 = -jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_647 + tmp_moved_constant_659;
       const real_t tmp_moved_constant_702 = -jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_639 + tmp_moved_constant_662;
       const real_t tmp_moved_constant_703 = -jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_642 + tmp_moved_constant_665;
       const real_t tmp_moved_constant_704 = -jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_645 + tmp_moved_constant_668;
       const real_t tmp_moved_constant_705 = -jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_648 + tmp_moved_constant_671;
       const real_t tmp_moved_constant_706 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_651 + tmp_moved_constant_663;
       const real_t tmp_moved_constant_707 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_654 + tmp_moved_constant_666;
       const real_t tmp_moved_constant_708 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_657 + tmp_moved_constant_669;
       const real_t tmp_moved_constant_709 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_660 + tmp_moved_constant_672;
       const real_t tmp_moved_constant_710 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_711 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_712 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_713 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_714 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_715 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_716 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_717 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_718 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_719 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_720 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_721 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_722 = tmp_moved_constant_546*0.1381966011250105;
       const real_t tmp_moved_constant_723 = tmp_kernel_op_1*tmp_moved_constant_722;
       const real_t tmp_moved_constant_724 = tmp_moved_constant_549*0.1381966011250105;
       const real_t tmp_moved_constant_725 = tmp_kernel_op_6*tmp_moved_constant_724;
       const real_t tmp_moved_constant_726 = tmp_moved_constant_552*0.5854101966249684;
       const real_t tmp_moved_constant_727 = tmp_kernel_op_11*tmp_moved_constant_726;
       const real_t tmp_moved_constant_728 = tmp_moved_constant_555*0.1381966011250105;
       const real_t tmp_moved_constant_729 = tmp_kernel_op_16*tmp_moved_constant_728;
       const real_t tmp_moved_constant_730 = tmp_kernel_op_21*tmp_moved_constant_722;
       const real_t tmp_moved_constant_731 = tmp_kernel_op_24*tmp_moved_constant_724;
       const real_t tmp_moved_constant_732 = tmp_kernel_op_27*tmp_moved_constant_726;
       const real_t tmp_moved_constant_733 = tmp_kernel_op_30*tmp_moved_constant_728;
       const real_t tmp_moved_constant_734 = tmp_kernel_op_33*tmp_moved_constant_722;
       const real_t tmp_moved_constant_735 = tmp_kernel_op_36*tmp_moved_constant_724;
       const real_t tmp_moved_constant_736 = tmp_kernel_op_39*tmp_moved_constant_726;
       const real_t tmp_moved_constant_737 = tmp_kernel_op_42*tmp_moved_constant_728;
       const real_t tmp_moved_constant_738 = tmp_moved_constant_546*0.1381966011250105;
       const real_t tmp_moved_constant_739 = tmp_kernel_op_1*tmp_moved_constant_738;
       const real_t tmp_moved_constant_740 = tmp_moved_constant_549*0.5854101966249684;
       const real_t tmp_moved_constant_741 = tmp_kernel_op_6*tmp_moved_constant_740;
       const real_t tmp_moved_constant_742 = tmp_moved_constant_552*0.1381966011250105;
       const real_t tmp_moved_constant_743 = tmp_kernel_op_11*tmp_moved_constant_742;
       const real_t tmp_moved_constant_744 = tmp_moved_constant_555*0.1381966011250105;
       const real_t tmp_moved_constant_745 = tmp_kernel_op_16*tmp_moved_constant_744;
       const real_t tmp_moved_constant_746 = tmp_kernel_op_21*tmp_moved_constant_738;
       const real_t tmp_moved_constant_747 = tmp_kernel_op_24*tmp_moved_constant_740;
       const real_t tmp_moved_constant_748 = tmp_kernel_op_27*tmp_moved_constant_742;
       const real_t tmp_moved_constant_749 = tmp_kernel_op_30*tmp_moved_constant_744;
       const real_t tmp_moved_constant_750 = tmp_kernel_op_33*tmp_moved_constant_738;
       const real_t tmp_moved_constant_751 = tmp_kernel_op_36*tmp_moved_constant_740;
       const real_t tmp_moved_constant_752 = tmp_kernel_op_39*tmp_moved_constant_742;
       const real_t tmp_moved_constant_753 = tmp_kernel_op_42*tmp_moved_constant_744;
       const real_t tmp_moved_constant_754 = tmp_moved_constant_546*0.5854101966249684;
       const real_t tmp_moved_constant_755 = tmp_kernel_op_1*tmp_moved_constant_754;
       const real_t tmp_moved_constant_756 = tmp_moved_constant_549*0.1381966011250105;
       const real_t tmp_moved_constant_757 = tmp_kernel_op_6*tmp_moved_constant_756;
       const real_t tmp_moved_constant_758 = tmp_moved_constant_552*0.1381966011250105;
       const real_t tmp_moved_constant_759 = tmp_kernel_op_11*tmp_moved_constant_758;
       const real_t tmp_moved_constant_760 = tmp_moved_constant_555*0.1381966011250105;
       const real_t tmp_moved_constant_761 = tmp_kernel_op_16*tmp_moved_constant_760;
       const real_t tmp_moved_constant_762 = tmp_kernel_op_21*tmp_moved_constant_754;
       const real_t tmp_moved_constant_763 = tmp_kernel_op_24*tmp_moved_constant_756;
       const real_t tmp_moved_constant_764 = tmp_kernel_op_27*tmp_moved_constant_758;
       const real_t tmp_moved_constant_765 = tmp_kernel_op_30*tmp_moved_constant_760;
       const real_t tmp_moved_constant_766 = tmp_kernel_op_33*tmp_moved_constant_754;
       const real_t tmp_moved_constant_767 = tmp_kernel_op_36*tmp_moved_constant_756;
       const real_t tmp_moved_constant_768 = tmp_kernel_op_39*tmp_moved_constant_758;
       const real_t tmp_moved_constant_769 = tmp_kernel_op_42*tmp_moved_constant_760;
       const real_t tmp_moved_constant_804 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_805 = tmp_moved_constant_804*0.13819660112501053;
       const real_t tmp_moved_constant_806 = tmp_kernel_op_1*tmp_moved_constant_805;
       const real_t tmp_moved_constant_807 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_808 = tmp_moved_constant_807*0.13819660112501056;
       const real_t tmp_moved_constant_809 = tmp_kernel_op_6*tmp_moved_constant_808;
       const real_t tmp_moved_constant_810 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_811 = tmp_moved_constant_810*0.13819660112501056;
       const real_t tmp_moved_constant_812 = tmp_kernel_op_11*tmp_moved_constant_811;
       const real_t tmp_moved_constant_813 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_814 = tmp_moved_constant_813*0.5854101966249684;
       const real_t tmp_moved_constant_815 = tmp_kernel_op_16*tmp_moved_constant_814;
       const real_t tmp_moved_constant_816 = tmp_kernel_op_21*tmp_moved_constant_805;
       const real_t tmp_moved_constant_817 = tmp_kernel_op_24*tmp_moved_constant_808;
       const real_t tmp_moved_constant_818 = tmp_kernel_op_27*tmp_moved_constant_811;
       const real_t tmp_moved_constant_819 = tmp_kernel_op_30*tmp_moved_constant_814;
       const real_t tmp_moved_constant_820 = tmp_kernel_op_33*tmp_moved_constant_805;
       const real_t tmp_moved_constant_821 = tmp_kernel_op_36*tmp_moved_constant_808;
       const real_t tmp_moved_constant_822 = tmp_kernel_op_39*tmp_moved_constant_811;
       const real_t tmp_moved_constant_823 = tmp_kernel_op_42*tmp_moved_constant_814;
       const real_t tmp_moved_constant_824 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_825 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_826 = -tmp_moved_constant_824 - tmp_moved_constant_825;
       const real_t tmp_moved_constant_827 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_828 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_829 = -tmp_moved_constant_827 - tmp_moved_constant_828;
       const real_t tmp_moved_constant_830 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_831 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_832 = -tmp_moved_constant_830 - tmp_moved_constant_831;
       const real_t tmp_moved_constant_833 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_834 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_835 = -tmp_moved_constant_833 - tmp_moved_constant_834;
       const real_t tmp_moved_constant_836 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_837 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_838 = -tmp_moved_constant_836 - tmp_moved_constant_837;
       const real_t tmp_moved_constant_839 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_840 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_841 = -tmp_moved_constant_839 - tmp_moved_constant_840;
       const real_t tmp_moved_constant_842 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_843 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_844 = -tmp_moved_constant_842 - tmp_moved_constant_843;
       const real_t tmp_moved_constant_845 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_846 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_847 = -tmp_moved_constant_845 - tmp_moved_constant_846;
       const real_t tmp_moved_constant_848 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_849 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_850 = -tmp_moved_constant_848 - tmp_moved_constant_849;
       const real_t tmp_moved_constant_851 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_852 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_853 = -tmp_moved_constant_851 - tmp_moved_constant_852;
       const real_t tmp_moved_constant_854 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_855 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_856 = -tmp_moved_constant_854 - tmp_moved_constant_855;
       const real_t tmp_moved_constant_857 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_858 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_859 = -tmp_moved_constant_857 - tmp_moved_constant_858;
       const real_t tmp_moved_constant_860 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_861 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_862 = -tmp_moved_constant_860 - tmp_moved_constant_861;
       const real_t tmp_moved_constant_863 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_864 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_865 = -tmp_moved_constant_863 - tmp_moved_constant_864;
       const real_t tmp_moved_constant_866 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_867 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_868 = -tmp_moved_constant_866 - tmp_moved_constant_867;
       const real_t tmp_moved_constant_869 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_870 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_871 = -tmp_moved_constant_869 - tmp_moved_constant_870;
       const real_t tmp_moved_constant_872 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_873 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_874 = -tmp_moved_constant_872 - tmp_moved_constant_873;
       const real_t tmp_moved_constant_875 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_876 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_877 = -tmp_moved_constant_875 - tmp_moved_constant_876;
       const real_t tmp_moved_constant_878 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_879 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_880 = -tmp_moved_constant_878 - tmp_moved_constant_879;
       const real_t tmp_moved_constant_881 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_882 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_883 = -tmp_moved_constant_881 - tmp_moved_constant_882;
       const real_t tmp_moved_constant_884 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_885 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_886 = -tmp_moved_constant_884 - tmp_moved_constant_885;
       const real_t tmp_moved_constant_887 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_888 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_889 = -tmp_moved_constant_887 - tmp_moved_constant_888;
       const real_t tmp_moved_constant_890 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_891 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_892 = -tmp_moved_constant_890 - tmp_moved_constant_891;
       const real_t tmp_moved_constant_893 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_894 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_895 = -tmp_moved_constant_893 - tmp_moved_constant_894;
       const real_t tmp_moved_constant_896 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_897 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_898 = -tmp_moved_constant_896 - tmp_moved_constant_897;
       const real_t tmp_moved_constant_899 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_900 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_901 = -tmp_moved_constant_899 - tmp_moved_constant_900;
       const real_t tmp_moved_constant_902 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_903 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_904 = -tmp_moved_constant_902 - tmp_moved_constant_903;
       const real_t tmp_moved_constant_905 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_906 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_907 = -tmp_moved_constant_905 - tmp_moved_constant_906;
       const real_t tmp_moved_constant_908 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_32;
       const real_t tmp_moved_constant_909 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_910 = -tmp_moved_constant_908 - tmp_moved_constant_909;
       const real_t tmp_moved_constant_911 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_35;
       const real_t tmp_moved_constant_912 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_913 = -tmp_moved_constant_911 - tmp_moved_constant_912;
       const real_t tmp_moved_constant_914 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_915 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_916 = -tmp_moved_constant_914 - tmp_moved_constant_915;
       const real_t tmp_moved_constant_917 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_41;
       const real_t tmp_moved_constant_918 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_919 = -tmp_moved_constant_917 - tmp_moved_constant_918;
       const real_t tmp_moved_constant_920 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_921 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_922 = -tmp_moved_constant_920 - tmp_moved_constant_921;
       const real_t tmp_moved_constant_923 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_924 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_5;
       const real_t tmp_moved_constant_925 = -tmp_moved_constant_923 - tmp_moved_constant_924;
       const real_t tmp_moved_constant_926 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_927 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_928 = -tmp_moved_constant_926 - tmp_moved_constant_927;
       const real_t tmp_moved_constant_929 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_930 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_931 = -tmp_moved_constant_929 - tmp_moved_constant_930;
       const real_t tmp_moved_constant_932 = -jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_153 + tmp_moved_constant_824 + tmp_moved_constant_836;
       const real_t tmp_moved_constant_933 = -jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_156 + tmp_moved_constant_827 + tmp_moved_constant_839;
       const real_t tmp_moved_constant_934 = -jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_159 + tmp_moved_constant_830 + tmp_moved_constant_842;
       const real_t tmp_moved_constant_935 = -jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_162 + tmp_moved_constant_833 + tmp_moved_constant_845;
       const real_t tmp_moved_constant_936 = -jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_165 + tmp_moved_constant_825 + tmp_moved_constant_848;
       const real_t tmp_moved_constant_937 = -jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_168 + tmp_moved_constant_828 + tmp_moved_constant_851;
       const real_t tmp_moved_constant_938 = -jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_171 + tmp_moved_constant_831 + tmp_moved_constant_854;
       const real_t tmp_moved_constant_939 = -jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_174 + tmp_moved_constant_834 + tmp_moved_constant_857;
       const real_t tmp_moved_constant_940 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_176 + tmp_moved_constant_837 + tmp_moved_constant_849;
       const real_t tmp_moved_constant_941 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_178 + tmp_moved_constant_840 + tmp_moved_constant_852;
       const real_t tmp_moved_constant_942 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_180 + tmp_moved_constant_843 + tmp_moved_constant_855;
       const real_t tmp_moved_constant_943 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_182 + tmp_moved_constant_846 + tmp_moved_constant_858;
       const real_t tmp_moved_constant_944 = -jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_153 + tmp_moved_constant_860 + tmp_moved_constant_872;
       const real_t tmp_moved_constant_945 = -jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_156 + tmp_moved_constant_863 + tmp_moved_constant_875;
       const real_t tmp_moved_constant_946 = -jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_159 + tmp_moved_constant_866 + tmp_moved_constant_878;
       const real_t tmp_moved_constant_947 = -jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_162 + tmp_moved_constant_869 + tmp_moved_constant_881;
       const real_t tmp_moved_constant_948 = -jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_165 + tmp_moved_constant_861 + tmp_moved_constant_884;
       const real_t tmp_moved_constant_949 = -jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_168 + tmp_moved_constant_864 + tmp_moved_constant_887;
       const real_t tmp_moved_constant_950 = -jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_171 + tmp_moved_constant_867 + tmp_moved_constant_890;
       const real_t tmp_moved_constant_951 = -jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_174 + tmp_moved_constant_870 + tmp_moved_constant_893;
       const real_t tmp_moved_constant_952 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_176 + tmp_moved_constant_873 + tmp_moved_constant_885;
       const real_t tmp_moved_constant_953 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_178 + tmp_moved_constant_876 + tmp_moved_constant_888;
       const real_t tmp_moved_constant_954 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_180 + tmp_moved_constant_879 + tmp_moved_constant_891;
       const real_t tmp_moved_constant_955 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_182 + tmp_moved_constant_882 + tmp_moved_constant_894;
       const real_t tmp_moved_constant_956 = -jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_153 + tmp_moved_constant_896 + tmp_moved_constant_908;
       const real_t tmp_moved_constant_957 = -jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_156 + tmp_moved_constant_899 + tmp_moved_constant_911;
       const real_t tmp_moved_constant_958 = -jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_159 + tmp_moved_constant_902 + tmp_moved_constant_914;
       const real_t tmp_moved_constant_959 = -jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_162 + tmp_moved_constant_905 + tmp_moved_constant_917;
       const real_t tmp_moved_constant_960 = -jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_165 + tmp_moved_constant_897 + tmp_moved_constant_920;
       const real_t tmp_moved_constant_961 = -jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_168 + tmp_moved_constant_900 + tmp_moved_constant_923;
       const real_t tmp_moved_constant_962 = -jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_171 + tmp_moved_constant_903 + tmp_moved_constant_926;
       const real_t tmp_moved_constant_963 = -jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_174 + tmp_moved_constant_906 + tmp_moved_constant_929;
       const real_t tmp_moved_constant_964 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_176 + tmp_moved_constant_909 + tmp_moved_constant_921;
       const real_t tmp_moved_constant_965 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_178 + tmp_moved_constant_912 + tmp_moved_constant_924;
       const real_t tmp_moved_constant_966 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_180 + tmp_moved_constant_915 + tmp_moved_constant_927;
       const real_t tmp_moved_constant_967 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_182 + tmp_moved_constant_918 + tmp_moved_constant_930;
       const real_t tmp_moved_constant_968 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_208;
       const real_t tmp_moved_constant_969 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_210;
       const real_t tmp_moved_constant_970 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_212;
       const real_t tmp_moved_constant_971 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_214;
       const real_t tmp_moved_constant_972 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_208;
       const real_t tmp_moved_constant_973 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_210;
       const real_t tmp_moved_constant_974 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_212;
       const real_t tmp_moved_constant_975 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_214;
       const real_t tmp_moved_constant_976 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_208;
       const real_t tmp_moved_constant_977 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_210;
       const real_t tmp_moved_constant_978 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_212;
       const real_t tmp_moved_constant_979 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_214;
       const real_t tmp_moved_constant_980 = tmp_moved_constant_804*0.1381966011250105;
       const real_t tmp_moved_constant_981 = tmp_kernel_op_1*tmp_moved_constant_980;
       const real_t tmp_moved_constant_982 = tmp_moved_constant_807*0.1381966011250105;
       const real_t tmp_moved_constant_983 = tmp_kernel_op_6*tmp_moved_constant_982;
       const real_t tmp_moved_constant_984 = tmp_moved_constant_810*0.5854101966249684;
       const real_t tmp_moved_constant_985 = tmp_kernel_op_11*tmp_moved_constant_984;
       const real_t tmp_moved_constant_986 = tmp_moved_constant_813*0.1381966011250105;
       const real_t tmp_moved_constant_987 = tmp_kernel_op_16*tmp_moved_constant_986;
       const real_t tmp_moved_constant_988 = tmp_kernel_op_21*tmp_moved_constant_980;
       const real_t tmp_moved_constant_989 = tmp_kernel_op_24*tmp_moved_constant_982;
       const real_t tmp_moved_constant_990 = tmp_kernel_op_27*tmp_moved_constant_984;
       const real_t tmp_moved_constant_991 = tmp_kernel_op_30*tmp_moved_constant_986;
       const real_t tmp_moved_constant_992 = tmp_kernel_op_33*tmp_moved_constant_980;
       const real_t tmp_moved_constant_993 = tmp_kernel_op_36*tmp_moved_constant_982;
       const real_t tmp_moved_constant_994 = tmp_kernel_op_39*tmp_moved_constant_984;
       const real_t tmp_moved_constant_995 = tmp_kernel_op_42*tmp_moved_constant_986;
       const real_t tmp_moved_constant_996 = tmp_moved_constant_804*0.1381966011250105;
       const real_t tmp_moved_constant_997 = tmp_kernel_op_1*tmp_moved_constant_996;
       const real_t tmp_moved_constant_998 = tmp_moved_constant_807*0.5854101966249684;
       const real_t tmp_moved_constant_999 = tmp_kernel_op_6*tmp_moved_constant_998;
       const real_t tmp_moved_constant_1000 = tmp_moved_constant_810*0.1381966011250105;
       const real_t tmp_moved_constant_1001 = tmp_kernel_op_11*tmp_moved_constant_1000;
       const real_t tmp_moved_constant_1002 = tmp_moved_constant_813*0.1381966011250105;
       const real_t tmp_moved_constant_1003 = tmp_kernel_op_16*tmp_moved_constant_1002;
       const real_t tmp_moved_constant_1004 = tmp_kernel_op_21*tmp_moved_constant_996;
       const real_t tmp_moved_constant_1005 = tmp_kernel_op_24*tmp_moved_constant_998;
       const real_t tmp_moved_constant_1006 = tmp_kernel_op_27*tmp_moved_constant_1000;
       const real_t tmp_moved_constant_1007 = tmp_kernel_op_30*tmp_moved_constant_1002;
       const real_t tmp_moved_constant_1008 = tmp_kernel_op_33*tmp_moved_constant_996;
       const real_t tmp_moved_constant_1009 = tmp_kernel_op_36*tmp_moved_constant_998;
       const real_t tmp_moved_constant_1010 = tmp_kernel_op_39*tmp_moved_constant_1000;
       const real_t tmp_moved_constant_1011 = tmp_kernel_op_42*tmp_moved_constant_1002;
       const real_t tmp_moved_constant_1012 = tmp_moved_constant_804*0.5854101966249684;
       const real_t tmp_moved_constant_1013 = tmp_kernel_op_1*tmp_moved_constant_1012;
       const real_t tmp_moved_constant_1014 = tmp_moved_constant_807*0.1381966011250105;
       const real_t tmp_moved_constant_1015 = tmp_kernel_op_6*tmp_moved_constant_1014;
       const real_t tmp_moved_constant_1016 = tmp_moved_constant_810*0.1381966011250105;
       const real_t tmp_moved_constant_1017 = tmp_kernel_op_11*tmp_moved_constant_1016;
       const real_t tmp_moved_constant_1018 = tmp_moved_constant_813*0.1381966011250105;
       const real_t tmp_moved_constant_1019 = tmp_kernel_op_16*tmp_moved_constant_1018;
       const real_t tmp_moved_constant_1020 = tmp_kernel_op_21*tmp_moved_constant_1012;
       const real_t tmp_moved_constant_1021 = tmp_kernel_op_24*tmp_moved_constant_1014;
       const real_t tmp_moved_constant_1022 = tmp_kernel_op_27*tmp_moved_constant_1016;
       const real_t tmp_moved_constant_1023 = tmp_kernel_op_30*tmp_moved_constant_1018;
       const real_t tmp_moved_constant_1024 = tmp_kernel_op_33*tmp_moved_constant_1012;
       const real_t tmp_moved_constant_1025 = tmp_kernel_op_36*tmp_moved_constant_1014;
       const real_t tmp_moved_constant_1026 = tmp_kernel_op_39*tmp_moved_constant_1016;
       const real_t tmp_moved_constant_1027 = tmp_kernel_op_42*tmp_moved_constant_1018;
       const real_t tmp_moved_constant_1062 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_1063 = tmp_moved_constant_1062*0.13819660112501053;
       const real_t tmp_moved_constant_1064 = tmp_kernel_op_1*tmp_moved_constant_1063;
       const real_t tmp_moved_constant_1065 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_1066 = tmp_moved_constant_1065*0.13819660112501056;
       const real_t tmp_moved_constant_1067 = tmp_kernel_op_6*tmp_moved_constant_1066;
       const real_t tmp_moved_constant_1068 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_1069 = tmp_moved_constant_1068*0.13819660112501056;
       const real_t tmp_moved_constant_1070 = tmp_kernel_op_11*tmp_moved_constant_1069;
       const real_t tmp_moved_constant_1071 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_1072 = tmp_moved_constant_1071*0.5854101966249684;
       const real_t tmp_moved_constant_1073 = tmp_kernel_op_16*tmp_moved_constant_1072;
       const real_t tmp_moved_constant_1074 = tmp_kernel_op_21*tmp_moved_constant_1063;
       const real_t tmp_moved_constant_1075 = tmp_kernel_op_24*tmp_moved_constant_1066;
       const real_t tmp_moved_constant_1076 = tmp_kernel_op_27*tmp_moved_constant_1069;
       const real_t tmp_moved_constant_1077 = tmp_kernel_op_30*tmp_moved_constant_1072;
       const real_t tmp_moved_constant_1078 = tmp_kernel_op_33*tmp_moved_constant_1063;
       const real_t tmp_moved_constant_1079 = tmp_kernel_op_36*tmp_moved_constant_1066;
       const real_t tmp_moved_constant_1080 = tmp_kernel_op_39*tmp_moved_constant_1069;
       const real_t tmp_moved_constant_1081 = tmp_kernel_op_42*tmp_moved_constant_1072;
       const real_t tmp_moved_constant_1082 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_1083 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1084 = -tmp_moved_constant_1082 - tmp_moved_constant_1083;
       const real_t tmp_moved_constant_1085 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_1086 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_1087 = -tmp_moved_constant_1085 - tmp_moved_constant_1086;
       const real_t tmp_moved_constant_1088 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1089 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1090 = -tmp_moved_constant_1088 - tmp_moved_constant_1089;
       const real_t tmp_moved_constant_1091 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_1092 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1093 = -tmp_moved_constant_1091 - tmp_moved_constant_1092;
       const real_t tmp_moved_constant_1094 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_1095 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1096 = -tmp_moved_constant_1094 - tmp_moved_constant_1095;
       const real_t tmp_moved_constant_1097 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_1098 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_1099 = -tmp_moved_constant_1097 - tmp_moved_constant_1098;
       const real_t tmp_moved_constant_1100 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1101 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1102 = -tmp_moved_constant_1100 - tmp_moved_constant_1101;
       const real_t tmp_moved_constant_1103 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_1104 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_1105 = -tmp_moved_constant_1103 - tmp_moved_constant_1104;
       const real_t tmp_moved_constant_1106 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1107 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1108 = -tmp_moved_constant_1106 - tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1109 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_1110 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_1111 = -tmp_moved_constant_1109 - tmp_moved_constant_1110;
       const real_t tmp_moved_constant_1112 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1113 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1114 = -tmp_moved_constant_1112 - tmp_moved_constant_1113;
       const real_t tmp_moved_constant_1115 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1116 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_1117 = -tmp_moved_constant_1115 - tmp_moved_constant_1116;
       const real_t tmp_moved_constant_1118 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_1119 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1120 = -tmp_moved_constant_1118 - tmp_moved_constant_1119;
       const real_t tmp_moved_constant_1121 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_1122 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_1123 = -tmp_moved_constant_1121 - tmp_moved_constant_1122;
       const real_t tmp_moved_constant_1124 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1125 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1126 = -tmp_moved_constant_1124 - tmp_moved_constant_1125;
       const real_t tmp_moved_constant_1127 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_1128 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1129 = -tmp_moved_constant_1127 - tmp_moved_constant_1128;
       const real_t tmp_moved_constant_1130 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_1131 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1132 = -tmp_moved_constant_1130 - tmp_moved_constant_1131;
       const real_t tmp_moved_constant_1133 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_1134 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_1135 = -tmp_moved_constant_1133 - tmp_moved_constant_1134;
       const real_t tmp_moved_constant_1136 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1137 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1138 = -tmp_moved_constant_1136 - tmp_moved_constant_1137;
       const real_t tmp_moved_constant_1139 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_1140 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_1141 = -tmp_moved_constant_1139 - tmp_moved_constant_1140;
       const real_t tmp_moved_constant_1142 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1143 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1144 = -tmp_moved_constant_1142 - tmp_moved_constant_1143;
       const real_t tmp_moved_constant_1145 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_1146 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_1147 = -tmp_moved_constant_1145 - tmp_moved_constant_1146;
       const real_t tmp_moved_constant_1148 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1149 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1150 = -tmp_moved_constant_1148 - tmp_moved_constant_1149;
       const real_t tmp_moved_constant_1151 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1152 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_1153 = -tmp_moved_constant_1151 - tmp_moved_constant_1152;
       const real_t tmp_moved_constant_1154 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_1155 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1156 = -tmp_moved_constant_1154 - tmp_moved_constant_1155;
       const real_t tmp_moved_constant_1157 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_1158 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_1159 = -tmp_moved_constant_1157 - tmp_moved_constant_1158;
       const real_t tmp_moved_constant_1160 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1161 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1162 = -tmp_moved_constant_1160 - tmp_moved_constant_1161;
       const real_t tmp_moved_constant_1163 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_1164 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1165 = -tmp_moved_constant_1163 - tmp_moved_constant_1164;
       const real_t tmp_moved_constant_1166 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_32;
       const real_t tmp_moved_constant_1167 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1168 = -tmp_moved_constant_1166 - tmp_moved_constant_1167;
       const real_t tmp_moved_constant_1169 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_35;
       const real_t tmp_moved_constant_1170 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_1171 = -tmp_moved_constant_1169 - tmp_moved_constant_1170;
       const real_t tmp_moved_constant_1172 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1173 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1174 = -tmp_moved_constant_1172 - tmp_moved_constant_1173;
       const real_t tmp_moved_constant_1175 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_41;
       const real_t tmp_moved_constant_1176 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_1177 = -tmp_moved_constant_1175 - tmp_moved_constant_1176;
       const real_t tmp_moved_constant_1178 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1179 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1180 = -tmp_moved_constant_1178 - tmp_moved_constant_1179;
       const real_t tmp_moved_constant_1181 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_1182 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_5;
       const real_t tmp_moved_constant_1183 = -tmp_moved_constant_1181 - tmp_moved_constant_1182;
       const real_t tmp_moved_constant_1184 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1185 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1186 = -tmp_moved_constant_1184 - tmp_moved_constant_1185;
       const real_t tmp_moved_constant_1187 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1188 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_1189 = -tmp_moved_constant_1187 - tmp_moved_constant_1188;
       const real_t tmp_moved_constant_1190 = -jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_153 + tmp_moved_constant_1082 + tmp_moved_constant_1094;
       const real_t tmp_moved_constant_1191 = -jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_156 + tmp_moved_constant_1085 + tmp_moved_constant_1097;
       const real_t tmp_moved_constant_1192 = -jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_159 + tmp_moved_constant_1088 + tmp_moved_constant_1100;
       const real_t tmp_moved_constant_1193 = -jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_162 + tmp_moved_constant_1091 + tmp_moved_constant_1103;
       const real_t tmp_moved_constant_1194 = -jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_165 + tmp_moved_constant_1083 + tmp_moved_constant_1106;
       const real_t tmp_moved_constant_1195 = -jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_168 + tmp_moved_constant_1086 + tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1196 = -jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_171 + tmp_moved_constant_1089 + tmp_moved_constant_1112;
       const real_t tmp_moved_constant_1197 = -jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_174 + tmp_moved_constant_1092 + tmp_moved_constant_1115;
       const real_t tmp_moved_constant_1198 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_176 + tmp_moved_constant_1095 + tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1199 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_178 + tmp_moved_constant_1098 + tmp_moved_constant_1110;
       const real_t tmp_moved_constant_1200 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_180 + tmp_moved_constant_1101 + tmp_moved_constant_1113;
       const real_t tmp_moved_constant_1201 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_182 + tmp_moved_constant_1104 + tmp_moved_constant_1116;
       const real_t tmp_moved_constant_1202 = -jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_153 + tmp_moved_constant_1118 + tmp_moved_constant_1130;
       const real_t tmp_moved_constant_1203 = -jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_156 + tmp_moved_constant_1121 + tmp_moved_constant_1133;
       const real_t tmp_moved_constant_1204 = -jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_159 + tmp_moved_constant_1124 + tmp_moved_constant_1136;
       const real_t tmp_moved_constant_1205 = -jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_162 + tmp_moved_constant_1127 + tmp_moved_constant_1139;
       const real_t tmp_moved_constant_1206 = -jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_165 + tmp_moved_constant_1119 + tmp_moved_constant_1142;
       const real_t tmp_moved_constant_1207 = -jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_168 + tmp_moved_constant_1122 + tmp_moved_constant_1145;
       const real_t tmp_moved_constant_1208 = -jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_171 + tmp_moved_constant_1125 + tmp_moved_constant_1148;
       const real_t tmp_moved_constant_1209 = -jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_174 + tmp_moved_constant_1128 + tmp_moved_constant_1151;
       const real_t tmp_moved_constant_1210 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_176 + tmp_moved_constant_1131 + tmp_moved_constant_1143;
       const real_t tmp_moved_constant_1211 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_178 + tmp_moved_constant_1134 + tmp_moved_constant_1146;
       const real_t tmp_moved_constant_1212 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_180 + tmp_moved_constant_1137 + tmp_moved_constant_1149;
       const real_t tmp_moved_constant_1213 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_182 + tmp_moved_constant_1140 + tmp_moved_constant_1152;
       const real_t tmp_moved_constant_1214 = -jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_153 + tmp_moved_constant_1154 + tmp_moved_constant_1166;
       const real_t tmp_moved_constant_1215 = -jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_156 + tmp_moved_constant_1157 + tmp_moved_constant_1169;
       const real_t tmp_moved_constant_1216 = -jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_159 + tmp_moved_constant_1160 + tmp_moved_constant_1172;
       const real_t tmp_moved_constant_1217 = -jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_162 + tmp_moved_constant_1163 + tmp_moved_constant_1175;
       const real_t tmp_moved_constant_1218 = -jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_165 + tmp_moved_constant_1155 + tmp_moved_constant_1178;
       const real_t tmp_moved_constant_1219 = -jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_168 + tmp_moved_constant_1158 + tmp_moved_constant_1181;
       const real_t tmp_moved_constant_1220 = -jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_171 + tmp_moved_constant_1161 + tmp_moved_constant_1184;
       const real_t tmp_moved_constant_1221 = -jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_174 + tmp_moved_constant_1164 + tmp_moved_constant_1187;
       const real_t tmp_moved_constant_1222 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_176 + tmp_moved_constant_1167 + tmp_moved_constant_1179;
       const real_t tmp_moved_constant_1223 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_178 + tmp_moved_constant_1170 + tmp_moved_constant_1182;
       const real_t tmp_moved_constant_1224 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_180 + tmp_moved_constant_1173 + tmp_moved_constant_1185;
       const real_t tmp_moved_constant_1225 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_182 + tmp_moved_constant_1176 + tmp_moved_constant_1188;
       const real_t tmp_moved_constant_1226 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_1227 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_1228 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_1229 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_1230 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_1231 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_1232 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_1233 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_1234 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_208;
       const real_t tmp_moved_constant_1235 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_210;
       const real_t tmp_moved_constant_1236 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_212;
       const real_t tmp_moved_constant_1237 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_214;
       const real_t tmp_moved_constant_1238 = tmp_moved_constant_1062*0.1381966011250105;
       const real_t tmp_moved_constant_1239 = tmp_kernel_op_1*tmp_moved_constant_1238;
       const real_t tmp_moved_constant_1240 = tmp_moved_constant_1065*0.1381966011250105;
       const real_t tmp_moved_constant_1241 = tmp_kernel_op_6*tmp_moved_constant_1240;
       const real_t tmp_moved_constant_1242 = tmp_moved_constant_1068*0.5854101966249684;
       const real_t tmp_moved_constant_1243 = tmp_kernel_op_11*tmp_moved_constant_1242;
       const real_t tmp_moved_constant_1244 = tmp_moved_constant_1071*0.1381966011250105;
       const real_t tmp_moved_constant_1245 = tmp_kernel_op_16*tmp_moved_constant_1244;
       const real_t tmp_moved_constant_1246 = tmp_kernel_op_21*tmp_moved_constant_1238;
       const real_t tmp_moved_constant_1247 = tmp_kernel_op_24*tmp_moved_constant_1240;
       const real_t tmp_moved_constant_1248 = tmp_kernel_op_27*tmp_moved_constant_1242;
       const real_t tmp_moved_constant_1249 = tmp_kernel_op_30*tmp_moved_constant_1244;
       const real_t tmp_moved_constant_1250 = tmp_kernel_op_33*tmp_moved_constant_1238;
       const real_t tmp_moved_constant_1251 = tmp_kernel_op_36*tmp_moved_constant_1240;
       const real_t tmp_moved_constant_1252 = tmp_kernel_op_39*tmp_moved_constant_1242;
       const real_t tmp_moved_constant_1253 = tmp_kernel_op_42*tmp_moved_constant_1244;
       const real_t tmp_moved_constant_1254 = tmp_moved_constant_1062*0.1381966011250105;
       const real_t tmp_moved_constant_1255 = tmp_kernel_op_1*tmp_moved_constant_1254;
       const real_t tmp_moved_constant_1256 = tmp_moved_constant_1065*0.5854101966249684;
       const real_t tmp_moved_constant_1257 = tmp_kernel_op_6*tmp_moved_constant_1256;
       const real_t tmp_moved_constant_1258 = tmp_moved_constant_1068*0.1381966011250105;
       const real_t tmp_moved_constant_1259 = tmp_kernel_op_11*tmp_moved_constant_1258;
       const real_t tmp_moved_constant_1260 = tmp_moved_constant_1071*0.1381966011250105;
       const real_t tmp_moved_constant_1261 = tmp_kernel_op_16*tmp_moved_constant_1260;
       const real_t tmp_moved_constant_1262 = tmp_kernel_op_21*tmp_moved_constant_1254;
       const real_t tmp_moved_constant_1263 = tmp_kernel_op_24*tmp_moved_constant_1256;
       const real_t tmp_moved_constant_1264 = tmp_kernel_op_27*tmp_moved_constant_1258;
       const real_t tmp_moved_constant_1265 = tmp_kernel_op_30*tmp_moved_constant_1260;
       const real_t tmp_moved_constant_1266 = tmp_kernel_op_33*tmp_moved_constant_1254;
       const real_t tmp_moved_constant_1267 = tmp_kernel_op_36*tmp_moved_constant_1256;
       const real_t tmp_moved_constant_1268 = tmp_kernel_op_39*tmp_moved_constant_1258;
       const real_t tmp_moved_constant_1269 = tmp_kernel_op_42*tmp_moved_constant_1260;
       const real_t tmp_moved_constant_1270 = tmp_moved_constant_1062*0.5854101966249684;
       const real_t tmp_moved_constant_1271 = tmp_kernel_op_1*tmp_moved_constant_1270;
       const real_t tmp_moved_constant_1272 = tmp_moved_constant_1065*0.1381966011250105;
       const real_t tmp_moved_constant_1273 = tmp_kernel_op_6*tmp_moved_constant_1272;
       const real_t tmp_moved_constant_1274 = tmp_moved_constant_1068*0.1381966011250105;
       const real_t tmp_moved_constant_1275 = tmp_kernel_op_11*tmp_moved_constant_1274;
       const real_t tmp_moved_constant_1276 = tmp_moved_constant_1071*0.1381966011250105;
       const real_t tmp_moved_constant_1277 = tmp_kernel_op_16*tmp_moved_constant_1276;
       const real_t tmp_moved_constant_1278 = tmp_kernel_op_21*tmp_moved_constant_1270;
       const real_t tmp_moved_constant_1279 = tmp_kernel_op_24*tmp_moved_constant_1272;
       const real_t tmp_moved_constant_1280 = tmp_kernel_op_27*tmp_moved_constant_1274;
       const real_t tmp_moved_constant_1281 = tmp_kernel_op_30*tmp_moved_constant_1276;
       const real_t tmp_moved_constant_1282 = tmp_kernel_op_33*tmp_moved_constant_1270;
       const real_t tmp_moved_constant_1283 = tmp_kernel_op_36*tmp_moved_constant_1272;
       const real_t tmp_moved_constant_1284 = tmp_kernel_op_39*tmp_moved_constant_1274;
       const real_t tmp_moved_constant_1285 = tmp_kernel_op_42*tmp_moved_constant_1276;
       for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
       for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
       {
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_12 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_13 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_14 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_15 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_16 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_17 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_18 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_19 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_20 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_21 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_22 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_23 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_24 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_25 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_26 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_27 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_28 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_29 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_25,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3),_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(src_dof_26,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_136,tmp_kernel_op_136,tmp_kernel_op_136,tmp_kernel_op_136)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_130,tmp_kernel_op_130,tmp_kernel_op_130,tmp_kernel_op_130),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_139,tmp_kernel_op_139,tmp_kernel_op_139,tmp_kernel_op_139),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18))))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_148,tmp_kernel_op_148,tmp_kernel_op_148,tmp_kernel_op_148)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_142,tmp_kernel_op_142,tmp_kernel_op_142,tmp_kernel_op_142),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_145,tmp_kernel_op_145,tmp_kernel_op_145,tmp_kernel_op_145),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_151,tmp_kernel_op_151,tmp_kernel_op_151,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18))))),_mm256_mul_pd(src_dof_17,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_157,tmp_kernel_op_157,tmp_kernel_op_157,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18))))),_mm256_mul_pd(src_dof_18,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_172,tmp_kernel_op_172,tmp_kernel_op_172,tmp_kernel_op_172)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18))))),_mm256_mul_pd(src_dof_19,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_181,tmp_kernel_op_181,tmp_kernel_op_181,tmp_kernel_op_181)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_177,tmp_kernel_op_177,tmp_kernel_op_177,tmp_kernel_op_177),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183))))),_mm256_mul_pd(src_dof_27,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_184,tmp_kernel_op_184,tmp_kernel_op_184,tmp_kernel_op_184),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_28,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_190,tmp_kernel_op_190,tmp_kernel_op_190,tmp_kernel_op_190)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_29,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_193,tmp_kernel_op_193,tmp_kernel_op_193,tmp_kernel_op_193),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_199,tmp_kernel_op_199,tmp_kernel_op_199,tmp_kernel_op_199))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_196,tmp_kernel_op_196,tmp_kernel_op_196,tmp_kernel_op_196),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_202,tmp_kernel_op_202,tmp_kernel_op_202,tmp_kernel_op_202)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_205,tmp_kernel_op_205,tmp_kernel_op_205,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_213,tmp_kernel_op_213,tmp_kernel_op_213,tmp_kernel_op_213)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_211,tmp_kernel_op_211,tmp_kernel_op_211,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_10,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_219,tmp_kernel_op_219,tmp_kernel_op_219,tmp_kernel_op_219))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_216,tmp_kernel_op_216,tmp_kernel_op_216,tmp_kernel_op_216),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_217,tmp_kernel_op_217,tmp_kernel_op_217,tmp_kernel_op_217),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_20,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_222,tmp_kernel_op_222,tmp_kernel_op_222,tmp_kernel_op_222)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_223,tmp_kernel_op_223,tmp_kernel_op_223,tmp_kernel_op_223))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_220,tmp_kernel_op_220,tmp_kernel_op_220,tmp_kernel_op_220),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_14,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_15,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_16,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_mul_pd(src_dof_24,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_4,tmp_kernel_op_4,tmp_kernel_op_4,tmp_kernel_op_4))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9))))),_mm256_mul_pd(src_dof_11,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_4,tmp_kernel_op_4,tmp_kernel_op_4,tmp_kernel_op_4))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9))))),_mm256_mul_pd(src_dof_21,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_4,tmp_kernel_op_4,tmp_kernel_op_4,tmp_kernel_op_4))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))))),_mm256_mul_pd(src_dof_12,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))))),_mm256_mul_pd(src_dof_22,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))))),_mm256_mul_pd(src_dof_13,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))))),_mm256_mul_pd(src_dof_23,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_25,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224),_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(src_dof_26,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_130,tmp_kernel_op_130,tmp_kernel_op_130,tmp_kernel_op_130),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_136,tmp_kernel_op_136,tmp_kernel_op_136,tmp_kernel_op_136),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_139,tmp_kernel_op_139,tmp_kernel_op_139,tmp_kernel_op_139),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_142,tmp_kernel_op_142,tmp_kernel_op_142,tmp_kernel_op_142),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_145,tmp_kernel_op_145,tmp_kernel_op_145,tmp_kernel_op_145),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_148,tmp_kernel_op_148,tmp_kernel_op_148,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_151,tmp_kernel_op_151,tmp_kernel_op_151,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_17,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_157,tmp_kernel_op_157,tmp_kernel_op_157,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_18,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_172,tmp_kernel_op_172,tmp_kernel_op_172,tmp_kernel_op_172),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_19,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_177,tmp_kernel_op_177,tmp_kernel_op_177,tmp_kernel_op_177),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_181,tmp_kernel_op_181,tmp_kernel_op_181,tmp_kernel_op_181),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_27,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_184,tmp_kernel_op_184,tmp_kernel_op_184,tmp_kernel_op_184),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_28,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_190,tmp_kernel_op_190,tmp_kernel_op_190,tmp_kernel_op_190),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_29,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_193,tmp_kernel_op_193,tmp_kernel_op_193,tmp_kernel_op_193),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_196,tmp_kernel_op_196,tmp_kernel_op_196,tmp_kernel_op_196),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_199,tmp_kernel_op_199,tmp_kernel_op_199,tmp_kernel_op_199),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_202,tmp_kernel_op_202,tmp_kernel_op_202,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_205,tmp_kernel_op_205,tmp_kernel_op_205,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_211,tmp_kernel_op_211,tmp_kernel_op_211,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_213,tmp_kernel_op_213,tmp_kernel_op_213,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_10,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_216,tmp_kernel_op_216,tmp_kernel_op_216,tmp_kernel_op_216),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_217,tmp_kernel_op_217,tmp_kernel_op_217,tmp_kernel_op_217),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_219,tmp_kernel_op_219,tmp_kernel_op_219,tmp_kernel_op_219),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_20,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_220,tmp_kernel_op_220,tmp_kernel_op_220,tmp_kernel_op_220),_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221),_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_222,tmp_kernel_op_222,tmp_kernel_op_222,tmp_kernel_op_222),_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_223,tmp_kernel_op_223,tmp_kernel_op_223,tmp_kernel_op_223),_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(src_dof_14,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))))),_mm256_mul_pd(src_dof_15,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226),_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))))),_mm256_mul_pd(src_dof_16,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226),_mm256_set_pd(tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_24,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226,tmp_kernel_op_226),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228,tmp_kernel_op_228),_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_225,tmp_kernel_op_225,tmp_kernel_op_225,tmp_kernel_op_225)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_229,tmp_kernel_op_229,tmp_kernel_op_229,tmp_kernel_op_229))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_231,tmp_kernel_op_231,tmp_kernel_op_231,tmp_kernel_op_231))))),_mm256_mul_pd(src_dof_11,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_225,tmp_kernel_op_225,tmp_kernel_op_225,tmp_kernel_op_225)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_229,tmp_kernel_op_229,tmp_kernel_op_229,tmp_kernel_op_229))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_231,tmp_kernel_op_231,tmp_kernel_op_231,tmp_kernel_op_231))))),_mm256_mul_pd(src_dof_21,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_225,tmp_kernel_op_225,tmp_kernel_op_225,tmp_kernel_op_225)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_229,tmp_kernel_op_229,tmp_kernel_op_229,tmp_kernel_op_229))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_231,tmp_kernel_op_231,tmp_kernel_op_231,tmp_kernel_op_231))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_232,tmp_kernel_op_232,tmp_kernel_op_232,tmp_kernel_op_232)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_234,tmp_kernel_op_234,tmp_kernel_op_234,tmp_kernel_op_234))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_235,tmp_kernel_op_235,tmp_kernel_op_235,tmp_kernel_op_235))))),_mm256_mul_pd(src_dof_12,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_232,tmp_kernel_op_232,tmp_kernel_op_232,tmp_kernel_op_232)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_234,tmp_kernel_op_234,tmp_kernel_op_234,tmp_kernel_op_234))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_235,tmp_kernel_op_235,tmp_kernel_op_235,tmp_kernel_op_235))))),_mm256_mul_pd(src_dof_22,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_232,tmp_kernel_op_232,tmp_kernel_op_232,tmp_kernel_op_232)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_234,tmp_kernel_op_234,tmp_kernel_op_234,tmp_kernel_op_234))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_235,tmp_kernel_op_235,tmp_kernel_op_235,tmp_kernel_op_235))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_237,tmp_kernel_op_237,tmp_kernel_op_237,tmp_kernel_op_237))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_238,tmp_kernel_op_238,tmp_kernel_op_238,tmp_kernel_op_238))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239))))),_mm256_mul_pd(src_dof_13,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_237,tmp_kernel_op_237,tmp_kernel_op_237,tmp_kernel_op_237))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_238,tmp_kernel_op_238,tmp_kernel_op_238,tmp_kernel_op_238))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239))))),_mm256_mul_pd(src_dof_23,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_237,tmp_kernel_op_237,tmp_kernel_op_237,tmp_kernel_op_237))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_238,tmp_kernel_op_238,tmp_kernel_op_238,tmp_kernel_op_238))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_25,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240),_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(src_dof_26,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_130,tmp_kernel_op_130,tmp_kernel_op_130,tmp_kernel_op_130),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_136,tmp_kernel_op_136,tmp_kernel_op_136,tmp_kernel_op_136),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_139,tmp_kernel_op_139,tmp_kernel_op_139,tmp_kernel_op_139),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_142,tmp_kernel_op_142,tmp_kernel_op_142,tmp_kernel_op_142),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_145,tmp_kernel_op_145,tmp_kernel_op_145,tmp_kernel_op_145),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_148,tmp_kernel_op_148,tmp_kernel_op_148,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_151,tmp_kernel_op_151,tmp_kernel_op_151,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_17,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_157,tmp_kernel_op_157,tmp_kernel_op_157,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_18,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_172,tmp_kernel_op_172,tmp_kernel_op_172,tmp_kernel_op_172),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_19,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_177,tmp_kernel_op_177,tmp_kernel_op_177,tmp_kernel_op_177),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_181,tmp_kernel_op_181,tmp_kernel_op_181,tmp_kernel_op_181),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_27,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_184,tmp_kernel_op_184,tmp_kernel_op_184,tmp_kernel_op_184),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_28,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_190,tmp_kernel_op_190,tmp_kernel_op_190,tmp_kernel_op_190),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_29,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_193,tmp_kernel_op_193,tmp_kernel_op_193,tmp_kernel_op_193),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_196,tmp_kernel_op_196,tmp_kernel_op_196,tmp_kernel_op_196),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_199,tmp_kernel_op_199,tmp_kernel_op_199,tmp_kernel_op_199),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_202,tmp_kernel_op_202,tmp_kernel_op_202,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_205,tmp_kernel_op_205,tmp_kernel_op_205,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_211,tmp_kernel_op_211,tmp_kernel_op_211,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_213,tmp_kernel_op_213,tmp_kernel_op_213,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_10,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_216,tmp_kernel_op_216,tmp_kernel_op_216,tmp_kernel_op_216),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_217,tmp_kernel_op_217,tmp_kernel_op_217,tmp_kernel_op_217),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_219,tmp_kernel_op_219,tmp_kernel_op_219,tmp_kernel_op_219),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_20,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_220,tmp_kernel_op_220,tmp_kernel_op_220,tmp_kernel_op_220),_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221),_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_222,tmp_kernel_op_222,tmp_kernel_op_222,tmp_kernel_op_222),_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_223,tmp_kernel_op_223,tmp_kernel_op_223,tmp_kernel_op_223),_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))))),_mm256_mul_pd(src_dof_14,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))))),_mm256_mul_pd(src_dof_15,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242),_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))))),_mm256_mul_pd(src_dof_16,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242),_mm256_set_pd(tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_24,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240,tmp_kernel_op_240),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244,tmp_kernel_op_244),_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247))))),_mm256_mul_pd(src_dof_11,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247))))),_mm256_mul_pd(src_dof_21,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_248,tmp_kernel_op_248,tmp_kernel_op_248,tmp_kernel_op_248)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251))))),_mm256_mul_pd(src_dof_12,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_248,tmp_kernel_op_248,tmp_kernel_op_248,tmp_kernel_op_248)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251))))),_mm256_mul_pd(src_dof_22,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_248,tmp_kernel_op_248,tmp_kernel_op_248,tmp_kernel_op_248)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_252,tmp_kernel_op_252,tmp_kernel_op_252,tmp_kernel_op_252)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))))),_mm256_mul_pd(src_dof_13,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_252,tmp_kernel_op_252,tmp_kernel_op_252,tmp_kernel_op_252)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))))),_mm256_mul_pd(src_dof_23,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_252,tmp_kernel_op_252,tmp_kernel_op_252,tmp_kernel_op_252)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_25,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256),_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(src_dof_26,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124,tmp_kernel_op_124),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_130,tmp_kernel_op_130,tmp_kernel_op_130,tmp_kernel_op_130),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_136,tmp_kernel_op_136,tmp_kernel_op_136,tmp_kernel_op_136),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_139,tmp_kernel_op_139,tmp_kernel_op_139,tmp_kernel_op_139),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_142,tmp_kernel_op_142,tmp_kernel_op_142,tmp_kernel_op_142),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_145,tmp_kernel_op_145,tmp_kernel_op_145,tmp_kernel_op_145),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_148,tmp_kernel_op_148,tmp_kernel_op_148,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_151,tmp_kernel_op_151,tmp_kernel_op_151,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_17,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_157,tmp_kernel_op_157,tmp_kernel_op_157,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160,tmp_kernel_op_160),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_18,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166,tmp_kernel_op_166),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_172,tmp_kernel_op_172,tmp_kernel_op_172,tmp_kernel_op_172),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_19,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_177,tmp_kernel_op_177,tmp_kernel_op_177,tmp_kernel_op_177),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_181,tmp_kernel_op_181,tmp_kernel_op_181,tmp_kernel_op_181),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_27,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_184,tmp_kernel_op_184,tmp_kernel_op_184,tmp_kernel_op_184),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_28,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_190,tmp_kernel_op_190,tmp_kernel_op_190,tmp_kernel_op_190),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_29,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_193,tmp_kernel_op_193,tmp_kernel_op_193,tmp_kernel_op_193),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_196,tmp_kernel_op_196,tmp_kernel_op_196,tmp_kernel_op_196),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_199,tmp_kernel_op_199,tmp_kernel_op_199,tmp_kernel_op_199),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_202,tmp_kernel_op_202,tmp_kernel_op_202,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_205,tmp_kernel_op_205,tmp_kernel_op_205,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_211,tmp_kernel_op_211,tmp_kernel_op_211,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_213,tmp_kernel_op_213,tmp_kernel_op_213,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_10,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_216,tmp_kernel_op_216,tmp_kernel_op_216,tmp_kernel_op_216),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_217,tmp_kernel_op_217,tmp_kernel_op_217,tmp_kernel_op_217),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_219,tmp_kernel_op_219,tmp_kernel_op_219,tmp_kernel_op_219),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_20,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_220,tmp_kernel_op_220,tmp_kernel_op_220,tmp_kernel_op_220),_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221),_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_222,tmp_kernel_op_222,tmp_kernel_op_222,tmp_kernel_op_222),_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_223,tmp_kernel_op_223,tmp_kernel_op_223,tmp_kernel_op_223),_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262))))),_mm256_mul_pd(src_dof_14,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))))),_mm256_mul_pd(src_dof_15,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258),_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))))),_mm256_mul_pd(src_dof_16,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258),_mm256_set_pd(tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73,tmp_kernel_op_73))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_24,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256,tmp_kernel_op_256),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260,tmp_kernel_op_260),_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_261,tmp_kernel_op_261,tmp_kernel_op_261,tmp_kernel_op_261))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))))),_mm256_mul_pd(src_dof_11,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_261,tmp_kernel_op_261,tmp_kernel_op_261,tmp_kernel_op_261))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))))),_mm256_mul_pd(src_dof_21,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_261,tmp_kernel_op_261,tmp_kernel_op_261,tmp_kernel_op_261))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_266,tmp_kernel_op_266,tmp_kernel_op_266,tmp_kernel_op_266))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))))),_mm256_mul_pd(src_dof_12,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_266,tmp_kernel_op_266,tmp_kernel_op_266,tmp_kernel_op_266))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))))),_mm256_mul_pd(src_dof_22,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_266,tmp_kernel_op_266,tmp_kernel_op_266,tmp_kernel_op_266))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_270,tmp_kernel_op_270,tmp_kernel_op_270,tmp_kernel_op_270))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271))))),_mm256_mul_pd(src_dof_13,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_270,tmp_kernel_op_270,tmp_kernel_op_270,tmp_kernel_op_270))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271))))),_mm256_mul_pd(src_dof_23,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_270,tmp_kernel_op_270,tmp_kernel_op_270,tmp_kernel_op_270))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)))));
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                   }
                }
                const __m256d tmp_moved_constant_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_3 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d tmp_moved_constant_6 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_7 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_8 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_9 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_10 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_11 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_12 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_13 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_14 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_15 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d tmp_moved_constant_16 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_17 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_18 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_19 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_20 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_21 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_22 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_23 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_24 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_25 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d tmp_moved_constant_26 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_27 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_28 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_29 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_254 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_25,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40)))),_mm256_mul_pd(tmp_moved_constant_26,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_17,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_18,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_19,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_27,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_28,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_29,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_10,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_20,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205),_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))))),_mm256_mul_pd(tmp_moved_constant_14,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31),_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34),_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37),_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40),_mm256_set_pd(tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61))))),_mm256_mul_pd(tmp_moved_constant_15,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31),_mm256_set_pd(tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34),_mm256_set_pd(tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37),_mm256_set_pd(tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40),_mm256_set_pd(tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73))))),_mm256_mul_pd(tmp_moved_constant_16,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))))),_mm256_mul_pd(tmp_moved_constant_24,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31),_mm256_set_pd(tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34),_mm256_set_pd(tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37),_mm256_set_pd(tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40),_mm256_set_pd(tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97))))),_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))))),_mm256_mul_pd(tmp_moved_constant_11,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))))),_mm256_mul_pd(tmp_moved_constant_21,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45))))),_mm256_mul_pd(tmp_moved_constant_12,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45))))),_mm256_mul_pd(tmp_moved_constant_22,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))))),_mm256_mul_pd(tmp_moved_constant_13,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))))),_mm256_mul_pd(tmp_moved_constant_23,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49)))));
                const __m256d tmp_moved_constant_255 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_25,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212)))),_mm256_mul_pd(tmp_moved_constant_26,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_17,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_18,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_19,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_27,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_28,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_29,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_10,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_20,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202),_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(tmp_moved_constant_14,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206),_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208),_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210),_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212),_mm256_set_pd(tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61))))),_mm256_mul_pd(tmp_moved_constant_15,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206),_mm256_set_pd(tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208),_mm256_set_pd(tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210),_mm256_set_pd(tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212),_mm256_set_pd(tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73))))),_mm256_mul_pd(tmp_moved_constant_16,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))))),_mm256_mul_pd(tmp_moved_constant_24,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206),_mm256_set_pd(tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208),_mm256_set_pd(tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210),_mm256_set_pd(tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212),_mm256_set_pd(tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97))))),_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213))))),_mm256_mul_pd(tmp_moved_constant_11,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213))))),_mm256_mul_pd(tmp_moved_constant_21,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213))))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))))),_mm256_mul_pd(tmp_moved_constant_12,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))))),_mm256_mul_pd(tmp_moved_constant_22,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))))),_mm256_mul_pd(tmp_moved_constant_13,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))))),_mm256_mul_pd(tmp_moved_constant_23,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221)))));
                const __m256d tmp_moved_constant_256 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_25,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)))),_mm256_mul_pd(tmp_moved_constant_26,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_17,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_18,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_19,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_27,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_28,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_29,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_10,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_20,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228))))),_mm256_mul_pd(tmp_moved_constant_14,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222),_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224),_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226),_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228),_mm256_set_pd(tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61))))),_mm256_mul_pd(tmp_moved_constant_15,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222),_mm256_set_pd(tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224),_mm256_set_pd(tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226),_mm256_set_pd(tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228),_mm256_set_pd(tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73))))),_mm256_mul_pd(tmp_moved_constant_16,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))))),_mm256_mul_pd(tmp_moved_constant_24,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222),_mm256_set_pd(tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224),_mm256_set_pd(tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226),_mm256_set_pd(tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228),_mm256_set_pd(tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97))))),_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))))),_mm256_mul_pd(tmp_moved_constant_11,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))))),_mm256_mul_pd(tmp_moved_constant_21,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))))),_mm256_mul_pd(tmp_moved_constant_12,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))))),_mm256_mul_pd(tmp_moved_constant_22,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237))))),_mm256_mul_pd(tmp_moved_constant_13,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237))))),_mm256_mul_pd(tmp_moved_constant_23,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237)))));
                const __m256d tmp_moved_constant_257 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_25,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100,tmp_moved_constant_100),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106,tmp_moved_constant_106),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244)))),_mm256_mul_pd(tmp_moved_constant_26,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139,tmp_moved_constant_139),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142,tmp_moved_constant_142),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145,tmp_moved_constant_145),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148,tmp_moved_constant_148),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151,tmp_moved_constant_151),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154,tmp_moved_constant_154),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157,tmp_moved_constant_157),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_17,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159,tmp_moved_constant_159),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160,tmp_moved_constant_160),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_18,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162,tmp_moved_constant_162),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163,tmp_moved_constant_163),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165,tmp_moved_constant_165),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_19,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166,tmp_moved_constant_166),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168,tmp_moved_constant_168),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169,tmp_moved_constant_169),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_27,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171,tmp_moved_constant_171),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172,tmp_moved_constant_172),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_28,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_29,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186,tmp_moved_constant_186),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187,tmp_moved_constant_187),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189,tmp_moved_constant_189),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190,tmp_moved_constant_190),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192,tmp_moved_constant_192),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193,tmp_moved_constant_193),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_10,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_20,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203),_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204),_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))))),_mm256_mul_pd(tmp_moved_constant_14,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238),_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240),_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242),_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244),_mm256_set_pd(tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61,tmp_moved_constant_61))))),_mm256_mul_pd(tmp_moved_constant_15,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238),_mm256_set_pd(tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64,tmp_moved_constant_64)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240),_mm256_set_pd(tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67,tmp_moved_constant_67))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242),_mm256_set_pd(tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70,tmp_moved_constant_70))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244),_mm256_set_pd(tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73,tmp_moved_constant_73))))),_mm256_mul_pd(tmp_moved_constant_16,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))))),_mm256_mul_pd(tmp_moved_constant_24,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238),_mm256_set_pd(tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88,tmp_moved_constant_88)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240),_mm256_set_pd(tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91,tmp_moved_constant_91))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242),_mm256_set_pd(tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94,tmp_moved_constant_94))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244),_mm256_set_pd(tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97,tmp_moved_constant_97))))),_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))))),_mm256_mul_pd(tmp_moved_constant_11,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))))),_mm256_mul_pd(tmp_moved_constant_21,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249))))),_mm256_mul_pd(tmp_moved_constant_12,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249))))),_mm256_mul_pd(tmp_moved_constant_22,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))))),_mm256_mul_pd(tmp_moved_constant_13,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))))),_mm256_mul_pd(tmp_moved_constant_23,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253)))));
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_254,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_255,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_256,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_257,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                   }
                }
                const __m256d tmp_moved_constant_258 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_259 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_260 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_261 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_262 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_263 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_264 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_265 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_266 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_267 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_268 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_269 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_270 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_271 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_272 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_273 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_274 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_275 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_276 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_277 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_278 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_279 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_280 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_281 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_282 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_283 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_284 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_285 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_286 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_287 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_512 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_272,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319)))),_mm256_mul_pd(tmp_moved_constant_273,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331))))),_mm256_mul_pd(tmp_moved_constant_274,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343))))),_mm256_mul_pd(tmp_moved_constant_282,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355))))),_mm256_mul_pd(tmp_moved_constant_283,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_361,tmp_moved_constant_361,tmp_moved_constant_361,tmp_moved_constant_361))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_364,tmp_moved_constant_364,tmp_moved_constant_364,tmp_moved_constant_364))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_367,tmp_moved_constant_367,tmp_moved_constant_367,tmp_moved_constant_367))))),_mm256_mul_pd(tmp_moved_constant_284,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379))))),_mm256_mul_pd(tmp_moved_constant_262,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_382,tmp_moved_constant_382,tmp_moved_constant_382,tmp_moved_constant_382)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_385,tmp_moved_constant_385,tmp_moved_constant_385,tmp_moved_constant_385))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_388,tmp_moved_constant_388,tmp_moved_constant_388,tmp_moved_constant_388))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_391,tmp_moved_constant_391,tmp_moved_constant_391,tmp_moved_constant_391))))),_mm256_mul_pd(tmp_moved_constant_263,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_394,tmp_moved_constant_394,tmp_moved_constant_394,tmp_moved_constant_394)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_400,tmp_moved_constant_400,tmp_moved_constant_400,tmp_moved_constant_400))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403))))),_mm256_mul_pd(tmp_moved_constant_264,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415))))),_mm256_mul_pd(tmp_moved_constant_275,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419))))),_mm256_mul_pd(tmp_moved_constant_276,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423))))),_mm256_mul_pd(tmp_moved_constant_277,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427))))),_mm256_mul_pd(tmp_moved_constant_285,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))))),_mm256_mul_pd(tmp_moved_constant_286,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_432,tmp_moved_constant_432,tmp_moved_constant_432,tmp_moved_constant_432)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_433,tmp_moved_constant_433,tmp_moved_constant_433,tmp_moved_constant_433))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435))))),_mm256_mul_pd(tmp_moved_constant_287,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439))))),_mm256_mul_pd(tmp_moved_constant_265,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))))),_mm256_mul_pd(tmp_moved_constant_266,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447))))),_mm256_mul_pd(tmp_moved_constant_267,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451))))),_mm256_mul_pd(tmp_moved_constant_258,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))))),_mm256_mul_pd(tmp_moved_constant_268,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459))))),_mm256_mul_pd(tmp_moved_constant_278,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289),_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292),_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295),_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298),_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463))))),_mm256_mul_pd(tmp_moved_constant_259,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))))),_mm256_mul_pd(tmp_moved_constant_269,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))))),_mm256_mul_pd(tmp_moved_constant_279,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))))),_mm256_mul_pd(tmp_moved_constant_260,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303))))),_mm256_mul_pd(tmp_moved_constant_270,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303))))),_mm256_mul_pd(tmp_moved_constant_280,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300,tmp_moved_constant_300)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303))))),_mm256_mul_pd(tmp_moved_constant_261,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307))))),_mm256_mul_pd(tmp_moved_constant_271,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307))))),_mm256_mul_pd(tmp_moved_constant_281,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304,tmp_moved_constant_304)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307)))));
                const __m256d tmp_moved_constant_513 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_272,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470)))),_mm256_mul_pd(tmp_moved_constant_273,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_274,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_282,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_283,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_361,tmp_moved_constant_361,tmp_moved_constant_361,tmp_moved_constant_361),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_364,tmp_moved_constant_364,tmp_moved_constant_364,tmp_moved_constant_364),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_367,tmp_moved_constant_367,tmp_moved_constant_367,tmp_moved_constant_367),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_284,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_262,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_382,tmp_moved_constant_382,tmp_moved_constant_382,tmp_moved_constant_382),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_385,tmp_moved_constant_385,tmp_moved_constant_385,tmp_moved_constant_385),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_388,tmp_moved_constant_388,tmp_moved_constant_388,tmp_moved_constant_388),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_391,tmp_moved_constant_391,tmp_moved_constant_391,tmp_moved_constant_391),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_263,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_394,tmp_moved_constant_394,tmp_moved_constant_394,tmp_moved_constant_394),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_400,tmp_moved_constant_400,tmp_moved_constant_400,tmp_moved_constant_400),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_264,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_275,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_276,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_277,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_285,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_286,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_432,tmp_moved_constant_432,tmp_moved_constant_432,tmp_moved_constant_432),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_433,tmp_moved_constant_433,tmp_moved_constant_433,tmp_moved_constant_433),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_287,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_265,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_266,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_267,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_258,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_268,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_278,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461),_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(tmp_moved_constant_259,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471))))),_mm256_mul_pd(tmp_moved_constant_269,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471))))),_mm256_mul_pd(tmp_moved_constant_279,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471))))),_mm256_mul_pd(tmp_moved_constant_260,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))))),_mm256_mul_pd(tmp_moved_constant_270,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))))),_mm256_mul_pd(tmp_moved_constant_280,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))))),_mm256_mul_pd(tmp_moved_constant_261,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))))),_mm256_mul_pd(tmp_moved_constant_271,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))))),_mm256_mul_pd(tmp_moved_constant_281,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479)))));
                const __m256d tmp_moved_constant_514 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_272,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486)))),_mm256_mul_pd(tmp_moved_constant_273,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_274,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_282,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_283,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_361,tmp_moved_constant_361,tmp_moved_constant_361,tmp_moved_constant_361),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_364,tmp_moved_constant_364,tmp_moved_constant_364,tmp_moved_constant_364),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_367,tmp_moved_constant_367,tmp_moved_constant_367,tmp_moved_constant_367),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_284,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_262,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_382,tmp_moved_constant_382,tmp_moved_constant_382,tmp_moved_constant_382),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_385,tmp_moved_constant_385,tmp_moved_constant_385,tmp_moved_constant_385),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_388,tmp_moved_constant_388,tmp_moved_constant_388,tmp_moved_constant_388),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_391,tmp_moved_constant_391,tmp_moved_constant_391,tmp_moved_constant_391),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_263,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_394,tmp_moved_constant_394,tmp_moved_constant_394,tmp_moved_constant_394),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_400,tmp_moved_constant_400,tmp_moved_constant_400,tmp_moved_constant_400),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_264,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_275,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_276,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_277,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_285,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_286,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_432,tmp_moved_constant_432,tmp_moved_constant_432,tmp_moved_constant_432),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_433,tmp_moved_constant_433,tmp_moved_constant_433,tmp_moved_constant_433),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_287,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_265,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_266,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_267,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_258,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_268,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_278,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460),_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461),_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462),_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463),_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486))))),_mm256_mul_pd(tmp_moved_constant_259,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))))),_mm256_mul_pd(tmp_moved_constant_269,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))))),_mm256_mul_pd(tmp_moved_constant_279,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))))),_mm256_mul_pd(tmp_moved_constant_260,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491))))),_mm256_mul_pd(tmp_moved_constant_270,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491))))),_mm256_mul_pd(tmp_moved_constant_280,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491))))),_mm256_mul_pd(tmp_moved_constant_261,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495))))),_mm256_mul_pd(tmp_moved_constant_271,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495))))),_mm256_mul_pd(tmp_moved_constant_281,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495)))));
                const __m256d tmp_moved_constant_515 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_272,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502)))),_mm256_mul_pd(tmp_moved_constant_273,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_274,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334,tmp_moved_constant_334),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337,tmp_moved_constant_337),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340,tmp_moved_constant_340),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343,tmp_moved_constant_343),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_282,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346,tmp_moved_constant_346),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349,tmp_moved_constant_349),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352,tmp_moved_constant_352),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355,tmp_moved_constant_355),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_283,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358,tmp_moved_constant_358),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_361,tmp_moved_constant_361,tmp_moved_constant_361,tmp_moved_constant_361),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_364,tmp_moved_constant_364,tmp_moved_constant_364,tmp_moved_constant_364),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_367,tmp_moved_constant_367,tmp_moved_constant_367,tmp_moved_constant_367),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_284,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_262,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_382,tmp_moved_constant_382,tmp_moved_constant_382,tmp_moved_constant_382),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_385,tmp_moved_constant_385,tmp_moved_constant_385,tmp_moved_constant_385),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_388,tmp_moved_constant_388,tmp_moved_constant_388,tmp_moved_constant_388),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_391,tmp_moved_constant_391,tmp_moved_constant_391,tmp_moved_constant_391),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_263,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_394,tmp_moved_constant_394,tmp_moved_constant_394,tmp_moved_constant_394),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_400,tmp_moved_constant_400,tmp_moved_constant_400,tmp_moved_constant_400),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_264,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_275,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_276,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_277,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_285,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_286,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_432,tmp_moved_constant_432,tmp_moved_constant_432,tmp_moved_constant_432),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_433,tmp_moved_constant_433,tmp_moved_constant_433,tmp_moved_constant_433),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_287,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_265,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_266,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_267,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_258,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_268,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_278,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460),_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461),_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462),_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463),_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))))),_mm256_mul_pd(tmp_moved_constant_259,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503))))),_mm256_mul_pd(tmp_moved_constant_269,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503))))),_mm256_mul_pd(tmp_moved_constant_279,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503))))),_mm256_mul_pd(tmp_moved_constant_260,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507))))),_mm256_mul_pd(tmp_moved_constant_270,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507))))),_mm256_mul_pd(tmp_moved_constant_280,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507))))),_mm256_mul_pd(tmp_moved_constant_261,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511))))),_mm256_mul_pd(tmp_moved_constant_271,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511))))),_mm256_mul_pd(tmp_moved_constant_281,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511)))));
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_512,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_513,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_514,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_515,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                   }
                }
                const __m256d tmp_moved_constant_516 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_517 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_518 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_519 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_520 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_521 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_522 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_523 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_524 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_525 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_526 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_527 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_528 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_529 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_530 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_531 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_532 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_533 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_534 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_535 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_536 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_537 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_538 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_539 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_540 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_541 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_542 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_543 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_544 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_545 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_770 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_530,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_568,tmp_moved_constant_568,tmp_moved_constant_568,tmp_moved_constant_568)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_571,tmp_moved_constant_571,tmp_moved_constant_571,tmp_moved_constant_571))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_574,tmp_moved_constant_574,tmp_moved_constant_574,tmp_moved_constant_574))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_577,tmp_moved_constant_577,tmp_moved_constant_577,tmp_moved_constant_577)))),_mm256_mul_pd(tmp_moved_constant_531,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_580,tmp_moved_constant_580,tmp_moved_constant_580,tmp_moved_constant_580)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_583,tmp_moved_constant_583,tmp_moved_constant_583,tmp_moved_constant_583))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_586,tmp_moved_constant_586,tmp_moved_constant_586,tmp_moved_constant_586))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_589,tmp_moved_constant_589,tmp_moved_constant_589,tmp_moved_constant_589))))),_mm256_mul_pd(tmp_moved_constant_532,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_592,tmp_moved_constant_592,tmp_moved_constant_592,tmp_moved_constant_592)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_595,tmp_moved_constant_595,tmp_moved_constant_595,tmp_moved_constant_595))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_598,tmp_moved_constant_598,tmp_moved_constant_598,tmp_moved_constant_598))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_601,tmp_moved_constant_601,tmp_moved_constant_601,tmp_moved_constant_601))))),_mm256_mul_pd(tmp_moved_constant_540,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_604,tmp_moved_constant_604,tmp_moved_constant_604,tmp_moved_constant_604)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_607,tmp_moved_constant_607,tmp_moved_constant_607,tmp_moved_constant_607))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_610,tmp_moved_constant_610,tmp_moved_constant_610,tmp_moved_constant_610))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_613,tmp_moved_constant_613,tmp_moved_constant_613,tmp_moved_constant_613))))),_mm256_mul_pd(tmp_moved_constant_541,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_616,tmp_moved_constant_616,tmp_moved_constant_616,tmp_moved_constant_616)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_619,tmp_moved_constant_619,tmp_moved_constant_619,tmp_moved_constant_619))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_622,tmp_moved_constant_622,tmp_moved_constant_622,tmp_moved_constant_622))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_625,tmp_moved_constant_625,tmp_moved_constant_625,tmp_moved_constant_625))))),_mm256_mul_pd(tmp_moved_constant_542,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_628,tmp_moved_constant_628,tmp_moved_constant_628,tmp_moved_constant_628)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_631,tmp_moved_constant_631,tmp_moved_constant_631,tmp_moved_constant_631))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_634,tmp_moved_constant_634,tmp_moved_constant_634,tmp_moved_constant_634))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_637,tmp_moved_constant_637,tmp_moved_constant_637,tmp_moved_constant_637))))),_mm256_mul_pd(tmp_moved_constant_520,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_640,tmp_moved_constant_640,tmp_moved_constant_640,tmp_moved_constant_640)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_643,tmp_moved_constant_643,tmp_moved_constant_643,tmp_moved_constant_643))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_646,tmp_moved_constant_646,tmp_moved_constant_646,tmp_moved_constant_646))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_649,tmp_moved_constant_649,tmp_moved_constant_649,tmp_moved_constant_649))))),_mm256_mul_pd(tmp_moved_constant_521,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_652,tmp_moved_constant_652,tmp_moved_constant_652,tmp_moved_constant_652)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_655,tmp_moved_constant_655,tmp_moved_constant_655,tmp_moved_constant_655))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_658,tmp_moved_constant_658,tmp_moved_constant_658,tmp_moved_constant_658))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_661,tmp_moved_constant_661,tmp_moved_constant_661,tmp_moved_constant_661))))),_mm256_mul_pd(tmp_moved_constant_522,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_664,tmp_moved_constant_664,tmp_moved_constant_664,tmp_moved_constant_664)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_667,tmp_moved_constant_667,tmp_moved_constant_667,tmp_moved_constant_667))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_670,tmp_moved_constant_670,tmp_moved_constant_670,tmp_moved_constant_670))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_673,tmp_moved_constant_673,tmp_moved_constant_673,tmp_moved_constant_673))))),_mm256_mul_pd(tmp_moved_constant_533,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677))))),_mm256_mul_pd(tmp_moved_constant_534,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681))))),_mm256_mul_pd(tmp_moved_constant_535,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685))))),_mm256_mul_pd(tmp_moved_constant_543,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689))))),_mm256_mul_pd(tmp_moved_constant_544,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693))))),_mm256_mul_pd(tmp_moved_constant_545,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697))))),_mm256_mul_pd(tmp_moved_constant_523,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701))))),_mm256_mul_pd(tmp_moved_constant_524,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705))))),_mm256_mul_pd(tmp_moved_constant_525,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709))))),_mm256_mul_pd(tmp_moved_constant_516,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713))))),_mm256_mul_pd(tmp_moved_constant_526,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717))))),_mm256_mul_pd(tmp_moved_constant_536,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547,tmp_moved_constant_547),_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550,tmp_moved_constant_550),_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553,tmp_moved_constant_553),_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556,tmp_moved_constant_556),_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721))))),_mm256_mul_pd(tmp_moved_constant_517,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557))))),_mm256_mul_pd(tmp_moved_constant_527,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557))))),_mm256_mul_pd(tmp_moved_constant_537,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557))))),_mm256_mul_pd(tmp_moved_constant_518,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_558,tmp_moved_constant_558,tmp_moved_constant_558,tmp_moved_constant_558)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_559,tmp_moved_constant_559,tmp_moved_constant_559,tmp_moved_constant_559))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_561,tmp_moved_constant_561,tmp_moved_constant_561,tmp_moved_constant_561))))),_mm256_mul_pd(tmp_moved_constant_528,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_558,tmp_moved_constant_558,tmp_moved_constant_558,tmp_moved_constant_558)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_559,tmp_moved_constant_559,tmp_moved_constant_559,tmp_moved_constant_559))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_561,tmp_moved_constant_561,tmp_moved_constant_561,tmp_moved_constant_561))))),_mm256_mul_pd(tmp_moved_constant_538,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_558,tmp_moved_constant_558,tmp_moved_constant_558,tmp_moved_constant_558)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_559,tmp_moved_constant_559,tmp_moved_constant_559,tmp_moved_constant_559))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_561,tmp_moved_constant_561,tmp_moved_constant_561,tmp_moved_constant_561))))),_mm256_mul_pd(tmp_moved_constant_519,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_562,tmp_moved_constant_562,tmp_moved_constant_562,tmp_moved_constant_562)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_564,tmp_moved_constant_564,tmp_moved_constant_564,tmp_moved_constant_564))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_565,tmp_moved_constant_565,tmp_moved_constant_565,tmp_moved_constant_565))))),_mm256_mul_pd(tmp_moved_constant_529,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_562,tmp_moved_constant_562,tmp_moved_constant_562,tmp_moved_constant_562)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_564,tmp_moved_constant_564,tmp_moved_constant_564,tmp_moved_constant_564))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_565,tmp_moved_constant_565,tmp_moved_constant_565,tmp_moved_constant_565))))),_mm256_mul_pd(tmp_moved_constant_539,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_562,tmp_moved_constant_562,tmp_moved_constant_562,tmp_moved_constant_562)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_564,tmp_moved_constant_564,tmp_moved_constant_564,tmp_moved_constant_564))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_565,tmp_moved_constant_565,tmp_moved_constant_565,tmp_moved_constant_565)))));
                const __m256d tmp_moved_constant_771 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_530,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_568,tmp_moved_constant_568,tmp_moved_constant_568,tmp_moved_constant_568),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_571,tmp_moved_constant_571,tmp_moved_constant_571,tmp_moved_constant_571),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_574,tmp_moved_constant_574,tmp_moved_constant_574,tmp_moved_constant_574),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_577,tmp_moved_constant_577,tmp_moved_constant_577,tmp_moved_constant_577),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728)))),_mm256_mul_pd(tmp_moved_constant_531,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_580,tmp_moved_constant_580,tmp_moved_constant_580,tmp_moved_constant_580),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_583,tmp_moved_constant_583,tmp_moved_constant_583,tmp_moved_constant_583),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_586,tmp_moved_constant_586,tmp_moved_constant_586,tmp_moved_constant_586),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_589,tmp_moved_constant_589,tmp_moved_constant_589,tmp_moved_constant_589),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_532,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_592,tmp_moved_constant_592,tmp_moved_constant_592,tmp_moved_constant_592),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_595,tmp_moved_constant_595,tmp_moved_constant_595,tmp_moved_constant_595),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_598,tmp_moved_constant_598,tmp_moved_constant_598,tmp_moved_constant_598),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_601,tmp_moved_constant_601,tmp_moved_constant_601,tmp_moved_constant_601),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_540,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_604,tmp_moved_constant_604,tmp_moved_constant_604,tmp_moved_constant_604),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_607,tmp_moved_constant_607,tmp_moved_constant_607,tmp_moved_constant_607),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_610,tmp_moved_constant_610,tmp_moved_constant_610,tmp_moved_constant_610),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_613,tmp_moved_constant_613,tmp_moved_constant_613,tmp_moved_constant_613),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_541,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_616,tmp_moved_constant_616,tmp_moved_constant_616,tmp_moved_constant_616),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_619,tmp_moved_constant_619,tmp_moved_constant_619,tmp_moved_constant_619),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_622,tmp_moved_constant_622,tmp_moved_constant_622,tmp_moved_constant_622),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_625,tmp_moved_constant_625,tmp_moved_constant_625,tmp_moved_constant_625),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_542,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_628,tmp_moved_constant_628,tmp_moved_constant_628,tmp_moved_constant_628),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_631,tmp_moved_constant_631,tmp_moved_constant_631,tmp_moved_constant_631),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_634,tmp_moved_constant_634,tmp_moved_constant_634,tmp_moved_constant_634),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_637,tmp_moved_constant_637,tmp_moved_constant_637,tmp_moved_constant_637),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_520,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_640,tmp_moved_constant_640,tmp_moved_constant_640,tmp_moved_constant_640),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_643,tmp_moved_constant_643,tmp_moved_constant_643,tmp_moved_constant_643),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_646,tmp_moved_constant_646,tmp_moved_constant_646,tmp_moved_constant_646),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_649,tmp_moved_constant_649,tmp_moved_constant_649,tmp_moved_constant_649),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_521,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_652,tmp_moved_constant_652,tmp_moved_constant_652,tmp_moved_constant_652),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_655,tmp_moved_constant_655,tmp_moved_constant_655,tmp_moved_constant_655),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_658,tmp_moved_constant_658,tmp_moved_constant_658,tmp_moved_constant_658),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_661,tmp_moved_constant_661,tmp_moved_constant_661,tmp_moved_constant_661),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_522,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_664,tmp_moved_constant_664,tmp_moved_constant_664,tmp_moved_constant_664),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_667,tmp_moved_constant_667,tmp_moved_constant_667,tmp_moved_constant_667),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_670,tmp_moved_constant_670,tmp_moved_constant_670,tmp_moved_constant_670),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_673,tmp_moved_constant_673,tmp_moved_constant_673,tmp_moved_constant_673),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_533,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_534,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_535,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_543,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_544,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_545,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_523,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_524,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_525,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_516,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_526,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_536,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718),_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719),_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720),_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721),_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(tmp_moved_constant_517,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729))))),_mm256_mul_pd(tmp_moved_constant_527,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729))))),_mm256_mul_pd(tmp_moved_constant_537,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729))))),_mm256_mul_pd(tmp_moved_constant_518,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))))),_mm256_mul_pd(tmp_moved_constant_528,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))))),_mm256_mul_pd(tmp_moved_constant_538,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))))),_mm256_mul_pd(tmp_moved_constant_519,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737))))),_mm256_mul_pd(tmp_moved_constant_529,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737))))),_mm256_mul_pd(tmp_moved_constant_539,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737)))));
                const __m256d tmp_moved_constant_772 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_530,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_568,tmp_moved_constant_568,tmp_moved_constant_568,tmp_moved_constant_568),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_571,tmp_moved_constant_571,tmp_moved_constant_571,tmp_moved_constant_571),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_574,tmp_moved_constant_574,tmp_moved_constant_574,tmp_moved_constant_574),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_577,tmp_moved_constant_577,tmp_moved_constant_577,tmp_moved_constant_577),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744)))),_mm256_mul_pd(tmp_moved_constant_531,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_580,tmp_moved_constant_580,tmp_moved_constant_580,tmp_moved_constant_580),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_583,tmp_moved_constant_583,tmp_moved_constant_583,tmp_moved_constant_583),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_586,tmp_moved_constant_586,tmp_moved_constant_586,tmp_moved_constant_586),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_589,tmp_moved_constant_589,tmp_moved_constant_589,tmp_moved_constant_589),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_532,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_592,tmp_moved_constant_592,tmp_moved_constant_592,tmp_moved_constant_592),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_595,tmp_moved_constant_595,tmp_moved_constant_595,tmp_moved_constant_595),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_598,tmp_moved_constant_598,tmp_moved_constant_598,tmp_moved_constant_598),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_601,tmp_moved_constant_601,tmp_moved_constant_601,tmp_moved_constant_601),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_540,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_604,tmp_moved_constant_604,tmp_moved_constant_604,tmp_moved_constant_604),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_607,tmp_moved_constant_607,tmp_moved_constant_607,tmp_moved_constant_607),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_610,tmp_moved_constant_610,tmp_moved_constant_610,tmp_moved_constant_610),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_613,tmp_moved_constant_613,tmp_moved_constant_613,tmp_moved_constant_613),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_541,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_616,tmp_moved_constant_616,tmp_moved_constant_616,tmp_moved_constant_616),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_619,tmp_moved_constant_619,tmp_moved_constant_619,tmp_moved_constant_619),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_622,tmp_moved_constant_622,tmp_moved_constant_622,tmp_moved_constant_622),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_625,tmp_moved_constant_625,tmp_moved_constant_625,tmp_moved_constant_625),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_542,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_628,tmp_moved_constant_628,tmp_moved_constant_628,tmp_moved_constant_628),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_631,tmp_moved_constant_631,tmp_moved_constant_631,tmp_moved_constant_631),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_634,tmp_moved_constant_634,tmp_moved_constant_634,tmp_moved_constant_634),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_637,tmp_moved_constant_637,tmp_moved_constant_637,tmp_moved_constant_637),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_520,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_640,tmp_moved_constant_640,tmp_moved_constant_640,tmp_moved_constant_640),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_643,tmp_moved_constant_643,tmp_moved_constant_643,tmp_moved_constant_643),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_646,tmp_moved_constant_646,tmp_moved_constant_646,tmp_moved_constant_646),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_649,tmp_moved_constant_649,tmp_moved_constant_649,tmp_moved_constant_649),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_521,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_652,tmp_moved_constant_652,tmp_moved_constant_652,tmp_moved_constant_652),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_655,tmp_moved_constant_655,tmp_moved_constant_655,tmp_moved_constant_655),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_658,tmp_moved_constant_658,tmp_moved_constant_658,tmp_moved_constant_658),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_661,tmp_moved_constant_661,tmp_moved_constant_661,tmp_moved_constant_661),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_522,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_664,tmp_moved_constant_664,tmp_moved_constant_664,tmp_moved_constant_664),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_667,tmp_moved_constant_667,tmp_moved_constant_667,tmp_moved_constant_667),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_670,tmp_moved_constant_670,tmp_moved_constant_670,tmp_moved_constant_670),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_673,tmp_moved_constant_673,tmp_moved_constant_673,tmp_moved_constant_673),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_533,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_534,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_535,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_543,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_544,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_545,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_523,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_524,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_525,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_516,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_526,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_536,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718),_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719),_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720),_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721),_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744))))),_mm256_mul_pd(tmp_moved_constant_517,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))))),_mm256_mul_pd(tmp_moved_constant_527,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))))),_mm256_mul_pd(tmp_moved_constant_537,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))))),_mm256_mul_pd(tmp_moved_constant_518,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749))))),_mm256_mul_pd(tmp_moved_constant_528,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749))))),_mm256_mul_pd(tmp_moved_constant_538,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749))))),_mm256_mul_pd(tmp_moved_constant_519,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753))))),_mm256_mul_pd(tmp_moved_constant_529,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753))))),_mm256_mul_pd(tmp_moved_constant_539,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753)))));
                const __m256d tmp_moved_constant_773 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_530,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_568,tmp_moved_constant_568,tmp_moved_constant_568,tmp_moved_constant_568),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_571,tmp_moved_constant_571,tmp_moved_constant_571,tmp_moved_constant_571),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_574,tmp_moved_constant_574,tmp_moved_constant_574,tmp_moved_constant_574),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_577,tmp_moved_constant_577,tmp_moved_constant_577,tmp_moved_constant_577),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760)))),_mm256_mul_pd(tmp_moved_constant_531,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_580,tmp_moved_constant_580,tmp_moved_constant_580,tmp_moved_constant_580),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_583,tmp_moved_constant_583,tmp_moved_constant_583,tmp_moved_constant_583),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_586,tmp_moved_constant_586,tmp_moved_constant_586,tmp_moved_constant_586),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_589,tmp_moved_constant_589,tmp_moved_constant_589,tmp_moved_constant_589),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_532,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_592,tmp_moved_constant_592,tmp_moved_constant_592,tmp_moved_constant_592),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_595,tmp_moved_constant_595,tmp_moved_constant_595,tmp_moved_constant_595),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_598,tmp_moved_constant_598,tmp_moved_constant_598,tmp_moved_constant_598),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_601,tmp_moved_constant_601,tmp_moved_constant_601,tmp_moved_constant_601),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_540,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_604,tmp_moved_constant_604,tmp_moved_constant_604,tmp_moved_constant_604),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_607,tmp_moved_constant_607,tmp_moved_constant_607,tmp_moved_constant_607),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_610,tmp_moved_constant_610,tmp_moved_constant_610,tmp_moved_constant_610),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_613,tmp_moved_constant_613,tmp_moved_constant_613,tmp_moved_constant_613),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_541,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_616,tmp_moved_constant_616,tmp_moved_constant_616,tmp_moved_constant_616),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_619,tmp_moved_constant_619,tmp_moved_constant_619,tmp_moved_constant_619),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_622,tmp_moved_constant_622,tmp_moved_constant_622,tmp_moved_constant_622),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_625,tmp_moved_constant_625,tmp_moved_constant_625,tmp_moved_constant_625),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_542,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_628,tmp_moved_constant_628,tmp_moved_constant_628,tmp_moved_constant_628),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_631,tmp_moved_constant_631,tmp_moved_constant_631,tmp_moved_constant_631),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_634,tmp_moved_constant_634,tmp_moved_constant_634,tmp_moved_constant_634),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_637,tmp_moved_constant_637,tmp_moved_constant_637,tmp_moved_constant_637),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_520,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_640,tmp_moved_constant_640,tmp_moved_constant_640,tmp_moved_constant_640),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_643,tmp_moved_constant_643,tmp_moved_constant_643,tmp_moved_constant_643),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_646,tmp_moved_constant_646,tmp_moved_constant_646,tmp_moved_constant_646),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_649,tmp_moved_constant_649,tmp_moved_constant_649,tmp_moved_constant_649),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_521,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_652,tmp_moved_constant_652,tmp_moved_constant_652,tmp_moved_constant_652),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_655,tmp_moved_constant_655,tmp_moved_constant_655,tmp_moved_constant_655),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_658,tmp_moved_constant_658,tmp_moved_constant_658,tmp_moved_constant_658),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_661,tmp_moved_constant_661,tmp_moved_constant_661,tmp_moved_constant_661),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_522,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_664,tmp_moved_constant_664,tmp_moved_constant_664,tmp_moved_constant_664),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_667,tmp_moved_constant_667,tmp_moved_constant_667,tmp_moved_constant_667),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_670,tmp_moved_constant_670,tmp_moved_constant_670,tmp_moved_constant_670),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_673,tmp_moved_constant_673,tmp_moved_constant_673,tmp_moved_constant_673),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_533,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_534,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_535,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_543,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_544,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_545,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_523,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_524,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_525,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_516,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_526,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_536,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718),_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719),_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720),_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721),_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))))),_mm256_mul_pd(tmp_moved_constant_517,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761))))),_mm256_mul_pd(tmp_moved_constant_527,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761))))),_mm256_mul_pd(tmp_moved_constant_537,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761))))),_mm256_mul_pd(tmp_moved_constant_518,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765))))),_mm256_mul_pd(tmp_moved_constant_528,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765))))),_mm256_mul_pd(tmp_moved_constant_538,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765))))),_mm256_mul_pd(tmp_moved_constant_519,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769))))),_mm256_mul_pd(tmp_moved_constant_529,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769))))),_mm256_mul_pd(tmp_moved_constant_539,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769)))));
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_770,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_771,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_772,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_773,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                   }
                }
                const __m256d tmp_moved_constant_774 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_775 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_776 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_777 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_778 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_779 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_780 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_781 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_782 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_783 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_784 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_785 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_786 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_787 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_788 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_789 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_790 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_791 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_792 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_793 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_794 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_795 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_796 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_797 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_798 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_799 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_800 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_801 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_802 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_803 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1028 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_788,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_826,tmp_moved_constant_826,tmp_moved_constant_826,tmp_moved_constant_826)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_829,tmp_moved_constant_829,tmp_moved_constant_829,tmp_moved_constant_829))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_832,tmp_moved_constant_832,tmp_moved_constant_832,tmp_moved_constant_832))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_835,tmp_moved_constant_835,tmp_moved_constant_835,tmp_moved_constant_835)))),_mm256_mul_pd(tmp_moved_constant_789,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_838,tmp_moved_constant_838,tmp_moved_constant_838,tmp_moved_constant_838)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_841,tmp_moved_constant_841,tmp_moved_constant_841,tmp_moved_constant_841))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_844,tmp_moved_constant_844,tmp_moved_constant_844,tmp_moved_constant_844))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_847,tmp_moved_constant_847,tmp_moved_constant_847,tmp_moved_constant_847))))),_mm256_mul_pd(tmp_moved_constant_790,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_850,tmp_moved_constant_850,tmp_moved_constant_850,tmp_moved_constant_850)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_853,tmp_moved_constant_853,tmp_moved_constant_853,tmp_moved_constant_853))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_856,tmp_moved_constant_856,tmp_moved_constant_856,tmp_moved_constant_856))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_859,tmp_moved_constant_859,tmp_moved_constant_859,tmp_moved_constant_859))))),_mm256_mul_pd(tmp_moved_constant_798,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_862,tmp_moved_constant_862,tmp_moved_constant_862,tmp_moved_constant_862)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_865,tmp_moved_constant_865,tmp_moved_constant_865,tmp_moved_constant_865))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_868,tmp_moved_constant_868,tmp_moved_constant_868,tmp_moved_constant_868))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_871,tmp_moved_constant_871,tmp_moved_constant_871,tmp_moved_constant_871))))),_mm256_mul_pd(tmp_moved_constant_799,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_874,tmp_moved_constant_874,tmp_moved_constant_874,tmp_moved_constant_874)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_877,tmp_moved_constant_877,tmp_moved_constant_877,tmp_moved_constant_877))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_880,tmp_moved_constant_880,tmp_moved_constant_880,tmp_moved_constant_880))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_883,tmp_moved_constant_883,tmp_moved_constant_883,tmp_moved_constant_883))))),_mm256_mul_pd(tmp_moved_constant_800,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_886,tmp_moved_constant_886,tmp_moved_constant_886,tmp_moved_constant_886)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_889,tmp_moved_constant_889,tmp_moved_constant_889,tmp_moved_constant_889))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_892,tmp_moved_constant_892,tmp_moved_constant_892,tmp_moved_constant_892))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_895,tmp_moved_constant_895,tmp_moved_constant_895,tmp_moved_constant_895))))),_mm256_mul_pd(tmp_moved_constant_778,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_898,tmp_moved_constant_898,tmp_moved_constant_898,tmp_moved_constant_898)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_901,tmp_moved_constant_901,tmp_moved_constant_901,tmp_moved_constant_901))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_904,tmp_moved_constant_904,tmp_moved_constant_904,tmp_moved_constant_904))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_907,tmp_moved_constant_907,tmp_moved_constant_907,tmp_moved_constant_907))))),_mm256_mul_pd(tmp_moved_constant_779,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_910,tmp_moved_constant_910,tmp_moved_constant_910,tmp_moved_constant_910)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_913,tmp_moved_constant_913,tmp_moved_constant_913,tmp_moved_constant_913))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))))),_mm256_mul_pd(tmp_moved_constant_780,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))))),_mm256_mul_pd(tmp_moved_constant_791,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935))))),_mm256_mul_pd(tmp_moved_constant_792,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939))))),_mm256_mul_pd(tmp_moved_constant_793,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))))),_mm256_mul_pd(tmp_moved_constant_801,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947))))),_mm256_mul_pd(tmp_moved_constant_802,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951))))),_mm256_mul_pd(tmp_moved_constant_803,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))))),_mm256_mul_pd(tmp_moved_constant_781,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959))))),_mm256_mul_pd(tmp_moved_constant_782,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963))))),_mm256_mul_pd(tmp_moved_constant_783,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))))),_mm256_mul_pd(tmp_moved_constant_774,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971))))),_mm256_mul_pd(tmp_moved_constant_784,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975))))),_mm256_mul_pd(tmp_moved_constant_794,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805,tmp_moved_constant_805),_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808,tmp_moved_constant_808),_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811,tmp_moved_constant_811),_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814,tmp_moved_constant_814),_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))))),_mm256_mul_pd(tmp_moved_constant_775,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815))))),_mm256_mul_pd(tmp_moved_constant_785,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815))))),_mm256_mul_pd(tmp_moved_constant_795,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815))))),_mm256_mul_pd(tmp_moved_constant_776,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_816,tmp_moved_constant_816,tmp_moved_constant_816,tmp_moved_constant_816)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_817,tmp_moved_constant_817,tmp_moved_constant_817,tmp_moved_constant_817))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_819,tmp_moved_constant_819,tmp_moved_constant_819,tmp_moved_constant_819))))),_mm256_mul_pd(tmp_moved_constant_786,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_816,tmp_moved_constant_816,tmp_moved_constant_816,tmp_moved_constant_816)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_817,tmp_moved_constant_817,tmp_moved_constant_817,tmp_moved_constant_817))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_819,tmp_moved_constant_819,tmp_moved_constant_819,tmp_moved_constant_819))))),_mm256_mul_pd(tmp_moved_constant_796,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_816,tmp_moved_constant_816,tmp_moved_constant_816,tmp_moved_constant_816)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_817,tmp_moved_constant_817,tmp_moved_constant_817,tmp_moved_constant_817))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_819,tmp_moved_constant_819,tmp_moved_constant_819,tmp_moved_constant_819))))),_mm256_mul_pd(tmp_moved_constant_777,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_820,tmp_moved_constant_820,tmp_moved_constant_820,tmp_moved_constant_820)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_822,tmp_moved_constant_822,tmp_moved_constant_822,tmp_moved_constant_822))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_823,tmp_moved_constant_823,tmp_moved_constant_823,tmp_moved_constant_823))))),_mm256_mul_pd(tmp_moved_constant_787,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_820,tmp_moved_constant_820,tmp_moved_constant_820,tmp_moved_constant_820)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_822,tmp_moved_constant_822,tmp_moved_constant_822,tmp_moved_constant_822))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_823,tmp_moved_constant_823,tmp_moved_constant_823,tmp_moved_constant_823))))),_mm256_mul_pd(tmp_moved_constant_797,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_820,tmp_moved_constant_820,tmp_moved_constant_820,tmp_moved_constant_820)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_822,tmp_moved_constant_822,tmp_moved_constant_822,tmp_moved_constant_822))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_823,tmp_moved_constant_823,tmp_moved_constant_823,tmp_moved_constant_823)))));
                const __m256d tmp_moved_constant_1029 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_788,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_826,tmp_moved_constant_826,tmp_moved_constant_826,tmp_moved_constant_826),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_829,tmp_moved_constant_829,tmp_moved_constant_829,tmp_moved_constant_829),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_832,tmp_moved_constant_832,tmp_moved_constant_832,tmp_moved_constant_832),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_835,tmp_moved_constant_835,tmp_moved_constant_835,tmp_moved_constant_835),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986)))),_mm256_mul_pd(tmp_moved_constant_789,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_838,tmp_moved_constant_838,tmp_moved_constant_838,tmp_moved_constant_838),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_841,tmp_moved_constant_841,tmp_moved_constant_841,tmp_moved_constant_841),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_844,tmp_moved_constant_844,tmp_moved_constant_844,tmp_moved_constant_844),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_847,tmp_moved_constant_847,tmp_moved_constant_847,tmp_moved_constant_847),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_790,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_850,tmp_moved_constant_850,tmp_moved_constant_850,tmp_moved_constant_850),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_853,tmp_moved_constant_853,tmp_moved_constant_853,tmp_moved_constant_853),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_856,tmp_moved_constant_856,tmp_moved_constant_856,tmp_moved_constant_856),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_859,tmp_moved_constant_859,tmp_moved_constant_859,tmp_moved_constant_859),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_798,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_862,tmp_moved_constant_862,tmp_moved_constant_862,tmp_moved_constant_862),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_865,tmp_moved_constant_865,tmp_moved_constant_865,tmp_moved_constant_865),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_868,tmp_moved_constant_868,tmp_moved_constant_868,tmp_moved_constant_868),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_871,tmp_moved_constant_871,tmp_moved_constant_871,tmp_moved_constant_871),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_799,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_874,tmp_moved_constant_874,tmp_moved_constant_874,tmp_moved_constant_874),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_877,tmp_moved_constant_877,tmp_moved_constant_877,tmp_moved_constant_877),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_880,tmp_moved_constant_880,tmp_moved_constant_880,tmp_moved_constant_880),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_883,tmp_moved_constant_883,tmp_moved_constant_883,tmp_moved_constant_883),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_800,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_886,tmp_moved_constant_886,tmp_moved_constant_886,tmp_moved_constant_886),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_889,tmp_moved_constant_889,tmp_moved_constant_889,tmp_moved_constant_889),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_892,tmp_moved_constant_892,tmp_moved_constant_892,tmp_moved_constant_892),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_895,tmp_moved_constant_895,tmp_moved_constant_895,tmp_moved_constant_895),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_778,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_898,tmp_moved_constant_898,tmp_moved_constant_898,tmp_moved_constant_898),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_901,tmp_moved_constant_901,tmp_moved_constant_901,tmp_moved_constant_901),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_904,tmp_moved_constant_904,tmp_moved_constant_904,tmp_moved_constant_904),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_907,tmp_moved_constant_907,tmp_moved_constant_907,tmp_moved_constant_907),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_779,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_910,tmp_moved_constant_910,tmp_moved_constant_910,tmp_moved_constant_910),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_913,tmp_moved_constant_913,tmp_moved_constant_913,tmp_moved_constant_913),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_780,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_791,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_792,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_793,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_801,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_802,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_803,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_781,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_782,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_783,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_774,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_784,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_794,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976),_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977),_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978),_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979),_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(tmp_moved_constant_775,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987))))),_mm256_mul_pd(tmp_moved_constant_785,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987))))),_mm256_mul_pd(tmp_moved_constant_795,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987))))),_mm256_mul_pd(tmp_moved_constant_776,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))))),_mm256_mul_pd(tmp_moved_constant_786,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))))),_mm256_mul_pd(tmp_moved_constant_796,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))))),_mm256_mul_pd(tmp_moved_constant_777,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995))))),_mm256_mul_pd(tmp_moved_constant_787,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995))))),_mm256_mul_pd(tmp_moved_constant_797,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995)))));
                const __m256d tmp_moved_constant_1030 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_788,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_832,tmp_moved_constant_832,tmp_moved_constant_832,tmp_moved_constant_832)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_835,tmp_moved_constant_835,tmp_moved_constant_835,tmp_moved_constant_835))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_826,tmp_moved_constant_826,tmp_moved_constant_826,tmp_moved_constant_826),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_829,tmp_moved_constant_829,tmp_moved_constant_829,tmp_moved_constant_829),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998)))),_mm256_mul_pd(tmp_moved_constant_789,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_844,tmp_moved_constant_844,tmp_moved_constant_844,tmp_moved_constant_844)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_847,tmp_moved_constant_847,tmp_moved_constant_847,tmp_moved_constant_847))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_838,tmp_moved_constant_838,tmp_moved_constant_838,tmp_moved_constant_838),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_841,tmp_moved_constant_841,tmp_moved_constant_841,tmp_moved_constant_841),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_790,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_856,tmp_moved_constant_856,tmp_moved_constant_856,tmp_moved_constant_856)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_859,tmp_moved_constant_859,tmp_moved_constant_859,tmp_moved_constant_859))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_850,tmp_moved_constant_850,tmp_moved_constant_850,tmp_moved_constant_850),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_853,tmp_moved_constant_853,tmp_moved_constant_853,tmp_moved_constant_853),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_798,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_868,tmp_moved_constant_868,tmp_moved_constant_868,tmp_moved_constant_868)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_871,tmp_moved_constant_871,tmp_moved_constant_871,tmp_moved_constant_871))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_862,tmp_moved_constant_862,tmp_moved_constant_862,tmp_moved_constant_862),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_865,tmp_moved_constant_865,tmp_moved_constant_865,tmp_moved_constant_865),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_799,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_880,tmp_moved_constant_880,tmp_moved_constant_880,tmp_moved_constant_880)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_883,tmp_moved_constant_883,tmp_moved_constant_883,tmp_moved_constant_883))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_874,tmp_moved_constant_874,tmp_moved_constant_874,tmp_moved_constant_874),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_877,tmp_moved_constant_877,tmp_moved_constant_877,tmp_moved_constant_877),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_800,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_892,tmp_moved_constant_892,tmp_moved_constant_892,tmp_moved_constant_892)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_895,tmp_moved_constant_895,tmp_moved_constant_895,tmp_moved_constant_895))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_886,tmp_moved_constant_886,tmp_moved_constant_886,tmp_moved_constant_886),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_889,tmp_moved_constant_889,tmp_moved_constant_889,tmp_moved_constant_889),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_778,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_904,tmp_moved_constant_904,tmp_moved_constant_904,tmp_moved_constant_904)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_907,tmp_moved_constant_907,tmp_moved_constant_907,tmp_moved_constant_907))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_898,tmp_moved_constant_898,tmp_moved_constant_898,tmp_moved_constant_898),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_901,tmp_moved_constant_901,tmp_moved_constant_901,tmp_moved_constant_901),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_779,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_910,tmp_moved_constant_910,tmp_moved_constant_910,tmp_moved_constant_910),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_913,tmp_moved_constant_913,tmp_moved_constant_913,tmp_moved_constant_913),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_780,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_791,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_792,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_793,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_801,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_802,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_803,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_781,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_782,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_783,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_774,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_784,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_794,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000),_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002),_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976),_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977),_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(tmp_moved_constant_775,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999))))),_mm256_mul_pd(tmp_moved_constant_785,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999))))),_mm256_mul_pd(tmp_moved_constant_795,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999))))),_mm256_mul_pd(tmp_moved_constant_776,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007))))),_mm256_mul_pd(tmp_moved_constant_786,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007))))),_mm256_mul_pd(tmp_moved_constant_796,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007))))),_mm256_mul_pd(tmp_moved_constant_777,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011))))),_mm256_mul_pd(tmp_moved_constant_787,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011))))),_mm256_mul_pd(tmp_moved_constant_797,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011)))));
                const __m256d tmp_moved_constant_1031 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_788,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_826,tmp_moved_constant_826,tmp_moved_constant_826,tmp_moved_constant_826)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_829,tmp_moved_constant_829,tmp_moved_constant_829,tmp_moved_constant_829))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_832,tmp_moved_constant_832,tmp_moved_constant_832,tmp_moved_constant_832))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_835,tmp_moved_constant_835,tmp_moved_constant_835,tmp_moved_constant_835)))),_mm256_mul_pd(tmp_moved_constant_789,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_838,tmp_moved_constant_838,tmp_moved_constant_838,tmp_moved_constant_838)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_841,tmp_moved_constant_841,tmp_moved_constant_841,tmp_moved_constant_841))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_844,tmp_moved_constant_844,tmp_moved_constant_844,tmp_moved_constant_844))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_847,tmp_moved_constant_847,tmp_moved_constant_847,tmp_moved_constant_847))))),_mm256_mul_pd(tmp_moved_constant_790,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_850,tmp_moved_constant_850,tmp_moved_constant_850,tmp_moved_constant_850)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_853,tmp_moved_constant_853,tmp_moved_constant_853,tmp_moved_constant_853))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_856,tmp_moved_constant_856,tmp_moved_constant_856,tmp_moved_constant_856))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_859,tmp_moved_constant_859,tmp_moved_constant_859,tmp_moved_constant_859))))),_mm256_mul_pd(tmp_moved_constant_798,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_862,tmp_moved_constant_862,tmp_moved_constant_862,tmp_moved_constant_862)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_865,tmp_moved_constant_865,tmp_moved_constant_865,tmp_moved_constant_865))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_868,tmp_moved_constant_868,tmp_moved_constant_868,tmp_moved_constant_868))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_871,tmp_moved_constant_871,tmp_moved_constant_871,tmp_moved_constant_871))))),_mm256_mul_pd(tmp_moved_constant_799,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_874,tmp_moved_constant_874,tmp_moved_constant_874,tmp_moved_constant_874)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_877,tmp_moved_constant_877,tmp_moved_constant_877,tmp_moved_constant_877))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_880,tmp_moved_constant_880,tmp_moved_constant_880,tmp_moved_constant_880))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_883,tmp_moved_constant_883,tmp_moved_constant_883,tmp_moved_constant_883))))),_mm256_mul_pd(tmp_moved_constant_800,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_886,tmp_moved_constant_886,tmp_moved_constant_886,tmp_moved_constant_886)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_889,tmp_moved_constant_889,tmp_moved_constant_889,tmp_moved_constant_889))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_892,tmp_moved_constant_892,tmp_moved_constant_892,tmp_moved_constant_892))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_895,tmp_moved_constant_895,tmp_moved_constant_895,tmp_moved_constant_895))))),_mm256_mul_pd(tmp_moved_constant_778,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_898,tmp_moved_constant_898,tmp_moved_constant_898,tmp_moved_constant_898)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_901,tmp_moved_constant_901,tmp_moved_constant_901,tmp_moved_constant_901))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_904,tmp_moved_constant_904,tmp_moved_constant_904,tmp_moved_constant_904))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_907,tmp_moved_constant_907,tmp_moved_constant_907,tmp_moved_constant_907))))),_mm256_mul_pd(tmp_moved_constant_779,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_910,tmp_moved_constant_910,tmp_moved_constant_910,tmp_moved_constant_910)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_913,tmp_moved_constant_913,tmp_moved_constant_913,tmp_moved_constant_913))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))))),_mm256_mul_pd(tmp_moved_constant_780,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))))),_mm256_mul_pd(tmp_moved_constant_791,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935))))),_mm256_mul_pd(tmp_moved_constant_792,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939))))),_mm256_mul_pd(tmp_moved_constant_793,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))))),_mm256_mul_pd(tmp_moved_constant_801,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947))))),_mm256_mul_pd(tmp_moved_constant_802,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951))))),_mm256_mul_pd(tmp_moved_constant_803,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))))),_mm256_mul_pd(tmp_moved_constant_781,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959))))),_mm256_mul_pd(tmp_moved_constant_782,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963))))),_mm256_mul_pd(tmp_moved_constant_783,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))))),_mm256_mul_pd(tmp_moved_constant_774,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971))))),_mm256_mul_pd(tmp_moved_constant_784,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975))))),_mm256_mul_pd(tmp_moved_constant_794,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012),_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014),_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016),_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018),_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))))),_mm256_mul_pd(tmp_moved_constant_775,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019))))),_mm256_mul_pd(tmp_moved_constant_785,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019))))),_mm256_mul_pd(tmp_moved_constant_795,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019))))),_mm256_mul_pd(tmp_moved_constant_776,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1020,tmp_moved_constant_1020,tmp_moved_constant_1020,tmp_moved_constant_1020)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1021,tmp_moved_constant_1021,tmp_moved_constant_1021,tmp_moved_constant_1021))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1023,tmp_moved_constant_1023,tmp_moved_constant_1023,tmp_moved_constant_1023))))),_mm256_mul_pd(tmp_moved_constant_786,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1020,tmp_moved_constant_1020,tmp_moved_constant_1020,tmp_moved_constant_1020)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1021,tmp_moved_constant_1021,tmp_moved_constant_1021,tmp_moved_constant_1021))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1023,tmp_moved_constant_1023,tmp_moved_constant_1023,tmp_moved_constant_1023))))),_mm256_mul_pd(tmp_moved_constant_796,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1020,tmp_moved_constant_1020,tmp_moved_constant_1020,tmp_moved_constant_1020)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1021,tmp_moved_constant_1021,tmp_moved_constant_1021,tmp_moved_constant_1021))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1023,tmp_moved_constant_1023,tmp_moved_constant_1023,tmp_moved_constant_1023))))),_mm256_mul_pd(tmp_moved_constant_777,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1024,tmp_moved_constant_1024,tmp_moved_constant_1024,tmp_moved_constant_1024)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1026,tmp_moved_constant_1026,tmp_moved_constant_1026,tmp_moved_constant_1026))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1027,tmp_moved_constant_1027,tmp_moved_constant_1027,tmp_moved_constant_1027))))),_mm256_mul_pd(tmp_moved_constant_787,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1024,tmp_moved_constant_1024,tmp_moved_constant_1024,tmp_moved_constant_1024)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1026,tmp_moved_constant_1026,tmp_moved_constant_1026,tmp_moved_constant_1026))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1027,tmp_moved_constant_1027,tmp_moved_constant_1027,tmp_moved_constant_1027))))),_mm256_mul_pd(tmp_moved_constant_797,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1024,tmp_moved_constant_1024,tmp_moved_constant_1024,tmp_moved_constant_1024)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1026,tmp_moved_constant_1026,tmp_moved_constant_1026,tmp_moved_constant_1026))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_set_pd(tmp_moved_constant_1027,tmp_moved_constant_1027,tmp_moved_constant_1027,tmp_moved_constant_1027)))));
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_1028,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_1029,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_1030,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_1031,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                   }
                }
                const __m256d tmp_moved_constant_1032 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_1033 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1034 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1035 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_1036 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_1037 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1038 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1039 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1040 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_1041 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1042 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_1043 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1044 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1045 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_1046 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_1047 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1048 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1049 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1050 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_1051 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1052 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_1053 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1054 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1055 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_1056 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_1057 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1058 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1059 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1060 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d tmp_moved_constant_1061 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_moved_constant_1286 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1046,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1084,tmp_moved_constant_1084,tmp_moved_constant_1084,tmp_moved_constant_1084)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1087,tmp_moved_constant_1087,tmp_moved_constant_1087,tmp_moved_constant_1087))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1090,tmp_moved_constant_1090,tmp_moved_constant_1090,tmp_moved_constant_1090))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1093,tmp_moved_constant_1093,tmp_moved_constant_1093,tmp_moved_constant_1093)))),_mm256_mul_pd(tmp_moved_constant_1047,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1096,tmp_moved_constant_1096,tmp_moved_constant_1096,tmp_moved_constant_1096)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1099,tmp_moved_constant_1099,tmp_moved_constant_1099,tmp_moved_constant_1099))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1102,tmp_moved_constant_1102,tmp_moved_constant_1102,tmp_moved_constant_1102))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1105,tmp_moved_constant_1105,tmp_moved_constant_1105,tmp_moved_constant_1105))))),_mm256_mul_pd(tmp_moved_constant_1048,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1108,tmp_moved_constant_1108,tmp_moved_constant_1108,tmp_moved_constant_1108)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1111,tmp_moved_constant_1111,tmp_moved_constant_1111,tmp_moved_constant_1111))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1114,tmp_moved_constant_1114,tmp_moved_constant_1114,tmp_moved_constant_1114))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1117,tmp_moved_constant_1117,tmp_moved_constant_1117,tmp_moved_constant_1117))))),_mm256_mul_pd(tmp_moved_constant_1056,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1120,tmp_moved_constant_1120,tmp_moved_constant_1120,tmp_moved_constant_1120)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1123,tmp_moved_constant_1123,tmp_moved_constant_1123,tmp_moved_constant_1123))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1126,tmp_moved_constant_1126,tmp_moved_constant_1126,tmp_moved_constant_1126))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1129,tmp_moved_constant_1129,tmp_moved_constant_1129,tmp_moved_constant_1129))))),_mm256_mul_pd(tmp_moved_constant_1057,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1132,tmp_moved_constant_1132,tmp_moved_constant_1132,tmp_moved_constant_1132)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1135,tmp_moved_constant_1135,tmp_moved_constant_1135,tmp_moved_constant_1135))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1138,tmp_moved_constant_1138,tmp_moved_constant_1138,tmp_moved_constant_1138))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1141,tmp_moved_constant_1141,tmp_moved_constant_1141,tmp_moved_constant_1141))))),_mm256_mul_pd(tmp_moved_constant_1058,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1144,tmp_moved_constant_1144,tmp_moved_constant_1144,tmp_moved_constant_1144)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1147,tmp_moved_constant_1147,tmp_moved_constant_1147,tmp_moved_constant_1147))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1150,tmp_moved_constant_1150,tmp_moved_constant_1150,tmp_moved_constant_1150))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1153,tmp_moved_constant_1153,tmp_moved_constant_1153,tmp_moved_constant_1153))))),_mm256_mul_pd(tmp_moved_constant_1036,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165))))),_mm256_mul_pd(tmp_moved_constant_1037,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177))))),_mm256_mul_pd(tmp_moved_constant_1038,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189))))),_mm256_mul_pd(tmp_moved_constant_1049,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193))))),_mm256_mul_pd(tmp_moved_constant_1050,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197))))),_mm256_mul_pd(tmp_moved_constant_1051,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1200,tmp_moved_constant_1200,tmp_moved_constant_1200,tmp_moved_constant_1200))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1201,tmp_moved_constant_1201,tmp_moved_constant_1201,tmp_moved_constant_1201))))),_mm256_mul_pd(tmp_moved_constant_1059,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1202,tmp_moved_constant_1202,tmp_moved_constant_1202,tmp_moved_constant_1202)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1203,tmp_moved_constant_1203,tmp_moved_constant_1203,tmp_moved_constant_1203))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1204,tmp_moved_constant_1204,tmp_moved_constant_1204,tmp_moved_constant_1204))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1205,tmp_moved_constant_1205,tmp_moved_constant_1205,tmp_moved_constant_1205))))),_mm256_mul_pd(tmp_moved_constant_1060,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1206,tmp_moved_constant_1206,tmp_moved_constant_1206,tmp_moved_constant_1206)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1207,tmp_moved_constant_1207,tmp_moved_constant_1207,tmp_moved_constant_1207))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1208,tmp_moved_constant_1208,tmp_moved_constant_1208,tmp_moved_constant_1208))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1209,tmp_moved_constant_1209,tmp_moved_constant_1209,tmp_moved_constant_1209))))),_mm256_mul_pd(tmp_moved_constant_1061,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1210,tmp_moved_constant_1210,tmp_moved_constant_1210,tmp_moved_constant_1210)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1211,tmp_moved_constant_1211,tmp_moved_constant_1211,tmp_moved_constant_1211))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1212,tmp_moved_constant_1212,tmp_moved_constant_1212,tmp_moved_constant_1212))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1213,tmp_moved_constant_1213,tmp_moved_constant_1213,tmp_moved_constant_1213))))),_mm256_mul_pd(tmp_moved_constant_1039,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1214,tmp_moved_constant_1214,tmp_moved_constant_1214,tmp_moved_constant_1214)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1215,tmp_moved_constant_1215,tmp_moved_constant_1215,tmp_moved_constant_1215))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1216,tmp_moved_constant_1216,tmp_moved_constant_1216,tmp_moved_constant_1216))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1217,tmp_moved_constant_1217,tmp_moved_constant_1217,tmp_moved_constant_1217))))),_mm256_mul_pd(tmp_moved_constant_1040,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1218,tmp_moved_constant_1218,tmp_moved_constant_1218,tmp_moved_constant_1218)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1219,tmp_moved_constant_1219,tmp_moved_constant_1219,tmp_moved_constant_1219))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1220,tmp_moved_constant_1220,tmp_moved_constant_1220,tmp_moved_constant_1220))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1221,tmp_moved_constant_1221,tmp_moved_constant_1221,tmp_moved_constant_1221))))),_mm256_mul_pd(tmp_moved_constant_1041,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1222,tmp_moved_constant_1222,tmp_moved_constant_1222,tmp_moved_constant_1222)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1223,tmp_moved_constant_1223,tmp_moved_constant_1223,tmp_moved_constant_1223))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1224,tmp_moved_constant_1224,tmp_moved_constant_1224,tmp_moved_constant_1224))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1225,tmp_moved_constant_1225,tmp_moved_constant_1225,tmp_moved_constant_1225))))),_mm256_mul_pd(tmp_moved_constant_1032,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1226,tmp_moved_constant_1226,tmp_moved_constant_1226,tmp_moved_constant_1226)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1227,tmp_moved_constant_1227,tmp_moved_constant_1227,tmp_moved_constant_1227))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1228,tmp_moved_constant_1228,tmp_moved_constant_1228,tmp_moved_constant_1228))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1229,tmp_moved_constant_1229,tmp_moved_constant_1229,tmp_moved_constant_1229))))),_mm256_mul_pd(tmp_moved_constant_1042,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1230,tmp_moved_constant_1230,tmp_moved_constant_1230,tmp_moved_constant_1230)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1231,tmp_moved_constant_1231,tmp_moved_constant_1231,tmp_moved_constant_1231))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1232,tmp_moved_constant_1232,tmp_moved_constant_1232,tmp_moved_constant_1232))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1233,tmp_moved_constant_1233,tmp_moved_constant_1233,tmp_moved_constant_1233))))),_mm256_mul_pd(tmp_moved_constant_1052,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063,tmp_moved_constant_1063),_mm256_set_pd(tmp_moved_constant_1234,tmp_moved_constant_1234,tmp_moved_constant_1234,tmp_moved_constant_1234)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066,tmp_moved_constant_1066),_mm256_set_pd(tmp_moved_constant_1235,tmp_moved_constant_1235,tmp_moved_constant_1235,tmp_moved_constant_1235))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069,tmp_moved_constant_1069),_mm256_set_pd(tmp_moved_constant_1236,tmp_moved_constant_1236,tmp_moved_constant_1236,tmp_moved_constant_1236))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072,tmp_moved_constant_1072),_mm256_set_pd(tmp_moved_constant_1237,tmp_moved_constant_1237,tmp_moved_constant_1237,tmp_moved_constant_1237))))),_mm256_mul_pd(tmp_moved_constant_1033,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073))))),_mm256_mul_pd(tmp_moved_constant_1043,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073))))),_mm256_mul_pd(tmp_moved_constant_1053,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073))))),_mm256_mul_pd(tmp_moved_constant_1034,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1074,tmp_moved_constant_1074,tmp_moved_constant_1074,tmp_moved_constant_1074)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1075,tmp_moved_constant_1075,tmp_moved_constant_1075,tmp_moved_constant_1075))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1077,tmp_moved_constant_1077,tmp_moved_constant_1077,tmp_moved_constant_1077))))),_mm256_mul_pd(tmp_moved_constant_1044,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1074,tmp_moved_constant_1074,tmp_moved_constant_1074,tmp_moved_constant_1074)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1075,tmp_moved_constant_1075,tmp_moved_constant_1075,tmp_moved_constant_1075))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1077,tmp_moved_constant_1077,tmp_moved_constant_1077,tmp_moved_constant_1077))))),_mm256_mul_pd(tmp_moved_constant_1054,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1074,tmp_moved_constant_1074,tmp_moved_constant_1074,tmp_moved_constant_1074)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1075,tmp_moved_constant_1075,tmp_moved_constant_1075,tmp_moved_constant_1075))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1077,tmp_moved_constant_1077,tmp_moved_constant_1077,tmp_moved_constant_1077))))),_mm256_mul_pd(tmp_moved_constant_1035,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1078,tmp_moved_constant_1078,tmp_moved_constant_1078,tmp_moved_constant_1078)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1080,tmp_moved_constant_1080,tmp_moved_constant_1080,tmp_moved_constant_1080))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1081,tmp_moved_constant_1081,tmp_moved_constant_1081,tmp_moved_constant_1081))))),_mm256_mul_pd(tmp_moved_constant_1045,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1078,tmp_moved_constant_1078,tmp_moved_constant_1078,tmp_moved_constant_1078)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1080,tmp_moved_constant_1080,tmp_moved_constant_1080,tmp_moved_constant_1080))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1081,tmp_moved_constant_1081,tmp_moved_constant_1081,tmp_moved_constant_1081))))),_mm256_mul_pd(tmp_moved_constant_1055,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1078,tmp_moved_constant_1078,tmp_moved_constant_1078,tmp_moved_constant_1078)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1080,tmp_moved_constant_1080,tmp_moved_constant_1080,tmp_moved_constant_1080))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1081,tmp_moved_constant_1081,tmp_moved_constant_1081,tmp_moved_constant_1081)))));
                const __m256d tmp_moved_constant_1287 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1046,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1084,tmp_moved_constant_1084,tmp_moved_constant_1084,tmp_moved_constant_1084),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1087,tmp_moved_constant_1087,tmp_moved_constant_1087,tmp_moved_constant_1087),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1090,tmp_moved_constant_1090,tmp_moved_constant_1090,tmp_moved_constant_1090),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1093,tmp_moved_constant_1093,tmp_moved_constant_1093,tmp_moved_constant_1093),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244)))),_mm256_mul_pd(tmp_moved_constant_1047,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1096,tmp_moved_constant_1096,tmp_moved_constant_1096,tmp_moved_constant_1096),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1099,tmp_moved_constant_1099,tmp_moved_constant_1099,tmp_moved_constant_1099),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1102,tmp_moved_constant_1102,tmp_moved_constant_1102,tmp_moved_constant_1102),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1105,tmp_moved_constant_1105,tmp_moved_constant_1105,tmp_moved_constant_1105),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1048,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1108,tmp_moved_constant_1108,tmp_moved_constant_1108,tmp_moved_constant_1108),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1111,tmp_moved_constant_1111,tmp_moved_constant_1111,tmp_moved_constant_1111),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1114,tmp_moved_constant_1114,tmp_moved_constant_1114,tmp_moved_constant_1114),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1117,tmp_moved_constant_1117,tmp_moved_constant_1117,tmp_moved_constant_1117),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1056,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1120,tmp_moved_constant_1120,tmp_moved_constant_1120,tmp_moved_constant_1120),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1123,tmp_moved_constant_1123,tmp_moved_constant_1123,tmp_moved_constant_1123),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1126,tmp_moved_constant_1126,tmp_moved_constant_1126,tmp_moved_constant_1126),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1129,tmp_moved_constant_1129,tmp_moved_constant_1129,tmp_moved_constant_1129),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1057,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1132,tmp_moved_constant_1132,tmp_moved_constant_1132,tmp_moved_constant_1132),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1135,tmp_moved_constant_1135,tmp_moved_constant_1135,tmp_moved_constant_1135),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1138,tmp_moved_constant_1138,tmp_moved_constant_1138,tmp_moved_constant_1138),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1141,tmp_moved_constant_1141,tmp_moved_constant_1141,tmp_moved_constant_1141),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1058,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1144,tmp_moved_constant_1144,tmp_moved_constant_1144,tmp_moved_constant_1144),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1147,tmp_moved_constant_1147,tmp_moved_constant_1147,tmp_moved_constant_1147),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1150,tmp_moved_constant_1150,tmp_moved_constant_1150,tmp_moved_constant_1150),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1153,tmp_moved_constant_1153,tmp_moved_constant_1153,tmp_moved_constant_1153),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1036,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1037,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1038,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1049,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1050,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1051,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1200,tmp_moved_constant_1200,tmp_moved_constant_1200,tmp_moved_constant_1200),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1201,tmp_moved_constant_1201,tmp_moved_constant_1201,tmp_moved_constant_1201),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1059,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1202,tmp_moved_constant_1202,tmp_moved_constant_1202,tmp_moved_constant_1202),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1203,tmp_moved_constant_1203,tmp_moved_constant_1203,tmp_moved_constant_1203),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1204,tmp_moved_constant_1204,tmp_moved_constant_1204,tmp_moved_constant_1204),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1205,tmp_moved_constant_1205,tmp_moved_constant_1205,tmp_moved_constant_1205),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1060,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1206,tmp_moved_constant_1206,tmp_moved_constant_1206,tmp_moved_constant_1206),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1207,tmp_moved_constant_1207,tmp_moved_constant_1207,tmp_moved_constant_1207),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1208,tmp_moved_constant_1208,tmp_moved_constant_1208,tmp_moved_constant_1208),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1209,tmp_moved_constant_1209,tmp_moved_constant_1209,tmp_moved_constant_1209),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1061,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1210,tmp_moved_constant_1210,tmp_moved_constant_1210,tmp_moved_constant_1210),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1211,tmp_moved_constant_1211,tmp_moved_constant_1211,tmp_moved_constant_1211),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1212,tmp_moved_constant_1212,tmp_moved_constant_1212,tmp_moved_constant_1212),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1213,tmp_moved_constant_1213,tmp_moved_constant_1213,tmp_moved_constant_1213),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1039,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1214,tmp_moved_constant_1214,tmp_moved_constant_1214,tmp_moved_constant_1214),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1215,tmp_moved_constant_1215,tmp_moved_constant_1215,tmp_moved_constant_1215),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1216,tmp_moved_constant_1216,tmp_moved_constant_1216,tmp_moved_constant_1216),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1217,tmp_moved_constant_1217,tmp_moved_constant_1217,tmp_moved_constant_1217),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1040,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1218,tmp_moved_constant_1218,tmp_moved_constant_1218,tmp_moved_constant_1218),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1219,tmp_moved_constant_1219,tmp_moved_constant_1219,tmp_moved_constant_1219),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1220,tmp_moved_constant_1220,tmp_moved_constant_1220,tmp_moved_constant_1220),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1221,tmp_moved_constant_1221,tmp_moved_constant_1221,tmp_moved_constant_1221),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1041,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1222,tmp_moved_constant_1222,tmp_moved_constant_1222,tmp_moved_constant_1222),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1223,tmp_moved_constant_1223,tmp_moved_constant_1223,tmp_moved_constant_1223),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1224,tmp_moved_constant_1224,tmp_moved_constant_1224,tmp_moved_constant_1224),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1225,tmp_moved_constant_1225,tmp_moved_constant_1225,tmp_moved_constant_1225),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1032,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1226,tmp_moved_constant_1226,tmp_moved_constant_1226,tmp_moved_constant_1226),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1227,tmp_moved_constant_1227,tmp_moved_constant_1227,tmp_moved_constant_1227),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1228,tmp_moved_constant_1228,tmp_moved_constant_1228,tmp_moved_constant_1228),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1229,tmp_moved_constant_1229,tmp_moved_constant_1229,tmp_moved_constant_1229),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1042,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1230,tmp_moved_constant_1230,tmp_moved_constant_1230,tmp_moved_constant_1230),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1231,tmp_moved_constant_1231,tmp_moved_constant_1231,tmp_moved_constant_1231),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1232,tmp_moved_constant_1232,tmp_moved_constant_1232,tmp_moved_constant_1232),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1233,tmp_moved_constant_1233,tmp_moved_constant_1233,tmp_moved_constant_1233),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1052,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1234,tmp_moved_constant_1234,tmp_moved_constant_1234,tmp_moved_constant_1234),_mm256_set_pd(tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238,tmp_moved_constant_1238)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1235,tmp_moved_constant_1235,tmp_moved_constant_1235,tmp_moved_constant_1235),_mm256_set_pd(tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240,tmp_moved_constant_1240))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1236,tmp_moved_constant_1236,tmp_moved_constant_1236,tmp_moved_constant_1236),_mm256_set_pd(tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242,tmp_moved_constant_1242))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1237,tmp_moved_constant_1237,tmp_moved_constant_1237,tmp_moved_constant_1237),_mm256_set_pd(tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244,tmp_moved_constant_1244))))),_mm256_mul_pd(tmp_moved_constant_1033,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1239,tmp_moved_constant_1239,tmp_moved_constant_1239,tmp_moved_constant_1239)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1241,tmp_moved_constant_1241,tmp_moved_constant_1241,tmp_moved_constant_1241))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1243,tmp_moved_constant_1243,tmp_moved_constant_1243,tmp_moved_constant_1243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1245,tmp_moved_constant_1245,tmp_moved_constant_1245,tmp_moved_constant_1245))))),_mm256_mul_pd(tmp_moved_constant_1043,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1239,tmp_moved_constant_1239,tmp_moved_constant_1239,tmp_moved_constant_1239)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1241,tmp_moved_constant_1241,tmp_moved_constant_1241,tmp_moved_constant_1241))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1243,tmp_moved_constant_1243,tmp_moved_constant_1243,tmp_moved_constant_1243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1245,tmp_moved_constant_1245,tmp_moved_constant_1245,tmp_moved_constant_1245))))),_mm256_mul_pd(tmp_moved_constant_1053,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1239,tmp_moved_constant_1239,tmp_moved_constant_1239,tmp_moved_constant_1239)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1241,tmp_moved_constant_1241,tmp_moved_constant_1241,tmp_moved_constant_1241))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1243,tmp_moved_constant_1243,tmp_moved_constant_1243,tmp_moved_constant_1243))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1245,tmp_moved_constant_1245,tmp_moved_constant_1245,tmp_moved_constant_1245))))),_mm256_mul_pd(tmp_moved_constant_1034,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1246,tmp_moved_constant_1246,tmp_moved_constant_1246,tmp_moved_constant_1246)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1247,tmp_moved_constant_1247,tmp_moved_constant_1247,tmp_moved_constant_1247))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1248,tmp_moved_constant_1248,tmp_moved_constant_1248,tmp_moved_constant_1248))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1249,tmp_moved_constant_1249,tmp_moved_constant_1249,tmp_moved_constant_1249))))),_mm256_mul_pd(tmp_moved_constant_1044,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1246,tmp_moved_constant_1246,tmp_moved_constant_1246,tmp_moved_constant_1246)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1247,tmp_moved_constant_1247,tmp_moved_constant_1247,tmp_moved_constant_1247))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1248,tmp_moved_constant_1248,tmp_moved_constant_1248,tmp_moved_constant_1248))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1249,tmp_moved_constant_1249,tmp_moved_constant_1249,tmp_moved_constant_1249))))),_mm256_mul_pd(tmp_moved_constant_1054,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1246,tmp_moved_constant_1246,tmp_moved_constant_1246,tmp_moved_constant_1246)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1247,tmp_moved_constant_1247,tmp_moved_constant_1247,tmp_moved_constant_1247))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1248,tmp_moved_constant_1248,tmp_moved_constant_1248,tmp_moved_constant_1248))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1249,tmp_moved_constant_1249,tmp_moved_constant_1249,tmp_moved_constant_1249))))),_mm256_mul_pd(tmp_moved_constant_1035,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1250,tmp_moved_constant_1250,tmp_moved_constant_1250,tmp_moved_constant_1250)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1251,tmp_moved_constant_1251,tmp_moved_constant_1251,tmp_moved_constant_1251))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1252,tmp_moved_constant_1252,tmp_moved_constant_1252,tmp_moved_constant_1252))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1253,tmp_moved_constant_1253,tmp_moved_constant_1253,tmp_moved_constant_1253))))),_mm256_mul_pd(tmp_moved_constant_1045,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1250,tmp_moved_constant_1250,tmp_moved_constant_1250,tmp_moved_constant_1250)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1251,tmp_moved_constant_1251,tmp_moved_constant_1251,tmp_moved_constant_1251))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1252,tmp_moved_constant_1252,tmp_moved_constant_1252,tmp_moved_constant_1252))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1253,tmp_moved_constant_1253,tmp_moved_constant_1253,tmp_moved_constant_1253))))),_mm256_mul_pd(tmp_moved_constant_1055,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1250,tmp_moved_constant_1250,tmp_moved_constant_1250,tmp_moved_constant_1250)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1251,tmp_moved_constant_1251,tmp_moved_constant_1251,tmp_moved_constant_1251))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1252,tmp_moved_constant_1252,tmp_moved_constant_1252,tmp_moved_constant_1252))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1253,tmp_moved_constant_1253,tmp_moved_constant_1253,tmp_moved_constant_1253)))));
                const __m256d tmp_moved_constant_1288 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1046,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1084,tmp_moved_constant_1084,tmp_moved_constant_1084,tmp_moved_constant_1084),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1087,tmp_moved_constant_1087,tmp_moved_constant_1087,tmp_moved_constant_1087),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1090,tmp_moved_constant_1090,tmp_moved_constant_1090,tmp_moved_constant_1090),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1093,tmp_moved_constant_1093,tmp_moved_constant_1093,tmp_moved_constant_1093),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260)))),_mm256_mul_pd(tmp_moved_constant_1047,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1096,tmp_moved_constant_1096,tmp_moved_constant_1096,tmp_moved_constant_1096),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1099,tmp_moved_constant_1099,tmp_moved_constant_1099,tmp_moved_constant_1099),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1102,tmp_moved_constant_1102,tmp_moved_constant_1102,tmp_moved_constant_1102),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1105,tmp_moved_constant_1105,tmp_moved_constant_1105,tmp_moved_constant_1105),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1048,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1108,tmp_moved_constant_1108,tmp_moved_constant_1108,tmp_moved_constant_1108),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1111,tmp_moved_constant_1111,tmp_moved_constant_1111,tmp_moved_constant_1111),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1114,tmp_moved_constant_1114,tmp_moved_constant_1114,tmp_moved_constant_1114),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1117,tmp_moved_constant_1117,tmp_moved_constant_1117,tmp_moved_constant_1117),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1056,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1120,tmp_moved_constant_1120,tmp_moved_constant_1120,tmp_moved_constant_1120),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1123,tmp_moved_constant_1123,tmp_moved_constant_1123,tmp_moved_constant_1123),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1126,tmp_moved_constant_1126,tmp_moved_constant_1126,tmp_moved_constant_1126),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1129,tmp_moved_constant_1129,tmp_moved_constant_1129,tmp_moved_constant_1129),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1057,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1132,tmp_moved_constant_1132,tmp_moved_constant_1132,tmp_moved_constant_1132),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1135,tmp_moved_constant_1135,tmp_moved_constant_1135,tmp_moved_constant_1135),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1138,tmp_moved_constant_1138,tmp_moved_constant_1138,tmp_moved_constant_1138),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1141,tmp_moved_constant_1141,tmp_moved_constant_1141,tmp_moved_constant_1141),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1058,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1144,tmp_moved_constant_1144,tmp_moved_constant_1144,tmp_moved_constant_1144),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1147,tmp_moved_constant_1147,tmp_moved_constant_1147,tmp_moved_constant_1147),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1150,tmp_moved_constant_1150,tmp_moved_constant_1150,tmp_moved_constant_1150),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1153,tmp_moved_constant_1153,tmp_moved_constant_1153,tmp_moved_constant_1153),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1036,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1037,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1038,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1049,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1050,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1051,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1200,tmp_moved_constant_1200,tmp_moved_constant_1200,tmp_moved_constant_1200),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1201,tmp_moved_constant_1201,tmp_moved_constant_1201,tmp_moved_constant_1201),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1059,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1202,tmp_moved_constant_1202,tmp_moved_constant_1202,tmp_moved_constant_1202),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1203,tmp_moved_constant_1203,tmp_moved_constant_1203,tmp_moved_constant_1203),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1204,tmp_moved_constant_1204,tmp_moved_constant_1204,tmp_moved_constant_1204),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1205,tmp_moved_constant_1205,tmp_moved_constant_1205,tmp_moved_constant_1205),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1060,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1206,tmp_moved_constant_1206,tmp_moved_constant_1206,tmp_moved_constant_1206),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1207,tmp_moved_constant_1207,tmp_moved_constant_1207,tmp_moved_constant_1207),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1208,tmp_moved_constant_1208,tmp_moved_constant_1208,tmp_moved_constant_1208),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1209,tmp_moved_constant_1209,tmp_moved_constant_1209,tmp_moved_constant_1209),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1061,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1210,tmp_moved_constant_1210,tmp_moved_constant_1210,tmp_moved_constant_1210),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1211,tmp_moved_constant_1211,tmp_moved_constant_1211,tmp_moved_constant_1211),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1212,tmp_moved_constant_1212,tmp_moved_constant_1212,tmp_moved_constant_1212),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1213,tmp_moved_constant_1213,tmp_moved_constant_1213,tmp_moved_constant_1213),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1039,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1214,tmp_moved_constant_1214,tmp_moved_constant_1214,tmp_moved_constant_1214),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1215,tmp_moved_constant_1215,tmp_moved_constant_1215,tmp_moved_constant_1215),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1216,tmp_moved_constant_1216,tmp_moved_constant_1216,tmp_moved_constant_1216),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1217,tmp_moved_constant_1217,tmp_moved_constant_1217,tmp_moved_constant_1217),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1040,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1218,tmp_moved_constant_1218,tmp_moved_constant_1218,tmp_moved_constant_1218),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1219,tmp_moved_constant_1219,tmp_moved_constant_1219,tmp_moved_constant_1219),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1220,tmp_moved_constant_1220,tmp_moved_constant_1220,tmp_moved_constant_1220),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1221,tmp_moved_constant_1221,tmp_moved_constant_1221,tmp_moved_constant_1221),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1041,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1222,tmp_moved_constant_1222,tmp_moved_constant_1222,tmp_moved_constant_1222),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1223,tmp_moved_constant_1223,tmp_moved_constant_1223,tmp_moved_constant_1223),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1224,tmp_moved_constant_1224,tmp_moved_constant_1224,tmp_moved_constant_1224),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1225,tmp_moved_constant_1225,tmp_moved_constant_1225,tmp_moved_constant_1225),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1032,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1226,tmp_moved_constant_1226,tmp_moved_constant_1226,tmp_moved_constant_1226),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1227,tmp_moved_constant_1227,tmp_moved_constant_1227,tmp_moved_constant_1227),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1228,tmp_moved_constant_1228,tmp_moved_constant_1228,tmp_moved_constant_1228),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1229,tmp_moved_constant_1229,tmp_moved_constant_1229,tmp_moved_constant_1229),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1042,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1230,tmp_moved_constant_1230,tmp_moved_constant_1230,tmp_moved_constant_1230),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1231,tmp_moved_constant_1231,tmp_moved_constant_1231,tmp_moved_constant_1231),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1232,tmp_moved_constant_1232,tmp_moved_constant_1232,tmp_moved_constant_1232),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1233,tmp_moved_constant_1233,tmp_moved_constant_1233,tmp_moved_constant_1233),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1052,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1234,tmp_moved_constant_1234,tmp_moved_constant_1234,tmp_moved_constant_1234),_mm256_set_pd(tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254,tmp_moved_constant_1254)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1235,tmp_moved_constant_1235,tmp_moved_constant_1235,tmp_moved_constant_1235),_mm256_set_pd(tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256,tmp_moved_constant_1256))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1236,tmp_moved_constant_1236,tmp_moved_constant_1236,tmp_moved_constant_1236),_mm256_set_pd(tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258,tmp_moved_constant_1258))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1237,tmp_moved_constant_1237,tmp_moved_constant_1237,tmp_moved_constant_1237),_mm256_set_pd(tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260,tmp_moved_constant_1260))))),_mm256_mul_pd(tmp_moved_constant_1033,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1255,tmp_moved_constant_1255,tmp_moved_constant_1255,tmp_moved_constant_1255)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1257,tmp_moved_constant_1257,tmp_moved_constant_1257,tmp_moved_constant_1257))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1259,tmp_moved_constant_1259,tmp_moved_constant_1259,tmp_moved_constant_1259))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1261,tmp_moved_constant_1261,tmp_moved_constant_1261,tmp_moved_constant_1261))))),_mm256_mul_pd(tmp_moved_constant_1043,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1255,tmp_moved_constant_1255,tmp_moved_constant_1255,tmp_moved_constant_1255)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1257,tmp_moved_constant_1257,tmp_moved_constant_1257,tmp_moved_constant_1257))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1259,tmp_moved_constant_1259,tmp_moved_constant_1259,tmp_moved_constant_1259))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1261,tmp_moved_constant_1261,tmp_moved_constant_1261,tmp_moved_constant_1261))))),_mm256_mul_pd(tmp_moved_constant_1053,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1255,tmp_moved_constant_1255,tmp_moved_constant_1255,tmp_moved_constant_1255)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1257,tmp_moved_constant_1257,tmp_moved_constant_1257,tmp_moved_constant_1257))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1259,tmp_moved_constant_1259,tmp_moved_constant_1259,tmp_moved_constant_1259))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1261,tmp_moved_constant_1261,tmp_moved_constant_1261,tmp_moved_constant_1261))))),_mm256_mul_pd(tmp_moved_constant_1034,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1262,tmp_moved_constant_1262,tmp_moved_constant_1262,tmp_moved_constant_1262)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1263,tmp_moved_constant_1263,tmp_moved_constant_1263,tmp_moved_constant_1263))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1264,tmp_moved_constant_1264,tmp_moved_constant_1264,tmp_moved_constant_1264))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1265,tmp_moved_constant_1265,tmp_moved_constant_1265,tmp_moved_constant_1265))))),_mm256_mul_pd(tmp_moved_constant_1044,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1262,tmp_moved_constant_1262,tmp_moved_constant_1262,tmp_moved_constant_1262)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1263,tmp_moved_constant_1263,tmp_moved_constant_1263,tmp_moved_constant_1263))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1264,tmp_moved_constant_1264,tmp_moved_constant_1264,tmp_moved_constant_1264))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1265,tmp_moved_constant_1265,tmp_moved_constant_1265,tmp_moved_constant_1265))))),_mm256_mul_pd(tmp_moved_constant_1054,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1262,tmp_moved_constant_1262,tmp_moved_constant_1262,tmp_moved_constant_1262)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1263,tmp_moved_constant_1263,tmp_moved_constant_1263,tmp_moved_constant_1263))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1264,tmp_moved_constant_1264,tmp_moved_constant_1264,tmp_moved_constant_1264))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1265,tmp_moved_constant_1265,tmp_moved_constant_1265,tmp_moved_constant_1265))))),_mm256_mul_pd(tmp_moved_constant_1035,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1266,tmp_moved_constant_1266,tmp_moved_constant_1266,tmp_moved_constant_1266)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1267,tmp_moved_constant_1267,tmp_moved_constant_1267,tmp_moved_constant_1267))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1268,tmp_moved_constant_1268,tmp_moved_constant_1268,tmp_moved_constant_1268))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1269,tmp_moved_constant_1269,tmp_moved_constant_1269,tmp_moved_constant_1269))))),_mm256_mul_pd(tmp_moved_constant_1045,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1266,tmp_moved_constant_1266,tmp_moved_constant_1266,tmp_moved_constant_1266)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1267,tmp_moved_constant_1267,tmp_moved_constant_1267,tmp_moved_constant_1267))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1268,tmp_moved_constant_1268,tmp_moved_constant_1268,tmp_moved_constant_1268))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1269,tmp_moved_constant_1269,tmp_moved_constant_1269,tmp_moved_constant_1269))))),_mm256_mul_pd(tmp_moved_constant_1055,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1266,tmp_moved_constant_1266,tmp_moved_constant_1266,tmp_moved_constant_1266)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1267,tmp_moved_constant_1267,tmp_moved_constant_1267,tmp_moved_constant_1267))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1268,tmp_moved_constant_1268,tmp_moved_constant_1268,tmp_moved_constant_1268))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1269,tmp_moved_constant_1269,tmp_moved_constant_1269,tmp_moved_constant_1269)))));
                const __m256d tmp_moved_constant_1289 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1046,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1084,tmp_moved_constant_1084,tmp_moved_constant_1084,tmp_moved_constant_1084),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1087,tmp_moved_constant_1087,tmp_moved_constant_1087,tmp_moved_constant_1087),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1090,tmp_moved_constant_1090,tmp_moved_constant_1090,tmp_moved_constant_1090),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1093,tmp_moved_constant_1093,tmp_moved_constant_1093,tmp_moved_constant_1093),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276)))),_mm256_mul_pd(tmp_moved_constant_1047,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1096,tmp_moved_constant_1096,tmp_moved_constant_1096,tmp_moved_constant_1096),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1099,tmp_moved_constant_1099,tmp_moved_constant_1099,tmp_moved_constant_1099),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1102,tmp_moved_constant_1102,tmp_moved_constant_1102,tmp_moved_constant_1102),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1105,tmp_moved_constant_1105,tmp_moved_constant_1105,tmp_moved_constant_1105),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1048,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1108,tmp_moved_constant_1108,tmp_moved_constant_1108,tmp_moved_constant_1108),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1111,tmp_moved_constant_1111,tmp_moved_constant_1111,tmp_moved_constant_1111),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1114,tmp_moved_constant_1114,tmp_moved_constant_1114,tmp_moved_constant_1114),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1117,tmp_moved_constant_1117,tmp_moved_constant_1117,tmp_moved_constant_1117),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1056,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1120,tmp_moved_constant_1120,tmp_moved_constant_1120,tmp_moved_constant_1120),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1123,tmp_moved_constant_1123,tmp_moved_constant_1123,tmp_moved_constant_1123),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1126,tmp_moved_constant_1126,tmp_moved_constant_1126,tmp_moved_constant_1126),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1129,tmp_moved_constant_1129,tmp_moved_constant_1129,tmp_moved_constant_1129),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1057,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1132,tmp_moved_constant_1132,tmp_moved_constant_1132,tmp_moved_constant_1132),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1135,tmp_moved_constant_1135,tmp_moved_constant_1135,tmp_moved_constant_1135),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1138,tmp_moved_constant_1138,tmp_moved_constant_1138,tmp_moved_constant_1138),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1141,tmp_moved_constant_1141,tmp_moved_constant_1141,tmp_moved_constant_1141),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1058,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1144,tmp_moved_constant_1144,tmp_moved_constant_1144,tmp_moved_constant_1144),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1147,tmp_moved_constant_1147,tmp_moved_constant_1147,tmp_moved_constant_1147),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1150,tmp_moved_constant_1150,tmp_moved_constant_1150,tmp_moved_constant_1150),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1153,tmp_moved_constant_1153,tmp_moved_constant_1153,tmp_moved_constant_1153),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1036,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1037,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1038,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1049,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1050,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1051,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1200,tmp_moved_constant_1200,tmp_moved_constant_1200,tmp_moved_constant_1200),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1201,tmp_moved_constant_1201,tmp_moved_constant_1201,tmp_moved_constant_1201),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1059,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1202,tmp_moved_constant_1202,tmp_moved_constant_1202,tmp_moved_constant_1202),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1203,tmp_moved_constant_1203,tmp_moved_constant_1203,tmp_moved_constant_1203),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1204,tmp_moved_constant_1204,tmp_moved_constant_1204,tmp_moved_constant_1204),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1205,tmp_moved_constant_1205,tmp_moved_constant_1205,tmp_moved_constant_1205),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1060,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1206,tmp_moved_constant_1206,tmp_moved_constant_1206,tmp_moved_constant_1206),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1207,tmp_moved_constant_1207,tmp_moved_constant_1207,tmp_moved_constant_1207),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1208,tmp_moved_constant_1208,tmp_moved_constant_1208,tmp_moved_constant_1208),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1209,tmp_moved_constant_1209,tmp_moved_constant_1209,tmp_moved_constant_1209),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1061,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1210,tmp_moved_constant_1210,tmp_moved_constant_1210,tmp_moved_constant_1210),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1211,tmp_moved_constant_1211,tmp_moved_constant_1211,tmp_moved_constant_1211),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1212,tmp_moved_constant_1212,tmp_moved_constant_1212,tmp_moved_constant_1212),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1213,tmp_moved_constant_1213,tmp_moved_constant_1213,tmp_moved_constant_1213),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1039,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1214,tmp_moved_constant_1214,tmp_moved_constant_1214,tmp_moved_constant_1214),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1215,tmp_moved_constant_1215,tmp_moved_constant_1215,tmp_moved_constant_1215),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1216,tmp_moved_constant_1216,tmp_moved_constant_1216,tmp_moved_constant_1216),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1217,tmp_moved_constant_1217,tmp_moved_constant_1217,tmp_moved_constant_1217),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1040,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1218,tmp_moved_constant_1218,tmp_moved_constant_1218,tmp_moved_constant_1218),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1219,tmp_moved_constant_1219,tmp_moved_constant_1219,tmp_moved_constant_1219),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1220,tmp_moved_constant_1220,tmp_moved_constant_1220,tmp_moved_constant_1220),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1221,tmp_moved_constant_1221,tmp_moved_constant_1221,tmp_moved_constant_1221),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1041,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1222,tmp_moved_constant_1222,tmp_moved_constant_1222,tmp_moved_constant_1222),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1223,tmp_moved_constant_1223,tmp_moved_constant_1223,tmp_moved_constant_1223),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1224,tmp_moved_constant_1224,tmp_moved_constant_1224,tmp_moved_constant_1224),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1225,tmp_moved_constant_1225,tmp_moved_constant_1225,tmp_moved_constant_1225),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1032,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1226,tmp_moved_constant_1226,tmp_moved_constant_1226,tmp_moved_constant_1226),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1227,tmp_moved_constant_1227,tmp_moved_constant_1227,tmp_moved_constant_1227),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1228,tmp_moved_constant_1228,tmp_moved_constant_1228,tmp_moved_constant_1228),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1229,tmp_moved_constant_1229,tmp_moved_constant_1229,tmp_moved_constant_1229),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1042,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1230,tmp_moved_constant_1230,tmp_moved_constant_1230,tmp_moved_constant_1230),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1231,tmp_moved_constant_1231,tmp_moved_constant_1231,tmp_moved_constant_1231),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1232,tmp_moved_constant_1232,tmp_moved_constant_1232,tmp_moved_constant_1232),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1233,tmp_moved_constant_1233,tmp_moved_constant_1233,tmp_moved_constant_1233),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1052,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1234,tmp_moved_constant_1234,tmp_moved_constant_1234,tmp_moved_constant_1234),_mm256_set_pd(tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270,tmp_moved_constant_1270)),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1235,tmp_moved_constant_1235,tmp_moved_constant_1235,tmp_moved_constant_1235),_mm256_set_pd(tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272,tmp_moved_constant_1272))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1236,tmp_moved_constant_1236,tmp_moved_constant_1236,tmp_moved_constant_1236),_mm256_set_pd(tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274,tmp_moved_constant_1274))),_mm256_mul_pd(_mm256_set_pd(tmp_moved_constant_1237,tmp_moved_constant_1237,tmp_moved_constant_1237,tmp_moved_constant_1237),_mm256_set_pd(tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276,tmp_moved_constant_1276))))),_mm256_mul_pd(tmp_moved_constant_1033,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1271,tmp_moved_constant_1271,tmp_moved_constant_1271,tmp_moved_constant_1271)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1273,tmp_moved_constant_1273,tmp_moved_constant_1273,tmp_moved_constant_1273))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1275,tmp_moved_constant_1275,tmp_moved_constant_1275,tmp_moved_constant_1275))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1277,tmp_moved_constant_1277,tmp_moved_constant_1277,tmp_moved_constant_1277))))),_mm256_mul_pd(tmp_moved_constant_1043,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1271,tmp_moved_constant_1271,tmp_moved_constant_1271,tmp_moved_constant_1271)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1273,tmp_moved_constant_1273,tmp_moved_constant_1273,tmp_moved_constant_1273))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1275,tmp_moved_constant_1275,tmp_moved_constant_1275,tmp_moved_constant_1275))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1277,tmp_moved_constant_1277,tmp_moved_constant_1277,tmp_moved_constant_1277))))),_mm256_mul_pd(tmp_moved_constant_1053,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1271,tmp_moved_constant_1271,tmp_moved_constant_1271,tmp_moved_constant_1271)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1273,tmp_moved_constant_1273,tmp_moved_constant_1273,tmp_moved_constant_1273))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1275,tmp_moved_constant_1275,tmp_moved_constant_1275,tmp_moved_constant_1275))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1277,tmp_moved_constant_1277,tmp_moved_constant_1277,tmp_moved_constant_1277))))),_mm256_mul_pd(tmp_moved_constant_1034,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1278,tmp_moved_constant_1278,tmp_moved_constant_1278,tmp_moved_constant_1278)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1279,tmp_moved_constant_1279,tmp_moved_constant_1279,tmp_moved_constant_1279))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1280,tmp_moved_constant_1280,tmp_moved_constant_1280,tmp_moved_constant_1280))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1281,tmp_moved_constant_1281,tmp_moved_constant_1281,tmp_moved_constant_1281))))),_mm256_mul_pd(tmp_moved_constant_1044,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1278,tmp_moved_constant_1278,tmp_moved_constant_1278,tmp_moved_constant_1278)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1279,tmp_moved_constant_1279,tmp_moved_constant_1279,tmp_moved_constant_1279))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1280,tmp_moved_constant_1280,tmp_moved_constant_1280,tmp_moved_constant_1280))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1281,tmp_moved_constant_1281,tmp_moved_constant_1281,tmp_moved_constant_1281))))),_mm256_mul_pd(tmp_moved_constant_1054,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1278,tmp_moved_constant_1278,tmp_moved_constant_1278,tmp_moved_constant_1278)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1279,tmp_moved_constant_1279,tmp_moved_constant_1279,tmp_moved_constant_1279))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1280,tmp_moved_constant_1280,tmp_moved_constant_1280,tmp_moved_constant_1280))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1281,tmp_moved_constant_1281,tmp_moved_constant_1281,tmp_moved_constant_1281))))),_mm256_mul_pd(tmp_moved_constant_1035,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1282,tmp_moved_constant_1282,tmp_moved_constant_1282,tmp_moved_constant_1282)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1283,tmp_moved_constant_1283,tmp_moved_constant_1283,tmp_moved_constant_1283))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1284,tmp_moved_constant_1284,tmp_moved_constant_1284,tmp_moved_constant_1284))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1285,tmp_moved_constant_1285,tmp_moved_constant_1285,tmp_moved_constant_1285))))),_mm256_mul_pd(tmp_moved_constant_1045,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1282,tmp_moved_constant_1282,tmp_moved_constant_1282,tmp_moved_constant_1282)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1283,tmp_moved_constant_1283,tmp_moved_constant_1283,tmp_moved_constant_1283))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1284,tmp_moved_constant_1284,tmp_moved_constant_1284,tmp_moved_constant_1284))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1285,tmp_moved_constant_1285,tmp_moved_constant_1285,tmp_moved_constant_1285))))),_mm256_mul_pd(tmp_moved_constant_1055,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1282,tmp_moved_constant_1282,tmp_moved_constant_1282,tmp_moved_constant_1282)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1283,tmp_moved_constant_1283,tmp_moved_constant_1283,tmp_moved_constant_1283))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1284,tmp_moved_constant_1284,tmp_moved_constant_1284,tmp_moved_constant_1284))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_set_pd(tmp_moved_constant_1285,tmp_moved_constant_1285,tmp_moved_constant_1285,tmp_moved_constant_1285)))));
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                      const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                      const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_1286,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_1287,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_1288,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_1289,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                   }
                }
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_13*tmp_kernel_op_213 + tmp_kernel_op_18*tmp_kernel_op_215 + tmp_kernel_op_209*tmp_kernel_op_3 + tmp_kernel_op_211*tmp_kernel_op_8) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_9) + src_dof_10*(tmp_kernel_op_13*tmp_kernel_op_218 + tmp_kernel_op_18*tmp_kernel_op_219 + tmp_kernel_op_216*tmp_kernel_op_3 + tmp_kernel_op_217*tmp_kernel_op_8) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_9) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_31) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_43) + src_dof_14*(tmp_kernel_op_13*tmp_kernel_op_52 + tmp_kernel_op_18*tmp_kernel_op_55 + tmp_kernel_op_3*tmp_kernel_op_46 + tmp_kernel_op_49*tmp_kernel_op_8) + src_dof_15*(tmp_kernel_op_13*tmp_kernel_op_64 + tmp_kernel_op_18*tmp_kernel_op_67 + tmp_kernel_op_3*tmp_kernel_op_58 + tmp_kernel_op_61*tmp_kernel_op_8) + src_dof_16*(tmp_kernel_op_13*tmp_kernel_op_76 + tmp_kernel_op_18*tmp_kernel_op_79 + tmp_kernel_op_3*tmp_kernel_op_70 + tmp_kernel_op_73*tmp_kernel_op_8) + src_dof_17*(tmp_kernel_op_13*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_3 + tmp_kernel_op_157*tmp_kernel_op_8 + tmp_kernel_op_163*tmp_kernel_op_18) + src_dof_18*(tmp_kernel_op_13*tmp_kernel_op_172 + tmp_kernel_op_166*tmp_kernel_op_3 + tmp_kernel_op_169*tmp_kernel_op_8 + tmp_kernel_op_175*tmp_kernel_op_18) + src_dof_19*(tmp_kernel_op_13*tmp_kernel_op_181 + tmp_kernel_op_177*tmp_kernel_op_3 + tmp_kernel_op_179*tmp_kernel_op_8 + tmp_kernel_op_18*tmp_kernel_op_183) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_31) + src_dof_20*(tmp_kernel_op_13*tmp_kernel_op_222 + tmp_kernel_op_18*tmp_kernel_op_223 + tmp_kernel_op_220*tmp_kernel_op_3 + tmp_kernel_op_221*tmp_kernel_op_8) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_9) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_31) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_43) + src_dof_24*(tmp_kernel_op_13*tmp_kernel_op_88 + tmp_kernel_op_18*tmp_kernel_op_91 + tmp_kernel_op_3*tmp_kernel_op_82 + tmp_kernel_op_8*tmp_kernel_op_85) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_13 + tmp_kernel_op_103*tmp_kernel_op_18 + tmp_kernel_op_3*tmp_kernel_op_94 + tmp_kernel_op_8*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_3 + tmp_kernel_op_109*tmp_kernel_op_8 + tmp_kernel_op_112*tmp_kernel_op_13 + tmp_kernel_op_115*tmp_kernel_op_18) + src_dof_27*(tmp_kernel_op_13*tmp_kernel_op_186 + tmp_kernel_op_18*tmp_kernel_op_187 + tmp_kernel_op_184*tmp_kernel_op_3 + tmp_kernel_op_185*tmp_kernel_op_8) + src_dof_28*(tmp_kernel_op_13*tmp_kernel_op_190 + tmp_kernel_op_18*tmp_kernel_op_191 + tmp_kernel_op_188*tmp_kernel_op_3 + tmp_kernel_op_189*tmp_kernel_op_8) + src_dof_29*(tmp_kernel_op_13*tmp_kernel_op_194 + tmp_kernel_op_18*tmp_kernel_op_195 + tmp_kernel_op_192*tmp_kernel_op_3 + tmp_kernel_op_193*tmp_kernel_op_8) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_3 + tmp_kernel_op_121*tmp_kernel_op_8 + tmp_kernel_op_124*tmp_kernel_op_13 + tmp_kernel_op_127*tmp_kernel_op_18) + src_dof_5*(tmp_kernel_op_13*tmp_kernel_op_136 + tmp_kernel_op_130*tmp_kernel_op_3 + tmp_kernel_op_133*tmp_kernel_op_8 + tmp_kernel_op_139*tmp_kernel_op_18) + src_dof_6*(tmp_kernel_op_13*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_3 + tmp_kernel_op_145*tmp_kernel_op_8 + tmp_kernel_op_151*tmp_kernel_op_18) + src_dof_7*(tmp_kernel_op_13*tmp_kernel_op_198 + tmp_kernel_op_18*tmp_kernel_op_199 + tmp_kernel_op_196*tmp_kernel_op_3 + tmp_kernel_op_197*tmp_kernel_op_8) + src_dof_8*(tmp_kernel_op_13*tmp_kernel_op_202 + tmp_kernel_op_18*tmp_kernel_op_203 + tmp_kernel_op_200*tmp_kernel_op_3 + tmp_kernel_op_201*tmp_kernel_op_8) + src_dof_9*(tmp_kernel_op_13*tmp_kernel_op_206 + tmp_kernel_op_18*tmp_kernel_op_207 + tmp_kernel_op_204*tmp_kernel_op_3 + tmp_kernel_op_205*tmp_kernel_op_8);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_224 + tmp_kernel_op_211*tmp_kernel_op_226 + tmp_kernel_op_213*tmp_kernel_op_228 + tmp_kernel_op_215*tmp_kernel_op_230) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_231) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_224 + tmp_kernel_op_217*tmp_kernel_op_226 + tmp_kernel_op_218*tmp_kernel_op_228 + tmp_kernel_op_219*tmp_kernel_op_230) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_231) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_235) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_239) + src_dof_14*(tmp_kernel_op_224*tmp_kernel_op_46 + tmp_kernel_op_226*tmp_kernel_op_49 + tmp_kernel_op_228*tmp_kernel_op_52 + tmp_kernel_op_230*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_224*tmp_kernel_op_58 + tmp_kernel_op_226*tmp_kernel_op_61 + tmp_kernel_op_228*tmp_kernel_op_64 + tmp_kernel_op_230*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_224*tmp_kernel_op_70 + tmp_kernel_op_226*tmp_kernel_op_73 + tmp_kernel_op_228*tmp_kernel_op_76 + tmp_kernel_op_230*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_224 + tmp_kernel_op_157*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_228 + tmp_kernel_op_163*tmp_kernel_op_230) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_224 + tmp_kernel_op_169*tmp_kernel_op_226 + tmp_kernel_op_172*tmp_kernel_op_228 + tmp_kernel_op_175*tmp_kernel_op_230) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_224 + tmp_kernel_op_179*tmp_kernel_op_226 + tmp_kernel_op_181*tmp_kernel_op_228 + tmp_kernel_op_183*tmp_kernel_op_230) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_235) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_224 + tmp_kernel_op_221*tmp_kernel_op_226 + tmp_kernel_op_222*tmp_kernel_op_228 + tmp_kernel_op_223*tmp_kernel_op_230) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_231) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_235) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_239) + src_dof_24*(tmp_kernel_op_224*tmp_kernel_op_82 + tmp_kernel_op_226*tmp_kernel_op_85 + tmp_kernel_op_228*tmp_kernel_op_88 + tmp_kernel_op_230*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_228 + tmp_kernel_op_103*tmp_kernel_op_230 + tmp_kernel_op_224*tmp_kernel_op_94 + tmp_kernel_op_226*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_224 + tmp_kernel_op_109*tmp_kernel_op_226 + tmp_kernel_op_112*tmp_kernel_op_228 + tmp_kernel_op_115*tmp_kernel_op_230) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_224 + tmp_kernel_op_185*tmp_kernel_op_226 + tmp_kernel_op_186*tmp_kernel_op_228 + tmp_kernel_op_187*tmp_kernel_op_230) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_224 + tmp_kernel_op_189*tmp_kernel_op_226 + tmp_kernel_op_190*tmp_kernel_op_228 + tmp_kernel_op_191*tmp_kernel_op_230) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_224 + tmp_kernel_op_193*tmp_kernel_op_226 + tmp_kernel_op_194*tmp_kernel_op_228 + tmp_kernel_op_195*tmp_kernel_op_230) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_239) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_224 + tmp_kernel_op_121*tmp_kernel_op_226 + tmp_kernel_op_124*tmp_kernel_op_228 + tmp_kernel_op_127*tmp_kernel_op_230) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_224 + tmp_kernel_op_133*tmp_kernel_op_226 + tmp_kernel_op_136*tmp_kernel_op_228 + tmp_kernel_op_139*tmp_kernel_op_230) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_224 + tmp_kernel_op_145*tmp_kernel_op_226 + tmp_kernel_op_148*tmp_kernel_op_228 + tmp_kernel_op_151*tmp_kernel_op_230) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_224 + tmp_kernel_op_197*tmp_kernel_op_226 + tmp_kernel_op_198*tmp_kernel_op_228 + tmp_kernel_op_199*tmp_kernel_op_230) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_224 + tmp_kernel_op_201*tmp_kernel_op_226 + tmp_kernel_op_202*tmp_kernel_op_228 + tmp_kernel_op_203*tmp_kernel_op_230) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_224 + tmp_kernel_op_205*tmp_kernel_op_226 + tmp_kernel_op_206*tmp_kernel_op_228 + tmp_kernel_op_207*tmp_kernel_op_230);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_240 + tmp_kernel_op_211*tmp_kernel_op_242 + tmp_kernel_op_213*tmp_kernel_op_244 + tmp_kernel_op_215*tmp_kernel_op_246) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_247) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_240 + tmp_kernel_op_217*tmp_kernel_op_242 + tmp_kernel_op_218*tmp_kernel_op_244 + tmp_kernel_op_219*tmp_kernel_op_246) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_247) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_251) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_255) + src_dof_14*(tmp_kernel_op_240*tmp_kernel_op_46 + tmp_kernel_op_242*tmp_kernel_op_49 + tmp_kernel_op_244*tmp_kernel_op_52 + tmp_kernel_op_246*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_240*tmp_kernel_op_58 + tmp_kernel_op_242*tmp_kernel_op_61 + tmp_kernel_op_244*tmp_kernel_op_64 + tmp_kernel_op_246*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_240*tmp_kernel_op_70 + tmp_kernel_op_242*tmp_kernel_op_73 + tmp_kernel_op_244*tmp_kernel_op_76 + tmp_kernel_op_246*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_240 + tmp_kernel_op_157*tmp_kernel_op_242 + tmp_kernel_op_160*tmp_kernel_op_244 + tmp_kernel_op_163*tmp_kernel_op_246) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_240 + tmp_kernel_op_169*tmp_kernel_op_242 + tmp_kernel_op_172*tmp_kernel_op_244 + tmp_kernel_op_175*tmp_kernel_op_246) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_240 + tmp_kernel_op_179*tmp_kernel_op_242 + tmp_kernel_op_181*tmp_kernel_op_244 + tmp_kernel_op_183*tmp_kernel_op_246) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_251) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_240 + tmp_kernel_op_221*tmp_kernel_op_242 + tmp_kernel_op_222*tmp_kernel_op_244 + tmp_kernel_op_223*tmp_kernel_op_246) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_247) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_251) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_255) + src_dof_24*(tmp_kernel_op_240*tmp_kernel_op_82 + tmp_kernel_op_242*tmp_kernel_op_85 + tmp_kernel_op_244*tmp_kernel_op_88 + tmp_kernel_op_246*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_244 + tmp_kernel_op_103*tmp_kernel_op_246 + tmp_kernel_op_240*tmp_kernel_op_94 + tmp_kernel_op_242*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_109*tmp_kernel_op_242 + tmp_kernel_op_112*tmp_kernel_op_244 + tmp_kernel_op_115*tmp_kernel_op_246) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_240 + tmp_kernel_op_185*tmp_kernel_op_242 + tmp_kernel_op_186*tmp_kernel_op_244 + tmp_kernel_op_187*tmp_kernel_op_246) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_240 + tmp_kernel_op_189*tmp_kernel_op_242 + tmp_kernel_op_190*tmp_kernel_op_244 + tmp_kernel_op_191*tmp_kernel_op_246) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_240 + tmp_kernel_op_193*tmp_kernel_op_242 + tmp_kernel_op_194*tmp_kernel_op_244 + tmp_kernel_op_195*tmp_kernel_op_246) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_255) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_240 + tmp_kernel_op_121*tmp_kernel_op_242 + tmp_kernel_op_124*tmp_kernel_op_244 + tmp_kernel_op_127*tmp_kernel_op_246) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_240 + tmp_kernel_op_133*tmp_kernel_op_242 + tmp_kernel_op_136*tmp_kernel_op_244 + tmp_kernel_op_139*tmp_kernel_op_246) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_240 + tmp_kernel_op_145*tmp_kernel_op_242 + tmp_kernel_op_148*tmp_kernel_op_244 + tmp_kernel_op_151*tmp_kernel_op_246) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_240 + tmp_kernel_op_197*tmp_kernel_op_242 + tmp_kernel_op_198*tmp_kernel_op_244 + tmp_kernel_op_199*tmp_kernel_op_246) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_240 + tmp_kernel_op_201*tmp_kernel_op_242 + tmp_kernel_op_202*tmp_kernel_op_244 + tmp_kernel_op_203*tmp_kernel_op_246) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_240 + tmp_kernel_op_205*tmp_kernel_op_242 + tmp_kernel_op_206*tmp_kernel_op_244 + tmp_kernel_op_207*tmp_kernel_op_246);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_256 + tmp_kernel_op_211*tmp_kernel_op_258 + tmp_kernel_op_213*tmp_kernel_op_260 + tmp_kernel_op_215*tmp_kernel_op_262) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_263) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_256 + tmp_kernel_op_217*tmp_kernel_op_258 + tmp_kernel_op_218*tmp_kernel_op_260 + tmp_kernel_op_219*tmp_kernel_op_262) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_263) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_267) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_271) + src_dof_14*(tmp_kernel_op_256*tmp_kernel_op_46 + tmp_kernel_op_258*tmp_kernel_op_49 + tmp_kernel_op_260*tmp_kernel_op_52 + tmp_kernel_op_262*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_256*tmp_kernel_op_58 + tmp_kernel_op_258*tmp_kernel_op_61 + tmp_kernel_op_260*tmp_kernel_op_64 + tmp_kernel_op_262*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_256*tmp_kernel_op_70 + tmp_kernel_op_258*tmp_kernel_op_73 + tmp_kernel_op_260*tmp_kernel_op_76 + tmp_kernel_op_262*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_256 + tmp_kernel_op_157*tmp_kernel_op_258 + tmp_kernel_op_160*tmp_kernel_op_260 + tmp_kernel_op_163*tmp_kernel_op_262) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_256 + tmp_kernel_op_169*tmp_kernel_op_258 + tmp_kernel_op_172*tmp_kernel_op_260 + tmp_kernel_op_175*tmp_kernel_op_262) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_256 + tmp_kernel_op_179*tmp_kernel_op_258 + tmp_kernel_op_181*tmp_kernel_op_260 + tmp_kernel_op_183*tmp_kernel_op_262) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_267) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_256 + tmp_kernel_op_221*tmp_kernel_op_258 + tmp_kernel_op_222*tmp_kernel_op_260 + tmp_kernel_op_223*tmp_kernel_op_262) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_263) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_267) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_271) + src_dof_24*(tmp_kernel_op_256*tmp_kernel_op_82 + tmp_kernel_op_258*tmp_kernel_op_85 + tmp_kernel_op_260*tmp_kernel_op_88 + tmp_kernel_op_262*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_260 + tmp_kernel_op_103*tmp_kernel_op_262 + tmp_kernel_op_256*tmp_kernel_op_94 + tmp_kernel_op_258*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_256 + tmp_kernel_op_109*tmp_kernel_op_258 + tmp_kernel_op_112*tmp_kernel_op_260 + tmp_kernel_op_115*tmp_kernel_op_262) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_256 + tmp_kernel_op_185*tmp_kernel_op_258 + tmp_kernel_op_186*tmp_kernel_op_260 + tmp_kernel_op_187*tmp_kernel_op_262) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_256 + tmp_kernel_op_189*tmp_kernel_op_258 + tmp_kernel_op_190*tmp_kernel_op_260 + tmp_kernel_op_191*tmp_kernel_op_262) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_256 + tmp_kernel_op_193*tmp_kernel_op_258 + tmp_kernel_op_194*tmp_kernel_op_260 + tmp_kernel_op_195*tmp_kernel_op_262) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_271) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_256 + tmp_kernel_op_121*tmp_kernel_op_258 + tmp_kernel_op_124*tmp_kernel_op_260 + tmp_kernel_op_127*tmp_kernel_op_262) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_256 + tmp_kernel_op_133*tmp_kernel_op_258 + tmp_kernel_op_136*tmp_kernel_op_260 + tmp_kernel_op_139*tmp_kernel_op_262) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_256 + tmp_kernel_op_145*tmp_kernel_op_258 + tmp_kernel_op_148*tmp_kernel_op_260 + tmp_kernel_op_151*tmp_kernel_op_262) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_256 + tmp_kernel_op_197*tmp_kernel_op_258 + tmp_kernel_op_198*tmp_kernel_op_260 + tmp_kernel_op_199*tmp_kernel_op_262) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_256 + tmp_kernel_op_201*tmp_kernel_op_258 + tmp_kernel_op_202*tmp_kernel_op_260 + tmp_kernel_op_203*tmp_kernel_op_262) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_256 + tmp_kernel_op_205*tmp_kernel_op_258 + tmp_kernel_op_206*tmp_kernel_op_260 + tmp_kernel_op_207*tmp_kernel_op_262);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   }
                }
                const real_t tmp_moved_constant_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_4 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t tmp_moved_constant_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_8 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_14 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t tmp_moved_constant_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_18 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_24 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t tmp_moved_constant_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_28 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_254 = tmp_moved_constant_0*(tmp_moved_constant_194*tmp_moved_constant_31 + tmp_moved_constant_195*tmp_moved_constant_34 + tmp_moved_constant_196*tmp_moved_constant_37 + tmp_moved_constant_197*tmp_moved_constant_40) + tmp_moved_constant_1*(-jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_32 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_35 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_38 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_41) + tmp_moved_constant_10*(tmp_moved_constant_198*tmp_moved_constant_31 + tmp_moved_constant_199*tmp_moved_constant_34 + tmp_moved_constant_200*tmp_moved_constant_37 + tmp_moved_constant_201*tmp_moved_constant_40) + tmp_moved_constant_11*(-jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_32 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_35 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_38 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_41) + tmp_moved_constant_12*(-jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_42 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_43 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_44 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_45) + tmp_moved_constant_13*(-jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_46 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_47 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_48 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_49) + tmp_moved_constant_14*(tmp_moved_constant_31*tmp_moved_constant_52 + tmp_moved_constant_34*tmp_moved_constant_55 + tmp_moved_constant_37*tmp_moved_constant_58 + tmp_moved_constant_40*tmp_moved_constant_61) + tmp_moved_constant_15*(tmp_moved_constant_31*tmp_moved_constant_64 + tmp_moved_constant_34*tmp_moved_constant_67 + tmp_moved_constant_37*tmp_moved_constant_70 + tmp_moved_constant_40*tmp_moved_constant_73) + tmp_moved_constant_16*(tmp_moved_constant_31*tmp_moved_constant_76 + tmp_moved_constant_34*tmp_moved_constant_79 + tmp_moved_constant_37*tmp_moved_constant_82 + tmp_moved_constant_40*tmp_moved_constant_85) + tmp_moved_constant_17*(tmp_moved_constant_158*tmp_moved_constant_31 + tmp_moved_constant_159*tmp_moved_constant_34 + tmp_moved_constant_160*tmp_moved_constant_37 + tmp_moved_constant_161*tmp_moved_constant_40) + tmp_moved_constant_18*(tmp_moved_constant_162*tmp_moved_constant_31 + tmp_moved_constant_163*tmp_moved_constant_34 + tmp_moved_constant_164*tmp_moved_constant_37 + tmp_moved_constant_165*tmp_moved_constant_40) + tmp_moved_constant_19*(tmp_moved_constant_166*tmp_moved_constant_31 + tmp_moved_constant_167*tmp_moved_constant_34 + tmp_moved_constant_168*tmp_moved_constant_37 + tmp_moved_constant_169*tmp_moved_constant_40) + tmp_moved_constant_2*(-jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_42 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_43 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_44 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_45) + tmp_moved_constant_20*(tmp_moved_constant_202*tmp_moved_constant_31 + tmp_moved_constant_203*tmp_moved_constant_34 + tmp_moved_constant_204*tmp_moved_constant_37 + tmp_moved_constant_205*tmp_moved_constant_40) + tmp_moved_constant_21*(-jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_32 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_35 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_38 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_41) + tmp_moved_constant_22*(-jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_42 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_43 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_44 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_45) + tmp_moved_constant_23*(-jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_46 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_47 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_48 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_49) + tmp_moved_constant_24*(tmp_moved_constant_31*tmp_moved_constant_88 + tmp_moved_constant_34*tmp_moved_constant_91 + tmp_moved_constant_37*tmp_moved_constant_94 + tmp_moved_constant_40*tmp_moved_constant_97) + tmp_moved_constant_25*(tmp_moved_constant_100*tmp_moved_constant_31 + tmp_moved_constant_103*tmp_moved_constant_34 + tmp_moved_constant_106*tmp_moved_constant_37 + tmp_moved_constant_109*tmp_moved_constant_40) + tmp_moved_constant_26*(tmp_moved_constant_112*tmp_moved_constant_31 + tmp_moved_constant_115*tmp_moved_constant_34 + tmp_moved_constant_118*tmp_moved_constant_37 + tmp_moved_constant_121*tmp_moved_constant_40) + tmp_moved_constant_27*(tmp_moved_constant_170*tmp_moved_constant_31 + tmp_moved_constant_171*tmp_moved_constant_34 + tmp_moved_constant_172*tmp_moved_constant_37 + tmp_moved_constant_173*tmp_moved_constant_40) + tmp_moved_constant_28*(tmp_moved_constant_174*tmp_moved_constant_31 + tmp_moved_constant_175*tmp_moved_constant_34 + tmp_moved_constant_176*tmp_moved_constant_37 + tmp_moved_constant_177*tmp_moved_constant_40) + tmp_moved_constant_29*(tmp_moved_constant_178*tmp_moved_constant_31 + tmp_moved_constant_179*tmp_moved_constant_34 + tmp_moved_constant_180*tmp_moved_constant_37 + tmp_moved_constant_181*tmp_moved_constant_40) + tmp_moved_constant_3*(-jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_46 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_47 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_48 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_49) + tmp_moved_constant_4*(tmp_moved_constant_124*tmp_moved_constant_31 + tmp_moved_constant_127*tmp_moved_constant_34 + tmp_moved_constant_130*tmp_moved_constant_37 + tmp_moved_constant_133*tmp_moved_constant_40) + tmp_moved_constant_5*(tmp_moved_constant_136*tmp_moved_constant_31 + tmp_moved_constant_139*tmp_moved_constant_34 + tmp_moved_constant_142*tmp_moved_constant_37 + tmp_moved_constant_145*tmp_moved_constant_40) + tmp_moved_constant_6*(tmp_moved_constant_148*tmp_moved_constant_31 + tmp_moved_constant_151*tmp_moved_constant_34 + tmp_moved_constant_154*tmp_moved_constant_37 + tmp_moved_constant_157*tmp_moved_constant_40) + tmp_moved_constant_7*(tmp_moved_constant_182*tmp_moved_constant_31 + tmp_moved_constant_183*tmp_moved_constant_34 + tmp_moved_constant_184*tmp_moved_constant_37 + tmp_moved_constant_185*tmp_moved_constant_40) + tmp_moved_constant_8*(tmp_moved_constant_186*tmp_moved_constant_31 + tmp_moved_constant_187*tmp_moved_constant_34 + tmp_moved_constant_188*tmp_moved_constant_37 + tmp_moved_constant_189*tmp_moved_constant_40) + tmp_moved_constant_9*(tmp_moved_constant_190*tmp_moved_constant_31 + tmp_moved_constant_191*tmp_moved_constant_34 + tmp_moved_constant_192*tmp_moved_constant_37 + tmp_moved_constant_193*tmp_moved_constant_40);
                const real_t tmp_moved_constant_255 = tmp_moved_constant_0*(tmp_moved_constant_194*tmp_moved_constant_206 + tmp_moved_constant_195*tmp_moved_constant_208 + tmp_moved_constant_196*tmp_moved_constant_210 + tmp_moved_constant_197*tmp_moved_constant_212) + tmp_moved_constant_1*(-jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_207 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_209 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_211 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_213) + tmp_moved_constant_10*(tmp_moved_constant_198*tmp_moved_constant_206 + tmp_moved_constant_199*tmp_moved_constant_208 + tmp_moved_constant_200*tmp_moved_constant_210 + tmp_moved_constant_201*tmp_moved_constant_212) + tmp_moved_constant_11*(-jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_207 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_209 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_211 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_213) + tmp_moved_constant_12*(-jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_214 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_215 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_216 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_217) + tmp_moved_constant_13*(-jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_218 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_219 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_220 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_221) + tmp_moved_constant_14*(tmp_moved_constant_206*tmp_moved_constant_52 + tmp_moved_constant_208*tmp_moved_constant_55 + tmp_moved_constant_210*tmp_moved_constant_58 + tmp_moved_constant_212*tmp_moved_constant_61) + tmp_moved_constant_15*(tmp_moved_constant_206*tmp_moved_constant_64 + tmp_moved_constant_208*tmp_moved_constant_67 + tmp_moved_constant_210*tmp_moved_constant_70 + tmp_moved_constant_212*tmp_moved_constant_73) + tmp_moved_constant_16*(tmp_moved_constant_206*tmp_moved_constant_76 + tmp_moved_constant_208*tmp_moved_constant_79 + tmp_moved_constant_210*tmp_moved_constant_82 + tmp_moved_constant_212*tmp_moved_constant_85) + tmp_moved_constant_17*(tmp_moved_constant_158*tmp_moved_constant_206 + tmp_moved_constant_159*tmp_moved_constant_208 + tmp_moved_constant_160*tmp_moved_constant_210 + tmp_moved_constant_161*tmp_moved_constant_212) + tmp_moved_constant_18*(tmp_moved_constant_162*tmp_moved_constant_206 + tmp_moved_constant_163*tmp_moved_constant_208 + tmp_moved_constant_164*tmp_moved_constant_210 + tmp_moved_constant_165*tmp_moved_constant_212) + tmp_moved_constant_19*(tmp_moved_constant_166*tmp_moved_constant_206 + tmp_moved_constant_167*tmp_moved_constant_208 + tmp_moved_constant_168*tmp_moved_constant_210 + tmp_moved_constant_169*tmp_moved_constant_212) + tmp_moved_constant_2*(-jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_214 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_215 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_216 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_217) + tmp_moved_constant_20*(tmp_moved_constant_202*tmp_moved_constant_206 + tmp_moved_constant_203*tmp_moved_constant_208 + tmp_moved_constant_204*tmp_moved_constant_210 + tmp_moved_constant_205*tmp_moved_constant_212) + tmp_moved_constant_21*(-jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_207 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_209 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_211 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_213) + tmp_moved_constant_22*(-jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_214 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_215 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_216 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_217) + tmp_moved_constant_23*(-jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_218 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_219 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_220 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_221) + tmp_moved_constant_24*(tmp_moved_constant_206*tmp_moved_constant_88 + tmp_moved_constant_208*tmp_moved_constant_91 + tmp_moved_constant_210*tmp_moved_constant_94 + tmp_moved_constant_212*tmp_moved_constant_97) + tmp_moved_constant_25*(tmp_moved_constant_100*tmp_moved_constant_206 + tmp_moved_constant_103*tmp_moved_constant_208 + tmp_moved_constant_106*tmp_moved_constant_210 + tmp_moved_constant_109*tmp_moved_constant_212) + tmp_moved_constant_26*(tmp_moved_constant_112*tmp_moved_constant_206 + tmp_moved_constant_115*tmp_moved_constant_208 + tmp_moved_constant_118*tmp_moved_constant_210 + tmp_moved_constant_121*tmp_moved_constant_212) + tmp_moved_constant_27*(tmp_moved_constant_170*tmp_moved_constant_206 + tmp_moved_constant_171*tmp_moved_constant_208 + tmp_moved_constant_172*tmp_moved_constant_210 + tmp_moved_constant_173*tmp_moved_constant_212) + tmp_moved_constant_28*(tmp_moved_constant_174*tmp_moved_constant_206 + tmp_moved_constant_175*tmp_moved_constant_208 + tmp_moved_constant_176*tmp_moved_constant_210 + tmp_moved_constant_177*tmp_moved_constant_212) + tmp_moved_constant_29*(tmp_moved_constant_178*tmp_moved_constant_206 + tmp_moved_constant_179*tmp_moved_constant_208 + tmp_moved_constant_180*tmp_moved_constant_210 + tmp_moved_constant_181*tmp_moved_constant_212) + tmp_moved_constant_3*(-jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_218 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_219 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_220 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_221) + tmp_moved_constant_4*(tmp_moved_constant_124*tmp_moved_constant_206 + tmp_moved_constant_127*tmp_moved_constant_208 + tmp_moved_constant_130*tmp_moved_constant_210 + tmp_moved_constant_133*tmp_moved_constant_212) + tmp_moved_constant_5*(tmp_moved_constant_136*tmp_moved_constant_206 + tmp_moved_constant_139*tmp_moved_constant_208 + tmp_moved_constant_142*tmp_moved_constant_210 + tmp_moved_constant_145*tmp_moved_constant_212) + tmp_moved_constant_6*(tmp_moved_constant_148*tmp_moved_constant_206 + tmp_moved_constant_151*tmp_moved_constant_208 + tmp_moved_constant_154*tmp_moved_constant_210 + tmp_moved_constant_157*tmp_moved_constant_212) + tmp_moved_constant_7*(tmp_moved_constant_182*tmp_moved_constant_206 + tmp_moved_constant_183*tmp_moved_constant_208 + tmp_moved_constant_184*tmp_moved_constant_210 + tmp_moved_constant_185*tmp_moved_constant_212) + tmp_moved_constant_8*(tmp_moved_constant_186*tmp_moved_constant_206 + tmp_moved_constant_187*tmp_moved_constant_208 + tmp_moved_constant_188*tmp_moved_constant_210 + tmp_moved_constant_189*tmp_moved_constant_212) + tmp_moved_constant_9*(tmp_moved_constant_190*tmp_moved_constant_206 + tmp_moved_constant_191*tmp_moved_constant_208 + tmp_moved_constant_192*tmp_moved_constant_210 + tmp_moved_constant_193*tmp_moved_constant_212);
                const real_t tmp_moved_constant_256 = tmp_moved_constant_0*(tmp_moved_constant_194*tmp_moved_constant_222 + tmp_moved_constant_195*tmp_moved_constant_224 + tmp_moved_constant_196*tmp_moved_constant_226 + tmp_moved_constant_197*tmp_moved_constant_228) + tmp_moved_constant_1*(-jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_223 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_225 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_227 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_229) + tmp_moved_constant_10*(tmp_moved_constant_198*tmp_moved_constant_222 + tmp_moved_constant_199*tmp_moved_constant_224 + tmp_moved_constant_200*tmp_moved_constant_226 + tmp_moved_constant_201*tmp_moved_constant_228) + tmp_moved_constant_11*(-jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_223 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_225 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_227 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_229) + tmp_moved_constant_12*(-jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_230 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_231 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_232 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_233) + tmp_moved_constant_13*(-jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_234 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_235 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_236 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_237) + tmp_moved_constant_14*(tmp_moved_constant_222*tmp_moved_constant_52 + tmp_moved_constant_224*tmp_moved_constant_55 + tmp_moved_constant_226*tmp_moved_constant_58 + tmp_moved_constant_228*tmp_moved_constant_61) + tmp_moved_constant_15*(tmp_moved_constant_222*tmp_moved_constant_64 + tmp_moved_constant_224*tmp_moved_constant_67 + tmp_moved_constant_226*tmp_moved_constant_70 + tmp_moved_constant_228*tmp_moved_constant_73) + tmp_moved_constant_16*(tmp_moved_constant_222*tmp_moved_constant_76 + tmp_moved_constant_224*tmp_moved_constant_79 + tmp_moved_constant_226*tmp_moved_constant_82 + tmp_moved_constant_228*tmp_moved_constant_85) + tmp_moved_constant_17*(tmp_moved_constant_158*tmp_moved_constant_222 + tmp_moved_constant_159*tmp_moved_constant_224 + tmp_moved_constant_160*tmp_moved_constant_226 + tmp_moved_constant_161*tmp_moved_constant_228) + tmp_moved_constant_18*(tmp_moved_constant_162*tmp_moved_constant_222 + tmp_moved_constant_163*tmp_moved_constant_224 + tmp_moved_constant_164*tmp_moved_constant_226 + tmp_moved_constant_165*tmp_moved_constant_228) + tmp_moved_constant_19*(tmp_moved_constant_166*tmp_moved_constant_222 + tmp_moved_constant_167*tmp_moved_constant_224 + tmp_moved_constant_168*tmp_moved_constant_226 + tmp_moved_constant_169*tmp_moved_constant_228) + tmp_moved_constant_2*(-jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_230 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_231 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_232 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_233) + tmp_moved_constant_20*(tmp_moved_constant_202*tmp_moved_constant_222 + tmp_moved_constant_203*tmp_moved_constant_224 + tmp_moved_constant_204*tmp_moved_constant_226 + tmp_moved_constant_205*tmp_moved_constant_228) + tmp_moved_constant_21*(-jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_223 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_225 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_227 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_229) + tmp_moved_constant_22*(-jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_230 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_231 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_232 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_233) + tmp_moved_constant_23*(-jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_234 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_235 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_236 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_237) + tmp_moved_constant_24*(tmp_moved_constant_222*tmp_moved_constant_88 + tmp_moved_constant_224*tmp_moved_constant_91 + tmp_moved_constant_226*tmp_moved_constant_94 + tmp_moved_constant_228*tmp_moved_constant_97) + tmp_moved_constant_25*(tmp_moved_constant_100*tmp_moved_constant_222 + tmp_moved_constant_103*tmp_moved_constant_224 + tmp_moved_constant_106*tmp_moved_constant_226 + tmp_moved_constant_109*tmp_moved_constant_228) + tmp_moved_constant_26*(tmp_moved_constant_112*tmp_moved_constant_222 + tmp_moved_constant_115*tmp_moved_constant_224 + tmp_moved_constant_118*tmp_moved_constant_226 + tmp_moved_constant_121*tmp_moved_constant_228) + tmp_moved_constant_27*(tmp_moved_constant_170*tmp_moved_constant_222 + tmp_moved_constant_171*tmp_moved_constant_224 + tmp_moved_constant_172*tmp_moved_constant_226 + tmp_moved_constant_173*tmp_moved_constant_228) + tmp_moved_constant_28*(tmp_moved_constant_174*tmp_moved_constant_222 + tmp_moved_constant_175*tmp_moved_constant_224 + tmp_moved_constant_176*tmp_moved_constant_226 + tmp_moved_constant_177*tmp_moved_constant_228) + tmp_moved_constant_29*(tmp_moved_constant_178*tmp_moved_constant_222 + tmp_moved_constant_179*tmp_moved_constant_224 + tmp_moved_constant_180*tmp_moved_constant_226 + tmp_moved_constant_181*tmp_moved_constant_228) + tmp_moved_constant_3*(-jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_234 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_235 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_236 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_237) + tmp_moved_constant_4*(tmp_moved_constant_124*tmp_moved_constant_222 + tmp_moved_constant_127*tmp_moved_constant_224 + tmp_moved_constant_130*tmp_moved_constant_226 + tmp_moved_constant_133*tmp_moved_constant_228) + tmp_moved_constant_5*(tmp_moved_constant_136*tmp_moved_constant_222 + tmp_moved_constant_139*tmp_moved_constant_224 + tmp_moved_constant_142*tmp_moved_constant_226 + tmp_moved_constant_145*tmp_moved_constant_228) + tmp_moved_constant_6*(tmp_moved_constant_148*tmp_moved_constant_222 + tmp_moved_constant_151*tmp_moved_constant_224 + tmp_moved_constant_154*tmp_moved_constant_226 + tmp_moved_constant_157*tmp_moved_constant_228) + tmp_moved_constant_7*(tmp_moved_constant_182*tmp_moved_constant_222 + tmp_moved_constant_183*tmp_moved_constant_224 + tmp_moved_constant_184*tmp_moved_constant_226 + tmp_moved_constant_185*tmp_moved_constant_228) + tmp_moved_constant_8*(tmp_moved_constant_186*tmp_moved_constant_222 + tmp_moved_constant_187*tmp_moved_constant_224 + tmp_moved_constant_188*tmp_moved_constant_226 + tmp_moved_constant_189*tmp_moved_constant_228) + tmp_moved_constant_9*(tmp_moved_constant_190*tmp_moved_constant_222 + tmp_moved_constant_191*tmp_moved_constant_224 + tmp_moved_constant_192*tmp_moved_constant_226 + tmp_moved_constant_193*tmp_moved_constant_228);
                const real_t tmp_moved_constant_257 = tmp_moved_constant_0*(tmp_moved_constant_194*tmp_moved_constant_238 + tmp_moved_constant_195*tmp_moved_constant_240 + tmp_moved_constant_196*tmp_moved_constant_242 + tmp_moved_constant_197*tmp_moved_constant_244) + tmp_moved_constant_1*(-jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_239 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_241 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_243 - jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_245) + tmp_moved_constant_10*(tmp_moved_constant_198*tmp_moved_constant_238 + tmp_moved_constant_199*tmp_moved_constant_240 + tmp_moved_constant_200*tmp_moved_constant_242 + tmp_moved_constant_201*tmp_moved_constant_244) + tmp_moved_constant_11*(-jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_239 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_241 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_243 - jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_245) + tmp_moved_constant_12*(-jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_246 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_247 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_248 - jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_249) + tmp_moved_constant_13*(-jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_250 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_251 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_252 - jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_253) + tmp_moved_constant_14*(tmp_moved_constant_238*tmp_moved_constant_52 + tmp_moved_constant_240*tmp_moved_constant_55 + tmp_moved_constant_242*tmp_moved_constant_58 + tmp_moved_constant_244*tmp_moved_constant_61) + tmp_moved_constant_15*(tmp_moved_constant_238*tmp_moved_constant_64 + tmp_moved_constant_240*tmp_moved_constant_67 + tmp_moved_constant_242*tmp_moved_constant_70 + tmp_moved_constant_244*tmp_moved_constant_73) + tmp_moved_constant_16*(tmp_moved_constant_238*tmp_moved_constant_76 + tmp_moved_constant_240*tmp_moved_constant_79 + tmp_moved_constant_242*tmp_moved_constant_82 + tmp_moved_constant_244*tmp_moved_constant_85) + tmp_moved_constant_17*(tmp_moved_constant_158*tmp_moved_constant_238 + tmp_moved_constant_159*tmp_moved_constant_240 + tmp_moved_constant_160*tmp_moved_constant_242 + tmp_moved_constant_161*tmp_moved_constant_244) + tmp_moved_constant_18*(tmp_moved_constant_162*tmp_moved_constant_238 + tmp_moved_constant_163*tmp_moved_constant_240 + tmp_moved_constant_164*tmp_moved_constant_242 + tmp_moved_constant_165*tmp_moved_constant_244) + tmp_moved_constant_19*(tmp_moved_constant_166*tmp_moved_constant_238 + tmp_moved_constant_167*tmp_moved_constant_240 + tmp_moved_constant_168*tmp_moved_constant_242 + tmp_moved_constant_169*tmp_moved_constant_244) + tmp_moved_constant_2*(-jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_246 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_247 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_248 - jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_249) + tmp_moved_constant_20*(tmp_moved_constant_202*tmp_moved_constant_238 + tmp_moved_constant_203*tmp_moved_constant_240 + tmp_moved_constant_204*tmp_moved_constant_242 + tmp_moved_constant_205*tmp_moved_constant_244) + tmp_moved_constant_21*(-jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_239 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_241 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_243 - jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_245) + tmp_moved_constant_22*(-jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_246 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_247 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_248 - jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_249) + tmp_moved_constant_23*(-jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_250 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_251 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_252 - jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_253) + tmp_moved_constant_24*(tmp_moved_constant_238*tmp_moved_constant_88 + tmp_moved_constant_240*tmp_moved_constant_91 + tmp_moved_constant_242*tmp_moved_constant_94 + tmp_moved_constant_244*tmp_moved_constant_97) + tmp_moved_constant_25*(tmp_moved_constant_100*tmp_moved_constant_238 + tmp_moved_constant_103*tmp_moved_constant_240 + tmp_moved_constant_106*tmp_moved_constant_242 + tmp_moved_constant_109*tmp_moved_constant_244) + tmp_moved_constant_26*(tmp_moved_constant_112*tmp_moved_constant_238 + tmp_moved_constant_115*tmp_moved_constant_240 + tmp_moved_constant_118*tmp_moved_constant_242 + tmp_moved_constant_121*tmp_moved_constant_244) + tmp_moved_constant_27*(tmp_moved_constant_170*tmp_moved_constant_238 + tmp_moved_constant_171*tmp_moved_constant_240 + tmp_moved_constant_172*tmp_moved_constant_242 + tmp_moved_constant_173*tmp_moved_constant_244) + tmp_moved_constant_28*(tmp_moved_constant_174*tmp_moved_constant_238 + tmp_moved_constant_175*tmp_moved_constant_240 + tmp_moved_constant_176*tmp_moved_constant_242 + tmp_moved_constant_177*tmp_moved_constant_244) + tmp_moved_constant_29*(tmp_moved_constant_178*tmp_moved_constant_238 + tmp_moved_constant_179*tmp_moved_constant_240 + tmp_moved_constant_180*tmp_moved_constant_242 + tmp_moved_constant_181*tmp_moved_constant_244) + tmp_moved_constant_3*(-jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_250 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_251 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_252 - jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_253) + tmp_moved_constant_4*(tmp_moved_constant_124*tmp_moved_constant_238 + tmp_moved_constant_127*tmp_moved_constant_240 + tmp_moved_constant_130*tmp_moved_constant_242 + tmp_moved_constant_133*tmp_moved_constant_244) + tmp_moved_constant_5*(tmp_moved_constant_136*tmp_moved_constant_238 + tmp_moved_constant_139*tmp_moved_constant_240 + tmp_moved_constant_142*tmp_moved_constant_242 + tmp_moved_constant_145*tmp_moved_constant_244) + tmp_moved_constant_6*(tmp_moved_constant_148*tmp_moved_constant_238 + tmp_moved_constant_151*tmp_moved_constant_240 + tmp_moved_constant_154*tmp_moved_constant_242 + tmp_moved_constant_157*tmp_moved_constant_244) + tmp_moved_constant_7*(tmp_moved_constant_182*tmp_moved_constant_238 + tmp_moved_constant_183*tmp_moved_constant_240 + tmp_moved_constant_184*tmp_moved_constant_242 + tmp_moved_constant_185*tmp_moved_constant_244) + tmp_moved_constant_8*(tmp_moved_constant_186*tmp_moved_constant_238 + tmp_moved_constant_187*tmp_moved_constant_240 + tmp_moved_constant_188*tmp_moved_constant_242 + tmp_moved_constant_189*tmp_moved_constant_244) + tmp_moved_constant_9*(tmp_moved_constant_190*tmp_moved_constant_238 + tmp_moved_constant_191*tmp_moved_constant_240 + tmp_moved_constant_192*tmp_moved_constant_242 + tmp_moved_constant_193*tmp_moved_constant_244);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_254 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_255 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_256 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_257 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   }
                }
                const real_t tmp_moved_constant_258 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_259 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_260 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_261 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_262 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_263 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_264 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_265 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_266 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_267 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_268 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_269 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_270 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_271 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_272 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_273 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_274 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_275 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_276 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_277 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_278 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_279 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_280 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_281 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_282 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_283 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_284 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_285 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_286 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_287 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_512 = tmp_moved_constant_258*(tmp_moved_constant_289*tmp_moved_constant_452 + tmp_moved_constant_292*tmp_moved_constant_453 + tmp_moved_constant_295*tmp_moved_constant_454 + tmp_moved_constant_298*tmp_moved_constant_455) + tmp_moved_constant_259*(-jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_290 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_293 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_296 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_299) + tmp_moved_constant_260*(-jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_300 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_301 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_302 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_303) + tmp_moved_constant_261*(-jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_304 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_305 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_306 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_307) + tmp_moved_constant_262*(tmp_moved_constant_289*tmp_moved_constant_382 + tmp_moved_constant_292*tmp_moved_constant_385 + tmp_moved_constant_295*tmp_moved_constant_388 + tmp_moved_constant_298*tmp_moved_constant_391) + tmp_moved_constant_263*(tmp_moved_constant_289*tmp_moved_constant_394 + tmp_moved_constant_292*tmp_moved_constant_397 + tmp_moved_constant_295*tmp_moved_constant_400 + tmp_moved_constant_298*tmp_moved_constant_403) + tmp_moved_constant_264*(tmp_moved_constant_289*tmp_moved_constant_406 + tmp_moved_constant_292*tmp_moved_constant_409 + tmp_moved_constant_295*tmp_moved_constant_412 + tmp_moved_constant_298*tmp_moved_constant_415) + tmp_moved_constant_265*(tmp_moved_constant_289*tmp_moved_constant_440 + tmp_moved_constant_292*tmp_moved_constant_441 + tmp_moved_constant_295*tmp_moved_constant_442 + tmp_moved_constant_298*tmp_moved_constant_443) + tmp_moved_constant_266*(tmp_moved_constant_289*tmp_moved_constant_444 + tmp_moved_constant_292*tmp_moved_constant_445 + tmp_moved_constant_295*tmp_moved_constant_446 + tmp_moved_constant_298*tmp_moved_constant_447) + tmp_moved_constant_267*(tmp_moved_constant_289*tmp_moved_constant_448 + tmp_moved_constant_292*tmp_moved_constant_449 + tmp_moved_constant_295*tmp_moved_constant_450 + tmp_moved_constant_298*tmp_moved_constant_451) + tmp_moved_constant_268*(tmp_moved_constant_289*tmp_moved_constant_456 + tmp_moved_constant_292*tmp_moved_constant_457 + tmp_moved_constant_295*tmp_moved_constant_458 + tmp_moved_constant_298*tmp_moved_constant_459) + tmp_moved_constant_269*(-jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_290 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_293 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_296 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_299) + tmp_moved_constant_270*(-jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_300 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_301 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_302 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_303) + tmp_moved_constant_271*(-jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_304 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_305 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_306 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_307) + tmp_moved_constant_272*(tmp_moved_constant_289*tmp_moved_constant_310 + tmp_moved_constant_292*tmp_moved_constant_313 + tmp_moved_constant_295*tmp_moved_constant_316 + tmp_moved_constant_298*tmp_moved_constant_319) + tmp_moved_constant_273*(tmp_moved_constant_289*tmp_moved_constant_322 + tmp_moved_constant_292*tmp_moved_constant_325 + tmp_moved_constant_295*tmp_moved_constant_328 + tmp_moved_constant_298*tmp_moved_constant_331) + tmp_moved_constant_274*(tmp_moved_constant_289*tmp_moved_constant_334 + tmp_moved_constant_292*tmp_moved_constant_337 + tmp_moved_constant_295*tmp_moved_constant_340 + tmp_moved_constant_298*tmp_moved_constant_343) + tmp_moved_constant_275*(tmp_moved_constant_289*tmp_moved_constant_416 + tmp_moved_constant_292*tmp_moved_constant_417 + tmp_moved_constant_295*tmp_moved_constant_418 + tmp_moved_constant_298*tmp_moved_constant_419) + tmp_moved_constant_276*(tmp_moved_constant_289*tmp_moved_constant_420 + tmp_moved_constant_292*tmp_moved_constant_421 + tmp_moved_constant_295*tmp_moved_constant_422 + tmp_moved_constant_298*tmp_moved_constant_423) + tmp_moved_constant_277*(tmp_moved_constant_289*tmp_moved_constant_424 + tmp_moved_constant_292*tmp_moved_constant_425 + tmp_moved_constant_295*tmp_moved_constant_426 + tmp_moved_constant_298*tmp_moved_constant_427) + tmp_moved_constant_278*(tmp_moved_constant_289*tmp_moved_constant_460 + tmp_moved_constant_292*tmp_moved_constant_461 + tmp_moved_constant_295*tmp_moved_constant_462 + tmp_moved_constant_298*tmp_moved_constant_463) + tmp_moved_constant_279*(-jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_290 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_293 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_296 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_299) + tmp_moved_constant_280*(-jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_300 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_301 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_302 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_303) + tmp_moved_constant_281*(-jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_304 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_305 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_306 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_307) + tmp_moved_constant_282*(tmp_moved_constant_289*tmp_moved_constant_346 + tmp_moved_constant_292*tmp_moved_constant_349 + tmp_moved_constant_295*tmp_moved_constant_352 + tmp_moved_constant_298*tmp_moved_constant_355) + tmp_moved_constant_283*(tmp_moved_constant_289*tmp_moved_constant_358 + tmp_moved_constant_292*tmp_moved_constant_361 + tmp_moved_constant_295*tmp_moved_constant_364 + tmp_moved_constant_298*tmp_moved_constant_367) + tmp_moved_constant_284*(tmp_moved_constant_289*tmp_moved_constant_370 + tmp_moved_constant_292*tmp_moved_constant_373 + tmp_moved_constant_295*tmp_moved_constant_376 + tmp_moved_constant_298*tmp_moved_constant_379) + tmp_moved_constant_285*(tmp_moved_constant_289*tmp_moved_constant_428 + tmp_moved_constant_292*tmp_moved_constant_429 + tmp_moved_constant_295*tmp_moved_constant_430 + tmp_moved_constant_298*tmp_moved_constant_431) + tmp_moved_constant_286*(tmp_moved_constant_289*tmp_moved_constant_432 + tmp_moved_constant_292*tmp_moved_constant_433 + tmp_moved_constant_295*tmp_moved_constant_434 + tmp_moved_constant_298*tmp_moved_constant_435) + tmp_moved_constant_287*(tmp_moved_constant_289*tmp_moved_constant_436 + tmp_moved_constant_292*tmp_moved_constant_437 + tmp_moved_constant_295*tmp_moved_constant_438 + tmp_moved_constant_298*tmp_moved_constant_439);
                const real_t tmp_moved_constant_513 = tmp_moved_constant_258*(tmp_moved_constant_452*tmp_moved_constant_464 + tmp_moved_constant_453*tmp_moved_constant_466 + tmp_moved_constant_454*tmp_moved_constant_468 + tmp_moved_constant_455*tmp_moved_constant_470) + tmp_moved_constant_259*(-jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_465 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_467 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_469 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_471) + tmp_moved_constant_260*(-jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_472 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_473 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_474 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_475) + tmp_moved_constant_261*(-jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_476 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_477 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_478 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_479) + tmp_moved_constant_262*(tmp_moved_constant_382*tmp_moved_constant_464 + tmp_moved_constant_385*tmp_moved_constant_466 + tmp_moved_constant_388*tmp_moved_constant_468 + tmp_moved_constant_391*tmp_moved_constant_470) + tmp_moved_constant_263*(tmp_moved_constant_394*tmp_moved_constant_464 + tmp_moved_constant_397*tmp_moved_constant_466 + tmp_moved_constant_400*tmp_moved_constant_468 + tmp_moved_constant_403*tmp_moved_constant_470) + tmp_moved_constant_264*(tmp_moved_constant_406*tmp_moved_constant_464 + tmp_moved_constant_409*tmp_moved_constant_466 + tmp_moved_constant_412*tmp_moved_constant_468 + tmp_moved_constant_415*tmp_moved_constant_470) + tmp_moved_constant_265*(tmp_moved_constant_440*tmp_moved_constant_464 + tmp_moved_constant_441*tmp_moved_constant_466 + tmp_moved_constant_442*tmp_moved_constant_468 + tmp_moved_constant_443*tmp_moved_constant_470) + tmp_moved_constant_266*(tmp_moved_constant_444*tmp_moved_constant_464 + tmp_moved_constant_445*tmp_moved_constant_466 + tmp_moved_constant_446*tmp_moved_constant_468 + tmp_moved_constant_447*tmp_moved_constant_470) + tmp_moved_constant_267*(tmp_moved_constant_448*tmp_moved_constant_464 + tmp_moved_constant_449*tmp_moved_constant_466 + tmp_moved_constant_450*tmp_moved_constant_468 + tmp_moved_constant_451*tmp_moved_constant_470) + tmp_moved_constant_268*(tmp_moved_constant_456*tmp_moved_constant_464 + tmp_moved_constant_457*tmp_moved_constant_466 + tmp_moved_constant_458*tmp_moved_constant_468 + tmp_moved_constant_459*tmp_moved_constant_470) + tmp_moved_constant_269*(-jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_465 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_467 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_469 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_471) + tmp_moved_constant_270*(-jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_472 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_473 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_474 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_475) + tmp_moved_constant_271*(-jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_476 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_477 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_478 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_479) + tmp_moved_constant_272*(tmp_moved_constant_310*tmp_moved_constant_464 + tmp_moved_constant_313*tmp_moved_constant_466 + tmp_moved_constant_316*tmp_moved_constant_468 + tmp_moved_constant_319*tmp_moved_constant_470) + tmp_moved_constant_273*(tmp_moved_constant_322*tmp_moved_constant_464 + tmp_moved_constant_325*tmp_moved_constant_466 + tmp_moved_constant_328*tmp_moved_constant_468 + tmp_moved_constant_331*tmp_moved_constant_470) + tmp_moved_constant_274*(tmp_moved_constant_334*tmp_moved_constant_464 + tmp_moved_constant_337*tmp_moved_constant_466 + tmp_moved_constant_340*tmp_moved_constant_468 + tmp_moved_constant_343*tmp_moved_constant_470) + tmp_moved_constant_275*(tmp_moved_constant_416*tmp_moved_constant_464 + tmp_moved_constant_417*tmp_moved_constant_466 + tmp_moved_constant_418*tmp_moved_constant_468 + tmp_moved_constant_419*tmp_moved_constant_470) + tmp_moved_constant_276*(tmp_moved_constant_420*tmp_moved_constant_464 + tmp_moved_constant_421*tmp_moved_constant_466 + tmp_moved_constant_422*tmp_moved_constant_468 + tmp_moved_constant_423*tmp_moved_constant_470) + tmp_moved_constant_277*(tmp_moved_constant_424*tmp_moved_constant_464 + tmp_moved_constant_425*tmp_moved_constant_466 + tmp_moved_constant_426*tmp_moved_constant_468 + tmp_moved_constant_427*tmp_moved_constant_470) + tmp_moved_constant_278*(tmp_moved_constant_460*tmp_moved_constant_464 + tmp_moved_constant_461*tmp_moved_constant_466 + tmp_moved_constant_462*tmp_moved_constant_468 + tmp_moved_constant_463*tmp_moved_constant_470) + tmp_moved_constant_279*(-jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_465 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_467 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_469 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_471) + tmp_moved_constant_280*(-jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_472 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_473 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_474 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_475) + tmp_moved_constant_281*(-jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_476 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_477 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_478 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_479) + tmp_moved_constant_282*(tmp_moved_constant_346*tmp_moved_constant_464 + tmp_moved_constant_349*tmp_moved_constant_466 + tmp_moved_constant_352*tmp_moved_constant_468 + tmp_moved_constant_355*tmp_moved_constant_470) + tmp_moved_constant_283*(tmp_moved_constant_358*tmp_moved_constant_464 + tmp_moved_constant_361*tmp_moved_constant_466 + tmp_moved_constant_364*tmp_moved_constant_468 + tmp_moved_constant_367*tmp_moved_constant_470) + tmp_moved_constant_284*(tmp_moved_constant_370*tmp_moved_constant_464 + tmp_moved_constant_373*tmp_moved_constant_466 + tmp_moved_constant_376*tmp_moved_constant_468 + tmp_moved_constant_379*tmp_moved_constant_470) + tmp_moved_constant_285*(tmp_moved_constant_428*tmp_moved_constant_464 + tmp_moved_constant_429*tmp_moved_constant_466 + tmp_moved_constant_430*tmp_moved_constant_468 + tmp_moved_constant_431*tmp_moved_constant_470) + tmp_moved_constant_286*(tmp_moved_constant_432*tmp_moved_constant_464 + tmp_moved_constant_433*tmp_moved_constant_466 + tmp_moved_constant_434*tmp_moved_constant_468 + tmp_moved_constant_435*tmp_moved_constant_470) + tmp_moved_constant_287*(tmp_moved_constant_436*tmp_moved_constant_464 + tmp_moved_constant_437*tmp_moved_constant_466 + tmp_moved_constant_438*tmp_moved_constant_468 + tmp_moved_constant_439*tmp_moved_constant_470);
                const real_t tmp_moved_constant_514 = tmp_moved_constant_258*(tmp_moved_constant_452*tmp_moved_constant_480 + tmp_moved_constant_453*tmp_moved_constant_482 + tmp_moved_constant_454*tmp_moved_constant_484 + tmp_moved_constant_455*tmp_moved_constant_486) + tmp_moved_constant_259*(-jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_481 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_483 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_485 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_487) + tmp_moved_constant_260*(-jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_488 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_489 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_490 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_491) + tmp_moved_constant_261*(-jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_492 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_493 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_494 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_495) + tmp_moved_constant_262*(tmp_moved_constant_382*tmp_moved_constant_480 + tmp_moved_constant_385*tmp_moved_constant_482 + tmp_moved_constant_388*tmp_moved_constant_484 + tmp_moved_constant_391*tmp_moved_constant_486) + tmp_moved_constant_263*(tmp_moved_constant_394*tmp_moved_constant_480 + tmp_moved_constant_397*tmp_moved_constant_482 + tmp_moved_constant_400*tmp_moved_constant_484 + tmp_moved_constant_403*tmp_moved_constant_486) + tmp_moved_constant_264*(tmp_moved_constant_406*tmp_moved_constant_480 + tmp_moved_constant_409*tmp_moved_constant_482 + tmp_moved_constant_412*tmp_moved_constant_484 + tmp_moved_constant_415*tmp_moved_constant_486) + tmp_moved_constant_265*(tmp_moved_constant_440*tmp_moved_constant_480 + tmp_moved_constant_441*tmp_moved_constant_482 + tmp_moved_constant_442*tmp_moved_constant_484 + tmp_moved_constant_443*tmp_moved_constant_486) + tmp_moved_constant_266*(tmp_moved_constant_444*tmp_moved_constant_480 + tmp_moved_constant_445*tmp_moved_constant_482 + tmp_moved_constant_446*tmp_moved_constant_484 + tmp_moved_constant_447*tmp_moved_constant_486) + tmp_moved_constant_267*(tmp_moved_constant_448*tmp_moved_constant_480 + tmp_moved_constant_449*tmp_moved_constant_482 + tmp_moved_constant_450*tmp_moved_constant_484 + tmp_moved_constant_451*tmp_moved_constant_486) + tmp_moved_constant_268*(tmp_moved_constant_456*tmp_moved_constant_480 + tmp_moved_constant_457*tmp_moved_constant_482 + tmp_moved_constant_458*tmp_moved_constant_484 + tmp_moved_constant_459*tmp_moved_constant_486) + tmp_moved_constant_269*(-jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_481 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_483 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_485 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_487) + tmp_moved_constant_270*(-jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_488 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_489 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_490 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_491) + tmp_moved_constant_271*(-jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_492 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_493 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_494 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_495) + tmp_moved_constant_272*(tmp_moved_constant_310*tmp_moved_constant_480 + tmp_moved_constant_313*tmp_moved_constant_482 + tmp_moved_constant_316*tmp_moved_constant_484 + tmp_moved_constant_319*tmp_moved_constant_486) + tmp_moved_constant_273*(tmp_moved_constant_322*tmp_moved_constant_480 + tmp_moved_constant_325*tmp_moved_constant_482 + tmp_moved_constant_328*tmp_moved_constant_484 + tmp_moved_constant_331*tmp_moved_constant_486) + tmp_moved_constant_274*(tmp_moved_constant_334*tmp_moved_constant_480 + tmp_moved_constant_337*tmp_moved_constant_482 + tmp_moved_constant_340*tmp_moved_constant_484 + tmp_moved_constant_343*tmp_moved_constant_486) + tmp_moved_constant_275*(tmp_moved_constant_416*tmp_moved_constant_480 + tmp_moved_constant_417*tmp_moved_constant_482 + tmp_moved_constant_418*tmp_moved_constant_484 + tmp_moved_constant_419*tmp_moved_constant_486) + tmp_moved_constant_276*(tmp_moved_constant_420*tmp_moved_constant_480 + tmp_moved_constant_421*tmp_moved_constant_482 + tmp_moved_constant_422*tmp_moved_constant_484 + tmp_moved_constant_423*tmp_moved_constant_486) + tmp_moved_constant_277*(tmp_moved_constant_424*tmp_moved_constant_480 + tmp_moved_constant_425*tmp_moved_constant_482 + tmp_moved_constant_426*tmp_moved_constant_484 + tmp_moved_constant_427*tmp_moved_constant_486) + tmp_moved_constant_278*(tmp_moved_constant_460*tmp_moved_constant_480 + tmp_moved_constant_461*tmp_moved_constant_482 + tmp_moved_constant_462*tmp_moved_constant_484 + tmp_moved_constant_463*tmp_moved_constant_486) + tmp_moved_constant_279*(-jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_481 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_483 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_485 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_487) + tmp_moved_constant_280*(-jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_488 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_489 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_490 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_491) + tmp_moved_constant_281*(-jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_492 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_493 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_494 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_495) + tmp_moved_constant_282*(tmp_moved_constant_346*tmp_moved_constant_480 + tmp_moved_constant_349*tmp_moved_constant_482 + tmp_moved_constant_352*tmp_moved_constant_484 + tmp_moved_constant_355*tmp_moved_constant_486) + tmp_moved_constant_283*(tmp_moved_constant_358*tmp_moved_constant_480 + tmp_moved_constant_361*tmp_moved_constant_482 + tmp_moved_constant_364*tmp_moved_constant_484 + tmp_moved_constant_367*tmp_moved_constant_486) + tmp_moved_constant_284*(tmp_moved_constant_370*tmp_moved_constant_480 + tmp_moved_constant_373*tmp_moved_constant_482 + tmp_moved_constant_376*tmp_moved_constant_484 + tmp_moved_constant_379*tmp_moved_constant_486) + tmp_moved_constant_285*(tmp_moved_constant_428*tmp_moved_constant_480 + tmp_moved_constant_429*tmp_moved_constant_482 + tmp_moved_constant_430*tmp_moved_constant_484 + tmp_moved_constant_431*tmp_moved_constant_486) + tmp_moved_constant_286*(tmp_moved_constant_432*tmp_moved_constant_480 + tmp_moved_constant_433*tmp_moved_constant_482 + tmp_moved_constant_434*tmp_moved_constant_484 + tmp_moved_constant_435*tmp_moved_constant_486) + tmp_moved_constant_287*(tmp_moved_constant_436*tmp_moved_constant_480 + tmp_moved_constant_437*tmp_moved_constant_482 + tmp_moved_constant_438*tmp_moved_constant_484 + tmp_moved_constant_439*tmp_moved_constant_486);
                const real_t tmp_moved_constant_515 = tmp_moved_constant_258*(tmp_moved_constant_452*tmp_moved_constant_496 + tmp_moved_constant_453*tmp_moved_constant_498 + tmp_moved_constant_454*tmp_moved_constant_500 + tmp_moved_constant_455*tmp_moved_constant_502) + tmp_moved_constant_259*(-jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_497 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_499 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_501 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_503) + tmp_moved_constant_260*(-jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_504 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_505 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_506 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_507) + tmp_moved_constant_261*(-jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_508 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_509 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_510 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_511) + tmp_moved_constant_262*(tmp_moved_constant_382*tmp_moved_constant_496 + tmp_moved_constant_385*tmp_moved_constant_498 + tmp_moved_constant_388*tmp_moved_constant_500 + tmp_moved_constant_391*tmp_moved_constant_502) + tmp_moved_constant_263*(tmp_moved_constant_394*tmp_moved_constant_496 + tmp_moved_constant_397*tmp_moved_constant_498 + tmp_moved_constant_400*tmp_moved_constant_500 + tmp_moved_constant_403*tmp_moved_constant_502) + tmp_moved_constant_264*(tmp_moved_constant_406*tmp_moved_constant_496 + tmp_moved_constant_409*tmp_moved_constant_498 + tmp_moved_constant_412*tmp_moved_constant_500 + tmp_moved_constant_415*tmp_moved_constant_502) + tmp_moved_constant_265*(tmp_moved_constant_440*tmp_moved_constant_496 + tmp_moved_constant_441*tmp_moved_constant_498 + tmp_moved_constant_442*tmp_moved_constant_500 + tmp_moved_constant_443*tmp_moved_constant_502) + tmp_moved_constant_266*(tmp_moved_constant_444*tmp_moved_constant_496 + tmp_moved_constant_445*tmp_moved_constant_498 + tmp_moved_constant_446*tmp_moved_constant_500 + tmp_moved_constant_447*tmp_moved_constant_502) + tmp_moved_constant_267*(tmp_moved_constant_448*tmp_moved_constant_496 + tmp_moved_constant_449*tmp_moved_constant_498 + tmp_moved_constant_450*tmp_moved_constant_500 + tmp_moved_constant_451*tmp_moved_constant_502) + tmp_moved_constant_268*(tmp_moved_constant_456*tmp_moved_constant_496 + tmp_moved_constant_457*tmp_moved_constant_498 + tmp_moved_constant_458*tmp_moved_constant_500 + tmp_moved_constant_459*tmp_moved_constant_502) + tmp_moved_constant_269*(-jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_497 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_499 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_501 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_503) + tmp_moved_constant_270*(-jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_504 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_505 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_506 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_507) + tmp_moved_constant_271*(-jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_508 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_509 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_510 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_511) + tmp_moved_constant_272*(tmp_moved_constant_310*tmp_moved_constant_496 + tmp_moved_constant_313*tmp_moved_constant_498 + tmp_moved_constant_316*tmp_moved_constant_500 + tmp_moved_constant_319*tmp_moved_constant_502) + tmp_moved_constant_273*(tmp_moved_constant_322*tmp_moved_constant_496 + tmp_moved_constant_325*tmp_moved_constant_498 + tmp_moved_constant_328*tmp_moved_constant_500 + tmp_moved_constant_331*tmp_moved_constant_502) + tmp_moved_constant_274*(tmp_moved_constant_334*tmp_moved_constant_496 + tmp_moved_constant_337*tmp_moved_constant_498 + tmp_moved_constant_340*tmp_moved_constant_500 + tmp_moved_constant_343*tmp_moved_constant_502) + tmp_moved_constant_275*(tmp_moved_constant_416*tmp_moved_constant_496 + tmp_moved_constant_417*tmp_moved_constant_498 + tmp_moved_constant_418*tmp_moved_constant_500 + tmp_moved_constant_419*tmp_moved_constant_502) + tmp_moved_constant_276*(tmp_moved_constant_420*tmp_moved_constant_496 + tmp_moved_constant_421*tmp_moved_constant_498 + tmp_moved_constant_422*tmp_moved_constant_500 + tmp_moved_constant_423*tmp_moved_constant_502) + tmp_moved_constant_277*(tmp_moved_constant_424*tmp_moved_constant_496 + tmp_moved_constant_425*tmp_moved_constant_498 + tmp_moved_constant_426*tmp_moved_constant_500 + tmp_moved_constant_427*tmp_moved_constant_502) + tmp_moved_constant_278*(tmp_moved_constant_460*tmp_moved_constant_496 + tmp_moved_constant_461*tmp_moved_constant_498 + tmp_moved_constant_462*tmp_moved_constant_500 + tmp_moved_constant_463*tmp_moved_constant_502) + tmp_moved_constant_279*(-jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_497 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_499 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_501 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_503) + tmp_moved_constant_280*(-jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_504 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_505 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_506 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_507) + tmp_moved_constant_281*(-jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_508 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_509 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_510 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_511) + tmp_moved_constant_282*(tmp_moved_constant_346*tmp_moved_constant_496 + tmp_moved_constant_349*tmp_moved_constant_498 + tmp_moved_constant_352*tmp_moved_constant_500 + tmp_moved_constant_355*tmp_moved_constant_502) + tmp_moved_constant_283*(tmp_moved_constant_358*tmp_moved_constant_496 + tmp_moved_constant_361*tmp_moved_constant_498 + tmp_moved_constant_364*tmp_moved_constant_500 + tmp_moved_constant_367*tmp_moved_constant_502) + tmp_moved_constant_284*(tmp_moved_constant_370*tmp_moved_constant_496 + tmp_moved_constant_373*tmp_moved_constant_498 + tmp_moved_constant_376*tmp_moved_constant_500 + tmp_moved_constant_379*tmp_moved_constant_502) + tmp_moved_constant_285*(tmp_moved_constant_428*tmp_moved_constant_496 + tmp_moved_constant_429*tmp_moved_constant_498 + tmp_moved_constant_430*tmp_moved_constant_500 + tmp_moved_constant_431*tmp_moved_constant_502) + tmp_moved_constant_286*(tmp_moved_constant_432*tmp_moved_constant_496 + tmp_moved_constant_433*tmp_moved_constant_498 + tmp_moved_constant_434*tmp_moved_constant_500 + tmp_moved_constant_435*tmp_moved_constant_502) + tmp_moved_constant_287*(tmp_moved_constant_436*tmp_moved_constant_496 + tmp_moved_constant_437*tmp_moved_constant_498 + tmp_moved_constant_438*tmp_moved_constant_500 + tmp_moved_constant_439*tmp_moved_constant_502);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_512 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_513 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_514 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_515 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   }
                }
                const real_t tmp_moved_constant_516 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_517 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_518 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_519 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_520 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_521 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_522 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_523 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_524 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_525 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_526 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_527 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_528 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_529 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_530 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_531 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_532 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_533 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_534 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_535 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_536 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_537 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_538 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_539 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_540 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_541 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_542 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_543 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_544 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_545 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_770 = tmp_moved_constant_516*(tmp_moved_constant_547*tmp_moved_constant_710 + tmp_moved_constant_550*tmp_moved_constant_711 + tmp_moved_constant_553*tmp_moved_constant_712 + tmp_moved_constant_556*tmp_moved_constant_713) + tmp_moved_constant_517*(-jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_548 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_551 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_554 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_557) + tmp_moved_constant_518*(-jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_558 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_559 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_560 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_561) + tmp_moved_constant_519*(-jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_562 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_563 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_564 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_565) + tmp_moved_constant_520*(tmp_moved_constant_547*tmp_moved_constant_640 + tmp_moved_constant_550*tmp_moved_constant_643 + tmp_moved_constant_553*tmp_moved_constant_646 + tmp_moved_constant_556*tmp_moved_constant_649) + tmp_moved_constant_521*(tmp_moved_constant_547*tmp_moved_constant_652 + tmp_moved_constant_550*tmp_moved_constant_655 + tmp_moved_constant_553*tmp_moved_constant_658 + tmp_moved_constant_556*tmp_moved_constant_661) + tmp_moved_constant_522*(tmp_moved_constant_547*tmp_moved_constant_664 + tmp_moved_constant_550*tmp_moved_constant_667 + tmp_moved_constant_553*tmp_moved_constant_670 + tmp_moved_constant_556*tmp_moved_constant_673) + tmp_moved_constant_523*(tmp_moved_constant_547*tmp_moved_constant_698 + tmp_moved_constant_550*tmp_moved_constant_699 + tmp_moved_constant_553*tmp_moved_constant_700 + tmp_moved_constant_556*tmp_moved_constant_701) + tmp_moved_constant_524*(tmp_moved_constant_547*tmp_moved_constant_702 + tmp_moved_constant_550*tmp_moved_constant_703 + tmp_moved_constant_553*tmp_moved_constant_704 + tmp_moved_constant_556*tmp_moved_constant_705) + tmp_moved_constant_525*(tmp_moved_constant_547*tmp_moved_constant_706 + tmp_moved_constant_550*tmp_moved_constant_707 + tmp_moved_constant_553*tmp_moved_constant_708 + tmp_moved_constant_556*tmp_moved_constant_709) + tmp_moved_constant_526*(tmp_moved_constant_547*tmp_moved_constant_714 + tmp_moved_constant_550*tmp_moved_constant_715 + tmp_moved_constant_553*tmp_moved_constant_716 + tmp_moved_constant_556*tmp_moved_constant_717) + tmp_moved_constant_527*(-jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_548 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_551 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_554 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_557) + tmp_moved_constant_528*(-jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_558 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_559 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_560 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_561) + tmp_moved_constant_529*(-jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_562 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_563 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_564 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_565) + tmp_moved_constant_530*(tmp_moved_constant_547*tmp_moved_constant_568 + tmp_moved_constant_550*tmp_moved_constant_571 + tmp_moved_constant_553*tmp_moved_constant_574 + tmp_moved_constant_556*tmp_moved_constant_577) + tmp_moved_constant_531*(tmp_moved_constant_547*tmp_moved_constant_580 + tmp_moved_constant_550*tmp_moved_constant_583 + tmp_moved_constant_553*tmp_moved_constant_586 + tmp_moved_constant_556*tmp_moved_constant_589) + tmp_moved_constant_532*(tmp_moved_constant_547*tmp_moved_constant_592 + tmp_moved_constant_550*tmp_moved_constant_595 + tmp_moved_constant_553*tmp_moved_constant_598 + tmp_moved_constant_556*tmp_moved_constant_601) + tmp_moved_constant_533*(tmp_moved_constant_547*tmp_moved_constant_674 + tmp_moved_constant_550*tmp_moved_constant_675 + tmp_moved_constant_553*tmp_moved_constant_676 + tmp_moved_constant_556*tmp_moved_constant_677) + tmp_moved_constant_534*(tmp_moved_constant_547*tmp_moved_constant_678 + tmp_moved_constant_550*tmp_moved_constant_679 + tmp_moved_constant_553*tmp_moved_constant_680 + tmp_moved_constant_556*tmp_moved_constant_681) + tmp_moved_constant_535*(tmp_moved_constant_547*tmp_moved_constant_682 + tmp_moved_constant_550*tmp_moved_constant_683 + tmp_moved_constant_553*tmp_moved_constant_684 + tmp_moved_constant_556*tmp_moved_constant_685) + tmp_moved_constant_536*(tmp_moved_constant_547*tmp_moved_constant_718 + tmp_moved_constant_550*tmp_moved_constant_719 + tmp_moved_constant_553*tmp_moved_constant_720 + tmp_moved_constant_556*tmp_moved_constant_721) + tmp_moved_constant_537*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_548 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_551 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_554 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_557) + tmp_moved_constant_538*(-jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_558 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_559 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_560 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_561) + tmp_moved_constant_539*(-jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_562 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_563 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_564 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_565) + tmp_moved_constant_540*(tmp_moved_constant_547*tmp_moved_constant_604 + tmp_moved_constant_550*tmp_moved_constant_607 + tmp_moved_constant_553*tmp_moved_constant_610 + tmp_moved_constant_556*tmp_moved_constant_613) + tmp_moved_constant_541*(tmp_moved_constant_547*tmp_moved_constant_616 + tmp_moved_constant_550*tmp_moved_constant_619 + tmp_moved_constant_553*tmp_moved_constant_622 + tmp_moved_constant_556*tmp_moved_constant_625) + tmp_moved_constant_542*(tmp_moved_constant_547*tmp_moved_constant_628 + tmp_moved_constant_550*tmp_moved_constant_631 + tmp_moved_constant_553*tmp_moved_constant_634 + tmp_moved_constant_556*tmp_moved_constant_637) + tmp_moved_constant_543*(tmp_moved_constant_547*tmp_moved_constant_686 + tmp_moved_constant_550*tmp_moved_constant_687 + tmp_moved_constant_553*tmp_moved_constant_688 + tmp_moved_constant_556*tmp_moved_constant_689) + tmp_moved_constant_544*(tmp_moved_constant_547*tmp_moved_constant_690 + tmp_moved_constant_550*tmp_moved_constant_691 + tmp_moved_constant_553*tmp_moved_constant_692 + tmp_moved_constant_556*tmp_moved_constant_693) + tmp_moved_constant_545*(tmp_moved_constant_547*tmp_moved_constant_694 + tmp_moved_constant_550*tmp_moved_constant_695 + tmp_moved_constant_553*tmp_moved_constant_696 + tmp_moved_constant_556*tmp_moved_constant_697);
                const real_t tmp_moved_constant_771 = tmp_moved_constant_516*(tmp_moved_constant_710*tmp_moved_constant_722 + tmp_moved_constant_711*tmp_moved_constant_724 + tmp_moved_constant_712*tmp_moved_constant_726 + tmp_moved_constant_713*tmp_moved_constant_728) + tmp_moved_constant_517*(-jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_723 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_725 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_727 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_729) + tmp_moved_constant_518*(-jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_730 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_731 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_732 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_733) + tmp_moved_constant_519*(-jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_734 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_735 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_736 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_737) + tmp_moved_constant_520*(tmp_moved_constant_640*tmp_moved_constant_722 + tmp_moved_constant_643*tmp_moved_constant_724 + tmp_moved_constant_646*tmp_moved_constant_726 + tmp_moved_constant_649*tmp_moved_constant_728) + tmp_moved_constant_521*(tmp_moved_constant_652*tmp_moved_constant_722 + tmp_moved_constant_655*tmp_moved_constant_724 + tmp_moved_constant_658*tmp_moved_constant_726 + tmp_moved_constant_661*tmp_moved_constant_728) + tmp_moved_constant_522*(tmp_moved_constant_664*tmp_moved_constant_722 + tmp_moved_constant_667*tmp_moved_constant_724 + tmp_moved_constant_670*tmp_moved_constant_726 + tmp_moved_constant_673*tmp_moved_constant_728) + tmp_moved_constant_523*(tmp_moved_constant_698*tmp_moved_constant_722 + tmp_moved_constant_699*tmp_moved_constant_724 + tmp_moved_constant_700*tmp_moved_constant_726 + tmp_moved_constant_701*tmp_moved_constant_728) + tmp_moved_constant_524*(tmp_moved_constant_702*tmp_moved_constant_722 + tmp_moved_constant_703*tmp_moved_constant_724 + tmp_moved_constant_704*tmp_moved_constant_726 + tmp_moved_constant_705*tmp_moved_constant_728) + tmp_moved_constant_525*(tmp_moved_constant_706*tmp_moved_constant_722 + tmp_moved_constant_707*tmp_moved_constant_724 + tmp_moved_constant_708*tmp_moved_constant_726 + tmp_moved_constant_709*tmp_moved_constant_728) + tmp_moved_constant_526*(tmp_moved_constant_714*tmp_moved_constant_722 + tmp_moved_constant_715*tmp_moved_constant_724 + tmp_moved_constant_716*tmp_moved_constant_726 + tmp_moved_constant_717*tmp_moved_constant_728) + tmp_moved_constant_527*(-jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_723 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_725 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_727 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_729) + tmp_moved_constant_528*(-jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_730 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_731 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_732 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_733) + tmp_moved_constant_529*(-jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_734 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_735 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_736 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_737) + tmp_moved_constant_530*(tmp_moved_constant_568*tmp_moved_constant_722 + tmp_moved_constant_571*tmp_moved_constant_724 + tmp_moved_constant_574*tmp_moved_constant_726 + tmp_moved_constant_577*tmp_moved_constant_728) + tmp_moved_constant_531*(tmp_moved_constant_580*tmp_moved_constant_722 + tmp_moved_constant_583*tmp_moved_constant_724 + tmp_moved_constant_586*tmp_moved_constant_726 + tmp_moved_constant_589*tmp_moved_constant_728) + tmp_moved_constant_532*(tmp_moved_constant_592*tmp_moved_constant_722 + tmp_moved_constant_595*tmp_moved_constant_724 + tmp_moved_constant_598*tmp_moved_constant_726 + tmp_moved_constant_601*tmp_moved_constant_728) + tmp_moved_constant_533*(tmp_moved_constant_674*tmp_moved_constant_722 + tmp_moved_constant_675*tmp_moved_constant_724 + tmp_moved_constant_676*tmp_moved_constant_726 + tmp_moved_constant_677*tmp_moved_constant_728) + tmp_moved_constant_534*(tmp_moved_constant_678*tmp_moved_constant_722 + tmp_moved_constant_679*tmp_moved_constant_724 + tmp_moved_constant_680*tmp_moved_constant_726 + tmp_moved_constant_681*tmp_moved_constant_728) + tmp_moved_constant_535*(tmp_moved_constant_682*tmp_moved_constant_722 + tmp_moved_constant_683*tmp_moved_constant_724 + tmp_moved_constant_684*tmp_moved_constant_726 + tmp_moved_constant_685*tmp_moved_constant_728) + tmp_moved_constant_536*(tmp_moved_constant_718*tmp_moved_constant_722 + tmp_moved_constant_719*tmp_moved_constant_724 + tmp_moved_constant_720*tmp_moved_constant_726 + tmp_moved_constant_721*tmp_moved_constant_728) + tmp_moved_constant_537*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_723 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_725 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_727 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_729) + tmp_moved_constant_538*(-jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_730 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_731 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_732 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_733) + tmp_moved_constant_539*(-jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_734 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_735 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_736 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_737) + tmp_moved_constant_540*(tmp_moved_constant_604*tmp_moved_constant_722 + tmp_moved_constant_607*tmp_moved_constant_724 + tmp_moved_constant_610*tmp_moved_constant_726 + tmp_moved_constant_613*tmp_moved_constant_728) + tmp_moved_constant_541*(tmp_moved_constant_616*tmp_moved_constant_722 + tmp_moved_constant_619*tmp_moved_constant_724 + tmp_moved_constant_622*tmp_moved_constant_726 + tmp_moved_constant_625*tmp_moved_constant_728) + tmp_moved_constant_542*(tmp_moved_constant_628*tmp_moved_constant_722 + tmp_moved_constant_631*tmp_moved_constant_724 + tmp_moved_constant_634*tmp_moved_constant_726 + tmp_moved_constant_637*tmp_moved_constant_728) + tmp_moved_constant_543*(tmp_moved_constant_686*tmp_moved_constant_722 + tmp_moved_constant_687*tmp_moved_constant_724 + tmp_moved_constant_688*tmp_moved_constant_726 + tmp_moved_constant_689*tmp_moved_constant_728) + tmp_moved_constant_544*(tmp_moved_constant_690*tmp_moved_constant_722 + tmp_moved_constant_691*tmp_moved_constant_724 + tmp_moved_constant_692*tmp_moved_constant_726 + tmp_moved_constant_693*tmp_moved_constant_728) + tmp_moved_constant_545*(tmp_moved_constant_694*tmp_moved_constant_722 + tmp_moved_constant_695*tmp_moved_constant_724 + tmp_moved_constant_696*tmp_moved_constant_726 + tmp_moved_constant_697*tmp_moved_constant_728);
                const real_t tmp_moved_constant_772 = tmp_moved_constant_516*(tmp_moved_constant_710*tmp_moved_constant_738 + tmp_moved_constant_711*tmp_moved_constant_740 + tmp_moved_constant_712*tmp_moved_constant_742 + tmp_moved_constant_713*tmp_moved_constant_744) + tmp_moved_constant_517*(-jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_739 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_741 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_743 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_745) + tmp_moved_constant_518*(-jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_746 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_747 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_748 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_749) + tmp_moved_constant_519*(-jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_750 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_751 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_752 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_753) + tmp_moved_constant_520*(tmp_moved_constant_640*tmp_moved_constant_738 + tmp_moved_constant_643*tmp_moved_constant_740 + tmp_moved_constant_646*tmp_moved_constant_742 + tmp_moved_constant_649*tmp_moved_constant_744) + tmp_moved_constant_521*(tmp_moved_constant_652*tmp_moved_constant_738 + tmp_moved_constant_655*tmp_moved_constant_740 + tmp_moved_constant_658*tmp_moved_constant_742 + tmp_moved_constant_661*tmp_moved_constant_744) + tmp_moved_constant_522*(tmp_moved_constant_664*tmp_moved_constant_738 + tmp_moved_constant_667*tmp_moved_constant_740 + tmp_moved_constant_670*tmp_moved_constant_742 + tmp_moved_constant_673*tmp_moved_constant_744) + tmp_moved_constant_523*(tmp_moved_constant_698*tmp_moved_constant_738 + tmp_moved_constant_699*tmp_moved_constant_740 + tmp_moved_constant_700*tmp_moved_constant_742 + tmp_moved_constant_701*tmp_moved_constant_744) + tmp_moved_constant_524*(tmp_moved_constant_702*tmp_moved_constant_738 + tmp_moved_constant_703*tmp_moved_constant_740 + tmp_moved_constant_704*tmp_moved_constant_742 + tmp_moved_constant_705*tmp_moved_constant_744) + tmp_moved_constant_525*(tmp_moved_constant_706*tmp_moved_constant_738 + tmp_moved_constant_707*tmp_moved_constant_740 + tmp_moved_constant_708*tmp_moved_constant_742 + tmp_moved_constant_709*tmp_moved_constant_744) + tmp_moved_constant_526*(tmp_moved_constant_714*tmp_moved_constant_738 + tmp_moved_constant_715*tmp_moved_constant_740 + tmp_moved_constant_716*tmp_moved_constant_742 + tmp_moved_constant_717*tmp_moved_constant_744) + tmp_moved_constant_527*(-jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_739 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_741 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_743 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_745) + tmp_moved_constant_528*(-jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_746 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_747 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_748 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_749) + tmp_moved_constant_529*(-jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_750 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_751 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_752 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_753) + tmp_moved_constant_530*(tmp_moved_constant_568*tmp_moved_constant_738 + tmp_moved_constant_571*tmp_moved_constant_740 + tmp_moved_constant_574*tmp_moved_constant_742 + tmp_moved_constant_577*tmp_moved_constant_744) + tmp_moved_constant_531*(tmp_moved_constant_580*tmp_moved_constant_738 + tmp_moved_constant_583*tmp_moved_constant_740 + tmp_moved_constant_586*tmp_moved_constant_742 + tmp_moved_constant_589*tmp_moved_constant_744) + tmp_moved_constant_532*(tmp_moved_constant_592*tmp_moved_constant_738 + tmp_moved_constant_595*tmp_moved_constant_740 + tmp_moved_constant_598*tmp_moved_constant_742 + tmp_moved_constant_601*tmp_moved_constant_744) + tmp_moved_constant_533*(tmp_moved_constant_674*tmp_moved_constant_738 + tmp_moved_constant_675*tmp_moved_constant_740 + tmp_moved_constant_676*tmp_moved_constant_742 + tmp_moved_constant_677*tmp_moved_constant_744) + tmp_moved_constant_534*(tmp_moved_constant_678*tmp_moved_constant_738 + tmp_moved_constant_679*tmp_moved_constant_740 + tmp_moved_constant_680*tmp_moved_constant_742 + tmp_moved_constant_681*tmp_moved_constant_744) + tmp_moved_constant_535*(tmp_moved_constant_682*tmp_moved_constant_738 + tmp_moved_constant_683*tmp_moved_constant_740 + tmp_moved_constant_684*tmp_moved_constant_742 + tmp_moved_constant_685*tmp_moved_constant_744) + tmp_moved_constant_536*(tmp_moved_constant_718*tmp_moved_constant_738 + tmp_moved_constant_719*tmp_moved_constant_740 + tmp_moved_constant_720*tmp_moved_constant_742 + tmp_moved_constant_721*tmp_moved_constant_744) + tmp_moved_constant_537*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_739 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_741 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_743 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_745) + tmp_moved_constant_538*(-jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_746 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_747 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_748 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_749) + tmp_moved_constant_539*(-jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_750 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_751 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_752 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_753) + tmp_moved_constant_540*(tmp_moved_constant_604*tmp_moved_constant_738 + tmp_moved_constant_607*tmp_moved_constant_740 + tmp_moved_constant_610*tmp_moved_constant_742 + tmp_moved_constant_613*tmp_moved_constant_744) + tmp_moved_constant_541*(tmp_moved_constant_616*tmp_moved_constant_738 + tmp_moved_constant_619*tmp_moved_constant_740 + tmp_moved_constant_622*tmp_moved_constant_742 + tmp_moved_constant_625*tmp_moved_constant_744) + tmp_moved_constant_542*(tmp_moved_constant_628*tmp_moved_constant_738 + tmp_moved_constant_631*tmp_moved_constant_740 + tmp_moved_constant_634*tmp_moved_constant_742 + tmp_moved_constant_637*tmp_moved_constant_744) + tmp_moved_constant_543*(tmp_moved_constant_686*tmp_moved_constant_738 + tmp_moved_constant_687*tmp_moved_constant_740 + tmp_moved_constant_688*tmp_moved_constant_742 + tmp_moved_constant_689*tmp_moved_constant_744) + tmp_moved_constant_544*(tmp_moved_constant_690*tmp_moved_constant_738 + tmp_moved_constant_691*tmp_moved_constant_740 + tmp_moved_constant_692*tmp_moved_constant_742 + tmp_moved_constant_693*tmp_moved_constant_744) + tmp_moved_constant_545*(tmp_moved_constant_694*tmp_moved_constant_738 + tmp_moved_constant_695*tmp_moved_constant_740 + tmp_moved_constant_696*tmp_moved_constant_742 + tmp_moved_constant_697*tmp_moved_constant_744);
                const real_t tmp_moved_constant_773 = tmp_moved_constant_516*(tmp_moved_constant_710*tmp_moved_constant_754 + tmp_moved_constant_711*tmp_moved_constant_756 + tmp_moved_constant_712*tmp_moved_constant_758 + tmp_moved_constant_713*tmp_moved_constant_760) + tmp_moved_constant_517*(-jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_755 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_757 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_759 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_761) + tmp_moved_constant_518*(-jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_762 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_763 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_764 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_765) + tmp_moved_constant_519*(-jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_766 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_767 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_768 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_769) + tmp_moved_constant_520*(tmp_moved_constant_640*tmp_moved_constant_754 + tmp_moved_constant_643*tmp_moved_constant_756 + tmp_moved_constant_646*tmp_moved_constant_758 + tmp_moved_constant_649*tmp_moved_constant_760) + tmp_moved_constant_521*(tmp_moved_constant_652*tmp_moved_constant_754 + tmp_moved_constant_655*tmp_moved_constant_756 + tmp_moved_constant_658*tmp_moved_constant_758 + tmp_moved_constant_661*tmp_moved_constant_760) + tmp_moved_constant_522*(tmp_moved_constant_664*tmp_moved_constant_754 + tmp_moved_constant_667*tmp_moved_constant_756 + tmp_moved_constant_670*tmp_moved_constant_758 + tmp_moved_constant_673*tmp_moved_constant_760) + tmp_moved_constant_523*(tmp_moved_constant_698*tmp_moved_constant_754 + tmp_moved_constant_699*tmp_moved_constant_756 + tmp_moved_constant_700*tmp_moved_constant_758 + tmp_moved_constant_701*tmp_moved_constant_760) + tmp_moved_constant_524*(tmp_moved_constant_702*tmp_moved_constant_754 + tmp_moved_constant_703*tmp_moved_constant_756 + tmp_moved_constant_704*tmp_moved_constant_758 + tmp_moved_constant_705*tmp_moved_constant_760) + tmp_moved_constant_525*(tmp_moved_constant_706*tmp_moved_constant_754 + tmp_moved_constant_707*tmp_moved_constant_756 + tmp_moved_constant_708*tmp_moved_constant_758 + tmp_moved_constant_709*tmp_moved_constant_760) + tmp_moved_constant_526*(tmp_moved_constant_714*tmp_moved_constant_754 + tmp_moved_constant_715*tmp_moved_constant_756 + tmp_moved_constant_716*tmp_moved_constant_758 + tmp_moved_constant_717*tmp_moved_constant_760) + tmp_moved_constant_527*(-jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_755 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_757 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_759 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_761) + tmp_moved_constant_528*(-jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_762 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_763 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_764 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_765) + tmp_moved_constant_529*(-jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_766 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_767 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_768 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_769) + tmp_moved_constant_530*(tmp_moved_constant_568*tmp_moved_constant_754 + tmp_moved_constant_571*tmp_moved_constant_756 + tmp_moved_constant_574*tmp_moved_constant_758 + tmp_moved_constant_577*tmp_moved_constant_760) + tmp_moved_constant_531*(tmp_moved_constant_580*tmp_moved_constant_754 + tmp_moved_constant_583*tmp_moved_constant_756 + tmp_moved_constant_586*tmp_moved_constant_758 + tmp_moved_constant_589*tmp_moved_constant_760) + tmp_moved_constant_532*(tmp_moved_constant_592*tmp_moved_constant_754 + tmp_moved_constant_595*tmp_moved_constant_756 + tmp_moved_constant_598*tmp_moved_constant_758 + tmp_moved_constant_601*tmp_moved_constant_760) + tmp_moved_constant_533*(tmp_moved_constant_674*tmp_moved_constant_754 + tmp_moved_constant_675*tmp_moved_constant_756 + tmp_moved_constant_676*tmp_moved_constant_758 + tmp_moved_constant_677*tmp_moved_constant_760) + tmp_moved_constant_534*(tmp_moved_constant_678*tmp_moved_constant_754 + tmp_moved_constant_679*tmp_moved_constant_756 + tmp_moved_constant_680*tmp_moved_constant_758 + tmp_moved_constant_681*tmp_moved_constant_760) + tmp_moved_constant_535*(tmp_moved_constant_682*tmp_moved_constant_754 + tmp_moved_constant_683*tmp_moved_constant_756 + tmp_moved_constant_684*tmp_moved_constant_758 + tmp_moved_constant_685*tmp_moved_constant_760) + tmp_moved_constant_536*(tmp_moved_constant_718*tmp_moved_constant_754 + tmp_moved_constant_719*tmp_moved_constant_756 + tmp_moved_constant_720*tmp_moved_constant_758 + tmp_moved_constant_721*tmp_moved_constant_760) + tmp_moved_constant_537*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_755 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_757 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_759 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_761) + tmp_moved_constant_538*(-jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_762 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_763 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_764 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_765) + tmp_moved_constant_539*(-jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_766 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_767 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_768 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_769) + tmp_moved_constant_540*(tmp_moved_constant_604*tmp_moved_constant_754 + tmp_moved_constant_607*tmp_moved_constant_756 + tmp_moved_constant_610*tmp_moved_constant_758 + tmp_moved_constant_613*tmp_moved_constant_760) + tmp_moved_constant_541*(tmp_moved_constant_616*tmp_moved_constant_754 + tmp_moved_constant_619*tmp_moved_constant_756 + tmp_moved_constant_622*tmp_moved_constant_758 + tmp_moved_constant_625*tmp_moved_constant_760) + tmp_moved_constant_542*(tmp_moved_constant_628*tmp_moved_constant_754 + tmp_moved_constant_631*tmp_moved_constant_756 + tmp_moved_constant_634*tmp_moved_constant_758 + tmp_moved_constant_637*tmp_moved_constant_760) + tmp_moved_constant_543*(tmp_moved_constant_686*tmp_moved_constant_754 + tmp_moved_constant_687*tmp_moved_constant_756 + tmp_moved_constant_688*tmp_moved_constant_758 + tmp_moved_constant_689*tmp_moved_constant_760) + tmp_moved_constant_544*(tmp_moved_constant_690*tmp_moved_constant_754 + tmp_moved_constant_691*tmp_moved_constant_756 + tmp_moved_constant_692*tmp_moved_constant_758 + tmp_moved_constant_693*tmp_moved_constant_760) + tmp_moved_constant_545*(tmp_moved_constant_694*tmp_moved_constant_754 + tmp_moved_constant_695*tmp_moved_constant_756 + tmp_moved_constant_696*tmp_moved_constant_758 + tmp_moved_constant_697*tmp_moved_constant_760);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_770 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_771 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_772 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_773 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   }
                }
                const real_t tmp_moved_constant_774 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_775 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_776 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_777 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_778 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_779 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_780 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_781 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_782 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_783 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_784 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_785 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_786 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_787 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_788 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_789 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_790 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_791 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_792 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_793 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_794 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_795 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_796 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_797 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_798 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_799 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_800 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_801 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_802 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_803 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1028 = tmp_moved_constant_774*(tmp_moved_constant_805*tmp_moved_constant_968 + tmp_moved_constant_808*tmp_moved_constant_969 + tmp_moved_constant_811*tmp_moved_constant_970 + tmp_moved_constant_814*tmp_moved_constant_971) + tmp_moved_constant_775*(-jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_806 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_809 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_812 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_815) + tmp_moved_constant_776*(-jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_816 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_817 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_818 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_819) + tmp_moved_constant_777*(-jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_820 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_821 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_822 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_823) + tmp_moved_constant_778*(tmp_moved_constant_805*tmp_moved_constant_898 + tmp_moved_constant_808*tmp_moved_constant_901 + tmp_moved_constant_811*tmp_moved_constant_904 + tmp_moved_constant_814*tmp_moved_constant_907) + tmp_moved_constant_779*(tmp_moved_constant_805*tmp_moved_constant_910 + tmp_moved_constant_808*tmp_moved_constant_913 + tmp_moved_constant_811*tmp_moved_constant_916 + tmp_moved_constant_814*tmp_moved_constant_919) + tmp_moved_constant_780*(tmp_moved_constant_805*tmp_moved_constant_922 + tmp_moved_constant_808*tmp_moved_constant_925 + tmp_moved_constant_811*tmp_moved_constant_928 + tmp_moved_constant_814*tmp_moved_constant_931) + tmp_moved_constant_781*(tmp_moved_constant_805*tmp_moved_constant_956 + tmp_moved_constant_808*tmp_moved_constant_957 + tmp_moved_constant_811*tmp_moved_constant_958 + tmp_moved_constant_814*tmp_moved_constant_959) + tmp_moved_constant_782*(tmp_moved_constant_805*tmp_moved_constant_960 + tmp_moved_constant_808*tmp_moved_constant_961 + tmp_moved_constant_811*tmp_moved_constant_962 + tmp_moved_constant_814*tmp_moved_constant_963) + tmp_moved_constant_783*(tmp_moved_constant_805*tmp_moved_constant_964 + tmp_moved_constant_808*tmp_moved_constant_965 + tmp_moved_constant_811*tmp_moved_constant_966 + tmp_moved_constant_814*tmp_moved_constant_967) + tmp_moved_constant_784*(tmp_moved_constant_805*tmp_moved_constant_972 + tmp_moved_constant_808*tmp_moved_constant_973 + tmp_moved_constant_811*tmp_moved_constant_974 + tmp_moved_constant_814*tmp_moved_constant_975) + tmp_moved_constant_785*(-jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_806 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_809 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_812 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_815) + tmp_moved_constant_786*(-jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_816 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_817 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_818 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_819) + tmp_moved_constant_787*(-jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_820 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_821 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_822 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_823) + tmp_moved_constant_788*(tmp_moved_constant_805*tmp_moved_constant_826 + tmp_moved_constant_808*tmp_moved_constant_829 + tmp_moved_constant_811*tmp_moved_constant_832 + tmp_moved_constant_814*tmp_moved_constant_835) + tmp_moved_constant_789*(tmp_moved_constant_805*tmp_moved_constant_838 + tmp_moved_constant_808*tmp_moved_constant_841 + tmp_moved_constant_811*tmp_moved_constant_844 + tmp_moved_constant_814*tmp_moved_constant_847) + tmp_moved_constant_790*(tmp_moved_constant_805*tmp_moved_constant_850 + tmp_moved_constant_808*tmp_moved_constant_853 + tmp_moved_constant_811*tmp_moved_constant_856 + tmp_moved_constant_814*tmp_moved_constant_859) + tmp_moved_constant_791*(tmp_moved_constant_805*tmp_moved_constant_932 + tmp_moved_constant_808*tmp_moved_constant_933 + tmp_moved_constant_811*tmp_moved_constant_934 + tmp_moved_constant_814*tmp_moved_constant_935) + tmp_moved_constant_792*(tmp_moved_constant_805*tmp_moved_constant_936 + tmp_moved_constant_808*tmp_moved_constant_937 + tmp_moved_constant_811*tmp_moved_constant_938 + tmp_moved_constant_814*tmp_moved_constant_939) + tmp_moved_constant_793*(tmp_moved_constant_805*tmp_moved_constant_940 + tmp_moved_constant_808*tmp_moved_constant_941 + tmp_moved_constant_811*tmp_moved_constant_942 + tmp_moved_constant_814*tmp_moved_constant_943) + tmp_moved_constant_794*(tmp_moved_constant_805*tmp_moved_constant_976 + tmp_moved_constant_808*tmp_moved_constant_977 + tmp_moved_constant_811*tmp_moved_constant_978 + tmp_moved_constant_814*tmp_moved_constant_979) + tmp_moved_constant_795*(-jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_806 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_809 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_812 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_815) + tmp_moved_constant_796*(-jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_816 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_817 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_818 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_819) + tmp_moved_constant_797*(-jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_820 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_821 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_822 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_823) + tmp_moved_constant_798*(tmp_moved_constant_805*tmp_moved_constant_862 + tmp_moved_constant_808*tmp_moved_constant_865 + tmp_moved_constant_811*tmp_moved_constant_868 + tmp_moved_constant_814*tmp_moved_constant_871) + tmp_moved_constant_799*(tmp_moved_constant_805*tmp_moved_constant_874 + tmp_moved_constant_808*tmp_moved_constant_877 + tmp_moved_constant_811*tmp_moved_constant_880 + tmp_moved_constant_814*tmp_moved_constant_883) + tmp_moved_constant_800*(tmp_moved_constant_805*tmp_moved_constant_886 + tmp_moved_constant_808*tmp_moved_constant_889 + tmp_moved_constant_811*tmp_moved_constant_892 + tmp_moved_constant_814*tmp_moved_constant_895) + tmp_moved_constant_801*(tmp_moved_constant_805*tmp_moved_constant_944 + tmp_moved_constant_808*tmp_moved_constant_945 + tmp_moved_constant_811*tmp_moved_constant_946 + tmp_moved_constant_814*tmp_moved_constant_947) + tmp_moved_constant_802*(tmp_moved_constant_805*tmp_moved_constant_948 + tmp_moved_constant_808*tmp_moved_constant_949 + tmp_moved_constant_811*tmp_moved_constant_950 + tmp_moved_constant_814*tmp_moved_constant_951) + tmp_moved_constant_803*(tmp_moved_constant_805*tmp_moved_constant_952 + tmp_moved_constant_808*tmp_moved_constant_953 + tmp_moved_constant_811*tmp_moved_constant_954 + tmp_moved_constant_814*tmp_moved_constant_955);
                const real_t tmp_moved_constant_1029 = tmp_moved_constant_774*(tmp_moved_constant_968*tmp_moved_constant_980 + tmp_moved_constant_969*tmp_moved_constant_982 + tmp_moved_constant_970*tmp_moved_constant_984 + tmp_moved_constant_971*tmp_moved_constant_986) + tmp_moved_constant_775*(-jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_981 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_983 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_985 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_987) + tmp_moved_constant_776*(-jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_988 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_989 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_990 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_991) + tmp_moved_constant_777*(-jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_992 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_993 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_994 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_995) + tmp_moved_constant_778*(tmp_moved_constant_898*tmp_moved_constant_980 + tmp_moved_constant_901*tmp_moved_constant_982 + tmp_moved_constant_904*tmp_moved_constant_984 + tmp_moved_constant_907*tmp_moved_constant_986) + tmp_moved_constant_779*(tmp_moved_constant_910*tmp_moved_constant_980 + tmp_moved_constant_913*tmp_moved_constant_982 + tmp_moved_constant_916*tmp_moved_constant_984 + tmp_moved_constant_919*tmp_moved_constant_986) + tmp_moved_constant_780*(tmp_moved_constant_922*tmp_moved_constant_980 + tmp_moved_constant_925*tmp_moved_constant_982 + tmp_moved_constant_928*tmp_moved_constant_984 + tmp_moved_constant_931*tmp_moved_constant_986) + tmp_moved_constant_781*(tmp_moved_constant_956*tmp_moved_constant_980 + tmp_moved_constant_957*tmp_moved_constant_982 + tmp_moved_constant_958*tmp_moved_constant_984 + tmp_moved_constant_959*tmp_moved_constant_986) + tmp_moved_constant_782*(tmp_moved_constant_960*tmp_moved_constant_980 + tmp_moved_constant_961*tmp_moved_constant_982 + tmp_moved_constant_962*tmp_moved_constant_984 + tmp_moved_constant_963*tmp_moved_constant_986) + tmp_moved_constant_783*(tmp_moved_constant_964*tmp_moved_constant_980 + tmp_moved_constant_965*tmp_moved_constant_982 + tmp_moved_constant_966*tmp_moved_constant_984 + tmp_moved_constant_967*tmp_moved_constant_986) + tmp_moved_constant_784*(tmp_moved_constant_972*tmp_moved_constant_980 + tmp_moved_constant_973*tmp_moved_constant_982 + tmp_moved_constant_974*tmp_moved_constant_984 + tmp_moved_constant_975*tmp_moved_constant_986) + tmp_moved_constant_785*(-jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_981 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_983 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_985 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_987) + tmp_moved_constant_786*(-jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_988 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_989 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_990 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_991) + tmp_moved_constant_787*(-jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_992 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_993 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_994 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_995) + tmp_moved_constant_788*(tmp_moved_constant_826*tmp_moved_constant_980 + tmp_moved_constant_829*tmp_moved_constant_982 + tmp_moved_constant_832*tmp_moved_constant_984 + tmp_moved_constant_835*tmp_moved_constant_986) + tmp_moved_constant_789*(tmp_moved_constant_838*tmp_moved_constant_980 + tmp_moved_constant_841*tmp_moved_constant_982 + tmp_moved_constant_844*tmp_moved_constant_984 + tmp_moved_constant_847*tmp_moved_constant_986) + tmp_moved_constant_790*(tmp_moved_constant_850*tmp_moved_constant_980 + tmp_moved_constant_853*tmp_moved_constant_982 + tmp_moved_constant_856*tmp_moved_constant_984 + tmp_moved_constant_859*tmp_moved_constant_986) + tmp_moved_constant_791*(tmp_moved_constant_932*tmp_moved_constant_980 + tmp_moved_constant_933*tmp_moved_constant_982 + tmp_moved_constant_934*tmp_moved_constant_984 + tmp_moved_constant_935*tmp_moved_constant_986) + tmp_moved_constant_792*(tmp_moved_constant_936*tmp_moved_constant_980 + tmp_moved_constant_937*tmp_moved_constant_982 + tmp_moved_constant_938*tmp_moved_constant_984 + tmp_moved_constant_939*tmp_moved_constant_986) + tmp_moved_constant_793*(tmp_moved_constant_940*tmp_moved_constant_980 + tmp_moved_constant_941*tmp_moved_constant_982 + tmp_moved_constant_942*tmp_moved_constant_984 + tmp_moved_constant_943*tmp_moved_constant_986) + tmp_moved_constant_794*(tmp_moved_constant_976*tmp_moved_constant_980 + tmp_moved_constant_977*tmp_moved_constant_982 + tmp_moved_constant_978*tmp_moved_constant_984 + tmp_moved_constant_979*tmp_moved_constant_986) + tmp_moved_constant_795*(-jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_981 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_983 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_985 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_987) + tmp_moved_constant_796*(-jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_988 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_989 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_990 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_991) + tmp_moved_constant_797*(-jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_992 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_993 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_994 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_995) + tmp_moved_constant_798*(tmp_moved_constant_862*tmp_moved_constant_980 + tmp_moved_constant_865*tmp_moved_constant_982 + tmp_moved_constant_868*tmp_moved_constant_984 + tmp_moved_constant_871*tmp_moved_constant_986) + tmp_moved_constant_799*(tmp_moved_constant_874*tmp_moved_constant_980 + tmp_moved_constant_877*tmp_moved_constant_982 + tmp_moved_constant_880*tmp_moved_constant_984 + tmp_moved_constant_883*tmp_moved_constant_986) + tmp_moved_constant_800*(tmp_moved_constant_886*tmp_moved_constant_980 + tmp_moved_constant_889*tmp_moved_constant_982 + tmp_moved_constant_892*tmp_moved_constant_984 + tmp_moved_constant_895*tmp_moved_constant_986) + tmp_moved_constant_801*(tmp_moved_constant_944*tmp_moved_constant_980 + tmp_moved_constant_945*tmp_moved_constant_982 + tmp_moved_constant_946*tmp_moved_constant_984 + tmp_moved_constant_947*tmp_moved_constant_986) + tmp_moved_constant_802*(tmp_moved_constant_948*tmp_moved_constant_980 + tmp_moved_constant_949*tmp_moved_constant_982 + tmp_moved_constant_950*tmp_moved_constant_984 + tmp_moved_constant_951*tmp_moved_constant_986) + tmp_moved_constant_803*(tmp_moved_constant_952*tmp_moved_constant_980 + tmp_moved_constant_953*tmp_moved_constant_982 + tmp_moved_constant_954*tmp_moved_constant_984 + tmp_moved_constant_955*tmp_moved_constant_986);
                const real_t tmp_moved_constant_1030 = tmp_moved_constant_774*(tmp_moved_constant_1000*tmp_moved_constant_970 + tmp_moved_constant_1002*tmp_moved_constant_971 + tmp_moved_constant_968*tmp_moved_constant_996 + tmp_moved_constant_969*tmp_moved_constant_998) + tmp_moved_constant_775*(-jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1001 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1003 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_997 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_999) + tmp_moved_constant_776*(-jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1004 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1005 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1006 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1007) + tmp_moved_constant_777*(-jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1008 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1009 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1010 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1011) + tmp_moved_constant_778*(tmp_moved_constant_1000*tmp_moved_constant_904 + tmp_moved_constant_1002*tmp_moved_constant_907 + tmp_moved_constant_898*tmp_moved_constant_996 + tmp_moved_constant_901*tmp_moved_constant_998) + tmp_moved_constant_779*(tmp_moved_constant_1000*tmp_moved_constant_916 + tmp_moved_constant_1002*tmp_moved_constant_919 + tmp_moved_constant_910*tmp_moved_constant_996 + tmp_moved_constant_913*tmp_moved_constant_998) + tmp_moved_constant_780*(tmp_moved_constant_1000*tmp_moved_constant_928 + tmp_moved_constant_1002*tmp_moved_constant_931 + tmp_moved_constant_922*tmp_moved_constant_996 + tmp_moved_constant_925*tmp_moved_constant_998) + tmp_moved_constant_781*(tmp_moved_constant_1000*tmp_moved_constant_958 + tmp_moved_constant_1002*tmp_moved_constant_959 + tmp_moved_constant_956*tmp_moved_constant_996 + tmp_moved_constant_957*tmp_moved_constant_998) + tmp_moved_constant_782*(tmp_moved_constant_1000*tmp_moved_constant_962 + tmp_moved_constant_1002*tmp_moved_constant_963 + tmp_moved_constant_960*tmp_moved_constant_996 + tmp_moved_constant_961*tmp_moved_constant_998) + tmp_moved_constant_783*(tmp_moved_constant_1000*tmp_moved_constant_966 + tmp_moved_constant_1002*tmp_moved_constant_967 + tmp_moved_constant_964*tmp_moved_constant_996 + tmp_moved_constant_965*tmp_moved_constant_998) + tmp_moved_constant_784*(tmp_moved_constant_1000*tmp_moved_constant_974 + tmp_moved_constant_1002*tmp_moved_constant_975 + tmp_moved_constant_972*tmp_moved_constant_996 + tmp_moved_constant_973*tmp_moved_constant_998) + tmp_moved_constant_785*(-jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1001 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1003 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_997 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_999) + tmp_moved_constant_786*(-jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1004 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1005 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1006 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1007) + tmp_moved_constant_787*(-jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1008 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1009 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1010 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1011) + tmp_moved_constant_788*(tmp_moved_constant_1000*tmp_moved_constant_832 + tmp_moved_constant_1002*tmp_moved_constant_835 + tmp_moved_constant_826*tmp_moved_constant_996 + tmp_moved_constant_829*tmp_moved_constant_998) + tmp_moved_constant_789*(tmp_moved_constant_1000*tmp_moved_constant_844 + tmp_moved_constant_1002*tmp_moved_constant_847 + tmp_moved_constant_838*tmp_moved_constant_996 + tmp_moved_constant_841*tmp_moved_constant_998) + tmp_moved_constant_790*(tmp_moved_constant_1000*tmp_moved_constant_856 + tmp_moved_constant_1002*tmp_moved_constant_859 + tmp_moved_constant_850*tmp_moved_constant_996 + tmp_moved_constant_853*tmp_moved_constant_998) + tmp_moved_constant_791*(tmp_moved_constant_1000*tmp_moved_constant_934 + tmp_moved_constant_1002*tmp_moved_constant_935 + tmp_moved_constant_932*tmp_moved_constant_996 + tmp_moved_constant_933*tmp_moved_constant_998) + tmp_moved_constant_792*(tmp_moved_constant_1000*tmp_moved_constant_938 + tmp_moved_constant_1002*tmp_moved_constant_939 + tmp_moved_constant_936*tmp_moved_constant_996 + tmp_moved_constant_937*tmp_moved_constant_998) + tmp_moved_constant_793*(tmp_moved_constant_1000*tmp_moved_constant_942 + tmp_moved_constant_1002*tmp_moved_constant_943 + tmp_moved_constant_940*tmp_moved_constant_996 + tmp_moved_constant_941*tmp_moved_constant_998) + tmp_moved_constant_794*(tmp_moved_constant_1000*tmp_moved_constant_978 + tmp_moved_constant_1002*tmp_moved_constant_979 + tmp_moved_constant_976*tmp_moved_constant_996 + tmp_moved_constant_977*tmp_moved_constant_998) + tmp_moved_constant_795*(-jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1001 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1003 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_997 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_999) + tmp_moved_constant_796*(-jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1004 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1005 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1006 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1007) + tmp_moved_constant_797*(-jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1008 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1009 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1010 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1011) + tmp_moved_constant_798*(tmp_moved_constant_1000*tmp_moved_constant_868 + tmp_moved_constant_1002*tmp_moved_constant_871 + tmp_moved_constant_862*tmp_moved_constant_996 + tmp_moved_constant_865*tmp_moved_constant_998) + tmp_moved_constant_799*(tmp_moved_constant_1000*tmp_moved_constant_880 + tmp_moved_constant_1002*tmp_moved_constant_883 + tmp_moved_constant_874*tmp_moved_constant_996 + tmp_moved_constant_877*tmp_moved_constant_998) + tmp_moved_constant_800*(tmp_moved_constant_1000*tmp_moved_constant_892 + tmp_moved_constant_1002*tmp_moved_constant_895 + tmp_moved_constant_886*tmp_moved_constant_996 + tmp_moved_constant_889*tmp_moved_constant_998) + tmp_moved_constant_801*(tmp_moved_constant_1000*tmp_moved_constant_946 + tmp_moved_constant_1002*tmp_moved_constant_947 + tmp_moved_constant_944*tmp_moved_constant_996 + tmp_moved_constant_945*tmp_moved_constant_998) + tmp_moved_constant_802*(tmp_moved_constant_1000*tmp_moved_constant_950 + tmp_moved_constant_1002*tmp_moved_constant_951 + tmp_moved_constant_948*tmp_moved_constant_996 + tmp_moved_constant_949*tmp_moved_constant_998) + tmp_moved_constant_803*(tmp_moved_constant_1000*tmp_moved_constant_954 + tmp_moved_constant_1002*tmp_moved_constant_955 + tmp_moved_constant_952*tmp_moved_constant_996 + tmp_moved_constant_953*tmp_moved_constant_998);
                const real_t tmp_moved_constant_1031 = tmp_moved_constant_774*(tmp_moved_constant_1012*tmp_moved_constant_968 + tmp_moved_constant_1014*tmp_moved_constant_969 + tmp_moved_constant_1016*tmp_moved_constant_970 + tmp_moved_constant_1018*tmp_moved_constant_971) + tmp_moved_constant_775*(-jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1013 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1015 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1017 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1019) + tmp_moved_constant_776*(-jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1020 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1021 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1022 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1023) + tmp_moved_constant_777*(-jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1024 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1025 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1026 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1027) + tmp_moved_constant_778*(tmp_moved_constant_1012*tmp_moved_constant_898 + tmp_moved_constant_1014*tmp_moved_constant_901 + tmp_moved_constant_1016*tmp_moved_constant_904 + tmp_moved_constant_1018*tmp_moved_constant_907) + tmp_moved_constant_779*(tmp_moved_constant_1012*tmp_moved_constant_910 + tmp_moved_constant_1014*tmp_moved_constant_913 + tmp_moved_constant_1016*tmp_moved_constant_916 + tmp_moved_constant_1018*tmp_moved_constant_919) + tmp_moved_constant_780*(tmp_moved_constant_1012*tmp_moved_constant_922 + tmp_moved_constant_1014*tmp_moved_constant_925 + tmp_moved_constant_1016*tmp_moved_constant_928 + tmp_moved_constant_1018*tmp_moved_constant_931) + tmp_moved_constant_781*(tmp_moved_constant_1012*tmp_moved_constant_956 + tmp_moved_constant_1014*tmp_moved_constant_957 + tmp_moved_constant_1016*tmp_moved_constant_958 + tmp_moved_constant_1018*tmp_moved_constant_959) + tmp_moved_constant_782*(tmp_moved_constant_1012*tmp_moved_constant_960 + tmp_moved_constant_1014*tmp_moved_constant_961 + tmp_moved_constant_1016*tmp_moved_constant_962 + tmp_moved_constant_1018*tmp_moved_constant_963) + tmp_moved_constant_783*(tmp_moved_constant_1012*tmp_moved_constant_964 + tmp_moved_constant_1014*tmp_moved_constant_965 + tmp_moved_constant_1016*tmp_moved_constant_966 + tmp_moved_constant_1018*tmp_moved_constant_967) + tmp_moved_constant_784*(tmp_moved_constant_1012*tmp_moved_constant_972 + tmp_moved_constant_1014*tmp_moved_constant_973 + tmp_moved_constant_1016*tmp_moved_constant_974 + tmp_moved_constant_1018*tmp_moved_constant_975) + tmp_moved_constant_785*(-jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1013 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1015 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1017 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1019) + tmp_moved_constant_786*(-jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1020 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1021 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1022 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1023) + tmp_moved_constant_787*(-jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1024 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1025 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1026 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1027) + tmp_moved_constant_788*(tmp_moved_constant_1012*tmp_moved_constant_826 + tmp_moved_constant_1014*tmp_moved_constant_829 + tmp_moved_constant_1016*tmp_moved_constant_832 + tmp_moved_constant_1018*tmp_moved_constant_835) + tmp_moved_constant_789*(tmp_moved_constant_1012*tmp_moved_constant_838 + tmp_moved_constant_1014*tmp_moved_constant_841 + tmp_moved_constant_1016*tmp_moved_constant_844 + tmp_moved_constant_1018*tmp_moved_constant_847) + tmp_moved_constant_790*(tmp_moved_constant_1012*tmp_moved_constant_850 + tmp_moved_constant_1014*tmp_moved_constant_853 + tmp_moved_constant_1016*tmp_moved_constant_856 + tmp_moved_constant_1018*tmp_moved_constant_859) + tmp_moved_constant_791*(tmp_moved_constant_1012*tmp_moved_constant_932 + tmp_moved_constant_1014*tmp_moved_constant_933 + tmp_moved_constant_1016*tmp_moved_constant_934 + tmp_moved_constant_1018*tmp_moved_constant_935) + tmp_moved_constant_792*(tmp_moved_constant_1012*tmp_moved_constant_936 + tmp_moved_constant_1014*tmp_moved_constant_937 + tmp_moved_constant_1016*tmp_moved_constant_938 + tmp_moved_constant_1018*tmp_moved_constant_939) + tmp_moved_constant_793*(tmp_moved_constant_1012*tmp_moved_constant_940 + tmp_moved_constant_1014*tmp_moved_constant_941 + tmp_moved_constant_1016*tmp_moved_constant_942 + tmp_moved_constant_1018*tmp_moved_constant_943) + tmp_moved_constant_794*(tmp_moved_constant_1012*tmp_moved_constant_976 + tmp_moved_constant_1014*tmp_moved_constant_977 + tmp_moved_constant_1016*tmp_moved_constant_978 + tmp_moved_constant_1018*tmp_moved_constant_979) + tmp_moved_constant_795*(-jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1013 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1015 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1017 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1019) + tmp_moved_constant_796*(-jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1020 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1021 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1022 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1023) + tmp_moved_constant_797*(-jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1024 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1025 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1026 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1027) + tmp_moved_constant_798*(tmp_moved_constant_1012*tmp_moved_constant_862 + tmp_moved_constant_1014*tmp_moved_constant_865 + tmp_moved_constant_1016*tmp_moved_constant_868 + tmp_moved_constant_1018*tmp_moved_constant_871) + tmp_moved_constant_799*(tmp_moved_constant_1012*tmp_moved_constant_874 + tmp_moved_constant_1014*tmp_moved_constant_877 + tmp_moved_constant_1016*tmp_moved_constant_880 + tmp_moved_constant_1018*tmp_moved_constant_883) + tmp_moved_constant_800*(tmp_moved_constant_1012*tmp_moved_constant_886 + tmp_moved_constant_1014*tmp_moved_constant_889 + tmp_moved_constant_1016*tmp_moved_constant_892 + tmp_moved_constant_1018*tmp_moved_constant_895) + tmp_moved_constant_801*(tmp_moved_constant_1012*tmp_moved_constant_944 + tmp_moved_constant_1014*tmp_moved_constant_945 + tmp_moved_constant_1016*tmp_moved_constant_946 + tmp_moved_constant_1018*tmp_moved_constant_947) + tmp_moved_constant_802*(tmp_moved_constant_1012*tmp_moved_constant_948 + tmp_moved_constant_1014*tmp_moved_constant_949 + tmp_moved_constant_1016*tmp_moved_constant_950 + tmp_moved_constant_1018*tmp_moved_constant_951) + tmp_moved_constant_803*(tmp_moved_constant_1012*tmp_moved_constant_952 + tmp_moved_constant_1014*tmp_moved_constant_953 + tmp_moved_constant_1016*tmp_moved_constant_954 + tmp_moved_constant_1018*tmp_moved_constant_955);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_1028 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_1029 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_1030 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_1031 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   }
                }
                const real_t tmp_moved_constant_1032 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_1033 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_1034 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_1035 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_1036 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_1037 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1038 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_1039 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1040 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_1041 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1042 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_1043 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_1044 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_1045 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_1046 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_1047 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1048 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_1049 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1050 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_1051 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1052 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_1053 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_1054 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_1055 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_1056 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_1057 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1058 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_1059 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1060 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_1061 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_1286 = tmp_moved_constant_1032*(tmp_moved_constant_1063*tmp_moved_constant_1226 + tmp_moved_constant_1066*tmp_moved_constant_1227 + tmp_moved_constant_1069*tmp_moved_constant_1228 + tmp_moved_constant_1072*tmp_moved_constant_1229) + tmp_moved_constant_1033*(-jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1064 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1067 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1070 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1073) + tmp_moved_constant_1034*(-jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1074 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1075 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1076 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1077) + tmp_moved_constant_1035*(-jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1078 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1079 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1080 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1081) + tmp_moved_constant_1036*(tmp_moved_constant_1063*tmp_moved_constant_1156 + tmp_moved_constant_1066*tmp_moved_constant_1159 + tmp_moved_constant_1069*tmp_moved_constant_1162 + tmp_moved_constant_1072*tmp_moved_constant_1165) + tmp_moved_constant_1037*(tmp_moved_constant_1063*tmp_moved_constant_1168 + tmp_moved_constant_1066*tmp_moved_constant_1171 + tmp_moved_constant_1069*tmp_moved_constant_1174 + tmp_moved_constant_1072*tmp_moved_constant_1177) + tmp_moved_constant_1038*(tmp_moved_constant_1063*tmp_moved_constant_1180 + tmp_moved_constant_1066*tmp_moved_constant_1183 + tmp_moved_constant_1069*tmp_moved_constant_1186 + tmp_moved_constant_1072*tmp_moved_constant_1189) + tmp_moved_constant_1039*(tmp_moved_constant_1063*tmp_moved_constant_1214 + tmp_moved_constant_1066*tmp_moved_constant_1215 + tmp_moved_constant_1069*tmp_moved_constant_1216 + tmp_moved_constant_1072*tmp_moved_constant_1217) + tmp_moved_constant_1040*(tmp_moved_constant_1063*tmp_moved_constant_1218 + tmp_moved_constant_1066*tmp_moved_constant_1219 + tmp_moved_constant_1069*tmp_moved_constant_1220 + tmp_moved_constant_1072*tmp_moved_constant_1221) + tmp_moved_constant_1041*(tmp_moved_constant_1063*tmp_moved_constant_1222 + tmp_moved_constant_1066*tmp_moved_constant_1223 + tmp_moved_constant_1069*tmp_moved_constant_1224 + tmp_moved_constant_1072*tmp_moved_constant_1225) + tmp_moved_constant_1042*(tmp_moved_constant_1063*tmp_moved_constant_1230 + tmp_moved_constant_1066*tmp_moved_constant_1231 + tmp_moved_constant_1069*tmp_moved_constant_1232 + tmp_moved_constant_1072*tmp_moved_constant_1233) + tmp_moved_constant_1043*(-jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1064 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1067 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1070 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1073) + tmp_moved_constant_1044*(-jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1074 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1075 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1076 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1077) + tmp_moved_constant_1045*(-jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1078 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1079 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1080 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1081) + tmp_moved_constant_1046*(tmp_moved_constant_1063*tmp_moved_constant_1084 + tmp_moved_constant_1066*tmp_moved_constant_1087 + tmp_moved_constant_1069*tmp_moved_constant_1090 + tmp_moved_constant_1072*tmp_moved_constant_1093) + tmp_moved_constant_1047*(tmp_moved_constant_1063*tmp_moved_constant_1096 + tmp_moved_constant_1066*tmp_moved_constant_1099 + tmp_moved_constant_1069*tmp_moved_constant_1102 + tmp_moved_constant_1072*tmp_moved_constant_1105) + tmp_moved_constant_1048*(tmp_moved_constant_1063*tmp_moved_constant_1108 + tmp_moved_constant_1066*tmp_moved_constant_1111 + tmp_moved_constant_1069*tmp_moved_constant_1114 + tmp_moved_constant_1072*tmp_moved_constant_1117) + tmp_moved_constant_1049*(tmp_moved_constant_1063*tmp_moved_constant_1190 + tmp_moved_constant_1066*tmp_moved_constant_1191 + tmp_moved_constant_1069*tmp_moved_constant_1192 + tmp_moved_constant_1072*tmp_moved_constant_1193) + tmp_moved_constant_1050*(tmp_moved_constant_1063*tmp_moved_constant_1194 + tmp_moved_constant_1066*tmp_moved_constant_1195 + tmp_moved_constant_1069*tmp_moved_constant_1196 + tmp_moved_constant_1072*tmp_moved_constant_1197) + tmp_moved_constant_1051*(tmp_moved_constant_1063*tmp_moved_constant_1198 + tmp_moved_constant_1066*tmp_moved_constant_1199 + tmp_moved_constant_1069*tmp_moved_constant_1200 + tmp_moved_constant_1072*tmp_moved_constant_1201) + tmp_moved_constant_1052*(tmp_moved_constant_1063*tmp_moved_constant_1234 + tmp_moved_constant_1066*tmp_moved_constant_1235 + tmp_moved_constant_1069*tmp_moved_constant_1236 + tmp_moved_constant_1072*tmp_moved_constant_1237) + tmp_moved_constant_1053*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1064 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1067 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1070 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1073) + tmp_moved_constant_1054*(-jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1074 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1075 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1076 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1077) + tmp_moved_constant_1055*(-jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1078 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1079 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1080 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1081) + tmp_moved_constant_1056*(tmp_moved_constant_1063*tmp_moved_constant_1120 + tmp_moved_constant_1066*tmp_moved_constant_1123 + tmp_moved_constant_1069*tmp_moved_constant_1126 + tmp_moved_constant_1072*tmp_moved_constant_1129) + tmp_moved_constant_1057*(tmp_moved_constant_1063*tmp_moved_constant_1132 + tmp_moved_constant_1066*tmp_moved_constant_1135 + tmp_moved_constant_1069*tmp_moved_constant_1138 + tmp_moved_constant_1072*tmp_moved_constant_1141) + tmp_moved_constant_1058*(tmp_moved_constant_1063*tmp_moved_constant_1144 + tmp_moved_constant_1066*tmp_moved_constant_1147 + tmp_moved_constant_1069*tmp_moved_constant_1150 + tmp_moved_constant_1072*tmp_moved_constant_1153) + tmp_moved_constant_1059*(tmp_moved_constant_1063*tmp_moved_constant_1202 + tmp_moved_constant_1066*tmp_moved_constant_1203 + tmp_moved_constant_1069*tmp_moved_constant_1204 + tmp_moved_constant_1072*tmp_moved_constant_1205) + tmp_moved_constant_1060*(tmp_moved_constant_1063*tmp_moved_constant_1206 + tmp_moved_constant_1066*tmp_moved_constant_1207 + tmp_moved_constant_1069*tmp_moved_constant_1208 + tmp_moved_constant_1072*tmp_moved_constant_1209) + tmp_moved_constant_1061*(tmp_moved_constant_1063*tmp_moved_constant_1210 + tmp_moved_constant_1066*tmp_moved_constant_1211 + tmp_moved_constant_1069*tmp_moved_constant_1212 + tmp_moved_constant_1072*tmp_moved_constant_1213);
                const real_t tmp_moved_constant_1287 = tmp_moved_constant_1032*(tmp_moved_constant_1226*tmp_moved_constant_1238 + tmp_moved_constant_1227*tmp_moved_constant_1240 + tmp_moved_constant_1228*tmp_moved_constant_1242 + tmp_moved_constant_1229*tmp_moved_constant_1244) + tmp_moved_constant_1033*(-jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1239 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1241 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1243 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1245) + tmp_moved_constant_1034*(-jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1246 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1247 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1248 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1249) + tmp_moved_constant_1035*(-jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1250 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1251 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1252 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1253) + tmp_moved_constant_1036*(tmp_moved_constant_1156*tmp_moved_constant_1238 + tmp_moved_constant_1159*tmp_moved_constant_1240 + tmp_moved_constant_1162*tmp_moved_constant_1242 + tmp_moved_constant_1165*tmp_moved_constant_1244) + tmp_moved_constant_1037*(tmp_moved_constant_1168*tmp_moved_constant_1238 + tmp_moved_constant_1171*tmp_moved_constant_1240 + tmp_moved_constant_1174*tmp_moved_constant_1242 + tmp_moved_constant_1177*tmp_moved_constant_1244) + tmp_moved_constant_1038*(tmp_moved_constant_1180*tmp_moved_constant_1238 + tmp_moved_constant_1183*tmp_moved_constant_1240 + tmp_moved_constant_1186*tmp_moved_constant_1242 + tmp_moved_constant_1189*tmp_moved_constant_1244) + tmp_moved_constant_1039*(tmp_moved_constant_1214*tmp_moved_constant_1238 + tmp_moved_constant_1215*tmp_moved_constant_1240 + tmp_moved_constant_1216*tmp_moved_constant_1242 + tmp_moved_constant_1217*tmp_moved_constant_1244) + tmp_moved_constant_1040*(tmp_moved_constant_1218*tmp_moved_constant_1238 + tmp_moved_constant_1219*tmp_moved_constant_1240 + tmp_moved_constant_1220*tmp_moved_constant_1242 + tmp_moved_constant_1221*tmp_moved_constant_1244) + tmp_moved_constant_1041*(tmp_moved_constant_1222*tmp_moved_constant_1238 + tmp_moved_constant_1223*tmp_moved_constant_1240 + tmp_moved_constant_1224*tmp_moved_constant_1242 + tmp_moved_constant_1225*tmp_moved_constant_1244) + tmp_moved_constant_1042*(tmp_moved_constant_1230*tmp_moved_constant_1238 + tmp_moved_constant_1231*tmp_moved_constant_1240 + tmp_moved_constant_1232*tmp_moved_constant_1242 + tmp_moved_constant_1233*tmp_moved_constant_1244) + tmp_moved_constant_1043*(-jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1239 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1241 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1243 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1245) + tmp_moved_constant_1044*(-jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1246 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1247 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1248 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1249) + tmp_moved_constant_1045*(-jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1250 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1251 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1252 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1253) + tmp_moved_constant_1046*(tmp_moved_constant_1084*tmp_moved_constant_1238 + tmp_moved_constant_1087*tmp_moved_constant_1240 + tmp_moved_constant_1090*tmp_moved_constant_1242 + tmp_moved_constant_1093*tmp_moved_constant_1244) + tmp_moved_constant_1047*(tmp_moved_constant_1096*tmp_moved_constant_1238 + tmp_moved_constant_1099*tmp_moved_constant_1240 + tmp_moved_constant_1102*tmp_moved_constant_1242 + tmp_moved_constant_1105*tmp_moved_constant_1244) + tmp_moved_constant_1048*(tmp_moved_constant_1108*tmp_moved_constant_1238 + tmp_moved_constant_1111*tmp_moved_constant_1240 + tmp_moved_constant_1114*tmp_moved_constant_1242 + tmp_moved_constant_1117*tmp_moved_constant_1244) + tmp_moved_constant_1049*(tmp_moved_constant_1190*tmp_moved_constant_1238 + tmp_moved_constant_1191*tmp_moved_constant_1240 + tmp_moved_constant_1192*tmp_moved_constant_1242 + tmp_moved_constant_1193*tmp_moved_constant_1244) + tmp_moved_constant_1050*(tmp_moved_constant_1194*tmp_moved_constant_1238 + tmp_moved_constant_1195*tmp_moved_constant_1240 + tmp_moved_constant_1196*tmp_moved_constant_1242 + tmp_moved_constant_1197*tmp_moved_constant_1244) + tmp_moved_constant_1051*(tmp_moved_constant_1198*tmp_moved_constant_1238 + tmp_moved_constant_1199*tmp_moved_constant_1240 + tmp_moved_constant_1200*tmp_moved_constant_1242 + tmp_moved_constant_1201*tmp_moved_constant_1244) + tmp_moved_constant_1052*(tmp_moved_constant_1234*tmp_moved_constant_1238 + tmp_moved_constant_1235*tmp_moved_constant_1240 + tmp_moved_constant_1236*tmp_moved_constant_1242 + tmp_moved_constant_1237*tmp_moved_constant_1244) + tmp_moved_constant_1053*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1239 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1241 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1243 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1245) + tmp_moved_constant_1054*(-jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1246 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1247 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1248 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1249) + tmp_moved_constant_1055*(-jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1250 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1251 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1252 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1253) + tmp_moved_constant_1056*(tmp_moved_constant_1120*tmp_moved_constant_1238 + tmp_moved_constant_1123*tmp_moved_constant_1240 + tmp_moved_constant_1126*tmp_moved_constant_1242 + tmp_moved_constant_1129*tmp_moved_constant_1244) + tmp_moved_constant_1057*(tmp_moved_constant_1132*tmp_moved_constant_1238 + tmp_moved_constant_1135*tmp_moved_constant_1240 + tmp_moved_constant_1138*tmp_moved_constant_1242 + tmp_moved_constant_1141*tmp_moved_constant_1244) + tmp_moved_constant_1058*(tmp_moved_constant_1144*tmp_moved_constant_1238 + tmp_moved_constant_1147*tmp_moved_constant_1240 + tmp_moved_constant_1150*tmp_moved_constant_1242 + tmp_moved_constant_1153*tmp_moved_constant_1244) + tmp_moved_constant_1059*(tmp_moved_constant_1202*tmp_moved_constant_1238 + tmp_moved_constant_1203*tmp_moved_constant_1240 + tmp_moved_constant_1204*tmp_moved_constant_1242 + tmp_moved_constant_1205*tmp_moved_constant_1244) + tmp_moved_constant_1060*(tmp_moved_constant_1206*tmp_moved_constant_1238 + tmp_moved_constant_1207*tmp_moved_constant_1240 + tmp_moved_constant_1208*tmp_moved_constant_1242 + tmp_moved_constant_1209*tmp_moved_constant_1244) + tmp_moved_constant_1061*(tmp_moved_constant_1210*tmp_moved_constant_1238 + tmp_moved_constant_1211*tmp_moved_constant_1240 + tmp_moved_constant_1212*tmp_moved_constant_1242 + tmp_moved_constant_1213*tmp_moved_constant_1244);
                const real_t tmp_moved_constant_1288 = tmp_moved_constant_1032*(tmp_moved_constant_1226*tmp_moved_constant_1254 + tmp_moved_constant_1227*tmp_moved_constant_1256 + tmp_moved_constant_1228*tmp_moved_constant_1258 + tmp_moved_constant_1229*tmp_moved_constant_1260) + tmp_moved_constant_1033*(-jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1255 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1257 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1259 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1261) + tmp_moved_constant_1034*(-jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1262 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1263 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1264 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1265) + tmp_moved_constant_1035*(-jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1266 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1267 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1268 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1269) + tmp_moved_constant_1036*(tmp_moved_constant_1156*tmp_moved_constant_1254 + tmp_moved_constant_1159*tmp_moved_constant_1256 + tmp_moved_constant_1162*tmp_moved_constant_1258 + tmp_moved_constant_1165*tmp_moved_constant_1260) + tmp_moved_constant_1037*(tmp_moved_constant_1168*tmp_moved_constant_1254 + tmp_moved_constant_1171*tmp_moved_constant_1256 + tmp_moved_constant_1174*tmp_moved_constant_1258 + tmp_moved_constant_1177*tmp_moved_constant_1260) + tmp_moved_constant_1038*(tmp_moved_constant_1180*tmp_moved_constant_1254 + tmp_moved_constant_1183*tmp_moved_constant_1256 + tmp_moved_constant_1186*tmp_moved_constant_1258 + tmp_moved_constant_1189*tmp_moved_constant_1260) + tmp_moved_constant_1039*(tmp_moved_constant_1214*tmp_moved_constant_1254 + tmp_moved_constant_1215*tmp_moved_constant_1256 + tmp_moved_constant_1216*tmp_moved_constant_1258 + tmp_moved_constant_1217*tmp_moved_constant_1260) + tmp_moved_constant_1040*(tmp_moved_constant_1218*tmp_moved_constant_1254 + tmp_moved_constant_1219*tmp_moved_constant_1256 + tmp_moved_constant_1220*tmp_moved_constant_1258 + tmp_moved_constant_1221*tmp_moved_constant_1260) + tmp_moved_constant_1041*(tmp_moved_constant_1222*tmp_moved_constant_1254 + tmp_moved_constant_1223*tmp_moved_constant_1256 + tmp_moved_constant_1224*tmp_moved_constant_1258 + tmp_moved_constant_1225*tmp_moved_constant_1260) + tmp_moved_constant_1042*(tmp_moved_constant_1230*tmp_moved_constant_1254 + tmp_moved_constant_1231*tmp_moved_constant_1256 + tmp_moved_constant_1232*tmp_moved_constant_1258 + tmp_moved_constant_1233*tmp_moved_constant_1260) + tmp_moved_constant_1043*(-jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1255 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1257 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1259 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1261) + tmp_moved_constant_1044*(-jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1262 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1263 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1264 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1265) + tmp_moved_constant_1045*(-jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1266 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1267 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1268 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1269) + tmp_moved_constant_1046*(tmp_moved_constant_1084*tmp_moved_constant_1254 + tmp_moved_constant_1087*tmp_moved_constant_1256 + tmp_moved_constant_1090*tmp_moved_constant_1258 + tmp_moved_constant_1093*tmp_moved_constant_1260) + tmp_moved_constant_1047*(tmp_moved_constant_1096*tmp_moved_constant_1254 + tmp_moved_constant_1099*tmp_moved_constant_1256 + tmp_moved_constant_1102*tmp_moved_constant_1258 + tmp_moved_constant_1105*tmp_moved_constant_1260) + tmp_moved_constant_1048*(tmp_moved_constant_1108*tmp_moved_constant_1254 + tmp_moved_constant_1111*tmp_moved_constant_1256 + tmp_moved_constant_1114*tmp_moved_constant_1258 + tmp_moved_constant_1117*tmp_moved_constant_1260) + tmp_moved_constant_1049*(tmp_moved_constant_1190*tmp_moved_constant_1254 + tmp_moved_constant_1191*tmp_moved_constant_1256 + tmp_moved_constant_1192*tmp_moved_constant_1258 + tmp_moved_constant_1193*tmp_moved_constant_1260) + tmp_moved_constant_1050*(tmp_moved_constant_1194*tmp_moved_constant_1254 + tmp_moved_constant_1195*tmp_moved_constant_1256 + tmp_moved_constant_1196*tmp_moved_constant_1258 + tmp_moved_constant_1197*tmp_moved_constant_1260) + tmp_moved_constant_1051*(tmp_moved_constant_1198*tmp_moved_constant_1254 + tmp_moved_constant_1199*tmp_moved_constant_1256 + tmp_moved_constant_1200*tmp_moved_constant_1258 + tmp_moved_constant_1201*tmp_moved_constant_1260) + tmp_moved_constant_1052*(tmp_moved_constant_1234*tmp_moved_constant_1254 + tmp_moved_constant_1235*tmp_moved_constant_1256 + tmp_moved_constant_1236*tmp_moved_constant_1258 + tmp_moved_constant_1237*tmp_moved_constant_1260) + tmp_moved_constant_1053*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1255 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1257 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1259 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1261) + tmp_moved_constant_1054*(-jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1262 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1263 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1264 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1265) + tmp_moved_constant_1055*(-jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1266 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1267 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1268 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1269) + tmp_moved_constant_1056*(tmp_moved_constant_1120*tmp_moved_constant_1254 + tmp_moved_constant_1123*tmp_moved_constant_1256 + tmp_moved_constant_1126*tmp_moved_constant_1258 + tmp_moved_constant_1129*tmp_moved_constant_1260) + tmp_moved_constant_1057*(tmp_moved_constant_1132*tmp_moved_constant_1254 + tmp_moved_constant_1135*tmp_moved_constant_1256 + tmp_moved_constant_1138*tmp_moved_constant_1258 + tmp_moved_constant_1141*tmp_moved_constant_1260) + tmp_moved_constant_1058*(tmp_moved_constant_1144*tmp_moved_constant_1254 + tmp_moved_constant_1147*tmp_moved_constant_1256 + tmp_moved_constant_1150*tmp_moved_constant_1258 + tmp_moved_constant_1153*tmp_moved_constant_1260) + tmp_moved_constant_1059*(tmp_moved_constant_1202*tmp_moved_constant_1254 + tmp_moved_constant_1203*tmp_moved_constant_1256 + tmp_moved_constant_1204*tmp_moved_constant_1258 + tmp_moved_constant_1205*tmp_moved_constant_1260) + tmp_moved_constant_1060*(tmp_moved_constant_1206*tmp_moved_constant_1254 + tmp_moved_constant_1207*tmp_moved_constant_1256 + tmp_moved_constant_1208*tmp_moved_constant_1258 + tmp_moved_constant_1209*tmp_moved_constant_1260) + tmp_moved_constant_1061*(tmp_moved_constant_1210*tmp_moved_constant_1254 + tmp_moved_constant_1211*tmp_moved_constant_1256 + tmp_moved_constant_1212*tmp_moved_constant_1258 + tmp_moved_constant_1213*tmp_moved_constant_1260);
                const real_t tmp_moved_constant_1289 = tmp_moved_constant_1032*(tmp_moved_constant_1226*tmp_moved_constant_1270 + tmp_moved_constant_1227*tmp_moved_constant_1272 + tmp_moved_constant_1228*tmp_moved_constant_1274 + tmp_moved_constant_1229*tmp_moved_constant_1276) + tmp_moved_constant_1033*(-jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1271 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1273 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1275 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1277) + tmp_moved_constant_1034*(-jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1278 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1279 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1280 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1281) + tmp_moved_constant_1035*(-jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1282 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1283 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1284 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1285) + tmp_moved_constant_1036*(tmp_moved_constant_1156*tmp_moved_constant_1270 + tmp_moved_constant_1159*tmp_moved_constant_1272 + tmp_moved_constant_1162*tmp_moved_constant_1274 + tmp_moved_constant_1165*tmp_moved_constant_1276) + tmp_moved_constant_1037*(tmp_moved_constant_1168*tmp_moved_constant_1270 + tmp_moved_constant_1171*tmp_moved_constant_1272 + tmp_moved_constant_1174*tmp_moved_constant_1274 + tmp_moved_constant_1177*tmp_moved_constant_1276) + tmp_moved_constant_1038*(tmp_moved_constant_1180*tmp_moved_constant_1270 + tmp_moved_constant_1183*tmp_moved_constant_1272 + tmp_moved_constant_1186*tmp_moved_constant_1274 + tmp_moved_constant_1189*tmp_moved_constant_1276) + tmp_moved_constant_1039*(tmp_moved_constant_1214*tmp_moved_constant_1270 + tmp_moved_constant_1215*tmp_moved_constant_1272 + tmp_moved_constant_1216*tmp_moved_constant_1274 + tmp_moved_constant_1217*tmp_moved_constant_1276) + tmp_moved_constant_1040*(tmp_moved_constant_1218*tmp_moved_constant_1270 + tmp_moved_constant_1219*tmp_moved_constant_1272 + tmp_moved_constant_1220*tmp_moved_constant_1274 + tmp_moved_constant_1221*tmp_moved_constant_1276) + tmp_moved_constant_1041*(tmp_moved_constant_1222*tmp_moved_constant_1270 + tmp_moved_constant_1223*tmp_moved_constant_1272 + tmp_moved_constant_1224*tmp_moved_constant_1274 + tmp_moved_constant_1225*tmp_moved_constant_1276) + tmp_moved_constant_1042*(tmp_moved_constant_1230*tmp_moved_constant_1270 + tmp_moved_constant_1231*tmp_moved_constant_1272 + tmp_moved_constant_1232*tmp_moved_constant_1274 + tmp_moved_constant_1233*tmp_moved_constant_1276) + tmp_moved_constant_1043*(-jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1271 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1273 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1275 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1277) + tmp_moved_constant_1044*(-jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1278 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1279 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1280 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1281) + tmp_moved_constant_1045*(-jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1282 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1283 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1284 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1285) + tmp_moved_constant_1046*(tmp_moved_constant_1084*tmp_moved_constant_1270 + tmp_moved_constant_1087*tmp_moved_constant_1272 + tmp_moved_constant_1090*tmp_moved_constant_1274 + tmp_moved_constant_1093*tmp_moved_constant_1276) + tmp_moved_constant_1047*(tmp_moved_constant_1096*tmp_moved_constant_1270 + tmp_moved_constant_1099*tmp_moved_constant_1272 + tmp_moved_constant_1102*tmp_moved_constant_1274 + tmp_moved_constant_1105*tmp_moved_constant_1276) + tmp_moved_constant_1048*(tmp_moved_constant_1108*tmp_moved_constant_1270 + tmp_moved_constant_1111*tmp_moved_constant_1272 + tmp_moved_constant_1114*tmp_moved_constant_1274 + tmp_moved_constant_1117*tmp_moved_constant_1276) + tmp_moved_constant_1049*(tmp_moved_constant_1190*tmp_moved_constant_1270 + tmp_moved_constant_1191*tmp_moved_constant_1272 + tmp_moved_constant_1192*tmp_moved_constant_1274 + tmp_moved_constant_1193*tmp_moved_constant_1276) + tmp_moved_constant_1050*(tmp_moved_constant_1194*tmp_moved_constant_1270 + tmp_moved_constant_1195*tmp_moved_constant_1272 + tmp_moved_constant_1196*tmp_moved_constant_1274 + tmp_moved_constant_1197*tmp_moved_constant_1276) + tmp_moved_constant_1051*(tmp_moved_constant_1198*tmp_moved_constant_1270 + tmp_moved_constant_1199*tmp_moved_constant_1272 + tmp_moved_constant_1200*tmp_moved_constant_1274 + tmp_moved_constant_1201*tmp_moved_constant_1276) + tmp_moved_constant_1052*(tmp_moved_constant_1234*tmp_moved_constant_1270 + tmp_moved_constant_1235*tmp_moved_constant_1272 + tmp_moved_constant_1236*tmp_moved_constant_1274 + tmp_moved_constant_1237*tmp_moved_constant_1276) + tmp_moved_constant_1053*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1271 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1273 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1275 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1277) + tmp_moved_constant_1054*(-jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1278 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1279 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1280 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1281) + tmp_moved_constant_1055*(-jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1282 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1283 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1284 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1285) + tmp_moved_constant_1056*(tmp_moved_constant_1120*tmp_moved_constant_1270 + tmp_moved_constant_1123*tmp_moved_constant_1272 + tmp_moved_constant_1126*tmp_moved_constant_1274 + tmp_moved_constant_1129*tmp_moved_constant_1276) + tmp_moved_constant_1057*(tmp_moved_constant_1132*tmp_moved_constant_1270 + tmp_moved_constant_1135*tmp_moved_constant_1272 + tmp_moved_constant_1138*tmp_moved_constant_1274 + tmp_moved_constant_1141*tmp_moved_constant_1276) + tmp_moved_constant_1058*(tmp_moved_constant_1144*tmp_moved_constant_1270 + tmp_moved_constant_1147*tmp_moved_constant_1272 + tmp_moved_constant_1150*tmp_moved_constant_1274 + tmp_moved_constant_1153*tmp_moved_constant_1276) + tmp_moved_constant_1059*(tmp_moved_constant_1202*tmp_moved_constant_1270 + tmp_moved_constant_1203*tmp_moved_constant_1272 + tmp_moved_constant_1204*tmp_moved_constant_1274 + tmp_moved_constant_1205*tmp_moved_constant_1276) + tmp_moved_constant_1060*(tmp_moved_constant_1206*tmp_moved_constant_1270 + tmp_moved_constant_1207*tmp_moved_constant_1272 + tmp_moved_constant_1208*tmp_moved_constant_1274 + tmp_moved_constant_1209*tmp_moved_constant_1276) + tmp_moved_constant_1061*(tmp_moved_constant_1210*tmp_moved_constant_1270 + tmp_moved_constant_1211*tmp_moved_constant_1272 + tmp_moved_constant_1212*tmp_moved_constant_1274 + tmp_moved_constant_1213*tmp_moved_constant_1276);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_1286 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_1287 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_1288 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_1289 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   }
                }
             }
          }
          {
             for (int64_t ctr_0 = -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
                if (-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2 >= 0)
                {
                   const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_kernel_op_0 = 0.55278640450004202;
                   const real_t tmp_kernel_op_1 = tmp_kernel_op_0 - 1.0;
                   const real_t tmp_kernel_op_2 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
                   const real_t tmp_kernel_op_3 = tmp_kernel_op_2*0.13819660112501053;
                   const real_t tmp_kernel_op_4 = tmp_kernel_op_1*tmp_kernel_op_3;
                   const real_t tmp_kernel_op_5 = 0.55278640450004202;
                   const real_t tmp_kernel_op_6 = tmp_kernel_op_5 - 1.0;
                   const real_t tmp_kernel_op_7 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
                   const real_t tmp_kernel_op_8 = tmp_kernel_op_7*0.13819660112501056;
                   const real_t tmp_kernel_op_9 = tmp_kernel_op_6*tmp_kernel_op_8;
                   const real_t tmp_kernel_op_10 = 2.3416407864998736;
                   const real_t tmp_kernel_op_11 = tmp_kernel_op_10 - 1.0;
                   const real_t tmp_kernel_op_12 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
                   const real_t tmp_kernel_op_13 = tmp_kernel_op_12*0.13819660112501056;
                   const real_t tmp_kernel_op_14 = tmp_kernel_op_11*tmp_kernel_op_13;
                   const real_t tmp_kernel_op_15 = 0.55278640450004202;
                   const real_t tmp_kernel_op_16 = tmp_kernel_op_15 - 1.0;
                   const real_t tmp_kernel_op_17 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
                   const real_t tmp_kernel_op_18 = tmp_kernel_op_17*0.5854101966249684;
                   const real_t tmp_kernel_op_19 = tmp_kernel_op_16*tmp_kernel_op_18;
                   const real_t tmp_kernel_op_20 = 0.55278640450004202;
                   const real_t tmp_kernel_op_21 = tmp_kernel_op_20 - 1.0;
                   const real_t tmp_kernel_op_22 = tmp_kernel_op_21*tmp_kernel_op_3;
                   const real_t tmp_kernel_op_23 = 2.3416407864998736;
                   const real_t tmp_kernel_op_24 = tmp_kernel_op_23 - 1.0;
                   const real_t tmp_kernel_op_25 = tmp_kernel_op_24*tmp_kernel_op_8;
                   const real_t tmp_kernel_op_26 = 0.55278640450004202;
                   const real_t tmp_kernel_op_27 = tmp_kernel_op_26 - 1.0;
                   const real_t tmp_kernel_op_28 = tmp_kernel_op_13*tmp_kernel_op_27;
                   const real_t tmp_kernel_op_29 = 0.55278640450004202;
                   const real_t tmp_kernel_op_30 = tmp_kernel_op_29 - 1.0;
                   const real_t tmp_kernel_op_31 = tmp_kernel_op_18*tmp_kernel_op_30;
                   const real_t tmp_kernel_op_32 = 2.3416407864998736;
                   const real_t tmp_kernel_op_33 = tmp_kernel_op_32 - 1.0;
                   const real_t tmp_kernel_op_34 = tmp_kernel_op_3*tmp_kernel_op_33;
                   const real_t tmp_kernel_op_35 = 0.55278640450004202;
                   const real_t tmp_kernel_op_36 = tmp_kernel_op_35 - 1.0;
                   const real_t tmp_kernel_op_37 = tmp_kernel_op_36*tmp_kernel_op_8;
                   const real_t tmp_kernel_op_38 = 0.55278640450004202;
                   const real_t tmp_kernel_op_39 = tmp_kernel_op_38 - 1.0;
                   const real_t tmp_kernel_op_40 = tmp_kernel_op_13*tmp_kernel_op_39;
                   const real_t tmp_kernel_op_41 = 0.55278640450004202;
                   const real_t tmp_kernel_op_42 = tmp_kernel_op_41 - 1.0;
                   const real_t tmp_kernel_op_43 = tmp_kernel_op_18*tmp_kernel_op_42;
                   const real_t tmp_kernel_op_44 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_32;
                   const real_t tmp_kernel_op_45 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_20;
                   const real_t tmp_kernel_op_46 = -tmp_kernel_op_44 - tmp_kernel_op_45;
                   const real_t tmp_kernel_op_47 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_35;
                   const real_t tmp_kernel_op_48 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_23;
                   const real_t tmp_kernel_op_49 = -tmp_kernel_op_47 - tmp_kernel_op_48;
                   const real_t tmp_kernel_op_50 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_38;
                   const real_t tmp_kernel_op_51 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_26;
                   const real_t tmp_kernel_op_52 = -tmp_kernel_op_50 - tmp_kernel_op_51;
                   const real_t tmp_kernel_op_53 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_41;
                   const real_t tmp_kernel_op_54 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_29;
                   const real_t tmp_kernel_op_55 = -tmp_kernel_op_53 - tmp_kernel_op_54;
                   const real_t tmp_kernel_op_56 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_32;
                   const real_t tmp_kernel_op_57 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_0;
                   const real_t tmp_kernel_op_58 = -tmp_kernel_op_56 - tmp_kernel_op_57;
                   const real_t tmp_kernel_op_59 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_35;
                   const real_t tmp_kernel_op_60 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_5;
                   const real_t tmp_kernel_op_61 = -tmp_kernel_op_59 - tmp_kernel_op_60;
                   const real_t tmp_kernel_op_62 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_38;
                   const real_t tmp_kernel_op_63 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_10;
                   const real_t tmp_kernel_op_64 = -tmp_kernel_op_62 - tmp_kernel_op_63;
                   const real_t tmp_kernel_op_65 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_41;
                   const real_t tmp_kernel_op_66 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_15;
                   const real_t tmp_kernel_op_67 = -tmp_kernel_op_65 - tmp_kernel_op_66;
                   const real_t tmp_kernel_op_68 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_20;
                   const real_t tmp_kernel_op_69 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_0;
                   const real_t tmp_kernel_op_70 = -tmp_kernel_op_68 - tmp_kernel_op_69;
                   const real_t tmp_kernel_op_71 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_23;
                   const real_t tmp_kernel_op_72 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_5;
                   const real_t tmp_kernel_op_73 = -tmp_kernel_op_71 - tmp_kernel_op_72;
                   const real_t tmp_kernel_op_74 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_26;
                   const real_t tmp_kernel_op_75 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_10;
                   const real_t tmp_kernel_op_76 = -tmp_kernel_op_74 - tmp_kernel_op_75;
                   const real_t tmp_kernel_op_77 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_29;
                   const real_t tmp_kernel_op_78 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_15;
                   const real_t tmp_kernel_op_79 = -tmp_kernel_op_77 - tmp_kernel_op_78;
                   const real_t tmp_kernel_op_80 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_32;
                   const real_t tmp_kernel_op_81 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_20;
                   const real_t tmp_kernel_op_82 = -tmp_kernel_op_80 - tmp_kernel_op_81;
                   const real_t tmp_kernel_op_83 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_35;
                   const real_t tmp_kernel_op_84 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_23;
                   const real_t tmp_kernel_op_85 = -tmp_kernel_op_83 - tmp_kernel_op_84;
                   const real_t tmp_kernel_op_86 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_38;
                   const real_t tmp_kernel_op_87 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_26;
                   const real_t tmp_kernel_op_88 = -tmp_kernel_op_86 - tmp_kernel_op_87;
                   const real_t tmp_kernel_op_89 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_41;
                   const real_t tmp_kernel_op_90 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_29;
                   const real_t tmp_kernel_op_91 = -tmp_kernel_op_89 - tmp_kernel_op_90;
                   const real_t tmp_kernel_op_92 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_32;
                   const real_t tmp_kernel_op_93 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_0;
                   const real_t tmp_kernel_op_94 = -tmp_kernel_op_92 - tmp_kernel_op_93;
                   const real_t tmp_kernel_op_95 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_35;
                   const real_t tmp_kernel_op_96 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_5;
                   const real_t tmp_kernel_op_97 = -tmp_kernel_op_95 - tmp_kernel_op_96;
                   const real_t tmp_kernel_op_98 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_38;
                   const real_t tmp_kernel_op_99 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_10;
                   const real_t tmp_kernel_op_100 = -tmp_kernel_op_98 - tmp_kernel_op_99;
                   const real_t tmp_kernel_op_101 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_41;
                   const real_t tmp_kernel_op_102 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_15;
                   const real_t tmp_kernel_op_103 = -tmp_kernel_op_101 - tmp_kernel_op_102;
                   const real_t tmp_kernel_op_104 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_20;
                   const real_t tmp_kernel_op_105 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_0;
                   const real_t tmp_kernel_op_106 = -tmp_kernel_op_104 - tmp_kernel_op_105;
                   const real_t tmp_kernel_op_107 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_23;
                   const real_t tmp_kernel_op_108 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_5;
                   const real_t tmp_kernel_op_109 = -tmp_kernel_op_107 - tmp_kernel_op_108;
                   const real_t tmp_kernel_op_110 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_26;
                   const real_t tmp_kernel_op_111 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_10;
                   const real_t tmp_kernel_op_112 = -tmp_kernel_op_110 - tmp_kernel_op_111;
                   const real_t tmp_kernel_op_113 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_29;
                   const real_t tmp_kernel_op_114 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_15;
                   const real_t tmp_kernel_op_115 = -tmp_kernel_op_113 - tmp_kernel_op_114;
                   const real_t tmp_kernel_op_116 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_32;
                   const real_t tmp_kernel_op_117 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_20;
                   const real_t tmp_kernel_op_118 = -tmp_kernel_op_116 - tmp_kernel_op_117;
                   const real_t tmp_kernel_op_119 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_35;
                   const real_t tmp_kernel_op_120 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_23;
                   const real_t tmp_kernel_op_121 = -tmp_kernel_op_119 - tmp_kernel_op_120;
                   const real_t tmp_kernel_op_122 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_38;
                   const real_t tmp_kernel_op_123 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_26;
                   const real_t tmp_kernel_op_124 = -tmp_kernel_op_122 - tmp_kernel_op_123;
                   const real_t tmp_kernel_op_125 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_41;
                   const real_t tmp_kernel_op_126 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_29;
                   const real_t tmp_kernel_op_127 = -tmp_kernel_op_125 - tmp_kernel_op_126;
                   const real_t tmp_kernel_op_128 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_32;
                   const real_t tmp_kernel_op_129 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_0;
                   const real_t tmp_kernel_op_130 = -tmp_kernel_op_128 - tmp_kernel_op_129;
                   const real_t tmp_kernel_op_131 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_35;
                   const real_t tmp_kernel_op_132 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_5;
                   const real_t tmp_kernel_op_133 = -tmp_kernel_op_131 - tmp_kernel_op_132;
                   const real_t tmp_kernel_op_134 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_38;
                   const real_t tmp_kernel_op_135 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_10;
                   const real_t tmp_kernel_op_136 = -tmp_kernel_op_134 - tmp_kernel_op_135;
                   const real_t tmp_kernel_op_137 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_41;
                   const real_t tmp_kernel_op_138 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_15;
                   const real_t tmp_kernel_op_139 = -tmp_kernel_op_137 - tmp_kernel_op_138;
                   const real_t tmp_kernel_op_140 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_20;
                   const real_t tmp_kernel_op_141 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_0;
                   const real_t tmp_kernel_op_142 = -tmp_kernel_op_140 - tmp_kernel_op_141;
                   const real_t tmp_kernel_op_143 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_23;
                   const real_t tmp_kernel_op_144 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_5;
                   const real_t tmp_kernel_op_145 = -tmp_kernel_op_143 - tmp_kernel_op_144;
                   const real_t tmp_kernel_op_146 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_26;
                   const real_t tmp_kernel_op_147 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_10;
                   const real_t tmp_kernel_op_148 = -tmp_kernel_op_146 - tmp_kernel_op_147;
                   const real_t tmp_kernel_op_149 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_29;
                   const real_t tmp_kernel_op_150 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_15;
                   const real_t tmp_kernel_op_151 = -tmp_kernel_op_149 - tmp_kernel_op_150;
                   const real_t tmp_kernel_op_152 = tmp_kernel_op_0 + tmp_kernel_op_20;
                   const real_t tmp_kernel_op_153 = -tmp_kernel_op_152 - 0.68328157299974723;
                   const real_t tmp_kernel_op_154 = -jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_153 + tmp_kernel_op_44 + tmp_kernel_op_56;
                   const real_t tmp_kernel_op_155 = tmp_kernel_op_23 + tmp_kernel_op_5;
                   const real_t tmp_kernel_op_156 = -tmp_kernel_op_155 + 2.8944271909999157;
                   const real_t tmp_kernel_op_157 = -jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_156 + tmp_kernel_op_47 + tmp_kernel_op_59;
                   const real_t tmp_kernel_op_158 = tmp_kernel_op_10 + tmp_kernel_op_26;
                   const real_t tmp_kernel_op_159 = -tmp_kernel_op_158 + 2.8944271909999157;
                   const real_t tmp_kernel_op_160 = -jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_159 + tmp_kernel_op_50 + tmp_kernel_op_62;
                   const real_t tmp_kernel_op_161 = tmp_kernel_op_15 + tmp_kernel_op_29;
                   const real_t tmp_kernel_op_162 = -tmp_kernel_op_161 + 2.8944271909999157;
                   const real_t tmp_kernel_op_163 = -jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_162 + tmp_kernel_op_53 + tmp_kernel_op_65;
                   const real_t tmp_kernel_op_164 = tmp_kernel_op_32 - 4.0;
                   const real_t tmp_kernel_op_165 = -tmp_kernel_op_0 - tmp_kernel_op_164 - 1.105572809000084;
                   const real_t tmp_kernel_op_166 = -jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_165 + tmp_kernel_op_45 + tmp_kernel_op_68;
                   const real_t tmp_kernel_op_167 = tmp_kernel_op_35 - 4.0;
                   const real_t tmp_kernel_op_168 = -tmp_kernel_op_167 - tmp_kernel_op_5 - 4.6832815729997472;
                   const real_t tmp_kernel_op_169 = -jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_168 + tmp_kernel_op_48 + tmp_kernel_op_71;
                   const real_t tmp_kernel_op_170 = tmp_kernel_op_38 - 4.0;
                   const real_t tmp_kernel_op_171 = -tmp_kernel_op_10 - tmp_kernel_op_170 - 1.105572809000084;
                   const real_t tmp_kernel_op_172 = -jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_171 + tmp_kernel_op_51 + tmp_kernel_op_74;
                   const real_t tmp_kernel_op_173 = tmp_kernel_op_41 - 4.0;
                   const real_t tmp_kernel_op_174 = -tmp_kernel_op_15 - tmp_kernel_op_173 - 1.105572809000084;
                   const real_t tmp_kernel_op_175 = -jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_174 + tmp_kernel_op_54 + tmp_kernel_op_77;
                   const real_t tmp_kernel_op_176 = -tmp_kernel_op_164 - tmp_kernel_op_20 - 1.105572809000084;
                   const real_t tmp_kernel_op_177 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_176 + tmp_kernel_op_57 + tmp_kernel_op_69;
                   const real_t tmp_kernel_op_178 = -tmp_kernel_op_167 - tmp_kernel_op_23 - 1.105572809000084;
                   const real_t tmp_kernel_op_179 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_178 + tmp_kernel_op_60 + tmp_kernel_op_72;
                   const real_t tmp_kernel_op_180 = -tmp_kernel_op_170 - tmp_kernel_op_26 - 4.6832815729997472;
                   const real_t tmp_kernel_op_181 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_180 + tmp_kernel_op_63 + tmp_kernel_op_75;
                   const real_t tmp_kernel_op_182 = -tmp_kernel_op_173 - tmp_kernel_op_29 - 1.105572809000084;
                   const real_t tmp_kernel_op_183 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_182 + tmp_kernel_op_66 + tmp_kernel_op_78;
                   const real_t tmp_kernel_op_184 = -jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_153 + tmp_kernel_op_80 + tmp_kernel_op_92;
                   const real_t tmp_kernel_op_185 = -jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_156 + tmp_kernel_op_83 + tmp_kernel_op_95;
                   const real_t tmp_kernel_op_186 = -jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_159 + tmp_kernel_op_86 + tmp_kernel_op_98;
                   const real_t tmp_kernel_op_187 = -jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_162 + tmp_kernel_op_101 + tmp_kernel_op_89;
                   const real_t tmp_kernel_op_188 = -jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_165 + tmp_kernel_op_104 + tmp_kernel_op_81;
                   const real_t tmp_kernel_op_189 = -jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_168 + tmp_kernel_op_107 + tmp_kernel_op_84;
                   const real_t tmp_kernel_op_190 = -jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_171 + tmp_kernel_op_110 + tmp_kernel_op_87;
                   const real_t tmp_kernel_op_191 = -jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_174 + tmp_kernel_op_113 + tmp_kernel_op_90;
                   const real_t tmp_kernel_op_192 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_176 + tmp_kernel_op_105 + tmp_kernel_op_93;
                   const real_t tmp_kernel_op_193 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_178 + tmp_kernel_op_108 + tmp_kernel_op_96;
                   const real_t tmp_kernel_op_194 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_180 + tmp_kernel_op_111 + tmp_kernel_op_99;
                   const real_t tmp_kernel_op_195 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_182 + tmp_kernel_op_102 + tmp_kernel_op_114;
                   const real_t tmp_kernel_op_196 = -jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_153 + tmp_kernel_op_116 + tmp_kernel_op_128;
                   const real_t tmp_kernel_op_197 = -jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_156 + tmp_kernel_op_119 + tmp_kernel_op_131;
                   const real_t tmp_kernel_op_198 = -jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_159 + tmp_kernel_op_122 + tmp_kernel_op_134;
                   const real_t tmp_kernel_op_199 = -jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_162 + tmp_kernel_op_125 + tmp_kernel_op_137;
                   const real_t tmp_kernel_op_200 = -jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_165 + tmp_kernel_op_117 + tmp_kernel_op_140;
                   const real_t tmp_kernel_op_201 = -jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_168 + tmp_kernel_op_120 + tmp_kernel_op_143;
                   const real_t tmp_kernel_op_202 = -jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_171 + tmp_kernel_op_123 + tmp_kernel_op_146;
                   const real_t tmp_kernel_op_203 = -jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_174 + tmp_kernel_op_126 + tmp_kernel_op_149;
                   const real_t tmp_kernel_op_204 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_176 + tmp_kernel_op_129 + tmp_kernel_op_141;
                   const real_t tmp_kernel_op_205 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_178 + tmp_kernel_op_132 + tmp_kernel_op_144;
                   const real_t tmp_kernel_op_206 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_180 + tmp_kernel_op_135 + tmp_kernel_op_147;
                   const real_t tmp_kernel_op_207 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_182 + tmp_kernel_op_138 + tmp_kernel_op_150;
                   const real_t tmp_kernel_op_208 = tmp_kernel_op_152 + tmp_kernel_op_32 - 3.0;
                   const real_t tmp_kernel_op_209 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_208;
                   const real_t tmp_kernel_op_210 = tmp_kernel_op_155 + tmp_kernel_op_35 - 3.0;
                   const real_t tmp_kernel_op_211 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_210;
                   const real_t tmp_kernel_op_212 = tmp_kernel_op_158 + tmp_kernel_op_38 - 3.0;
                   const real_t tmp_kernel_op_213 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_212;
                   const real_t tmp_kernel_op_214 = tmp_kernel_op_161 + tmp_kernel_op_41 - 3.0;
                   const real_t tmp_kernel_op_215 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_214;
                   const real_t tmp_kernel_op_216 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_208;
                   const real_t tmp_kernel_op_217 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_210;
                   const real_t tmp_kernel_op_218 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_212;
                   const real_t tmp_kernel_op_219 = -jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_214;
                   const real_t tmp_kernel_op_220 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_208 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_208;
                   const real_t tmp_kernel_op_221 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_210 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_210;
                   const real_t tmp_kernel_op_222 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_212 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_212;
                   const real_t tmp_kernel_op_223 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_214 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_214;
                   const real_t tmp_kernel_op_224 = tmp_kernel_op_2*0.1381966011250105;
                   const real_t tmp_kernel_op_225 = tmp_kernel_op_1*tmp_kernel_op_224;
                   const real_t tmp_kernel_op_226 = tmp_kernel_op_7*0.1381966011250105;
                   const real_t tmp_kernel_op_227 = tmp_kernel_op_226*tmp_kernel_op_6;
                   const real_t tmp_kernel_op_228 = tmp_kernel_op_12*0.5854101966249684;
                   const real_t tmp_kernel_op_229 = tmp_kernel_op_11*tmp_kernel_op_228;
                   const real_t tmp_kernel_op_230 = tmp_kernel_op_17*0.1381966011250105;
                   const real_t tmp_kernel_op_231 = tmp_kernel_op_16*tmp_kernel_op_230;
                   const real_t tmp_kernel_op_232 = tmp_kernel_op_21*tmp_kernel_op_224;
                   const real_t tmp_kernel_op_233 = tmp_kernel_op_226*tmp_kernel_op_24;
                   const real_t tmp_kernel_op_234 = tmp_kernel_op_228*tmp_kernel_op_27;
                   const real_t tmp_kernel_op_235 = tmp_kernel_op_230*tmp_kernel_op_30;
                   const real_t tmp_kernel_op_236 = tmp_kernel_op_224*tmp_kernel_op_33;
                   const real_t tmp_kernel_op_237 = tmp_kernel_op_226*tmp_kernel_op_36;
                   const real_t tmp_kernel_op_238 = tmp_kernel_op_228*tmp_kernel_op_39;
                   const real_t tmp_kernel_op_239 = tmp_kernel_op_230*tmp_kernel_op_42;
                   const real_t tmp_kernel_op_240 = tmp_kernel_op_2*0.1381966011250105;
                   const real_t tmp_kernel_op_241 = tmp_kernel_op_1*tmp_kernel_op_240;
                   const real_t tmp_kernel_op_242 = tmp_kernel_op_7*0.5854101966249684;
                   const real_t tmp_kernel_op_243 = tmp_kernel_op_242*tmp_kernel_op_6;
                   const real_t tmp_kernel_op_244 = tmp_kernel_op_12*0.1381966011250105;
                   const real_t tmp_kernel_op_245 = tmp_kernel_op_11*tmp_kernel_op_244;
                   const real_t tmp_kernel_op_246 = tmp_kernel_op_17*0.1381966011250105;
                   const real_t tmp_kernel_op_247 = tmp_kernel_op_16*tmp_kernel_op_246;
                   const real_t tmp_kernel_op_248 = tmp_kernel_op_21*tmp_kernel_op_240;
                   const real_t tmp_kernel_op_249 = tmp_kernel_op_24*tmp_kernel_op_242;
                   const real_t tmp_kernel_op_250 = tmp_kernel_op_244*tmp_kernel_op_27;
                   const real_t tmp_kernel_op_251 = tmp_kernel_op_246*tmp_kernel_op_30;
                   const real_t tmp_kernel_op_252 = tmp_kernel_op_240*tmp_kernel_op_33;
                   const real_t tmp_kernel_op_253 = tmp_kernel_op_242*tmp_kernel_op_36;
                   const real_t tmp_kernel_op_254 = tmp_kernel_op_244*tmp_kernel_op_39;
                   const real_t tmp_kernel_op_255 = tmp_kernel_op_246*tmp_kernel_op_42;
                   const real_t tmp_kernel_op_256 = tmp_kernel_op_2*0.5854101966249684;
                   const real_t tmp_kernel_op_257 = tmp_kernel_op_1*tmp_kernel_op_256;
                   const real_t tmp_kernel_op_258 = tmp_kernel_op_7*0.1381966011250105;
                   const real_t tmp_kernel_op_259 = tmp_kernel_op_258*tmp_kernel_op_6;
                   const real_t tmp_kernel_op_260 = tmp_kernel_op_12*0.1381966011250105;
                   const real_t tmp_kernel_op_261 = tmp_kernel_op_11*tmp_kernel_op_260;
                   const real_t tmp_kernel_op_262 = tmp_kernel_op_17*0.1381966011250105;
                   const real_t tmp_kernel_op_263 = tmp_kernel_op_16*tmp_kernel_op_262;
                   const real_t tmp_kernel_op_264 = tmp_kernel_op_21*tmp_kernel_op_256;
                   const real_t tmp_kernel_op_265 = tmp_kernel_op_24*tmp_kernel_op_258;
                   const real_t tmp_kernel_op_266 = tmp_kernel_op_260*tmp_kernel_op_27;
                   const real_t tmp_kernel_op_267 = tmp_kernel_op_262*tmp_kernel_op_30;
                   const real_t tmp_kernel_op_268 = tmp_kernel_op_256*tmp_kernel_op_33;
                   const real_t tmp_kernel_op_269 = tmp_kernel_op_258*tmp_kernel_op_36;
                   const real_t tmp_kernel_op_270 = tmp_kernel_op_260*tmp_kernel_op_39;
                   const real_t tmp_kernel_op_271 = tmp_kernel_op_262*tmp_kernel_op_42;
                   const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_13*tmp_kernel_op_213 + tmp_kernel_op_18*tmp_kernel_op_215 + tmp_kernel_op_209*tmp_kernel_op_3 + tmp_kernel_op_211*tmp_kernel_op_8) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_9) + src_dof_10*(tmp_kernel_op_13*tmp_kernel_op_218 + tmp_kernel_op_18*tmp_kernel_op_219 + tmp_kernel_op_216*tmp_kernel_op_3 + tmp_kernel_op_217*tmp_kernel_op_8) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_9) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_31) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_43) + src_dof_14*(tmp_kernel_op_13*tmp_kernel_op_52 + tmp_kernel_op_18*tmp_kernel_op_55 + tmp_kernel_op_3*tmp_kernel_op_46 + tmp_kernel_op_49*tmp_kernel_op_8) + src_dof_15*(tmp_kernel_op_13*tmp_kernel_op_64 + tmp_kernel_op_18*tmp_kernel_op_67 + tmp_kernel_op_3*tmp_kernel_op_58 + tmp_kernel_op_61*tmp_kernel_op_8) + src_dof_16*(tmp_kernel_op_13*tmp_kernel_op_76 + tmp_kernel_op_18*tmp_kernel_op_79 + tmp_kernel_op_3*tmp_kernel_op_70 + tmp_kernel_op_73*tmp_kernel_op_8) + src_dof_17*(tmp_kernel_op_13*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_3 + tmp_kernel_op_157*tmp_kernel_op_8 + tmp_kernel_op_163*tmp_kernel_op_18) + src_dof_18*(tmp_kernel_op_13*tmp_kernel_op_172 + tmp_kernel_op_166*tmp_kernel_op_3 + tmp_kernel_op_169*tmp_kernel_op_8 + tmp_kernel_op_175*tmp_kernel_op_18) + src_dof_19*(tmp_kernel_op_13*tmp_kernel_op_181 + tmp_kernel_op_177*tmp_kernel_op_3 + tmp_kernel_op_179*tmp_kernel_op_8 + tmp_kernel_op_18*tmp_kernel_op_183) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_31) + src_dof_20*(tmp_kernel_op_13*tmp_kernel_op_222 + tmp_kernel_op_18*tmp_kernel_op_223 + tmp_kernel_op_220*tmp_kernel_op_3 + tmp_kernel_op_221*tmp_kernel_op_8) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_9) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_31) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_43) + src_dof_24*(tmp_kernel_op_13*tmp_kernel_op_88 + tmp_kernel_op_18*tmp_kernel_op_91 + tmp_kernel_op_3*tmp_kernel_op_82 + tmp_kernel_op_8*tmp_kernel_op_85) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_13 + tmp_kernel_op_103*tmp_kernel_op_18 + tmp_kernel_op_3*tmp_kernel_op_94 + tmp_kernel_op_8*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_3 + tmp_kernel_op_109*tmp_kernel_op_8 + tmp_kernel_op_112*tmp_kernel_op_13 + tmp_kernel_op_115*tmp_kernel_op_18) + src_dof_27*(tmp_kernel_op_13*tmp_kernel_op_186 + tmp_kernel_op_18*tmp_kernel_op_187 + tmp_kernel_op_184*tmp_kernel_op_3 + tmp_kernel_op_185*tmp_kernel_op_8) + src_dof_28*(tmp_kernel_op_13*tmp_kernel_op_190 + tmp_kernel_op_18*tmp_kernel_op_191 + tmp_kernel_op_188*tmp_kernel_op_3 + tmp_kernel_op_189*tmp_kernel_op_8) + src_dof_29*(tmp_kernel_op_13*tmp_kernel_op_194 + tmp_kernel_op_18*tmp_kernel_op_195 + tmp_kernel_op_192*tmp_kernel_op_3 + tmp_kernel_op_193*tmp_kernel_op_8) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_3 + tmp_kernel_op_121*tmp_kernel_op_8 + tmp_kernel_op_124*tmp_kernel_op_13 + tmp_kernel_op_127*tmp_kernel_op_18) + src_dof_5*(tmp_kernel_op_13*tmp_kernel_op_136 + tmp_kernel_op_130*tmp_kernel_op_3 + tmp_kernel_op_133*tmp_kernel_op_8 + tmp_kernel_op_139*tmp_kernel_op_18) + src_dof_6*(tmp_kernel_op_13*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_3 + tmp_kernel_op_145*tmp_kernel_op_8 + tmp_kernel_op_151*tmp_kernel_op_18) + src_dof_7*(tmp_kernel_op_13*tmp_kernel_op_198 + tmp_kernel_op_18*tmp_kernel_op_199 + tmp_kernel_op_196*tmp_kernel_op_3 + tmp_kernel_op_197*tmp_kernel_op_8) + src_dof_8*(tmp_kernel_op_13*tmp_kernel_op_202 + tmp_kernel_op_18*tmp_kernel_op_203 + tmp_kernel_op_200*tmp_kernel_op_3 + tmp_kernel_op_201*tmp_kernel_op_8) + src_dof_9*(tmp_kernel_op_13*tmp_kernel_op_206 + tmp_kernel_op_18*tmp_kernel_op_207 + tmp_kernel_op_204*tmp_kernel_op_3 + tmp_kernel_op_205*tmp_kernel_op_8);
                   const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_224 + tmp_kernel_op_211*tmp_kernel_op_226 + tmp_kernel_op_213*tmp_kernel_op_228 + tmp_kernel_op_215*tmp_kernel_op_230) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_231) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_224 + tmp_kernel_op_217*tmp_kernel_op_226 + tmp_kernel_op_218*tmp_kernel_op_228 + tmp_kernel_op_219*tmp_kernel_op_230) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_231) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_235) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_239) + src_dof_14*(tmp_kernel_op_224*tmp_kernel_op_46 + tmp_kernel_op_226*tmp_kernel_op_49 + tmp_kernel_op_228*tmp_kernel_op_52 + tmp_kernel_op_230*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_224*tmp_kernel_op_58 + tmp_kernel_op_226*tmp_kernel_op_61 + tmp_kernel_op_228*tmp_kernel_op_64 + tmp_kernel_op_230*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_224*tmp_kernel_op_70 + tmp_kernel_op_226*tmp_kernel_op_73 + tmp_kernel_op_228*tmp_kernel_op_76 + tmp_kernel_op_230*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_224 + tmp_kernel_op_157*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_228 + tmp_kernel_op_163*tmp_kernel_op_230) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_224 + tmp_kernel_op_169*tmp_kernel_op_226 + tmp_kernel_op_172*tmp_kernel_op_228 + tmp_kernel_op_175*tmp_kernel_op_230) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_224 + tmp_kernel_op_179*tmp_kernel_op_226 + tmp_kernel_op_181*tmp_kernel_op_228 + tmp_kernel_op_183*tmp_kernel_op_230) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_235) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_224 + tmp_kernel_op_221*tmp_kernel_op_226 + tmp_kernel_op_222*tmp_kernel_op_228 + tmp_kernel_op_223*tmp_kernel_op_230) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_231) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_235) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_239) + src_dof_24*(tmp_kernel_op_224*tmp_kernel_op_82 + tmp_kernel_op_226*tmp_kernel_op_85 + tmp_kernel_op_228*tmp_kernel_op_88 + tmp_kernel_op_230*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_228 + tmp_kernel_op_103*tmp_kernel_op_230 + tmp_kernel_op_224*tmp_kernel_op_94 + tmp_kernel_op_226*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_224 + tmp_kernel_op_109*tmp_kernel_op_226 + tmp_kernel_op_112*tmp_kernel_op_228 + tmp_kernel_op_115*tmp_kernel_op_230) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_224 + tmp_kernel_op_185*tmp_kernel_op_226 + tmp_kernel_op_186*tmp_kernel_op_228 + tmp_kernel_op_187*tmp_kernel_op_230) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_224 + tmp_kernel_op_189*tmp_kernel_op_226 + tmp_kernel_op_190*tmp_kernel_op_228 + tmp_kernel_op_191*tmp_kernel_op_230) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_224 + tmp_kernel_op_193*tmp_kernel_op_226 + tmp_kernel_op_194*tmp_kernel_op_228 + tmp_kernel_op_195*tmp_kernel_op_230) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_239) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_224 + tmp_kernel_op_121*tmp_kernel_op_226 + tmp_kernel_op_124*tmp_kernel_op_228 + tmp_kernel_op_127*tmp_kernel_op_230) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_224 + tmp_kernel_op_133*tmp_kernel_op_226 + tmp_kernel_op_136*tmp_kernel_op_228 + tmp_kernel_op_139*tmp_kernel_op_230) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_224 + tmp_kernel_op_145*tmp_kernel_op_226 + tmp_kernel_op_148*tmp_kernel_op_228 + tmp_kernel_op_151*tmp_kernel_op_230) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_224 + tmp_kernel_op_197*tmp_kernel_op_226 + tmp_kernel_op_198*tmp_kernel_op_228 + tmp_kernel_op_199*tmp_kernel_op_230) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_224 + tmp_kernel_op_201*tmp_kernel_op_226 + tmp_kernel_op_202*tmp_kernel_op_228 + tmp_kernel_op_203*tmp_kernel_op_230) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_224 + tmp_kernel_op_205*tmp_kernel_op_226 + tmp_kernel_op_206*tmp_kernel_op_228 + tmp_kernel_op_207*tmp_kernel_op_230);
                   const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_240 + tmp_kernel_op_211*tmp_kernel_op_242 + tmp_kernel_op_213*tmp_kernel_op_244 + tmp_kernel_op_215*tmp_kernel_op_246) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_247) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_240 + tmp_kernel_op_217*tmp_kernel_op_242 + tmp_kernel_op_218*tmp_kernel_op_244 + tmp_kernel_op_219*tmp_kernel_op_246) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_247) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_251) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_255) + src_dof_14*(tmp_kernel_op_240*tmp_kernel_op_46 + tmp_kernel_op_242*tmp_kernel_op_49 + tmp_kernel_op_244*tmp_kernel_op_52 + tmp_kernel_op_246*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_240*tmp_kernel_op_58 + tmp_kernel_op_242*tmp_kernel_op_61 + tmp_kernel_op_244*tmp_kernel_op_64 + tmp_kernel_op_246*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_240*tmp_kernel_op_70 + tmp_kernel_op_242*tmp_kernel_op_73 + tmp_kernel_op_244*tmp_kernel_op_76 + tmp_kernel_op_246*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_240 + tmp_kernel_op_157*tmp_kernel_op_242 + tmp_kernel_op_160*tmp_kernel_op_244 + tmp_kernel_op_163*tmp_kernel_op_246) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_240 + tmp_kernel_op_169*tmp_kernel_op_242 + tmp_kernel_op_172*tmp_kernel_op_244 + tmp_kernel_op_175*tmp_kernel_op_246) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_240 + tmp_kernel_op_179*tmp_kernel_op_242 + tmp_kernel_op_181*tmp_kernel_op_244 + tmp_kernel_op_183*tmp_kernel_op_246) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_251) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_240 + tmp_kernel_op_221*tmp_kernel_op_242 + tmp_kernel_op_222*tmp_kernel_op_244 + tmp_kernel_op_223*tmp_kernel_op_246) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_247) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_251) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_255) + src_dof_24*(tmp_kernel_op_240*tmp_kernel_op_82 + tmp_kernel_op_242*tmp_kernel_op_85 + tmp_kernel_op_244*tmp_kernel_op_88 + tmp_kernel_op_246*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_244 + tmp_kernel_op_103*tmp_kernel_op_246 + tmp_kernel_op_240*tmp_kernel_op_94 + tmp_kernel_op_242*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_109*tmp_kernel_op_242 + tmp_kernel_op_112*tmp_kernel_op_244 + tmp_kernel_op_115*tmp_kernel_op_246) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_240 + tmp_kernel_op_185*tmp_kernel_op_242 + tmp_kernel_op_186*tmp_kernel_op_244 + tmp_kernel_op_187*tmp_kernel_op_246) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_240 + tmp_kernel_op_189*tmp_kernel_op_242 + tmp_kernel_op_190*tmp_kernel_op_244 + tmp_kernel_op_191*tmp_kernel_op_246) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_240 + tmp_kernel_op_193*tmp_kernel_op_242 + tmp_kernel_op_194*tmp_kernel_op_244 + tmp_kernel_op_195*tmp_kernel_op_246) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_255) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_240 + tmp_kernel_op_121*tmp_kernel_op_242 + tmp_kernel_op_124*tmp_kernel_op_244 + tmp_kernel_op_127*tmp_kernel_op_246) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_240 + tmp_kernel_op_133*tmp_kernel_op_242 + tmp_kernel_op_136*tmp_kernel_op_244 + tmp_kernel_op_139*tmp_kernel_op_246) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_240 + tmp_kernel_op_145*tmp_kernel_op_242 + tmp_kernel_op_148*tmp_kernel_op_244 + tmp_kernel_op_151*tmp_kernel_op_246) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_240 + tmp_kernel_op_197*tmp_kernel_op_242 + tmp_kernel_op_198*tmp_kernel_op_244 + tmp_kernel_op_199*tmp_kernel_op_246) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_240 + tmp_kernel_op_201*tmp_kernel_op_242 + tmp_kernel_op_202*tmp_kernel_op_244 + tmp_kernel_op_203*tmp_kernel_op_246) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_240 + tmp_kernel_op_205*tmp_kernel_op_242 + tmp_kernel_op_206*tmp_kernel_op_244 + tmp_kernel_op_207*tmp_kernel_op_246);
                   const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_256 + tmp_kernel_op_211*tmp_kernel_op_258 + tmp_kernel_op_213*tmp_kernel_op_260 + tmp_kernel_op_215*tmp_kernel_op_262) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_263) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_256 + tmp_kernel_op_217*tmp_kernel_op_258 + tmp_kernel_op_218*tmp_kernel_op_260 + tmp_kernel_op_219*tmp_kernel_op_262) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_263) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_267) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_271) + src_dof_14*(tmp_kernel_op_256*tmp_kernel_op_46 + tmp_kernel_op_258*tmp_kernel_op_49 + tmp_kernel_op_260*tmp_kernel_op_52 + tmp_kernel_op_262*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_256*tmp_kernel_op_58 + tmp_kernel_op_258*tmp_kernel_op_61 + tmp_kernel_op_260*tmp_kernel_op_64 + tmp_kernel_op_262*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_256*tmp_kernel_op_70 + tmp_kernel_op_258*tmp_kernel_op_73 + tmp_kernel_op_260*tmp_kernel_op_76 + tmp_kernel_op_262*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_256 + tmp_kernel_op_157*tmp_kernel_op_258 + tmp_kernel_op_160*tmp_kernel_op_260 + tmp_kernel_op_163*tmp_kernel_op_262) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_256 + tmp_kernel_op_169*tmp_kernel_op_258 + tmp_kernel_op_172*tmp_kernel_op_260 + tmp_kernel_op_175*tmp_kernel_op_262) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_256 + tmp_kernel_op_179*tmp_kernel_op_258 + tmp_kernel_op_181*tmp_kernel_op_260 + tmp_kernel_op_183*tmp_kernel_op_262) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_267) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_256 + tmp_kernel_op_221*tmp_kernel_op_258 + tmp_kernel_op_222*tmp_kernel_op_260 + tmp_kernel_op_223*tmp_kernel_op_262) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_263) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_267) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_271) + src_dof_24*(tmp_kernel_op_256*tmp_kernel_op_82 + tmp_kernel_op_258*tmp_kernel_op_85 + tmp_kernel_op_260*tmp_kernel_op_88 + tmp_kernel_op_262*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_260 + tmp_kernel_op_103*tmp_kernel_op_262 + tmp_kernel_op_256*tmp_kernel_op_94 + tmp_kernel_op_258*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_256 + tmp_kernel_op_109*tmp_kernel_op_258 + tmp_kernel_op_112*tmp_kernel_op_260 + tmp_kernel_op_115*tmp_kernel_op_262) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_256 + tmp_kernel_op_185*tmp_kernel_op_258 + tmp_kernel_op_186*tmp_kernel_op_260 + tmp_kernel_op_187*tmp_kernel_op_262) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_256 + tmp_kernel_op_189*tmp_kernel_op_258 + tmp_kernel_op_190*tmp_kernel_op_260 + tmp_kernel_op_191*tmp_kernel_op_262) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_256 + tmp_kernel_op_193*tmp_kernel_op_258 + tmp_kernel_op_194*tmp_kernel_op_260 + tmp_kernel_op_195*tmp_kernel_op_262) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_271) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_256 + tmp_kernel_op_121*tmp_kernel_op_258 + tmp_kernel_op_124*tmp_kernel_op_260 + tmp_kernel_op_127*tmp_kernel_op_262) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_256 + tmp_kernel_op_133*tmp_kernel_op_258 + tmp_kernel_op_136*tmp_kernel_op_260 + tmp_kernel_op_139*tmp_kernel_op_262) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_256 + tmp_kernel_op_145*tmp_kernel_op_258 + tmp_kernel_op_148*tmp_kernel_op_260 + tmp_kernel_op_151*tmp_kernel_op_262) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_256 + tmp_kernel_op_197*tmp_kernel_op_258 + tmp_kernel_op_198*tmp_kernel_op_260 + tmp_kernel_op_199*tmp_kernel_op_262) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_256 + tmp_kernel_op_201*tmp_kernel_op_258 + tmp_kernel_op_202*tmp_kernel_op_260 + tmp_kernel_op_203*tmp_kernel_op_262) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_256 + tmp_kernel_op_205*tmp_kernel_op_258 + tmp_kernel_op_206*tmp_kernel_op_260 + tmp_kernel_op_207*tmp_kernel_op_262);
                   {
                      {
                     
                         const int64_t phantom_ctr_0 = ctr_0;
                         real_t _data_float_loop_ctr_array_dim_0[4];
                         _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                         _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                         _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                         _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                         real_t _data_float_loop_ctr_array_dim_1[4];
                         _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                         real_t _data_float_loop_ctr_array_dim_2[4];
                         _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                     
                         const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      }
                   }
                   const real_t tmp_moved_constant_1290 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1291 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1292 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1293 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1294 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1295 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1296 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1297 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1298 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1299 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1300 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1301 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1302 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1303 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1304 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1305 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1306 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1307 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1308 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1309 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1310 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1311 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1312 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1313 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1314 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1315 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1316 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1317 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1318 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1319 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1320 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
                   const real_t tmp_moved_constant_1321 = tmp_moved_constant_1320*0.13819660112501053;
                   const real_t tmp_moved_constant_1322 = tmp_kernel_op_1*tmp_moved_constant_1321;
                   const real_t tmp_moved_constant_1323 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
                   const real_t tmp_moved_constant_1324 = tmp_moved_constant_1323*0.13819660112501056;
                   const real_t tmp_moved_constant_1325 = tmp_kernel_op_6*tmp_moved_constant_1324;
                   const real_t tmp_moved_constant_1326 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
                   const real_t tmp_moved_constant_1327 = tmp_moved_constant_1326*0.13819660112501056;
                   const real_t tmp_moved_constant_1328 = tmp_kernel_op_11*tmp_moved_constant_1327;
                   const real_t tmp_moved_constant_1329 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
                   const real_t tmp_moved_constant_1330 = tmp_moved_constant_1329*0.5854101966249684;
                   const real_t tmp_moved_constant_1331 = tmp_kernel_op_16*tmp_moved_constant_1330;
                   const real_t tmp_moved_constant_1332 = tmp_kernel_op_21*tmp_moved_constant_1321;
                   const real_t tmp_moved_constant_1333 = tmp_kernel_op_24*tmp_moved_constant_1324;
                   const real_t tmp_moved_constant_1334 = tmp_kernel_op_27*tmp_moved_constant_1327;
                   const real_t tmp_moved_constant_1335 = tmp_kernel_op_30*tmp_moved_constant_1330;
                   const real_t tmp_moved_constant_1336 = tmp_kernel_op_33*tmp_moved_constant_1321;
                   const real_t tmp_moved_constant_1337 = tmp_kernel_op_36*tmp_moved_constant_1324;
                   const real_t tmp_moved_constant_1338 = tmp_kernel_op_39*tmp_moved_constant_1327;
                   const real_t tmp_moved_constant_1339 = tmp_kernel_op_42*tmp_moved_constant_1330;
                   const real_t tmp_moved_constant_1340 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1341 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1342 = -tmp_moved_constant_1340 - tmp_moved_constant_1341;
                   const real_t tmp_moved_constant_1343 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1344 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1345 = -tmp_moved_constant_1343 - tmp_moved_constant_1344;
                   const real_t tmp_moved_constant_1346 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1347 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1348 = -tmp_moved_constant_1346 - tmp_moved_constant_1347;
                   const real_t tmp_moved_constant_1349 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1350 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1351 = -tmp_moved_constant_1349 - tmp_moved_constant_1350;
                   const real_t tmp_moved_constant_1352 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1353 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1354 = -tmp_moved_constant_1352 - tmp_moved_constant_1353;
                   const real_t tmp_moved_constant_1355 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1356 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1357 = -tmp_moved_constant_1355 - tmp_moved_constant_1356;
                   const real_t tmp_moved_constant_1358 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1359 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1360 = -tmp_moved_constant_1358 - tmp_moved_constant_1359;
                   const real_t tmp_moved_constant_1361 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1362 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1363 = -tmp_moved_constant_1361 - tmp_moved_constant_1362;
                   const real_t tmp_moved_constant_1364 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1365 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1366 = -tmp_moved_constant_1364 - tmp_moved_constant_1365;
                   const real_t tmp_moved_constant_1367 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1368 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1369 = -tmp_moved_constant_1367 - tmp_moved_constant_1368;
                   const real_t tmp_moved_constant_1370 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1371 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1372 = -tmp_moved_constant_1370 - tmp_moved_constant_1371;
                   const real_t tmp_moved_constant_1373 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1374 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1375 = -tmp_moved_constant_1373 - tmp_moved_constant_1374;
                   const real_t tmp_moved_constant_1376 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1377 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1378 = -tmp_moved_constant_1376 - tmp_moved_constant_1377;
                   const real_t tmp_moved_constant_1379 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1380 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1381 = -tmp_moved_constant_1379 - tmp_moved_constant_1380;
                   const real_t tmp_moved_constant_1382 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1383 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1384 = -tmp_moved_constant_1382 - tmp_moved_constant_1383;
                   const real_t tmp_moved_constant_1385 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1386 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1387 = -tmp_moved_constant_1385 - tmp_moved_constant_1386;
                   const real_t tmp_moved_constant_1388 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1389 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1390 = -tmp_moved_constant_1388 - tmp_moved_constant_1389;
                   const real_t tmp_moved_constant_1391 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1392 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1393 = -tmp_moved_constant_1391 - tmp_moved_constant_1392;
                   const real_t tmp_moved_constant_1394 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1395 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1396 = -tmp_moved_constant_1394 - tmp_moved_constant_1395;
                   const real_t tmp_moved_constant_1397 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1398 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1399 = -tmp_moved_constant_1397 - tmp_moved_constant_1398;
                   const real_t tmp_moved_constant_1400 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1401 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1402 = -tmp_moved_constant_1400 - tmp_moved_constant_1401;
                   const real_t tmp_moved_constant_1403 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1404 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1405 = -tmp_moved_constant_1403 - tmp_moved_constant_1404;
                   const real_t tmp_moved_constant_1406 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1407 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1408 = -tmp_moved_constant_1406 - tmp_moved_constant_1407;
                   const real_t tmp_moved_constant_1409 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1410 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1411 = -tmp_moved_constant_1409 - tmp_moved_constant_1410;
                   const real_t tmp_moved_constant_1412 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1413 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1414 = -tmp_moved_constant_1412 - tmp_moved_constant_1413;
                   const real_t tmp_moved_constant_1415 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1416 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1417 = -tmp_moved_constant_1415 - tmp_moved_constant_1416;
                   const real_t tmp_moved_constant_1418 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1419 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1420 = -tmp_moved_constant_1418 - tmp_moved_constant_1419;
                   const real_t tmp_moved_constant_1421 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1422 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1423 = -tmp_moved_constant_1421 - tmp_moved_constant_1422;
                   const real_t tmp_moved_constant_1424 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1425 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1426 = -tmp_moved_constant_1424 - tmp_moved_constant_1425;
                   const real_t tmp_moved_constant_1427 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1428 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1429 = -tmp_moved_constant_1427 - tmp_moved_constant_1428;
                   const real_t tmp_moved_constant_1430 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1431 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1432 = -tmp_moved_constant_1430 - tmp_moved_constant_1431;
                   const real_t tmp_moved_constant_1433 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1434 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1435 = -tmp_moved_constant_1433 - tmp_moved_constant_1434;
                   const real_t tmp_moved_constant_1436 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1437 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1438 = -tmp_moved_constant_1436 - tmp_moved_constant_1437;
                   const real_t tmp_moved_constant_1439 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1440 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1441 = -tmp_moved_constant_1439 - tmp_moved_constant_1440;
                   const real_t tmp_moved_constant_1442 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1443 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1444 = -tmp_moved_constant_1442 - tmp_moved_constant_1443;
                   const real_t tmp_moved_constant_1445 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1446 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1447 = -tmp_moved_constant_1445 - tmp_moved_constant_1446;
                   const real_t tmp_moved_constant_1448 = -jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_153 + tmp_moved_constant_1340 + tmp_moved_constant_1352;
                   const real_t tmp_moved_constant_1449 = -jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_156 + tmp_moved_constant_1343 + tmp_moved_constant_1355;
                   const real_t tmp_moved_constant_1450 = -jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_159 + tmp_moved_constant_1346 + tmp_moved_constant_1358;
                   const real_t tmp_moved_constant_1451 = -jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_162 + tmp_moved_constant_1349 + tmp_moved_constant_1361;
                   const real_t tmp_moved_constant_1452 = -jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_165 + tmp_moved_constant_1341 + tmp_moved_constant_1364;
                   const real_t tmp_moved_constant_1453 = -jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_168 + tmp_moved_constant_1344 + tmp_moved_constant_1367;
                   const real_t tmp_moved_constant_1454 = -jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_171 + tmp_moved_constant_1347 + tmp_moved_constant_1370;
                   const real_t tmp_moved_constant_1455 = -jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_174 + tmp_moved_constant_1350 + tmp_moved_constant_1373;
                   const real_t tmp_moved_constant_1456 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_176 + tmp_moved_constant_1353 + tmp_moved_constant_1365;
                   const real_t tmp_moved_constant_1457 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_178 + tmp_moved_constant_1356 + tmp_moved_constant_1368;
                   const real_t tmp_moved_constant_1458 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_180 + tmp_moved_constant_1359 + tmp_moved_constant_1371;
                   const real_t tmp_moved_constant_1459 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_182 + tmp_moved_constant_1362 + tmp_moved_constant_1374;
                   const real_t tmp_moved_constant_1460 = -jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_153 + tmp_moved_constant_1376 + tmp_moved_constant_1388;
                   const real_t tmp_moved_constant_1461 = -jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_156 + tmp_moved_constant_1379 + tmp_moved_constant_1391;
                   const real_t tmp_moved_constant_1462 = -jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_159 + tmp_moved_constant_1382 + tmp_moved_constant_1394;
                   const real_t tmp_moved_constant_1463 = -jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_162 + tmp_moved_constant_1385 + tmp_moved_constant_1397;
                   const real_t tmp_moved_constant_1464 = -jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_165 + tmp_moved_constant_1377 + tmp_moved_constant_1400;
                   const real_t tmp_moved_constant_1465 = -jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_168 + tmp_moved_constant_1380 + tmp_moved_constant_1403;
                   const real_t tmp_moved_constant_1466 = -jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_171 + tmp_moved_constant_1383 + tmp_moved_constant_1406;
                   const real_t tmp_moved_constant_1467 = -jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_174 + tmp_moved_constant_1386 + tmp_moved_constant_1409;
                   const real_t tmp_moved_constant_1468 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_176 + tmp_moved_constant_1389 + tmp_moved_constant_1401;
                   const real_t tmp_moved_constant_1469 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_178 + tmp_moved_constant_1392 + tmp_moved_constant_1404;
                   const real_t tmp_moved_constant_1470 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_180 + tmp_moved_constant_1395 + tmp_moved_constant_1407;
                   const real_t tmp_moved_constant_1471 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_182 + tmp_moved_constant_1398 + tmp_moved_constant_1410;
                   const real_t tmp_moved_constant_1472 = -jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_153 + tmp_moved_constant_1412 + tmp_moved_constant_1424;
                   const real_t tmp_moved_constant_1473 = -jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_156 + tmp_moved_constant_1415 + tmp_moved_constant_1427;
                   const real_t tmp_moved_constant_1474 = -jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_159 + tmp_moved_constant_1418 + tmp_moved_constant_1430;
                   const real_t tmp_moved_constant_1475 = -jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_162 + tmp_moved_constant_1421 + tmp_moved_constant_1433;
                   const real_t tmp_moved_constant_1476 = -jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_165 + tmp_moved_constant_1413 + tmp_moved_constant_1436;
                   const real_t tmp_moved_constant_1477 = -jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_168 + tmp_moved_constant_1416 + tmp_moved_constant_1439;
                   const real_t tmp_moved_constant_1478 = -jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_171 + tmp_moved_constant_1419 + tmp_moved_constant_1442;
                   const real_t tmp_moved_constant_1479 = -jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_174 + tmp_moved_constant_1422 + tmp_moved_constant_1445;
                   const real_t tmp_moved_constant_1480 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_176 + tmp_moved_constant_1425 + tmp_moved_constant_1437;
                   const real_t tmp_moved_constant_1481 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_178 + tmp_moved_constant_1428 + tmp_moved_constant_1440;
                   const real_t tmp_moved_constant_1482 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_180 + tmp_moved_constant_1431 + tmp_moved_constant_1443;
                   const real_t tmp_moved_constant_1483 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_182 + tmp_moved_constant_1434 + tmp_moved_constant_1446;
                   const real_t tmp_moved_constant_1484 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_1485 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_1486 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_1487 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_1488 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_1489 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_1490 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_1491 = -jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_1492 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_208 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_1493 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_210 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_1494 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_212 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_1495 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_214 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_1496 = tmp_moved_constant_1320*0.1381966011250105;
                   const real_t tmp_moved_constant_1497 = tmp_kernel_op_1*tmp_moved_constant_1496;
                   const real_t tmp_moved_constant_1498 = tmp_moved_constant_1323*0.1381966011250105;
                   const real_t tmp_moved_constant_1499 = tmp_kernel_op_6*tmp_moved_constant_1498;
                   const real_t tmp_moved_constant_1500 = tmp_moved_constant_1326*0.5854101966249684;
                   const real_t tmp_moved_constant_1501 = tmp_kernel_op_11*tmp_moved_constant_1500;
                   const real_t tmp_moved_constant_1502 = tmp_moved_constant_1329*0.1381966011250105;
                   const real_t tmp_moved_constant_1503 = tmp_kernel_op_16*tmp_moved_constant_1502;
                   const real_t tmp_moved_constant_1504 = tmp_kernel_op_21*tmp_moved_constant_1496;
                   const real_t tmp_moved_constant_1505 = tmp_kernel_op_24*tmp_moved_constant_1498;
                   const real_t tmp_moved_constant_1506 = tmp_kernel_op_27*tmp_moved_constant_1500;
                   const real_t tmp_moved_constant_1507 = tmp_kernel_op_30*tmp_moved_constant_1502;
                   const real_t tmp_moved_constant_1508 = tmp_kernel_op_33*tmp_moved_constant_1496;
                   const real_t tmp_moved_constant_1509 = tmp_kernel_op_36*tmp_moved_constant_1498;
                   const real_t tmp_moved_constant_1510 = tmp_kernel_op_39*tmp_moved_constant_1500;
                   const real_t tmp_moved_constant_1511 = tmp_kernel_op_42*tmp_moved_constant_1502;
                   const real_t tmp_moved_constant_1512 = tmp_moved_constant_1320*0.1381966011250105;
                   const real_t tmp_moved_constant_1513 = tmp_kernel_op_1*tmp_moved_constant_1512;
                   const real_t tmp_moved_constant_1514 = tmp_moved_constant_1323*0.5854101966249684;
                   const real_t tmp_moved_constant_1515 = tmp_kernel_op_6*tmp_moved_constant_1514;
                   const real_t tmp_moved_constant_1516 = tmp_moved_constant_1326*0.1381966011250105;
                   const real_t tmp_moved_constant_1517 = tmp_kernel_op_11*tmp_moved_constant_1516;
                   const real_t tmp_moved_constant_1518 = tmp_moved_constant_1329*0.1381966011250105;
                   const real_t tmp_moved_constant_1519 = tmp_kernel_op_16*tmp_moved_constant_1518;
                   const real_t tmp_moved_constant_1520 = tmp_kernel_op_21*tmp_moved_constant_1512;
                   const real_t tmp_moved_constant_1521 = tmp_kernel_op_24*tmp_moved_constant_1514;
                   const real_t tmp_moved_constant_1522 = tmp_kernel_op_27*tmp_moved_constant_1516;
                   const real_t tmp_moved_constant_1523 = tmp_kernel_op_30*tmp_moved_constant_1518;
                   const real_t tmp_moved_constant_1524 = tmp_kernel_op_33*tmp_moved_constant_1512;
                   const real_t tmp_moved_constant_1525 = tmp_kernel_op_36*tmp_moved_constant_1514;
                   const real_t tmp_moved_constant_1526 = tmp_kernel_op_39*tmp_moved_constant_1516;
                   const real_t tmp_moved_constant_1527 = tmp_kernel_op_42*tmp_moved_constant_1518;
                   const real_t tmp_moved_constant_1528 = tmp_moved_constant_1320*0.5854101966249684;
                   const real_t tmp_moved_constant_1529 = tmp_kernel_op_1*tmp_moved_constant_1528;
                   const real_t tmp_moved_constant_1530 = tmp_moved_constant_1323*0.1381966011250105;
                   const real_t tmp_moved_constant_1531 = tmp_kernel_op_6*tmp_moved_constant_1530;
                   const real_t tmp_moved_constant_1532 = tmp_moved_constant_1326*0.1381966011250105;
                   const real_t tmp_moved_constant_1533 = tmp_kernel_op_11*tmp_moved_constant_1532;
                   const real_t tmp_moved_constant_1534 = tmp_moved_constant_1329*0.1381966011250105;
                   const real_t tmp_moved_constant_1535 = tmp_kernel_op_16*tmp_moved_constant_1534;
                   const real_t tmp_moved_constant_1536 = tmp_kernel_op_21*tmp_moved_constant_1528;
                   const real_t tmp_moved_constant_1537 = tmp_kernel_op_24*tmp_moved_constant_1530;
                   const real_t tmp_moved_constant_1538 = tmp_kernel_op_27*tmp_moved_constant_1532;
                   const real_t tmp_moved_constant_1539 = tmp_kernel_op_30*tmp_moved_constant_1534;
                   const real_t tmp_moved_constant_1540 = tmp_kernel_op_33*tmp_moved_constant_1528;
                   const real_t tmp_moved_constant_1541 = tmp_kernel_op_36*tmp_moved_constant_1530;
                   const real_t tmp_moved_constant_1542 = tmp_kernel_op_39*tmp_moved_constant_1532;
                   const real_t tmp_moved_constant_1543 = tmp_kernel_op_42*tmp_moved_constant_1534;
                   const real_t tmp_moved_constant_1544 = tmp_moved_constant_1290*(tmp_moved_constant_1321*tmp_moved_constant_1484 + tmp_moved_constant_1324*tmp_moved_constant_1485 + tmp_moved_constant_1327*tmp_moved_constant_1486 + tmp_moved_constant_1330*tmp_moved_constant_1487) + tmp_moved_constant_1291*(-jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1322 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1325 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1328 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1331) + tmp_moved_constant_1292*(-jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1332 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1333 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1334 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1335) + tmp_moved_constant_1293*(-jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1336 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1337 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1338 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1339) + tmp_moved_constant_1294*(tmp_moved_constant_1321*tmp_moved_constant_1414 + tmp_moved_constant_1324*tmp_moved_constant_1417 + tmp_moved_constant_1327*tmp_moved_constant_1420 + tmp_moved_constant_1330*tmp_moved_constant_1423) + tmp_moved_constant_1295*(tmp_moved_constant_1321*tmp_moved_constant_1426 + tmp_moved_constant_1324*tmp_moved_constant_1429 + tmp_moved_constant_1327*tmp_moved_constant_1432 + tmp_moved_constant_1330*tmp_moved_constant_1435) + tmp_moved_constant_1296*(tmp_moved_constant_1321*tmp_moved_constant_1438 + tmp_moved_constant_1324*tmp_moved_constant_1441 + tmp_moved_constant_1327*tmp_moved_constant_1444 + tmp_moved_constant_1330*tmp_moved_constant_1447) + tmp_moved_constant_1297*(tmp_moved_constant_1321*tmp_moved_constant_1472 + tmp_moved_constant_1324*tmp_moved_constant_1473 + tmp_moved_constant_1327*tmp_moved_constant_1474 + tmp_moved_constant_1330*tmp_moved_constant_1475) + tmp_moved_constant_1298*(tmp_moved_constant_1321*tmp_moved_constant_1476 + tmp_moved_constant_1324*tmp_moved_constant_1477 + tmp_moved_constant_1327*tmp_moved_constant_1478 + tmp_moved_constant_1330*tmp_moved_constant_1479) + tmp_moved_constant_1299*(tmp_moved_constant_1321*tmp_moved_constant_1480 + tmp_moved_constant_1324*tmp_moved_constant_1481 + tmp_moved_constant_1327*tmp_moved_constant_1482 + tmp_moved_constant_1330*tmp_moved_constant_1483) + tmp_moved_constant_1300*(tmp_moved_constant_1321*tmp_moved_constant_1488 + tmp_moved_constant_1324*tmp_moved_constant_1489 + tmp_moved_constant_1327*tmp_moved_constant_1490 + tmp_moved_constant_1330*tmp_moved_constant_1491) + tmp_moved_constant_1301*(-jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1322 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1325 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1328 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1331) + tmp_moved_constant_1302*(-jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1332 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1333 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1334 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1335) + tmp_moved_constant_1303*(-jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1336 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1337 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1338 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1339) + tmp_moved_constant_1304*(tmp_moved_constant_1321*tmp_moved_constant_1342 + tmp_moved_constant_1324*tmp_moved_constant_1345 + tmp_moved_constant_1327*tmp_moved_constant_1348 + tmp_moved_constant_1330*tmp_moved_constant_1351) + tmp_moved_constant_1305*(tmp_moved_constant_1321*tmp_moved_constant_1354 + tmp_moved_constant_1324*tmp_moved_constant_1357 + tmp_moved_constant_1327*tmp_moved_constant_1360 + tmp_moved_constant_1330*tmp_moved_constant_1363) + tmp_moved_constant_1306*(tmp_moved_constant_1321*tmp_moved_constant_1366 + tmp_moved_constant_1324*tmp_moved_constant_1369 + tmp_moved_constant_1327*tmp_moved_constant_1372 + tmp_moved_constant_1330*tmp_moved_constant_1375) + tmp_moved_constant_1307*(tmp_moved_constant_1321*tmp_moved_constant_1448 + tmp_moved_constant_1324*tmp_moved_constant_1449 + tmp_moved_constant_1327*tmp_moved_constant_1450 + tmp_moved_constant_1330*tmp_moved_constant_1451) + tmp_moved_constant_1308*(tmp_moved_constant_1321*tmp_moved_constant_1452 + tmp_moved_constant_1324*tmp_moved_constant_1453 + tmp_moved_constant_1327*tmp_moved_constant_1454 + tmp_moved_constant_1330*tmp_moved_constant_1455) + tmp_moved_constant_1309*(tmp_moved_constant_1321*tmp_moved_constant_1456 + tmp_moved_constant_1324*tmp_moved_constant_1457 + tmp_moved_constant_1327*tmp_moved_constant_1458 + tmp_moved_constant_1330*tmp_moved_constant_1459) + tmp_moved_constant_1310*(tmp_moved_constant_1321*tmp_moved_constant_1492 + tmp_moved_constant_1324*tmp_moved_constant_1493 + tmp_moved_constant_1327*tmp_moved_constant_1494 + tmp_moved_constant_1330*tmp_moved_constant_1495) + tmp_moved_constant_1311*(-jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1322 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1325 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1328 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1331) + tmp_moved_constant_1312*(-jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1332 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1333 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1334 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1335) + tmp_moved_constant_1313*(-jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1336 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1337 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1338 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1339) + tmp_moved_constant_1314*(tmp_moved_constant_1321*tmp_moved_constant_1378 + tmp_moved_constant_1324*tmp_moved_constant_1381 + tmp_moved_constant_1327*tmp_moved_constant_1384 + tmp_moved_constant_1330*tmp_moved_constant_1387) + tmp_moved_constant_1315*(tmp_moved_constant_1321*tmp_moved_constant_1390 + tmp_moved_constant_1324*tmp_moved_constant_1393 + tmp_moved_constant_1327*tmp_moved_constant_1396 + tmp_moved_constant_1330*tmp_moved_constant_1399) + tmp_moved_constant_1316*(tmp_moved_constant_1321*tmp_moved_constant_1402 + tmp_moved_constant_1324*tmp_moved_constant_1405 + tmp_moved_constant_1327*tmp_moved_constant_1408 + tmp_moved_constant_1330*tmp_moved_constant_1411) + tmp_moved_constant_1317*(tmp_moved_constant_1321*tmp_moved_constant_1460 + tmp_moved_constant_1324*tmp_moved_constant_1461 + tmp_moved_constant_1327*tmp_moved_constant_1462 + tmp_moved_constant_1330*tmp_moved_constant_1463) + tmp_moved_constant_1318*(tmp_moved_constant_1321*tmp_moved_constant_1464 + tmp_moved_constant_1324*tmp_moved_constant_1465 + tmp_moved_constant_1327*tmp_moved_constant_1466 + tmp_moved_constant_1330*tmp_moved_constant_1467) + tmp_moved_constant_1319*(tmp_moved_constant_1321*tmp_moved_constant_1468 + tmp_moved_constant_1324*tmp_moved_constant_1469 + tmp_moved_constant_1327*tmp_moved_constant_1470 + tmp_moved_constant_1330*tmp_moved_constant_1471);
                   const real_t tmp_moved_constant_1545 = tmp_moved_constant_1290*(tmp_moved_constant_1484*tmp_moved_constant_1496 + tmp_moved_constant_1485*tmp_moved_constant_1498 + tmp_moved_constant_1486*tmp_moved_constant_1500 + tmp_moved_constant_1487*tmp_moved_constant_1502) + tmp_moved_constant_1291*(-jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1497 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1499 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1501 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1503) + tmp_moved_constant_1292*(-jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1504 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1505 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1506 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1507) + tmp_moved_constant_1293*(-jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1508 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1509 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1510 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1511) + tmp_moved_constant_1294*(tmp_moved_constant_1414*tmp_moved_constant_1496 + tmp_moved_constant_1417*tmp_moved_constant_1498 + tmp_moved_constant_1420*tmp_moved_constant_1500 + tmp_moved_constant_1423*tmp_moved_constant_1502) + tmp_moved_constant_1295*(tmp_moved_constant_1426*tmp_moved_constant_1496 + tmp_moved_constant_1429*tmp_moved_constant_1498 + tmp_moved_constant_1432*tmp_moved_constant_1500 + tmp_moved_constant_1435*tmp_moved_constant_1502) + tmp_moved_constant_1296*(tmp_moved_constant_1438*tmp_moved_constant_1496 + tmp_moved_constant_1441*tmp_moved_constant_1498 + tmp_moved_constant_1444*tmp_moved_constant_1500 + tmp_moved_constant_1447*tmp_moved_constant_1502) + tmp_moved_constant_1297*(tmp_moved_constant_1472*tmp_moved_constant_1496 + tmp_moved_constant_1473*tmp_moved_constant_1498 + tmp_moved_constant_1474*tmp_moved_constant_1500 + tmp_moved_constant_1475*tmp_moved_constant_1502) + tmp_moved_constant_1298*(tmp_moved_constant_1476*tmp_moved_constant_1496 + tmp_moved_constant_1477*tmp_moved_constant_1498 + tmp_moved_constant_1478*tmp_moved_constant_1500 + tmp_moved_constant_1479*tmp_moved_constant_1502) + tmp_moved_constant_1299*(tmp_moved_constant_1480*tmp_moved_constant_1496 + tmp_moved_constant_1481*tmp_moved_constant_1498 + tmp_moved_constant_1482*tmp_moved_constant_1500 + tmp_moved_constant_1483*tmp_moved_constant_1502) + tmp_moved_constant_1300*(tmp_moved_constant_1488*tmp_moved_constant_1496 + tmp_moved_constant_1489*tmp_moved_constant_1498 + tmp_moved_constant_1490*tmp_moved_constant_1500 + tmp_moved_constant_1491*tmp_moved_constant_1502) + tmp_moved_constant_1301*(-jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1497 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1499 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1501 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1503) + tmp_moved_constant_1302*(-jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1504 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1505 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1506 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1507) + tmp_moved_constant_1303*(-jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1508 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1509 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1510 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1511) + tmp_moved_constant_1304*(tmp_moved_constant_1342*tmp_moved_constant_1496 + tmp_moved_constant_1345*tmp_moved_constant_1498 + tmp_moved_constant_1348*tmp_moved_constant_1500 + tmp_moved_constant_1351*tmp_moved_constant_1502) + tmp_moved_constant_1305*(tmp_moved_constant_1354*tmp_moved_constant_1496 + tmp_moved_constant_1357*tmp_moved_constant_1498 + tmp_moved_constant_1360*tmp_moved_constant_1500 + tmp_moved_constant_1363*tmp_moved_constant_1502) + tmp_moved_constant_1306*(tmp_moved_constant_1366*tmp_moved_constant_1496 + tmp_moved_constant_1369*tmp_moved_constant_1498 + tmp_moved_constant_1372*tmp_moved_constant_1500 + tmp_moved_constant_1375*tmp_moved_constant_1502) + tmp_moved_constant_1307*(tmp_moved_constant_1448*tmp_moved_constant_1496 + tmp_moved_constant_1449*tmp_moved_constant_1498 + tmp_moved_constant_1450*tmp_moved_constant_1500 + tmp_moved_constant_1451*tmp_moved_constant_1502) + tmp_moved_constant_1308*(tmp_moved_constant_1452*tmp_moved_constant_1496 + tmp_moved_constant_1453*tmp_moved_constant_1498 + tmp_moved_constant_1454*tmp_moved_constant_1500 + tmp_moved_constant_1455*tmp_moved_constant_1502) + tmp_moved_constant_1309*(tmp_moved_constant_1456*tmp_moved_constant_1496 + tmp_moved_constant_1457*tmp_moved_constant_1498 + tmp_moved_constant_1458*tmp_moved_constant_1500 + tmp_moved_constant_1459*tmp_moved_constant_1502) + tmp_moved_constant_1310*(tmp_moved_constant_1492*tmp_moved_constant_1496 + tmp_moved_constant_1493*tmp_moved_constant_1498 + tmp_moved_constant_1494*tmp_moved_constant_1500 + tmp_moved_constant_1495*tmp_moved_constant_1502) + tmp_moved_constant_1311*(-jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1497 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1499 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1501 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1503) + tmp_moved_constant_1312*(-jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1504 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1505 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1506 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1507) + tmp_moved_constant_1313*(-jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1508 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1509 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1510 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1511) + tmp_moved_constant_1314*(tmp_moved_constant_1378*tmp_moved_constant_1496 + tmp_moved_constant_1381*tmp_moved_constant_1498 + tmp_moved_constant_1384*tmp_moved_constant_1500 + tmp_moved_constant_1387*tmp_moved_constant_1502) + tmp_moved_constant_1315*(tmp_moved_constant_1390*tmp_moved_constant_1496 + tmp_moved_constant_1393*tmp_moved_constant_1498 + tmp_moved_constant_1396*tmp_moved_constant_1500 + tmp_moved_constant_1399*tmp_moved_constant_1502) + tmp_moved_constant_1316*(tmp_moved_constant_1402*tmp_moved_constant_1496 + tmp_moved_constant_1405*tmp_moved_constant_1498 + tmp_moved_constant_1408*tmp_moved_constant_1500 + tmp_moved_constant_1411*tmp_moved_constant_1502) + tmp_moved_constant_1317*(tmp_moved_constant_1460*tmp_moved_constant_1496 + tmp_moved_constant_1461*tmp_moved_constant_1498 + tmp_moved_constant_1462*tmp_moved_constant_1500 + tmp_moved_constant_1463*tmp_moved_constant_1502) + tmp_moved_constant_1318*(tmp_moved_constant_1464*tmp_moved_constant_1496 + tmp_moved_constant_1465*tmp_moved_constant_1498 + tmp_moved_constant_1466*tmp_moved_constant_1500 + tmp_moved_constant_1467*tmp_moved_constant_1502) + tmp_moved_constant_1319*(tmp_moved_constant_1468*tmp_moved_constant_1496 + tmp_moved_constant_1469*tmp_moved_constant_1498 + tmp_moved_constant_1470*tmp_moved_constant_1500 + tmp_moved_constant_1471*tmp_moved_constant_1502);
                   const real_t tmp_moved_constant_1546 = tmp_moved_constant_1290*(tmp_moved_constant_1484*tmp_moved_constant_1512 + tmp_moved_constant_1485*tmp_moved_constant_1514 + tmp_moved_constant_1486*tmp_moved_constant_1516 + tmp_moved_constant_1487*tmp_moved_constant_1518) + tmp_moved_constant_1291*(-jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1513 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1515 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1517 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1519) + tmp_moved_constant_1292*(-jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1520 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1521 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1522 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1523) + tmp_moved_constant_1293*(-jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1524 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1525 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1526 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1527) + tmp_moved_constant_1294*(tmp_moved_constant_1414*tmp_moved_constant_1512 + tmp_moved_constant_1417*tmp_moved_constant_1514 + tmp_moved_constant_1420*tmp_moved_constant_1516 + tmp_moved_constant_1423*tmp_moved_constant_1518) + tmp_moved_constant_1295*(tmp_moved_constant_1426*tmp_moved_constant_1512 + tmp_moved_constant_1429*tmp_moved_constant_1514 + tmp_moved_constant_1432*tmp_moved_constant_1516 + tmp_moved_constant_1435*tmp_moved_constant_1518) + tmp_moved_constant_1296*(tmp_moved_constant_1438*tmp_moved_constant_1512 + tmp_moved_constant_1441*tmp_moved_constant_1514 + tmp_moved_constant_1444*tmp_moved_constant_1516 + tmp_moved_constant_1447*tmp_moved_constant_1518) + tmp_moved_constant_1297*(tmp_moved_constant_1472*tmp_moved_constant_1512 + tmp_moved_constant_1473*tmp_moved_constant_1514 + tmp_moved_constant_1474*tmp_moved_constant_1516 + tmp_moved_constant_1475*tmp_moved_constant_1518) + tmp_moved_constant_1298*(tmp_moved_constant_1476*tmp_moved_constant_1512 + tmp_moved_constant_1477*tmp_moved_constant_1514 + tmp_moved_constant_1478*tmp_moved_constant_1516 + tmp_moved_constant_1479*tmp_moved_constant_1518) + tmp_moved_constant_1299*(tmp_moved_constant_1480*tmp_moved_constant_1512 + tmp_moved_constant_1481*tmp_moved_constant_1514 + tmp_moved_constant_1482*tmp_moved_constant_1516 + tmp_moved_constant_1483*tmp_moved_constant_1518) + tmp_moved_constant_1300*(tmp_moved_constant_1488*tmp_moved_constant_1512 + tmp_moved_constant_1489*tmp_moved_constant_1514 + tmp_moved_constant_1490*tmp_moved_constant_1516 + tmp_moved_constant_1491*tmp_moved_constant_1518) + tmp_moved_constant_1301*(-jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1513 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1515 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1517 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1519) + tmp_moved_constant_1302*(-jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1520 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1521 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1522 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1523) + tmp_moved_constant_1303*(-jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1524 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1525 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1526 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1527) + tmp_moved_constant_1304*(tmp_moved_constant_1342*tmp_moved_constant_1512 + tmp_moved_constant_1345*tmp_moved_constant_1514 + tmp_moved_constant_1348*tmp_moved_constant_1516 + tmp_moved_constant_1351*tmp_moved_constant_1518) + tmp_moved_constant_1305*(tmp_moved_constant_1354*tmp_moved_constant_1512 + tmp_moved_constant_1357*tmp_moved_constant_1514 + tmp_moved_constant_1360*tmp_moved_constant_1516 + tmp_moved_constant_1363*tmp_moved_constant_1518) + tmp_moved_constant_1306*(tmp_moved_constant_1366*tmp_moved_constant_1512 + tmp_moved_constant_1369*tmp_moved_constant_1514 + tmp_moved_constant_1372*tmp_moved_constant_1516 + tmp_moved_constant_1375*tmp_moved_constant_1518) + tmp_moved_constant_1307*(tmp_moved_constant_1448*tmp_moved_constant_1512 + tmp_moved_constant_1449*tmp_moved_constant_1514 + tmp_moved_constant_1450*tmp_moved_constant_1516 + tmp_moved_constant_1451*tmp_moved_constant_1518) + tmp_moved_constant_1308*(tmp_moved_constant_1452*tmp_moved_constant_1512 + tmp_moved_constant_1453*tmp_moved_constant_1514 + tmp_moved_constant_1454*tmp_moved_constant_1516 + tmp_moved_constant_1455*tmp_moved_constant_1518) + tmp_moved_constant_1309*(tmp_moved_constant_1456*tmp_moved_constant_1512 + tmp_moved_constant_1457*tmp_moved_constant_1514 + tmp_moved_constant_1458*tmp_moved_constant_1516 + tmp_moved_constant_1459*tmp_moved_constant_1518) + tmp_moved_constant_1310*(tmp_moved_constant_1492*tmp_moved_constant_1512 + tmp_moved_constant_1493*tmp_moved_constant_1514 + tmp_moved_constant_1494*tmp_moved_constant_1516 + tmp_moved_constant_1495*tmp_moved_constant_1518) + tmp_moved_constant_1311*(-jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1513 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1515 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1517 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1519) + tmp_moved_constant_1312*(-jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1520 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1521 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1522 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1523) + tmp_moved_constant_1313*(-jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1524 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1525 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1526 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1527) + tmp_moved_constant_1314*(tmp_moved_constant_1378*tmp_moved_constant_1512 + tmp_moved_constant_1381*tmp_moved_constant_1514 + tmp_moved_constant_1384*tmp_moved_constant_1516 + tmp_moved_constant_1387*tmp_moved_constant_1518) + tmp_moved_constant_1315*(tmp_moved_constant_1390*tmp_moved_constant_1512 + tmp_moved_constant_1393*tmp_moved_constant_1514 + tmp_moved_constant_1396*tmp_moved_constant_1516 + tmp_moved_constant_1399*tmp_moved_constant_1518) + tmp_moved_constant_1316*(tmp_moved_constant_1402*tmp_moved_constant_1512 + tmp_moved_constant_1405*tmp_moved_constant_1514 + tmp_moved_constant_1408*tmp_moved_constant_1516 + tmp_moved_constant_1411*tmp_moved_constant_1518) + tmp_moved_constant_1317*(tmp_moved_constant_1460*tmp_moved_constant_1512 + tmp_moved_constant_1461*tmp_moved_constant_1514 + tmp_moved_constant_1462*tmp_moved_constant_1516 + tmp_moved_constant_1463*tmp_moved_constant_1518) + tmp_moved_constant_1318*(tmp_moved_constant_1464*tmp_moved_constant_1512 + tmp_moved_constant_1465*tmp_moved_constant_1514 + tmp_moved_constant_1466*tmp_moved_constant_1516 + tmp_moved_constant_1467*tmp_moved_constant_1518) + tmp_moved_constant_1319*(tmp_moved_constant_1468*tmp_moved_constant_1512 + tmp_moved_constant_1469*tmp_moved_constant_1514 + tmp_moved_constant_1470*tmp_moved_constant_1516 + tmp_moved_constant_1471*tmp_moved_constant_1518);
                   const real_t tmp_moved_constant_1547 = tmp_moved_constant_1290*(tmp_moved_constant_1484*tmp_moved_constant_1528 + tmp_moved_constant_1485*tmp_moved_constant_1530 + tmp_moved_constant_1486*tmp_moved_constant_1532 + tmp_moved_constant_1487*tmp_moved_constant_1534) + tmp_moved_constant_1291*(-jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1529 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1531 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1533 - jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_1535) + tmp_moved_constant_1292*(-jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1536 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1537 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1538 - jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_1539) + tmp_moved_constant_1293*(-jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1540 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1541 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1542 - jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_1543) + tmp_moved_constant_1294*(tmp_moved_constant_1414*tmp_moved_constant_1528 + tmp_moved_constant_1417*tmp_moved_constant_1530 + tmp_moved_constant_1420*tmp_moved_constant_1532 + tmp_moved_constant_1423*tmp_moved_constant_1534) + tmp_moved_constant_1295*(tmp_moved_constant_1426*tmp_moved_constant_1528 + tmp_moved_constant_1429*tmp_moved_constant_1530 + tmp_moved_constant_1432*tmp_moved_constant_1532 + tmp_moved_constant_1435*tmp_moved_constant_1534) + tmp_moved_constant_1296*(tmp_moved_constant_1438*tmp_moved_constant_1528 + tmp_moved_constant_1441*tmp_moved_constant_1530 + tmp_moved_constant_1444*tmp_moved_constant_1532 + tmp_moved_constant_1447*tmp_moved_constant_1534) + tmp_moved_constant_1297*(tmp_moved_constant_1472*tmp_moved_constant_1528 + tmp_moved_constant_1473*tmp_moved_constant_1530 + tmp_moved_constant_1474*tmp_moved_constant_1532 + tmp_moved_constant_1475*tmp_moved_constant_1534) + tmp_moved_constant_1298*(tmp_moved_constant_1476*tmp_moved_constant_1528 + tmp_moved_constant_1477*tmp_moved_constant_1530 + tmp_moved_constant_1478*tmp_moved_constant_1532 + tmp_moved_constant_1479*tmp_moved_constant_1534) + tmp_moved_constant_1299*(tmp_moved_constant_1480*tmp_moved_constant_1528 + tmp_moved_constant_1481*tmp_moved_constant_1530 + tmp_moved_constant_1482*tmp_moved_constant_1532 + tmp_moved_constant_1483*tmp_moved_constant_1534) + tmp_moved_constant_1300*(tmp_moved_constant_1488*tmp_moved_constant_1528 + tmp_moved_constant_1489*tmp_moved_constant_1530 + tmp_moved_constant_1490*tmp_moved_constant_1532 + tmp_moved_constant_1491*tmp_moved_constant_1534) + tmp_moved_constant_1301*(-jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1529 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1531 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1533 - jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_1535) + tmp_moved_constant_1302*(-jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1536 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1537 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1538 - jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_1539) + tmp_moved_constant_1303*(-jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1540 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1541 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1542 - jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_1543) + tmp_moved_constant_1304*(tmp_moved_constant_1342*tmp_moved_constant_1528 + tmp_moved_constant_1345*tmp_moved_constant_1530 + tmp_moved_constant_1348*tmp_moved_constant_1532 + tmp_moved_constant_1351*tmp_moved_constant_1534) + tmp_moved_constant_1305*(tmp_moved_constant_1354*tmp_moved_constant_1528 + tmp_moved_constant_1357*tmp_moved_constant_1530 + tmp_moved_constant_1360*tmp_moved_constant_1532 + tmp_moved_constant_1363*tmp_moved_constant_1534) + tmp_moved_constant_1306*(tmp_moved_constant_1366*tmp_moved_constant_1528 + tmp_moved_constant_1369*tmp_moved_constant_1530 + tmp_moved_constant_1372*tmp_moved_constant_1532 + tmp_moved_constant_1375*tmp_moved_constant_1534) + tmp_moved_constant_1307*(tmp_moved_constant_1448*tmp_moved_constant_1528 + tmp_moved_constant_1449*tmp_moved_constant_1530 + tmp_moved_constant_1450*tmp_moved_constant_1532 + tmp_moved_constant_1451*tmp_moved_constant_1534) + tmp_moved_constant_1308*(tmp_moved_constant_1452*tmp_moved_constant_1528 + tmp_moved_constant_1453*tmp_moved_constant_1530 + tmp_moved_constant_1454*tmp_moved_constant_1532 + tmp_moved_constant_1455*tmp_moved_constant_1534) + tmp_moved_constant_1309*(tmp_moved_constant_1456*tmp_moved_constant_1528 + tmp_moved_constant_1457*tmp_moved_constant_1530 + tmp_moved_constant_1458*tmp_moved_constant_1532 + tmp_moved_constant_1459*tmp_moved_constant_1534) + tmp_moved_constant_1310*(tmp_moved_constant_1492*tmp_moved_constant_1528 + tmp_moved_constant_1493*tmp_moved_constant_1530 + tmp_moved_constant_1494*tmp_moved_constant_1532 + tmp_moved_constant_1495*tmp_moved_constant_1534) + tmp_moved_constant_1311*(-jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1529 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1531 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1533 - jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_1535) + tmp_moved_constant_1312*(-jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1536 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1537 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1538 - jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_1539) + tmp_moved_constant_1313*(-jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1540 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1541 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1542 - jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_1543) + tmp_moved_constant_1314*(tmp_moved_constant_1378*tmp_moved_constant_1528 + tmp_moved_constant_1381*tmp_moved_constant_1530 + tmp_moved_constant_1384*tmp_moved_constant_1532 + tmp_moved_constant_1387*tmp_moved_constant_1534) + tmp_moved_constant_1315*(tmp_moved_constant_1390*tmp_moved_constant_1528 + tmp_moved_constant_1393*tmp_moved_constant_1530 + tmp_moved_constant_1396*tmp_moved_constant_1532 + tmp_moved_constant_1399*tmp_moved_constant_1534) + tmp_moved_constant_1316*(tmp_moved_constant_1402*tmp_moved_constant_1528 + tmp_moved_constant_1405*tmp_moved_constant_1530 + tmp_moved_constant_1408*tmp_moved_constant_1532 + tmp_moved_constant_1411*tmp_moved_constant_1534) + tmp_moved_constant_1317*(tmp_moved_constant_1460*tmp_moved_constant_1528 + tmp_moved_constant_1461*tmp_moved_constant_1530 + tmp_moved_constant_1462*tmp_moved_constant_1532 + tmp_moved_constant_1463*tmp_moved_constant_1534) + tmp_moved_constant_1318*(tmp_moved_constant_1464*tmp_moved_constant_1528 + tmp_moved_constant_1465*tmp_moved_constant_1530 + tmp_moved_constant_1466*tmp_moved_constant_1532 + tmp_moved_constant_1467*tmp_moved_constant_1534) + tmp_moved_constant_1319*(tmp_moved_constant_1468*tmp_moved_constant_1528 + tmp_moved_constant_1469*tmp_moved_constant_1530 + tmp_moved_constant_1470*tmp_moved_constant_1532 + tmp_moved_constant_1471*tmp_moved_constant_1534);
                   {
                      {
                     
                         const int64_t phantom_ctr_0 = ctr_0;
                         real_t _data_float_loop_ctr_array_dim_0[4];
                         _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                         _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                         _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                         _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                         real_t _data_float_loop_ctr_array_dim_1[4];
                         _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                         real_t _data_float_loop_ctr_array_dim_2[4];
                         _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                     
                         const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_1544 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_1545 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_1546 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_1547 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      }
                   }
                   const real_t tmp_moved_constant_1548 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1549 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1550 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1551 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1552 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1553 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1554 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1555 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1556 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1557 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1558 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1559 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1560 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1561 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1562 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1563 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1564 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1565 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1566 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1567 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1568 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1569 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1570 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1571 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1572 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1573 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1574 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1575 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1576 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1577 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1578 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
                   const real_t tmp_moved_constant_1579 = tmp_moved_constant_1578*0.13819660112501053;
                   const real_t tmp_moved_constant_1580 = tmp_kernel_op_1*tmp_moved_constant_1579;
                   const real_t tmp_moved_constant_1581 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
                   const real_t tmp_moved_constant_1582 = tmp_moved_constant_1581*0.13819660112501056;
                   const real_t tmp_moved_constant_1583 = tmp_kernel_op_6*tmp_moved_constant_1582;
                   const real_t tmp_moved_constant_1584 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
                   const real_t tmp_moved_constant_1585 = tmp_moved_constant_1584*0.13819660112501056;
                   const real_t tmp_moved_constant_1586 = tmp_kernel_op_11*tmp_moved_constant_1585;
                   const real_t tmp_moved_constant_1587 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
                   const real_t tmp_moved_constant_1588 = tmp_moved_constant_1587*0.5854101966249684;
                   const real_t tmp_moved_constant_1589 = tmp_kernel_op_16*tmp_moved_constant_1588;
                   const real_t tmp_moved_constant_1590 = tmp_kernel_op_21*tmp_moved_constant_1579;
                   const real_t tmp_moved_constant_1591 = tmp_kernel_op_24*tmp_moved_constant_1582;
                   const real_t tmp_moved_constant_1592 = tmp_kernel_op_27*tmp_moved_constant_1585;
                   const real_t tmp_moved_constant_1593 = tmp_kernel_op_30*tmp_moved_constant_1588;
                   const real_t tmp_moved_constant_1594 = tmp_kernel_op_33*tmp_moved_constant_1579;
                   const real_t tmp_moved_constant_1595 = tmp_kernel_op_36*tmp_moved_constant_1582;
                   const real_t tmp_moved_constant_1596 = tmp_kernel_op_39*tmp_moved_constant_1585;
                   const real_t tmp_moved_constant_1597 = tmp_kernel_op_42*tmp_moved_constant_1588;
                   const real_t tmp_moved_constant_1598 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1599 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1600 = -tmp_moved_constant_1598 - tmp_moved_constant_1599;
                   const real_t tmp_moved_constant_1601 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1602 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1603 = -tmp_moved_constant_1601 - tmp_moved_constant_1602;
                   const real_t tmp_moved_constant_1604 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1605 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1606 = -tmp_moved_constant_1604 - tmp_moved_constant_1605;
                   const real_t tmp_moved_constant_1607 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1608 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1609 = -tmp_moved_constant_1607 - tmp_moved_constant_1608;
                   const real_t tmp_moved_constant_1610 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1611 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1612 = -tmp_moved_constant_1610 - tmp_moved_constant_1611;
                   const real_t tmp_moved_constant_1613 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1614 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1615 = -tmp_moved_constant_1613 - tmp_moved_constant_1614;
                   const real_t tmp_moved_constant_1616 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1617 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1618 = -tmp_moved_constant_1616 - tmp_moved_constant_1617;
                   const real_t tmp_moved_constant_1619 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1620 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1621 = -tmp_moved_constant_1619 - tmp_moved_constant_1620;
                   const real_t tmp_moved_constant_1622 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1623 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1624 = -tmp_moved_constant_1622 - tmp_moved_constant_1623;
                   const real_t tmp_moved_constant_1625 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1626 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1627 = -tmp_moved_constant_1625 - tmp_moved_constant_1626;
                   const real_t tmp_moved_constant_1628 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1629 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1630 = -tmp_moved_constant_1628 - tmp_moved_constant_1629;
                   const real_t tmp_moved_constant_1631 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1632 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1633 = -tmp_moved_constant_1631 - tmp_moved_constant_1632;
                   const real_t tmp_moved_constant_1634 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1635 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1636 = -tmp_moved_constant_1634 - tmp_moved_constant_1635;
                   const real_t tmp_moved_constant_1637 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1638 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1639 = -tmp_moved_constant_1637 - tmp_moved_constant_1638;
                   const real_t tmp_moved_constant_1640 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1641 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1642 = -tmp_moved_constant_1640 - tmp_moved_constant_1641;
                   const real_t tmp_moved_constant_1643 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1644 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1645 = -tmp_moved_constant_1643 - tmp_moved_constant_1644;
                   const real_t tmp_moved_constant_1646 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1647 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1648 = -tmp_moved_constant_1646 - tmp_moved_constant_1647;
                   const real_t tmp_moved_constant_1649 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1650 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1651 = -tmp_moved_constant_1649 - tmp_moved_constant_1650;
                   const real_t tmp_moved_constant_1652 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1653 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1654 = -tmp_moved_constant_1652 - tmp_moved_constant_1653;
                   const real_t tmp_moved_constant_1655 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1656 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1657 = -tmp_moved_constant_1655 - tmp_moved_constant_1656;
                   const real_t tmp_moved_constant_1658 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1659 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1660 = -tmp_moved_constant_1658 - tmp_moved_constant_1659;
                   const real_t tmp_moved_constant_1661 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1662 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1663 = -tmp_moved_constant_1661 - tmp_moved_constant_1662;
                   const real_t tmp_moved_constant_1664 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1665 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1666 = -tmp_moved_constant_1664 - tmp_moved_constant_1665;
                   const real_t tmp_moved_constant_1667 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1668 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1669 = -tmp_moved_constant_1667 - tmp_moved_constant_1668;
                   const real_t tmp_moved_constant_1670 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1671 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1672 = -tmp_moved_constant_1670 - tmp_moved_constant_1671;
                   const real_t tmp_moved_constant_1673 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1674 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1675 = -tmp_moved_constant_1673 - tmp_moved_constant_1674;
                   const real_t tmp_moved_constant_1676 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1677 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1678 = -tmp_moved_constant_1676 - tmp_moved_constant_1677;
                   const real_t tmp_moved_constant_1679 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1680 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1681 = -tmp_moved_constant_1679 - tmp_moved_constant_1680;
                   const real_t tmp_moved_constant_1682 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1683 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1684 = -tmp_moved_constant_1682 - tmp_moved_constant_1683;
                   const real_t tmp_moved_constant_1685 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1686 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1687 = -tmp_moved_constant_1685 - tmp_moved_constant_1686;
                   const real_t tmp_moved_constant_1688 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1689 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1690 = -tmp_moved_constant_1688 - tmp_moved_constant_1689;
                   const real_t tmp_moved_constant_1691 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1692 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1693 = -tmp_moved_constant_1691 - tmp_moved_constant_1692;
                   const real_t tmp_moved_constant_1694 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1695 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1696 = -tmp_moved_constant_1694 - tmp_moved_constant_1695;
                   const real_t tmp_moved_constant_1697 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1698 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1699 = -tmp_moved_constant_1697 - tmp_moved_constant_1698;
                   const real_t tmp_moved_constant_1700 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1701 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1702 = -tmp_moved_constant_1700 - tmp_moved_constant_1701;
                   const real_t tmp_moved_constant_1703 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1704 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1705 = -tmp_moved_constant_1703 - tmp_moved_constant_1704;
                   const real_t tmp_moved_constant_1706 = -jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_1598 + tmp_moved_constant_1610;
                   const real_t tmp_moved_constant_1707 = -jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_1601 + tmp_moved_constant_1613;
                   const real_t tmp_moved_constant_1708 = -jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_1604 + tmp_moved_constant_1616;
                   const real_t tmp_moved_constant_1709 = -jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_1607 + tmp_moved_constant_1619;
                   const real_t tmp_moved_constant_1710 = -jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_1599 + tmp_moved_constant_1622;
                   const real_t tmp_moved_constant_1711 = -jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_1602 + tmp_moved_constant_1625;
                   const real_t tmp_moved_constant_1712 = -jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_1605 + tmp_moved_constant_1628;
                   const real_t tmp_moved_constant_1713 = -jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_1608 + tmp_moved_constant_1631;
                   const real_t tmp_moved_constant_1714 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_1611 + tmp_moved_constant_1623;
                   const real_t tmp_moved_constant_1715 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_1614 + tmp_moved_constant_1626;
                   const real_t tmp_moved_constant_1716 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_1617 + tmp_moved_constant_1629;
                   const real_t tmp_moved_constant_1717 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_1620 + tmp_moved_constant_1632;
                   const real_t tmp_moved_constant_1718 = -jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_1634 + tmp_moved_constant_1646;
                   const real_t tmp_moved_constant_1719 = -jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_1637 + tmp_moved_constant_1649;
                   const real_t tmp_moved_constant_1720 = -jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_1640 + tmp_moved_constant_1652;
                   const real_t tmp_moved_constant_1721 = -jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_1643 + tmp_moved_constant_1655;
                   const real_t tmp_moved_constant_1722 = -jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_1635 + tmp_moved_constant_1658;
                   const real_t tmp_moved_constant_1723 = -jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_1638 + tmp_moved_constant_1661;
                   const real_t tmp_moved_constant_1724 = -jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_1641 + tmp_moved_constant_1664;
                   const real_t tmp_moved_constant_1725 = -jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_1644 + tmp_moved_constant_1667;
                   const real_t tmp_moved_constant_1726 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_1647 + tmp_moved_constant_1659;
                   const real_t tmp_moved_constant_1727 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_1650 + tmp_moved_constant_1662;
                   const real_t tmp_moved_constant_1728 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_1653 + tmp_moved_constant_1665;
                   const real_t tmp_moved_constant_1729 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_1656 + tmp_moved_constant_1668;
                   const real_t tmp_moved_constant_1730 = -jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_153 + tmp_moved_constant_1670 + tmp_moved_constant_1682;
                   const real_t tmp_moved_constant_1731 = -jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_156 + tmp_moved_constant_1673 + tmp_moved_constant_1685;
                   const real_t tmp_moved_constant_1732 = -jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_159 + tmp_moved_constant_1676 + tmp_moved_constant_1688;
                   const real_t tmp_moved_constant_1733 = -jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_162 + tmp_moved_constant_1679 + tmp_moved_constant_1691;
                   const real_t tmp_moved_constant_1734 = -jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_165 + tmp_moved_constant_1671 + tmp_moved_constant_1694;
                   const real_t tmp_moved_constant_1735 = -jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_168 + tmp_moved_constant_1674 + tmp_moved_constant_1697;
                   const real_t tmp_moved_constant_1736 = -jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_171 + tmp_moved_constant_1677 + tmp_moved_constant_1700;
                   const real_t tmp_moved_constant_1737 = -jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_174 + tmp_moved_constant_1680 + tmp_moved_constant_1703;
                   const real_t tmp_moved_constant_1738 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_176 + tmp_moved_constant_1683 + tmp_moved_constant_1695;
                   const real_t tmp_moved_constant_1739 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_178 + tmp_moved_constant_1686 + tmp_moved_constant_1698;
                   const real_t tmp_moved_constant_1740 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_180 + tmp_moved_constant_1689 + tmp_moved_constant_1701;
                   const real_t tmp_moved_constant_1741 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_182 + tmp_moved_constant_1692 + tmp_moved_constant_1704;
                   const real_t tmp_moved_constant_1742 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_1743 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_1744 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_1745 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_1746 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_1747 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_1748 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_1749 = -jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_1750 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_1751 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_1752 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_1753 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_1754 = tmp_moved_constant_1578*0.1381966011250105;
                   const real_t tmp_moved_constant_1755 = tmp_kernel_op_1*tmp_moved_constant_1754;
                   const real_t tmp_moved_constant_1756 = tmp_moved_constant_1581*0.1381966011250105;
                   const real_t tmp_moved_constant_1757 = tmp_kernel_op_6*tmp_moved_constant_1756;
                   const real_t tmp_moved_constant_1758 = tmp_moved_constant_1584*0.5854101966249684;
                   const real_t tmp_moved_constant_1759 = tmp_kernel_op_11*tmp_moved_constant_1758;
                   const real_t tmp_moved_constant_1760 = tmp_moved_constant_1587*0.1381966011250105;
                   const real_t tmp_moved_constant_1761 = tmp_kernel_op_16*tmp_moved_constant_1760;
                   const real_t tmp_moved_constant_1762 = tmp_kernel_op_21*tmp_moved_constant_1754;
                   const real_t tmp_moved_constant_1763 = tmp_kernel_op_24*tmp_moved_constant_1756;
                   const real_t tmp_moved_constant_1764 = tmp_kernel_op_27*tmp_moved_constant_1758;
                   const real_t tmp_moved_constant_1765 = tmp_kernel_op_30*tmp_moved_constant_1760;
                   const real_t tmp_moved_constant_1766 = tmp_kernel_op_33*tmp_moved_constant_1754;
                   const real_t tmp_moved_constant_1767 = tmp_kernel_op_36*tmp_moved_constant_1756;
                   const real_t tmp_moved_constant_1768 = tmp_kernel_op_39*tmp_moved_constant_1758;
                   const real_t tmp_moved_constant_1769 = tmp_kernel_op_42*tmp_moved_constant_1760;
                   const real_t tmp_moved_constant_1770 = tmp_moved_constant_1578*0.1381966011250105;
                   const real_t tmp_moved_constant_1771 = tmp_kernel_op_1*tmp_moved_constant_1770;
                   const real_t tmp_moved_constant_1772 = tmp_moved_constant_1581*0.5854101966249684;
                   const real_t tmp_moved_constant_1773 = tmp_kernel_op_6*tmp_moved_constant_1772;
                   const real_t tmp_moved_constant_1774 = tmp_moved_constant_1584*0.1381966011250105;
                   const real_t tmp_moved_constant_1775 = tmp_kernel_op_11*tmp_moved_constant_1774;
                   const real_t tmp_moved_constant_1776 = tmp_moved_constant_1587*0.1381966011250105;
                   const real_t tmp_moved_constant_1777 = tmp_kernel_op_16*tmp_moved_constant_1776;
                   const real_t tmp_moved_constant_1778 = tmp_kernel_op_21*tmp_moved_constant_1770;
                   const real_t tmp_moved_constant_1779 = tmp_kernel_op_24*tmp_moved_constant_1772;
                   const real_t tmp_moved_constant_1780 = tmp_kernel_op_27*tmp_moved_constant_1774;
                   const real_t tmp_moved_constant_1781 = tmp_kernel_op_30*tmp_moved_constant_1776;
                   const real_t tmp_moved_constant_1782 = tmp_kernel_op_33*tmp_moved_constant_1770;
                   const real_t tmp_moved_constant_1783 = tmp_kernel_op_36*tmp_moved_constant_1772;
                   const real_t tmp_moved_constant_1784 = tmp_kernel_op_39*tmp_moved_constant_1774;
                   const real_t tmp_moved_constant_1785 = tmp_kernel_op_42*tmp_moved_constant_1776;
                   const real_t tmp_moved_constant_1786 = tmp_moved_constant_1578*0.5854101966249684;
                   const real_t tmp_moved_constant_1787 = tmp_kernel_op_1*tmp_moved_constant_1786;
                   const real_t tmp_moved_constant_1788 = tmp_moved_constant_1581*0.1381966011250105;
                   const real_t tmp_moved_constant_1789 = tmp_kernel_op_6*tmp_moved_constant_1788;
                   const real_t tmp_moved_constant_1790 = tmp_moved_constant_1584*0.1381966011250105;
                   const real_t tmp_moved_constant_1791 = tmp_kernel_op_11*tmp_moved_constant_1790;
                   const real_t tmp_moved_constant_1792 = tmp_moved_constant_1587*0.1381966011250105;
                   const real_t tmp_moved_constant_1793 = tmp_kernel_op_16*tmp_moved_constant_1792;
                   const real_t tmp_moved_constant_1794 = tmp_kernel_op_21*tmp_moved_constant_1786;
                   const real_t tmp_moved_constant_1795 = tmp_kernel_op_24*tmp_moved_constant_1788;
                   const real_t tmp_moved_constant_1796 = tmp_kernel_op_27*tmp_moved_constant_1790;
                   const real_t tmp_moved_constant_1797 = tmp_kernel_op_30*tmp_moved_constant_1792;
                   const real_t tmp_moved_constant_1798 = tmp_kernel_op_33*tmp_moved_constant_1786;
                   const real_t tmp_moved_constant_1799 = tmp_kernel_op_36*tmp_moved_constant_1788;
                   const real_t tmp_moved_constant_1800 = tmp_kernel_op_39*tmp_moved_constant_1790;
                   const real_t tmp_moved_constant_1801 = tmp_kernel_op_42*tmp_moved_constant_1792;
                   const real_t tmp_moved_constant_1802 = tmp_moved_constant_1548*(tmp_moved_constant_1579*tmp_moved_constant_1742 + tmp_moved_constant_1582*tmp_moved_constant_1743 + tmp_moved_constant_1585*tmp_moved_constant_1744 + tmp_moved_constant_1588*tmp_moved_constant_1745) + tmp_moved_constant_1549*(-jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1580 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1583 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1586 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1589) + tmp_moved_constant_1550*(-jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1590 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1591 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1592 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1593) + tmp_moved_constant_1551*(-jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1594 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1595 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1596 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1597) + tmp_moved_constant_1552*(tmp_moved_constant_1579*tmp_moved_constant_1672 + tmp_moved_constant_1582*tmp_moved_constant_1675 + tmp_moved_constant_1585*tmp_moved_constant_1678 + tmp_moved_constant_1588*tmp_moved_constant_1681) + tmp_moved_constant_1553*(tmp_moved_constant_1579*tmp_moved_constant_1684 + tmp_moved_constant_1582*tmp_moved_constant_1687 + tmp_moved_constant_1585*tmp_moved_constant_1690 + tmp_moved_constant_1588*tmp_moved_constant_1693) + tmp_moved_constant_1554*(tmp_moved_constant_1579*tmp_moved_constant_1696 + tmp_moved_constant_1582*tmp_moved_constant_1699 + tmp_moved_constant_1585*tmp_moved_constant_1702 + tmp_moved_constant_1588*tmp_moved_constant_1705) + tmp_moved_constant_1555*(tmp_moved_constant_1579*tmp_moved_constant_1730 + tmp_moved_constant_1582*tmp_moved_constant_1731 + tmp_moved_constant_1585*tmp_moved_constant_1732 + tmp_moved_constant_1588*tmp_moved_constant_1733) + tmp_moved_constant_1556*(tmp_moved_constant_1579*tmp_moved_constant_1734 + tmp_moved_constant_1582*tmp_moved_constant_1735 + tmp_moved_constant_1585*tmp_moved_constant_1736 + tmp_moved_constant_1588*tmp_moved_constant_1737) + tmp_moved_constant_1557*(tmp_moved_constant_1579*tmp_moved_constant_1738 + tmp_moved_constant_1582*tmp_moved_constant_1739 + tmp_moved_constant_1585*tmp_moved_constant_1740 + tmp_moved_constant_1588*tmp_moved_constant_1741) + tmp_moved_constant_1558*(tmp_moved_constant_1579*tmp_moved_constant_1746 + tmp_moved_constant_1582*tmp_moved_constant_1747 + tmp_moved_constant_1585*tmp_moved_constant_1748 + tmp_moved_constant_1588*tmp_moved_constant_1749) + tmp_moved_constant_1559*(-jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1580 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1583 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1586 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1589) + tmp_moved_constant_1560*(-jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1590 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1591 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1592 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1593) + tmp_moved_constant_1561*(-jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1594 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1595 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1596 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1597) + tmp_moved_constant_1562*(tmp_moved_constant_1579*tmp_moved_constant_1600 + tmp_moved_constant_1582*tmp_moved_constant_1603 + tmp_moved_constant_1585*tmp_moved_constant_1606 + tmp_moved_constant_1588*tmp_moved_constant_1609) + tmp_moved_constant_1563*(tmp_moved_constant_1579*tmp_moved_constant_1612 + tmp_moved_constant_1582*tmp_moved_constant_1615 + tmp_moved_constant_1585*tmp_moved_constant_1618 + tmp_moved_constant_1588*tmp_moved_constant_1621) + tmp_moved_constant_1564*(tmp_moved_constant_1579*tmp_moved_constant_1624 + tmp_moved_constant_1582*tmp_moved_constant_1627 + tmp_moved_constant_1585*tmp_moved_constant_1630 + tmp_moved_constant_1588*tmp_moved_constant_1633) + tmp_moved_constant_1565*(tmp_moved_constant_1579*tmp_moved_constant_1706 + tmp_moved_constant_1582*tmp_moved_constant_1707 + tmp_moved_constant_1585*tmp_moved_constant_1708 + tmp_moved_constant_1588*tmp_moved_constant_1709) + tmp_moved_constant_1566*(tmp_moved_constant_1579*tmp_moved_constant_1710 + tmp_moved_constant_1582*tmp_moved_constant_1711 + tmp_moved_constant_1585*tmp_moved_constant_1712 + tmp_moved_constant_1588*tmp_moved_constant_1713) + tmp_moved_constant_1567*(tmp_moved_constant_1579*tmp_moved_constant_1714 + tmp_moved_constant_1582*tmp_moved_constant_1715 + tmp_moved_constant_1585*tmp_moved_constant_1716 + tmp_moved_constant_1588*tmp_moved_constant_1717) + tmp_moved_constant_1568*(tmp_moved_constant_1579*tmp_moved_constant_1750 + tmp_moved_constant_1582*tmp_moved_constant_1751 + tmp_moved_constant_1585*tmp_moved_constant_1752 + tmp_moved_constant_1588*tmp_moved_constant_1753) + tmp_moved_constant_1569*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1580 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1583 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1586 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1589) + tmp_moved_constant_1570*(-jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1590 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1591 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1592 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1593) + tmp_moved_constant_1571*(-jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1594 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1595 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1596 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1597) + tmp_moved_constant_1572*(tmp_moved_constant_1579*tmp_moved_constant_1636 + tmp_moved_constant_1582*tmp_moved_constant_1639 + tmp_moved_constant_1585*tmp_moved_constant_1642 + tmp_moved_constant_1588*tmp_moved_constant_1645) + tmp_moved_constant_1573*(tmp_moved_constant_1579*tmp_moved_constant_1648 + tmp_moved_constant_1582*tmp_moved_constant_1651 + tmp_moved_constant_1585*tmp_moved_constant_1654 + tmp_moved_constant_1588*tmp_moved_constant_1657) + tmp_moved_constant_1574*(tmp_moved_constant_1579*tmp_moved_constant_1660 + tmp_moved_constant_1582*tmp_moved_constant_1663 + tmp_moved_constant_1585*tmp_moved_constant_1666 + tmp_moved_constant_1588*tmp_moved_constant_1669) + tmp_moved_constant_1575*(tmp_moved_constant_1579*tmp_moved_constant_1718 + tmp_moved_constant_1582*tmp_moved_constant_1719 + tmp_moved_constant_1585*tmp_moved_constant_1720 + tmp_moved_constant_1588*tmp_moved_constant_1721) + tmp_moved_constant_1576*(tmp_moved_constant_1579*tmp_moved_constant_1722 + tmp_moved_constant_1582*tmp_moved_constant_1723 + tmp_moved_constant_1585*tmp_moved_constant_1724 + tmp_moved_constant_1588*tmp_moved_constant_1725) + tmp_moved_constant_1577*(tmp_moved_constant_1579*tmp_moved_constant_1726 + tmp_moved_constant_1582*tmp_moved_constant_1727 + tmp_moved_constant_1585*tmp_moved_constant_1728 + tmp_moved_constant_1588*tmp_moved_constant_1729);
                   const real_t tmp_moved_constant_1803 = tmp_moved_constant_1548*(tmp_moved_constant_1742*tmp_moved_constant_1754 + tmp_moved_constant_1743*tmp_moved_constant_1756 + tmp_moved_constant_1744*tmp_moved_constant_1758 + tmp_moved_constant_1745*tmp_moved_constant_1760) + tmp_moved_constant_1549*(-jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1755 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1757 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1759 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1761) + tmp_moved_constant_1550*(-jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1762 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1763 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1764 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1765) + tmp_moved_constant_1551*(-jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1766 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1767 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1768 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1769) + tmp_moved_constant_1552*(tmp_moved_constant_1672*tmp_moved_constant_1754 + tmp_moved_constant_1675*tmp_moved_constant_1756 + tmp_moved_constant_1678*tmp_moved_constant_1758 + tmp_moved_constant_1681*tmp_moved_constant_1760) + tmp_moved_constant_1553*(tmp_moved_constant_1684*tmp_moved_constant_1754 + tmp_moved_constant_1687*tmp_moved_constant_1756 + tmp_moved_constant_1690*tmp_moved_constant_1758 + tmp_moved_constant_1693*tmp_moved_constant_1760) + tmp_moved_constant_1554*(tmp_moved_constant_1696*tmp_moved_constant_1754 + tmp_moved_constant_1699*tmp_moved_constant_1756 + tmp_moved_constant_1702*tmp_moved_constant_1758 + tmp_moved_constant_1705*tmp_moved_constant_1760) + tmp_moved_constant_1555*(tmp_moved_constant_1730*tmp_moved_constant_1754 + tmp_moved_constant_1731*tmp_moved_constant_1756 + tmp_moved_constant_1732*tmp_moved_constant_1758 + tmp_moved_constant_1733*tmp_moved_constant_1760) + tmp_moved_constant_1556*(tmp_moved_constant_1734*tmp_moved_constant_1754 + tmp_moved_constant_1735*tmp_moved_constant_1756 + tmp_moved_constant_1736*tmp_moved_constant_1758 + tmp_moved_constant_1737*tmp_moved_constant_1760) + tmp_moved_constant_1557*(tmp_moved_constant_1738*tmp_moved_constant_1754 + tmp_moved_constant_1739*tmp_moved_constant_1756 + tmp_moved_constant_1740*tmp_moved_constant_1758 + tmp_moved_constant_1741*tmp_moved_constant_1760) + tmp_moved_constant_1558*(tmp_moved_constant_1746*tmp_moved_constant_1754 + tmp_moved_constant_1747*tmp_moved_constant_1756 + tmp_moved_constant_1748*tmp_moved_constant_1758 + tmp_moved_constant_1749*tmp_moved_constant_1760) + tmp_moved_constant_1559*(-jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1755 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1757 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1759 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1761) + tmp_moved_constant_1560*(-jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1762 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1763 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1764 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1765) + tmp_moved_constant_1561*(-jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1766 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1767 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1768 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1769) + tmp_moved_constant_1562*(tmp_moved_constant_1600*tmp_moved_constant_1754 + tmp_moved_constant_1603*tmp_moved_constant_1756 + tmp_moved_constant_1606*tmp_moved_constant_1758 + tmp_moved_constant_1609*tmp_moved_constant_1760) + tmp_moved_constant_1563*(tmp_moved_constant_1612*tmp_moved_constant_1754 + tmp_moved_constant_1615*tmp_moved_constant_1756 + tmp_moved_constant_1618*tmp_moved_constant_1758 + tmp_moved_constant_1621*tmp_moved_constant_1760) + tmp_moved_constant_1564*(tmp_moved_constant_1624*tmp_moved_constant_1754 + tmp_moved_constant_1627*tmp_moved_constant_1756 + tmp_moved_constant_1630*tmp_moved_constant_1758 + tmp_moved_constant_1633*tmp_moved_constant_1760) + tmp_moved_constant_1565*(tmp_moved_constant_1706*tmp_moved_constant_1754 + tmp_moved_constant_1707*tmp_moved_constant_1756 + tmp_moved_constant_1708*tmp_moved_constant_1758 + tmp_moved_constant_1709*tmp_moved_constant_1760) + tmp_moved_constant_1566*(tmp_moved_constant_1710*tmp_moved_constant_1754 + tmp_moved_constant_1711*tmp_moved_constant_1756 + tmp_moved_constant_1712*tmp_moved_constant_1758 + tmp_moved_constant_1713*tmp_moved_constant_1760) + tmp_moved_constant_1567*(tmp_moved_constant_1714*tmp_moved_constant_1754 + tmp_moved_constant_1715*tmp_moved_constant_1756 + tmp_moved_constant_1716*tmp_moved_constant_1758 + tmp_moved_constant_1717*tmp_moved_constant_1760) + tmp_moved_constant_1568*(tmp_moved_constant_1750*tmp_moved_constant_1754 + tmp_moved_constant_1751*tmp_moved_constant_1756 + tmp_moved_constant_1752*tmp_moved_constant_1758 + tmp_moved_constant_1753*tmp_moved_constant_1760) + tmp_moved_constant_1569*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1755 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1757 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1759 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1761) + tmp_moved_constant_1570*(-jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1762 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1763 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1764 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1765) + tmp_moved_constant_1571*(-jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1766 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1767 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1768 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1769) + tmp_moved_constant_1572*(tmp_moved_constant_1636*tmp_moved_constant_1754 + tmp_moved_constant_1639*tmp_moved_constant_1756 + tmp_moved_constant_1642*tmp_moved_constant_1758 + tmp_moved_constant_1645*tmp_moved_constant_1760) + tmp_moved_constant_1573*(tmp_moved_constant_1648*tmp_moved_constant_1754 + tmp_moved_constant_1651*tmp_moved_constant_1756 + tmp_moved_constant_1654*tmp_moved_constant_1758 + tmp_moved_constant_1657*tmp_moved_constant_1760) + tmp_moved_constant_1574*(tmp_moved_constant_1660*tmp_moved_constant_1754 + tmp_moved_constant_1663*tmp_moved_constant_1756 + tmp_moved_constant_1666*tmp_moved_constant_1758 + tmp_moved_constant_1669*tmp_moved_constant_1760) + tmp_moved_constant_1575*(tmp_moved_constant_1718*tmp_moved_constant_1754 + tmp_moved_constant_1719*tmp_moved_constant_1756 + tmp_moved_constant_1720*tmp_moved_constant_1758 + tmp_moved_constant_1721*tmp_moved_constant_1760) + tmp_moved_constant_1576*(tmp_moved_constant_1722*tmp_moved_constant_1754 + tmp_moved_constant_1723*tmp_moved_constant_1756 + tmp_moved_constant_1724*tmp_moved_constant_1758 + tmp_moved_constant_1725*tmp_moved_constant_1760) + tmp_moved_constant_1577*(tmp_moved_constant_1726*tmp_moved_constant_1754 + tmp_moved_constant_1727*tmp_moved_constant_1756 + tmp_moved_constant_1728*tmp_moved_constant_1758 + tmp_moved_constant_1729*tmp_moved_constant_1760);
                   const real_t tmp_moved_constant_1804 = tmp_moved_constant_1548*(tmp_moved_constant_1742*tmp_moved_constant_1770 + tmp_moved_constant_1743*tmp_moved_constant_1772 + tmp_moved_constant_1744*tmp_moved_constant_1774 + tmp_moved_constant_1745*tmp_moved_constant_1776) + tmp_moved_constant_1549*(-jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1771 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1773 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1775 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1777) + tmp_moved_constant_1550*(-jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1778 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1779 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1780 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1781) + tmp_moved_constant_1551*(-jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1782 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1783 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1784 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1785) + tmp_moved_constant_1552*(tmp_moved_constant_1672*tmp_moved_constant_1770 + tmp_moved_constant_1675*tmp_moved_constant_1772 + tmp_moved_constant_1678*tmp_moved_constant_1774 + tmp_moved_constant_1681*tmp_moved_constant_1776) + tmp_moved_constant_1553*(tmp_moved_constant_1684*tmp_moved_constant_1770 + tmp_moved_constant_1687*tmp_moved_constant_1772 + tmp_moved_constant_1690*tmp_moved_constant_1774 + tmp_moved_constant_1693*tmp_moved_constant_1776) + tmp_moved_constant_1554*(tmp_moved_constant_1696*tmp_moved_constant_1770 + tmp_moved_constant_1699*tmp_moved_constant_1772 + tmp_moved_constant_1702*tmp_moved_constant_1774 + tmp_moved_constant_1705*tmp_moved_constant_1776) + tmp_moved_constant_1555*(tmp_moved_constant_1730*tmp_moved_constant_1770 + tmp_moved_constant_1731*tmp_moved_constant_1772 + tmp_moved_constant_1732*tmp_moved_constant_1774 + tmp_moved_constant_1733*tmp_moved_constant_1776) + tmp_moved_constant_1556*(tmp_moved_constant_1734*tmp_moved_constant_1770 + tmp_moved_constant_1735*tmp_moved_constant_1772 + tmp_moved_constant_1736*tmp_moved_constant_1774 + tmp_moved_constant_1737*tmp_moved_constant_1776) + tmp_moved_constant_1557*(tmp_moved_constant_1738*tmp_moved_constant_1770 + tmp_moved_constant_1739*tmp_moved_constant_1772 + tmp_moved_constant_1740*tmp_moved_constant_1774 + tmp_moved_constant_1741*tmp_moved_constant_1776) + tmp_moved_constant_1558*(tmp_moved_constant_1746*tmp_moved_constant_1770 + tmp_moved_constant_1747*tmp_moved_constant_1772 + tmp_moved_constant_1748*tmp_moved_constant_1774 + tmp_moved_constant_1749*tmp_moved_constant_1776) + tmp_moved_constant_1559*(-jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1771 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1773 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1775 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1777) + tmp_moved_constant_1560*(-jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1778 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1779 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1780 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1781) + tmp_moved_constant_1561*(-jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1782 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1783 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1784 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1785) + tmp_moved_constant_1562*(tmp_moved_constant_1600*tmp_moved_constant_1770 + tmp_moved_constant_1603*tmp_moved_constant_1772 + tmp_moved_constant_1606*tmp_moved_constant_1774 + tmp_moved_constant_1609*tmp_moved_constant_1776) + tmp_moved_constant_1563*(tmp_moved_constant_1612*tmp_moved_constant_1770 + tmp_moved_constant_1615*tmp_moved_constant_1772 + tmp_moved_constant_1618*tmp_moved_constant_1774 + tmp_moved_constant_1621*tmp_moved_constant_1776) + tmp_moved_constant_1564*(tmp_moved_constant_1624*tmp_moved_constant_1770 + tmp_moved_constant_1627*tmp_moved_constant_1772 + tmp_moved_constant_1630*tmp_moved_constant_1774 + tmp_moved_constant_1633*tmp_moved_constant_1776) + tmp_moved_constant_1565*(tmp_moved_constant_1706*tmp_moved_constant_1770 + tmp_moved_constant_1707*tmp_moved_constant_1772 + tmp_moved_constant_1708*tmp_moved_constant_1774 + tmp_moved_constant_1709*tmp_moved_constant_1776) + tmp_moved_constant_1566*(tmp_moved_constant_1710*tmp_moved_constant_1770 + tmp_moved_constant_1711*tmp_moved_constant_1772 + tmp_moved_constant_1712*tmp_moved_constant_1774 + tmp_moved_constant_1713*tmp_moved_constant_1776) + tmp_moved_constant_1567*(tmp_moved_constant_1714*tmp_moved_constant_1770 + tmp_moved_constant_1715*tmp_moved_constant_1772 + tmp_moved_constant_1716*tmp_moved_constant_1774 + tmp_moved_constant_1717*tmp_moved_constant_1776) + tmp_moved_constant_1568*(tmp_moved_constant_1750*tmp_moved_constant_1770 + tmp_moved_constant_1751*tmp_moved_constant_1772 + tmp_moved_constant_1752*tmp_moved_constant_1774 + tmp_moved_constant_1753*tmp_moved_constant_1776) + tmp_moved_constant_1569*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1771 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1773 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1775 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1777) + tmp_moved_constant_1570*(-jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1778 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1779 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1780 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1781) + tmp_moved_constant_1571*(-jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1782 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1783 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1784 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1785) + tmp_moved_constant_1572*(tmp_moved_constant_1636*tmp_moved_constant_1770 + tmp_moved_constant_1639*tmp_moved_constant_1772 + tmp_moved_constant_1642*tmp_moved_constant_1774 + tmp_moved_constant_1645*tmp_moved_constant_1776) + tmp_moved_constant_1573*(tmp_moved_constant_1648*tmp_moved_constant_1770 + tmp_moved_constant_1651*tmp_moved_constant_1772 + tmp_moved_constant_1654*tmp_moved_constant_1774 + tmp_moved_constant_1657*tmp_moved_constant_1776) + tmp_moved_constant_1574*(tmp_moved_constant_1660*tmp_moved_constant_1770 + tmp_moved_constant_1663*tmp_moved_constant_1772 + tmp_moved_constant_1666*tmp_moved_constant_1774 + tmp_moved_constant_1669*tmp_moved_constant_1776) + tmp_moved_constant_1575*(tmp_moved_constant_1718*tmp_moved_constant_1770 + tmp_moved_constant_1719*tmp_moved_constant_1772 + tmp_moved_constant_1720*tmp_moved_constant_1774 + tmp_moved_constant_1721*tmp_moved_constant_1776) + tmp_moved_constant_1576*(tmp_moved_constant_1722*tmp_moved_constant_1770 + tmp_moved_constant_1723*tmp_moved_constant_1772 + tmp_moved_constant_1724*tmp_moved_constant_1774 + tmp_moved_constant_1725*tmp_moved_constant_1776) + tmp_moved_constant_1577*(tmp_moved_constant_1726*tmp_moved_constant_1770 + tmp_moved_constant_1727*tmp_moved_constant_1772 + tmp_moved_constant_1728*tmp_moved_constant_1774 + tmp_moved_constant_1729*tmp_moved_constant_1776);
                   const real_t tmp_moved_constant_1805 = tmp_moved_constant_1548*(tmp_moved_constant_1742*tmp_moved_constant_1786 + tmp_moved_constant_1743*tmp_moved_constant_1788 + tmp_moved_constant_1744*tmp_moved_constant_1790 + tmp_moved_constant_1745*tmp_moved_constant_1792) + tmp_moved_constant_1549*(-jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1787 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1789 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1791 - jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1793) + tmp_moved_constant_1550*(-jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1794 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1795 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1796 - jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1797) + tmp_moved_constant_1551*(-jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1798 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1799 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1800 - jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1801) + tmp_moved_constant_1552*(tmp_moved_constant_1672*tmp_moved_constant_1786 + tmp_moved_constant_1675*tmp_moved_constant_1788 + tmp_moved_constant_1678*tmp_moved_constant_1790 + tmp_moved_constant_1681*tmp_moved_constant_1792) + tmp_moved_constant_1553*(tmp_moved_constant_1684*tmp_moved_constant_1786 + tmp_moved_constant_1687*tmp_moved_constant_1788 + tmp_moved_constant_1690*tmp_moved_constant_1790 + tmp_moved_constant_1693*tmp_moved_constant_1792) + tmp_moved_constant_1554*(tmp_moved_constant_1696*tmp_moved_constant_1786 + tmp_moved_constant_1699*tmp_moved_constant_1788 + tmp_moved_constant_1702*tmp_moved_constant_1790 + tmp_moved_constant_1705*tmp_moved_constant_1792) + tmp_moved_constant_1555*(tmp_moved_constant_1730*tmp_moved_constant_1786 + tmp_moved_constant_1731*tmp_moved_constant_1788 + tmp_moved_constant_1732*tmp_moved_constant_1790 + tmp_moved_constant_1733*tmp_moved_constant_1792) + tmp_moved_constant_1556*(tmp_moved_constant_1734*tmp_moved_constant_1786 + tmp_moved_constant_1735*tmp_moved_constant_1788 + tmp_moved_constant_1736*tmp_moved_constant_1790 + tmp_moved_constant_1737*tmp_moved_constant_1792) + tmp_moved_constant_1557*(tmp_moved_constant_1738*tmp_moved_constant_1786 + tmp_moved_constant_1739*tmp_moved_constant_1788 + tmp_moved_constant_1740*tmp_moved_constant_1790 + tmp_moved_constant_1741*tmp_moved_constant_1792) + tmp_moved_constant_1558*(tmp_moved_constant_1746*tmp_moved_constant_1786 + tmp_moved_constant_1747*tmp_moved_constant_1788 + tmp_moved_constant_1748*tmp_moved_constant_1790 + tmp_moved_constant_1749*tmp_moved_constant_1792) + tmp_moved_constant_1559*(-jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1787 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1789 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1791 - jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1793) + tmp_moved_constant_1560*(-jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1794 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1795 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1796 - jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1797) + tmp_moved_constant_1561*(-jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1798 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1799 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1800 - jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1801) + tmp_moved_constant_1562*(tmp_moved_constant_1600*tmp_moved_constant_1786 + tmp_moved_constant_1603*tmp_moved_constant_1788 + tmp_moved_constant_1606*tmp_moved_constant_1790 + tmp_moved_constant_1609*tmp_moved_constant_1792) + tmp_moved_constant_1563*(tmp_moved_constant_1612*tmp_moved_constant_1786 + tmp_moved_constant_1615*tmp_moved_constant_1788 + tmp_moved_constant_1618*tmp_moved_constant_1790 + tmp_moved_constant_1621*tmp_moved_constant_1792) + tmp_moved_constant_1564*(tmp_moved_constant_1624*tmp_moved_constant_1786 + tmp_moved_constant_1627*tmp_moved_constant_1788 + tmp_moved_constant_1630*tmp_moved_constant_1790 + tmp_moved_constant_1633*tmp_moved_constant_1792) + tmp_moved_constant_1565*(tmp_moved_constant_1706*tmp_moved_constant_1786 + tmp_moved_constant_1707*tmp_moved_constant_1788 + tmp_moved_constant_1708*tmp_moved_constant_1790 + tmp_moved_constant_1709*tmp_moved_constant_1792) + tmp_moved_constant_1566*(tmp_moved_constant_1710*tmp_moved_constant_1786 + tmp_moved_constant_1711*tmp_moved_constant_1788 + tmp_moved_constant_1712*tmp_moved_constant_1790 + tmp_moved_constant_1713*tmp_moved_constant_1792) + tmp_moved_constant_1567*(tmp_moved_constant_1714*tmp_moved_constant_1786 + tmp_moved_constant_1715*tmp_moved_constant_1788 + tmp_moved_constant_1716*tmp_moved_constant_1790 + tmp_moved_constant_1717*tmp_moved_constant_1792) + tmp_moved_constant_1568*(tmp_moved_constant_1750*tmp_moved_constant_1786 + tmp_moved_constant_1751*tmp_moved_constant_1788 + tmp_moved_constant_1752*tmp_moved_constant_1790 + tmp_moved_constant_1753*tmp_moved_constant_1792) + tmp_moved_constant_1569*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1787 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1789 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1791 - jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1793) + tmp_moved_constant_1570*(-jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1794 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1795 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1796 - jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1797) + tmp_moved_constant_1571*(-jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1798 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1799 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1800 - jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1801) + tmp_moved_constant_1572*(tmp_moved_constant_1636*tmp_moved_constant_1786 + tmp_moved_constant_1639*tmp_moved_constant_1788 + tmp_moved_constant_1642*tmp_moved_constant_1790 + tmp_moved_constant_1645*tmp_moved_constant_1792) + tmp_moved_constant_1573*(tmp_moved_constant_1648*tmp_moved_constant_1786 + tmp_moved_constant_1651*tmp_moved_constant_1788 + tmp_moved_constant_1654*tmp_moved_constant_1790 + tmp_moved_constant_1657*tmp_moved_constant_1792) + tmp_moved_constant_1574*(tmp_moved_constant_1660*tmp_moved_constant_1786 + tmp_moved_constant_1663*tmp_moved_constant_1788 + tmp_moved_constant_1666*tmp_moved_constant_1790 + tmp_moved_constant_1669*tmp_moved_constant_1792) + tmp_moved_constant_1575*(tmp_moved_constant_1718*tmp_moved_constant_1786 + tmp_moved_constant_1719*tmp_moved_constant_1788 + tmp_moved_constant_1720*tmp_moved_constant_1790 + tmp_moved_constant_1721*tmp_moved_constant_1792) + tmp_moved_constant_1576*(tmp_moved_constant_1722*tmp_moved_constant_1786 + tmp_moved_constant_1723*tmp_moved_constant_1788 + tmp_moved_constant_1724*tmp_moved_constant_1790 + tmp_moved_constant_1725*tmp_moved_constant_1792) + tmp_moved_constant_1577*(tmp_moved_constant_1726*tmp_moved_constant_1786 + tmp_moved_constant_1727*tmp_moved_constant_1788 + tmp_moved_constant_1728*tmp_moved_constant_1790 + tmp_moved_constant_1729*tmp_moved_constant_1792);
                   {
                      {
                     
                         const int64_t phantom_ctr_0 = ctr_0;
                         real_t _data_float_loop_ctr_array_dim_0[4];
                         _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                         _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                         _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                         _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                         real_t _data_float_loop_ctr_array_dim_1[4];
                         _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                         real_t _data_float_loop_ctr_array_dim_2[4];
                         _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                     
                         const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_1802 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_1803 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_1804 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_1805 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      }
                   }
                   const real_t tmp_moved_constant_1806 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1807 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1808 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1809 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1810 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1811 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1812 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1813 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1814 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1815 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1816 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1817 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1818 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1819 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1820 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1821 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1822 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1823 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1824 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1825 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1826 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1827 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1828 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_1829 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_1830 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1831 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_1832 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1833 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_1834 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1835 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_1836 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
                   const real_t tmp_moved_constant_1837 = tmp_moved_constant_1836*0.13819660112501053;
                   const real_t tmp_moved_constant_1838 = tmp_kernel_op_1*tmp_moved_constant_1837;
                   const real_t tmp_moved_constant_1839 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
                   const real_t tmp_moved_constant_1840 = tmp_moved_constant_1839*0.13819660112501056;
                   const real_t tmp_moved_constant_1841 = tmp_kernel_op_6*tmp_moved_constant_1840;
                   const real_t tmp_moved_constant_1842 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
                   const real_t tmp_moved_constant_1843 = tmp_moved_constant_1842*0.13819660112501056;
                   const real_t tmp_moved_constant_1844 = tmp_kernel_op_11*tmp_moved_constant_1843;
                   const real_t tmp_moved_constant_1845 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
                   const real_t tmp_moved_constant_1846 = tmp_moved_constant_1845*0.5854101966249684;
                   const real_t tmp_moved_constant_1847 = tmp_kernel_op_16*tmp_moved_constant_1846;
                   const real_t tmp_moved_constant_1848 = tmp_kernel_op_21*tmp_moved_constant_1837;
                   const real_t tmp_moved_constant_1849 = tmp_kernel_op_24*tmp_moved_constant_1840;
                   const real_t tmp_moved_constant_1850 = tmp_kernel_op_27*tmp_moved_constant_1843;
                   const real_t tmp_moved_constant_1851 = tmp_kernel_op_30*tmp_moved_constant_1846;
                   const real_t tmp_moved_constant_1852 = tmp_kernel_op_33*tmp_moved_constant_1837;
                   const real_t tmp_moved_constant_1853 = tmp_kernel_op_36*tmp_moved_constant_1840;
                   const real_t tmp_moved_constant_1854 = tmp_kernel_op_39*tmp_moved_constant_1843;
                   const real_t tmp_moved_constant_1855 = tmp_kernel_op_42*tmp_moved_constant_1846;
                   const real_t tmp_moved_constant_1856 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1857 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1858 = -tmp_moved_constant_1856 - tmp_moved_constant_1857;
                   const real_t tmp_moved_constant_1859 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1860 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1861 = -tmp_moved_constant_1859 - tmp_moved_constant_1860;
                   const real_t tmp_moved_constant_1862 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1863 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1864 = -tmp_moved_constant_1862 - tmp_moved_constant_1863;
                   const real_t tmp_moved_constant_1865 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1866 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1867 = -tmp_moved_constant_1865 - tmp_moved_constant_1866;
                   const real_t tmp_moved_constant_1868 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1869 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1870 = -tmp_moved_constant_1868 - tmp_moved_constant_1869;
                   const real_t tmp_moved_constant_1871 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1872 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1873 = -tmp_moved_constant_1871 - tmp_moved_constant_1872;
                   const real_t tmp_moved_constant_1874 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1875 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1876 = -tmp_moved_constant_1874 - tmp_moved_constant_1875;
                   const real_t tmp_moved_constant_1877 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1878 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1879 = -tmp_moved_constant_1877 - tmp_moved_constant_1878;
                   const real_t tmp_moved_constant_1880 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1881 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1882 = -tmp_moved_constant_1880 - tmp_moved_constant_1881;
                   const real_t tmp_moved_constant_1883 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1884 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1885 = -tmp_moved_constant_1883 - tmp_moved_constant_1884;
                   const real_t tmp_moved_constant_1886 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1887 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1888 = -tmp_moved_constant_1886 - tmp_moved_constant_1887;
                   const real_t tmp_moved_constant_1889 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1890 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1891 = -tmp_moved_constant_1889 - tmp_moved_constant_1890;
                   const real_t tmp_moved_constant_1892 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1893 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1894 = -tmp_moved_constant_1892 - tmp_moved_constant_1893;
                   const real_t tmp_moved_constant_1895 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1896 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1897 = -tmp_moved_constant_1895 - tmp_moved_constant_1896;
                   const real_t tmp_moved_constant_1898 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1899 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1900 = -tmp_moved_constant_1898 - tmp_moved_constant_1899;
                   const real_t tmp_moved_constant_1901 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1902 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1903 = -tmp_moved_constant_1901 - tmp_moved_constant_1902;
                   const real_t tmp_moved_constant_1904 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1905 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1906 = -tmp_moved_constant_1904 - tmp_moved_constant_1905;
                   const real_t tmp_moved_constant_1907 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1908 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1909 = -tmp_moved_constant_1907 - tmp_moved_constant_1908;
                   const real_t tmp_moved_constant_1910 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1911 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1912 = -tmp_moved_constant_1910 - tmp_moved_constant_1911;
                   const real_t tmp_moved_constant_1913 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1914 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1915 = -tmp_moved_constant_1913 - tmp_moved_constant_1914;
                   const real_t tmp_moved_constant_1916 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1917 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1918 = -tmp_moved_constant_1916 - tmp_moved_constant_1917;
                   const real_t tmp_moved_constant_1919 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1920 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1921 = -tmp_moved_constant_1919 - tmp_moved_constant_1920;
                   const real_t tmp_moved_constant_1922 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1923 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1924 = -tmp_moved_constant_1922 - tmp_moved_constant_1923;
                   const real_t tmp_moved_constant_1925 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1926 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1927 = -tmp_moved_constant_1925 - tmp_moved_constant_1926;
                   const real_t tmp_moved_constant_1928 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1929 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1930 = -tmp_moved_constant_1928 - tmp_moved_constant_1929;
                   const real_t tmp_moved_constant_1931 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1932 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1933 = -tmp_moved_constant_1931 - tmp_moved_constant_1932;
                   const real_t tmp_moved_constant_1934 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1935 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1936 = -tmp_moved_constant_1934 - tmp_moved_constant_1935;
                   const real_t tmp_moved_constant_1937 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1938 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1939 = -tmp_moved_constant_1937 - tmp_moved_constant_1938;
                   const real_t tmp_moved_constant_1940 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_1941 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1942 = -tmp_moved_constant_1940 - tmp_moved_constant_1941;
                   const real_t tmp_moved_constant_1943 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_1944 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1945 = -tmp_moved_constant_1943 - tmp_moved_constant_1944;
                   const real_t tmp_moved_constant_1946 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_1947 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1948 = -tmp_moved_constant_1946 - tmp_moved_constant_1947;
                   const real_t tmp_moved_constant_1949 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_1950 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1951 = -tmp_moved_constant_1949 - tmp_moved_constant_1950;
                   const real_t tmp_moved_constant_1952 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_1953 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_1954 = -tmp_moved_constant_1952 - tmp_moved_constant_1953;
                   const real_t tmp_moved_constant_1955 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_1956 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_1957 = -tmp_moved_constant_1955 - tmp_moved_constant_1956;
                   const real_t tmp_moved_constant_1958 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_1959 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_1960 = -tmp_moved_constant_1958 - tmp_moved_constant_1959;
                   const real_t tmp_moved_constant_1961 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_1962 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_1963 = -tmp_moved_constant_1961 - tmp_moved_constant_1962;
                   const real_t tmp_moved_constant_1964 = -jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_153 + tmp_moved_constant_1856 + tmp_moved_constant_1868;
                   const real_t tmp_moved_constant_1965 = -jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_156 + tmp_moved_constant_1859 + tmp_moved_constant_1871;
                   const real_t tmp_moved_constant_1966 = -jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_159 + tmp_moved_constant_1862 + tmp_moved_constant_1874;
                   const real_t tmp_moved_constant_1967 = -jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_162 + tmp_moved_constant_1865 + tmp_moved_constant_1877;
                   const real_t tmp_moved_constant_1968 = -jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_165 + tmp_moved_constant_1857 + tmp_moved_constant_1880;
                   const real_t tmp_moved_constant_1969 = -jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_168 + tmp_moved_constant_1860 + tmp_moved_constant_1883;
                   const real_t tmp_moved_constant_1970 = -jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_171 + tmp_moved_constant_1863 + tmp_moved_constant_1886;
                   const real_t tmp_moved_constant_1971 = -jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_174 + tmp_moved_constant_1866 + tmp_moved_constant_1889;
                   const real_t tmp_moved_constant_1972 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_176 + tmp_moved_constant_1869 + tmp_moved_constant_1881;
                   const real_t tmp_moved_constant_1973 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_178 + tmp_moved_constant_1872 + tmp_moved_constant_1884;
                   const real_t tmp_moved_constant_1974 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_180 + tmp_moved_constant_1875 + tmp_moved_constant_1887;
                   const real_t tmp_moved_constant_1975 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_182 + tmp_moved_constant_1878 + tmp_moved_constant_1890;
                   const real_t tmp_moved_constant_1976 = -jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_153 + tmp_moved_constant_1892 + tmp_moved_constant_1904;
                   const real_t tmp_moved_constant_1977 = -jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_156 + tmp_moved_constant_1895 + tmp_moved_constant_1907;
                   const real_t tmp_moved_constant_1978 = -jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_159 + tmp_moved_constant_1898 + tmp_moved_constant_1910;
                   const real_t tmp_moved_constant_1979 = -jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_162 + tmp_moved_constant_1901 + tmp_moved_constant_1913;
                   const real_t tmp_moved_constant_1980 = -jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_165 + tmp_moved_constant_1893 + tmp_moved_constant_1916;
                   const real_t tmp_moved_constant_1981 = -jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_168 + tmp_moved_constant_1896 + tmp_moved_constant_1919;
                   const real_t tmp_moved_constant_1982 = -jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_171 + tmp_moved_constant_1899 + tmp_moved_constant_1922;
                   const real_t tmp_moved_constant_1983 = -jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_174 + tmp_moved_constant_1902 + tmp_moved_constant_1925;
                   const real_t tmp_moved_constant_1984 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_176 + tmp_moved_constant_1905 + tmp_moved_constant_1917;
                   const real_t tmp_moved_constant_1985 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_178 + tmp_moved_constant_1908 + tmp_moved_constant_1920;
                   const real_t tmp_moved_constant_1986 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_180 + tmp_moved_constant_1911 + tmp_moved_constant_1923;
                   const real_t tmp_moved_constant_1987 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_182 + tmp_moved_constant_1914 + tmp_moved_constant_1926;
                   const real_t tmp_moved_constant_1988 = -jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_153 + tmp_moved_constant_1928 + tmp_moved_constant_1940;
                   const real_t tmp_moved_constant_1989 = -jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_156 + tmp_moved_constant_1931 + tmp_moved_constant_1943;
                   const real_t tmp_moved_constant_1990 = -jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_159 + tmp_moved_constant_1934 + tmp_moved_constant_1946;
                   const real_t tmp_moved_constant_1991 = -jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_162 + tmp_moved_constant_1937 + tmp_moved_constant_1949;
                   const real_t tmp_moved_constant_1992 = -jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_165 + tmp_moved_constant_1929 + tmp_moved_constant_1952;
                   const real_t tmp_moved_constant_1993 = -jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_168 + tmp_moved_constant_1932 + tmp_moved_constant_1955;
                   const real_t tmp_moved_constant_1994 = -jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_171 + tmp_moved_constant_1935 + tmp_moved_constant_1958;
                   const real_t tmp_moved_constant_1995 = -jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_174 + tmp_moved_constant_1938 + tmp_moved_constant_1961;
                   const real_t tmp_moved_constant_1996 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_176 + tmp_moved_constant_1941 + tmp_moved_constant_1953;
                   const real_t tmp_moved_constant_1997 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_178 + tmp_moved_constant_1944 + tmp_moved_constant_1956;
                   const real_t tmp_moved_constant_1998 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_180 + tmp_moved_constant_1947 + tmp_moved_constant_1959;
                   const real_t tmp_moved_constant_1999 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_182 + tmp_moved_constant_1950 + tmp_moved_constant_1962;
                   const real_t tmp_moved_constant_2000 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_2001 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_2002 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_2003 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_2004 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_2005 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_2006 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_2007 = -jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_2008 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_208 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_2009 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_210 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_2010 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_212 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_2011 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_214 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_2012 = tmp_moved_constant_1836*0.1381966011250105;
                   const real_t tmp_moved_constant_2013 = tmp_kernel_op_1*tmp_moved_constant_2012;
                   const real_t tmp_moved_constant_2014 = tmp_moved_constant_1839*0.1381966011250105;
                   const real_t tmp_moved_constant_2015 = tmp_kernel_op_6*tmp_moved_constant_2014;
                   const real_t tmp_moved_constant_2016 = tmp_moved_constant_1842*0.5854101966249684;
                   const real_t tmp_moved_constant_2017 = tmp_kernel_op_11*tmp_moved_constant_2016;
                   const real_t tmp_moved_constant_2018 = tmp_moved_constant_1845*0.1381966011250105;
                   const real_t tmp_moved_constant_2019 = tmp_kernel_op_16*tmp_moved_constant_2018;
                   const real_t tmp_moved_constant_2020 = tmp_kernel_op_21*tmp_moved_constant_2012;
                   const real_t tmp_moved_constant_2021 = tmp_kernel_op_24*tmp_moved_constant_2014;
                   const real_t tmp_moved_constant_2022 = tmp_kernel_op_27*tmp_moved_constant_2016;
                   const real_t tmp_moved_constant_2023 = tmp_kernel_op_30*tmp_moved_constant_2018;
                   const real_t tmp_moved_constant_2024 = tmp_kernel_op_33*tmp_moved_constant_2012;
                   const real_t tmp_moved_constant_2025 = tmp_kernel_op_36*tmp_moved_constant_2014;
                   const real_t tmp_moved_constant_2026 = tmp_kernel_op_39*tmp_moved_constant_2016;
                   const real_t tmp_moved_constant_2027 = tmp_kernel_op_42*tmp_moved_constant_2018;
                   const real_t tmp_moved_constant_2028 = tmp_moved_constant_1836*0.1381966011250105;
                   const real_t tmp_moved_constant_2029 = tmp_kernel_op_1*tmp_moved_constant_2028;
                   const real_t tmp_moved_constant_2030 = tmp_moved_constant_1839*0.5854101966249684;
                   const real_t tmp_moved_constant_2031 = tmp_kernel_op_6*tmp_moved_constant_2030;
                   const real_t tmp_moved_constant_2032 = tmp_moved_constant_1842*0.1381966011250105;
                   const real_t tmp_moved_constant_2033 = tmp_kernel_op_11*tmp_moved_constant_2032;
                   const real_t tmp_moved_constant_2034 = tmp_moved_constant_1845*0.1381966011250105;
                   const real_t tmp_moved_constant_2035 = tmp_kernel_op_16*tmp_moved_constant_2034;
                   const real_t tmp_moved_constant_2036 = tmp_kernel_op_21*tmp_moved_constant_2028;
                   const real_t tmp_moved_constant_2037 = tmp_kernel_op_24*tmp_moved_constant_2030;
                   const real_t tmp_moved_constant_2038 = tmp_kernel_op_27*tmp_moved_constant_2032;
                   const real_t tmp_moved_constant_2039 = tmp_kernel_op_30*tmp_moved_constant_2034;
                   const real_t tmp_moved_constant_2040 = tmp_kernel_op_33*tmp_moved_constant_2028;
                   const real_t tmp_moved_constant_2041 = tmp_kernel_op_36*tmp_moved_constant_2030;
                   const real_t tmp_moved_constant_2042 = tmp_kernel_op_39*tmp_moved_constant_2032;
                   const real_t tmp_moved_constant_2043 = tmp_kernel_op_42*tmp_moved_constant_2034;
                   const real_t tmp_moved_constant_2044 = tmp_moved_constant_1836*0.5854101966249684;
                   const real_t tmp_moved_constant_2045 = tmp_kernel_op_1*tmp_moved_constant_2044;
                   const real_t tmp_moved_constant_2046 = tmp_moved_constant_1839*0.1381966011250105;
                   const real_t tmp_moved_constant_2047 = tmp_kernel_op_6*tmp_moved_constant_2046;
                   const real_t tmp_moved_constant_2048 = tmp_moved_constant_1842*0.1381966011250105;
                   const real_t tmp_moved_constant_2049 = tmp_kernel_op_11*tmp_moved_constant_2048;
                   const real_t tmp_moved_constant_2050 = tmp_moved_constant_1845*0.1381966011250105;
                   const real_t tmp_moved_constant_2051 = tmp_kernel_op_16*tmp_moved_constant_2050;
                   const real_t tmp_moved_constant_2052 = tmp_kernel_op_21*tmp_moved_constant_2044;
                   const real_t tmp_moved_constant_2053 = tmp_kernel_op_24*tmp_moved_constant_2046;
                   const real_t tmp_moved_constant_2054 = tmp_kernel_op_27*tmp_moved_constant_2048;
                   const real_t tmp_moved_constant_2055 = tmp_kernel_op_30*tmp_moved_constant_2050;
                   const real_t tmp_moved_constant_2056 = tmp_kernel_op_33*tmp_moved_constant_2044;
                   const real_t tmp_moved_constant_2057 = tmp_kernel_op_36*tmp_moved_constant_2046;
                   const real_t tmp_moved_constant_2058 = tmp_kernel_op_39*tmp_moved_constant_2048;
                   const real_t tmp_moved_constant_2059 = tmp_kernel_op_42*tmp_moved_constant_2050;
                   const real_t tmp_moved_constant_2060 = tmp_moved_constant_1806*(tmp_moved_constant_1837*tmp_moved_constant_2000 + tmp_moved_constant_1840*tmp_moved_constant_2001 + tmp_moved_constant_1843*tmp_moved_constant_2002 + tmp_moved_constant_1846*tmp_moved_constant_2003) + tmp_moved_constant_1807*(-jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1838 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1841 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1844 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1847) + tmp_moved_constant_1808*(-jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1848 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1849 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1850 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1851) + tmp_moved_constant_1809*(-jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1852 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1853 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1854 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1855) + tmp_moved_constant_1810*(tmp_moved_constant_1837*tmp_moved_constant_1930 + tmp_moved_constant_1840*tmp_moved_constant_1933 + tmp_moved_constant_1843*tmp_moved_constant_1936 + tmp_moved_constant_1846*tmp_moved_constant_1939) + tmp_moved_constant_1811*(tmp_moved_constant_1837*tmp_moved_constant_1942 + tmp_moved_constant_1840*tmp_moved_constant_1945 + tmp_moved_constant_1843*tmp_moved_constant_1948 + tmp_moved_constant_1846*tmp_moved_constant_1951) + tmp_moved_constant_1812*(tmp_moved_constant_1837*tmp_moved_constant_1954 + tmp_moved_constant_1840*tmp_moved_constant_1957 + tmp_moved_constant_1843*tmp_moved_constant_1960 + tmp_moved_constant_1846*tmp_moved_constant_1963) + tmp_moved_constant_1813*(tmp_moved_constant_1837*tmp_moved_constant_1988 + tmp_moved_constant_1840*tmp_moved_constant_1989 + tmp_moved_constant_1843*tmp_moved_constant_1990 + tmp_moved_constant_1846*tmp_moved_constant_1991) + tmp_moved_constant_1814*(tmp_moved_constant_1837*tmp_moved_constant_1992 + tmp_moved_constant_1840*tmp_moved_constant_1993 + tmp_moved_constant_1843*tmp_moved_constant_1994 + tmp_moved_constant_1846*tmp_moved_constant_1995) + tmp_moved_constant_1815*(tmp_moved_constant_1837*tmp_moved_constant_1996 + tmp_moved_constant_1840*tmp_moved_constant_1997 + tmp_moved_constant_1843*tmp_moved_constant_1998 + tmp_moved_constant_1846*tmp_moved_constant_1999) + tmp_moved_constant_1816*(tmp_moved_constant_1837*tmp_moved_constant_2004 + tmp_moved_constant_1840*tmp_moved_constant_2005 + tmp_moved_constant_1843*tmp_moved_constant_2006 + tmp_moved_constant_1846*tmp_moved_constant_2007) + tmp_moved_constant_1817*(-jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1838 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1841 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1844 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1847) + tmp_moved_constant_1818*(-jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1848 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1849 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1850 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1851) + tmp_moved_constant_1819*(-jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1852 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1853 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1854 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1855) + tmp_moved_constant_1820*(tmp_moved_constant_1837*tmp_moved_constant_1858 + tmp_moved_constant_1840*tmp_moved_constant_1861 + tmp_moved_constant_1843*tmp_moved_constant_1864 + tmp_moved_constant_1846*tmp_moved_constant_1867) + tmp_moved_constant_1821*(tmp_moved_constant_1837*tmp_moved_constant_1870 + tmp_moved_constant_1840*tmp_moved_constant_1873 + tmp_moved_constant_1843*tmp_moved_constant_1876 + tmp_moved_constant_1846*tmp_moved_constant_1879) + tmp_moved_constant_1822*(tmp_moved_constant_1837*tmp_moved_constant_1882 + tmp_moved_constant_1840*tmp_moved_constant_1885 + tmp_moved_constant_1843*tmp_moved_constant_1888 + tmp_moved_constant_1846*tmp_moved_constant_1891) + tmp_moved_constant_1823*(tmp_moved_constant_1837*tmp_moved_constant_1964 + tmp_moved_constant_1840*tmp_moved_constant_1965 + tmp_moved_constant_1843*tmp_moved_constant_1966 + tmp_moved_constant_1846*tmp_moved_constant_1967) + tmp_moved_constant_1824*(tmp_moved_constant_1837*tmp_moved_constant_1968 + tmp_moved_constant_1840*tmp_moved_constant_1969 + tmp_moved_constant_1843*tmp_moved_constant_1970 + tmp_moved_constant_1846*tmp_moved_constant_1971) + tmp_moved_constant_1825*(tmp_moved_constant_1837*tmp_moved_constant_1972 + tmp_moved_constant_1840*tmp_moved_constant_1973 + tmp_moved_constant_1843*tmp_moved_constant_1974 + tmp_moved_constant_1846*tmp_moved_constant_1975) + tmp_moved_constant_1826*(tmp_moved_constant_1837*tmp_moved_constant_2008 + tmp_moved_constant_1840*tmp_moved_constant_2009 + tmp_moved_constant_1843*tmp_moved_constant_2010 + tmp_moved_constant_1846*tmp_moved_constant_2011) + tmp_moved_constant_1827*(-jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1838 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1841 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1844 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1847) + tmp_moved_constant_1828*(-jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1848 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1849 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1850 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1851) + tmp_moved_constant_1829*(-jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1852 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1853 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1854 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1855) + tmp_moved_constant_1830*(tmp_moved_constant_1837*tmp_moved_constant_1894 + tmp_moved_constant_1840*tmp_moved_constant_1897 + tmp_moved_constant_1843*tmp_moved_constant_1900 + tmp_moved_constant_1846*tmp_moved_constant_1903) + tmp_moved_constant_1831*(tmp_moved_constant_1837*tmp_moved_constant_1906 + tmp_moved_constant_1840*tmp_moved_constant_1909 + tmp_moved_constant_1843*tmp_moved_constant_1912 + tmp_moved_constant_1846*tmp_moved_constant_1915) + tmp_moved_constant_1832*(tmp_moved_constant_1837*tmp_moved_constant_1918 + tmp_moved_constant_1840*tmp_moved_constant_1921 + tmp_moved_constant_1843*tmp_moved_constant_1924 + tmp_moved_constant_1846*tmp_moved_constant_1927) + tmp_moved_constant_1833*(tmp_moved_constant_1837*tmp_moved_constant_1976 + tmp_moved_constant_1840*tmp_moved_constant_1977 + tmp_moved_constant_1843*tmp_moved_constant_1978 + tmp_moved_constant_1846*tmp_moved_constant_1979) + tmp_moved_constant_1834*(tmp_moved_constant_1837*tmp_moved_constant_1980 + tmp_moved_constant_1840*tmp_moved_constant_1981 + tmp_moved_constant_1843*tmp_moved_constant_1982 + tmp_moved_constant_1846*tmp_moved_constant_1983) + tmp_moved_constant_1835*(tmp_moved_constant_1837*tmp_moved_constant_1984 + tmp_moved_constant_1840*tmp_moved_constant_1985 + tmp_moved_constant_1843*tmp_moved_constant_1986 + tmp_moved_constant_1846*tmp_moved_constant_1987);
                   const real_t tmp_moved_constant_2061 = tmp_moved_constant_1806*(tmp_moved_constant_2000*tmp_moved_constant_2012 + tmp_moved_constant_2001*tmp_moved_constant_2014 + tmp_moved_constant_2002*tmp_moved_constant_2016 + tmp_moved_constant_2003*tmp_moved_constant_2018) + tmp_moved_constant_1807*(-jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2013 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2015 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2017 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2019) + tmp_moved_constant_1808*(-jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2020 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2021 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2022 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2023) + tmp_moved_constant_1809*(-jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2024 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2025 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2026 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2027) + tmp_moved_constant_1810*(tmp_moved_constant_1930*tmp_moved_constant_2012 + tmp_moved_constant_1933*tmp_moved_constant_2014 + tmp_moved_constant_1936*tmp_moved_constant_2016 + tmp_moved_constant_1939*tmp_moved_constant_2018) + tmp_moved_constant_1811*(tmp_moved_constant_1942*tmp_moved_constant_2012 + tmp_moved_constant_1945*tmp_moved_constant_2014 + tmp_moved_constant_1948*tmp_moved_constant_2016 + tmp_moved_constant_1951*tmp_moved_constant_2018) + tmp_moved_constant_1812*(tmp_moved_constant_1954*tmp_moved_constant_2012 + tmp_moved_constant_1957*tmp_moved_constant_2014 + tmp_moved_constant_1960*tmp_moved_constant_2016 + tmp_moved_constant_1963*tmp_moved_constant_2018) + tmp_moved_constant_1813*(tmp_moved_constant_1988*tmp_moved_constant_2012 + tmp_moved_constant_1989*tmp_moved_constant_2014 + tmp_moved_constant_1990*tmp_moved_constant_2016 + tmp_moved_constant_1991*tmp_moved_constant_2018) + tmp_moved_constant_1814*(tmp_moved_constant_1992*tmp_moved_constant_2012 + tmp_moved_constant_1993*tmp_moved_constant_2014 + tmp_moved_constant_1994*tmp_moved_constant_2016 + tmp_moved_constant_1995*tmp_moved_constant_2018) + tmp_moved_constant_1815*(tmp_moved_constant_1996*tmp_moved_constant_2012 + tmp_moved_constant_1997*tmp_moved_constant_2014 + tmp_moved_constant_1998*tmp_moved_constant_2016 + tmp_moved_constant_1999*tmp_moved_constant_2018) + tmp_moved_constant_1816*(tmp_moved_constant_2004*tmp_moved_constant_2012 + tmp_moved_constant_2005*tmp_moved_constant_2014 + tmp_moved_constant_2006*tmp_moved_constant_2016 + tmp_moved_constant_2007*tmp_moved_constant_2018) + tmp_moved_constant_1817*(-jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2013 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2015 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2017 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2019) + tmp_moved_constant_1818*(-jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2020 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2021 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2022 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2023) + tmp_moved_constant_1819*(-jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2024 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2025 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2026 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2027) + tmp_moved_constant_1820*(tmp_moved_constant_1858*tmp_moved_constant_2012 + tmp_moved_constant_1861*tmp_moved_constant_2014 + tmp_moved_constant_1864*tmp_moved_constant_2016 + tmp_moved_constant_1867*tmp_moved_constant_2018) + tmp_moved_constant_1821*(tmp_moved_constant_1870*tmp_moved_constant_2012 + tmp_moved_constant_1873*tmp_moved_constant_2014 + tmp_moved_constant_1876*tmp_moved_constant_2016 + tmp_moved_constant_1879*tmp_moved_constant_2018) + tmp_moved_constant_1822*(tmp_moved_constant_1882*tmp_moved_constant_2012 + tmp_moved_constant_1885*tmp_moved_constant_2014 + tmp_moved_constant_1888*tmp_moved_constant_2016 + tmp_moved_constant_1891*tmp_moved_constant_2018) + tmp_moved_constant_1823*(tmp_moved_constant_1964*tmp_moved_constant_2012 + tmp_moved_constant_1965*tmp_moved_constant_2014 + tmp_moved_constant_1966*tmp_moved_constant_2016 + tmp_moved_constant_1967*tmp_moved_constant_2018) + tmp_moved_constant_1824*(tmp_moved_constant_1968*tmp_moved_constant_2012 + tmp_moved_constant_1969*tmp_moved_constant_2014 + tmp_moved_constant_1970*tmp_moved_constant_2016 + tmp_moved_constant_1971*tmp_moved_constant_2018) + tmp_moved_constant_1825*(tmp_moved_constant_1972*tmp_moved_constant_2012 + tmp_moved_constant_1973*tmp_moved_constant_2014 + tmp_moved_constant_1974*tmp_moved_constant_2016 + tmp_moved_constant_1975*tmp_moved_constant_2018) + tmp_moved_constant_1826*(tmp_moved_constant_2008*tmp_moved_constant_2012 + tmp_moved_constant_2009*tmp_moved_constant_2014 + tmp_moved_constant_2010*tmp_moved_constant_2016 + tmp_moved_constant_2011*tmp_moved_constant_2018) + tmp_moved_constant_1827*(-jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2013 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2015 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2017 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2019) + tmp_moved_constant_1828*(-jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2020 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2021 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2022 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2023) + tmp_moved_constant_1829*(-jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2024 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2025 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2026 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2027) + tmp_moved_constant_1830*(tmp_moved_constant_1894*tmp_moved_constant_2012 + tmp_moved_constant_1897*tmp_moved_constant_2014 + tmp_moved_constant_1900*tmp_moved_constant_2016 + tmp_moved_constant_1903*tmp_moved_constant_2018) + tmp_moved_constant_1831*(tmp_moved_constant_1906*tmp_moved_constant_2012 + tmp_moved_constant_1909*tmp_moved_constant_2014 + tmp_moved_constant_1912*tmp_moved_constant_2016 + tmp_moved_constant_1915*tmp_moved_constant_2018) + tmp_moved_constant_1832*(tmp_moved_constant_1918*tmp_moved_constant_2012 + tmp_moved_constant_1921*tmp_moved_constant_2014 + tmp_moved_constant_1924*tmp_moved_constant_2016 + tmp_moved_constant_1927*tmp_moved_constant_2018) + tmp_moved_constant_1833*(tmp_moved_constant_1976*tmp_moved_constant_2012 + tmp_moved_constant_1977*tmp_moved_constant_2014 + tmp_moved_constant_1978*tmp_moved_constant_2016 + tmp_moved_constant_1979*tmp_moved_constant_2018) + tmp_moved_constant_1834*(tmp_moved_constant_1980*tmp_moved_constant_2012 + tmp_moved_constant_1981*tmp_moved_constant_2014 + tmp_moved_constant_1982*tmp_moved_constant_2016 + tmp_moved_constant_1983*tmp_moved_constant_2018) + tmp_moved_constant_1835*(tmp_moved_constant_1984*tmp_moved_constant_2012 + tmp_moved_constant_1985*tmp_moved_constant_2014 + tmp_moved_constant_1986*tmp_moved_constant_2016 + tmp_moved_constant_1987*tmp_moved_constant_2018);
                   const real_t tmp_moved_constant_2062 = tmp_moved_constant_1806*(tmp_moved_constant_2000*tmp_moved_constant_2028 + tmp_moved_constant_2001*tmp_moved_constant_2030 + tmp_moved_constant_2002*tmp_moved_constant_2032 + tmp_moved_constant_2003*tmp_moved_constant_2034) + tmp_moved_constant_1807*(-jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2029 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2031 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2033 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2035) + tmp_moved_constant_1808*(-jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2036 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2037 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2038 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2039) + tmp_moved_constant_1809*(-jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2040 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2041 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2042 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2043) + tmp_moved_constant_1810*(tmp_moved_constant_1930*tmp_moved_constant_2028 + tmp_moved_constant_1933*tmp_moved_constant_2030 + tmp_moved_constant_1936*tmp_moved_constant_2032 + tmp_moved_constant_1939*tmp_moved_constant_2034) + tmp_moved_constant_1811*(tmp_moved_constant_1942*tmp_moved_constant_2028 + tmp_moved_constant_1945*tmp_moved_constant_2030 + tmp_moved_constant_1948*tmp_moved_constant_2032 + tmp_moved_constant_1951*tmp_moved_constant_2034) + tmp_moved_constant_1812*(tmp_moved_constant_1954*tmp_moved_constant_2028 + tmp_moved_constant_1957*tmp_moved_constant_2030 + tmp_moved_constant_1960*tmp_moved_constant_2032 + tmp_moved_constant_1963*tmp_moved_constant_2034) + tmp_moved_constant_1813*(tmp_moved_constant_1988*tmp_moved_constant_2028 + tmp_moved_constant_1989*tmp_moved_constant_2030 + tmp_moved_constant_1990*tmp_moved_constant_2032 + tmp_moved_constant_1991*tmp_moved_constant_2034) + tmp_moved_constant_1814*(tmp_moved_constant_1992*tmp_moved_constant_2028 + tmp_moved_constant_1993*tmp_moved_constant_2030 + tmp_moved_constant_1994*tmp_moved_constant_2032 + tmp_moved_constant_1995*tmp_moved_constant_2034) + tmp_moved_constant_1815*(tmp_moved_constant_1996*tmp_moved_constant_2028 + tmp_moved_constant_1997*tmp_moved_constant_2030 + tmp_moved_constant_1998*tmp_moved_constant_2032 + tmp_moved_constant_1999*tmp_moved_constant_2034) + tmp_moved_constant_1816*(tmp_moved_constant_2004*tmp_moved_constant_2028 + tmp_moved_constant_2005*tmp_moved_constant_2030 + tmp_moved_constant_2006*tmp_moved_constant_2032 + tmp_moved_constant_2007*tmp_moved_constant_2034) + tmp_moved_constant_1817*(-jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2029 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2031 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2033 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2035) + tmp_moved_constant_1818*(-jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2036 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2037 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2038 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2039) + tmp_moved_constant_1819*(-jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2040 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2041 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2042 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2043) + tmp_moved_constant_1820*(tmp_moved_constant_1858*tmp_moved_constant_2028 + tmp_moved_constant_1861*tmp_moved_constant_2030 + tmp_moved_constant_1864*tmp_moved_constant_2032 + tmp_moved_constant_1867*tmp_moved_constant_2034) + tmp_moved_constant_1821*(tmp_moved_constant_1870*tmp_moved_constant_2028 + tmp_moved_constant_1873*tmp_moved_constant_2030 + tmp_moved_constant_1876*tmp_moved_constant_2032 + tmp_moved_constant_1879*tmp_moved_constant_2034) + tmp_moved_constant_1822*(tmp_moved_constant_1882*tmp_moved_constant_2028 + tmp_moved_constant_1885*tmp_moved_constant_2030 + tmp_moved_constant_1888*tmp_moved_constant_2032 + tmp_moved_constant_1891*tmp_moved_constant_2034) + tmp_moved_constant_1823*(tmp_moved_constant_1964*tmp_moved_constant_2028 + tmp_moved_constant_1965*tmp_moved_constant_2030 + tmp_moved_constant_1966*tmp_moved_constant_2032 + tmp_moved_constant_1967*tmp_moved_constant_2034) + tmp_moved_constant_1824*(tmp_moved_constant_1968*tmp_moved_constant_2028 + tmp_moved_constant_1969*tmp_moved_constant_2030 + tmp_moved_constant_1970*tmp_moved_constant_2032 + tmp_moved_constant_1971*tmp_moved_constant_2034) + tmp_moved_constant_1825*(tmp_moved_constant_1972*tmp_moved_constant_2028 + tmp_moved_constant_1973*tmp_moved_constant_2030 + tmp_moved_constant_1974*tmp_moved_constant_2032 + tmp_moved_constant_1975*tmp_moved_constant_2034) + tmp_moved_constant_1826*(tmp_moved_constant_2008*tmp_moved_constant_2028 + tmp_moved_constant_2009*tmp_moved_constant_2030 + tmp_moved_constant_2010*tmp_moved_constant_2032 + tmp_moved_constant_2011*tmp_moved_constant_2034) + tmp_moved_constant_1827*(-jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2029 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2031 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2033 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2035) + tmp_moved_constant_1828*(-jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2036 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2037 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2038 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2039) + tmp_moved_constant_1829*(-jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2040 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2041 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2042 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2043) + tmp_moved_constant_1830*(tmp_moved_constant_1894*tmp_moved_constant_2028 + tmp_moved_constant_1897*tmp_moved_constant_2030 + tmp_moved_constant_1900*tmp_moved_constant_2032 + tmp_moved_constant_1903*tmp_moved_constant_2034) + tmp_moved_constant_1831*(tmp_moved_constant_1906*tmp_moved_constant_2028 + tmp_moved_constant_1909*tmp_moved_constant_2030 + tmp_moved_constant_1912*tmp_moved_constant_2032 + tmp_moved_constant_1915*tmp_moved_constant_2034) + tmp_moved_constant_1832*(tmp_moved_constant_1918*tmp_moved_constant_2028 + tmp_moved_constant_1921*tmp_moved_constant_2030 + tmp_moved_constant_1924*tmp_moved_constant_2032 + tmp_moved_constant_1927*tmp_moved_constant_2034) + tmp_moved_constant_1833*(tmp_moved_constant_1976*tmp_moved_constant_2028 + tmp_moved_constant_1977*tmp_moved_constant_2030 + tmp_moved_constant_1978*tmp_moved_constant_2032 + tmp_moved_constant_1979*tmp_moved_constant_2034) + tmp_moved_constant_1834*(tmp_moved_constant_1980*tmp_moved_constant_2028 + tmp_moved_constant_1981*tmp_moved_constant_2030 + tmp_moved_constant_1982*tmp_moved_constant_2032 + tmp_moved_constant_1983*tmp_moved_constant_2034) + tmp_moved_constant_1835*(tmp_moved_constant_1984*tmp_moved_constant_2028 + tmp_moved_constant_1985*tmp_moved_constant_2030 + tmp_moved_constant_1986*tmp_moved_constant_2032 + tmp_moved_constant_1987*tmp_moved_constant_2034);
                   const real_t tmp_moved_constant_2063 = tmp_moved_constant_1806*(tmp_moved_constant_2000*tmp_moved_constant_2044 + tmp_moved_constant_2001*tmp_moved_constant_2046 + tmp_moved_constant_2002*tmp_moved_constant_2048 + tmp_moved_constant_2003*tmp_moved_constant_2050) + tmp_moved_constant_1807*(-jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2045 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2047 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2049 - jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_2051) + tmp_moved_constant_1808*(-jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2052 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2053 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2054 - jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_2055) + tmp_moved_constant_1809*(-jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2056 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2057 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2058 - jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_2059) + tmp_moved_constant_1810*(tmp_moved_constant_1930*tmp_moved_constant_2044 + tmp_moved_constant_1933*tmp_moved_constant_2046 + tmp_moved_constant_1936*tmp_moved_constant_2048 + tmp_moved_constant_1939*tmp_moved_constant_2050) + tmp_moved_constant_1811*(tmp_moved_constant_1942*tmp_moved_constant_2044 + tmp_moved_constant_1945*tmp_moved_constant_2046 + tmp_moved_constant_1948*tmp_moved_constant_2048 + tmp_moved_constant_1951*tmp_moved_constant_2050) + tmp_moved_constant_1812*(tmp_moved_constant_1954*tmp_moved_constant_2044 + tmp_moved_constant_1957*tmp_moved_constant_2046 + tmp_moved_constant_1960*tmp_moved_constant_2048 + tmp_moved_constant_1963*tmp_moved_constant_2050) + tmp_moved_constant_1813*(tmp_moved_constant_1988*tmp_moved_constant_2044 + tmp_moved_constant_1989*tmp_moved_constant_2046 + tmp_moved_constant_1990*tmp_moved_constant_2048 + tmp_moved_constant_1991*tmp_moved_constant_2050) + tmp_moved_constant_1814*(tmp_moved_constant_1992*tmp_moved_constant_2044 + tmp_moved_constant_1993*tmp_moved_constant_2046 + tmp_moved_constant_1994*tmp_moved_constant_2048 + tmp_moved_constant_1995*tmp_moved_constant_2050) + tmp_moved_constant_1815*(tmp_moved_constant_1996*tmp_moved_constant_2044 + tmp_moved_constant_1997*tmp_moved_constant_2046 + tmp_moved_constant_1998*tmp_moved_constant_2048 + tmp_moved_constant_1999*tmp_moved_constant_2050) + tmp_moved_constant_1816*(tmp_moved_constant_2004*tmp_moved_constant_2044 + tmp_moved_constant_2005*tmp_moved_constant_2046 + tmp_moved_constant_2006*tmp_moved_constant_2048 + tmp_moved_constant_2007*tmp_moved_constant_2050) + tmp_moved_constant_1817*(-jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2045 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2047 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2049 - jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_2051) + tmp_moved_constant_1818*(-jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2052 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2053 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2054 - jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_2055) + tmp_moved_constant_1819*(-jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2056 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2057 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2058 - jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_2059) + tmp_moved_constant_1820*(tmp_moved_constant_1858*tmp_moved_constant_2044 + tmp_moved_constant_1861*tmp_moved_constant_2046 + tmp_moved_constant_1864*tmp_moved_constant_2048 + tmp_moved_constant_1867*tmp_moved_constant_2050) + tmp_moved_constant_1821*(tmp_moved_constant_1870*tmp_moved_constant_2044 + tmp_moved_constant_1873*tmp_moved_constant_2046 + tmp_moved_constant_1876*tmp_moved_constant_2048 + tmp_moved_constant_1879*tmp_moved_constant_2050) + tmp_moved_constant_1822*(tmp_moved_constant_1882*tmp_moved_constant_2044 + tmp_moved_constant_1885*tmp_moved_constant_2046 + tmp_moved_constant_1888*tmp_moved_constant_2048 + tmp_moved_constant_1891*tmp_moved_constant_2050) + tmp_moved_constant_1823*(tmp_moved_constant_1964*tmp_moved_constant_2044 + tmp_moved_constant_1965*tmp_moved_constant_2046 + tmp_moved_constant_1966*tmp_moved_constant_2048 + tmp_moved_constant_1967*tmp_moved_constant_2050) + tmp_moved_constant_1824*(tmp_moved_constant_1968*tmp_moved_constant_2044 + tmp_moved_constant_1969*tmp_moved_constant_2046 + tmp_moved_constant_1970*tmp_moved_constant_2048 + tmp_moved_constant_1971*tmp_moved_constant_2050) + tmp_moved_constant_1825*(tmp_moved_constant_1972*tmp_moved_constant_2044 + tmp_moved_constant_1973*tmp_moved_constant_2046 + tmp_moved_constant_1974*tmp_moved_constant_2048 + tmp_moved_constant_1975*tmp_moved_constant_2050) + tmp_moved_constant_1826*(tmp_moved_constant_2008*tmp_moved_constant_2044 + tmp_moved_constant_2009*tmp_moved_constant_2046 + tmp_moved_constant_2010*tmp_moved_constant_2048 + tmp_moved_constant_2011*tmp_moved_constant_2050) + tmp_moved_constant_1827*(-jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2045 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2047 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2049 - jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_2051) + tmp_moved_constant_1828*(-jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2052 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2053 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2054 - jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_2055) + tmp_moved_constant_1829*(-jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2056 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2057 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2058 - jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_2059) + tmp_moved_constant_1830*(tmp_moved_constant_1894*tmp_moved_constant_2044 + tmp_moved_constant_1897*tmp_moved_constant_2046 + tmp_moved_constant_1900*tmp_moved_constant_2048 + tmp_moved_constant_1903*tmp_moved_constant_2050) + tmp_moved_constant_1831*(tmp_moved_constant_1906*tmp_moved_constant_2044 + tmp_moved_constant_1909*tmp_moved_constant_2046 + tmp_moved_constant_1912*tmp_moved_constant_2048 + tmp_moved_constant_1915*tmp_moved_constant_2050) + tmp_moved_constant_1832*(tmp_moved_constant_1918*tmp_moved_constant_2044 + tmp_moved_constant_1921*tmp_moved_constant_2046 + tmp_moved_constant_1924*tmp_moved_constant_2048 + tmp_moved_constant_1927*tmp_moved_constant_2050) + tmp_moved_constant_1833*(tmp_moved_constant_1976*tmp_moved_constant_2044 + tmp_moved_constant_1977*tmp_moved_constant_2046 + tmp_moved_constant_1978*tmp_moved_constant_2048 + tmp_moved_constant_1979*tmp_moved_constant_2050) + tmp_moved_constant_1834*(tmp_moved_constant_1980*tmp_moved_constant_2044 + tmp_moved_constant_1981*tmp_moved_constant_2046 + tmp_moved_constant_1982*tmp_moved_constant_2048 + tmp_moved_constant_1983*tmp_moved_constant_2050) + tmp_moved_constant_1835*(tmp_moved_constant_1984*tmp_moved_constant_2044 + tmp_moved_constant_1985*tmp_moved_constant_2046 + tmp_moved_constant_1986*tmp_moved_constant_2048 + tmp_moved_constant_1987*tmp_moved_constant_2050);
                   {
                      {
                     
                         const int64_t phantom_ctr_0 = ctr_0;
                         real_t _data_float_loop_ctr_array_dim_0[4];
                         _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                         _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                         _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                         _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                         real_t _data_float_loop_ctr_array_dim_1[4];
                         _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                         real_t _data_float_loop_ctr_array_dim_2[4];
                         _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                     
                         const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_2060 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_2061 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_2062 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_2063 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      }
                   }
                   const real_t tmp_moved_constant_2064 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_2065 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_2066 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_2067 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_2068 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_2069 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2070 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_2071 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2072 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_2073 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2074 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_2075 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_2076 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_2077 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_2078 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_2079 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2080 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_2081 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2082 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_2083 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2084 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_2085 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_2086 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   const real_t tmp_moved_constant_2087 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   const real_t tmp_moved_constant_2088 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_2089 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2090 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   const real_t tmp_moved_constant_2091 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2092 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                   const real_t tmp_moved_constant_2093 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   const real_t tmp_moved_constant_2094 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
                   const real_t tmp_moved_constant_2095 = tmp_moved_constant_2094*0.13819660112501053;
                   const real_t tmp_moved_constant_2096 = tmp_kernel_op_1*tmp_moved_constant_2095;
                   const real_t tmp_moved_constant_2097 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
                   const real_t tmp_moved_constant_2098 = tmp_moved_constant_2097*0.13819660112501056;
                   const real_t tmp_moved_constant_2099 = tmp_kernel_op_6*tmp_moved_constant_2098;
                   const real_t tmp_moved_constant_2100 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
                   const real_t tmp_moved_constant_2101 = tmp_moved_constant_2100*0.13819660112501056;
                   const real_t tmp_moved_constant_2102 = tmp_kernel_op_11*tmp_moved_constant_2101;
                   const real_t tmp_moved_constant_2103 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
                   const real_t tmp_moved_constant_2104 = tmp_moved_constant_2103*0.5854101966249684;
                   const real_t tmp_moved_constant_2105 = tmp_kernel_op_16*tmp_moved_constant_2104;
                   const real_t tmp_moved_constant_2106 = tmp_kernel_op_21*tmp_moved_constant_2095;
                   const real_t tmp_moved_constant_2107 = tmp_kernel_op_24*tmp_moved_constant_2098;
                   const real_t tmp_moved_constant_2108 = tmp_kernel_op_27*tmp_moved_constant_2101;
                   const real_t tmp_moved_constant_2109 = tmp_kernel_op_30*tmp_moved_constant_2104;
                   const real_t tmp_moved_constant_2110 = tmp_kernel_op_33*tmp_moved_constant_2095;
                   const real_t tmp_moved_constant_2111 = tmp_kernel_op_36*tmp_moved_constant_2098;
                   const real_t tmp_moved_constant_2112 = tmp_kernel_op_39*tmp_moved_constant_2101;
                   const real_t tmp_moved_constant_2113 = tmp_kernel_op_42*tmp_moved_constant_2104;
                   const real_t tmp_moved_constant_2114 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_2115 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_2116 = -tmp_moved_constant_2114 - tmp_moved_constant_2115;
                   const real_t tmp_moved_constant_2117 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_2118 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_2119 = -tmp_moved_constant_2117 - tmp_moved_constant_2118;
                   const real_t tmp_moved_constant_2120 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_2121 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_2122 = -tmp_moved_constant_2120 - tmp_moved_constant_2121;
                   const real_t tmp_moved_constant_2123 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_2124 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_2125 = -tmp_moved_constant_2123 - tmp_moved_constant_2124;
                   const real_t tmp_moved_constant_2126 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_2127 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_2128 = -tmp_moved_constant_2126 - tmp_moved_constant_2127;
                   const real_t tmp_moved_constant_2129 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_2130 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_2131 = -tmp_moved_constant_2129 - tmp_moved_constant_2130;
                   const real_t tmp_moved_constant_2132 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_2133 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_2134 = -tmp_moved_constant_2132 - tmp_moved_constant_2133;
                   const real_t tmp_moved_constant_2135 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_2136 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_2137 = -tmp_moved_constant_2135 - tmp_moved_constant_2136;
                   const real_t tmp_moved_constant_2138 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_2139 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_2140 = -tmp_moved_constant_2138 - tmp_moved_constant_2139;
                   const real_t tmp_moved_constant_2141 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_2142 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_2143 = -tmp_moved_constant_2141 - tmp_moved_constant_2142;
                   const real_t tmp_moved_constant_2144 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_2145 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_2146 = -tmp_moved_constant_2144 - tmp_moved_constant_2145;
                   const real_t tmp_moved_constant_2147 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_2148 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_2149 = -tmp_moved_constant_2147 - tmp_moved_constant_2148;
                   const real_t tmp_moved_constant_2150 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_2151 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_2152 = -tmp_moved_constant_2150 - tmp_moved_constant_2151;
                   const real_t tmp_moved_constant_2153 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_2154 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_2155 = -tmp_moved_constant_2153 - tmp_moved_constant_2154;
                   const real_t tmp_moved_constant_2156 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_2157 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_2158 = -tmp_moved_constant_2156 - tmp_moved_constant_2157;
                   const real_t tmp_moved_constant_2159 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_2160 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_2161 = -tmp_moved_constant_2159 - tmp_moved_constant_2160;
                   const real_t tmp_moved_constant_2162 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_2163 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_2164 = -tmp_moved_constant_2162 - tmp_moved_constant_2163;
                   const real_t tmp_moved_constant_2165 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_2166 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_2167 = -tmp_moved_constant_2165 - tmp_moved_constant_2166;
                   const real_t tmp_moved_constant_2168 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_2169 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_2170 = -tmp_moved_constant_2168 - tmp_moved_constant_2169;
                   const real_t tmp_moved_constant_2171 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_2172 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_2173 = -tmp_moved_constant_2171 - tmp_moved_constant_2172;
                   const real_t tmp_moved_constant_2174 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_2175 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_2176 = -tmp_moved_constant_2174 - tmp_moved_constant_2175;
                   const real_t tmp_moved_constant_2177 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_2178 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_2179 = -tmp_moved_constant_2177 - tmp_moved_constant_2178;
                   const real_t tmp_moved_constant_2180 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_2181 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_2182 = -tmp_moved_constant_2180 - tmp_moved_constant_2181;
                   const real_t tmp_moved_constant_2183 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_2184 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_2185 = -tmp_moved_constant_2183 - tmp_moved_constant_2184;
                   const real_t tmp_moved_constant_2186 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_2187 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_2188 = -tmp_moved_constant_2186 - tmp_moved_constant_2187;
                   const real_t tmp_moved_constant_2189 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_2190 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_2191 = -tmp_moved_constant_2189 - tmp_moved_constant_2190;
                   const real_t tmp_moved_constant_2192 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_2193 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_2194 = -tmp_moved_constant_2192 - tmp_moved_constant_2193;
                   const real_t tmp_moved_constant_2195 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_2196 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_2197 = -tmp_moved_constant_2195 - tmp_moved_constant_2196;
                   const real_t tmp_moved_constant_2198 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_32;
                   const real_t tmp_moved_constant_2199 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_2200 = -tmp_moved_constant_2198 - tmp_moved_constant_2199;
                   const real_t tmp_moved_constant_2201 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_35;
                   const real_t tmp_moved_constant_2202 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_2203 = -tmp_moved_constant_2201 - tmp_moved_constant_2202;
                   const real_t tmp_moved_constant_2204 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_38;
                   const real_t tmp_moved_constant_2205 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_2206 = -tmp_moved_constant_2204 - tmp_moved_constant_2205;
                   const real_t tmp_moved_constant_2207 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_41;
                   const real_t tmp_moved_constant_2208 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_2209 = -tmp_moved_constant_2207 - tmp_moved_constant_2208;
                   const real_t tmp_moved_constant_2210 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_20;
                   const real_t tmp_moved_constant_2211 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_0;
                   const real_t tmp_moved_constant_2212 = -tmp_moved_constant_2210 - tmp_moved_constant_2211;
                   const real_t tmp_moved_constant_2213 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_23;
                   const real_t tmp_moved_constant_2214 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_5;
                   const real_t tmp_moved_constant_2215 = -tmp_moved_constant_2213 - tmp_moved_constant_2214;
                   const real_t tmp_moved_constant_2216 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_26;
                   const real_t tmp_moved_constant_2217 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_10;
                   const real_t tmp_moved_constant_2218 = -tmp_moved_constant_2216 - tmp_moved_constant_2217;
                   const real_t tmp_moved_constant_2219 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_29;
                   const real_t tmp_moved_constant_2220 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_15;
                   const real_t tmp_moved_constant_2221 = -tmp_moved_constant_2219 - tmp_moved_constant_2220;
                   const real_t tmp_moved_constant_2222 = -jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_153 + tmp_moved_constant_2114 + tmp_moved_constant_2126;
                   const real_t tmp_moved_constant_2223 = -jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_156 + tmp_moved_constant_2117 + tmp_moved_constant_2129;
                   const real_t tmp_moved_constant_2224 = -jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_159 + tmp_moved_constant_2120 + tmp_moved_constant_2132;
                   const real_t tmp_moved_constant_2225 = -jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_162 + tmp_moved_constant_2123 + tmp_moved_constant_2135;
                   const real_t tmp_moved_constant_2226 = -jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_165 + tmp_moved_constant_2115 + tmp_moved_constant_2138;
                   const real_t tmp_moved_constant_2227 = -jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_168 + tmp_moved_constant_2118 + tmp_moved_constant_2141;
                   const real_t tmp_moved_constant_2228 = -jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_171 + tmp_moved_constant_2121 + tmp_moved_constant_2144;
                   const real_t tmp_moved_constant_2229 = -jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_174 + tmp_moved_constant_2124 + tmp_moved_constant_2147;
                   const real_t tmp_moved_constant_2230 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_176 + tmp_moved_constant_2127 + tmp_moved_constant_2139;
                   const real_t tmp_moved_constant_2231 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_178 + tmp_moved_constant_2130 + tmp_moved_constant_2142;
                   const real_t tmp_moved_constant_2232 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_180 + tmp_moved_constant_2133 + tmp_moved_constant_2145;
                   const real_t tmp_moved_constant_2233 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_182 + tmp_moved_constant_2136 + tmp_moved_constant_2148;
                   const real_t tmp_moved_constant_2234 = -jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_153 + tmp_moved_constant_2150 + tmp_moved_constant_2162;
                   const real_t tmp_moved_constant_2235 = -jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_156 + tmp_moved_constant_2153 + tmp_moved_constant_2165;
                   const real_t tmp_moved_constant_2236 = -jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_159 + tmp_moved_constant_2156 + tmp_moved_constant_2168;
                   const real_t tmp_moved_constant_2237 = -jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_162 + tmp_moved_constant_2159 + tmp_moved_constant_2171;
                   const real_t tmp_moved_constant_2238 = -jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_165 + tmp_moved_constant_2151 + tmp_moved_constant_2174;
                   const real_t tmp_moved_constant_2239 = -jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_168 + tmp_moved_constant_2154 + tmp_moved_constant_2177;
                   const real_t tmp_moved_constant_2240 = -jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_171 + tmp_moved_constant_2157 + tmp_moved_constant_2180;
                   const real_t tmp_moved_constant_2241 = -jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_174 + tmp_moved_constant_2160 + tmp_moved_constant_2183;
                   const real_t tmp_moved_constant_2242 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_176 + tmp_moved_constant_2163 + tmp_moved_constant_2175;
                   const real_t tmp_moved_constant_2243 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_178 + tmp_moved_constant_2166 + tmp_moved_constant_2178;
                   const real_t tmp_moved_constant_2244 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_180 + tmp_moved_constant_2169 + tmp_moved_constant_2181;
                   const real_t tmp_moved_constant_2245 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_182 + tmp_moved_constant_2172 + tmp_moved_constant_2184;
                   const real_t tmp_moved_constant_2246 = -jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_153 + tmp_moved_constant_2186 + tmp_moved_constant_2198;
                   const real_t tmp_moved_constant_2247 = -jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_156 + tmp_moved_constant_2189 + tmp_moved_constant_2201;
                   const real_t tmp_moved_constant_2248 = -jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_159 + tmp_moved_constant_2192 + tmp_moved_constant_2204;
                   const real_t tmp_moved_constant_2249 = -jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_162 + tmp_moved_constant_2195 + tmp_moved_constant_2207;
                   const real_t tmp_moved_constant_2250 = -jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_165 + tmp_moved_constant_2187 + tmp_moved_constant_2210;
                   const real_t tmp_moved_constant_2251 = -jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_168 + tmp_moved_constant_2190 + tmp_moved_constant_2213;
                   const real_t tmp_moved_constant_2252 = -jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_171 + tmp_moved_constant_2193 + tmp_moved_constant_2216;
                   const real_t tmp_moved_constant_2253 = -jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_174 + tmp_moved_constant_2196 + tmp_moved_constant_2219;
                   const real_t tmp_moved_constant_2254 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_176 + tmp_moved_constant_2199 + tmp_moved_constant_2211;
                   const real_t tmp_moved_constant_2255 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_178 + tmp_moved_constant_2202 + tmp_moved_constant_2214;
                   const real_t tmp_moved_constant_2256 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_180 + tmp_moved_constant_2205 + tmp_moved_constant_2217;
                   const real_t tmp_moved_constant_2257 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_182 + tmp_moved_constant_2208 + tmp_moved_constant_2220;
                   const real_t tmp_moved_constant_2258 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_2259 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_2260 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_2261 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_2262 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_2263 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_2264 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_2265 = -jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_2266 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_208 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_208;
                   const real_t tmp_moved_constant_2267 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_210 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_210;
                   const real_t tmp_moved_constant_2268 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_212 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_212;
                   const real_t tmp_moved_constant_2269 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_214 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_214;
                   const real_t tmp_moved_constant_2270 = tmp_moved_constant_2094*0.1381966011250105;
                   const real_t tmp_moved_constant_2271 = tmp_kernel_op_1*tmp_moved_constant_2270;
                   const real_t tmp_moved_constant_2272 = tmp_moved_constant_2097*0.1381966011250105;
                   const real_t tmp_moved_constant_2273 = tmp_kernel_op_6*tmp_moved_constant_2272;
                   const real_t tmp_moved_constant_2274 = tmp_moved_constant_2100*0.5854101966249684;
                   const real_t tmp_moved_constant_2275 = tmp_kernel_op_11*tmp_moved_constant_2274;
                   const real_t tmp_moved_constant_2276 = tmp_moved_constant_2103*0.1381966011250105;
                   const real_t tmp_moved_constant_2277 = tmp_kernel_op_16*tmp_moved_constant_2276;
                   const real_t tmp_moved_constant_2278 = tmp_kernel_op_21*tmp_moved_constant_2270;
                   const real_t tmp_moved_constant_2279 = tmp_kernel_op_24*tmp_moved_constant_2272;
                   const real_t tmp_moved_constant_2280 = tmp_kernel_op_27*tmp_moved_constant_2274;
                   const real_t tmp_moved_constant_2281 = tmp_kernel_op_30*tmp_moved_constant_2276;
                   const real_t tmp_moved_constant_2282 = tmp_kernel_op_33*tmp_moved_constant_2270;
                   const real_t tmp_moved_constant_2283 = tmp_kernel_op_36*tmp_moved_constant_2272;
                   const real_t tmp_moved_constant_2284 = tmp_kernel_op_39*tmp_moved_constant_2274;
                   const real_t tmp_moved_constant_2285 = tmp_kernel_op_42*tmp_moved_constant_2276;
                   const real_t tmp_moved_constant_2286 = tmp_moved_constant_2094*0.1381966011250105;
                   const real_t tmp_moved_constant_2287 = tmp_kernel_op_1*tmp_moved_constant_2286;
                   const real_t tmp_moved_constant_2288 = tmp_moved_constant_2097*0.5854101966249684;
                   const real_t tmp_moved_constant_2289 = tmp_kernel_op_6*tmp_moved_constant_2288;
                   const real_t tmp_moved_constant_2290 = tmp_moved_constant_2100*0.1381966011250105;
                   const real_t tmp_moved_constant_2291 = tmp_kernel_op_11*tmp_moved_constant_2290;
                   const real_t tmp_moved_constant_2292 = tmp_moved_constant_2103*0.1381966011250105;
                   const real_t tmp_moved_constant_2293 = tmp_kernel_op_16*tmp_moved_constant_2292;
                   const real_t tmp_moved_constant_2294 = tmp_kernel_op_21*tmp_moved_constant_2286;
                   const real_t tmp_moved_constant_2295 = tmp_kernel_op_24*tmp_moved_constant_2288;
                   const real_t tmp_moved_constant_2296 = tmp_kernel_op_27*tmp_moved_constant_2290;
                   const real_t tmp_moved_constant_2297 = tmp_kernel_op_30*tmp_moved_constant_2292;
                   const real_t tmp_moved_constant_2298 = tmp_kernel_op_33*tmp_moved_constant_2286;
                   const real_t tmp_moved_constant_2299 = tmp_kernel_op_36*tmp_moved_constant_2288;
                   const real_t tmp_moved_constant_2300 = tmp_kernel_op_39*tmp_moved_constant_2290;
                   const real_t tmp_moved_constant_2301 = tmp_kernel_op_42*tmp_moved_constant_2292;
                   const real_t tmp_moved_constant_2302 = tmp_moved_constant_2094*0.5854101966249684;
                   const real_t tmp_moved_constant_2303 = tmp_kernel_op_1*tmp_moved_constant_2302;
                   const real_t tmp_moved_constant_2304 = tmp_moved_constant_2097*0.1381966011250105;
                   const real_t tmp_moved_constant_2305 = tmp_kernel_op_6*tmp_moved_constant_2304;
                   const real_t tmp_moved_constant_2306 = tmp_moved_constant_2100*0.1381966011250105;
                   const real_t tmp_moved_constant_2307 = tmp_kernel_op_11*tmp_moved_constant_2306;
                   const real_t tmp_moved_constant_2308 = tmp_moved_constant_2103*0.1381966011250105;
                   const real_t tmp_moved_constant_2309 = tmp_kernel_op_16*tmp_moved_constant_2308;
                   const real_t tmp_moved_constant_2310 = tmp_kernel_op_21*tmp_moved_constant_2302;
                   const real_t tmp_moved_constant_2311 = tmp_kernel_op_24*tmp_moved_constant_2304;
                   const real_t tmp_moved_constant_2312 = tmp_kernel_op_27*tmp_moved_constant_2306;
                   const real_t tmp_moved_constant_2313 = tmp_kernel_op_30*tmp_moved_constant_2308;
                   const real_t tmp_moved_constant_2314 = tmp_kernel_op_33*tmp_moved_constant_2302;
                   const real_t tmp_moved_constant_2315 = tmp_kernel_op_36*tmp_moved_constant_2304;
                   const real_t tmp_moved_constant_2316 = tmp_kernel_op_39*tmp_moved_constant_2306;
                   const real_t tmp_moved_constant_2317 = tmp_kernel_op_42*tmp_moved_constant_2308;
                   const real_t tmp_moved_constant_2318 = tmp_moved_constant_2064*(tmp_moved_constant_2095*tmp_moved_constant_2258 + tmp_moved_constant_2098*tmp_moved_constant_2259 + tmp_moved_constant_2101*tmp_moved_constant_2260 + tmp_moved_constant_2104*tmp_moved_constant_2261) + tmp_moved_constant_2065*(-jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2096 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2099 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2102 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2105) + tmp_moved_constant_2066*(-jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2106 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2107 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2108 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2109) + tmp_moved_constant_2067*(-jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2110 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2111 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2112 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2113) + tmp_moved_constant_2068*(tmp_moved_constant_2095*tmp_moved_constant_2188 + tmp_moved_constant_2098*tmp_moved_constant_2191 + tmp_moved_constant_2101*tmp_moved_constant_2194 + tmp_moved_constant_2104*tmp_moved_constant_2197) + tmp_moved_constant_2069*(tmp_moved_constant_2095*tmp_moved_constant_2200 + tmp_moved_constant_2098*tmp_moved_constant_2203 + tmp_moved_constant_2101*tmp_moved_constant_2206 + tmp_moved_constant_2104*tmp_moved_constant_2209) + tmp_moved_constant_2070*(tmp_moved_constant_2095*tmp_moved_constant_2212 + tmp_moved_constant_2098*tmp_moved_constant_2215 + tmp_moved_constant_2101*tmp_moved_constant_2218 + tmp_moved_constant_2104*tmp_moved_constant_2221) + tmp_moved_constant_2071*(tmp_moved_constant_2095*tmp_moved_constant_2246 + tmp_moved_constant_2098*tmp_moved_constant_2247 + tmp_moved_constant_2101*tmp_moved_constant_2248 + tmp_moved_constant_2104*tmp_moved_constant_2249) + tmp_moved_constant_2072*(tmp_moved_constant_2095*tmp_moved_constant_2250 + tmp_moved_constant_2098*tmp_moved_constant_2251 + tmp_moved_constant_2101*tmp_moved_constant_2252 + tmp_moved_constant_2104*tmp_moved_constant_2253) + tmp_moved_constant_2073*(tmp_moved_constant_2095*tmp_moved_constant_2254 + tmp_moved_constant_2098*tmp_moved_constant_2255 + tmp_moved_constant_2101*tmp_moved_constant_2256 + tmp_moved_constant_2104*tmp_moved_constant_2257) + tmp_moved_constant_2074*(tmp_moved_constant_2095*tmp_moved_constant_2262 + tmp_moved_constant_2098*tmp_moved_constant_2263 + tmp_moved_constant_2101*tmp_moved_constant_2264 + tmp_moved_constant_2104*tmp_moved_constant_2265) + tmp_moved_constant_2075*(-jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2096 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2099 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2102 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2105) + tmp_moved_constant_2076*(-jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2106 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2107 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2108 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2109) + tmp_moved_constant_2077*(-jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2110 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2111 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2112 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2113) + tmp_moved_constant_2078*(tmp_moved_constant_2095*tmp_moved_constant_2116 + tmp_moved_constant_2098*tmp_moved_constant_2119 + tmp_moved_constant_2101*tmp_moved_constant_2122 + tmp_moved_constant_2104*tmp_moved_constant_2125) + tmp_moved_constant_2079*(tmp_moved_constant_2095*tmp_moved_constant_2128 + tmp_moved_constant_2098*tmp_moved_constant_2131 + tmp_moved_constant_2101*tmp_moved_constant_2134 + tmp_moved_constant_2104*tmp_moved_constant_2137) + tmp_moved_constant_2080*(tmp_moved_constant_2095*tmp_moved_constant_2140 + tmp_moved_constant_2098*tmp_moved_constant_2143 + tmp_moved_constant_2101*tmp_moved_constant_2146 + tmp_moved_constant_2104*tmp_moved_constant_2149) + tmp_moved_constant_2081*(tmp_moved_constant_2095*tmp_moved_constant_2222 + tmp_moved_constant_2098*tmp_moved_constant_2223 + tmp_moved_constant_2101*tmp_moved_constant_2224 + tmp_moved_constant_2104*tmp_moved_constant_2225) + tmp_moved_constant_2082*(tmp_moved_constant_2095*tmp_moved_constant_2226 + tmp_moved_constant_2098*tmp_moved_constant_2227 + tmp_moved_constant_2101*tmp_moved_constant_2228 + tmp_moved_constant_2104*tmp_moved_constant_2229) + tmp_moved_constant_2083*(tmp_moved_constant_2095*tmp_moved_constant_2230 + tmp_moved_constant_2098*tmp_moved_constant_2231 + tmp_moved_constant_2101*tmp_moved_constant_2232 + tmp_moved_constant_2104*tmp_moved_constant_2233) + tmp_moved_constant_2084*(tmp_moved_constant_2095*tmp_moved_constant_2266 + tmp_moved_constant_2098*tmp_moved_constant_2267 + tmp_moved_constant_2101*tmp_moved_constant_2268 + tmp_moved_constant_2104*tmp_moved_constant_2269) + tmp_moved_constant_2085*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2096 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2099 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2102 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2105) + tmp_moved_constant_2086*(-jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2106 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2107 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2108 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2109) + tmp_moved_constant_2087*(-jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2110 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2111 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2112 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2113) + tmp_moved_constant_2088*(tmp_moved_constant_2095*tmp_moved_constant_2152 + tmp_moved_constant_2098*tmp_moved_constant_2155 + tmp_moved_constant_2101*tmp_moved_constant_2158 + tmp_moved_constant_2104*tmp_moved_constant_2161) + tmp_moved_constant_2089*(tmp_moved_constant_2095*tmp_moved_constant_2164 + tmp_moved_constant_2098*tmp_moved_constant_2167 + tmp_moved_constant_2101*tmp_moved_constant_2170 + tmp_moved_constant_2104*tmp_moved_constant_2173) + tmp_moved_constant_2090*(tmp_moved_constant_2095*tmp_moved_constant_2176 + tmp_moved_constant_2098*tmp_moved_constant_2179 + tmp_moved_constant_2101*tmp_moved_constant_2182 + tmp_moved_constant_2104*tmp_moved_constant_2185) + tmp_moved_constant_2091*(tmp_moved_constant_2095*tmp_moved_constant_2234 + tmp_moved_constant_2098*tmp_moved_constant_2235 + tmp_moved_constant_2101*tmp_moved_constant_2236 + tmp_moved_constant_2104*tmp_moved_constant_2237) + tmp_moved_constant_2092*(tmp_moved_constant_2095*tmp_moved_constant_2238 + tmp_moved_constant_2098*tmp_moved_constant_2239 + tmp_moved_constant_2101*tmp_moved_constant_2240 + tmp_moved_constant_2104*tmp_moved_constant_2241) + tmp_moved_constant_2093*(tmp_moved_constant_2095*tmp_moved_constant_2242 + tmp_moved_constant_2098*tmp_moved_constant_2243 + tmp_moved_constant_2101*tmp_moved_constant_2244 + tmp_moved_constant_2104*tmp_moved_constant_2245);
                   const real_t tmp_moved_constant_2319 = tmp_moved_constant_2064*(tmp_moved_constant_2258*tmp_moved_constant_2270 + tmp_moved_constant_2259*tmp_moved_constant_2272 + tmp_moved_constant_2260*tmp_moved_constant_2274 + tmp_moved_constant_2261*tmp_moved_constant_2276) + tmp_moved_constant_2065*(-jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2271 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2273 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2275 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2277) + tmp_moved_constant_2066*(-jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2278 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2279 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2280 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2281) + tmp_moved_constant_2067*(-jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2282 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2283 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2284 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2285) + tmp_moved_constant_2068*(tmp_moved_constant_2188*tmp_moved_constant_2270 + tmp_moved_constant_2191*tmp_moved_constant_2272 + tmp_moved_constant_2194*tmp_moved_constant_2274 + tmp_moved_constant_2197*tmp_moved_constant_2276) + tmp_moved_constant_2069*(tmp_moved_constant_2200*tmp_moved_constant_2270 + tmp_moved_constant_2203*tmp_moved_constant_2272 + tmp_moved_constant_2206*tmp_moved_constant_2274 + tmp_moved_constant_2209*tmp_moved_constant_2276) + tmp_moved_constant_2070*(tmp_moved_constant_2212*tmp_moved_constant_2270 + tmp_moved_constant_2215*tmp_moved_constant_2272 + tmp_moved_constant_2218*tmp_moved_constant_2274 + tmp_moved_constant_2221*tmp_moved_constant_2276) + tmp_moved_constant_2071*(tmp_moved_constant_2246*tmp_moved_constant_2270 + tmp_moved_constant_2247*tmp_moved_constant_2272 + tmp_moved_constant_2248*tmp_moved_constant_2274 + tmp_moved_constant_2249*tmp_moved_constant_2276) + tmp_moved_constant_2072*(tmp_moved_constant_2250*tmp_moved_constant_2270 + tmp_moved_constant_2251*tmp_moved_constant_2272 + tmp_moved_constant_2252*tmp_moved_constant_2274 + tmp_moved_constant_2253*tmp_moved_constant_2276) + tmp_moved_constant_2073*(tmp_moved_constant_2254*tmp_moved_constant_2270 + tmp_moved_constant_2255*tmp_moved_constant_2272 + tmp_moved_constant_2256*tmp_moved_constant_2274 + tmp_moved_constant_2257*tmp_moved_constant_2276) + tmp_moved_constant_2074*(tmp_moved_constant_2262*tmp_moved_constant_2270 + tmp_moved_constant_2263*tmp_moved_constant_2272 + tmp_moved_constant_2264*tmp_moved_constant_2274 + tmp_moved_constant_2265*tmp_moved_constant_2276) + tmp_moved_constant_2075*(-jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2271 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2273 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2275 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2277) + tmp_moved_constant_2076*(-jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2278 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2279 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2280 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2281) + tmp_moved_constant_2077*(-jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2282 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2283 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2284 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2285) + tmp_moved_constant_2078*(tmp_moved_constant_2116*tmp_moved_constant_2270 + tmp_moved_constant_2119*tmp_moved_constant_2272 + tmp_moved_constant_2122*tmp_moved_constant_2274 + tmp_moved_constant_2125*tmp_moved_constant_2276) + tmp_moved_constant_2079*(tmp_moved_constant_2128*tmp_moved_constant_2270 + tmp_moved_constant_2131*tmp_moved_constant_2272 + tmp_moved_constant_2134*tmp_moved_constant_2274 + tmp_moved_constant_2137*tmp_moved_constant_2276) + tmp_moved_constant_2080*(tmp_moved_constant_2140*tmp_moved_constant_2270 + tmp_moved_constant_2143*tmp_moved_constant_2272 + tmp_moved_constant_2146*tmp_moved_constant_2274 + tmp_moved_constant_2149*tmp_moved_constant_2276) + tmp_moved_constant_2081*(tmp_moved_constant_2222*tmp_moved_constant_2270 + tmp_moved_constant_2223*tmp_moved_constant_2272 + tmp_moved_constant_2224*tmp_moved_constant_2274 + tmp_moved_constant_2225*tmp_moved_constant_2276) + tmp_moved_constant_2082*(tmp_moved_constant_2226*tmp_moved_constant_2270 + tmp_moved_constant_2227*tmp_moved_constant_2272 + tmp_moved_constant_2228*tmp_moved_constant_2274 + tmp_moved_constant_2229*tmp_moved_constant_2276) + tmp_moved_constant_2083*(tmp_moved_constant_2230*tmp_moved_constant_2270 + tmp_moved_constant_2231*tmp_moved_constant_2272 + tmp_moved_constant_2232*tmp_moved_constant_2274 + tmp_moved_constant_2233*tmp_moved_constant_2276) + tmp_moved_constant_2084*(tmp_moved_constant_2266*tmp_moved_constant_2270 + tmp_moved_constant_2267*tmp_moved_constant_2272 + tmp_moved_constant_2268*tmp_moved_constant_2274 + tmp_moved_constant_2269*tmp_moved_constant_2276) + tmp_moved_constant_2085*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2271 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2273 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2275 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2277) + tmp_moved_constant_2086*(-jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2278 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2279 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2280 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2281) + tmp_moved_constant_2087*(-jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2282 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2283 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2284 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2285) + tmp_moved_constant_2088*(tmp_moved_constant_2152*tmp_moved_constant_2270 + tmp_moved_constant_2155*tmp_moved_constant_2272 + tmp_moved_constant_2158*tmp_moved_constant_2274 + tmp_moved_constant_2161*tmp_moved_constant_2276) + tmp_moved_constant_2089*(tmp_moved_constant_2164*tmp_moved_constant_2270 + tmp_moved_constant_2167*tmp_moved_constant_2272 + tmp_moved_constant_2170*tmp_moved_constant_2274 + tmp_moved_constant_2173*tmp_moved_constant_2276) + tmp_moved_constant_2090*(tmp_moved_constant_2176*tmp_moved_constant_2270 + tmp_moved_constant_2179*tmp_moved_constant_2272 + tmp_moved_constant_2182*tmp_moved_constant_2274 + tmp_moved_constant_2185*tmp_moved_constant_2276) + tmp_moved_constant_2091*(tmp_moved_constant_2234*tmp_moved_constant_2270 + tmp_moved_constant_2235*tmp_moved_constant_2272 + tmp_moved_constant_2236*tmp_moved_constant_2274 + tmp_moved_constant_2237*tmp_moved_constant_2276) + tmp_moved_constant_2092*(tmp_moved_constant_2238*tmp_moved_constant_2270 + tmp_moved_constant_2239*tmp_moved_constant_2272 + tmp_moved_constant_2240*tmp_moved_constant_2274 + tmp_moved_constant_2241*tmp_moved_constant_2276) + tmp_moved_constant_2093*(tmp_moved_constant_2242*tmp_moved_constant_2270 + tmp_moved_constant_2243*tmp_moved_constant_2272 + tmp_moved_constant_2244*tmp_moved_constant_2274 + tmp_moved_constant_2245*tmp_moved_constant_2276);
                   const real_t tmp_moved_constant_2320 = tmp_moved_constant_2064*(tmp_moved_constant_2258*tmp_moved_constant_2286 + tmp_moved_constant_2259*tmp_moved_constant_2288 + tmp_moved_constant_2260*tmp_moved_constant_2290 + tmp_moved_constant_2261*tmp_moved_constant_2292) + tmp_moved_constant_2065*(-jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2287 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2289 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2291 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2293) + tmp_moved_constant_2066*(-jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2294 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2295 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2296 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2297) + tmp_moved_constant_2067*(-jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2298 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2299 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2300 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2301) + tmp_moved_constant_2068*(tmp_moved_constant_2188*tmp_moved_constant_2286 + tmp_moved_constant_2191*tmp_moved_constant_2288 + tmp_moved_constant_2194*tmp_moved_constant_2290 + tmp_moved_constant_2197*tmp_moved_constant_2292) + tmp_moved_constant_2069*(tmp_moved_constant_2200*tmp_moved_constant_2286 + tmp_moved_constant_2203*tmp_moved_constant_2288 + tmp_moved_constant_2206*tmp_moved_constant_2290 + tmp_moved_constant_2209*tmp_moved_constant_2292) + tmp_moved_constant_2070*(tmp_moved_constant_2212*tmp_moved_constant_2286 + tmp_moved_constant_2215*tmp_moved_constant_2288 + tmp_moved_constant_2218*tmp_moved_constant_2290 + tmp_moved_constant_2221*tmp_moved_constant_2292) + tmp_moved_constant_2071*(tmp_moved_constant_2246*tmp_moved_constant_2286 + tmp_moved_constant_2247*tmp_moved_constant_2288 + tmp_moved_constant_2248*tmp_moved_constant_2290 + tmp_moved_constant_2249*tmp_moved_constant_2292) + tmp_moved_constant_2072*(tmp_moved_constant_2250*tmp_moved_constant_2286 + tmp_moved_constant_2251*tmp_moved_constant_2288 + tmp_moved_constant_2252*tmp_moved_constant_2290 + tmp_moved_constant_2253*tmp_moved_constant_2292) + tmp_moved_constant_2073*(tmp_moved_constant_2254*tmp_moved_constant_2286 + tmp_moved_constant_2255*tmp_moved_constant_2288 + tmp_moved_constant_2256*tmp_moved_constant_2290 + tmp_moved_constant_2257*tmp_moved_constant_2292) + tmp_moved_constant_2074*(tmp_moved_constant_2262*tmp_moved_constant_2286 + tmp_moved_constant_2263*tmp_moved_constant_2288 + tmp_moved_constant_2264*tmp_moved_constant_2290 + tmp_moved_constant_2265*tmp_moved_constant_2292) + tmp_moved_constant_2075*(-jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2287 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2289 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2291 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2293) + tmp_moved_constant_2076*(-jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2294 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2295 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2296 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2297) + tmp_moved_constant_2077*(-jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2298 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2299 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2300 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2301) + tmp_moved_constant_2078*(tmp_moved_constant_2116*tmp_moved_constant_2286 + tmp_moved_constant_2119*tmp_moved_constant_2288 + tmp_moved_constant_2122*tmp_moved_constant_2290 + tmp_moved_constant_2125*tmp_moved_constant_2292) + tmp_moved_constant_2079*(tmp_moved_constant_2128*tmp_moved_constant_2286 + tmp_moved_constant_2131*tmp_moved_constant_2288 + tmp_moved_constant_2134*tmp_moved_constant_2290 + tmp_moved_constant_2137*tmp_moved_constant_2292) + tmp_moved_constant_2080*(tmp_moved_constant_2140*tmp_moved_constant_2286 + tmp_moved_constant_2143*tmp_moved_constant_2288 + tmp_moved_constant_2146*tmp_moved_constant_2290 + tmp_moved_constant_2149*tmp_moved_constant_2292) + tmp_moved_constant_2081*(tmp_moved_constant_2222*tmp_moved_constant_2286 + tmp_moved_constant_2223*tmp_moved_constant_2288 + tmp_moved_constant_2224*tmp_moved_constant_2290 + tmp_moved_constant_2225*tmp_moved_constant_2292) + tmp_moved_constant_2082*(tmp_moved_constant_2226*tmp_moved_constant_2286 + tmp_moved_constant_2227*tmp_moved_constant_2288 + tmp_moved_constant_2228*tmp_moved_constant_2290 + tmp_moved_constant_2229*tmp_moved_constant_2292) + tmp_moved_constant_2083*(tmp_moved_constant_2230*tmp_moved_constant_2286 + tmp_moved_constant_2231*tmp_moved_constant_2288 + tmp_moved_constant_2232*tmp_moved_constant_2290 + tmp_moved_constant_2233*tmp_moved_constant_2292) + tmp_moved_constant_2084*(tmp_moved_constant_2266*tmp_moved_constant_2286 + tmp_moved_constant_2267*tmp_moved_constant_2288 + tmp_moved_constant_2268*tmp_moved_constant_2290 + tmp_moved_constant_2269*tmp_moved_constant_2292) + tmp_moved_constant_2085*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2287 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2289 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2291 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2293) + tmp_moved_constant_2086*(-jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2294 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2295 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2296 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2297) + tmp_moved_constant_2087*(-jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2298 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2299 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2300 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2301) + tmp_moved_constant_2088*(tmp_moved_constant_2152*tmp_moved_constant_2286 + tmp_moved_constant_2155*tmp_moved_constant_2288 + tmp_moved_constant_2158*tmp_moved_constant_2290 + tmp_moved_constant_2161*tmp_moved_constant_2292) + tmp_moved_constant_2089*(tmp_moved_constant_2164*tmp_moved_constant_2286 + tmp_moved_constant_2167*tmp_moved_constant_2288 + tmp_moved_constant_2170*tmp_moved_constant_2290 + tmp_moved_constant_2173*tmp_moved_constant_2292) + tmp_moved_constant_2090*(tmp_moved_constant_2176*tmp_moved_constant_2286 + tmp_moved_constant_2179*tmp_moved_constant_2288 + tmp_moved_constant_2182*tmp_moved_constant_2290 + tmp_moved_constant_2185*tmp_moved_constant_2292) + tmp_moved_constant_2091*(tmp_moved_constant_2234*tmp_moved_constant_2286 + tmp_moved_constant_2235*tmp_moved_constant_2288 + tmp_moved_constant_2236*tmp_moved_constant_2290 + tmp_moved_constant_2237*tmp_moved_constant_2292) + tmp_moved_constant_2092*(tmp_moved_constant_2238*tmp_moved_constant_2286 + tmp_moved_constant_2239*tmp_moved_constant_2288 + tmp_moved_constant_2240*tmp_moved_constant_2290 + tmp_moved_constant_2241*tmp_moved_constant_2292) + tmp_moved_constant_2093*(tmp_moved_constant_2242*tmp_moved_constant_2286 + tmp_moved_constant_2243*tmp_moved_constant_2288 + tmp_moved_constant_2244*tmp_moved_constant_2290 + tmp_moved_constant_2245*tmp_moved_constant_2292);
                   const real_t tmp_moved_constant_2321 = tmp_moved_constant_2064*(tmp_moved_constant_2258*tmp_moved_constant_2302 + tmp_moved_constant_2259*tmp_moved_constant_2304 + tmp_moved_constant_2260*tmp_moved_constant_2306 + tmp_moved_constant_2261*tmp_moved_constant_2308) + tmp_moved_constant_2065*(-jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2303 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2305 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2307 - jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_2309) + tmp_moved_constant_2066*(-jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2310 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2311 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2312 - jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_2313) + tmp_moved_constant_2067*(-jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2314 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2315 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2316 - jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_2317) + tmp_moved_constant_2068*(tmp_moved_constant_2188*tmp_moved_constant_2302 + tmp_moved_constant_2191*tmp_moved_constant_2304 + tmp_moved_constant_2194*tmp_moved_constant_2306 + tmp_moved_constant_2197*tmp_moved_constant_2308) + tmp_moved_constant_2069*(tmp_moved_constant_2200*tmp_moved_constant_2302 + tmp_moved_constant_2203*tmp_moved_constant_2304 + tmp_moved_constant_2206*tmp_moved_constant_2306 + tmp_moved_constant_2209*tmp_moved_constant_2308) + tmp_moved_constant_2070*(tmp_moved_constant_2212*tmp_moved_constant_2302 + tmp_moved_constant_2215*tmp_moved_constant_2304 + tmp_moved_constant_2218*tmp_moved_constant_2306 + tmp_moved_constant_2221*tmp_moved_constant_2308) + tmp_moved_constant_2071*(tmp_moved_constant_2246*tmp_moved_constant_2302 + tmp_moved_constant_2247*tmp_moved_constant_2304 + tmp_moved_constant_2248*tmp_moved_constant_2306 + tmp_moved_constant_2249*tmp_moved_constant_2308) + tmp_moved_constant_2072*(tmp_moved_constant_2250*tmp_moved_constant_2302 + tmp_moved_constant_2251*tmp_moved_constant_2304 + tmp_moved_constant_2252*tmp_moved_constant_2306 + tmp_moved_constant_2253*tmp_moved_constant_2308) + tmp_moved_constant_2073*(tmp_moved_constant_2254*tmp_moved_constant_2302 + tmp_moved_constant_2255*tmp_moved_constant_2304 + tmp_moved_constant_2256*tmp_moved_constant_2306 + tmp_moved_constant_2257*tmp_moved_constant_2308) + tmp_moved_constant_2074*(tmp_moved_constant_2262*tmp_moved_constant_2302 + tmp_moved_constant_2263*tmp_moved_constant_2304 + tmp_moved_constant_2264*tmp_moved_constant_2306 + tmp_moved_constant_2265*tmp_moved_constant_2308) + tmp_moved_constant_2075*(-jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2303 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2305 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2307 - jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_2309) + tmp_moved_constant_2076*(-jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2310 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2311 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2312 - jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_2313) + tmp_moved_constant_2077*(-jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2314 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2315 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2316 - jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_2317) + tmp_moved_constant_2078*(tmp_moved_constant_2116*tmp_moved_constant_2302 + tmp_moved_constant_2119*tmp_moved_constant_2304 + tmp_moved_constant_2122*tmp_moved_constant_2306 + tmp_moved_constant_2125*tmp_moved_constant_2308) + tmp_moved_constant_2079*(tmp_moved_constant_2128*tmp_moved_constant_2302 + tmp_moved_constant_2131*tmp_moved_constant_2304 + tmp_moved_constant_2134*tmp_moved_constant_2306 + tmp_moved_constant_2137*tmp_moved_constant_2308) + tmp_moved_constant_2080*(tmp_moved_constant_2140*tmp_moved_constant_2302 + tmp_moved_constant_2143*tmp_moved_constant_2304 + tmp_moved_constant_2146*tmp_moved_constant_2306 + tmp_moved_constant_2149*tmp_moved_constant_2308) + tmp_moved_constant_2081*(tmp_moved_constant_2222*tmp_moved_constant_2302 + tmp_moved_constant_2223*tmp_moved_constant_2304 + tmp_moved_constant_2224*tmp_moved_constant_2306 + tmp_moved_constant_2225*tmp_moved_constant_2308) + tmp_moved_constant_2082*(tmp_moved_constant_2226*tmp_moved_constant_2302 + tmp_moved_constant_2227*tmp_moved_constant_2304 + tmp_moved_constant_2228*tmp_moved_constant_2306 + tmp_moved_constant_2229*tmp_moved_constant_2308) + tmp_moved_constant_2083*(tmp_moved_constant_2230*tmp_moved_constant_2302 + tmp_moved_constant_2231*tmp_moved_constant_2304 + tmp_moved_constant_2232*tmp_moved_constant_2306 + tmp_moved_constant_2233*tmp_moved_constant_2308) + tmp_moved_constant_2084*(tmp_moved_constant_2266*tmp_moved_constant_2302 + tmp_moved_constant_2267*tmp_moved_constant_2304 + tmp_moved_constant_2268*tmp_moved_constant_2306 + tmp_moved_constant_2269*tmp_moved_constant_2308) + tmp_moved_constant_2085*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2303 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2305 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2307 - jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_2309) + tmp_moved_constant_2086*(-jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2310 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2311 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2312 - jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_2313) + tmp_moved_constant_2087*(-jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2314 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2315 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2316 - jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_2317) + tmp_moved_constant_2088*(tmp_moved_constant_2152*tmp_moved_constant_2302 + tmp_moved_constant_2155*tmp_moved_constant_2304 + tmp_moved_constant_2158*tmp_moved_constant_2306 + tmp_moved_constant_2161*tmp_moved_constant_2308) + tmp_moved_constant_2089*(tmp_moved_constant_2164*tmp_moved_constant_2302 + tmp_moved_constant_2167*tmp_moved_constant_2304 + tmp_moved_constant_2170*tmp_moved_constant_2306 + tmp_moved_constant_2173*tmp_moved_constant_2308) + tmp_moved_constant_2090*(tmp_moved_constant_2176*tmp_moved_constant_2302 + tmp_moved_constant_2179*tmp_moved_constant_2304 + tmp_moved_constant_2182*tmp_moved_constant_2306 + tmp_moved_constant_2185*tmp_moved_constant_2308) + tmp_moved_constant_2091*(tmp_moved_constant_2234*tmp_moved_constant_2302 + tmp_moved_constant_2235*tmp_moved_constant_2304 + tmp_moved_constant_2236*tmp_moved_constant_2306 + tmp_moved_constant_2237*tmp_moved_constant_2308) + tmp_moved_constant_2092*(tmp_moved_constant_2238*tmp_moved_constant_2302 + tmp_moved_constant_2239*tmp_moved_constant_2304 + tmp_moved_constant_2240*tmp_moved_constant_2306 + tmp_moved_constant_2241*tmp_moved_constant_2308) + tmp_moved_constant_2093*(tmp_moved_constant_2242*tmp_moved_constant_2302 + tmp_moved_constant_2243*tmp_moved_constant_2304 + tmp_moved_constant_2244*tmp_moved_constant_2306 + tmp_moved_constant_2245*tmp_moved_constant_2308);
                   {
                      {
                     
                         const int64_t phantom_ctr_0 = ctr_0;
                         real_t _data_float_loop_ctr_array_dim_0[4];
                         _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                         _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                         _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                         _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                         real_t _data_float_loop_ctr_array_dim_1[4];
                         _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                         real_t _data_float_loop_ctr_array_dim_2[4];
                         _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                     
                         const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_2318 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_2319 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_2320 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_2321 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      }
                   }
                } 
             }
          }
          {
             for (int64_t ctr_0 = -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_13*tmp_kernel_op_213 + tmp_kernel_op_18*tmp_kernel_op_215 + tmp_kernel_op_209*tmp_kernel_op_3 + tmp_kernel_op_211*tmp_kernel_op_8) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_9) + src_dof_10*(tmp_kernel_op_13*tmp_kernel_op_218 + tmp_kernel_op_18*tmp_kernel_op_219 + tmp_kernel_op_216*tmp_kernel_op_3 + tmp_kernel_op_217*tmp_kernel_op_8) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_9) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_31) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_43) + src_dof_14*(tmp_kernel_op_13*tmp_kernel_op_52 + tmp_kernel_op_18*tmp_kernel_op_55 + tmp_kernel_op_3*tmp_kernel_op_46 + tmp_kernel_op_49*tmp_kernel_op_8) + src_dof_15*(tmp_kernel_op_13*tmp_kernel_op_64 + tmp_kernel_op_18*tmp_kernel_op_67 + tmp_kernel_op_3*tmp_kernel_op_58 + tmp_kernel_op_61*tmp_kernel_op_8) + src_dof_16*(tmp_kernel_op_13*tmp_kernel_op_76 + tmp_kernel_op_18*tmp_kernel_op_79 + tmp_kernel_op_3*tmp_kernel_op_70 + tmp_kernel_op_73*tmp_kernel_op_8) + src_dof_17*(tmp_kernel_op_13*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_3 + tmp_kernel_op_157*tmp_kernel_op_8 + tmp_kernel_op_163*tmp_kernel_op_18) + src_dof_18*(tmp_kernel_op_13*tmp_kernel_op_172 + tmp_kernel_op_166*tmp_kernel_op_3 + tmp_kernel_op_169*tmp_kernel_op_8 + tmp_kernel_op_175*tmp_kernel_op_18) + src_dof_19*(tmp_kernel_op_13*tmp_kernel_op_181 + tmp_kernel_op_177*tmp_kernel_op_3 + tmp_kernel_op_179*tmp_kernel_op_8 + tmp_kernel_op_18*tmp_kernel_op_183) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_31) + src_dof_20*(tmp_kernel_op_13*tmp_kernel_op_222 + tmp_kernel_op_18*tmp_kernel_op_223 + tmp_kernel_op_220*tmp_kernel_op_3 + tmp_kernel_op_221*tmp_kernel_op_8) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_14 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_19 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_9) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_22 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_31) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_43) + src_dof_24*(tmp_kernel_op_13*tmp_kernel_op_88 + tmp_kernel_op_18*tmp_kernel_op_91 + tmp_kernel_op_3*tmp_kernel_op_82 + tmp_kernel_op_8*tmp_kernel_op_85) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_13 + tmp_kernel_op_103*tmp_kernel_op_18 + tmp_kernel_op_3*tmp_kernel_op_94 + tmp_kernel_op_8*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_3 + tmp_kernel_op_109*tmp_kernel_op_8 + tmp_kernel_op_112*tmp_kernel_op_13 + tmp_kernel_op_115*tmp_kernel_op_18) + src_dof_27*(tmp_kernel_op_13*tmp_kernel_op_186 + tmp_kernel_op_18*tmp_kernel_op_187 + tmp_kernel_op_184*tmp_kernel_op_3 + tmp_kernel_op_185*tmp_kernel_op_8) + src_dof_28*(tmp_kernel_op_13*tmp_kernel_op_190 + tmp_kernel_op_18*tmp_kernel_op_191 + tmp_kernel_op_188*tmp_kernel_op_3 + tmp_kernel_op_189*tmp_kernel_op_8) + src_dof_29*(tmp_kernel_op_13*tmp_kernel_op_194 + tmp_kernel_op_18*tmp_kernel_op_195 + tmp_kernel_op_192*tmp_kernel_op_3 + tmp_kernel_op_193*tmp_kernel_op_8) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_34 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_37 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_40 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_43) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_3 + tmp_kernel_op_121*tmp_kernel_op_8 + tmp_kernel_op_124*tmp_kernel_op_13 + tmp_kernel_op_127*tmp_kernel_op_18) + src_dof_5*(tmp_kernel_op_13*tmp_kernel_op_136 + tmp_kernel_op_130*tmp_kernel_op_3 + tmp_kernel_op_133*tmp_kernel_op_8 + tmp_kernel_op_139*tmp_kernel_op_18) + src_dof_6*(tmp_kernel_op_13*tmp_kernel_op_148 + tmp_kernel_op_142*tmp_kernel_op_3 + tmp_kernel_op_145*tmp_kernel_op_8 + tmp_kernel_op_151*tmp_kernel_op_18) + src_dof_7*(tmp_kernel_op_13*tmp_kernel_op_198 + tmp_kernel_op_18*tmp_kernel_op_199 + tmp_kernel_op_196*tmp_kernel_op_3 + tmp_kernel_op_197*tmp_kernel_op_8) + src_dof_8*(tmp_kernel_op_13*tmp_kernel_op_202 + tmp_kernel_op_18*tmp_kernel_op_203 + tmp_kernel_op_200*tmp_kernel_op_3 + tmp_kernel_op_201*tmp_kernel_op_8) + src_dof_9*(tmp_kernel_op_13*tmp_kernel_op_206 + tmp_kernel_op_18*tmp_kernel_op_207 + tmp_kernel_op_204*tmp_kernel_op_3 + tmp_kernel_op_205*tmp_kernel_op_8);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_224 + tmp_kernel_op_211*tmp_kernel_op_226 + tmp_kernel_op_213*tmp_kernel_op_228 + tmp_kernel_op_215*tmp_kernel_op_230) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_231) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_224 + tmp_kernel_op_217*tmp_kernel_op_226 + tmp_kernel_op_218*tmp_kernel_op_228 + tmp_kernel_op_219*tmp_kernel_op_230) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_231) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_235) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_239) + src_dof_14*(tmp_kernel_op_224*tmp_kernel_op_46 + tmp_kernel_op_226*tmp_kernel_op_49 + tmp_kernel_op_228*tmp_kernel_op_52 + tmp_kernel_op_230*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_224*tmp_kernel_op_58 + tmp_kernel_op_226*tmp_kernel_op_61 + tmp_kernel_op_228*tmp_kernel_op_64 + tmp_kernel_op_230*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_224*tmp_kernel_op_70 + tmp_kernel_op_226*tmp_kernel_op_73 + tmp_kernel_op_228*tmp_kernel_op_76 + tmp_kernel_op_230*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_224 + tmp_kernel_op_157*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_228 + tmp_kernel_op_163*tmp_kernel_op_230) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_224 + tmp_kernel_op_169*tmp_kernel_op_226 + tmp_kernel_op_172*tmp_kernel_op_228 + tmp_kernel_op_175*tmp_kernel_op_230) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_224 + tmp_kernel_op_179*tmp_kernel_op_226 + tmp_kernel_op_181*tmp_kernel_op_228 + tmp_kernel_op_183*tmp_kernel_op_230) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_235) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_224 + tmp_kernel_op_221*tmp_kernel_op_226 + tmp_kernel_op_222*tmp_kernel_op_228 + tmp_kernel_op_223*tmp_kernel_op_230) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_225 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_227 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_229 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_231) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_232 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_233 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_234 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_235) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_239) + src_dof_24*(tmp_kernel_op_224*tmp_kernel_op_82 + tmp_kernel_op_226*tmp_kernel_op_85 + tmp_kernel_op_228*tmp_kernel_op_88 + tmp_kernel_op_230*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_228 + tmp_kernel_op_103*tmp_kernel_op_230 + tmp_kernel_op_224*tmp_kernel_op_94 + tmp_kernel_op_226*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_224 + tmp_kernel_op_109*tmp_kernel_op_226 + tmp_kernel_op_112*tmp_kernel_op_228 + tmp_kernel_op_115*tmp_kernel_op_230) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_224 + tmp_kernel_op_185*tmp_kernel_op_226 + tmp_kernel_op_186*tmp_kernel_op_228 + tmp_kernel_op_187*tmp_kernel_op_230) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_224 + tmp_kernel_op_189*tmp_kernel_op_226 + tmp_kernel_op_190*tmp_kernel_op_228 + tmp_kernel_op_191*tmp_kernel_op_230) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_224 + tmp_kernel_op_193*tmp_kernel_op_226 + tmp_kernel_op_194*tmp_kernel_op_228 + tmp_kernel_op_195*tmp_kernel_op_230) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_236 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_237 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_238 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_239) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_224 + tmp_kernel_op_121*tmp_kernel_op_226 + tmp_kernel_op_124*tmp_kernel_op_228 + tmp_kernel_op_127*tmp_kernel_op_230) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_224 + tmp_kernel_op_133*tmp_kernel_op_226 + tmp_kernel_op_136*tmp_kernel_op_228 + tmp_kernel_op_139*tmp_kernel_op_230) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_224 + tmp_kernel_op_145*tmp_kernel_op_226 + tmp_kernel_op_148*tmp_kernel_op_228 + tmp_kernel_op_151*tmp_kernel_op_230) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_224 + tmp_kernel_op_197*tmp_kernel_op_226 + tmp_kernel_op_198*tmp_kernel_op_228 + tmp_kernel_op_199*tmp_kernel_op_230) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_224 + tmp_kernel_op_201*tmp_kernel_op_226 + tmp_kernel_op_202*tmp_kernel_op_228 + tmp_kernel_op_203*tmp_kernel_op_230) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_224 + tmp_kernel_op_205*tmp_kernel_op_226 + tmp_kernel_op_206*tmp_kernel_op_228 + tmp_kernel_op_207*tmp_kernel_op_230);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_240 + tmp_kernel_op_211*tmp_kernel_op_242 + tmp_kernel_op_213*tmp_kernel_op_244 + tmp_kernel_op_215*tmp_kernel_op_246) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_247) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_240 + tmp_kernel_op_217*tmp_kernel_op_242 + tmp_kernel_op_218*tmp_kernel_op_244 + tmp_kernel_op_219*tmp_kernel_op_246) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_247) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_251) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_255) + src_dof_14*(tmp_kernel_op_240*tmp_kernel_op_46 + tmp_kernel_op_242*tmp_kernel_op_49 + tmp_kernel_op_244*tmp_kernel_op_52 + tmp_kernel_op_246*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_240*tmp_kernel_op_58 + tmp_kernel_op_242*tmp_kernel_op_61 + tmp_kernel_op_244*tmp_kernel_op_64 + tmp_kernel_op_246*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_240*tmp_kernel_op_70 + tmp_kernel_op_242*tmp_kernel_op_73 + tmp_kernel_op_244*tmp_kernel_op_76 + tmp_kernel_op_246*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_240 + tmp_kernel_op_157*tmp_kernel_op_242 + tmp_kernel_op_160*tmp_kernel_op_244 + tmp_kernel_op_163*tmp_kernel_op_246) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_240 + tmp_kernel_op_169*tmp_kernel_op_242 + tmp_kernel_op_172*tmp_kernel_op_244 + tmp_kernel_op_175*tmp_kernel_op_246) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_240 + tmp_kernel_op_179*tmp_kernel_op_242 + tmp_kernel_op_181*tmp_kernel_op_244 + tmp_kernel_op_183*tmp_kernel_op_246) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_251) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_240 + tmp_kernel_op_221*tmp_kernel_op_242 + tmp_kernel_op_222*tmp_kernel_op_244 + tmp_kernel_op_223*tmp_kernel_op_246) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_241 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_243 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_245 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_247) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_248 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_249 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_250 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_251) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_255) + src_dof_24*(tmp_kernel_op_240*tmp_kernel_op_82 + tmp_kernel_op_242*tmp_kernel_op_85 + tmp_kernel_op_244*tmp_kernel_op_88 + tmp_kernel_op_246*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_244 + tmp_kernel_op_103*tmp_kernel_op_246 + tmp_kernel_op_240*tmp_kernel_op_94 + tmp_kernel_op_242*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_109*tmp_kernel_op_242 + tmp_kernel_op_112*tmp_kernel_op_244 + tmp_kernel_op_115*tmp_kernel_op_246) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_240 + tmp_kernel_op_185*tmp_kernel_op_242 + tmp_kernel_op_186*tmp_kernel_op_244 + tmp_kernel_op_187*tmp_kernel_op_246) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_240 + tmp_kernel_op_189*tmp_kernel_op_242 + tmp_kernel_op_190*tmp_kernel_op_244 + tmp_kernel_op_191*tmp_kernel_op_246) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_240 + tmp_kernel_op_193*tmp_kernel_op_242 + tmp_kernel_op_194*tmp_kernel_op_244 + tmp_kernel_op_195*tmp_kernel_op_246) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_252 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_253 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_254 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_255) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_240 + tmp_kernel_op_121*tmp_kernel_op_242 + tmp_kernel_op_124*tmp_kernel_op_244 + tmp_kernel_op_127*tmp_kernel_op_246) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_240 + tmp_kernel_op_133*tmp_kernel_op_242 + tmp_kernel_op_136*tmp_kernel_op_244 + tmp_kernel_op_139*tmp_kernel_op_246) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_240 + tmp_kernel_op_145*tmp_kernel_op_242 + tmp_kernel_op_148*tmp_kernel_op_244 + tmp_kernel_op_151*tmp_kernel_op_246) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_240 + tmp_kernel_op_197*tmp_kernel_op_242 + tmp_kernel_op_198*tmp_kernel_op_244 + tmp_kernel_op_199*tmp_kernel_op_246) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_240 + tmp_kernel_op_201*tmp_kernel_op_242 + tmp_kernel_op_202*tmp_kernel_op_244 + tmp_kernel_op_203*tmp_kernel_op_246) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_240 + tmp_kernel_op_205*tmp_kernel_op_242 + tmp_kernel_op_206*tmp_kernel_op_244 + tmp_kernel_op_207*tmp_kernel_op_246);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_209*tmp_kernel_op_256 + tmp_kernel_op_211*tmp_kernel_op_258 + tmp_kernel_op_213*tmp_kernel_op_260 + tmp_kernel_op_215*tmp_kernel_op_262) + src_dof_1*(-jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_263) + src_dof_10*(tmp_kernel_op_216*tmp_kernel_op_256 + tmp_kernel_op_217*tmp_kernel_op_258 + tmp_kernel_op_218*tmp_kernel_op_260 + tmp_kernel_op_219*tmp_kernel_op_262) + src_dof_11*(-jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_263) + src_dof_12*(-jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_267) + src_dof_13*(-jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_271) + src_dof_14*(tmp_kernel_op_256*tmp_kernel_op_46 + tmp_kernel_op_258*tmp_kernel_op_49 + tmp_kernel_op_260*tmp_kernel_op_52 + tmp_kernel_op_262*tmp_kernel_op_55) + src_dof_15*(tmp_kernel_op_256*tmp_kernel_op_58 + tmp_kernel_op_258*tmp_kernel_op_61 + tmp_kernel_op_260*tmp_kernel_op_64 + tmp_kernel_op_262*tmp_kernel_op_67) + src_dof_16*(tmp_kernel_op_256*tmp_kernel_op_70 + tmp_kernel_op_258*tmp_kernel_op_73 + tmp_kernel_op_260*tmp_kernel_op_76 + tmp_kernel_op_262*tmp_kernel_op_79) + src_dof_17*(tmp_kernel_op_154*tmp_kernel_op_256 + tmp_kernel_op_157*tmp_kernel_op_258 + tmp_kernel_op_160*tmp_kernel_op_260 + tmp_kernel_op_163*tmp_kernel_op_262) + src_dof_18*(tmp_kernel_op_166*tmp_kernel_op_256 + tmp_kernel_op_169*tmp_kernel_op_258 + tmp_kernel_op_172*tmp_kernel_op_260 + tmp_kernel_op_175*tmp_kernel_op_262) + src_dof_19*(tmp_kernel_op_177*tmp_kernel_op_256 + tmp_kernel_op_179*tmp_kernel_op_258 + tmp_kernel_op_181*tmp_kernel_op_260 + tmp_kernel_op_183*tmp_kernel_op_262) + src_dof_2*(-jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_267) + src_dof_20*(tmp_kernel_op_220*tmp_kernel_op_256 + tmp_kernel_op_221*tmp_kernel_op_258 + tmp_kernel_op_222*tmp_kernel_op_260 + tmp_kernel_op_223*tmp_kernel_op_262) + src_dof_21*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_257 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_259 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_261 - jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_263) + src_dof_22*(-jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_264 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_265 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_266 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_267) + src_dof_23*(-jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_271) + src_dof_24*(tmp_kernel_op_256*tmp_kernel_op_82 + tmp_kernel_op_258*tmp_kernel_op_85 + tmp_kernel_op_260*tmp_kernel_op_88 + tmp_kernel_op_262*tmp_kernel_op_91) + src_dof_25*(tmp_kernel_op_100*tmp_kernel_op_260 + tmp_kernel_op_103*tmp_kernel_op_262 + tmp_kernel_op_256*tmp_kernel_op_94 + tmp_kernel_op_258*tmp_kernel_op_97) + src_dof_26*(tmp_kernel_op_106*tmp_kernel_op_256 + tmp_kernel_op_109*tmp_kernel_op_258 + tmp_kernel_op_112*tmp_kernel_op_260 + tmp_kernel_op_115*tmp_kernel_op_262) + src_dof_27*(tmp_kernel_op_184*tmp_kernel_op_256 + tmp_kernel_op_185*tmp_kernel_op_258 + tmp_kernel_op_186*tmp_kernel_op_260 + tmp_kernel_op_187*tmp_kernel_op_262) + src_dof_28*(tmp_kernel_op_188*tmp_kernel_op_256 + tmp_kernel_op_189*tmp_kernel_op_258 + tmp_kernel_op_190*tmp_kernel_op_260 + tmp_kernel_op_191*tmp_kernel_op_262) + src_dof_29*(tmp_kernel_op_192*tmp_kernel_op_256 + tmp_kernel_op_193*tmp_kernel_op_258 + tmp_kernel_op_194*tmp_kernel_op_260 + tmp_kernel_op_195*tmp_kernel_op_262) + src_dof_3*(-jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_268 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_269 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_270 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_271) + src_dof_4*(tmp_kernel_op_118*tmp_kernel_op_256 + tmp_kernel_op_121*tmp_kernel_op_258 + tmp_kernel_op_124*tmp_kernel_op_260 + tmp_kernel_op_127*tmp_kernel_op_262) + src_dof_5*(tmp_kernel_op_130*tmp_kernel_op_256 + tmp_kernel_op_133*tmp_kernel_op_258 + tmp_kernel_op_136*tmp_kernel_op_260 + tmp_kernel_op_139*tmp_kernel_op_262) + src_dof_6*(tmp_kernel_op_142*tmp_kernel_op_256 + tmp_kernel_op_145*tmp_kernel_op_258 + tmp_kernel_op_148*tmp_kernel_op_260 + tmp_kernel_op_151*tmp_kernel_op_262) + src_dof_7*(tmp_kernel_op_196*tmp_kernel_op_256 + tmp_kernel_op_197*tmp_kernel_op_258 + tmp_kernel_op_198*tmp_kernel_op_260 + tmp_kernel_op_199*tmp_kernel_op_262) + src_dof_8*(tmp_kernel_op_200*tmp_kernel_op_256 + tmp_kernel_op_201*tmp_kernel_op_258 + tmp_kernel_op_202*tmp_kernel_op_260 + tmp_kernel_op_203*tmp_kernel_op_262) + src_dof_9*(tmp_kernel_op_204*tmp_kernel_op_256 + tmp_kernel_op_205*tmp_kernel_op_258 + tmp_kernel_op_206*tmp_kernel_op_260 + tmp_kernel_op_207*tmp_kernel_op_262);
                {
                   {
                      {
                     
                         const int64_t phantom_ctr_0 = ctr_0;
                         real_t _data_float_loop_ctr_array_dim_0[4];
                         _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                         _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                         _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                         _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                         real_t _data_float_loop_ctr_array_dim_1[4];
                         _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                         _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                         real_t _data_float_loop_ctr_array_dim_2[4];
                         _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                         _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                     
                         const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                         const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                         _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                         _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      }
                   }
                }
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
