/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2ToP1ElementwiseDivergence_0_2.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ToP1ElementwiseDivergence_0_2::apply_P2ToP1ElementwiseDivergence_0_2_macro_3D( real_t * RESTRICT  _data_dst, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN - jac_affine_2_1_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_2_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_2_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP - jac_affine_2_1_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_2_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_2_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN - jac_affine_2_1_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_2_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_2_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP - jac_affine_2_1_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_2_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_2_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN - jac_affine_2_1_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_2_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_2_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP - jac_affine_2_1_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_2_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_2_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_kernel_op_0 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_1 = tmp_kernel_op_0*0.13819660112501053;
       const real_t tmp_kernel_op_2 = 0.55278640450004202;
       const real_t tmp_kernel_op_3 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_kernel_op_4 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_5 = tmp_kernel_op_4*0.13819660112501056;
       const real_t tmp_kernel_op_6 = 0.55278640450004202;
       const real_t tmp_kernel_op_7 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_6 - 1.0);
       const real_t tmp_kernel_op_8 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_8*0.13819660112501056;
       const real_t tmp_kernel_op_10 = 2.3416407864998736;
       const real_t tmp_kernel_op_11 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_kernel_op_12 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_13 = tmp_kernel_op_12*0.5854101966249684;
       const real_t tmp_kernel_op_14 = 0.55278640450004202;
       const real_t tmp_kernel_op_15 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_kernel_op_16 = 0.55278640450004202;
       const real_t tmp_kernel_op_17 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_kernel_op_18 = 2.3416407864998736;
       const real_t tmp_kernel_op_19 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_kernel_op_20 = 0.55278640450004202;
       const real_t tmp_kernel_op_21 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_20 - 1.0);
       const real_t tmp_kernel_op_22 = 0.55278640450004202;
       const real_t tmp_kernel_op_23 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_kernel_op_24 = 2.3416407864998736;
       const real_t tmp_kernel_op_25 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_kernel_op_26 = 0.55278640450004202;
       const real_t tmp_kernel_op_27 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_kernel_op_28 = 0.55278640450004202;
       const real_t tmp_kernel_op_29 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_28 - 1.0);
       const real_t tmp_kernel_op_30 = 0.55278640450004202;
       const real_t tmp_kernel_op_31 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_30 - 1.0);
       const real_t tmp_kernel_op_32 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_33 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_34 = -tmp_kernel_op_32 - tmp_kernel_op_33;
       const real_t tmp_kernel_op_35 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_36 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_37 = -tmp_kernel_op_35 - tmp_kernel_op_36;
       const real_t tmp_kernel_op_38 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_39 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_40 = -tmp_kernel_op_38 - tmp_kernel_op_39;
       const real_t tmp_kernel_op_41 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_30;
       const real_t tmp_kernel_op_42 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_22;
       const real_t tmp_kernel_op_43 = -tmp_kernel_op_41 - tmp_kernel_op_42;
       const real_t tmp_kernel_op_44 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_45 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_46 = -tmp_kernel_op_44 - tmp_kernel_op_45;
       const real_t tmp_kernel_op_47 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_48 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_6;
       const real_t tmp_kernel_op_49 = -tmp_kernel_op_47 - tmp_kernel_op_48;
       const real_t tmp_kernel_op_50 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_51 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_52 = -tmp_kernel_op_50 - tmp_kernel_op_51;
       const real_t tmp_kernel_op_53 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_30;
       const real_t tmp_kernel_op_54 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_14;
       const real_t tmp_kernel_op_55 = -tmp_kernel_op_53 - tmp_kernel_op_54;
       const real_t tmp_kernel_op_56 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_57 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_58 = -tmp_kernel_op_56 - tmp_kernel_op_57;
       const real_t tmp_kernel_op_59 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_60 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_6;
       const real_t tmp_kernel_op_61 = -tmp_kernel_op_59 - tmp_kernel_op_60;
       const real_t tmp_kernel_op_62 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_63 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_64 = -tmp_kernel_op_62 - tmp_kernel_op_63;
       const real_t tmp_kernel_op_65 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_22;
       const real_t tmp_kernel_op_66 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_14;
       const real_t tmp_kernel_op_67 = -tmp_kernel_op_65 - tmp_kernel_op_66;
       const real_t tmp_kernel_op_68 = tmp_kernel_op_16 + tmp_kernel_op_2;
       const real_t tmp_kernel_op_69 = -jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_kernel_op_32 + tmp_kernel_op_44;
       const real_t tmp_kernel_op_70 = tmp_kernel_op_18 + tmp_kernel_op_6;
       const real_t tmp_kernel_op_71 = -jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_kernel_op_35 + tmp_kernel_op_47;
       const real_t tmp_kernel_op_72 = tmp_kernel_op_10 + tmp_kernel_op_20;
       const real_t tmp_kernel_op_73 = -jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_kernel_op_38 + tmp_kernel_op_50;
       const real_t tmp_kernel_op_74 = tmp_kernel_op_14 + tmp_kernel_op_22;
       const real_t tmp_kernel_op_75 = -jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_kernel_op_41 + tmp_kernel_op_53;
       const real_t tmp_kernel_op_76 = tmp_kernel_op_24 - 4.0;
       const real_t tmp_kernel_op_77 = -jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_kernel_op_33 + tmp_kernel_op_56;
       const real_t tmp_kernel_op_78 = tmp_kernel_op_26 - 4.0;
       const real_t tmp_kernel_op_79 = -jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_kernel_op_36 + tmp_kernel_op_59;
       const real_t tmp_kernel_op_80 = tmp_kernel_op_28 - 4.0;
       const real_t tmp_kernel_op_81 = -jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_kernel_op_39 + tmp_kernel_op_62;
       const real_t tmp_kernel_op_82 = tmp_kernel_op_30 - 4.0;
       const real_t tmp_kernel_op_83 = -jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_kernel_op_42 + tmp_kernel_op_65;
       const real_t tmp_kernel_op_84 = -jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_kernel_op_45 + tmp_kernel_op_57;
       const real_t tmp_kernel_op_85 = -jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_kernel_op_48 + tmp_kernel_op_60;
       const real_t tmp_kernel_op_86 = -jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_kernel_op_51 + tmp_kernel_op_63;
       const real_t tmp_kernel_op_87 = -jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_kernel_op_54 + tmp_kernel_op_66;
       const real_t tmp_kernel_op_88 = tmp_kernel_op_24 + tmp_kernel_op_68 - 3.0;
       const real_t tmp_kernel_op_89 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_88 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_88 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_88;
       const real_t tmp_kernel_op_90 = tmp_kernel_op_26 + tmp_kernel_op_70 - 3.0;
       const real_t tmp_kernel_op_91 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_90 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_90 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_90;
       const real_t tmp_kernel_op_92 = tmp_kernel_op_28 + tmp_kernel_op_72 - 3.0;
       const real_t tmp_kernel_op_93 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_92 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_92 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_92;
       const real_t tmp_kernel_op_94 = tmp_kernel_op_30 + tmp_kernel_op_74 - 3.0;
       const real_t tmp_kernel_op_95 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_94 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_94 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_94;
       const real_t tmp_kernel_op_96 = tmp_kernel_op_0*0.1381966011250105;
       const real_t tmp_kernel_op_97 = tmp_kernel_op_4*0.1381966011250105;
       const real_t tmp_kernel_op_98 = tmp_kernel_op_8*0.5854101966249684;
       const real_t tmp_kernel_op_99 = tmp_kernel_op_12*0.1381966011250105;
       const real_t tmp_kernel_op_100 = tmp_kernel_op_0*0.1381966011250105;
       const real_t tmp_kernel_op_101 = tmp_kernel_op_4*0.5854101966249684;
       const real_t tmp_kernel_op_102 = tmp_kernel_op_8*0.1381966011250105;
       const real_t tmp_kernel_op_103 = tmp_kernel_op_12*0.1381966011250105;
       const real_t tmp_kernel_op_104 = tmp_kernel_op_0*0.5854101966249684;
       const real_t tmp_kernel_op_105 = tmp_kernel_op_4*0.1381966011250105;
       const real_t tmp_kernel_op_106 = tmp_kernel_op_8*0.1381966011250105;
       const real_t tmp_kernel_op_107 = tmp_kernel_op_12*0.1381966011250105;
       const real_t tmp_moved_constant_10 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_11 = tmp_moved_constant_10*0.13819660112501053;
       const real_t tmp_moved_constant_12 = jac_affine_inv_0_2_WHITE_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_13 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_14 = tmp_moved_constant_13*0.13819660112501056;
       const real_t tmp_moved_constant_15 = jac_affine_inv_0_2_WHITE_DOWN*(tmp_kernel_op_6 - 1.0);
       const real_t tmp_moved_constant_16 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_17 = tmp_moved_constant_16*0.13819660112501056;
       const real_t tmp_moved_constant_18 = jac_affine_inv_0_2_WHITE_DOWN*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_19 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_20 = tmp_moved_constant_19*0.5854101966249684;
       const real_t tmp_moved_constant_21 = jac_affine_inv_0_2_WHITE_DOWN*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_22 = jac_affine_inv_1_2_WHITE_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_23 = jac_affine_inv_1_2_WHITE_DOWN*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_24 = jac_affine_inv_1_2_WHITE_DOWN*(tmp_kernel_op_20 - 1.0);
       const real_t tmp_moved_constant_25 = jac_affine_inv_1_2_WHITE_DOWN*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_26 = jac_affine_inv_2_2_WHITE_DOWN*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_27 = jac_affine_inv_2_2_WHITE_DOWN*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_28 = jac_affine_inv_2_2_WHITE_DOWN*(tmp_kernel_op_28 - 1.0);
       const real_t tmp_moved_constant_29 = jac_affine_inv_2_2_WHITE_DOWN*(tmp_kernel_op_30 - 1.0);
       const real_t tmp_moved_constant_30 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_31 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_32 = -tmp_moved_constant_30 - tmp_moved_constant_31;
       const real_t tmp_moved_constant_33 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_34 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_35 = -tmp_moved_constant_33 - tmp_moved_constant_34;
       const real_t tmp_moved_constant_36 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_37 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_38 = -tmp_moved_constant_36 - tmp_moved_constant_37;
       const real_t tmp_moved_constant_39 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_40 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_41 = -tmp_moved_constant_39 - tmp_moved_constant_40;
       const real_t tmp_moved_constant_42 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_43 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_44 = -tmp_moved_constant_42 - tmp_moved_constant_43;
       const real_t tmp_moved_constant_45 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_46 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_6;
       const real_t tmp_moved_constant_47 = -tmp_moved_constant_45 - tmp_moved_constant_46;
       const real_t tmp_moved_constant_48 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_49 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_50 = -tmp_moved_constant_48 - tmp_moved_constant_49;
       const real_t tmp_moved_constant_51 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_52 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_53 = -tmp_moved_constant_51 - tmp_moved_constant_52;
       const real_t tmp_moved_constant_54 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_55 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_56 = -tmp_moved_constant_54 - tmp_moved_constant_55;
       const real_t tmp_moved_constant_57 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_58 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_6;
       const real_t tmp_moved_constant_59 = -tmp_moved_constant_57 - tmp_moved_constant_58;
       const real_t tmp_moved_constant_60 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_61 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_62 = -tmp_moved_constant_60 - tmp_moved_constant_61;
       const real_t tmp_moved_constant_63 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_64 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_65 = -tmp_moved_constant_63 - tmp_moved_constant_64;
       const real_t tmp_moved_constant_66 = -jac_affine_inv_2_2_WHITE_DOWN*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_30 + tmp_moved_constant_42;
       const real_t tmp_moved_constant_67 = -jac_affine_inv_2_2_WHITE_DOWN*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_33 + tmp_moved_constant_45;
       const real_t tmp_moved_constant_68 = -jac_affine_inv_2_2_WHITE_DOWN*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_36 + tmp_moved_constant_48;
       const real_t tmp_moved_constant_69 = -jac_affine_inv_2_2_WHITE_DOWN*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_39 + tmp_moved_constant_51;
       const real_t tmp_moved_constant_70 = -jac_affine_inv_1_2_WHITE_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_31 + tmp_moved_constant_54;
       const real_t tmp_moved_constant_71 = -jac_affine_inv_1_2_WHITE_DOWN*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_34 + tmp_moved_constant_57;
       const real_t tmp_moved_constant_72 = -jac_affine_inv_1_2_WHITE_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_37 + tmp_moved_constant_60;
       const real_t tmp_moved_constant_73 = -jac_affine_inv_1_2_WHITE_DOWN*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_40 + tmp_moved_constant_63;
       const real_t tmp_moved_constant_74 = -jac_affine_inv_0_2_WHITE_DOWN*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_43 + tmp_moved_constant_55;
       const real_t tmp_moved_constant_75 = -jac_affine_inv_0_2_WHITE_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_46 + tmp_moved_constant_58;
       const real_t tmp_moved_constant_76 = -jac_affine_inv_0_2_WHITE_DOWN*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_49 + tmp_moved_constant_61;
       const real_t tmp_moved_constant_77 = -jac_affine_inv_0_2_WHITE_DOWN*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_52 + tmp_moved_constant_64;
       const real_t tmp_moved_constant_78 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_88 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_88 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_79 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_90 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_90 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_90;
       const real_t tmp_moved_constant_80 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_92 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_92 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_92;
       const real_t tmp_moved_constant_81 = -jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_94 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_94 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_94;
       const real_t tmp_moved_constant_82 = tmp_moved_constant_10*0.1381966011250105;
       const real_t tmp_moved_constant_83 = tmp_moved_constant_13*0.1381966011250105;
       const real_t tmp_moved_constant_84 = tmp_moved_constant_16*0.5854101966249684;
       const real_t tmp_moved_constant_85 = tmp_moved_constant_19*0.1381966011250105;
       const real_t tmp_moved_constant_86 = tmp_moved_constant_10*0.1381966011250105;
       const real_t tmp_moved_constant_87 = tmp_moved_constant_13*0.5854101966249684;
       const real_t tmp_moved_constant_88 = tmp_moved_constant_16*0.1381966011250105;
       const real_t tmp_moved_constant_89 = tmp_moved_constant_19*0.1381966011250105;
       const real_t tmp_moved_constant_90 = tmp_moved_constant_10*0.5854101966249684;
       const real_t tmp_moved_constant_91 = tmp_moved_constant_13*0.1381966011250105;
       const real_t tmp_moved_constant_92 = tmp_moved_constant_16*0.1381966011250105;
       const real_t tmp_moved_constant_93 = tmp_moved_constant_19*0.1381966011250105;
       const real_t tmp_moved_constant_108 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_109 = tmp_moved_constant_108*0.13819660112501053;
       const real_t tmp_moved_constant_110 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_111 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_112 = tmp_moved_constant_111*0.13819660112501056;
       const real_t tmp_moved_constant_113 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_6 - 1.0);
       const real_t tmp_moved_constant_114 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_115 = tmp_moved_constant_114*0.13819660112501056;
       const real_t tmp_moved_constant_116 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_117 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_118 = tmp_moved_constant_117*0.5854101966249684;
       const real_t tmp_moved_constant_119 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_120 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_121 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_122 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_20 - 1.0);
       const real_t tmp_moved_constant_123 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_124 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_125 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_126 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_28 - 1.0);
       const real_t tmp_moved_constant_127 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_30 - 1.0);
       const real_t tmp_moved_constant_128 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_129 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_130 = -tmp_moved_constant_128 - tmp_moved_constant_129;
       const real_t tmp_moved_constant_131 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_132 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_133 = -tmp_moved_constant_131 - tmp_moved_constant_132;
       const real_t tmp_moved_constant_134 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_135 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_136 = -tmp_moved_constant_134 - tmp_moved_constant_135;
       const real_t tmp_moved_constant_137 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_138 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_139 = -tmp_moved_constant_137 - tmp_moved_constant_138;
       const real_t tmp_moved_constant_140 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_141 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_142 = -tmp_moved_constant_140 - tmp_moved_constant_141;
       const real_t tmp_moved_constant_143 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_144 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_6;
       const real_t tmp_moved_constant_145 = -tmp_moved_constant_143 - tmp_moved_constant_144;
       const real_t tmp_moved_constant_146 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_147 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_148 = -tmp_moved_constant_146 - tmp_moved_constant_147;
       const real_t tmp_moved_constant_149 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_150 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_14;
       const real_t tmp_moved_constant_151 = -tmp_moved_constant_149 - tmp_moved_constant_150;
       const real_t tmp_moved_constant_152 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_153 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_154 = -tmp_moved_constant_152 - tmp_moved_constant_153;
       const real_t tmp_moved_constant_155 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_156 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_6;
       const real_t tmp_moved_constant_157 = -tmp_moved_constant_155 - tmp_moved_constant_156;
       const real_t tmp_moved_constant_158 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_159 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_160 = -tmp_moved_constant_158 - tmp_moved_constant_159;
       const real_t tmp_moved_constant_161 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_162 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_14;
       const real_t tmp_moved_constant_163 = -tmp_moved_constant_161 - tmp_moved_constant_162;
       const real_t tmp_moved_constant_164 = -jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_128 + tmp_moved_constant_140;
       const real_t tmp_moved_constant_165 = -jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_131 + tmp_moved_constant_143;
       const real_t tmp_moved_constant_166 = -jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_134 + tmp_moved_constant_146;
       const real_t tmp_moved_constant_167 = -jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_137 + tmp_moved_constant_149;
       const real_t tmp_moved_constant_168 = -jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_129 + tmp_moved_constant_152;
       const real_t tmp_moved_constant_169 = -jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_132 + tmp_moved_constant_155;
       const real_t tmp_moved_constant_170 = -jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_135 + tmp_moved_constant_158;
       const real_t tmp_moved_constant_171 = -jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_138 + tmp_moved_constant_161;
       const real_t tmp_moved_constant_172 = -jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_141 + tmp_moved_constant_153;
       const real_t tmp_moved_constant_173 = -jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_144 + tmp_moved_constant_156;
       const real_t tmp_moved_constant_174 = -jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_147 + tmp_moved_constant_159;
       const real_t tmp_moved_constant_175 = -jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_150 + tmp_moved_constant_162;
       const real_t tmp_moved_constant_176 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_88 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_88 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_177 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_90 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_90 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_90;
       const real_t tmp_moved_constant_178 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_92 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_92 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_92;
       const real_t tmp_moved_constant_179 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_94 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_94 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_94;
       const real_t tmp_moved_constant_180 = tmp_moved_constant_108*0.1381966011250105;
       const real_t tmp_moved_constant_181 = tmp_moved_constant_111*0.1381966011250105;
       const real_t tmp_moved_constant_182 = tmp_moved_constant_114*0.5854101966249684;
       const real_t tmp_moved_constant_183 = tmp_moved_constant_117*0.1381966011250105;
       const real_t tmp_moved_constant_184 = tmp_moved_constant_108*0.1381966011250105;
       const real_t tmp_moved_constant_185 = tmp_moved_constant_111*0.5854101966249684;
       const real_t tmp_moved_constant_186 = tmp_moved_constant_114*0.1381966011250105;
       const real_t tmp_moved_constant_187 = tmp_moved_constant_117*0.1381966011250105;
       const real_t tmp_moved_constant_188 = tmp_moved_constant_108*0.5854101966249684;
       const real_t tmp_moved_constant_189 = tmp_moved_constant_111*0.1381966011250105;
       const real_t tmp_moved_constant_190 = tmp_moved_constant_114*0.1381966011250105;
       const real_t tmp_moved_constant_191 = tmp_moved_constant_117*0.1381966011250105;
       const real_t tmp_moved_constant_206 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_207 = tmp_moved_constant_206*0.13819660112501053;
       const real_t tmp_moved_constant_208 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_209 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_210 = tmp_moved_constant_209*0.13819660112501056;
       const real_t tmp_moved_constant_211 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_6 - 1.0);
       const real_t tmp_moved_constant_212 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_213 = tmp_moved_constant_212*0.13819660112501056;
       const real_t tmp_moved_constant_214 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_215 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_216 = tmp_moved_constant_215*0.5854101966249684;
       const real_t tmp_moved_constant_217 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_218 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_219 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_220 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_20 - 1.0);
       const real_t tmp_moved_constant_221 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_222 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_223 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_224 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_28 - 1.0);
       const real_t tmp_moved_constant_225 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_30 - 1.0);
       const real_t tmp_moved_constant_226 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_227 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_228 = -tmp_moved_constant_226 - tmp_moved_constant_227;
       const real_t tmp_moved_constant_229 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_230 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_231 = -tmp_moved_constant_229 - tmp_moved_constant_230;
       const real_t tmp_moved_constant_232 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_233 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_234 = -tmp_moved_constant_232 - tmp_moved_constant_233;
       const real_t tmp_moved_constant_235 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_236 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_237 = -tmp_moved_constant_235 - tmp_moved_constant_236;
       const real_t tmp_moved_constant_238 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_239 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_240 = -tmp_moved_constant_238 - tmp_moved_constant_239;
       const real_t tmp_moved_constant_241 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_242 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_6;
       const real_t tmp_moved_constant_243 = -tmp_moved_constant_241 - tmp_moved_constant_242;
       const real_t tmp_moved_constant_244 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_245 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_246 = -tmp_moved_constant_244 - tmp_moved_constant_245;
       const real_t tmp_moved_constant_247 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_248 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_249 = -tmp_moved_constant_247 - tmp_moved_constant_248;
       const real_t tmp_moved_constant_250 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_251 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_252 = -tmp_moved_constant_250 - tmp_moved_constant_251;
       const real_t tmp_moved_constant_253 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_254 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_6;
       const real_t tmp_moved_constant_255 = -tmp_moved_constant_253 - tmp_moved_constant_254;
       const real_t tmp_moved_constant_256 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_257 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_258 = -tmp_moved_constant_256 - tmp_moved_constant_257;
       const real_t tmp_moved_constant_259 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_260 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_261 = -tmp_moved_constant_259 - tmp_moved_constant_260;
       const real_t tmp_moved_constant_262 = -jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_226 + tmp_moved_constant_238;
       const real_t tmp_moved_constant_263 = -jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_229 + tmp_moved_constant_241;
       const real_t tmp_moved_constant_264 = -jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_232 + tmp_moved_constant_244;
       const real_t tmp_moved_constant_265 = -jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_235 + tmp_moved_constant_247;
       const real_t tmp_moved_constant_266 = -jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_227 + tmp_moved_constant_250;
       const real_t tmp_moved_constant_267 = -jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_230 + tmp_moved_constant_253;
       const real_t tmp_moved_constant_268 = -jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_233 + tmp_moved_constant_256;
       const real_t tmp_moved_constant_269 = -jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_236 + tmp_moved_constant_259;
       const real_t tmp_moved_constant_270 = -jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_239 + tmp_moved_constant_251;
       const real_t tmp_moved_constant_271 = -jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_242 + tmp_moved_constant_254;
       const real_t tmp_moved_constant_272 = -jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_245 + tmp_moved_constant_257;
       const real_t tmp_moved_constant_273 = -jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_248 + tmp_moved_constant_260;
       const real_t tmp_moved_constant_274 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_88 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_88 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_275 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_90 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_90 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_90;
       const real_t tmp_moved_constant_276 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_92 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_92 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_92;
       const real_t tmp_moved_constant_277 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_94 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_94 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_94;
       const real_t tmp_moved_constant_278 = tmp_moved_constant_206*0.1381966011250105;
       const real_t tmp_moved_constant_279 = tmp_moved_constant_209*0.1381966011250105;
       const real_t tmp_moved_constant_280 = tmp_moved_constant_212*0.5854101966249684;
       const real_t tmp_moved_constant_281 = tmp_moved_constant_215*0.1381966011250105;
       const real_t tmp_moved_constant_282 = tmp_moved_constant_206*0.1381966011250105;
       const real_t tmp_moved_constant_283 = tmp_moved_constant_209*0.5854101966249684;
       const real_t tmp_moved_constant_284 = tmp_moved_constant_212*0.1381966011250105;
       const real_t tmp_moved_constant_285 = tmp_moved_constant_215*0.1381966011250105;
       const real_t tmp_moved_constant_286 = tmp_moved_constant_206*0.5854101966249684;
       const real_t tmp_moved_constant_287 = tmp_moved_constant_209*0.1381966011250105;
       const real_t tmp_moved_constant_288 = tmp_moved_constant_212*0.1381966011250105;
       const real_t tmp_moved_constant_289 = tmp_moved_constant_215*0.1381966011250105;
       const real_t tmp_moved_constant_304 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_305 = tmp_moved_constant_304*0.13819660112501053;
       const real_t tmp_moved_constant_306 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_307 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_308 = tmp_moved_constant_307*0.13819660112501056;
       const real_t tmp_moved_constant_309 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_6 - 1.0);
       const real_t tmp_moved_constant_310 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_311 = tmp_moved_constant_310*0.13819660112501056;
       const real_t tmp_moved_constant_312 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_313 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_314 = tmp_moved_constant_313*0.5854101966249684;
       const real_t tmp_moved_constant_315 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_316 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_317 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_318 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_20 - 1.0);
       const real_t tmp_moved_constant_319 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_320 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_321 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_322 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_28 - 1.0);
       const real_t tmp_moved_constant_323 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_30 - 1.0);
       const real_t tmp_moved_constant_324 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_325 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_326 = -tmp_moved_constant_324 - tmp_moved_constant_325;
       const real_t tmp_moved_constant_327 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_328 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_329 = -tmp_moved_constant_327 - tmp_moved_constant_328;
       const real_t tmp_moved_constant_330 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_331 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_332 = -tmp_moved_constant_330 - tmp_moved_constant_331;
       const real_t tmp_moved_constant_333 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_334 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_335 = -tmp_moved_constant_333 - tmp_moved_constant_334;
       const real_t tmp_moved_constant_336 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_337 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_338 = -tmp_moved_constant_336 - tmp_moved_constant_337;
       const real_t tmp_moved_constant_339 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_340 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_6;
       const real_t tmp_moved_constant_341 = -tmp_moved_constant_339 - tmp_moved_constant_340;
       const real_t tmp_moved_constant_342 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_343 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_344 = -tmp_moved_constant_342 - tmp_moved_constant_343;
       const real_t tmp_moved_constant_345 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_346 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_14;
       const real_t tmp_moved_constant_347 = -tmp_moved_constant_345 - tmp_moved_constant_346;
       const real_t tmp_moved_constant_348 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_349 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_350 = -tmp_moved_constant_348 - tmp_moved_constant_349;
       const real_t tmp_moved_constant_351 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_352 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_6;
       const real_t tmp_moved_constant_353 = -tmp_moved_constant_351 - tmp_moved_constant_352;
       const real_t tmp_moved_constant_354 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_355 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_356 = -tmp_moved_constant_354 - tmp_moved_constant_355;
       const real_t tmp_moved_constant_357 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_358 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_14;
       const real_t tmp_moved_constant_359 = -tmp_moved_constant_357 - tmp_moved_constant_358;
       const real_t tmp_moved_constant_360 = -jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_324 + tmp_moved_constant_336;
       const real_t tmp_moved_constant_361 = -jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_327 + tmp_moved_constant_339;
       const real_t tmp_moved_constant_362 = -jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_330 + tmp_moved_constant_342;
       const real_t tmp_moved_constant_363 = -jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_333 + tmp_moved_constant_345;
       const real_t tmp_moved_constant_364 = -jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_325 + tmp_moved_constant_348;
       const real_t tmp_moved_constant_365 = -jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_328 + tmp_moved_constant_351;
       const real_t tmp_moved_constant_366 = -jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_331 + tmp_moved_constant_354;
       const real_t tmp_moved_constant_367 = -jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_334 + tmp_moved_constant_357;
       const real_t tmp_moved_constant_368 = -jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_337 + tmp_moved_constant_349;
       const real_t tmp_moved_constant_369 = -jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_340 + tmp_moved_constant_352;
       const real_t tmp_moved_constant_370 = -jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_343 + tmp_moved_constant_355;
       const real_t tmp_moved_constant_371 = -jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_346 + tmp_moved_constant_358;
       const real_t tmp_moved_constant_372 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_88 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_88 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_373 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_90 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_90 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_90;
       const real_t tmp_moved_constant_374 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_92 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_92 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_92;
       const real_t tmp_moved_constant_375 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_94 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_94 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_94;
       const real_t tmp_moved_constant_376 = tmp_moved_constant_304*0.1381966011250105;
       const real_t tmp_moved_constant_377 = tmp_moved_constant_307*0.1381966011250105;
       const real_t tmp_moved_constant_378 = tmp_moved_constant_310*0.5854101966249684;
       const real_t tmp_moved_constant_379 = tmp_moved_constant_313*0.1381966011250105;
       const real_t tmp_moved_constant_380 = tmp_moved_constant_304*0.1381966011250105;
       const real_t tmp_moved_constant_381 = tmp_moved_constant_307*0.5854101966249684;
       const real_t tmp_moved_constant_382 = tmp_moved_constant_310*0.1381966011250105;
       const real_t tmp_moved_constant_383 = tmp_moved_constant_313*0.1381966011250105;
       const real_t tmp_moved_constant_384 = tmp_moved_constant_304*0.5854101966249684;
       const real_t tmp_moved_constant_385 = tmp_moved_constant_307*0.1381966011250105;
       const real_t tmp_moved_constant_386 = tmp_moved_constant_310*0.1381966011250105;
       const real_t tmp_moved_constant_387 = tmp_moved_constant_313*0.1381966011250105;
       const real_t tmp_moved_constant_402 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_403 = tmp_moved_constant_402*0.13819660112501053;
       const real_t tmp_moved_constant_404 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_405 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_406 = tmp_moved_constant_405*0.13819660112501056;
       const real_t tmp_moved_constant_407 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_6 - 1.0);
       const real_t tmp_moved_constant_408 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_409 = tmp_moved_constant_408*0.13819660112501056;
       const real_t tmp_moved_constant_410 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_411 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_412 = tmp_moved_constant_411*0.5854101966249684;
       const real_t tmp_moved_constant_413 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_414 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_415 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_416 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_20 - 1.0);
       const real_t tmp_moved_constant_417 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_418 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_419 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_420 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_28 - 1.0);
       const real_t tmp_moved_constant_421 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_30 - 1.0);
       const real_t tmp_moved_constant_422 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_423 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_424 = -tmp_moved_constant_422 - tmp_moved_constant_423;
       const real_t tmp_moved_constant_425 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_426 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_427 = -tmp_moved_constant_425 - tmp_moved_constant_426;
       const real_t tmp_moved_constant_428 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_429 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_430 = -tmp_moved_constant_428 - tmp_moved_constant_429;
       const real_t tmp_moved_constant_431 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_432 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_433 = -tmp_moved_constant_431 - tmp_moved_constant_432;
       const real_t tmp_moved_constant_434 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_435 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_436 = -tmp_moved_constant_434 - tmp_moved_constant_435;
       const real_t tmp_moved_constant_437 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_438 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_6;
       const real_t tmp_moved_constant_439 = -tmp_moved_constant_437 - tmp_moved_constant_438;
       const real_t tmp_moved_constant_440 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_441 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_442 = -tmp_moved_constant_440 - tmp_moved_constant_441;
       const real_t tmp_moved_constant_443 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_444 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_445 = -tmp_moved_constant_443 - tmp_moved_constant_444;
       const real_t tmp_moved_constant_446 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_447 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_448 = -tmp_moved_constant_446 - tmp_moved_constant_447;
       const real_t tmp_moved_constant_449 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_450 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_6;
       const real_t tmp_moved_constant_451 = -tmp_moved_constant_449 - tmp_moved_constant_450;
       const real_t tmp_moved_constant_452 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_453 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_454 = -tmp_moved_constant_452 - tmp_moved_constant_453;
       const real_t tmp_moved_constant_455 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_456 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_457 = -tmp_moved_constant_455 - tmp_moved_constant_456;
       const real_t tmp_moved_constant_458 = -jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_422 + tmp_moved_constant_434;
       const real_t tmp_moved_constant_459 = -jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_425 + tmp_moved_constant_437;
       const real_t tmp_moved_constant_460 = -jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_428 + tmp_moved_constant_440;
       const real_t tmp_moved_constant_461 = -jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_431 + tmp_moved_constant_443;
       const real_t tmp_moved_constant_462 = -jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_423 + tmp_moved_constant_446;
       const real_t tmp_moved_constant_463 = -jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_426 + tmp_moved_constant_449;
       const real_t tmp_moved_constant_464 = -jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_429 + tmp_moved_constant_452;
       const real_t tmp_moved_constant_465 = -jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_432 + tmp_moved_constant_455;
       const real_t tmp_moved_constant_466 = -jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_435 + tmp_moved_constant_447;
       const real_t tmp_moved_constant_467 = -jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_438 + tmp_moved_constant_450;
       const real_t tmp_moved_constant_468 = -jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_441 + tmp_moved_constant_453;
       const real_t tmp_moved_constant_469 = -jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_444 + tmp_moved_constant_456;
       const real_t tmp_moved_constant_470 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_88 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_88 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_471 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_90 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_90 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_90;
       const real_t tmp_moved_constant_472 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_92 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_92 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_92;
       const real_t tmp_moved_constant_473 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_94 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_94 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_94;
       const real_t tmp_moved_constant_474 = tmp_moved_constant_402*0.1381966011250105;
       const real_t tmp_moved_constant_475 = tmp_moved_constant_405*0.1381966011250105;
       const real_t tmp_moved_constant_476 = tmp_moved_constant_408*0.5854101966249684;
       const real_t tmp_moved_constant_477 = tmp_moved_constant_411*0.1381966011250105;
       const real_t tmp_moved_constant_478 = tmp_moved_constant_402*0.1381966011250105;
       const real_t tmp_moved_constant_479 = tmp_moved_constant_405*0.5854101966249684;
       const real_t tmp_moved_constant_480 = tmp_moved_constant_408*0.1381966011250105;
       const real_t tmp_moved_constant_481 = tmp_moved_constant_411*0.1381966011250105;
       const real_t tmp_moved_constant_482 = tmp_moved_constant_402*0.5854101966249684;
       const real_t tmp_moved_constant_483 = tmp_moved_constant_405*0.1381966011250105;
       const real_t tmp_moved_constant_484 = tmp_moved_constant_408*0.1381966011250105;
       const real_t tmp_moved_constant_485 = tmp_moved_constant_411*0.1381966011250105;
       for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
       for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
       {
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_1*tmp_kernel_op_89 + tmp_kernel_op_13*tmp_kernel_op_95 + tmp_kernel_op_5*tmp_kernel_op_91 + tmp_kernel_op_9*tmp_kernel_op_93) + src_dof_1*(-tmp_kernel_op_1*tmp_kernel_op_3 - tmp_kernel_op_11*tmp_kernel_op_9 - tmp_kernel_op_13*tmp_kernel_op_15 - tmp_kernel_op_5*tmp_kernel_op_7) + src_dof_2*(-tmp_kernel_op_1*tmp_kernel_op_17 - tmp_kernel_op_13*tmp_kernel_op_23 - tmp_kernel_op_19*tmp_kernel_op_5 - tmp_kernel_op_21*tmp_kernel_op_9) + src_dof_3*(-tmp_kernel_op_1*tmp_kernel_op_25 - tmp_kernel_op_13*tmp_kernel_op_31 - tmp_kernel_op_27*tmp_kernel_op_5 - tmp_kernel_op_29*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_1*tmp_kernel_op_34 + tmp_kernel_op_13*tmp_kernel_op_43 + tmp_kernel_op_37*tmp_kernel_op_5 + tmp_kernel_op_40*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_1*tmp_kernel_op_46 + tmp_kernel_op_13*tmp_kernel_op_55 + tmp_kernel_op_49*tmp_kernel_op_5 + tmp_kernel_op_52*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_1*tmp_kernel_op_58 + tmp_kernel_op_13*tmp_kernel_op_67 + tmp_kernel_op_5*tmp_kernel_op_61 + tmp_kernel_op_64*tmp_kernel_op_9) + src_dof_7*(tmp_kernel_op_1*tmp_kernel_op_69 + tmp_kernel_op_13*tmp_kernel_op_75 + tmp_kernel_op_5*tmp_kernel_op_71 + tmp_kernel_op_73*tmp_kernel_op_9) + src_dof_8*(tmp_kernel_op_1*tmp_kernel_op_77 + tmp_kernel_op_13*tmp_kernel_op_83 + tmp_kernel_op_5*tmp_kernel_op_79 + tmp_kernel_op_81*tmp_kernel_op_9) + src_dof_9*(tmp_kernel_op_1*tmp_kernel_op_84 + tmp_kernel_op_13*tmp_kernel_op_87 + tmp_kernel_op_5*tmp_kernel_op_85 + tmp_kernel_op_86*tmp_kernel_op_9);
             const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_89*tmp_kernel_op_96 + tmp_kernel_op_91*tmp_kernel_op_97 + tmp_kernel_op_93*tmp_kernel_op_98 + tmp_kernel_op_95*tmp_kernel_op_99) + src_dof_1*(-tmp_kernel_op_11*tmp_kernel_op_98 - tmp_kernel_op_15*tmp_kernel_op_99 - tmp_kernel_op_3*tmp_kernel_op_96 - tmp_kernel_op_7*tmp_kernel_op_97) + src_dof_2*(-tmp_kernel_op_17*tmp_kernel_op_96 - tmp_kernel_op_19*tmp_kernel_op_97 - tmp_kernel_op_21*tmp_kernel_op_98 - tmp_kernel_op_23*tmp_kernel_op_99) + src_dof_3*(-tmp_kernel_op_25*tmp_kernel_op_96 - tmp_kernel_op_27*tmp_kernel_op_97 - tmp_kernel_op_29*tmp_kernel_op_98 - tmp_kernel_op_31*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_34*tmp_kernel_op_96 + tmp_kernel_op_37*tmp_kernel_op_97 + tmp_kernel_op_40*tmp_kernel_op_98 + tmp_kernel_op_43*tmp_kernel_op_99) + src_dof_5*(tmp_kernel_op_46*tmp_kernel_op_96 + tmp_kernel_op_49*tmp_kernel_op_97 + tmp_kernel_op_52*tmp_kernel_op_98 + tmp_kernel_op_55*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_58*tmp_kernel_op_96 + tmp_kernel_op_61*tmp_kernel_op_97 + tmp_kernel_op_64*tmp_kernel_op_98 + tmp_kernel_op_67*tmp_kernel_op_99) + src_dof_7*(tmp_kernel_op_69*tmp_kernel_op_96 + tmp_kernel_op_71*tmp_kernel_op_97 + tmp_kernel_op_73*tmp_kernel_op_98 + tmp_kernel_op_75*tmp_kernel_op_99) + src_dof_8*(tmp_kernel_op_77*tmp_kernel_op_96 + tmp_kernel_op_79*tmp_kernel_op_97 + tmp_kernel_op_81*tmp_kernel_op_98 + tmp_kernel_op_83*tmp_kernel_op_99) + src_dof_9*(tmp_kernel_op_84*tmp_kernel_op_96 + tmp_kernel_op_85*tmp_kernel_op_97 + tmp_kernel_op_86*tmp_kernel_op_98 + tmp_kernel_op_87*tmp_kernel_op_99);
             const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_89 + tmp_kernel_op_101*tmp_kernel_op_91 + tmp_kernel_op_102*tmp_kernel_op_93 + tmp_kernel_op_103*tmp_kernel_op_95) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_3 - tmp_kernel_op_101*tmp_kernel_op_7 - tmp_kernel_op_102*tmp_kernel_op_11 - tmp_kernel_op_103*tmp_kernel_op_15) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_17 - tmp_kernel_op_101*tmp_kernel_op_19 - tmp_kernel_op_102*tmp_kernel_op_21 - tmp_kernel_op_103*tmp_kernel_op_23) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_25 - tmp_kernel_op_101*tmp_kernel_op_27 - tmp_kernel_op_102*tmp_kernel_op_29 - tmp_kernel_op_103*tmp_kernel_op_31) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_34 + tmp_kernel_op_101*tmp_kernel_op_37 + tmp_kernel_op_102*tmp_kernel_op_40 + tmp_kernel_op_103*tmp_kernel_op_43) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_46 + tmp_kernel_op_101*tmp_kernel_op_49 + tmp_kernel_op_102*tmp_kernel_op_52 + tmp_kernel_op_103*tmp_kernel_op_55) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_58 + tmp_kernel_op_101*tmp_kernel_op_61 + tmp_kernel_op_102*tmp_kernel_op_64 + tmp_kernel_op_103*tmp_kernel_op_67) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_69 + tmp_kernel_op_101*tmp_kernel_op_71 + tmp_kernel_op_102*tmp_kernel_op_73 + tmp_kernel_op_103*tmp_kernel_op_75) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_77 + tmp_kernel_op_101*tmp_kernel_op_79 + tmp_kernel_op_102*tmp_kernel_op_81 + tmp_kernel_op_103*tmp_kernel_op_83) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_84 + tmp_kernel_op_101*tmp_kernel_op_85 + tmp_kernel_op_102*tmp_kernel_op_86 + tmp_kernel_op_103*tmp_kernel_op_87);
             const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_104*tmp_kernel_op_89 + tmp_kernel_op_105*tmp_kernel_op_91 + tmp_kernel_op_106*tmp_kernel_op_93 + tmp_kernel_op_107*tmp_kernel_op_95) + src_dof_1*(-tmp_kernel_op_104*tmp_kernel_op_3 - tmp_kernel_op_105*tmp_kernel_op_7 - tmp_kernel_op_106*tmp_kernel_op_11 - tmp_kernel_op_107*tmp_kernel_op_15) + src_dof_2*(-tmp_kernel_op_104*tmp_kernel_op_17 - tmp_kernel_op_105*tmp_kernel_op_19 - tmp_kernel_op_106*tmp_kernel_op_21 - tmp_kernel_op_107*tmp_kernel_op_23) + src_dof_3*(-tmp_kernel_op_104*tmp_kernel_op_25 - tmp_kernel_op_105*tmp_kernel_op_27 - tmp_kernel_op_106*tmp_kernel_op_29 - tmp_kernel_op_107*tmp_kernel_op_31) + src_dof_4*(tmp_kernel_op_104*tmp_kernel_op_34 + tmp_kernel_op_105*tmp_kernel_op_37 + tmp_kernel_op_106*tmp_kernel_op_40 + tmp_kernel_op_107*tmp_kernel_op_43) + src_dof_5*(tmp_kernel_op_104*tmp_kernel_op_46 + tmp_kernel_op_105*tmp_kernel_op_49 + tmp_kernel_op_106*tmp_kernel_op_52 + tmp_kernel_op_107*tmp_kernel_op_55) + src_dof_6*(tmp_kernel_op_104*tmp_kernel_op_58 + tmp_kernel_op_105*tmp_kernel_op_61 + tmp_kernel_op_106*tmp_kernel_op_64 + tmp_kernel_op_107*tmp_kernel_op_67) + src_dof_7*(tmp_kernel_op_104*tmp_kernel_op_69 + tmp_kernel_op_105*tmp_kernel_op_71 + tmp_kernel_op_106*tmp_kernel_op_73 + tmp_kernel_op_107*tmp_kernel_op_75) + src_dof_8*(tmp_kernel_op_104*tmp_kernel_op_77 + tmp_kernel_op_105*tmp_kernel_op_79 + tmp_kernel_op_106*tmp_kernel_op_81 + tmp_kernel_op_107*tmp_kernel_op_83) + src_dof_9*(tmp_kernel_op_104*tmp_kernel_op_84 + tmp_kernel_op_105*tmp_kernel_op_85 + tmp_kernel_op_106*tmp_kernel_op_86 + tmp_kernel_op_107*tmp_kernel_op_87);
             {
                {
               
                   const int64_t phantom_ctr_0 = ctr_0;
                   real_t _data_float_loop_ctr_array_dim_0[4];
                   _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                   _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                   _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                   _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                   real_t _data_float_loop_ctr_array_dim_1[4];
                   _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                   real_t _data_float_loop_ctr_array_dim_2[4];
                   _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
               
                   const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                }
             }
             const real_t tmp_moved_constant_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t tmp_moved_constant_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_moved_constant_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_moved_constant_94 = tmp_moved_constant_0*(tmp_moved_constant_11*tmp_moved_constant_78 + tmp_moved_constant_14*tmp_moved_constant_79 + tmp_moved_constant_17*tmp_moved_constant_80 + tmp_moved_constant_20*tmp_moved_constant_81) + tmp_moved_constant_1*(-tmp_moved_constant_11*tmp_moved_constant_12 - tmp_moved_constant_14*tmp_moved_constant_15 - tmp_moved_constant_17*tmp_moved_constant_18 - tmp_moved_constant_20*tmp_moved_constant_21) + tmp_moved_constant_2*(-tmp_moved_constant_11*tmp_moved_constant_22 - tmp_moved_constant_14*tmp_moved_constant_23 - tmp_moved_constant_17*tmp_moved_constant_24 - tmp_moved_constant_20*tmp_moved_constant_25) + tmp_moved_constant_3*(-tmp_moved_constant_11*tmp_moved_constant_26 - tmp_moved_constant_14*tmp_moved_constant_27 - tmp_moved_constant_17*tmp_moved_constant_28 - tmp_moved_constant_20*tmp_moved_constant_29) + tmp_moved_constant_4*(tmp_moved_constant_11*tmp_moved_constant_32 + tmp_moved_constant_14*tmp_moved_constant_35 + tmp_moved_constant_17*tmp_moved_constant_38 + tmp_moved_constant_20*tmp_moved_constant_41) + tmp_moved_constant_5*(tmp_moved_constant_11*tmp_moved_constant_44 + tmp_moved_constant_14*tmp_moved_constant_47 + tmp_moved_constant_17*tmp_moved_constant_50 + tmp_moved_constant_20*tmp_moved_constant_53) + tmp_moved_constant_6*(tmp_moved_constant_11*tmp_moved_constant_56 + tmp_moved_constant_14*tmp_moved_constant_59 + tmp_moved_constant_17*tmp_moved_constant_62 + tmp_moved_constant_20*tmp_moved_constant_65) + tmp_moved_constant_7*(tmp_moved_constant_11*tmp_moved_constant_66 + tmp_moved_constant_14*tmp_moved_constant_67 + tmp_moved_constant_17*tmp_moved_constant_68 + tmp_moved_constant_20*tmp_moved_constant_69) + tmp_moved_constant_8*(tmp_moved_constant_11*tmp_moved_constant_70 + tmp_moved_constant_14*tmp_moved_constant_71 + tmp_moved_constant_17*tmp_moved_constant_72 + tmp_moved_constant_20*tmp_moved_constant_73) + tmp_moved_constant_9*(tmp_moved_constant_11*tmp_moved_constant_74 + tmp_moved_constant_14*tmp_moved_constant_75 + tmp_moved_constant_17*tmp_moved_constant_76 + tmp_moved_constant_20*tmp_moved_constant_77);
             const real_t tmp_moved_constant_95 = tmp_moved_constant_0*(tmp_moved_constant_78*tmp_moved_constant_82 + tmp_moved_constant_79*tmp_moved_constant_83 + tmp_moved_constant_80*tmp_moved_constant_84 + tmp_moved_constant_81*tmp_moved_constant_85) + tmp_moved_constant_1*(-tmp_moved_constant_12*tmp_moved_constant_82 - tmp_moved_constant_15*tmp_moved_constant_83 - tmp_moved_constant_18*tmp_moved_constant_84 - tmp_moved_constant_21*tmp_moved_constant_85) + tmp_moved_constant_2*(-tmp_moved_constant_22*tmp_moved_constant_82 - tmp_moved_constant_23*tmp_moved_constant_83 - tmp_moved_constant_24*tmp_moved_constant_84 - tmp_moved_constant_25*tmp_moved_constant_85) + tmp_moved_constant_3*(-tmp_moved_constant_26*tmp_moved_constant_82 - tmp_moved_constant_27*tmp_moved_constant_83 - tmp_moved_constant_28*tmp_moved_constant_84 - tmp_moved_constant_29*tmp_moved_constant_85) + tmp_moved_constant_4*(tmp_moved_constant_32*tmp_moved_constant_82 + tmp_moved_constant_35*tmp_moved_constant_83 + tmp_moved_constant_38*tmp_moved_constant_84 + tmp_moved_constant_41*tmp_moved_constant_85) + tmp_moved_constant_5*(tmp_moved_constant_44*tmp_moved_constant_82 + tmp_moved_constant_47*tmp_moved_constant_83 + tmp_moved_constant_50*tmp_moved_constant_84 + tmp_moved_constant_53*tmp_moved_constant_85) + tmp_moved_constant_6*(tmp_moved_constant_56*tmp_moved_constant_82 + tmp_moved_constant_59*tmp_moved_constant_83 + tmp_moved_constant_62*tmp_moved_constant_84 + tmp_moved_constant_65*tmp_moved_constant_85) + tmp_moved_constant_7*(tmp_moved_constant_66*tmp_moved_constant_82 + tmp_moved_constant_67*tmp_moved_constant_83 + tmp_moved_constant_68*tmp_moved_constant_84 + tmp_moved_constant_69*tmp_moved_constant_85) + tmp_moved_constant_8*(tmp_moved_constant_70*tmp_moved_constant_82 + tmp_moved_constant_71*tmp_moved_constant_83 + tmp_moved_constant_72*tmp_moved_constant_84 + tmp_moved_constant_73*tmp_moved_constant_85) + tmp_moved_constant_9*(tmp_moved_constant_74*tmp_moved_constant_82 + tmp_moved_constant_75*tmp_moved_constant_83 + tmp_moved_constant_76*tmp_moved_constant_84 + tmp_moved_constant_77*tmp_moved_constant_85);
             const real_t tmp_moved_constant_96 = tmp_moved_constant_0*(tmp_moved_constant_78*tmp_moved_constant_86 + tmp_moved_constant_79*tmp_moved_constant_87 + tmp_moved_constant_80*tmp_moved_constant_88 + tmp_moved_constant_81*tmp_moved_constant_89) + tmp_moved_constant_1*(-tmp_moved_constant_12*tmp_moved_constant_86 - tmp_moved_constant_15*tmp_moved_constant_87 - tmp_moved_constant_18*tmp_moved_constant_88 - tmp_moved_constant_21*tmp_moved_constant_89) + tmp_moved_constant_2*(-tmp_moved_constant_22*tmp_moved_constant_86 - tmp_moved_constant_23*tmp_moved_constant_87 - tmp_moved_constant_24*tmp_moved_constant_88 - tmp_moved_constant_25*tmp_moved_constant_89) + tmp_moved_constant_3*(-tmp_moved_constant_26*tmp_moved_constant_86 - tmp_moved_constant_27*tmp_moved_constant_87 - tmp_moved_constant_28*tmp_moved_constant_88 - tmp_moved_constant_29*tmp_moved_constant_89) + tmp_moved_constant_4*(tmp_moved_constant_32*tmp_moved_constant_86 + tmp_moved_constant_35*tmp_moved_constant_87 + tmp_moved_constant_38*tmp_moved_constant_88 + tmp_moved_constant_41*tmp_moved_constant_89) + tmp_moved_constant_5*(tmp_moved_constant_44*tmp_moved_constant_86 + tmp_moved_constant_47*tmp_moved_constant_87 + tmp_moved_constant_50*tmp_moved_constant_88 + tmp_moved_constant_53*tmp_moved_constant_89) + tmp_moved_constant_6*(tmp_moved_constant_56*tmp_moved_constant_86 + tmp_moved_constant_59*tmp_moved_constant_87 + tmp_moved_constant_62*tmp_moved_constant_88 + tmp_moved_constant_65*tmp_moved_constant_89) + tmp_moved_constant_7*(tmp_moved_constant_66*tmp_moved_constant_86 + tmp_moved_constant_67*tmp_moved_constant_87 + tmp_moved_constant_68*tmp_moved_constant_88 + tmp_moved_constant_69*tmp_moved_constant_89) + tmp_moved_constant_8*(tmp_moved_constant_70*tmp_moved_constant_86 + tmp_moved_constant_71*tmp_moved_constant_87 + tmp_moved_constant_72*tmp_moved_constant_88 + tmp_moved_constant_73*tmp_moved_constant_89) + tmp_moved_constant_9*(tmp_moved_constant_74*tmp_moved_constant_86 + tmp_moved_constant_75*tmp_moved_constant_87 + tmp_moved_constant_76*tmp_moved_constant_88 + tmp_moved_constant_77*tmp_moved_constant_89);
             const real_t tmp_moved_constant_97 = tmp_moved_constant_0*(tmp_moved_constant_78*tmp_moved_constant_90 + tmp_moved_constant_79*tmp_moved_constant_91 + tmp_moved_constant_80*tmp_moved_constant_92 + tmp_moved_constant_81*tmp_moved_constant_93) + tmp_moved_constant_1*(-tmp_moved_constant_12*tmp_moved_constant_90 - tmp_moved_constant_15*tmp_moved_constant_91 - tmp_moved_constant_18*tmp_moved_constant_92 - tmp_moved_constant_21*tmp_moved_constant_93) + tmp_moved_constant_2*(-tmp_moved_constant_22*tmp_moved_constant_90 - tmp_moved_constant_23*tmp_moved_constant_91 - tmp_moved_constant_24*tmp_moved_constant_92 - tmp_moved_constant_25*tmp_moved_constant_93) + tmp_moved_constant_3*(-tmp_moved_constant_26*tmp_moved_constant_90 - tmp_moved_constant_27*tmp_moved_constant_91 - tmp_moved_constant_28*tmp_moved_constant_92 - tmp_moved_constant_29*tmp_moved_constant_93) + tmp_moved_constant_4*(tmp_moved_constant_32*tmp_moved_constant_90 + tmp_moved_constant_35*tmp_moved_constant_91 + tmp_moved_constant_38*tmp_moved_constant_92 + tmp_moved_constant_41*tmp_moved_constant_93) + tmp_moved_constant_5*(tmp_moved_constant_44*tmp_moved_constant_90 + tmp_moved_constant_47*tmp_moved_constant_91 + tmp_moved_constant_50*tmp_moved_constant_92 + tmp_moved_constant_53*tmp_moved_constant_93) + tmp_moved_constant_6*(tmp_moved_constant_56*tmp_moved_constant_90 + tmp_moved_constant_59*tmp_moved_constant_91 + tmp_moved_constant_62*tmp_moved_constant_92 + tmp_moved_constant_65*tmp_moved_constant_93) + tmp_moved_constant_7*(tmp_moved_constant_66*tmp_moved_constant_90 + tmp_moved_constant_67*tmp_moved_constant_91 + tmp_moved_constant_68*tmp_moved_constant_92 + tmp_moved_constant_69*tmp_moved_constant_93) + tmp_moved_constant_8*(tmp_moved_constant_70*tmp_moved_constant_90 + tmp_moved_constant_71*tmp_moved_constant_91 + tmp_moved_constant_72*tmp_moved_constant_92 + tmp_moved_constant_73*tmp_moved_constant_93) + tmp_moved_constant_9*(tmp_moved_constant_74*tmp_moved_constant_90 + tmp_moved_constant_75*tmp_moved_constant_91 + tmp_moved_constant_76*tmp_moved_constant_92 + tmp_moved_constant_77*tmp_moved_constant_93);
             {
                {
               
                   const int64_t phantom_ctr_0 = ctr_0;
                   real_t _data_float_loop_ctr_array_dim_0[4];
                   _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                   _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                   _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                   _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                   real_t _data_float_loop_ctr_array_dim_1[4];
                   _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                   real_t _data_float_loop_ctr_array_dim_2[4];
                   _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
               
                   const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_94 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_95 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_96 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_97 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                }
             }
             const real_t tmp_moved_constant_98 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_99 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_100 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_101 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_102 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_moved_constant_103 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_104 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_105 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_moved_constant_106 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_moved_constant_107 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_192 = tmp_moved_constant_100*(-tmp_moved_constant_109*tmp_moved_constant_120 - tmp_moved_constant_112*tmp_moved_constant_121 - tmp_moved_constant_115*tmp_moved_constant_122 - tmp_moved_constant_118*tmp_moved_constant_123) + tmp_moved_constant_101*(-tmp_moved_constant_109*tmp_moved_constant_124 - tmp_moved_constant_112*tmp_moved_constant_125 - tmp_moved_constant_115*tmp_moved_constant_126 - tmp_moved_constant_118*tmp_moved_constant_127) + tmp_moved_constant_102*(tmp_moved_constant_109*tmp_moved_constant_130 + tmp_moved_constant_112*tmp_moved_constant_133 + tmp_moved_constant_115*tmp_moved_constant_136 + tmp_moved_constant_118*tmp_moved_constant_139) + tmp_moved_constant_103*(tmp_moved_constant_109*tmp_moved_constant_142 + tmp_moved_constant_112*tmp_moved_constant_145 + tmp_moved_constant_115*tmp_moved_constant_148 + tmp_moved_constant_118*tmp_moved_constant_151) + tmp_moved_constant_104*(tmp_moved_constant_109*tmp_moved_constant_154 + tmp_moved_constant_112*tmp_moved_constant_157 + tmp_moved_constant_115*tmp_moved_constant_160 + tmp_moved_constant_118*tmp_moved_constant_163) + tmp_moved_constant_105*(tmp_moved_constant_109*tmp_moved_constant_164 + tmp_moved_constant_112*tmp_moved_constant_165 + tmp_moved_constant_115*tmp_moved_constant_166 + tmp_moved_constant_118*tmp_moved_constant_167) + tmp_moved_constant_106*(tmp_moved_constant_109*tmp_moved_constant_168 + tmp_moved_constant_112*tmp_moved_constant_169 + tmp_moved_constant_115*tmp_moved_constant_170 + tmp_moved_constant_118*tmp_moved_constant_171) + tmp_moved_constant_107*(tmp_moved_constant_109*tmp_moved_constant_172 + tmp_moved_constant_112*tmp_moved_constant_173 + tmp_moved_constant_115*tmp_moved_constant_174 + tmp_moved_constant_118*tmp_moved_constant_175) + tmp_moved_constant_98*(tmp_moved_constant_109*tmp_moved_constant_176 + tmp_moved_constant_112*tmp_moved_constant_177 + tmp_moved_constant_115*tmp_moved_constant_178 + tmp_moved_constant_118*tmp_moved_constant_179) + tmp_moved_constant_99*(-tmp_moved_constant_109*tmp_moved_constant_110 - tmp_moved_constant_112*tmp_moved_constant_113 - tmp_moved_constant_115*tmp_moved_constant_116 - tmp_moved_constant_118*tmp_moved_constant_119);
             const real_t tmp_moved_constant_193 = tmp_moved_constant_100*(-tmp_moved_constant_120*tmp_moved_constant_180 - tmp_moved_constant_121*tmp_moved_constant_181 - tmp_moved_constant_122*tmp_moved_constant_182 - tmp_moved_constant_123*tmp_moved_constant_183) + tmp_moved_constant_101*(-tmp_moved_constant_124*tmp_moved_constant_180 - tmp_moved_constant_125*tmp_moved_constant_181 - tmp_moved_constant_126*tmp_moved_constant_182 - tmp_moved_constant_127*tmp_moved_constant_183) + tmp_moved_constant_102*(tmp_moved_constant_130*tmp_moved_constant_180 + tmp_moved_constant_133*tmp_moved_constant_181 + tmp_moved_constant_136*tmp_moved_constant_182 + tmp_moved_constant_139*tmp_moved_constant_183) + tmp_moved_constant_103*(tmp_moved_constant_142*tmp_moved_constant_180 + tmp_moved_constant_145*tmp_moved_constant_181 + tmp_moved_constant_148*tmp_moved_constant_182 + tmp_moved_constant_151*tmp_moved_constant_183) + tmp_moved_constant_104*(tmp_moved_constant_154*tmp_moved_constant_180 + tmp_moved_constant_157*tmp_moved_constant_181 + tmp_moved_constant_160*tmp_moved_constant_182 + tmp_moved_constant_163*tmp_moved_constant_183) + tmp_moved_constant_105*(tmp_moved_constant_164*tmp_moved_constant_180 + tmp_moved_constant_165*tmp_moved_constant_181 + tmp_moved_constant_166*tmp_moved_constant_182 + tmp_moved_constant_167*tmp_moved_constant_183) + tmp_moved_constant_106*(tmp_moved_constant_168*tmp_moved_constant_180 + tmp_moved_constant_169*tmp_moved_constant_181 + tmp_moved_constant_170*tmp_moved_constant_182 + tmp_moved_constant_171*tmp_moved_constant_183) + tmp_moved_constant_107*(tmp_moved_constant_172*tmp_moved_constant_180 + tmp_moved_constant_173*tmp_moved_constant_181 + tmp_moved_constant_174*tmp_moved_constant_182 + tmp_moved_constant_175*tmp_moved_constant_183) + tmp_moved_constant_98*(tmp_moved_constant_176*tmp_moved_constant_180 + tmp_moved_constant_177*tmp_moved_constant_181 + tmp_moved_constant_178*tmp_moved_constant_182 + tmp_moved_constant_179*tmp_moved_constant_183) + tmp_moved_constant_99*(-tmp_moved_constant_110*tmp_moved_constant_180 - tmp_moved_constant_113*tmp_moved_constant_181 - tmp_moved_constant_116*tmp_moved_constant_182 - tmp_moved_constant_119*tmp_moved_constant_183);
             const real_t tmp_moved_constant_194 = tmp_moved_constant_100*(-tmp_moved_constant_120*tmp_moved_constant_184 - tmp_moved_constant_121*tmp_moved_constant_185 - tmp_moved_constant_122*tmp_moved_constant_186 - tmp_moved_constant_123*tmp_moved_constant_187) + tmp_moved_constant_101*(-tmp_moved_constant_124*tmp_moved_constant_184 - tmp_moved_constant_125*tmp_moved_constant_185 - tmp_moved_constant_126*tmp_moved_constant_186 - tmp_moved_constant_127*tmp_moved_constant_187) + tmp_moved_constant_102*(tmp_moved_constant_130*tmp_moved_constant_184 + tmp_moved_constant_133*tmp_moved_constant_185 + tmp_moved_constant_136*tmp_moved_constant_186 + tmp_moved_constant_139*tmp_moved_constant_187) + tmp_moved_constant_103*(tmp_moved_constant_142*tmp_moved_constant_184 + tmp_moved_constant_145*tmp_moved_constant_185 + tmp_moved_constant_148*tmp_moved_constant_186 + tmp_moved_constant_151*tmp_moved_constant_187) + tmp_moved_constant_104*(tmp_moved_constant_154*tmp_moved_constant_184 + tmp_moved_constant_157*tmp_moved_constant_185 + tmp_moved_constant_160*tmp_moved_constant_186 + tmp_moved_constant_163*tmp_moved_constant_187) + tmp_moved_constant_105*(tmp_moved_constant_164*tmp_moved_constant_184 + tmp_moved_constant_165*tmp_moved_constant_185 + tmp_moved_constant_166*tmp_moved_constant_186 + tmp_moved_constant_167*tmp_moved_constant_187) + tmp_moved_constant_106*(tmp_moved_constant_168*tmp_moved_constant_184 + tmp_moved_constant_169*tmp_moved_constant_185 + tmp_moved_constant_170*tmp_moved_constant_186 + tmp_moved_constant_171*tmp_moved_constant_187) + tmp_moved_constant_107*(tmp_moved_constant_172*tmp_moved_constant_184 + tmp_moved_constant_173*tmp_moved_constant_185 + tmp_moved_constant_174*tmp_moved_constant_186 + tmp_moved_constant_175*tmp_moved_constant_187) + tmp_moved_constant_98*(tmp_moved_constant_176*tmp_moved_constant_184 + tmp_moved_constant_177*tmp_moved_constant_185 + tmp_moved_constant_178*tmp_moved_constant_186 + tmp_moved_constant_179*tmp_moved_constant_187) + tmp_moved_constant_99*(-tmp_moved_constant_110*tmp_moved_constant_184 - tmp_moved_constant_113*tmp_moved_constant_185 - tmp_moved_constant_116*tmp_moved_constant_186 - tmp_moved_constant_119*tmp_moved_constant_187);
             const real_t tmp_moved_constant_195 = tmp_moved_constant_100*(-tmp_moved_constant_120*tmp_moved_constant_188 - tmp_moved_constant_121*tmp_moved_constant_189 - tmp_moved_constant_122*tmp_moved_constant_190 - tmp_moved_constant_123*tmp_moved_constant_191) + tmp_moved_constant_101*(-tmp_moved_constant_124*tmp_moved_constant_188 - tmp_moved_constant_125*tmp_moved_constant_189 - tmp_moved_constant_126*tmp_moved_constant_190 - tmp_moved_constant_127*tmp_moved_constant_191) + tmp_moved_constant_102*(tmp_moved_constant_130*tmp_moved_constant_188 + tmp_moved_constant_133*tmp_moved_constant_189 + tmp_moved_constant_136*tmp_moved_constant_190 + tmp_moved_constant_139*tmp_moved_constant_191) + tmp_moved_constant_103*(tmp_moved_constant_142*tmp_moved_constant_188 + tmp_moved_constant_145*tmp_moved_constant_189 + tmp_moved_constant_148*tmp_moved_constant_190 + tmp_moved_constant_151*tmp_moved_constant_191) + tmp_moved_constant_104*(tmp_moved_constant_154*tmp_moved_constant_188 + tmp_moved_constant_157*tmp_moved_constant_189 + tmp_moved_constant_160*tmp_moved_constant_190 + tmp_moved_constant_163*tmp_moved_constant_191) + tmp_moved_constant_105*(tmp_moved_constant_164*tmp_moved_constant_188 + tmp_moved_constant_165*tmp_moved_constant_189 + tmp_moved_constant_166*tmp_moved_constant_190 + tmp_moved_constant_167*tmp_moved_constant_191) + tmp_moved_constant_106*(tmp_moved_constant_168*tmp_moved_constant_188 + tmp_moved_constant_169*tmp_moved_constant_189 + tmp_moved_constant_170*tmp_moved_constant_190 + tmp_moved_constant_171*tmp_moved_constant_191) + tmp_moved_constant_107*(tmp_moved_constant_172*tmp_moved_constant_188 + tmp_moved_constant_173*tmp_moved_constant_189 + tmp_moved_constant_174*tmp_moved_constant_190 + tmp_moved_constant_175*tmp_moved_constant_191) + tmp_moved_constant_98*(tmp_moved_constant_176*tmp_moved_constant_188 + tmp_moved_constant_177*tmp_moved_constant_189 + tmp_moved_constant_178*tmp_moved_constant_190 + tmp_moved_constant_179*tmp_moved_constant_191) + tmp_moved_constant_99*(-tmp_moved_constant_110*tmp_moved_constant_188 - tmp_moved_constant_113*tmp_moved_constant_189 - tmp_moved_constant_116*tmp_moved_constant_190 - tmp_moved_constant_119*tmp_moved_constant_191);
             {
                {
               
                   const int64_t phantom_ctr_0 = ctr_0;
                   real_t _data_float_loop_ctr_array_dim_0[4];
                   _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                   _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                   _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                   _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                   real_t _data_float_loop_ctr_array_dim_1[4];
                   _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                   real_t _data_float_loop_ctr_array_dim_2[4];
                   _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
               
                   const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_192 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_193 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_194 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_195 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                }
             }
             const real_t tmp_moved_constant_196 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_197 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_198 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_199 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_200 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_201 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_202 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_203 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_204 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_205 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_290 = tmp_moved_constant_196*(tmp_moved_constant_207*tmp_moved_constant_274 + tmp_moved_constant_210*tmp_moved_constant_275 + tmp_moved_constant_213*tmp_moved_constant_276 + tmp_moved_constant_216*tmp_moved_constant_277) + tmp_moved_constant_197*(-tmp_moved_constant_207*tmp_moved_constant_208 - tmp_moved_constant_210*tmp_moved_constant_211 - tmp_moved_constant_213*tmp_moved_constant_214 - tmp_moved_constant_216*tmp_moved_constant_217) + tmp_moved_constant_198*(-tmp_moved_constant_207*tmp_moved_constant_218 - tmp_moved_constant_210*tmp_moved_constant_219 - tmp_moved_constant_213*tmp_moved_constant_220 - tmp_moved_constant_216*tmp_moved_constant_221) + tmp_moved_constant_199*(-tmp_moved_constant_207*tmp_moved_constant_222 - tmp_moved_constant_210*tmp_moved_constant_223 - tmp_moved_constant_213*tmp_moved_constant_224 - tmp_moved_constant_216*tmp_moved_constant_225) + tmp_moved_constant_200*(tmp_moved_constant_207*tmp_moved_constant_228 + tmp_moved_constant_210*tmp_moved_constant_231 + tmp_moved_constant_213*tmp_moved_constant_234 + tmp_moved_constant_216*tmp_moved_constant_237) + tmp_moved_constant_201*(tmp_moved_constant_207*tmp_moved_constant_240 + tmp_moved_constant_210*tmp_moved_constant_243 + tmp_moved_constant_213*tmp_moved_constant_246 + tmp_moved_constant_216*tmp_moved_constant_249) + tmp_moved_constant_202*(tmp_moved_constant_207*tmp_moved_constant_252 + tmp_moved_constant_210*tmp_moved_constant_255 + tmp_moved_constant_213*tmp_moved_constant_258 + tmp_moved_constant_216*tmp_moved_constant_261) + tmp_moved_constant_203*(tmp_moved_constant_207*tmp_moved_constant_262 + tmp_moved_constant_210*tmp_moved_constant_263 + tmp_moved_constant_213*tmp_moved_constant_264 + tmp_moved_constant_216*tmp_moved_constant_265) + tmp_moved_constant_204*(tmp_moved_constant_207*tmp_moved_constant_266 + tmp_moved_constant_210*tmp_moved_constant_267 + tmp_moved_constant_213*tmp_moved_constant_268 + tmp_moved_constant_216*tmp_moved_constant_269) + tmp_moved_constant_205*(tmp_moved_constant_207*tmp_moved_constant_270 + tmp_moved_constant_210*tmp_moved_constant_271 + tmp_moved_constant_213*tmp_moved_constant_272 + tmp_moved_constant_216*tmp_moved_constant_273);
             const real_t tmp_moved_constant_291 = tmp_moved_constant_196*(tmp_moved_constant_274*tmp_moved_constant_278 + tmp_moved_constant_275*tmp_moved_constant_279 + tmp_moved_constant_276*tmp_moved_constant_280 + tmp_moved_constant_277*tmp_moved_constant_281) + tmp_moved_constant_197*(-tmp_moved_constant_208*tmp_moved_constant_278 - tmp_moved_constant_211*tmp_moved_constant_279 - tmp_moved_constant_214*tmp_moved_constant_280 - tmp_moved_constant_217*tmp_moved_constant_281) + tmp_moved_constant_198*(-tmp_moved_constant_218*tmp_moved_constant_278 - tmp_moved_constant_219*tmp_moved_constant_279 - tmp_moved_constant_220*tmp_moved_constant_280 - tmp_moved_constant_221*tmp_moved_constant_281) + tmp_moved_constant_199*(-tmp_moved_constant_222*tmp_moved_constant_278 - tmp_moved_constant_223*tmp_moved_constant_279 - tmp_moved_constant_224*tmp_moved_constant_280 - tmp_moved_constant_225*tmp_moved_constant_281) + tmp_moved_constant_200*(tmp_moved_constant_228*tmp_moved_constant_278 + tmp_moved_constant_231*tmp_moved_constant_279 + tmp_moved_constant_234*tmp_moved_constant_280 + tmp_moved_constant_237*tmp_moved_constant_281) + tmp_moved_constant_201*(tmp_moved_constant_240*tmp_moved_constant_278 + tmp_moved_constant_243*tmp_moved_constant_279 + tmp_moved_constant_246*tmp_moved_constant_280 + tmp_moved_constant_249*tmp_moved_constant_281) + tmp_moved_constant_202*(tmp_moved_constant_252*tmp_moved_constant_278 + tmp_moved_constant_255*tmp_moved_constant_279 + tmp_moved_constant_258*tmp_moved_constant_280 + tmp_moved_constant_261*tmp_moved_constant_281) + tmp_moved_constant_203*(tmp_moved_constant_262*tmp_moved_constant_278 + tmp_moved_constant_263*tmp_moved_constant_279 + tmp_moved_constant_264*tmp_moved_constant_280 + tmp_moved_constant_265*tmp_moved_constant_281) + tmp_moved_constant_204*(tmp_moved_constant_266*tmp_moved_constant_278 + tmp_moved_constant_267*tmp_moved_constant_279 + tmp_moved_constant_268*tmp_moved_constant_280 + tmp_moved_constant_269*tmp_moved_constant_281) + tmp_moved_constant_205*(tmp_moved_constant_270*tmp_moved_constant_278 + tmp_moved_constant_271*tmp_moved_constant_279 + tmp_moved_constant_272*tmp_moved_constant_280 + tmp_moved_constant_273*tmp_moved_constant_281);
             const real_t tmp_moved_constant_292 = tmp_moved_constant_196*(tmp_moved_constant_274*tmp_moved_constant_282 + tmp_moved_constant_275*tmp_moved_constant_283 + tmp_moved_constant_276*tmp_moved_constant_284 + tmp_moved_constant_277*tmp_moved_constant_285) + tmp_moved_constant_197*(-tmp_moved_constant_208*tmp_moved_constant_282 - tmp_moved_constant_211*tmp_moved_constant_283 - tmp_moved_constant_214*tmp_moved_constant_284 - tmp_moved_constant_217*tmp_moved_constant_285) + tmp_moved_constant_198*(-tmp_moved_constant_218*tmp_moved_constant_282 - tmp_moved_constant_219*tmp_moved_constant_283 - tmp_moved_constant_220*tmp_moved_constant_284 - tmp_moved_constant_221*tmp_moved_constant_285) + tmp_moved_constant_199*(-tmp_moved_constant_222*tmp_moved_constant_282 - tmp_moved_constant_223*tmp_moved_constant_283 - tmp_moved_constant_224*tmp_moved_constant_284 - tmp_moved_constant_225*tmp_moved_constant_285) + tmp_moved_constant_200*(tmp_moved_constant_228*tmp_moved_constant_282 + tmp_moved_constant_231*tmp_moved_constant_283 + tmp_moved_constant_234*tmp_moved_constant_284 + tmp_moved_constant_237*tmp_moved_constant_285) + tmp_moved_constant_201*(tmp_moved_constant_240*tmp_moved_constant_282 + tmp_moved_constant_243*tmp_moved_constant_283 + tmp_moved_constant_246*tmp_moved_constant_284 + tmp_moved_constant_249*tmp_moved_constant_285) + tmp_moved_constant_202*(tmp_moved_constant_252*tmp_moved_constant_282 + tmp_moved_constant_255*tmp_moved_constant_283 + tmp_moved_constant_258*tmp_moved_constant_284 + tmp_moved_constant_261*tmp_moved_constant_285) + tmp_moved_constant_203*(tmp_moved_constant_262*tmp_moved_constant_282 + tmp_moved_constant_263*tmp_moved_constant_283 + tmp_moved_constant_264*tmp_moved_constant_284 + tmp_moved_constant_265*tmp_moved_constant_285) + tmp_moved_constant_204*(tmp_moved_constant_266*tmp_moved_constant_282 + tmp_moved_constant_267*tmp_moved_constant_283 + tmp_moved_constant_268*tmp_moved_constant_284 + tmp_moved_constant_269*tmp_moved_constant_285) + tmp_moved_constant_205*(tmp_moved_constant_270*tmp_moved_constant_282 + tmp_moved_constant_271*tmp_moved_constant_283 + tmp_moved_constant_272*tmp_moved_constant_284 + tmp_moved_constant_273*tmp_moved_constant_285);
             const real_t tmp_moved_constant_293 = tmp_moved_constant_196*(tmp_moved_constant_274*tmp_moved_constant_286 + tmp_moved_constant_275*tmp_moved_constant_287 + tmp_moved_constant_276*tmp_moved_constant_288 + tmp_moved_constant_277*tmp_moved_constant_289) + tmp_moved_constant_197*(-tmp_moved_constant_208*tmp_moved_constant_286 - tmp_moved_constant_211*tmp_moved_constant_287 - tmp_moved_constant_214*tmp_moved_constant_288 - tmp_moved_constant_217*tmp_moved_constant_289) + tmp_moved_constant_198*(-tmp_moved_constant_218*tmp_moved_constant_286 - tmp_moved_constant_219*tmp_moved_constant_287 - tmp_moved_constant_220*tmp_moved_constant_288 - tmp_moved_constant_221*tmp_moved_constant_289) + tmp_moved_constant_199*(-tmp_moved_constant_222*tmp_moved_constant_286 - tmp_moved_constant_223*tmp_moved_constant_287 - tmp_moved_constant_224*tmp_moved_constant_288 - tmp_moved_constant_225*tmp_moved_constant_289) + tmp_moved_constant_200*(tmp_moved_constant_228*tmp_moved_constant_286 + tmp_moved_constant_231*tmp_moved_constant_287 + tmp_moved_constant_234*tmp_moved_constant_288 + tmp_moved_constant_237*tmp_moved_constant_289) + tmp_moved_constant_201*(tmp_moved_constant_240*tmp_moved_constant_286 + tmp_moved_constant_243*tmp_moved_constant_287 + tmp_moved_constant_246*tmp_moved_constant_288 + tmp_moved_constant_249*tmp_moved_constant_289) + tmp_moved_constant_202*(tmp_moved_constant_252*tmp_moved_constant_286 + tmp_moved_constant_255*tmp_moved_constant_287 + tmp_moved_constant_258*tmp_moved_constant_288 + tmp_moved_constant_261*tmp_moved_constant_289) + tmp_moved_constant_203*(tmp_moved_constant_262*tmp_moved_constant_286 + tmp_moved_constant_263*tmp_moved_constant_287 + tmp_moved_constant_264*tmp_moved_constant_288 + tmp_moved_constant_265*tmp_moved_constant_289) + tmp_moved_constant_204*(tmp_moved_constant_266*tmp_moved_constant_286 + tmp_moved_constant_267*tmp_moved_constant_287 + tmp_moved_constant_268*tmp_moved_constant_288 + tmp_moved_constant_269*tmp_moved_constant_289) + tmp_moved_constant_205*(tmp_moved_constant_270*tmp_moved_constant_286 + tmp_moved_constant_271*tmp_moved_constant_287 + tmp_moved_constant_272*tmp_moved_constant_288 + tmp_moved_constant_273*tmp_moved_constant_289);
             {
                {
               
                   const int64_t phantom_ctr_0 = ctr_0;
                   real_t _data_float_loop_ctr_array_dim_0[4];
                   _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                   _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                   _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                   _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                   real_t _data_float_loop_ctr_array_dim_1[4];
                   _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                   real_t _data_float_loop_ctr_array_dim_2[4];
                   _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
               
                   const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_290 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_291 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_292 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_293 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                }
             }
             const real_t tmp_moved_constant_294 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_295 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_296 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_297 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_298 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_299 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_300 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_301 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_moved_constant_302 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_303 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_388 = tmp_moved_constant_294*(tmp_moved_constant_305*tmp_moved_constant_372 + tmp_moved_constant_308*tmp_moved_constant_373 + tmp_moved_constant_311*tmp_moved_constant_374 + tmp_moved_constant_314*tmp_moved_constant_375) + tmp_moved_constant_295*(-tmp_moved_constant_305*tmp_moved_constant_306 - tmp_moved_constant_308*tmp_moved_constant_309 - tmp_moved_constant_311*tmp_moved_constant_312 - tmp_moved_constant_314*tmp_moved_constant_315) + tmp_moved_constant_296*(-tmp_moved_constant_305*tmp_moved_constant_316 - tmp_moved_constant_308*tmp_moved_constant_317 - tmp_moved_constant_311*tmp_moved_constant_318 - tmp_moved_constant_314*tmp_moved_constant_319) + tmp_moved_constant_297*(-tmp_moved_constant_305*tmp_moved_constant_320 - tmp_moved_constant_308*tmp_moved_constant_321 - tmp_moved_constant_311*tmp_moved_constant_322 - tmp_moved_constant_314*tmp_moved_constant_323) + tmp_moved_constant_298*(tmp_moved_constant_305*tmp_moved_constant_326 + tmp_moved_constant_308*tmp_moved_constant_329 + tmp_moved_constant_311*tmp_moved_constant_332 + tmp_moved_constant_314*tmp_moved_constant_335) + tmp_moved_constant_299*(tmp_moved_constant_305*tmp_moved_constant_338 + tmp_moved_constant_308*tmp_moved_constant_341 + tmp_moved_constant_311*tmp_moved_constant_344 + tmp_moved_constant_314*tmp_moved_constant_347) + tmp_moved_constant_300*(tmp_moved_constant_305*tmp_moved_constant_350 + tmp_moved_constant_308*tmp_moved_constant_353 + tmp_moved_constant_311*tmp_moved_constant_356 + tmp_moved_constant_314*tmp_moved_constant_359) + tmp_moved_constant_301*(tmp_moved_constant_305*tmp_moved_constant_360 + tmp_moved_constant_308*tmp_moved_constant_361 + tmp_moved_constant_311*tmp_moved_constant_362 + tmp_moved_constant_314*tmp_moved_constant_363) + tmp_moved_constant_302*(tmp_moved_constant_305*tmp_moved_constant_364 + tmp_moved_constant_308*tmp_moved_constant_365 + tmp_moved_constant_311*tmp_moved_constant_366 + tmp_moved_constant_314*tmp_moved_constant_367) + tmp_moved_constant_303*(tmp_moved_constant_305*tmp_moved_constant_368 + tmp_moved_constant_308*tmp_moved_constant_369 + tmp_moved_constant_311*tmp_moved_constant_370 + tmp_moved_constant_314*tmp_moved_constant_371);
             const real_t tmp_moved_constant_389 = tmp_moved_constant_294*(tmp_moved_constant_372*tmp_moved_constant_376 + tmp_moved_constant_373*tmp_moved_constant_377 + tmp_moved_constant_374*tmp_moved_constant_378 + tmp_moved_constant_375*tmp_moved_constant_379) + tmp_moved_constant_295*(-tmp_moved_constant_306*tmp_moved_constant_376 - tmp_moved_constant_309*tmp_moved_constant_377 - tmp_moved_constant_312*tmp_moved_constant_378 - tmp_moved_constant_315*tmp_moved_constant_379) + tmp_moved_constant_296*(-tmp_moved_constant_316*tmp_moved_constant_376 - tmp_moved_constant_317*tmp_moved_constant_377 - tmp_moved_constant_318*tmp_moved_constant_378 - tmp_moved_constant_319*tmp_moved_constant_379) + tmp_moved_constant_297*(-tmp_moved_constant_320*tmp_moved_constant_376 - tmp_moved_constant_321*tmp_moved_constant_377 - tmp_moved_constant_322*tmp_moved_constant_378 - tmp_moved_constant_323*tmp_moved_constant_379) + tmp_moved_constant_298*(tmp_moved_constant_326*tmp_moved_constant_376 + tmp_moved_constant_329*tmp_moved_constant_377 + tmp_moved_constant_332*tmp_moved_constant_378 + tmp_moved_constant_335*tmp_moved_constant_379) + tmp_moved_constant_299*(tmp_moved_constant_338*tmp_moved_constant_376 + tmp_moved_constant_341*tmp_moved_constant_377 + tmp_moved_constant_344*tmp_moved_constant_378 + tmp_moved_constant_347*tmp_moved_constant_379) + tmp_moved_constant_300*(tmp_moved_constant_350*tmp_moved_constant_376 + tmp_moved_constant_353*tmp_moved_constant_377 + tmp_moved_constant_356*tmp_moved_constant_378 + tmp_moved_constant_359*tmp_moved_constant_379) + tmp_moved_constant_301*(tmp_moved_constant_360*tmp_moved_constant_376 + tmp_moved_constant_361*tmp_moved_constant_377 + tmp_moved_constant_362*tmp_moved_constant_378 + tmp_moved_constant_363*tmp_moved_constant_379) + tmp_moved_constant_302*(tmp_moved_constant_364*tmp_moved_constant_376 + tmp_moved_constant_365*tmp_moved_constant_377 + tmp_moved_constant_366*tmp_moved_constant_378 + tmp_moved_constant_367*tmp_moved_constant_379) + tmp_moved_constant_303*(tmp_moved_constant_368*tmp_moved_constant_376 + tmp_moved_constant_369*tmp_moved_constant_377 + tmp_moved_constant_370*tmp_moved_constant_378 + tmp_moved_constant_371*tmp_moved_constant_379);
             const real_t tmp_moved_constant_390 = tmp_moved_constant_294*(tmp_moved_constant_372*tmp_moved_constant_380 + tmp_moved_constant_373*tmp_moved_constant_381 + tmp_moved_constant_374*tmp_moved_constant_382 + tmp_moved_constant_375*tmp_moved_constant_383) + tmp_moved_constant_295*(-tmp_moved_constant_306*tmp_moved_constant_380 - tmp_moved_constant_309*tmp_moved_constant_381 - tmp_moved_constant_312*tmp_moved_constant_382 - tmp_moved_constant_315*tmp_moved_constant_383) + tmp_moved_constant_296*(-tmp_moved_constant_316*tmp_moved_constant_380 - tmp_moved_constant_317*tmp_moved_constant_381 - tmp_moved_constant_318*tmp_moved_constant_382 - tmp_moved_constant_319*tmp_moved_constant_383) + tmp_moved_constant_297*(-tmp_moved_constant_320*tmp_moved_constant_380 - tmp_moved_constant_321*tmp_moved_constant_381 - tmp_moved_constant_322*tmp_moved_constant_382 - tmp_moved_constant_323*tmp_moved_constant_383) + tmp_moved_constant_298*(tmp_moved_constant_326*tmp_moved_constant_380 + tmp_moved_constant_329*tmp_moved_constant_381 + tmp_moved_constant_332*tmp_moved_constant_382 + tmp_moved_constant_335*tmp_moved_constant_383) + tmp_moved_constant_299*(tmp_moved_constant_338*tmp_moved_constant_380 + tmp_moved_constant_341*tmp_moved_constant_381 + tmp_moved_constant_344*tmp_moved_constant_382 + tmp_moved_constant_347*tmp_moved_constant_383) + tmp_moved_constant_300*(tmp_moved_constant_350*tmp_moved_constant_380 + tmp_moved_constant_353*tmp_moved_constant_381 + tmp_moved_constant_356*tmp_moved_constant_382 + tmp_moved_constant_359*tmp_moved_constant_383) + tmp_moved_constant_301*(tmp_moved_constant_360*tmp_moved_constant_380 + tmp_moved_constant_361*tmp_moved_constant_381 + tmp_moved_constant_362*tmp_moved_constant_382 + tmp_moved_constant_363*tmp_moved_constant_383) + tmp_moved_constant_302*(tmp_moved_constant_364*tmp_moved_constant_380 + tmp_moved_constant_365*tmp_moved_constant_381 + tmp_moved_constant_366*tmp_moved_constant_382 + tmp_moved_constant_367*tmp_moved_constant_383) + tmp_moved_constant_303*(tmp_moved_constant_368*tmp_moved_constant_380 + tmp_moved_constant_369*tmp_moved_constant_381 + tmp_moved_constant_370*tmp_moved_constant_382 + tmp_moved_constant_371*tmp_moved_constant_383);
             const real_t tmp_moved_constant_391 = tmp_moved_constant_294*(tmp_moved_constant_372*tmp_moved_constant_384 + tmp_moved_constant_373*tmp_moved_constant_385 + tmp_moved_constant_374*tmp_moved_constant_386 + tmp_moved_constant_375*tmp_moved_constant_387) + tmp_moved_constant_295*(-tmp_moved_constant_306*tmp_moved_constant_384 - tmp_moved_constant_309*tmp_moved_constant_385 - tmp_moved_constant_312*tmp_moved_constant_386 - tmp_moved_constant_315*tmp_moved_constant_387) + tmp_moved_constant_296*(-tmp_moved_constant_316*tmp_moved_constant_384 - tmp_moved_constant_317*tmp_moved_constant_385 - tmp_moved_constant_318*tmp_moved_constant_386 - tmp_moved_constant_319*tmp_moved_constant_387) + tmp_moved_constant_297*(-tmp_moved_constant_320*tmp_moved_constant_384 - tmp_moved_constant_321*tmp_moved_constant_385 - tmp_moved_constant_322*tmp_moved_constant_386 - tmp_moved_constant_323*tmp_moved_constant_387) + tmp_moved_constant_298*(tmp_moved_constant_326*tmp_moved_constant_384 + tmp_moved_constant_329*tmp_moved_constant_385 + tmp_moved_constant_332*tmp_moved_constant_386 + tmp_moved_constant_335*tmp_moved_constant_387) + tmp_moved_constant_299*(tmp_moved_constant_338*tmp_moved_constant_384 + tmp_moved_constant_341*tmp_moved_constant_385 + tmp_moved_constant_344*tmp_moved_constant_386 + tmp_moved_constant_347*tmp_moved_constant_387) + tmp_moved_constant_300*(tmp_moved_constant_350*tmp_moved_constant_384 + tmp_moved_constant_353*tmp_moved_constant_385 + tmp_moved_constant_356*tmp_moved_constant_386 + tmp_moved_constant_359*tmp_moved_constant_387) + tmp_moved_constant_301*(tmp_moved_constant_360*tmp_moved_constant_384 + tmp_moved_constant_361*tmp_moved_constant_385 + tmp_moved_constant_362*tmp_moved_constant_386 + tmp_moved_constant_363*tmp_moved_constant_387) + tmp_moved_constant_302*(tmp_moved_constant_364*tmp_moved_constant_384 + tmp_moved_constant_365*tmp_moved_constant_385 + tmp_moved_constant_366*tmp_moved_constant_386 + tmp_moved_constant_367*tmp_moved_constant_387) + tmp_moved_constant_303*(tmp_moved_constant_368*tmp_moved_constant_384 + tmp_moved_constant_369*tmp_moved_constant_385 + tmp_moved_constant_370*tmp_moved_constant_386 + tmp_moved_constant_371*tmp_moved_constant_387);
             {
                {
               
                   const int64_t phantom_ctr_0 = ctr_0;
                   real_t _data_float_loop_ctr_array_dim_0[4];
                   _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                   _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                   _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                   _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                   real_t _data_float_loop_ctr_array_dim_1[4];
                   _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                   real_t _data_float_loop_ctr_array_dim_2[4];
                   _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
               
                   const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_388 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_389 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_390 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_391 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                }
             }
             const real_t tmp_moved_constant_392 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_393 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_394 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t tmp_moved_constant_395 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t tmp_moved_constant_396 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_397 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_398 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_moved_constant_399 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_400 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t tmp_moved_constant_401 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_moved_constant_486 = tmp_moved_constant_392*(tmp_moved_constant_403*tmp_moved_constant_470 + tmp_moved_constant_406*tmp_moved_constant_471 + tmp_moved_constant_409*tmp_moved_constant_472 + tmp_moved_constant_412*tmp_moved_constant_473) + tmp_moved_constant_393*(-tmp_moved_constant_403*tmp_moved_constant_404 - tmp_moved_constant_406*tmp_moved_constant_407 - tmp_moved_constant_409*tmp_moved_constant_410 - tmp_moved_constant_412*tmp_moved_constant_413) + tmp_moved_constant_394*(-tmp_moved_constant_403*tmp_moved_constant_414 - tmp_moved_constant_406*tmp_moved_constant_415 - tmp_moved_constant_409*tmp_moved_constant_416 - tmp_moved_constant_412*tmp_moved_constant_417) + tmp_moved_constant_395*(-tmp_moved_constant_403*tmp_moved_constant_418 - tmp_moved_constant_406*tmp_moved_constant_419 - tmp_moved_constant_409*tmp_moved_constant_420 - tmp_moved_constant_412*tmp_moved_constant_421) + tmp_moved_constant_396*(tmp_moved_constant_403*tmp_moved_constant_424 + tmp_moved_constant_406*tmp_moved_constant_427 + tmp_moved_constant_409*tmp_moved_constant_430 + tmp_moved_constant_412*tmp_moved_constant_433) + tmp_moved_constant_397*(tmp_moved_constant_403*tmp_moved_constant_436 + tmp_moved_constant_406*tmp_moved_constant_439 + tmp_moved_constant_409*tmp_moved_constant_442 + tmp_moved_constant_412*tmp_moved_constant_445) + tmp_moved_constant_398*(tmp_moved_constant_403*tmp_moved_constant_448 + tmp_moved_constant_406*tmp_moved_constant_451 + tmp_moved_constant_409*tmp_moved_constant_454 + tmp_moved_constant_412*tmp_moved_constant_457) + tmp_moved_constant_399*(tmp_moved_constant_403*tmp_moved_constant_458 + tmp_moved_constant_406*tmp_moved_constant_459 + tmp_moved_constant_409*tmp_moved_constant_460 + tmp_moved_constant_412*tmp_moved_constant_461) + tmp_moved_constant_400*(tmp_moved_constant_403*tmp_moved_constant_462 + tmp_moved_constant_406*tmp_moved_constant_463 + tmp_moved_constant_409*tmp_moved_constant_464 + tmp_moved_constant_412*tmp_moved_constant_465) + tmp_moved_constant_401*(tmp_moved_constant_403*tmp_moved_constant_466 + tmp_moved_constant_406*tmp_moved_constant_467 + tmp_moved_constant_409*tmp_moved_constant_468 + tmp_moved_constant_412*tmp_moved_constant_469);
             const real_t tmp_moved_constant_487 = tmp_moved_constant_392*(tmp_moved_constant_470*tmp_moved_constant_474 + tmp_moved_constant_471*tmp_moved_constant_475 + tmp_moved_constant_472*tmp_moved_constant_476 + tmp_moved_constant_473*tmp_moved_constant_477) + tmp_moved_constant_393*(-tmp_moved_constant_404*tmp_moved_constant_474 - tmp_moved_constant_407*tmp_moved_constant_475 - tmp_moved_constant_410*tmp_moved_constant_476 - tmp_moved_constant_413*tmp_moved_constant_477) + tmp_moved_constant_394*(-tmp_moved_constant_414*tmp_moved_constant_474 - tmp_moved_constant_415*tmp_moved_constant_475 - tmp_moved_constant_416*tmp_moved_constant_476 - tmp_moved_constant_417*tmp_moved_constant_477) + tmp_moved_constant_395*(-tmp_moved_constant_418*tmp_moved_constant_474 - tmp_moved_constant_419*tmp_moved_constant_475 - tmp_moved_constant_420*tmp_moved_constant_476 - tmp_moved_constant_421*tmp_moved_constant_477) + tmp_moved_constant_396*(tmp_moved_constant_424*tmp_moved_constant_474 + tmp_moved_constant_427*tmp_moved_constant_475 + tmp_moved_constant_430*tmp_moved_constant_476 + tmp_moved_constant_433*tmp_moved_constant_477) + tmp_moved_constant_397*(tmp_moved_constant_436*tmp_moved_constant_474 + tmp_moved_constant_439*tmp_moved_constant_475 + tmp_moved_constant_442*tmp_moved_constant_476 + tmp_moved_constant_445*tmp_moved_constant_477) + tmp_moved_constant_398*(tmp_moved_constant_448*tmp_moved_constant_474 + tmp_moved_constant_451*tmp_moved_constant_475 + tmp_moved_constant_454*tmp_moved_constant_476 + tmp_moved_constant_457*tmp_moved_constant_477) + tmp_moved_constant_399*(tmp_moved_constant_458*tmp_moved_constant_474 + tmp_moved_constant_459*tmp_moved_constant_475 + tmp_moved_constant_460*tmp_moved_constant_476 + tmp_moved_constant_461*tmp_moved_constant_477) + tmp_moved_constant_400*(tmp_moved_constant_462*tmp_moved_constant_474 + tmp_moved_constant_463*tmp_moved_constant_475 + tmp_moved_constant_464*tmp_moved_constant_476 + tmp_moved_constant_465*tmp_moved_constant_477) + tmp_moved_constant_401*(tmp_moved_constant_466*tmp_moved_constant_474 + tmp_moved_constant_467*tmp_moved_constant_475 + tmp_moved_constant_468*tmp_moved_constant_476 + tmp_moved_constant_469*tmp_moved_constant_477);
             const real_t tmp_moved_constant_488 = tmp_moved_constant_392*(tmp_moved_constant_470*tmp_moved_constant_478 + tmp_moved_constant_471*tmp_moved_constant_479 + tmp_moved_constant_472*tmp_moved_constant_480 + tmp_moved_constant_473*tmp_moved_constant_481) + tmp_moved_constant_393*(-tmp_moved_constant_404*tmp_moved_constant_478 - tmp_moved_constant_407*tmp_moved_constant_479 - tmp_moved_constant_410*tmp_moved_constant_480 - tmp_moved_constant_413*tmp_moved_constant_481) + tmp_moved_constant_394*(-tmp_moved_constant_414*tmp_moved_constant_478 - tmp_moved_constant_415*tmp_moved_constant_479 - tmp_moved_constant_416*tmp_moved_constant_480 - tmp_moved_constant_417*tmp_moved_constant_481) + tmp_moved_constant_395*(-tmp_moved_constant_418*tmp_moved_constant_478 - tmp_moved_constant_419*tmp_moved_constant_479 - tmp_moved_constant_420*tmp_moved_constant_480 - tmp_moved_constant_421*tmp_moved_constant_481) + tmp_moved_constant_396*(tmp_moved_constant_424*tmp_moved_constant_478 + tmp_moved_constant_427*tmp_moved_constant_479 + tmp_moved_constant_430*tmp_moved_constant_480 + tmp_moved_constant_433*tmp_moved_constant_481) + tmp_moved_constant_397*(tmp_moved_constant_436*tmp_moved_constant_478 + tmp_moved_constant_439*tmp_moved_constant_479 + tmp_moved_constant_442*tmp_moved_constant_480 + tmp_moved_constant_445*tmp_moved_constant_481) + tmp_moved_constant_398*(tmp_moved_constant_448*tmp_moved_constant_478 + tmp_moved_constant_451*tmp_moved_constant_479 + tmp_moved_constant_454*tmp_moved_constant_480 + tmp_moved_constant_457*tmp_moved_constant_481) + tmp_moved_constant_399*(tmp_moved_constant_458*tmp_moved_constant_478 + tmp_moved_constant_459*tmp_moved_constant_479 + tmp_moved_constant_460*tmp_moved_constant_480 + tmp_moved_constant_461*tmp_moved_constant_481) + tmp_moved_constant_400*(tmp_moved_constant_462*tmp_moved_constant_478 + tmp_moved_constant_463*tmp_moved_constant_479 + tmp_moved_constant_464*tmp_moved_constant_480 + tmp_moved_constant_465*tmp_moved_constant_481) + tmp_moved_constant_401*(tmp_moved_constant_466*tmp_moved_constant_478 + tmp_moved_constant_467*tmp_moved_constant_479 + tmp_moved_constant_468*tmp_moved_constant_480 + tmp_moved_constant_469*tmp_moved_constant_481);
             const real_t tmp_moved_constant_489 = tmp_moved_constant_392*(tmp_moved_constant_470*tmp_moved_constant_482 + tmp_moved_constant_471*tmp_moved_constant_483 + tmp_moved_constant_472*tmp_moved_constant_484 + tmp_moved_constant_473*tmp_moved_constant_485) + tmp_moved_constant_393*(-tmp_moved_constant_404*tmp_moved_constant_482 - tmp_moved_constant_407*tmp_moved_constant_483 - tmp_moved_constant_410*tmp_moved_constant_484 - tmp_moved_constant_413*tmp_moved_constant_485) + tmp_moved_constant_394*(-tmp_moved_constant_414*tmp_moved_constant_482 - tmp_moved_constant_415*tmp_moved_constant_483 - tmp_moved_constant_416*tmp_moved_constant_484 - tmp_moved_constant_417*tmp_moved_constant_485) + tmp_moved_constant_395*(-tmp_moved_constant_418*tmp_moved_constant_482 - tmp_moved_constant_419*tmp_moved_constant_483 - tmp_moved_constant_420*tmp_moved_constant_484 - tmp_moved_constant_421*tmp_moved_constant_485) + tmp_moved_constant_396*(tmp_moved_constant_424*tmp_moved_constant_482 + tmp_moved_constant_427*tmp_moved_constant_483 + tmp_moved_constant_430*tmp_moved_constant_484 + tmp_moved_constant_433*tmp_moved_constant_485) + tmp_moved_constant_397*(tmp_moved_constant_436*tmp_moved_constant_482 + tmp_moved_constant_439*tmp_moved_constant_483 + tmp_moved_constant_442*tmp_moved_constant_484 + tmp_moved_constant_445*tmp_moved_constant_485) + tmp_moved_constant_398*(tmp_moved_constant_448*tmp_moved_constant_482 + tmp_moved_constant_451*tmp_moved_constant_483 + tmp_moved_constant_454*tmp_moved_constant_484 + tmp_moved_constant_457*tmp_moved_constant_485) + tmp_moved_constant_399*(tmp_moved_constant_458*tmp_moved_constant_482 + tmp_moved_constant_459*tmp_moved_constant_483 + tmp_moved_constant_460*tmp_moved_constant_484 + tmp_moved_constant_461*tmp_moved_constant_485) + tmp_moved_constant_400*(tmp_moved_constant_462*tmp_moved_constant_482 + tmp_moved_constant_463*tmp_moved_constant_483 + tmp_moved_constant_464*tmp_moved_constant_484 + tmp_moved_constant_465*tmp_moved_constant_485) + tmp_moved_constant_401*(tmp_moved_constant_466*tmp_moved_constant_482 + tmp_moved_constant_467*tmp_moved_constant_483 + tmp_moved_constant_468*tmp_moved_constant_484 + tmp_moved_constant_469*tmp_moved_constant_485);
             {
                {
               
                   const int64_t phantom_ctr_0 = ctr_0;
                   real_t _data_float_loop_ctr_array_dim_0[4];
                   _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                   _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                   _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                   _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                   real_t _data_float_loop_ctr_array_dim_1[4];
                   _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                   _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                   real_t _data_float_loop_ctr_array_dim_2[4];
                   _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                   _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
               
                   const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                   const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_486 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_487 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_488 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_489 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                }
             }
          }
          for (int64_t ctr_0 = -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             if (-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2 >= 0)
             {
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_0 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
                const real_t tmp_kernel_op_1 = tmp_kernel_op_0*0.13819660112501053;
                const real_t tmp_kernel_op_2 = 0.55278640450004202;
                const real_t tmp_kernel_op_3 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_2 - 1.0);
                const real_t tmp_kernel_op_4 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
                const real_t tmp_kernel_op_5 = tmp_kernel_op_4*0.13819660112501056;
                const real_t tmp_kernel_op_6 = 0.55278640450004202;
                const real_t tmp_kernel_op_7 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_6 - 1.0);
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
                const real_t tmp_kernel_op_9 = tmp_kernel_op_8*0.13819660112501056;
                const real_t tmp_kernel_op_10 = 2.3416407864998736;
                const real_t tmp_kernel_op_11 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_10 - 1.0);
                const real_t tmp_kernel_op_12 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
                const real_t tmp_kernel_op_13 = tmp_kernel_op_12*0.5854101966249684;
                const real_t tmp_kernel_op_14 = 0.55278640450004202;
                const real_t tmp_kernel_op_15 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_14 - 1.0);
                const real_t tmp_kernel_op_16 = 0.55278640450004202;
                const real_t tmp_kernel_op_17 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_16 - 1.0);
                const real_t tmp_kernel_op_18 = 2.3416407864998736;
                const real_t tmp_kernel_op_19 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_18 - 1.0);
                const real_t tmp_kernel_op_20 = 0.55278640450004202;
                const real_t tmp_kernel_op_21 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_20 - 1.0);
                const real_t tmp_kernel_op_22 = 0.55278640450004202;
                const real_t tmp_kernel_op_23 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_22 - 1.0);
                const real_t tmp_kernel_op_24 = 2.3416407864998736;
                const real_t tmp_kernel_op_25 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_24 - 1.0);
                const real_t tmp_kernel_op_26 = 0.55278640450004202;
                const real_t tmp_kernel_op_27 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_26 - 1.0);
                const real_t tmp_kernel_op_28 = 0.55278640450004202;
                const real_t tmp_kernel_op_29 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_28 - 1.0);
                const real_t tmp_kernel_op_30 = 0.55278640450004202;
                const real_t tmp_kernel_op_31 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_30 - 1.0);
                const real_t tmp_kernel_op_32 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_24;
                const real_t tmp_kernel_op_33 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_16;
                const real_t tmp_kernel_op_34 = -tmp_kernel_op_32 - tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_26;
                const real_t tmp_kernel_op_36 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_18;
                const real_t tmp_kernel_op_37 = -tmp_kernel_op_35 - tmp_kernel_op_36;
                const real_t tmp_kernel_op_38 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_28;
                const real_t tmp_kernel_op_39 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_20;
                const real_t tmp_kernel_op_40 = -tmp_kernel_op_38 - tmp_kernel_op_39;
                const real_t tmp_kernel_op_41 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_30;
                const real_t tmp_kernel_op_42 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_22;
                const real_t tmp_kernel_op_43 = -tmp_kernel_op_41 - tmp_kernel_op_42;
                const real_t tmp_kernel_op_44 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_24;
                const real_t tmp_kernel_op_45 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_2;
                const real_t tmp_kernel_op_46 = -tmp_kernel_op_44 - tmp_kernel_op_45;
                const real_t tmp_kernel_op_47 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_26;
                const real_t tmp_kernel_op_48 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_6;
                const real_t tmp_kernel_op_49 = -tmp_kernel_op_47 - tmp_kernel_op_48;
                const real_t tmp_kernel_op_50 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_28;
                const real_t tmp_kernel_op_51 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_10;
                const real_t tmp_kernel_op_52 = -tmp_kernel_op_50 - tmp_kernel_op_51;
                const real_t tmp_kernel_op_53 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_30;
                const real_t tmp_kernel_op_54 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_14;
                const real_t tmp_kernel_op_55 = -tmp_kernel_op_53 - tmp_kernel_op_54;
                const real_t tmp_kernel_op_56 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_16;
                const real_t tmp_kernel_op_57 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_2;
                const real_t tmp_kernel_op_58 = -tmp_kernel_op_56 - tmp_kernel_op_57;
                const real_t tmp_kernel_op_59 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_18;
                const real_t tmp_kernel_op_60 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_6;
                const real_t tmp_kernel_op_61 = -tmp_kernel_op_59 - tmp_kernel_op_60;
                const real_t tmp_kernel_op_62 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_20;
                const real_t tmp_kernel_op_63 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_10;
                const real_t tmp_kernel_op_64 = -tmp_kernel_op_62 - tmp_kernel_op_63;
                const real_t tmp_kernel_op_65 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_22;
                const real_t tmp_kernel_op_66 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_14;
                const real_t tmp_kernel_op_67 = -tmp_kernel_op_65 - tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_16 + tmp_kernel_op_2;
                const real_t tmp_kernel_op_69 = -jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_kernel_op_32 + tmp_kernel_op_44;
                const real_t tmp_kernel_op_70 = tmp_kernel_op_18 + tmp_kernel_op_6;
                const real_t tmp_kernel_op_71 = -jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_kernel_op_35 + tmp_kernel_op_47;
                const real_t tmp_kernel_op_72 = tmp_kernel_op_10 + tmp_kernel_op_20;
                const real_t tmp_kernel_op_73 = -jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_kernel_op_38 + tmp_kernel_op_50;
                const real_t tmp_kernel_op_74 = tmp_kernel_op_14 + tmp_kernel_op_22;
                const real_t tmp_kernel_op_75 = -jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_kernel_op_41 + tmp_kernel_op_53;
                const real_t tmp_kernel_op_76 = tmp_kernel_op_24 - 4.0;
                const real_t tmp_kernel_op_77 = -jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_kernel_op_33 + tmp_kernel_op_56;
                const real_t tmp_kernel_op_78 = tmp_kernel_op_26 - 4.0;
                const real_t tmp_kernel_op_79 = -jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_kernel_op_36 + tmp_kernel_op_59;
                const real_t tmp_kernel_op_80 = tmp_kernel_op_28 - 4.0;
                const real_t tmp_kernel_op_81 = -jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_kernel_op_39 + tmp_kernel_op_62;
                const real_t tmp_kernel_op_82 = tmp_kernel_op_30 - 4.0;
                const real_t tmp_kernel_op_83 = -jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_kernel_op_42 + tmp_kernel_op_65;
                const real_t tmp_kernel_op_84 = -jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_kernel_op_45 + tmp_kernel_op_57;
                const real_t tmp_kernel_op_85 = -jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_kernel_op_48 + tmp_kernel_op_60;
                const real_t tmp_kernel_op_86 = -jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_kernel_op_51 + tmp_kernel_op_63;
                const real_t tmp_kernel_op_87 = -jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_kernel_op_54 + tmp_kernel_op_66;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_24 + tmp_kernel_op_68 - 3.0;
                const real_t tmp_kernel_op_89 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_88 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_88 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_88;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_26 + tmp_kernel_op_70 - 3.0;
                const real_t tmp_kernel_op_91 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_90 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_90 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_90;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_28 + tmp_kernel_op_72 - 3.0;
                const real_t tmp_kernel_op_93 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_92 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_92 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_92;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_30 + tmp_kernel_op_74 - 3.0;
                const real_t tmp_kernel_op_95 = -jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_94 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_94 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_94;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_0*0.1381966011250105;
                const real_t tmp_kernel_op_97 = tmp_kernel_op_4*0.1381966011250105;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_8*0.5854101966249684;
                const real_t tmp_kernel_op_99 = tmp_kernel_op_12*0.1381966011250105;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_0*0.1381966011250105;
                const real_t tmp_kernel_op_101 = tmp_kernel_op_4*0.5854101966249684;
                const real_t tmp_kernel_op_102 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_103 = tmp_kernel_op_12*0.1381966011250105;
                const real_t tmp_kernel_op_104 = tmp_kernel_op_0*0.5854101966249684;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_4*0.1381966011250105;
                const real_t tmp_kernel_op_106 = tmp_kernel_op_8*0.1381966011250105;
                const real_t tmp_kernel_op_107 = tmp_kernel_op_12*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_1*tmp_kernel_op_89 + tmp_kernel_op_13*tmp_kernel_op_95 + tmp_kernel_op_5*tmp_kernel_op_91 + tmp_kernel_op_9*tmp_kernel_op_93) + src_dof_1*(-tmp_kernel_op_1*tmp_kernel_op_3 - tmp_kernel_op_11*tmp_kernel_op_9 - tmp_kernel_op_13*tmp_kernel_op_15 - tmp_kernel_op_5*tmp_kernel_op_7) + src_dof_2*(-tmp_kernel_op_1*tmp_kernel_op_17 - tmp_kernel_op_13*tmp_kernel_op_23 - tmp_kernel_op_19*tmp_kernel_op_5 - tmp_kernel_op_21*tmp_kernel_op_9) + src_dof_3*(-tmp_kernel_op_1*tmp_kernel_op_25 - tmp_kernel_op_13*tmp_kernel_op_31 - tmp_kernel_op_27*tmp_kernel_op_5 - tmp_kernel_op_29*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_1*tmp_kernel_op_34 + tmp_kernel_op_13*tmp_kernel_op_43 + tmp_kernel_op_37*tmp_kernel_op_5 + tmp_kernel_op_40*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_1*tmp_kernel_op_46 + tmp_kernel_op_13*tmp_kernel_op_55 + tmp_kernel_op_49*tmp_kernel_op_5 + tmp_kernel_op_52*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_1*tmp_kernel_op_58 + tmp_kernel_op_13*tmp_kernel_op_67 + tmp_kernel_op_5*tmp_kernel_op_61 + tmp_kernel_op_64*tmp_kernel_op_9) + src_dof_7*(tmp_kernel_op_1*tmp_kernel_op_69 + tmp_kernel_op_13*tmp_kernel_op_75 + tmp_kernel_op_5*tmp_kernel_op_71 + tmp_kernel_op_73*tmp_kernel_op_9) + src_dof_8*(tmp_kernel_op_1*tmp_kernel_op_77 + tmp_kernel_op_13*tmp_kernel_op_83 + tmp_kernel_op_5*tmp_kernel_op_79 + tmp_kernel_op_81*tmp_kernel_op_9) + src_dof_9*(tmp_kernel_op_1*tmp_kernel_op_84 + tmp_kernel_op_13*tmp_kernel_op_87 + tmp_kernel_op_5*tmp_kernel_op_85 + tmp_kernel_op_86*tmp_kernel_op_9);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_89*tmp_kernel_op_96 + tmp_kernel_op_91*tmp_kernel_op_97 + tmp_kernel_op_93*tmp_kernel_op_98 + tmp_kernel_op_95*tmp_kernel_op_99) + src_dof_1*(-tmp_kernel_op_11*tmp_kernel_op_98 - tmp_kernel_op_15*tmp_kernel_op_99 - tmp_kernel_op_3*tmp_kernel_op_96 - tmp_kernel_op_7*tmp_kernel_op_97) + src_dof_2*(-tmp_kernel_op_17*tmp_kernel_op_96 - tmp_kernel_op_19*tmp_kernel_op_97 - tmp_kernel_op_21*tmp_kernel_op_98 - tmp_kernel_op_23*tmp_kernel_op_99) + src_dof_3*(-tmp_kernel_op_25*tmp_kernel_op_96 - tmp_kernel_op_27*tmp_kernel_op_97 - tmp_kernel_op_29*tmp_kernel_op_98 - tmp_kernel_op_31*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_34*tmp_kernel_op_96 + tmp_kernel_op_37*tmp_kernel_op_97 + tmp_kernel_op_40*tmp_kernel_op_98 + tmp_kernel_op_43*tmp_kernel_op_99) + src_dof_5*(tmp_kernel_op_46*tmp_kernel_op_96 + tmp_kernel_op_49*tmp_kernel_op_97 + tmp_kernel_op_52*tmp_kernel_op_98 + tmp_kernel_op_55*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_58*tmp_kernel_op_96 + tmp_kernel_op_61*tmp_kernel_op_97 + tmp_kernel_op_64*tmp_kernel_op_98 + tmp_kernel_op_67*tmp_kernel_op_99) + src_dof_7*(tmp_kernel_op_69*tmp_kernel_op_96 + tmp_kernel_op_71*tmp_kernel_op_97 + tmp_kernel_op_73*tmp_kernel_op_98 + tmp_kernel_op_75*tmp_kernel_op_99) + src_dof_8*(tmp_kernel_op_77*tmp_kernel_op_96 + tmp_kernel_op_79*tmp_kernel_op_97 + tmp_kernel_op_81*tmp_kernel_op_98 + tmp_kernel_op_83*tmp_kernel_op_99) + src_dof_9*(tmp_kernel_op_84*tmp_kernel_op_96 + tmp_kernel_op_85*tmp_kernel_op_97 + tmp_kernel_op_86*tmp_kernel_op_98 + tmp_kernel_op_87*tmp_kernel_op_99);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_89 + tmp_kernel_op_101*tmp_kernel_op_91 + tmp_kernel_op_102*tmp_kernel_op_93 + tmp_kernel_op_103*tmp_kernel_op_95) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_3 - tmp_kernel_op_101*tmp_kernel_op_7 - tmp_kernel_op_102*tmp_kernel_op_11 - tmp_kernel_op_103*tmp_kernel_op_15) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_17 - tmp_kernel_op_101*tmp_kernel_op_19 - tmp_kernel_op_102*tmp_kernel_op_21 - tmp_kernel_op_103*tmp_kernel_op_23) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_25 - tmp_kernel_op_101*tmp_kernel_op_27 - tmp_kernel_op_102*tmp_kernel_op_29 - tmp_kernel_op_103*tmp_kernel_op_31) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_34 + tmp_kernel_op_101*tmp_kernel_op_37 + tmp_kernel_op_102*tmp_kernel_op_40 + tmp_kernel_op_103*tmp_kernel_op_43) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_46 + tmp_kernel_op_101*tmp_kernel_op_49 + tmp_kernel_op_102*tmp_kernel_op_52 + tmp_kernel_op_103*tmp_kernel_op_55) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_58 + tmp_kernel_op_101*tmp_kernel_op_61 + tmp_kernel_op_102*tmp_kernel_op_64 + tmp_kernel_op_103*tmp_kernel_op_67) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_69 + tmp_kernel_op_101*tmp_kernel_op_71 + tmp_kernel_op_102*tmp_kernel_op_73 + tmp_kernel_op_103*tmp_kernel_op_75) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_77 + tmp_kernel_op_101*tmp_kernel_op_79 + tmp_kernel_op_102*tmp_kernel_op_81 + tmp_kernel_op_103*tmp_kernel_op_83) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_84 + tmp_kernel_op_101*tmp_kernel_op_85 + tmp_kernel_op_102*tmp_kernel_op_86 + tmp_kernel_op_103*tmp_kernel_op_87);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_104*tmp_kernel_op_89 + tmp_kernel_op_105*tmp_kernel_op_91 + tmp_kernel_op_106*tmp_kernel_op_93 + tmp_kernel_op_107*tmp_kernel_op_95) + src_dof_1*(-tmp_kernel_op_104*tmp_kernel_op_3 - tmp_kernel_op_105*tmp_kernel_op_7 - tmp_kernel_op_106*tmp_kernel_op_11 - tmp_kernel_op_107*tmp_kernel_op_15) + src_dof_2*(-tmp_kernel_op_104*tmp_kernel_op_17 - tmp_kernel_op_105*tmp_kernel_op_19 - tmp_kernel_op_106*tmp_kernel_op_21 - tmp_kernel_op_107*tmp_kernel_op_23) + src_dof_3*(-tmp_kernel_op_104*tmp_kernel_op_25 - tmp_kernel_op_105*tmp_kernel_op_27 - tmp_kernel_op_106*tmp_kernel_op_29 - tmp_kernel_op_107*tmp_kernel_op_31) + src_dof_4*(tmp_kernel_op_104*tmp_kernel_op_34 + tmp_kernel_op_105*tmp_kernel_op_37 + tmp_kernel_op_106*tmp_kernel_op_40 + tmp_kernel_op_107*tmp_kernel_op_43) + src_dof_5*(tmp_kernel_op_104*tmp_kernel_op_46 + tmp_kernel_op_105*tmp_kernel_op_49 + tmp_kernel_op_106*tmp_kernel_op_52 + tmp_kernel_op_107*tmp_kernel_op_55) + src_dof_6*(tmp_kernel_op_104*tmp_kernel_op_58 + tmp_kernel_op_105*tmp_kernel_op_61 + tmp_kernel_op_106*tmp_kernel_op_64 + tmp_kernel_op_107*tmp_kernel_op_67) + src_dof_7*(tmp_kernel_op_104*tmp_kernel_op_69 + tmp_kernel_op_105*tmp_kernel_op_71 + tmp_kernel_op_106*tmp_kernel_op_73 + tmp_kernel_op_107*tmp_kernel_op_75) + src_dof_8*(tmp_kernel_op_104*tmp_kernel_op_77 + tmp_kernel_op_105*tmp_kernel_op_79 + tmp_kernel_op_106*tmp_kernel_op_81 + tmp_kernel_op_107*tmp_kernel_op_83) + src_dof_9*(tmp_kernel_op_104*tmp_kernel_op_84 + tmp_kernel_op_105*tmp_kernel_op_85 + tmp_kernel_op_106*tmp_kernel_op_86 + tmp_kernel_op_107*tmp_kernel_op_87);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   }
                }
                const real_t tmp_moved_constant_490 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_491 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_492 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_493 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_494 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_495 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_496 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_497 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_498 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_499 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_500 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
                const real_t tmp_moved_constant_501 = tmp_moved_constant_500*0.13819660112501053;
                const real_t tmp_moved_constant_502 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_2 - 1.0);
                const real_t tmp_moved_constant_503 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
                const real_t tmp_moved_constant_504 = tmp_moved_constant_503*0.13819660112501056;
                const real_t tmp_moved_constant_505 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_6 - 1.0);
                const real_t tmp_moved_constant_506 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
                const real_t tmp_moved_constant_507 = tmp_moved_constant_506*0.13819660112501056;
                const real_t tmp_moved_constant_508 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_10 - 1.0);
                const real_t tmp_moved_constant_509 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
                const real_t tmp_moved_constant_510 = tmp_moved_constant_509*0.5854101966249684;
                const real_t tmp_moved_constant_511 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_14 - 1.0);
                const real_t tmp_moved_constant_512 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_16 - 1.0);
                const real_t tmp_moved_constant_513 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_18 - 1.0);
                const real_t tmp_moved_constant_514 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_20 - 1.0);
                const real_t tmp_moved_constant_515 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_22 - 1.0);
                const real_t tmp_moved_constant_516 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_24 - 1.0);
                const real_t tmp_moved_constant_517 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_26 - 1.0);
                const real_t tmp_moved_constant_518 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_28 - 1.0);
                const real_t tmp_moved_constant_519 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_30 - 1.0);
                const real_t tmp_moved_constant_520 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_24;
                const real_t tmp_moved_constant_521 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_16;
                const real_t tmp_moved_constant_522 = -tmp_moved_constant_520 - tmp_moved_constant_521;
                const real_t tmp_moved_constant_523 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_26;
                const real_t tmp_moved_constant_524 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_18;
                const real_t tmp_moved_constant_525 = -tmp_moved_constant_523 - tmp_moved_constant_524;
                const real_t tmp_moved_constant_526 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_28;
                const real_t tmp_moved_constant_527 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_20;
                const real_t tmp_moved_constant_528 = -tmp_moved_constant_526 - tmp_moved_constant_527;
                const real_t tmp_moved_constant_529 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_30;
                const real_t tmp_moved_constant_530 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_22;
                const real_t tmp_moved_constant_531 = -tmp_moved_constant_529 - tmp_moved_constant_530;
                const real_t tmp_moved_constant_532 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_24;
                const real_t tmp_moved_constant_533 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_2;
                const real_t tmp_moved_constant_534 = -tmp_moved_constant_532 - tmp_moved_constant_533;
                const real_t tmp_moved_constant_535 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_26;
                const real_t tmp_moved_constant_536 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_6;
                const real_t tmp_moved_constant_537 = -tmp_moved_constant_535 - tmp_moved_constant_536;
                const real_t tmp_moved_constant_538 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_28;
                const real_t tmp_moved_constant_539 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_10;
                const real_t tmp_moved_constant_540 = -tmp_moved_constant_538 - tmp_moved_constant_539;
                const real_t tmp_moved_constant_541 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_30;
                const real_t tmp_moved_constant_542 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_14;
                const real_t tmp_moved_constant_543 = -tmp_moved_constant_541 - tmp_moved_constant_542;
                const real_t tmp_moved_constant_544 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_16;
                const real_t tmp_moved_constant_545 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_2;
                const real_t tmp_moved_constant_546 = -tmp_moved_constant_544 - tmp_moved_constant_545;
                const real_t tmp_moved_constant_547 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_18;
                const real_t tmp_moved_constant_548 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_6;
                const real_t tmp_moved_constant_549 = -tmp_moved_constant_547 - tmp_moved_constant_548;
                const real_t tmp_moved_constant_550 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_20;
                const real_t tmp_moved_constant_551 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_10;
                const real_t tmp_moved_constant_552 = -tmp_moved_constant_550 - tmp_moved_constant_551;
                const real_t tmp_moved_constant_553 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_22;
                const real_t tmp_moved_constant_554 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_14;
                const real_t tmp_moved_constant_555 = -tmp_moved_constant_553 - tmp_moved_constant_554;
                const real_t tmp_moved_constant_556 = -jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_520 + tmp_moved_constant_532;
                const real_t tmp_moved_constant_557 = -jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_523 + tmp_moved_constant_535;
                const real_t tmp_moved_constant_558 = -jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_526 + tmp_moved_constant_538;
                const real_t tmp_moved_constant_559 = -jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_529 + tmp_moved_constant_541;
                const real_t tmp_moved_constant_560 = -jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_521 + tmp_moved_constant_544;
                const real_t tmp_moved_constant_561 = -jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_524 + tmp_moved_constant_547;
                const real_t tmp_moved_constant_562 = -jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_527 + tmp_moved_constant_550;
                const real_t tmp_moved_constant_563 = -jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_530 + tmp_moved_constant_553;
                const real_t tmp_moved_constant_564 = -jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_533 + tmp_moved_constant_545;
                const real_t tmp_moved_constant_565 = -jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_536 + tmp_moved_constant_548;
                const real_t tmp_moved_constant_566 = -jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_539 + tmp_moved_constant_551;
                const real_t tmp_moved_constant_567 = -jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_542 + tmp_moved_constant_554;
                const real_t tmp_moved_constant_568 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_88 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_88 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_88;
                const real_t tmp_moved_constant_569 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_90 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_90 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_90;
                const real_t tmp_moved_constant_570 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_92 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_92 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_92;
                const real_t tmp_moved_constant_571 = -jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_94 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_94 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_94;
                const real_t tmp_moved_constant_572 = tmp_moved_constant_500*0.1381966011250105;
                const real_t tmp_moved_constant_573 = tmp_moved_constant_503*0.1381966011250105;
                const real_t tmp_moved_constant_574 = tmp_moved_constant_506*0.5854101966249684;
                const real_t tmp_moved_constant_575 = tmp_moved_constant_509*0.1381966011250105;
                const real_t tmp_moved_constant_576 = tmp_moved_constant_500*0.1381966011250105;
                const real_t tmp_moved_constant_577 = tmp_moved_constant_503*0.5854101966249684;
                const real_t tmp_moved_constant_578 = tmp_moved_constant_506*0.1381966011250105;
                const real_t tmp_moved_constant_579 = tmp_moved_constant_509*0.1381966011250105;
                const real_t tmp_moved_constant_580 = tmp_moved_constant_500*0.5854101966249684;
                const real_t tmp_moved_constant_581 = tmp_moved_constant_503*0.1381966011250105;
                const real_t tmp_moved_constant_582 = tmp_moved_constant_506*0.1381966011250105;
                const real_t tmp_moved_constant_583 = tmp_moved_constant_509*0.1381966011250105;
                const real_t tmp_moved_constant_584 = tmp_moved_constant_490*(tmp_moved_constant_501*tmp_moved_constant_568 + tmp_moved_constant_504*tmp_moved_constant_569 + tmp_moved_constant_507*tmp_moved_constant_570 + tmp_moved_constant_510*tmp_moved_constant_571) + tmp_moved_constant_491*(-tmp_moved_constant_501*tmp_moved_constant_502 - tmp_moved_constant_504*tmp_moved_constant_505 - tmp_moved_constant_507*tmp_moved_constant_508 - tmp_moved_constant_510*tmp_moved_constant_511) + tmp_moved_constant_492*(-tmp_moved_constant_501*tmp_moved_constant_512 - tmp_moved_constant_504*tmp_moved_constant_513 - tmp_moved_constant_507*tmp_moved_constant_514 - tmp_moved_constant_510*tmp_moved_constant_515) + tmp_moved_constant_493*(-tmp_moved_constant_501*tmp_moved_constant_516 - tmp_moved_constant_504*tmp_moved_constant_517 - tmp_moved_constant_507*tmp_moved_constant_518 - tmp_moved_constant_510*tmp_moved_constant_519) + tmp_moved_constant_494*(tmp_moved_constant_501*tmp_moved_constant_522 + tmp_moved_constant_504*tmp_moved_constant_525 + tmp_moved_constant_507*tmp_moved_constant_528 + tmp_moved_constant_510*tmp_moved_constant_531) + tmp_moved_constant_495*(tmp_moved_constant_501*tmp_moved_constant_534 + tmp_moved_constant_504*tmp_moved_constant_537 + tmp_moved_constant_507*tmp_moved_constant_540 + tmp_moved_constant_510*tmp_moved_constant_543) + tmp_moved_constant_496*(tmp_moved_constant_501*tmp_moved_constant_546 + tmp_moved_constant_504*tmp_moved_constant_549 + tmp_moved_constant_507*tmp_moved_constant_552 + tmp_moved_constant_510*tmp_moved_constant_555) + tmp_moved_constant_497*(tmp_moved_constant_501*tmp_moved_constant_556 + tmp_moved_constant_504*tmp_moved_constant_557 + tmp_moved_constant_507*tmp_moved_constant_558 + tmp_moved_constant_510*tmp_moved_constant_559) + tmp_moved_constant_498*(tmp_moved_constant_501*tmp_moved_constant_560 + tmp_moved_constant_504*tmp_moved_constant_561 + tmp_moved_constant_507*tmp_moved_constant_562 + tmp_moved_constant_510*tmp_moved_constant_563) + tmp_moved_constant_499*(tmp_moved_constant_501*tmp_moved_constant_564 + tmp_moved_constant_504*tmp_moved_constant_565 + tmp_moved_constant_507*tmp_moved_constant_566 + tmp_moved_constant_510*tmp_moved_constant_567);
                const real_t tmp_moved_constant_585 = tmp_moved_constant_490*(tmp_moved_constant_568*tmp_moved_constant_572 + tmp_moved_constant_569*tmp_moved_constant_573 + tmp_moved_constant_570*tmp_moved_constant_574 + tmp_moved_constant_571*tmp_moved_constant_575) + tmp_moved_constant_491*(-tmp_moved_constant_502*tmp_moved_constant_572 - tmp_moved_constant_505*tmp_moved_constant_573 - tmp_moved_constant_508*tmp_moved_constant_574 - tmp_moved_constant_511*tmp_moved_constant_575) + tmp_moved_constant_492*(-tmp_moved_constant_512*tmp_moved_constant_572 - tmp_moved_constant_513*tmp_moved_constant_573 - tmp_moved_constant_514*tmp_moved_constant_574 - tmp_moved_constant_515*tmp_moved_constant_575) + tmp_moved_constant_493*(-tmp_moved_constant_516*tmp_moved_constant_572 - tmp_moved_constant_517*tmp_moved_constant_573 - tmp_moved_constant_518*tmp_moved_constant_574 - tmp_moved_constant_519*tmp_moved_constant_575) + tmp_moved_constant_494*(tmp_moved_constant_522*tmp_moved_constant_572 + tmp_moved_constant_525*tmp_moved_constant_573 + tmp_moved_constant_528*tmp_moved_constant_574 + tmp_moved_constant_531*tmp_moved_constant_575) + tmp_moved_constant_495*(tmp_moved_constant_534*tmp_moved_constant_572 + tmp_moved_constant_537*tmp_moved_constant_573 + tmp_moved_constant_540*tmp_moved_constant_574 + tmp_moved_constant_543*tmp_moved_constant_575) + tmp_moved_constant_496*(tmp_moved_constant_546*tmp_moved_constant_572 + tmp_moved_constant_549*tmp_moved_constant_573 + tmp_moved_constant_552*tmp_moved_constant_574 + tmp_moved_constant_555*tmp_moved_constant_575) + tmp_moved_constant_497*(tmp_moved_constant_556*tmp_moved_constant_572 + tmp_moved_constant_557*tmp_moved_constant_573 + tmp_moved_constant_558*tmp_moved_constant_574 + tmp_moved_constant_559*tmp_moved_constant_575) + tmp_moved_constant_498*(tmp_moved_constant_560*tmp_moved_constant_572 + tmp_moved_constant_561*tmp_moved_constant_573 + tmp_moved_constant_562*tmp_moved_constant_574 + tmp_moved_constant_563*tmp_moved_constant_575) + tmp_moved_constant_499*(tmp_moved_constant_564*tmp_moved_constant_572 + tmp_moved_constant_565*tmp_moved_constant_573 + tmp_moved_constant_566*tmp_moved_constant_574 + tmp_moved_constant_567*tmp_moved_constant_575);
                const real_t tmp_moved_constant_586 = tmp_moved_constant_490*(tmp_moved_constant_568*tmp_moved_constant_576 + tmp_moved_constant_569*tmp_moved_constant_577 + tmp_moved_constant_570*tmp_moved_constant_578 + tmp_moved_constant_571*tmp_moved_constant_579) + tmp_moved_constant_491*(-tmp_moved_constant_502*tmp_moved_constant_576 - tmp_moved_constant_505*tmp_moved_constant_577 - tmp_moved_constant_508*tmp_moved_constant_578 - tmp_moved_constant_511*tmp_moved_constant_579) + tmp_moved_constant_492*(-tmp_moved_constant_512*tmp_moved_constant_576 - tmp_moved_constant_513*tmp_moved_constant_577 - tmp_moved_constant_514*tmp_moved_constant_578 - tmp_moved_constant_515*tmp_moved_constant_579) + tmp_moved_constant_493*(-tmp_moved_constant_516*tmp_moved_constant_576 - tmp_moved_constant_517*tmp_moved_constant_577 - tmp_moved_constant_518*tmp_moved_constant_578 - tmp_moved_constant_519*tmp_moved_constant_579) + tmp_moved_constant_494*(tmp_moved_constant_522*tmp_moved_constant_576 + tmp_moved_constant_525*tmp_moved_constant_577 + tmp_moved_constant_528*tmp_moved_constant_578 + tmp_moved_constant_531*tmp_moved_constant_579) + tmp_moved_constant_495*(tmp_moved_constant_534*tmp_moved_constant_576 + tmp_moved_constant_537*tmp_moved_constant_577 + tmp_moved_constant_540*tmp_moved_constant_578 + tmp_moved_constant_543*tmp_moved_constant_579) + tmp_moved_constant_496*(tmp_moved_constant_546*tmp_moved_constant_576 + tmp_moved_constant_549*tmp_moved_constant_577 + tmp_moved_constant_552*tmp_moved_constant_578 + tmp_moved_constant_555*tmp_moved_constant_579) + tmp_moved_constant_497*(tmp_moved_constant_556*tmp_moved_constant_576 + tmp_moved_constant_557*tmp_moved_constant_577 + tmp_moved_constant_558*tmp_moved_constant_578 + tmp_moved_constant_559*tmp_moved_constant_579) + tmp_moved_constant_498*(tmp_moved_constant_560*tmp_moved_constant_576 + tmp_moved_constant_561*tmp_moved_constant_577 + tmp_moved_constant_562*tmp_moved_constant_578 + tmp_moved_constant_563*tmp_moved_constant_579) + tmp_moved_constant_499*(tmp_moved_constant_564*tmp_moved_constant_576 + tmp_moved_constant_565*tmp_moved_constant_577 + tmp_moved_constant_566*tmp_moved_constant_578 + tmp_moved_constant_567*tmp_moved_constant_579);
                const real_t tmp_moved_constant_587 = tmp_moved_constant_490*(tmp_moved_constant_568*tmp_moved_constant_580 + tmp_moved_constant_569*tmp_moved_constant_581 + tmp_moved_constant_570*tmp_moved_constant_582 + tmp_moved_constant_571*tmp_moved_constant_583) + tmp_moved_constant_491*(-tmp_moved_constant_502*tmp_moved_constant_580 - tmp_moved_constant_505*tmp_moved_constant_581 - tmp_moved_constant_508*tmp_moved_constant_582 - tmp_moved_constant_511*tmp_moved_constant_583) + tmp_moved_constant_492*(-tmp_moved_constant_512*tmp_moved_constant_580 - tmp_moved_constant_513*tmp_moved_constant_581 - tmp_moved_constant_514*tmp_moved_constant_582 - tmp_moved_constant_515*tmp_moved_constant_583) + tmp_moved_constant_493*(-tmp_moved_constant_516*tmp_moved_constant_580 - tmp_moved_constant_517*tmp_moved_constant_581 - tmp_moved_constant_518*tmp_moved_constant_582 - tmp_moved_constant_519*tmp_moved_constant_583) + tmp_moved_constant_494*(tmp_moved_constant_522*tmp_moved_constant_580 + tmp_moved_constant_525*tmp_moved_constant_581 + tmp_moved_constant_528*tmp_moved_constant_582 + tmp_moved_constant_531*tmp_moved_constant_583) + tmp_moved_constant_495*(tmp_moved_constant_534*tmp_moved_constant_580 + tmp_moved_constant_537*tmp_moved_constant_581 + tmp_moved_constant_540*tmp_moved_constant_582 + tmp_moved_constant_543*tmp_moved_constant_583) + tmp_moved_constant_496*(tmp_moved_constant_546*tmp_moved_constant_580 + tmp_moved_constant_549*tmp_moved_constant_581 + tmp_moved_constant_552*tmp_moved_constant_582 + tmp_moved_constant_555*tmp_moved_constant_583) + tmp_moved_constant_497*(tmp_moved_constant_556*tmp_moved_constant_580 + tmp_moved_constant_557*tmp_moved_constant_581 + tmp_moved_constant_558*tmp_moved_constant_582 + tmp_moved_constant_559*tmp_moved_constant_583) + tmp_moved_constant_498*(tmp_moved_constant_560*tmp_moved_constant_580 + tmp_moved_constant_561*tmp_moved_constant_581 + tmp_moved_constant_562*tmp_moved_constant_582 + tmp_moved_constant_563*tmp_moved_constant_583) + tmp_moved_constant_499*(tmp_moved_constant_564*tmp_moved_constant_580 + tmp_moved_constant_565*tmp_moved_constant_581 + tmp_moved_constant_566*tmp_moved_constant_582 + tmp_moved_constant_567*tmp_moved_constant_583);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_584 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_585 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_586 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_587 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   }
                }
                const real_t tmp_moved_constant_588 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_589 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_590 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_591 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_592 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_593 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_594 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_595 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_596 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_597 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_598 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
                const real_t tmp_moved_constant_599 = tmp_moved_constant_598*0.13819660112501053;
                const real_t tmp_moved_constant_600 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_2 - 1.0);
                const real_t tmp_moved_constant_601 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
                const real_t tmp_moved_constant_602 = tmp_moved_constant_601*0.13819660112501056;
                const real_t tmp_moved_constant_603 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_6 - 1.0);
                const real_t tmp_moved_constant_604 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
                const real_t tmp_moved_constant_605 = tmp_moved_constant_604*0.13819660112501056;
                const real_t tmp_moved_constant_606 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_10 - 1.0);
                const real_t tmp_moved_constant_607 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
                const real_t tmp_moved_constant_608 = tmp_moved_constant_607*0.5854101966249684;
                const real_t tmp_moved_constant_609 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_14 - 1.0);
                const real_t tmp_moved_constant_610 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_16 - 1.0);
                const real_t tmp_moved_constant_611 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_18 - 1.0);
                const real_t tmp_moved_constant_612 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_20 - 1.0);
                const real_t tmp_moved_constant_613 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_22 - 1.0);
                const real_t tmp_moved_constant_614 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_24 - 1.0);
                const real_t tmp_moved_constant_615 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_26 - 1.0);
                const real_t tmp_moved_constant_616 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_28 - 1.0);
                const real_t tmp_moved_constant_617 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_30 - 1.0);
                const real_t tmp_moved_constant_618 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_24;
                const real_t tmp_moved_constant_619 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_16;
                const real_t tmp_moved_constant_620 = -tmp_moved_constant_618 - tmp_moved_constant_619;
                const real_t tmp_moved_constant_621 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_26;
                const real_t tmp_moved_constant_622 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_18;
                const real_t tmp_moved_constant_623 = -tmp_moved_constant_621 - tmp_moved_constant_622;
                const real_t tmp_moved_constant_624 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_28;
                const real_t tmp_moved_constant_625 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_20;
                const real_t tmp_moved_constant_626 = -tmp_moved_constant_624 - tmp_moved_constant_625;
                const real_t tmp_moved_constant_627 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_30;
                const real_t tmp_moved_constant_628 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_22;
                const real_t tmp_moved_constant_629 = -tmp_moved_constant_627 - tmp_moved_constant_628;
                const real_t tmp_moved_constant_630 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_24;
                const real_t tmp_moved_constant_631 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_2;
                const real_t tmp_moved_constant_632 = -tmp_moved_constant_630 - tmp_moved_constant_631;
                const real_t tmp_moved_constant_633 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_26;
                const real_t tmp_moved_constant_634 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_6;
                const real_t tmp_moved_constant_635 = -tmp_moved_constant_633 - tmp_moved_constant_634;
                const real_t tmp_moved_constant_636 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_28;
                const real_t tmp_moved_constant_637 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_10;
                const real_t tmp_moved_constant_638 = -tmp_moved_constant_636 - tmp_moved_constant_637;
                const real_t tmp_moved_constant_639 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_30;
                const real_t tmp_moved_constant_640 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_14;
                const real_t tmp_moved_constant_641 = -tmp_moved_constant_639 - tmp_moved_constant_640;
                const real_t tmp_moved_constant_642 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_16;
                const real_t tmp_moved_constant_643 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_2;
                const real_t tmp_moved_constant_644 = -tmp_moved_constant_642 - tmp_moved_constant_643;
                const real_t tmp_moved_constant_645 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_18;
                const real_t tmp_moved_constant_646 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_6;
                const real_t tmp_moved_constant_647 = -tmp_moved_constant_645 - tmp_moved_constant_646;
                const real_t tmp_moved_constant_648 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_20;
                const real_t tmp_moved_constant_649 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_10;
                const real_t tmp_moved_constant_650 = -tmp_moved_constant_648 - tmp_moved_constant_649;
                const real_t tmp_moved_constant_651 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_22;
                const real_t tmp_moved_constant_652 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_14;
                const real_t tmp_moved_constant_653 = -tmp_moved_constant_651 - tmp_moved_constant_652;
                const real_t tmp_moved_constant_654 = -jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_618 + tmp_moved_constant_630;
                const real_t tmp_moved_constant_655 = -jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_621 + tmp_moved_constant_633;
                const real_t tmp_moved_constant_656 = -jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_624 + tmp_moved_constant_636;
                const real_t tmp_moved_constant_657 = -jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_627 + tmp_moved_constant_639;
                const real_t tmp_moved_constant_658 = -jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_619 + tmp_moved_constant_642;
                const real_t tmp_moved_constant_659 = -jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_622 + tmp_moved_constant_645;
                const real_t tmp_moved_constant_660 = -jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_625 + tmp_moved_constant_648;
                const real_t tmp_moved_constant_661 = -jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_628 + tmp_moved_constant_651;
                const real_t tmp_moved_constant_662 = -jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_631 + tmp_moved_constant_643;
                const real_t tmp_moved_constant_663 = -jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_634 + tmp_moved_constant_646;
                const real_t tmp_moved_constant_664 = -jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_637 + tmp_moved_constant_649;
                const real_t tmp_moved_constant_665 = -jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_640 + tmp_moved_constant_652;
                const real_t tmp_moved_constant_666 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_88 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_88 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_88;
                const real_t tmp_moved_constant_667 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_90 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_90 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_90;
                const real_t tmp_moved_constant_668 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_92 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_92 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_92;
                const real_t tmp_moved_constant_669 = -jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_94 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_94 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_94;
                const real_t tmp_moved_constant_670 = tmp_moved_constant_598*0.1381966011250105;
                const real_t tmp_moved_constant_671 = tmp_moved_constant_601*0.1381966011250105;
                const real_t tmp_moved_constant_672 = tmp_moved_constant_604*0.5854101966249684;
                const real_t tmp_moved_constant_673 = tmp_moved_constant_607*0.1381966011250105;
                const real_t tmp_moved_constant_674 = tmp_moved_constant_598*0.1381966011250105;
                const real_t tmp_moved_constant_675 = tmp_moved_constant_601*0.5854101966249684;
                const real_t tmp_moved_constant_676 = tmp_moved_constant_604*0.1381966011250105;
                const real_t tmp_moved_constant_677 = tmp_moved_constant_607*0.1381966011250105;
                const real_t tmp_moved_constant_678 = tmp_moved_constant_598*0.5854101966249684;
                const real_t tmp_moved_constant_679 = tmp_moved_constant_601*0.1381966011250105;
                const real_t tmp_moved_constant_680 = tmp_moved_constant_604*0.1381966011250105;
                const real_t tmp_moved_constant_681 = tmp_moved_constant_607*0.1381966011250105;
                const real_t tmp_moved_constant_682 = tmp_moved_constant_588*(tmp_moved_constant_599*tmp_moved_constant_666 + tmp_moved_constant_602*tmp_moved_constant_667 + tmp_moved_constant_605*tmp_moved_constant_668 + tmp_moved_constant_608*tmp_moved_constant_669) + tmp_moved_constant_589*(-tmp_moved_constant_599*tmp_moved_constant_600 - tmp_moved_constant_602*tmp_moved_constant_603 - tmp_moved_constant_605*tmp_moved_constant_606 - tmp_moved_constant_608*tmp_moved_constant_609) + tmp_moved_constant_590*(-tmp_moved_constant_599*tmp_moved_constant_610 - tmp_moved_constant_602*tmp_moved_constant_611 - tmp_moved_constant_605*tmp_moved_constant_612 - tmp_moved_constant_608*tmp_moved_constant_613) + tmp_moved_constant_591*(-tmp_moved_constant_599*tmp_moved_constant_614 - tmp_moved_constant_602*tmp_moved_constant_615 - tmp_moved_constant_605*tmp_moved_constant_616 - tmp_moved_constant_608*tmp_moved_constant_617) + tmp_moved_constant_592*(tmp_moved_constant_599*tmp_moved_constant_620 + tmp_moved_constant_602*tmp_moved_constant_623 + tmp_moved_constant_605*tmp_moved_constant_626 + tmp_moved_constant_608*tmp_moved_constant_629) + tmp_moved_constant_593*(tmp_moved_constant_599*tmp_moved_constant_632 + tmp_moved_constant_602*tmp_moved_constant_635 + tmp_moved_constant_605*tmp_moved_constant_638 + tmp_moved_constant_608*tmp_moved_constant_641) + tmp_moved_constant_594*(tmp_moved_constant_599*tmp_moved_constant_644 + tmp_moved_constant_602*tmp_moved_constant_647 + tmp_moved_constant_605*tmp_moved_constant_650 + tmp_moved_constant_608*tmp_moved_constant_653) + tmp_moved_constant_595*(tmp_moved_constant_599*tmp_moved_constant_654 + tmp_moved_constant_602*tmp_moved_constant_655 + tmp_moved_constant_605*tmp_moved_constant_656 + tmp_moved_constant_608*tmp_moved_constant_657) + tmp_moved_constant_596*(tmp_moved_constant_599*tmp_moved_constant_658 + tmp_moved_constant_602*tmp_moved_constant_659 + tmp_moved_constant_605*tmp_moved_constant_660 + tmp_moved_constant_608*tmp_moved_constant_661) + tmp_moved_constant_597*(tmp_moved_constant_599*tmp_moved_constant_662 + tmp_moved_constant_602*tmp_moved_constant_663 + tmp_moved_constant_605*tmp_moved_constant_664 + tmp_moved_constant_608*tmp_moved_constant_665);
                const real_t tmp_moved_constant_683 = tmp_moved_constant_588*(tmp_moved_constant_666*tmp_moved_constant_670 + tmp_moved_constant_667*tmp_moved_constant_671 + tmp_moved_constant_668*tmp_moved_constant_672 + tmp_moved_constant_669*tmp_moved_constant_673) + tmp_moved_constant_589*(-tmp_moved_constant_600*tmp_moved_constant_670 - tmp_moved_constant_603*tmp_moved_constant_671 - tmp_moved_constant_606*tmp_moved_constant_672 - tmp_moved_constant_609*tmp_moved_constant_673) + tmp_moved_constant_590*(-tmp_moved_constant_610*tmp_moved_constant_670 - tmp_moved_constant_611*tmp_moved_constant_671 - tmp_moved_constant_612*tmp_moved_constant_672 - tmp_moved_constant_613*tmp_moved_constant_673) + tmp_moved_constant_591*(-tmp_moved_constant_614*tmp_moved_constant_670 - tmp_moved_constant_615*tmp_moved_constant_671 - tmp_moved_constant_616*tmp_moved_constant_672 - tmp_moved_constant_617*tmp_moved_constant_673) + tmp_moved_constant_592*(tmp_moved_constant_620*tmp_moved_constant_670 + tmp_moved_constant_623*tmp_moved_constant_671 + tmp_moved_constant_626*tmp_moved_constant_672 + tmp_moved_constant_629*tmp_moved_constant_673) + tmp_moved_constant_593*(tmp_moved_constant_632*tmp_moved_constant_670 + tmp_moved_constant_635*tmp_moved_constant_671 + tmp_moved_constant_638*tmp_moved_constant_672 + tmp_moved_constant_641*tmp_moved_constant_673) + tmp_moved_constant_594*(tmp_moved_constant_644*tmp_moved_constant_670 + tmp_moved_constant_647*tmp_moved_constant_671 + tmp_moved_constant_650*tmp_moved_constant_672 + tmp_moved_constant_653*tmp_moved_constant_673) + tmp_moved_constant_595*(tmp_moved_constant_654*tmp_moved_constant_670 + tmp_moved_constant_655*tmp_moved_constant_671 + tmp_moved_constant_656*tmp_moved_constant_672 + tmp_moved_constant_657*tmp_moved_constant_673) + tmp_moved_constant_596*(tmp_moved_constant_658*tmp_moved_constant_670 + tmp_moved_constant_659*tmp_moved_constant_671 + tmp_moved_constant_660*tmp_moved_constant_672 + tmp_moved_constant_661*tmp_moved_constant_673) + tmp_moved_constant_597*(tmp_moved_constant_662*tmp_moved_constant_670 + tmp_moved_constant_663*tmp_moved_constant_671 + tmp_moved_constant_664*tmp_moved_constant_672 + tmp_moved_constant_665*tmp_moved_constant_673);
                const real_t tmp_moved_constant_684 = tmp_moved_constant_588*(tmp_moved_constant_666*tmp_moved_constant_674 + tmp_moved_constant_667*tmp_moved_constant_675 + tmp_moved_constant_668*tmp_moved_constant_676 + tmp_moved_constant_669*tmp_moved_constant_677) + tmp_moved_constant_589*(-tmp_moved_constant_600*tmp_moved_constant_674 - tmp_moved_constant_603*tmp_moved_constant_675 - tmp_moved_constant_606*tmp_moved_constant_676 - tmp_moved_constant_609*tmp_moved_constant_677) + tmp_moved_constant_590*(-tmp_moved_constant_610*tmp_moved_constant_674 - tmp_moved_constant_611*tmp_moved_constant_675 - tmp_moved_constant_612*tmp_moved_constant_676 - tmp_moved_constant_613*tmp_moved_constant_677) + tmp_moved_constant_591*(-tmp_moved_constant_614*tmp_moved_constant_674 - tmp_moved_constant_615*tmp_moved_constant_675 - tmp_moved_constant_616*tmp_moved_constant_676 - tmp_moved_constant_617*tmp_moved_constant_677) + tmp_moved_constant_592*(tmp_moved_constant_620*tmp_moved_constant_674 + tmp_moved_constant_623*tmp_moved_constant_675 + tmp_moved_constant_626*tmp_moved_constant_676 + tmp_moved_constant_629*tmp_moved_constant_677) + tmp_moved_constant_593*(tmp_moved_constant_632*tmp_moved_constant_674 + tmp_moved_constant_635*tmp_moved_constant_675 + tmp_moved_constant_638*tmp_moved_constant_676 + tmp_moved_constant_641*tmp_moved_constant_677) + tmp_moved_constant_594*(tmp_moved_constant_644*tmp_moved_constant_674 + tmp_moved_constant_647*tmp_moved_constant_675 + tmp_moved_constant_650*tmp_moved_constant_676 + tmp_moved_constant_653*tmp_moved_constant_677) + tmp_moved_constant_595*(tmp_moved_constant_654*tmp_moved_constant_674 + tmp_moved_constant_655*tmp_moved_constant_675 + tmp_moved_constant_656*tmp_moved_constant_676 + tmp_moved_constant_657*tmp_moved_constant_677) + tmp_moved_constant_596*(tmp_moved_constant_658*tmp_moved_constant_674 + tmp_moved_constant_659*tmp_moved_constant_675 + tmp_moved_constant_660*tmp_moved_constant_676 + tmp_moved_constant_661*tmp_moved_constant_677) + tmp_moved_constant_597*(tmp_moved_constant_662*tmp_moved_constant_674 + tmp_moved_constant_663*tmp_moved_constant_675 + tmp_moved_constant_664*tmp_moved_constant_676 + tmp_moved_constant_665*tmp_moved_constant_677);
                const real_t tmp_moved_constant_685 = tmp_moved_constant_588*(tmp_moved_constant_666*tmp_moved_constant_678 + tmp_moved_constant_667*tmp_moved_constant_679 + tmp_moved_constant_668*tmp_moved_constant_680 + tmp_moved_constant_669*tmp_moved_constant_681) + tmp_moved_constant_589*(-tmp_moved_constant_600*tmp_moved_constant_678 - tmp_moved_constant_603*tmp_moved_constant_679 - tmp_moved_constant_606*tmp_moved_constant_680 - tmp_moved_constant_609*tmp_moved_constant_681) + tmp_moved_constant_590*(-tmp_moved_constant_610*tmp_moved_constant_678 - tmp_moved_constant_611*tmp_moved_constant_679 - tmp_moved_constant_612*tmp_moved_constant_680 - tmp_moved_constant_613*tmp_moved_constant_681) + tmp_moved_constant_591*(-tmp_moved_constant_614*tmp_moved_constant_678 - tmp_moved_constant_615*tmp_moved_constant_679 - tmp_moved_constant_616*tmp_moved_constant_680 - tmp_moved_constant_617*tmp_moved_constant_681) + tmp_moved_constant_592*(tmp_moved_constant_620*tmp_moved_constant_678 + tmp_moved_constant_623*tmp_moved_constant_679 + tmp_moved_constant_626*tmp_moved_constant_680 + tmp_moved_constant_629*tmp_moved_constant_681) + tmp_moved_constant_593*(tmp_moved_constant_632*tmp_moved_constant_678 + tmp_moved_constant_635*tmp_moved_constant_679 + tmp_moved_constant_638*tmp_moved_constant_680 + tmp_moved_constant_641*tmp_moved_constant_681) + tmp_moved_constant_594*(tmp_moved_constant_644*tmp_moved_constant_678 + tmp_moved_constant_647*tmp_moved_constant_679 + tmp_moved_constant_650*tmp_moved_constant_680 + tmp_moved_constant_653*tmp_moved_constant_681) + tmp_moved_constant_595*(tmp_moved_constant_654*tmp_moved_constant_678 + tmp_moved_constant_655*tmp_moved_constant_679 + tmp_moved_constant_656*tmp_moved_constant_680 + tmp_moved_constant_657*tmp_moved_constant_681) + tmp_moved_constant_596*(tmp_moved_constant_658*tmp_moved_constant_678 + tmp_moved_constant_659*tmp_moved_constant_679 + tmp_moved_constant_660*tmp_moved_constant_680 + tmp_moved_constant_661*tmp_moved_constant_681) + tmp_moved_constant_597*(tmp_moved_constant_662*tmp_moved_constant_678 + tmp_moved_constant_663*tmp_moved_constant_679 + tmp_moved_constant_664*tmp_moved_constant_680 + tmp_moved_constant_665*tmp_moved_constant_681);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_682 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_683 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_684 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_685 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   }
                }
                const real_t tmp_moved_constant_686 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_687 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_688 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_689 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_690 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_691 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_692 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_693 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_694 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_695 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_696 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
                const real_t tmp_moved_constant_697 = tmp_moved_constant_696*0.13819660112501053;
                const real_t tmp_moved_constant_698 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_2 - 1.0);
                const real_t tmp_moved_constant_699 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
                const real_t tmp_moved_constant_700 = tmp_moved_constant_699*0.13819660112501056;
                const real_t tmp_moved_constant_701 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_6 - 1.0);
                const real_t tmp_moved_constant_702 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
                const real_t tmp_moved_constant_703 = tmp_moved_constant_702*0.13819660112501056;
                const real_t tmp_moved_constant_704 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_10 - 1.0);
                const real_t tmp_moved_constant_705 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
                const real_t tmp_moved_constant_706 = tmp_moved_constant_705*0.5854101966249684;
                const real_t tmp_moved_constant_707 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_14 - 1.0);
                const real_t tmp_moved_constant_708 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_16 - 1.0);
                const real_t tmp_moved_constant_709 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_18 - 1.0);
                const real_t tmp_moved_constant_710 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_20 - 1.0);
                const real_t tmp_moved_constant_711 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_22 - 1.0);
                const real_t tmp_moved_constant_712 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_24 - 1.0);
                const real_t tmp_moved_constant_713 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_26 - 1.0);
                const real_t tmp_moved_constant_714 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_28 - 1.0);
                const real_t tmp_moved_constant_715 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_30 - 1.0);
                const real_t tmp_moved_constant_716 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_24;
                const real_t tmp_moved_constant_717 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_16;
                const real_t tmp_moved_constant_718 = -tmp_moved_constant_716 - tmp_moved_constant_717;
                const real_t tmp_moved_constant_719 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_26;
                const real_t tmp_moved_constant_720 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_18;
                const real_t tmp_moved_constant_721 = -tmp_moved_constant_719 - tmp_moved_constant_720;
                const real_t tmp_moved_constant_722 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_28;
                const real_t tmp_moved_constant_723 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_20;
                const real_t tmp_moved_constant_724 = -tmp_moved_constant_722 - tmp_moved_constant_723;
                const real_t tmp_moved_constant_725 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_30;
                const real_t tmp_moved_constant_726 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_22;
                const real_t tmp_moved_constant_727 = -tmp_moved_constant_725 - tmp_moved_constant_726;
                const real_t tmp_moved_constant_728 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_24;
                const real_t tmp_moved_constant_729 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_2;
                const real_t tmp_moved_constant_730 = -tmp_moved_constant_728 - tmp_moved_constant_729;
                const real_t tmp_moved_constant_731 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_26;
                const real_t tmp_moved_constant_732 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_6;
                const real_t tmp_moved_constant_733 = -tmp_moved_constant_731 - tmp_moved_constant_732;
                const real_t tmp_moved_constant_734 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_28;
                const real_t tmp_moved_constant_735 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_10;
                const real_t tmp_moved_constant_736 = -tmp_moved_constant_734 - tmp_moved_constant_735;
                const real_t tmp_moved_constant_737 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_30;
                const real_t tmp_moved_constant_738 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_14;
                const real_t tmp_moved_constant_739 = -tmp_moved_constant_737 - tmp_moved_constant_738;
                const real_t tmp_moved_constant_740 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_16;
                const real_t tmp_moved_constant_741 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_2;
                const real_t tmp_moved_constant_742 = -tmp_moved_constant_740 - tmp_moved_constant_741;
                const real_t tmp_moved_constant_743 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_18;
                const real_t tmp_moved_constant_744 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_6;
                const real_t tmp_moved_constant_745 = -tmp_moved_constant_743 - tmp_moved_constant_744;
                const real_t tmp_moved_constant_746 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_20;
                const real_t tmp_moved_constant_747 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_10;
                const real_t tmp_moved_constant_748 = -tmp_moved_constant_746 - tmp_moved_constant_747;
                const real_t tmp_moved_constant_749 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_22;
                const real_t tmp_moved_constant_750 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_14;
                const real_t tmp_moved_constant_751 = -tmp_moved_constant_749 - tmp_moved_constant_750;
                const real_t tmp_moved_constant_752 = -jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_716 + tmp_moved_constant_728;
                const real_t tmp_moved_constant_753 = -jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_719 + tmp_moved_constant_731;
                const real_t tmp_moved_constant_754 = -jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_722 + tmp_moved_constant_734;
                const real_t tmp_moved_constant_755 = -jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_725 + tmp_moved_constant_737;
                const real_t tmp_moved_constant_756 = -jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_717 + tmp_moved_constant_740;
                const real_t tmp_moved_constant_757 = -jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_720 + tmp_moved_constant_743;
                const real_t tmp_moved_constant_758 = -jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_723 + tmp_moved_constant_746;
                const real_t tmp_moved_constant_759 = -jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_726 + tmp_moved_constant_749;
                const real_t tmp_moved_constant_760 = -jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_729 + tmp_moved_constant_741;
                const real_t tmp_moved_constant_761 = -jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_732 + tmp_moved_constant_744;
                const real_t tmp_moved_constant_762 = -jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_735 + tmp_moved_constant_747;
                const real_t tmp_moved_constant_763 = -jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_738 + tmp_moved_constant_750;
                const real_t tmp_moved_constant_764 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_88 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_88 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_88;
                const real_t tmp_moved_constant_765 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_90 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_90 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_90;
                const real_t tmp_moved_constant_766 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_92 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_92 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_92;
                const real_t tmp_moved_constant_767 = -jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_94 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_94 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_94;
                const real_t tmp_moved_constant_768 = tmp_moved_constant_696*0.1381966011250105;
                const real_t tmp_moved_constant_769 = tmp_moved_constant_699*0.1381966011250105;
                const real_t tmp_moved_constant_770 = tmp_moved_constant_702*0.5854101966249684;
                const real_t tmp_moved_constant_771 = tmp_moved_constant_705*0.1381966011250105;
                const real_t tmp_moved_constant_772 = tmp_moved_constant_696*0.1381966011250105;
                const real_t tmp_moved_constant_773 = tmp_moved_constant_699*0.5854101966249684;
                const real_t tmp_moved_constant_774 = tmp_moved_constant_702*0.1381966011250105;
                const real_t tmp_moved_constant_775 = tmp_moved_constant_705*0.1381966011250105;
                const real_t tmp_moved_constant_776 = tmp_moved_constant_696*0.5854101966249684;
                const real_t tmp_moved_constant_777 = tmp_moved_constant_699*0.1381966011250105;
                const real_t tmp_moved_constant_778 = tmp_moved_constant_702*0.1381966011250105;
                const real_t tmp_moved_constant_779 = tmp_moved_constant_705*0.1381966011250105;
                const real_t tmp_moved_constant_780 = tmp_moved_constant_686*(tmp_moved_constant_697*tmp_moved_constant_764 + tmp_moved_constant_700*tmp_moved_constant_765 + tmp_moved_constant_703*tmp_moved_constant_766 + tmp_moved_constant_706*tmp_moved_constant_767) + tmp_moved_constant_687*(-tmp_moved_constant_697*tmp_moved_constant_698 - tmp_moved_constant_700*tmp_moved_constant_701 - tmp_moved_constant_703*tmp_moved_constant_704 - tmp_moved_constant_706*tmp_moved_constant_707) + tmp_moved_constant_688*(-tmp_moved_constant_697*tmp_moved_constant_708 - tmp_moved_constant_700*tmp_moved_constant_709 - tmp_moved_constant_703*tmp_moved_constant_710 - tmp_moved_constant_706*tmp_moved_constant_711) + tmp_moved_constant_689*(-tmp_moved_constant_697*tmp_moved_constant_712 - tmp_moved_constant_700*tmp_moved_constant_713 - tmp_moved_constant_703*tmp_moved_constant_714 - tmp_moved_constant_706*tmp_moved_constant_715) + tmp_moved_constant_690*(tmp_moved_constant_697*tmp_moved_constant_718 + tmp_moved_constant_700*tmp_moved_constant_721 + tmp_moved_constant_703*tmp_moved_constant_724 + tmp_moved_constant_706*tmp_moved_constant_727) + tmp_moved_constant_691*(tmp_moved_constant_697*tmp_moved_constant_730 + tmp_moved_constant_700*tmp_moved_constant_733 + tmp_moved_constant_703*tmp_moved_constant_736 + tmp_moved_constant_706*tmp_moved_constant_739) + tmp_moved_constant_692*(tmp_moved_constant_697*tmp_moved_constant_742 + tmp_moved_constant_700*tmp_moved_constant_745 + tmp_moved_constant_703*tmp_moved_constant_748 + tmp_moved_constant_706*tmp_moved_constant_751) + tmp_moved_constant_693*(tmp_moved_constant_697*tmp_moved_constant_752 + tmp_moved_constant_700*tmp_moved_constant_753 + tmp_moved_constant_703*tmp_moved_constant_754 + tmp_moved_constant_706*tmp_moved_constant_755) + tmp_moved_constant_694*(tmp_moved_constant_697*tmp_moved_constant_756 + tmp_moved_constant_700*tmp_moved_constant_757 + tmp_moved_constant_703*tmp_moved_constant_758 + tmp_moved_constant_706*tmp_moved_constant_759) + tmp_moved_constant_695*(tmp_moved_constant_697*tmp_moved_constant_760 + tmp_moved_constant_700*tmp_moved_constant_761 + tmp_moved_constant_703*tmp_moved_constant_762 + tmp_moved_constant_706*tmp_moved_constant_763);
                const real_t tmp_moved_constant_781 = tmp_moved_constant_686*(tmp_moved_constant_764*tmp_moved_constant_768 + tmp_moved_constant_765*tmp_moved_constant_769 + tmp_moved_constant_766*tmp_moved_constant_770 + tmp_moved_constant_767*tmp_moved_constant_771) + tmp_moved_constant_687*(-tmp_moved_constant_698*tmp_moved_constant_768 - tmp_moved_constant_701*tmp_moved_constant_769 - tmp_moved_constant_704*tmp_moved_constant_770 - tmp_moved_constant_707*tmp_moved_constant_771) + tmp_moved_constant_688*(-tmp_moved_constant_708*tmp_moved_constant_768 - tmp_moved_constant_709*tmp_moved_constant_769 - tmp_moved_constant_710*tmp_moved_constant_770 - tmp_moved_constant_711*tmp_moved_constant_771) + tmp_moved_constant_689*(-tmp_moved_constant_712*tmp_moved_constant_768 - tmp_moved_constant_713*tmp_moved_constant_769 - tmp_moved_constant_714*tmp_moved_constant_770 - tmp_moved_constant_715*tmp_moved_constant_771) + tmp_moved_constant_690*(tmp_moved_constant_718*tmp_moved_constant_768 + tmp_moved_constant_721*tmp_moved_constant_769 + tmp_moved_constant_724*tmp_moved_constant_770 + tmp_moved_constant_727*tmp_moved_constant_771) + tmp_moved_constant_691*(tmp_moved_constant_730*tmp_moved_constant_768 + tmp_moved_constant_733*tmp_moved_constant_769 + tmp_moved_constant_736*tmp_moved_constant_770 + tmp_moved_constant_739*tmp_moved_constant_771) + tmp_moved_constant_692*(tmp_moved_constant_742*tmp_moved_constant_768 + tmp_moved_constant_745*tmp_moved_constant_769 + tmp_moved_constant_748*tmp_moved_constant_770 + tmp_moved_constant_751*tmp_moved_constant_771) + tmp_moved_constant_693*(tmp_moved_constant_752*tmp_moved_constant_768 + tmp_moved_constant_753*tmp_moved_constant_769 + tmp_moved_constant_754*tmp_moved_constant_770 + tmp_moved_constant_755*tmp_moved_constant_771) + tmp_moved_constant_694*(tmp_moved_constant_756*tmp_moved_constant_768 + tmp_moved_constant_757*tmp_moved_constant_769 + tmp_moved_constant_758*tmp_moved_constant_770 + tmp_moved_constant_759*tmp_moved_constant_771) + tmp_moved_constant_695*(tmp_moved_constant_760*tmp_moved_constant_768 + tmp_moved_constant_761*tmp_moved_constant_769 + tmp_moved_constant_762*tmp_moved_constant_770 + tmp_moved_constant_763*tmp_moved_constant_771);
                const real_t tmp_moved_constant_782 = tmp_moved_constant_686*(tmp_moved_constant_764*tmp_moved_constant_772 + tmp_moved_constant_765*tmp_moved_constant_773 + tmp_moved_constant_766*tmp_moved_constant_774 + tmp_moved_constant_767*tmp_moved_constant_775) + tmp_moved_constant_687*(-tmp_moved_constant_698*tmp_moved_constant_772 - tmp_moved_constant_701*tmp_moved_constant_773 - tmp_moved_constant_704*tmp_moved_constant_774 - tmp_moved_constant_707*tmp_moved_constant_775) + tmp_moved_constant_688*(-tmp_moved_constant_708*tmp_moved_constant_772 - tmp_moved_constant_709*tmp_moved_constant_773 - tmp_moved_constant_710*tmp_moved_constant_774 - tmp_moved_constant_711*tmp_moved_constant_775) + tmp_moved_constant_689*(-tmp_moved_constant_712*tmp_moved_constant_772 - tmp_moved_constant_713*tmp_moved_constant_773 - tmp_moved_constant_714*tmp_moved_constant_774 - tmp_moved_constant_715*tmp_moved_constant_775) + tmp_moved_constant_690*(tmp_moved_constant_718*tmp_moved_constant_772 + tmp_moved_constant_721*tmp_moved_constant_773 + tmp_moved_constant_724*tmp_moved_constant_774 + tmp_moved_constant_727*tmp_moved_constant_775) + tmp_moved_constant_691*(tmp_moved_constant_730*tmp_moved_constant_772 + tmp_moved_constant_733*tmp_moved_constant_773 + tmp_moved_constant_736*tmp_moved_constant_774 + tmp_moved_constant_739*tmp_moved_constant_775) + tmp_moved_constant_692*(tmp_moved_constant_742*tmp_moved_constant_772 + tmp_moved_constant_745*tmp_moved_constant_773 + tmp_moved_constant_748*tmp_moved_constant_774 + tmp_moved_constant_751*tmp_moved_constant_775) + tmp_moved_constant_693*(tmp_moved_constant_752*tmp_moved_constant_772 + tmp_moved_constant_753*tmp_moved_constant_773 + tmp_moved_constant_754*tmp_moved_constant_774 + tmp_moved_constant_755*tmp_moved_constant_775) + tmp_moved_constant_694*(tmp_moved_constant_756*tmp_moved_constant_772 + tmp_moved_constant_757*tmp_moved_constant_773 + tmp_moved_constant_758*tmp_moved_constant_774 + tmp_moved_constant_759*tmp_moved_constant_775) + tmp_moved_constant_695*(tmp_moved_constant_760*tmp_moved_constant_772 + tmp_moved_constant_761*tmp_moved_constant_773 + tmp_moved_constant_762*tmp_moved_constant_774 + tmp_moved_constant_763*tmp_moved_constant_775);
                const real_t tmp_moved_constant_783 = tmp_moved_constant_686*(tmp_moved_constant_764*tmp_moved_constant_776 + tmp_moved_constant_765*tmp_moved_constant_777 + tmp_moved_constant_766*tmp_moved_constant_778 + tmp_moved_constant_767*tmp_moved_constant_779) + tmp_moved_constant_687*(-tmp_moved_constant_698*tmp_moved_constant_776 - tmp_moved_constant_701*tmp_moved_constant_777 - tmp_moved_constant_704*tmp_moved_constant_778 - tmp_moved_constant_707*tmp_moved_constant_779) + tmp_moved_constant_688*(-tmp_moved_constant_708*tmp_moved_constant_776 - tmp_moved_constant_709*tmp_moved_constant_777 - tmp_moved_constant_710*tmp_moved_constant_778 - tmp_moved_constant_711*tmp_moved_constant_779) + tmp_moved_constant_689*(-tmp_moved_constant_712*tmp_moved_constant_776 - tmp_moved_constant_713*tmp_moved_constant_777 - tmp_moved_constant_714*tmp_moved_constant_778 - tmp_moved_constant_715*tmp_moved_constant_779) + tmp_moved_constant_690*(tmp_moved_constant_718*tmp_moved_constant_776 + tmp_moved_constant_721*tmp_moved_constant_777 + tmp_moved_constant_724*tmp_moved_constant_778 + tmp_moved_constant_727*tmp_moved_constant_779) + tmp_moved_constant_691*(tmp_moved_constant_730*tmp_moved_constant_776 + tmp_moved_constant_733*tmp_moved_constant_777 + tmp_moved_constant_736*tmp_moved_constant_778 + tmp_moved_constant_739*tmp_moved_constant_779) + tmp_moved_constant_692*(tmp_moved_constant_742*tmp_moved_constant_776 + tmp_moved_constant_745*tmp_moved_constant_777 + tmp_moved_constant_748*tmp_moved_constant_778 + tmp_moved_constant_751*tmp_moved_constant_779) + tmp_moved_constant_693*(tmp_moved_constant_752*tmp_moved_constant_776 + tmp_moved_constant_753*tmp_moved_constant_777 + tmp_moved_constant_754*tmp_moved_constant_778 + tmp_moved_constant_755*tmp_moved_constant_779) + tmp_moved_constant_694*(tmp_moved_constant_756*tmp_moved_constant_776 + tmp_moved_constant_757*tmp_moved_constant_777 + tmp_moved_constant_758*tmp_moved_constant_778 + tmp_moved_constant_759*tmp_moved_constant_779) + tmp_moved_constant_695*(tmp_moved_constant_760*tmp_moved_constant_776 + tmp_moved_constant_761*tmp_moved_constant_777 + tmp_moved_constant_762*tmp_moved_constant_778 + tmp_moved_constant_763*tmp_moved_constant_779);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_780 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_781 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_782 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_783 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                   }
                }
                const real_t tmp_moved_constant_784 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_785 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_786 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_787 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_788 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_789 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_790 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_moved_constant_791 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_792 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t tmp_moved_constant_793 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_moved_constant_794 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
                const real_t tmp_moved_constant_795 = tmp_moved_constant_794*0.13819660112501053;
                const real_t tmp_moved_constant_796 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_2 - 1.0);
                const real_t tmp_moved_constant_797 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
                const real_t tmp_moved_constant_798 = tmp_moved_constant_797*0.13819660112501056;
                const real_t tmp_moved_constant_799 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_6 - 1.0);
                const real_t tmp_moved_constant_800 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
                const real_t tmp_moved_constant_801 = tmp_moved_constant_800*0.13819660112501056;
                const real_t tmp_moved_constant_802 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_10 - 1.0);
                const real_t tmp_moved_constant_803 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
                const real_t tmp_moved_constant_804 = tmp_moved_constant_803*0.5854101966249684;
                const real_t tmp_moved_constant_805 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_14 - 1.0);
                const real_t tmp_moved_constant_806 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_16 - 1.0);
                const real_t tmp_moved_constant_807 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_18 - 1.0);
                const real_t tmp_moved_constant_808 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_20 - 1.0);
                const real_t tmp_moved_constant_809 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_22 - 1.0);
                const real_t tmp_moved_constant_810 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_24 - 1.0);
                const real_t tmp_moved_constant_811 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_26 - 1.0);
                const real_t tmp_moved_constant_812 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_28 - 1.0);
                const real_t tmp_moved_constant_813 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_30 - 1.0);
                const real_t tmp_moved_constant_814 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_24;
                const real_t tmp_moved_constant_815 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_16;
                const real_t tmp_moved_constant_816 = -tmp_moved_constant_814 - tmp_moved_constant_815;
                const real_t tmp_moved_constant_817 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_26;
                const real_t tmp_moved_constant_818 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_18;
                const real_t tmp_moved_constant_819 = -tmp_moved_constant_817 - tmp_moved_constant_818;
                const real_t tmp_moved_constant_820 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_28;
                const real_t tmp_moved_constant_821 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_20;
                const real_t tmp_moved_constant_822 = -tmp_moved_constant_820 - tmp_moved_constant_821;
                const real_t tmp_moved_constant_823 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_30;
                const real_t tmp_moved_constant_824 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_22;
                const real_t tmp_moved_constant_825 = -tmp_moved_constant_823 - tmp_moved_constant_824;
                const real_t tmp_moved_constant_826 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_24;
                const real_t tmp_moved_constant_827 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_2;
                const real_t tmp_moved_constant_828 = -tmp_moved_constant_826 - tmp_moved_constant_827;
                const real_t tmp_moved_constant_829 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_26;
                const real_t tmp_moved_constant_830 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_6;
                const real_t tmp_moved_constant_831 = -tmp_moved_constant_829 - tmp_moved_constant_830;
                const real_t tmp_moved_constant_832 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_28;
                const real_t tmp_moved_constant_833 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_10;
                const real_t tmp_moved_constant_834 = -tmp_moved_constant_832 - tmp_moved_constant_833;
                const real_t tmp_moved_constant_835 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_30;
                const real_t tmp_moved_constant_836 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_14;
                const real_t tmp_moved_constant_837 = -tmp_moved_constant_835 - tmp_moved_constant_836;
                const real_t tmp_moved_constant_838 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_16;
                const real_t tmp_moved_constant_839 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_2;
                const real_t tmp_moved_constant_840 = -tmp_moved_constant_838 - tmp_moved_constant_839;
                const real_t tmp_moved_constant_841 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_18;
                const real_t tmp_moved_constant_842 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_6;
                const real_t tmp_moved_constant_843 = -tmp_moved_constant_841 - tmp_moved_constant_842;
                const real_t tmp_moved_constant_844 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_20;
                const real_t tmp_moved_constant_845 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_10;
                const real_t tmp_moved_constant_846 = -tmp_moved_constant_844 - tmp_moved_constant_845;
                const real_t tmp_moved_constant_847 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_22;
                const real_t tmp_moved_constant_848 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_14;
                const real_t tmp_moved_constant_849 = -tmp_moved_constant_847 - tmp_moved_constant_848;
                const real_t tmp_moved_constant_850 = -jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_68 - 0.68328157299974723) + tmp_moved_constant_814 + tmp_moved_constant_826;
                const real_t tmp_moved_constant_851 = -jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_70 + 2.8944271909999157) + tmp_moved_constant_817 + tmp_moved_constant_829;
                const real_t tmp_moved_constant_852 = -jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_72 + 2.8944271909999157) + tmp_moved_constant_820 + tmp_moved_constant_832;
                const real_t tmp_moved_constant_853 = -jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_74 + 2.8944271909999157) + tmp_moved_constant_823 + tmp_moved_constant_835;
                const real_t tmp_moved_constant_854 = -jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_815 + tmp_moved_constant_838;
                const real_t tmp_moved_constant_855 = -jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_6 - tmp_kernel_op_78 - 4.6832815729997472) + tmp_moved_constant_818 + tmp_moved_constant_841;
                const real_t tmp_moved_constant_856 = -jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_80 - 1.105572809000084) + tmp_moved_constant_821 + tmp_moved_constant_844;
                const real_t tmp_moved_constant_857 = -jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_14 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_824 + tmp_moved_constant_847;
                const real_t tmp_moved_constant_858 = -jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_16 - tmp_kernel_op_76 - 1.105572809000084) + tmp_moved_constant_827 + tmp_moved_constant_839;
                const real_t tmp_moved_constant_859 = -jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_78 - 1.105572809000084) + tmp_moved_constant_830 + tmp_moved_constant_842;
                const real_t tmp_moved_constant_860 = -jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_20 - tmp_kernel_op_80 - 4.6832815729997472) + tmp_moved_constant_833 + tmp_moved_constant_845;
                const real_t tmp_moved_constant_861 = -jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_22 - tmp_kernel_op_82 - 1.105572809000084) + tmp_moved_constant_836 + tmp_moved_constant_848;
                const real_t tmp_moved_constant_862 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_88 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_88 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_88;
                const real_t tmp_moved_constant_863 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_90 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_90 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_90;
                const real_t tmp_moved_constant_864 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_92 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_92 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_92;
                const real_t tmp_moved_constant_865 = -jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_94 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_94 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_94;
                const real_t tmp_moved_constant_866 = tmp_moved_constant_794*0.1381966011250105;
                const real_t tmp_moved_constant_867 = tmp_moved_constant_797*0.1381966011250105;
                const real_t tmp_moved_constant_868 = tmp_moved_constant_800*0.5854101966249684;
                const real_t tmp_moved_constant_869 = tmp_moved_constant_803*0.1381966011250105;
                const real_t tmp_moved_constant_870 = tmp_moved_constant_794*0.1381966011250105;
                const real_t tmp_moved_constant_871 = tmp_moved_constant_797*0.5854101966249684;
                const real_t tmp_moved_constant_872 = tmp_moved_constant_800*0.1381966011250105;
                const real_t tmp_moved_constant_873 = tmp_moved_constant_803*0.1381966011250105;
                const real_t tmp_moved_constant_874 = tmp_moved_constant_794*0.5854101966249684;
                const real_t tmp_moved_constant_875 = tmp_moved_constant_797*0.1381966011250105;
                const real_t tmp_moved_constant_876 = tmp_moved_constant_800*0.1381966011250105;
                const real_t tmp_moved_constant_877 = tmp_moved_constant_803*0.1381966011250105;
                const real_t tmp_moved_constant_878 = tmp_moved_constant_784*(tmp_moved_constant_795*tmp_moved_constant_862 + tmp_moved_constant_798*tmp_moved_constant_863 + tmp_moved_constant_801*tmp_moved_constant_864 + tmp_moved_constant_804*tmp_moved_constant_865) + tmp_moved_constant_785*(-tmp_moved_constant_795*tmp_moved_constant_796 - tmp_moved_constant_798*tmp_moved_constant_799 - tmp_moved_constant_801*tmp_moved_constant_802 - tmp_moved_constant_804*tmp_moved_constant_805) + tmp_moved_constant_786*(-tmp_moved_constant_795*tmp_moved_constant_806 - tmp_moved_constant_798*tmp_moved_constant_807 - tmp_moved_constant_801*tmp_moved_constant_808 - tmp_moved_constant_804*tmp_moved_constant_809) + tmp_moved_constant_787*(-tmp_moved_constant_795*tmp_moved_constant_810 - tmp_moved_constant_798*tmp_moved_constant_811 - tmp_moved_constant_801*tmp_moved_constant_812 - tmp_moved_constant_804*tmp_moved_constant_813) + tmp_moved_constant_788*(tmp_moved_constant_795*tmp_moved_constant_816 + tmp_moved_constant_798*tmp_moved_constant_819 + tmp_moved_constant_801*tmp_moved_constant_822 + tmp_moved_constant_804*tmp_moved_constant_825) + tmp_moved_constant_789*(tmp_moved_constant_795*tmp_moved_constant_828 + tmp_moved_constant_798*tmp_moved_constant_831 + tmp_moved_constant_801*tmp_moved_constant_834 + tmp_moved_constant_804*tmp_moved_constant_837) + tmp_moved_constant_790*(tmp_moved_constant_795*tmp_moved_constant_840 + tmp_moved_constant_798*tmp_moved_constant_843 + tmp_moved_constant_801*tmp_moved_constant_846 + tmp_moved_constant_804*tmp_moved_constant_849) + tmp_moved_constant_791*(tmp_moved_constant_795*tmp_moved_constant_850 + tmp_moved_constant_798*tmp_moved_constant_851 + tmp_moved_constant_801*tmp_moved_constant_852 + tmp_moved_constant_804*tmp_moved_constant_853) + tmp_moved_constant_792*(tmp_moved_constant_795*tmp_moved_constant_854 + tmp_moved_constant_798*tmp_moved_constant_855 + tmp_moved_constant_801*tmp_moved_constant_856 + tmp_moved_constant_804*tmp_moved_constant_857) + tmp_moved_constant_793*(tmp_moved_constant_795*tmp_moved_constant_858 + tmp_moved_constant_798*tmp_moved_constant_859 + tmp_moved_constant_801*tmp_moved_constant_860 + tmp_moved_constant_804*tmp_moved_constant_861);
                const real_t tmp_moved_constant_879 = tmp_moved_constant_784*(tmp_moved_constant_862*tmp_moved_constant_866 + tmp_moved_constant_863*tmp_moved_constant_867 + tmp_moved_constant_864*tmp_moved_constant_868 + tmp_moved_constant_865*tmp_moved_constant_869) + tmp_moved_constant_785*(-tmp_moved_constant_796*tmp_moved_constant_866 - tmp_moved_constant_799*tmp_moved_constant_867 - tmp_moved_constant_802*tmp_moved_constant_868 - tmp_moved_constant_805*tmp_moved_constant_869) + tmp_moved_constant_786*(-tmp_moved_constant_806*tmp_moved_constant_866 - tmp_moved_constant_807*tmp_moved_constant_867 - tmp_moved_constant_808*tmp_moved_constant_868 - tmp_moved_constant_809*tmp_moved_constant_869) + tmp_moved_constant_787*(-tmp_moved_constant_810*tmp_moved_constant_866 - tmp_moved_constant_811*tmp_moved_constant_867 - tmp_moved_constant_812*tmp_moved_constant_868 - tmp_moved_constant_813*tmp_moved_constant_869) + tmp_moved_constant_788*(tmp_moved_constant_816*tmp_moved_constant_866 + tmp_moved_constant_819*tmp_moved_constant_867 + tmp_moved_constant_822*tmp_moved_constant_868 + tmp_moved_constant_825*tmp_moved_constant_869) + tmp_moved_constant_789*(tmp_moved_constant_828*tmp_moved_constant_866 + tmp_moved_constant_831*tmp_moved_constant_867 + tmp_moved_constant_834*tmp_moved_constant_868 + tmp_moved_constant_837*tmp_moved_constant_869) + tmp_moved_constant_790*(tmp_moved_constant_840*tmp_moved_constant_866 + tmp_moved_constant_843*tmp_moved_constant_867 + tmp_moved_constant_846*tmp_moved_constant_868 + tmp_moved_constant_849*tmp_moved_constant_869) + tmp_moved_constant_791*(tmp_moved_constant_850*tmp_moved_constant_866 + tmp_moved_constant_851*tmp_moved_constant_867 + tmp_moved_constant_852*tmp_moved_constant_868 + tmp_moved_constant_853*tmp_moved_constant_869) + tmp_moved_constant_792*(tmp_moved_constant_854*tmp_moved_constant_866 + tmp_moved_constant_855*tmp_moved_constant_867 + tmp_moved_constant_856*tmp_moved_constant_868 + tmp_moved_constant_857*tmp_moved_constant_869) + tmp_moved_constant_793*(tmp_moved_constant_858*tmp_moved_constant_866 + tmp_moved_constant_859*tmp_moved_constant_867 + tmp_moved_constant_860*tmp_moved_constant_868 + tmp_moved_constant_861*tmp_moved_constant_869);
                const real_t tmp_moved_constant_880 = tmp_moved_constant_784*(tmp_moved_constant_862*tmp_moved_constant_870 + tmp_moved_constant_863*tmp_moved_constant_871 + tmp_moved_constant_864*tmp_moved_constant_872 + tmp_moved_constant_865*tmp_moved_constant_873) + tmp_moved_constant_785*(-tmp_moved_constant_796*tmp_moved_constant_870 - tmp_moved_constant_799*tmp_moved_constant_871 - tmp_moved_constant_802*tmp_moved_constant_872 - tmp_moved_constant_805*tmp_moved_constant_873) + tmp_moved_constant_786*(-tmp_moved_constant_806*tmp_moved_constant_870 - tmp_moved_constant_807*tmp_moved_constant_871 - tmp_moved_constant_808*tmp_moved_constant_872 - tmp_moved_constant_809*tmp_moved_constant_873) + tmp_moved_constant_787*(-tmp_moved_constant_810*tmp_moved_constant_870 - tmp_moved_constant_811*tmp_moved_constant_871 - tmp_moved_constant_812*tmp_moved_constant_872 - tmp_moved_constant_813*tmp_moved_constant_873) + tmp_moved_constant_788*(tmp_moved_constant_816*tmp_moved_constant_870 + tmp_moved_constant_819*tmp_moved_constant_871 + tmp_moved_constant_822*tmp_moved_constant_872 + tmp_moved_constant_825*tmp_moved_constant_873) + tmp_moved_constant_789*(tmp_moved_constant_828*tmp_moved_constant_870 + tmp_moved_constant_831*tmp_moved_constant_871 + tmp_moved_constant_834*tmp_moved_constant_872 + tmp_moved_constant_837*tmp_moved_constant_873) + tmp_moved_constant_790*(tmp_moved_constant_840*tmp_moved_constant_870 + tmp_moved_constant_843*tmp_moved_constant_871 + tmp_moved_constant_846*tmp_moved_constant_872 + tmp_moved_constant_849*tmp_moved_constant_873) + tmp_moved_constant_791*(tmp_moved_constant_850*tmp_moved_constant_870 + tmp_moved_constant_851*tmp_moved_constant_871 + tmp_moved_constant_852*tmp_moved_constant_872 + tmp_moved_constant_853*tmp_moved_constant_873) + tmp_moved_constant_792*(tmp_moved_constant_854*tmp_moved_constant_870 + tmp_moved_constant_855*tmp_moved_constant_871 + tmp_moved_constant_856*tmp_moved_constant_872 + tmp_moved_constant_857*tmp_moved_constant_873) + tmp_moved_constant_793*(tmp_moved_constant_858*tmp_moved_constant_870 + tmp_moved_constant_859*tmp_moved_constant_871 + tmp_moved_constant_860*tmp_moved_constant_872 + tmp_moved_constant_861*tmp_moved_constant_873);
                const real_t tmp_moved_constant_881 = tmp_moved_constant_784*(tmp_moved_constant_862*tmp_moved_constant_874 + tmp_moved_constant_863*tmp_moved_constant_875 + tmp_moved_constant_864*tmp_moved_constant_876 + tmp_moved_constant_865*tmp_moved_constant_877) + tmp_moved_constant_785*(-tmp_moved_constant_796*tmp_moved_constant_874 - tmp_moved_constant_799*tmp_moved_constant_875 - tmp_moved_constant_802*tmp_moved_constant_876 - tmp_moved_constant_805*tmp_moved_constant_877) + tmp_moved_constant_786*(-tmp_moved_constant_806*tmp_moved_constant_874 - tmp_moved_constant_807*tmp_moved_constant_875 - tmp_moved_constant_808*tmp_moved_constant_876 - tmp_moved_constant_809*tmp_moved_constant_877) + tmp_moved_constant_787*(-tmp_moved_constant_810*tmp_moved_constant_874 - tmp_moved_constant_811*tmp_moved_constant_875 - tmp_moved_constant_812*tmp_moved_constant_876 - tmp_moved_constant_813*tmp_moved_constant_877) + tmp_moved_constant_788*(tmp_moved_constant_816*tmp_moved_constant_874 + tmp_moved_constant_819*tmp_moved_constant_875 + tmp_moved_constant_822*tmp_moved_constant_876 + tmp_moved_constant_825*tmp_moved_constant_877) + tmp_moved_constant_789*(tmp_moved_constant_828*tmp_moved_constant_874 + tmp_moved_constant_831*tmp_moved_constant_875 + tmp_moved_constant_834*tmp_moved_constant_876 + tmp_moved_constant_837*tmp_moved_constant_877) + tmp_moved_constant_790*(tmp_moved_constant_840*tmp_moved_constant_874 + tmp_moved_constant_843*tmp_moved_constant_875 + tmp_moved_constant_846*tmp_moved_constant_876 + tmp_moved_constant_849*tmp_moved_constant_877) + tmp_moved_constant_791*(tmp_moved_constant_850*tmp_moved_constant_874 + tmp_moved_constant_851*tmp_moved_constant_875 + tmp_moved_constant_852*tmp_moved_constant_876 + tmp_moved_constant_853*tmp_moved_constant_877) + tmp_moved_constant_792*(tmp_moved_constant_854*tmp_moved_constant_874 + tmp_moved_constant_855*tmp_moved_constant_875 + tmp_moved_constant_856*tmp_moved_constant_876 + tmp_moved_constant_857*tmp_moved_constant_877) + tmp_moved_constant_793*(tmp_moved_constant_858*tmp_moved_constant_874 + tmp_moved_constant_859*tmp_moved_constant_875 + tmp_moved_constant_860*tmp_moved_constant_876 + tmp_moved_constant_861*tmp_moved_constant_877);
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_878 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_879 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_880 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_881 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   }
                }
             } 
          }
          for (int64_t ctr_0 = -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_1*tmp_kernel_op_89 + tmp_kernel_op_13*tmp_kernel_op_95 + tmp_kernel_op_5*tmp_kernel_op_91 + tmp_kernel_op_9*tmp_kernel_op_93) + src_dof_1*(-tmp_kernel_op_1*tmp_kernel_op_3 - tmp_kernel_op_11*tmp_kernel_op_9 - tmp_kernel_op_13*tmp_kernel_op_15 - tmp_kernel_op_5*tmp_kernel_op_7) + src_dof_2*(-tmp_kernel_op_1*tmp_kernel_op_17 - tmp_kernel_op_13*tmp_kernel_op_23 - tmp_kernel_op_19*tmp_kernel_op_5 - tmp_kernel_op_21*tmp_kernel_op_9) + src_dof_3*(-tmp_kernel_op_1*tmp_kernel_op_25 - tmp_kernel_op_13*tmp_kernel_op_31 - tmp_kernel_op_27*tmp_kernel_op_5 - tmp_kernel_op_29*tmp_kernel_op_9) + src_dof_4*(tmp_kernel_op_1*tmp_kernel_op_34 + tmp_kernel_op_13*tmp_kernel_op_43 + tmp_kernel_op_37*tmp_kernel_op_5 + tmp_kernel_op_40*tmp_kernel_op_9) + src_dof_5*(tmp_kernel_op_1*tmp_kernel_op_46 + tmp_kernel_op_13*tmp_kernel_op_55 + tmp_kernel_op_49*tmp_kernel_op_5 + tmp_kernel_op_52*tmp_kernel_op_9) + src_dof_6*(tmp_kernel_op_1*tmp_kernel_op_58 + tmp_kernel_op_13*tmp_kernel_op_67 + tmp_kernel_op_5*tmp_kernel_op_61 + tmp_kernel_op_64*tmp_kernel_op_9) + src_dof_7*(tmp_kernel_op_1*tmp_kernel_op_69 + tmp_kernel_op_13*tmp_kernel_op_75 + tmp_kernel_op_5*tmp_kernel_op_71 + tmp_kernel_op_73*tmp_kernel_op_9) + src_dof_8*(tmp_kernel_op_1*tmp_kernel_op_77 + tmp_kernel_op_13*tmp_kernel_op_83 + tmp_kernel_op_5*tmp_kernel_op_79 + tmp_kernel_op_81*tmp_kernel_op_9) + src_dof_9*(tmp_kernel_op_1*tmp_kernel_op_84 + tmp_kernel_op_13*tmp_kernel_op_87 + tmp_kernel_op_5*tmp_kernel_op_85 + tmp_kernel_op_86*tmp_kernel_op_9);
             const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_89*tmp_kernel_op_96 + tmp_kernel_op_91*tmp_kernel_op_97 + tmp_kernel_op_93*tmp_kernel_op_98 + tmp_kernel_op_95*tmp_kernel_op_99) + src_dof_1*(-tmp_kernel_op_11*tmp_kernel_op_98 - tmp_kernel_op_15*tmp_kernel_op_99 - tmp_kernel_op_3*tmp_kernel_op_96 - tmp_kernel_op_7*tmp_kernel_op_97) + src_dof_2*(-tmp_kernel_op_17*tmp_kernel_op_96 - tmp_kernel_op_19*tmp_kernel_op_97 - tmp_kernel_op_21*tmp_kernel_op_98 - tmp_kernel_op_23*tmp_kernel_op_99) + src_dof_3*(-tmp_kernel_op_25*tmp_kernel_op_96 - tmp_kernel_op_27*tmp_kernel_op_97 - tmp_kernel_op_29*tmp_kernel_op_98 - tmp_kernel_op_31*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_34*tmp_kernel_op_96 + tmp_kernel_op_37*tmp_kernel_op_97 + tmp_kernel_op_40*tmp_kernel_op_98 + tmp_kernel_op_43*tmp_kernel_op_99) + src_dof_5*(tmp_kernel_op_46*tmp_kernel_op_96 + tmp_kernel_op_49*tmp_kernel_op_97 + tmp_kernel_op_52*tmp_kernel_op_98 + tmp_kernel_op_55*tmp_kernel_op_99) + src_dof_6*(tmp_kernel_op_58*tmp_kernel_op_96 + tmp_kernel_op_61*tmp_kernel_op_97 + tmp_kernel_op_64*tmp_kernel_op_98 + tmp_kernel_op_67*tmp_kernel_op_99) + src_dof_7*(tmp_kernel_op_69*tmp_kernel_op_96 + tmp_kernel_op_71*tmp_kernel_op_97 + tmp_kernel_op_73*tmp_kernel_op_98 + tmp_kernel_op_75*tmp_kernel_op_99) + src_dof_8*(tmp_kernel_op_77*tmp_kernel_op_96 + tmp_kernel_op_79*tmp_kernel_op_97 + tmp_kernel_op_81*tmp_kernel_op_98 + tmp_kernel_op_83*tmp_kernel_op_99) + src_dof_9*(tmp_kernel_op_84*tmp_kernel_op_96 + tmp_kernel_op_85*tmp_kernel_op_97 + tmp_kernel_op_86*tmp_kernel_op_98 + tmp_kernel_op_87*tmp_kernel_op_99);
             const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_89 + tmp_kernel_op_101*tmp_kernel_op_91 + tmp_kernel_op_102*tmp_kernel_op_93 + tmp_kernel_op_103*tmp_kernel_op_95) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_3 - tmp_kernel_op_101*tmp_kernel_op_7 - tmp_kernel_op_102*tmp_kernel_op_11 - tmp_kernel_op_103*tmp_kernel_op_15) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_17 - tmp_kernel_op_101*tmp_kernel_op_19 - tmp_kernel_op_102*tmp_kernel_op_21 - tmp_kernel_op_103*tmp_kernel_op_23) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_25 - tmp_kernel_op_101*tmp_kernel_op_27 - tmp_kernel_op_102*tmp_kernel_op_29 - tmp_kernel_op_103*tmp_kernel_op_31) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_34 + tmp_kernel_op_101*tmp_kernel_op_37 + tmp_kernel_op_102*tmp_kernel_op_40 + tmp_kernel_op_103*tmp_kernel_op_43) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_46 + tmp_kernel_op_101*tmp_kernel_op_49 + tmp_kernel_op_102*tmp_kernel_op_52 + tmp_kernel_op_103*tmp_kernel_op_55) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_58 + tmp_kernel_op_101*tmp_kernel_op_61 + tmp_kernel_op_102*tmp_kernel_op_64 + tmp_kernel_op_103*tmp_kernel_op_67) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_69 + tmp_kernel_op_101*tmp_kernel_op_71 + tmp_kernel_op_102*tmp_kernel_op_73 + tmp_kernel_op_103*tmp_kernel_op_75) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_77 + tmp_kernel_op_101*tmp_kernel_op_79 + tmp_kernel_op_102*tmp_kernel_op_81 + tmp_kernel_op_103*tmp_kernel_op_83) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_84 + tmp_kernel_op_101*tmp_kernel_op_85 + tmp_kernel_op_102*tmp_kernel_op_86 + tmp_kernel_op_103*tmp_kernel_op_87);
             const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_104*tmp_kernel_op_89 + tmp_kernel_op_105*tmp_kernel_op_91 + tmp_kernel_op_106*tmp_kernel_op_93 + tmp_kernel_op_107*tmp_kernel_op_95) + src_dof_1*(-tmp_kernel_op_104*tmp_kernel_op_3 - tmp_kernel_op_105*tmp_kernel_op_7 - tmp_kernel_op_106*tmp_kernel_op_11 - tmp_kernel_op_107*tmp_kernel_op_15) + src_dof_2*(-tmp_kernel_op_104*tmp_kernel_op_17 - tmp_kernel_op_105*tmp_kernel_op_19 - tmp_kernel_op_106*tmp_kernel_op_21 - tmp_kernel_op_107*tmp_kernel_op_23) + src_dof_3*(-tmp_kernel_op_104*tmp_kernel_op_25 - tmp_kernel_op_105*tmp_kernel_op_27 - tmp_kernel_op_106*tmp_kernel_op_29 - tmp_kernel_op_107*tmp_kernel_op_31) + src_dof_4*(tmp_kernel_op_104*tmp_kernel_op_34 + tmp_kernel_op_105*tmp_kernel_op_37 + tmp_kernel_op_106*tmp_kernel_op_40 + tmp_kernel_op_107*tmp_kernel_op_43) + src_dof_5*(tmp_kernel_op_104*tmp_kernel_op_46 + tmp_kernel_op_105*tmp_kernel_op_49 + tmp_kernel_op_106*tmp_kernel_op_52 + tmp_kernel_op_107*tmp_kernel_op_55) + src_dof_6*(tmp_kernel_op_104*tmp_kernel_op_58 + tmp_kernel_op_105*tmp_kernel_op_61 + tmp_kernel_op_106*tmp_kernel_op_64 + tmp_kernel_op_107*tmp_kernel_op_67) + src_dof_7*(tmp_kernel_op_104*tmp_kernel_op_69 + tmp_kernel_op_105*tmp_kernel_op_71 + tmp_kernel_op_106*tmp_kernel_op_73 + tmp_kernel_op_107*tmp_kernel_op_75) + src_dof_8*(tmp_kernel_op_104*tmp_kernel_op_77 + tmp_kernel_op_105*tmp_kernel_op_79 + tmp_kernel_op_106*tmp_kernel_op_81 + tmp_kernel_op_107*tmp_kernel_op_83) + src_dof_9*(tmp_kernel_op_104*tmp_kernel_op_84 + tmp_kernel_op_105*tmp_kernel_op_85 + tmp_kernel_op_106*tmp_kernel_op_86 + tmp_kernel_op_107*tmp_kernel_op_87);
             {
                {
                   {
                  
                      const int64_t phantom_ctr_0 = ctr_0;
                      real_t _data_float_loop_ctr_array_dim_0[4];
                      _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                      _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                      _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                      _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                      real_t _data_float_loop_ctr_array_dim_1[4];
                      _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                      _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                      real_t _data_float_loop_ctr_array_dim_2[4];
                      _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                      _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
                  
                      const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                      const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                   }
                }
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
