/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/



























#include "../P2ElementwiseEpsilon_1_2.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseEpsilon_1_2::apply_P2ElementwiseEpsilon_1_2_macro_3D( real_t * RESTRICT  _data_dstEdge, real_t * RESTRICT  _data_dstVertex, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t _data_q_w [] = {0.041666666666666657, 0.041666666666666657, 0.041666666666666657, 0.041666666666666657};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP + jac_affine_1_1_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP - jac_affine_2_1_WHITE_UP*tmp_coords_jac_4_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_1_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP + tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_UP [] = {((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q]));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 1]));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 2]));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 3]));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 4]));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 5]));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 6]));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 7]));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 8]));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 9]));
                   const __m256d q_tmp_1_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 10]));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 11]));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 12],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 12],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 12],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 12]));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 13],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 13],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 13],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 13]));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 14],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 14],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 14],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 14]));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 15],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 15],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 15],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 15]));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 16],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 16],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 16],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 16]));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 17],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 17],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 17],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 17]));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 18],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 18],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 18],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 18]));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 19],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 19],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 19],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 19]));
                   const __m256d q_tmp_2_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 20],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 20],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 20],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 20]));
                   const __m256d q_tmp_2_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 21],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 21],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 21],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 21]));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 22],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 22],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 22],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 22]));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 23],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 23],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 23],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 23]));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 24],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 24],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 24],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 24]));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 25],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 25],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 25],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 25]));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 26],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 26],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 26],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 26]));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 27],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 27],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 27],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 27]));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 28],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 28],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 28],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 28]));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 29],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 29],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 29],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 29]));
                   const __m256d q_tmp_3_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 30],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 30],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 30],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 30]));
                   const __m256d q_tmp_3_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 31],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 31],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 31],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 31]));
                   const __m256d q_tmp_3_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 32],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 32],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 32],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 32]));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 33],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 33],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 33],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 33]));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 34],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 34],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 34],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 34]));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 35],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 35],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 35],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 35]));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 36],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 36],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 36],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 36]));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 37],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 37],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 37],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 37]));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 38],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 38],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 38],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 38]));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 39],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 39],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 39],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 39]));
                   const __m256d q_tmp_4_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 40],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 40],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 40],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 40]));
                   const __m256d q_tmp_4_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 41],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 41],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 41],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 41]));
                   const __m256d q_tmp_4_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 42],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 42],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 42],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 42]));
                   const __m256d q_tmp_4_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 43],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 43],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 43],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 43]));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 44],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 44],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 44],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 44]));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 45],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 45],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 45],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 45]));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 46],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 46],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 46],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 46]));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 47],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 47],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 47],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 47]));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 48],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 48],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 48],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 48]));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 49],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 49],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 49],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 49]));
                   const __m256d q_tmp_5_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 50],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 50],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 50],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 50]));
                   const __m256d q_tmp_5_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 51],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 51],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 51],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 51]));
                   const __m256d q_tmp_5_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 52],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 52],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 52],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 52]));
                   const __m256d q_tmp_5_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 53],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 53],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 53],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 53]));
                   const __m256d q_tmp_5_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 54],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 54],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 54],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 54]));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 55],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 55],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 55],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 55]));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 56],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 56],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 56],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 56]));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 57],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 57],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 57],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 57]));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 58],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 58],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 58],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 58]));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 59],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 59],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 59],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 59]));
                   const __m256d q_tmp_6_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 60],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 60],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 60],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 60]));
                   const __m256d q_tmp_6_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 61],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 61],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 61],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 61]));
                   const __m256d q_tmp_6_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 62],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 62],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 62],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 62]));
                   const __m256d q_tmp_6_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 63],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 63],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 63],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 63]));
                   const __m256d q_tmp_6_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 64],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 64],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 64],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 64]));
                   const __m256d q_tmp_6_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 65],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 65],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 65],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 65]));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 66],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 66],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 66],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 66]));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 67],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 67],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 67],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 67]));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 68],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 68],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 68],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 68]));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 69],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 69],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 69],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 69]));
                   const __m256d q_tmp_7_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 70],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 70],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 70],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 70]));
                   const __m256d q_tmp_7_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 71],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 71],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 71],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 71]));
                   const __m256d q_tmp_7_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 72],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 72],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 72],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 72]));
                   const __m256d q_tmp_7_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 73],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 73],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 73],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 73]));
                   const __m256d q_tmp_7_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 74],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 74],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 74],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 74]));
                   const __m256d q_tmp_7_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 75],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 75],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 75],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 75]));
                   const __m256d q_tmp_7_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 76],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 76],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 76],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 76]));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 77],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 77],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 77],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 77]));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 78],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 78],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 78],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 78]));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 79],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 79],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 79],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 79]));
                   const __m256d q_tmp_8_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 80],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 80],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 80],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 80]));
                   const __m256d q_tmp_8_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 81],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 81],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 81],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 81]));
                   const __m256d q_tmp_8_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 82],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 82],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 82],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 82]));
                   const __m256d q_tmp_8_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 83],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 83],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 83],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 83]));
                   const __m256d q_tmp_8_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 84],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 84],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 84],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 84]));
                   const __m256d q_tmp_8_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 85],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 85],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 85],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 85]));
                   const __m256d q_tmp_8_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 86],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 86],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 86],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 86]));
                   const __m256d q_tmp_8_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 87],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 87],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 87],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 87]));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 88],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 88],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 88],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 88]));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 89],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 89],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 89],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 89]));
                   const __m256d q_tmp_9_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 90],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 90],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 90],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 90]));
                   const __m256d q_tmp_9_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 91],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 91],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 91],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 91]));
                   const __m256d q_tmp_9_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 92],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 92],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 92],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 92]));
                   const __m256d q_tmp_9_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 93],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 93],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 93],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 93]));
                   const __m256d q_tmp_9_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 94],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 94],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 94],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 94]));
                   const __m256d q_tmp_9_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 95],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 95],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 95],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 95]));
                   const __m256d q_tmp_9_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 96],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 96],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 96],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 96]));
                   const __m256d q_tmp_9_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 97],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 97],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 97],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 97]));
                   const __m256d q_tmp_9_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 98],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 98],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 98],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 98]));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 99],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 99],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 99],_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 99]));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_0 = _mm256_add_pd(q_acc_1_0,q_tmp_1_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_0 = _mm256_add_pd(q_acc_2_0,q_tmp_2_0);
                   q_acc_2_1 = _mm256_add_pd(q_acc_2_1,q_tmp_2_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_0 = _mm256_add_pd(q_acc_3_0,q_tmp_3_0);
                   q_acc_3_1 = _mm256_add_pd(q_acc_3_1,q_tmp_3_1);
                   q_acc_3_2 = _mm256_add_pd(q_acc_3_2,q_tmp_3_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_0 = _mm256_add_pd(q_acc_4_0,q_tmp_4_0);
                   q_acc_4_1 = _mm256_add_pd(q_acc_4_1,q_tmp_4_1);
                   q_acc_4_2 = _mm256_add_pd(q_acc_4_2,q_tmp_4_2);
                   q_acc_4_3 = _mm256_add_pd(q_acc_4_3,q_tmp_4_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_0 = _mm256_add_pd(q_acc_5_0,q_tmp_5_0);
                   q_acc_5_1 = _mm256_add_pd(q_acc_5_1,q_tmp_5_1);
                   q_acc_5_2 = _mm256_add_pd(q_acc_5_2,q_tmp_5_2);
                   q_acc_5_3 = _mm256_add_pd(q_acc_5_3,q_tmp_5_3);
                   q_acc_5_4 = _mm256_add_pd(q_acc_5_4,q_tmp_5_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_0 = _mm256_add_pd(q_acc_6_0,q_tmp_6_0);
                   q_acc_6_1 = _mm256_add_pd(q_acc_6_1,q_tmp_6_1);
                   q_acc_6_2 = _mm256_add_pd(q_acc_6_2,q_tmp_6_2);
                   q_acc_6_3 = _mm256_add_pd(q_acc_6_3,q_tmp_6_3);
                   q_acc_6_4 = _mm256_add_pd(q_acc_6_4,q_tmp_6_4);
                   q_acc_6_5 = _mm256_add_pd(q_acc_6_5,q_tmp_6_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_0 = _mm256_add_pd(q_acc_7_0,q_tmp_7_0);
                   q_acc_7_1 = _mm256_add_pd(q_acc_7_1,q_tmp_7_1);
                   q_acc_7_2 = _mm256_add_pd(q_acc_7_2,q_tmp_7_2);
                   q_acc_7_3 = _mm256_add_pd(q_acc_7_3,q_tmp_7_3);
                   q_acc_7_4 = _mm256_add_pd(q_acc_7_4,q_tmp_7_4);
                   q_acc_7_5 = _mm256_add_pd(q_acc_7_5,q_tmp_7_5);
                   q_acc_7_6 = _mm256_add_pd(q_acc_7_6,q_tmp_7_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_0 = _mm256_add_pd(q_acc_8_0,q_tmp_8_0);
                   q_acc_8_1 = _mm256_add_pd(q_acc_8_1,q_tmp_8_1);
                   q_acc_8_2 = _mm256_add_pd(q_acc_8_2,q_tmp_8_2);
                   q_acc_8_3 = _mm256_add_pd(q_acc_8_3,q_tmp_8_3);
                   q_acc_8_4 = _mm256_add_pd(q_acc_8_4,q_tmp_8_4);
                   q_acc_8_5 = _mm256_add_pd(q_acc_8_5,q_tmp_8_5);
                   q_acc_8_6 = _mm256_add_pd(q_acc_8_6,q_tmp_8_6);
                   q_acc_8_7 = _mm256_add_pd(q_acc_8_7,q_tmp_8_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_0 = _mm256_add_pd(q_acc_9_0,q_tmp_9_0);
                   q_acc_9_1 = _mm256_add_pd(q_acc_9_1,q_tmp_9_1);
                   q_acc_9_2 = _mm256_add_pd(q_acc_9_2,q_tmp_9_2);
                   q_acc_9_3 = _mm256_add_pd(q_acc_9_3,q_tmp_9_3);
                   q_acc_9_4 = _mm256_add_pd(q_acc_9_4,q_tmp_9_4);
                   q_acc_9_5 = _mm256_add_pd(q_acc_9_5,q_tmp_9_5);
                   q_acc_9_6 = _mm256_add_pd(q_acc_9_6,q_tmp_9_6);
                   q_acc_9_7 = _mm256_add_pd(q_acc_9_7,q_tmp_9_7);
                   q_acc_9_8 = _mm256_add_pd(q_acc_9_8,q_tmp_9_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_1_0,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_2_0,src_dof_0),_mm256_mul_pd(q_acc_2_1,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_3_0,src_dof_0),_mm256_mul_pd(q_acc_3_1,src_dof_1)),_mm256_mul_pd(q_acc_3_2,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_4_0,src_dof_0),_mm256_mul_pd(q_acc_4_1,src_dof_1)),_mm256_mul_pd(q_acc_4_2,src_dof_2)),_mm256_mul_pd(q_acc_4_3,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_5_0,src_dof_0),_mm256_mul_pd(q_acc_5_1,src_dof_1)),_mm256_mul_pd(q_acc_5_2,src_dof_2)),_mm256_mul_pd(q_acc_5_3,src_dof_3)),_mm256_mul_pd(q_acc_5_4,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_6_0,src_dof_0),_mm256_mul_pd(q_acc_6_1,src_dof_1)),_mm256_mul_pd(q_acc_6_2,src_dof_2)),_mm256_mul_pd(q_acc_6_3,src_dof_3)),_mm256_mul_pd(q_acc_6_4,src_dof_4)),_mm256_mul_pd(q_acc_6_5,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_7_0,src_dof_0),_mm256_mul_pd(q_acc_7_1,src_dof_1)),_mm256_mul_pd(q_acc_7_2,src_dof_2)),_mm256_mul_pd(q_acc_7_3,src_dof_3)),_mm256_mul_pd(q_acc_7_4,src_dof_4)),_mm256_mul_pd(q_acc_7_5,src_dof_5)),_mm256_mul_pd(q_acc_7_6,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_8_0,src_dof_0),_mm256_mul_pd(q_acc_8_1,src_dof_1)),_mm256_mul_pd(q_acc_8_2,src_dof_2)),_mm256_mul_pd(q_acc_8_3,src_dof_3)),_mm256_mul_pd(q_acc_8_4,src_dof_4)),_mm256_mul_pd(q_acc_8_5,src_dof_5)),_mm256_mul_pd(q_acc_8_6,src_dof_6)),_mm256_mul_pd(q_acc_8_7,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_9_0,src_dof_0),_mm256_mul_pd(q_acc_9_1,src_dof_1)),_mm256_mul_pd(q_acc_9_2,src_dof_2)),_mm256_mul_pd(q_acc_9_3,src_dof_3)),_mm256_mul_pd(q_acc_9_4,src_dof_4)),_mm256_mul_pd(q_acc_9_5,src_dof_5)),_mm256_mul_pd(q_acc_9_6,src_dof_6)),_mm256_mul_pd(q_acc_9_7,src_dof_7)),_mm256_mul_pd(q_acc_9_8,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_0 = 0.0;
                real_t q_acc_2_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_0 = 0.0;
                real_t q_acc_3_1 = 0.0;
                real_t q_acc_3_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_0 = 0.0;
                real_t q_acc_4_1 = 0.0;
                real_t q_acc_4_2 = 0.0;
                real_t q_acc_4_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_0 = 0.0;
                real_t q_acc_5_1 = 0.0;
                real_t q_acc_5_2 = 0.0;
                real_t q_acc_5_3 = 0.0;
                real_t q_acc_5_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_0 = 0.0;
                real_t q_acc_6_1 = 0.0;
                real_t q_acc_6_2 = 0.0;
                real_t q_acc_6_3 = 0.0;
                real_t q_acc_6_4 = 0.0;
                real_t q_acc_6_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_0 = 0.0;
                real_t q_acc_7_1 = 0.0;
                real_t q_acc_7_2 = 0.0;
                real_t q_acc_7_3 = 0.0;
                real_t q_acc_7_4 = 0.0;
                real_t q_acc_7_5 = 0.0;
                real_t q_acc_7_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_0 = 0.0;
                real_t q_acc_8_1 = 0.0;
                real_t q_acc_8_2 = 0.0;
                real_t q_acc_8_3 = 0.0;
                real_t q_acc_8_4 = 0.0;
                real_t q_acc_8_5 = 0.0;
                real_t q_acc_8_6 = 0.0;
                real_t q_acc_8_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_0 = 0.0;
                real_t q_acc_9_1 = 0.0;
                real_t q_acc_9_2 = 0.0;
                real_t q_acc_9_3 = 0.0;
                real_t q_acc_9_4 = 0.0;
                real_t q_acc_9_5 = 0.0;
                real_t q_acc_9_6 = 0.0;
                real_t q_acc_9_7 = 0.0;
                real_t q_acc_9_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t tmp_qloop_0 = (mu_dof_0*_data_phi_0_0_WHITE_UP[10*q] + mu_dof_1*_data_phi_0_0_WHITE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_UP[10*q + 9])*_data_q_w[q];
                   const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q];
                   const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 1];
                   const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 2];
                   const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 3];
                   const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 4];
                   const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 5];
                   const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 6];
                   const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 7];
                   const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 8];
                   const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 9];
                   const real_t q_tmp_1_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 10];
                   const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 11];
                   const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 12];
                   const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 13];
                   const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 14];
                   const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 15];
                   const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 16];
                   const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 17];
                   const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 18];
                   const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 19];
                   const real_t q_tmp_2_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 20];
                   const real_t q_tmp_2_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 21];
                   const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 22];
                   const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 23];
                   const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 24];
                   const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 25];
                   const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 26];
                   const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 27];
                   const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 28];
                   const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 29];
                   const real_t q_tmp_3_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 30];
                   const real_t q_tmp_3_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 31];
                   const real_t q_tmp_3_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 32];
                   const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 33];
                   const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 34];
                   const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 35];
                   const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 36];
                   const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 37];
                   const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 38];
                   const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 39];
                   const real_t q_tmp_4_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 40];
                   const real_t q_tmp_4_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 41];
                   const real_t q_tmp_4_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 42];
                   const real_t q_tmp_4_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 43];
                   const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 44];
                   const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 45];
                   const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 46];
                   const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 47];
                   const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 48];
                   const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 49];
                   const real_t q_tmp_5_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 50];
                   const real_t q_tmp_5_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 51];
                   const real_t q_tmp_5_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 52];
                   const real_t q_tmp_5_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 53];
                   const real_t q_tmp_5_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 54];
                   const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 55];
                   const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 56];
                   const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 57];
                   const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 58];
                   const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 59];
                   const real_t q_tmp_6_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 60];
                   const real_t q_tmp_6_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 61];
                   const real_t q_tmp_6_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 62];
                   const real_t q_tmp_6_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 63];
                   const real_t q_tmp_6_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 64];
                   const real_t q_tmp_6_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 65];
                   const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 66];
                   const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 67];
                   const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 68];
                   const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 69];
                   const real_t q_tmp_7_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 70];
                   const real_t q_tmp_7_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 71];
                   const real_t q_tmp_7_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 72];
                   const real_t q_tmp_7_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 73];
                   const real_t q_tmp_7_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 74];
                   const real_t q_tmp_7_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 75];
                   const real_t q_tmp_7_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 76];
                   const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 77];
                   const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 78];
                   const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 79];
                   const real_t q_tmp_8_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 80];
                   const real_t q_tmp_8_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 81];
                   const real_t q_tmp_8_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 82];
                   const real_t q_tmp_8_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 83];
                   const real_t q_tmp_8_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 84];
                   const real_t q_tmp_8_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 85];
                   const real_t q_tmp_8_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 86];
                   const real_t q_tmp_8_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 87];
                   const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 88];
                   const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 89];
                   const real_t q_tmp_9_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 90];
                   const real_t q_tmp_9_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 91];
                   const real_t q_tmp_9_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 92];
                   const real_t q_tmp_9_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 93];
                   const real_t q_tmp_9_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 94];
                   const real_t q_tmp_9_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 95];
                   const real_t q_tmp_9_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 96];
                   const real_t q_tmp_9_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 97];
                   const real_t q_tmp_9_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 98];
                   const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[100*q + 99];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                   q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                   q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                   q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                   q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                   q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                   q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                   q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                   q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                   q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                   q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                   q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                   q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                   q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                   q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                   q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                   q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                   q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                   q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                   q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                   q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                   q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                   q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                   q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                   q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                   q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                   q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                   q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                   q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                   q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                   q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                   q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                   q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                   q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                   q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                   q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                   q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN + jac_affine_1_1_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN - jac_affine_2_1_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_13_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN + tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_DOWN [] = {((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q]));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 1]));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 2]));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 3]));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 4]));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 5]));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 6]));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 7]));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 8]));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 9]));
                   const __m256d q_tmp_1_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 10]));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 11]));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 12]));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 13]));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 14]));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 15]));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 16]));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 17]));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 18]));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 19]));
                   const __m256d q_tmp_2_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 20]));
                   const __m256d q_tmp_2_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 21]));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 22]));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 23]));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 24]));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 25]));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 26]));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 27]));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 28]));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 29]));
                   const __m256d q_tmp_3_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 30]));
                   const __m256d q_tmp_3_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 31]));
                   const __m256d q_tmp_3_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 32]));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 33]));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 34]));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 35]));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 36]));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 37]));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 38]));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 39]));
                   const __m256d q_tmp_4_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 40]));
                   const __m256d q_tmp_4_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 41]));
                   const __m256d q_tmp_4_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 42]));
                   const __m256d q_tmp_4_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 43]));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 44]));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 45]));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 46]));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 47]));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 48]));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 49]));
                   const __m256d q_tmp_5_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 50]));
                   const __m256d q_tmp_5_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 51]));
                   const __m256d q_tmp_5_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 52]));
                   const __m256d q_tmp_5_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 53]));
                   const __m256d q_tmp_5_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 54]));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 55]));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 56]));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 57]));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 58]));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 59]));
                   const __m256d q_tmp_6_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 60]));
                   const __m256d q_tmp_6_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 61]));
                   const __m256d q_tmp_6_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 62]));
                   const __m256d q_tmp_6_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 63]));
                   const __m256d q_tmp_6_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 64]));
                   const __m256d q_tmp_6_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 65]));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 66]));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 67]));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 68]));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 69]));
                   const __m256d q_tmp_7_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 70]));
                   const __m256d q_tmp_7_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 71]));
                   const __m256d q_tmp_7_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 72]));
                   const __m256d q_tmp_7_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 73]));
                   const __m256d q_tmp_7_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 74]));
                   const __m256d q_tmp_7_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 75]));
                   const __m256d q_tmp_7_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 76]));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 77]));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 78]));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 79]));
                   const __m256d q_tmp_8_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 80]));
                   const __m256d q_tmp_8_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 81]));
                   const __m256d q_tmp_8_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 82]));
                   const __m256d q_tmp_8_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 83]));
                   const __m256d q_tmp_8_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 84]));
                   const __m256d q_tmp_8_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 85]));
                   const __m256d q_tmp_8_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 86]));
                   const __m256d q_tmp_8_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 87]));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 88]));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 89]));
                   const __m256d q_tmp_9_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 90]));
                   const __m256d q_tmp_9_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 91]));
                   const __m256d q_tmp_9_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 92]));
                   const __m256d q_tmp_9_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 93]));
                   const __m256d q_tmp_9_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 94]));
                   const __m256d q_tmp_9_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 95]));
                   const __m256d q_tmp_9_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 96]));
                   const __m256d q_tmp_9_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 97]));
                   const __m256d q_tmp_9_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 98]));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 99]));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_0 = _mm256_add_pd(q_acc_1_0,q_tmp_1_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_0 = _mm256_add_pd(q_acc_2_0,q_tmp_2_0);
                   q_acc_2_1 = _mm256_add_pd(q_acc_2_1,q_tmp_2_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_0 = _mm256_add_pd(q_acc_3_0,q_tmp_3_0);
                   q_acc_3_1 = _mm256_add_pd(q_acc_3_1,q_tmp_3_1);
                   q_acc_3_2 = _mm256_add_pd(q_acc_3_2,q_tmp_3_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_0 = _mm256_add_pd(q_acc_4_0,q_tmp_4_0);
                   q_acc_4_1 = _mm256_add_pd(q_acc_4_1,q_tmp_4_1);
                   q_acc_4_2 = _mm256_add_pd(q_acc_4_2,q_tmp_4_2);
                   q_acc_4_3 = _mm256_add_pd(q_acc_4_3,q_tmp_4_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_0 = _mm256_add_pd(q_acc_5_0,q_tmp_5_0);
                   q_acc_5_1 = _mm256_add_pd(q_acc_5_1,q_tmp_5_1);
                   q_acc_5_2 = _mm256_add_pd(q_acc_5_2,q_tmp_5_2);
                   q_acc_5_3 = _mm256_add_pd(q_acc_5_3,q_tmp_5_3);
                   q_acc_5_4 = _mm256_add_pd(q_acc_5_4,q_tmp_5_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_0 = _mm256_add_pd(q_acc_6_0,q_tmp_6_0);
                   q_acc_6_1 = _mm256_add_pd(q_acc_6_1,q_tmp_6_1);
                   q_acc_6_2 = _mm256_add_pd(q_acc_6_2,q_tmp_6_2);
                   q_acc_6_3 = _mm256_add_pd(q_acc_6_3,q_tmp_6_3);
                   q_acc_6_4 = _mm256_add_pd(q_acc_6_4,q_tmp_6_4);
                   q_acc_6_5 = _mm256_add_pd(q_acc_6_5,q_tmp_6_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_0 = _mm256_add_pd(q_acc_7_0,q_tmp_7_0);
                   q_acc_7_1 = _mm256_add_pd(q_acc_7_1,q_tmp_7_1);
                   q_acc_7_2 = _mm256_add_pd(q_acc_7_2,q_tmp_7_2);
                   q_acc_7_3 = _mm256_add_pd(q_acc_7_3,q_tmp_7_3);
                   q_acc_7_4 = _mm256_add_pd(q_acc_7_4,q_tmp_7_4);
                   q_acc_7_5 = _mm256_add_pd(q_acc_7_5,q_tmp_7_5);
                   q_acc_7_6 = _mm256_add_pd(q_acc_7_6,q_tmp_7_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_0 = _mm256_add_pd(q_acc_8_0,q_tmp_8_0);
                   q_acc_8_1 = _mm256_add_pd(q_acc_8_1,q_tmp_8_1);
                   q_acc_8_2 = _mm256_add_pd(q_acc_8_2,q_tmp_8_2);
                   q_acc_8_3 = _mm256_add_pd(q_acc_8_3,q_tmp_8_3);
                   q_acc_8_4 = _mm256_add_pd(q_acc_8_4,q_tmp_8_4);
                   q_acc_8_5 = _mm256_add_pd(q_acc_8_5,q_tmp_8_5);
                   q_acc_8_6 = _mm256_add_pd(q_acc_8_6,q_tmp_8_6);
                   q_acc_8_7 = _mm256_add_pd(q_acc_8_7,q_tmp_8_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_0 = _mm256_add_pd(q_acc_9_0,q_tmp_9_0);
                   q_acc_9_1 = _mm256_add_pd(q_acc_9_1,q_tmp_9_1);
                   q_acc_9_2 = _mm256_add_pd(q_acc_9_2,q_tmp_9_2);
                   q_acc_9_3 = _mm256_add_pd(q_acc_9_3,q_tmp_9_3);
                   q_acc_9_4 = _mm256_add_pd(q_acc_9_4,q_tmp_9_4);
                   q_acc_9_5 = _mm256_add_pd(q_acc_9_5,q_tmp_9_5);
                   q_acc_9_6 = _mm256_add_pd(q_acc_9_6,q_tmp_9_6);
                   q_acc_9_7 = _mm256_add_pd(q_acc_9_7,q_tmp_9_7);
                   q_acc_9_8 = _mm256_add_pd(q_acc_9_8,q_tmp_9_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_1_0,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_2_0,src_dof_0),_mm256_mul_pd(q_acc_2_1,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_3_0,src_dof_0),_mm256_mul_pd(q_acc_3_1,src_dof_1)),_mm256_mul_pd(q_acc_3_2,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_4_0,src_dof_0),_mm256_mul_pd(q_acc_4_1,src_dof_1)),_mm256_mul_pd(q_acc_4_2,src_dof_2)),_mm256_mul_pd(q_acc_4_3,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_5_0,src_dof_0),_mm256_mul_pd(q_acc_5_1,src_dof_1)),_mm256_mul_pd(q_acc_5_2,src_dof_2)),_mm256_mul_pd(q_acc_5_3,src_dof_3)),_mm256_mul_pd(q_acc_5_4,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_6_0,src_dof_0),_mm256_mul_pd(q_acc_6_1,src_dof_1)),_mm256_mul_pd(q_acc_6_2,src_dof_2)),_mm256_mul_pd(q_acc_6_3,src_dof_3)),_mm256_mul_pd(q_acc_6_4,src_dof_4)),_mm256_mul_pd(q_acc_6_5,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_7_0,src_dof_0),_mm256_mul_pd(q_acc_7_1,src_dof_1)),_mm256_mul_pd(q_acc_7_2,src_dof_2)),_mm256_mul_pd(q_acc_7_3,src_dof_3)),_mm256_mul_pd(q_acc_7_4,src_dof_4)),_mm256_mul_pd(q_acc_7_5,src_dof_5)),_mm256_mul_pd(q_acc_7_6,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_8_0,src_dof_0),_mm256_mul_pd(q_acc_8_1,src_dof_1)),_mm256_mul_pd(q_acc_8_2,src_dof_2)),_mm256_mul_pd(q_acc_8_3,src_dof_3)),_mm256_mul_pd(q_acc_8_4,src_dof_4)),_mm256_mul_pd(q_acc_8_5,src_dof_5)),_mm256_mul_pd(q_acc_8_6,src_dof_6)),_mm256_mul_pd(q_acc_8_7,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_9_0,src_dof_0),_mm256_mul_pd(q_acc_9_1,src_dof_1)),_mm256_mul_pd(q_acc_9_2,src_dof_2)),_mm256_mul_pd(q_acc_9_3,src_dof_3)),_mm256_mul_pd(q_acc_9_4,src_dof_4)),_mm256_mul_pd(q_acc_9_5,src_dof_5)),_mm256_mul_pd(q_acc_9_6,src_dof_6)),_mm256_mul_pd(q_acc_9_7,src_dof_7)),_mm256_mul_pd(q_acc_9_8,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_0 = 0.0;
                real_t q_acc_2_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_0 = 0.0;
                real_t q_acc_3_1 = 0.0;
                real_t q_acc_3_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_0 = 0.0;
                real_t q_acc_4_1 = 0.0;
                real_t q_acc_4_2 = 0.0;
                real_t q_acc_4_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_0 = 0.0;
                real_t q_acc_5_1 = 0.0;
                real_t q_acc_5_2 = 0.0;
                real_t q_acc_5_3 = 0.0;
                real_t q_acc_5_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_0 = 0.0;
                real_t q_acc_6_1 = 0.0;
                real_t q_acc_6_2 = 0.0;
                real_t q_acc_6_3 = 0.0;
                real_t q_acc_6_4 = 0.0;
                real_t q_acc_6_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_0 = 0.0;
                real_t q_acc_7_1 = 0.0;
                real_t q_acc_7_2 = 0.0;
                real_t q_acc_7_3 = 0.0;
                real_t q_acc_7_4 = 0.0;
                real_t q_acc_7_5 = 0.0;
                real_t q_acc_7_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_0 = 0.0;
                real_t q_acc_8_1 = 0.0;
                real_t q_acc_8_2 = 0.0;
                real_t q_acc_8_3 = 0.0;
                real_t q_acc_8_4 = 0.0;
                real_t q_acc_8_5 = 0.0;
                real_t q_acc_8_6 = 0.0;
                real_t q_acc_8_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_0 = 0.0;
                real_t q_acc_9_1 = 0.0;
                real_t q_acc_9_2 = 0.0;
                real_t q_acc_9_3 = 0.0;
                real_t q_acc_9_4 = 0.0;
                real_t q_acc_9_5 = 0.0;
                real_t q_acc_9_6 = 0.0;
                real_t q_acc_9_7 = 0.0;
                real_t q_acc_9_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t tmp_qloop_0 = (mu_dof_0*_data_phi_0_0_WHITE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_WHITE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_DOWN[10*q + 9])*_data_q_w[q];
                   const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q];
                   const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 1];
                   const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 2];
                   const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 3];
                   const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 4];
                   const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 5];
                   const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 6];
                   const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 7];
                   const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 8];
                   const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 9];
                   const real_t q_tmp_1_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 10];
                   const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 11];
                   const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 12];
                   const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 13];
                   const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 14];
                   const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 15];
                   const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 16];
                   const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 17];
                   const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 18];
                   const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 19];
                   const real_t q_tmp_2_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 20];
                   const real_t q_tmp_2_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 21];
                   const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 22];
                   const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 23];
                   const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 24];
                   const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 25];
                   const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 26];
                   const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 27];
                   const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 28];
                   const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 29];
                   const real_t q_tmp_3_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 30];
                   const real_t q_tmp_3_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 31];
                   const real_t q_tmp_3_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 32];
                   const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 33];
                   const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 34];
                   const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 35];
                   const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 36];
                   const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 37];
                   const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 38];
                   const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 39];
                   const real_t q_tmp_4_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 40];
                   const real_t q_tmp_4_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 41];
                   const real_t q_tmp_4_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 42];
                   const real_t q_tmp_4_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 43];
                   const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 44];
                   const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 45];
                   const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 46];
                   const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 47];
                   const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 48];
                   const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 49];
                   const real_t q_tmp_5_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 50];
                   const real_t q_tmp_5_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 51];
                   const real_t q_tmp_5_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 52];
                   const real_t q_tmp_5_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 53];
                   const real_t q_tmp_5_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 54];
                   const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 55];
                   const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 56];
                   const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 57];
                   const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 58];
                   const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 59];
                   const real_t q_tmp_6_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 60];
                   const real_t q_tmp_6_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 61];
                   const real_t q_tmp_6_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 62];
                   const real_t q_tmp_6_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 63];
                   const real_t q_tmp_6_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 64];
                   const real_t q_tmp_6_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 65];
                   const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 66];
                   const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 67];
                   const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 68];
                   const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 69];
                   const real_t q_tmp_7_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 70];
                   const real_t q_tmp_7_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 71];
                   const real_t q_tmp_7_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 72];
                   const real_t q_tmp_7_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 73];
                   const real_t q_tmp_7_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 74];
                   const real_t q_tmp_7_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 75];
                   const real_t q_tmp_7_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 76];
                   const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 77];
                   const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 78];
                   const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 79];
                   const real_t q_tmp_8_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 80];
                   const real_t q_tmp_8_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 81];
                   const real_t q_tmp_8_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 82];
                   const real_t q_tmp_8_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 83];
                   const real_t q_tmp_8_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 84];
                   const real_t q_tmp_8_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 85];
                   const real_t q_tmp_8_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 86];
                   const real_t q_tmp_8_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 87];
                   const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 88];
                   const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 89];
                   const real_t q_tmp_9_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 90];
                   const real_t q_tmp_9_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 91];
                   const real_t q_tmp_9_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 92];
                   const real_t q_tmp_9_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 93];
                   const real_t q_tmp_9_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 94];
                   const real_t q_tmp_9_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 95];
                   const real_t q_tmp_9_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 96];
                   const real_t q_tmp_9_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 97];
                   const real_t q_tmp_9_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 98];
                   const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[100*q + 99];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                   q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                   q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                   q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                   q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                   q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                   q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                   q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                   q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                   q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                   q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                   q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                   q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                   q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                   q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                   q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                   q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                   q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                   q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                   q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                   q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                   q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                   q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                   q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                   q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                   q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                   q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                   q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                   q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                   q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                   q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                   q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                   q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                   q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                   q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                   q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                   q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP + jac_affine_1_1_BLUE_UP*tmp_coords_jac_8_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP - jac_affine_2_1_BLUE_UP*tmp_coords_jac_10_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_7_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP + tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_UP [] = {((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q]));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 1]));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 2]));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 3]));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 4]));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 5]));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 6]));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 7]));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 8]));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 9]));
                   const __m256d q_tmp_1_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 10]));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 11]));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 12],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 12],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 12],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 12]));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 13],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 13],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 13],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 13]));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 14],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 14],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 14],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 14]));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 15],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 15],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 15],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 15]));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 16],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 16],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 16],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 16]));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 17],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 17],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 17],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 17]));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 18],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 18],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 18],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 18]));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 19],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 19],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 19],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 19]));
                   const __m256d q_tmp_2_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 20],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 20],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 20],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 20]));
                   const __m256d q_tmp_2_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 21],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 21],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 21],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 21]));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 22],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 22],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 22],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 22]));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 23],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 23],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 23],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 23]));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 24],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 24],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 24],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 24]));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 25],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 25],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 25],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 25]));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 26],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 26],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 26],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 26]));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 27],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 27],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 27],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 27]));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 28],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 28],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 28],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 28]));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 29],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 29],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 29],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 29]));
                   const __m256d q_tmp_3_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 30],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 30],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 30],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 30]));
                   const __m256d q_tmp_3_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 31],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 31],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 31],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 31]));
                   const __m256d q_tmp_3_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 32],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 32],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 32],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 32]));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 33],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 33],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 33],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 33]));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 34],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 34],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 34],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 34]));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 35],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 35],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 35],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 35]));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 36],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 36],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 36],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 36]));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 37],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 37],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 37],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 37]));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 38],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 38],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 38],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 38]));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 39],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 39],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 39],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 39]));
                   const __m256d q_tmp_4_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 40],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 40],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 40],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 40]));
                   const __m256d q_tmp_4_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 41],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 41],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 41],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 41]));
                   const __m256d q_tmp_4_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 42],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 42],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 42],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 42]));
                   const __m256d q_tmp_4_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 43],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 43],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 43],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 43]));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 44],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 44],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 44],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 44]));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 45],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 45],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 45],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 45]));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 46],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 46],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 46],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 46]));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 47],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 47],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 47],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 47]));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 48],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 48],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 48],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 48]));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 49],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 49],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 49],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 49]));
                   const __m256d q_tmp_5_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 50],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 50],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 50],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 50]));
                   const __m256d q_tmp_5_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 51],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 51],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 51],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 51]));
                   const __m256d q_tmp_5_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 52],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 52],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 52],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 52]));
                   const __m256d q_tmp_5_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 53],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 53],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 53],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 53]));
                   const __m256d q_tmp_5_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 54],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 54],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 54],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 54]));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 55],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 55],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 55],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 55]));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 56],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 56],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 56],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 56]));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 57],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 57],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 57],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 57]));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 58],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 58],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 58],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 58]));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 59],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 59],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 59],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 59]));
                   const __m256d q_tmp_6_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 60],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 60],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 60],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 60]));
                   const __m256d q_tmp_6_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 61],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 61],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 61],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 61]));
                   const __m256d q_tmp_6_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 62],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 62],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 62],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 62]));
                   const __m256d q_tmp_6_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 63],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 63],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 63],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 63]));
                   const __m256d q_tmp_6_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 64],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 64],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 64],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 64]));
                   const __m256d q_tmp_6_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 65],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 65],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 65],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 65]));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 66],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 66],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 66],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 66]));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 67],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 67],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 67],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 67]));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 68],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 68],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 68],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 68]));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 69],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 69],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 69],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 69]));
                   const __m256d q_tmp_7_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 70],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 70],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 70],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 70]));
                   const __m256d q_tmp_7_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 71],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 71],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 71],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 71]));
                   const __m256d q_tmp_7_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 72],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 72],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 72],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 72]));
                   const __m256d q_tmp_7_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 73],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 73],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 73],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 73]));
                   const __m256d q_tmp_7_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 74],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 74],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 74],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 74]));
                   const __m256d q_tmp_7_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 75],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 75],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 75],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 75]));
                   const __m256d q_tmp_7_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 76],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 76],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 76],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 76]));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 77],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 77],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 77],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 77]));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 78],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 78],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 78],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 78]));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 79],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 79],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 79],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 79]));
                   const __m256d q_tmp_8_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 80],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 80],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 80],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 80]));
                   const __m256d q_tmp_8_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 81],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 81],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 81],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 81]));
                   const __m256d q_tmp_8_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 82],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 82],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 82],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 82]));
                   const __m256d q_tmp_8_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 83],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 83],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 83],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 83]));
                   const __m256d q_tmp_8_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 84],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 84],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 84],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 84]));
                   const __m256d q_tmp_8_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 85],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 85],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 85],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 85]));
                   const __m256d q_tmp_8_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 86],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 86],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 86],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 86]));
                   const __m256d q_tmp_8_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 87],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 87],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 87],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 87]));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 88],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 88],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 88],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 88]));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 89],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 89],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 89],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 89]));
                   const __m256d q_tmp_9_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 90],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 90],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 90],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 90]));
                   const __m256d q_tmp_9_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 91],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 91],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 91],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 91]));
                   const __m256d q_tmp_9_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 92],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 92],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 92],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 92]));
                   const __m256d q_tmp_9_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 93],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 93],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 93],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 93]));
                   const __m256d q_tmp_9_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 94],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 94],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 94],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 94]));
                   const __m256d q_tmp_9_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 95],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 95],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 95],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 95]));
                   const __m256d q_tmp_9_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 96],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 96],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 96],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 96]));
                   const __m256d q_tmp_9_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 97],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 97],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 97],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 97]));
                   const __m256d q_tmp_9_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 98],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 98],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 98],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 98]));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 99],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 99],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 99],_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 99]));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_0 = _mm256_add_pd(q_acc_1_0,q_tmp_1_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_0 = _mm256_add_pd(q_acc_2_0,q_tmp_2_0);
                   q_acc_2_1 = _mm256_add_pd(q_acc_2_1,q_tmp_2_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_0 = _mm256_add_pd(q_acc_3_0,q_tmp_3_0);
                   q_acc_3_1 = _mm256_add_pd(q_acc_3_1,q_tmp_3_1);
                   q_acc_3_2 = _mm256_add_pd(q_acc_3_2,q_tmp_3_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_0 = _mm256_add_pd(q_acc_4_0,q_tmp_4_0);
                   q_acc_4_1 = _mm256_add_pd(q_acc_4_1,q_tmp_4_1);
                   q_acc_4_2 = _mm256_add_pd(q_acc_4_2,q_tmp_4_2);
                   q_acc_4_3 = _mm256_add_pd(q_acc_4_3,q_tmp_4_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_0 = _mm256_add_pd(q_acc_5_0,q_tmp_5_0);
                   q_acc_5_1 = _mm256_add_pd(q_acc_5_1,q_tmp_5_1);
                   q_acc_5_2 = _mm256_add_pd(q_acc_5_2,q_tmp_5_2);
                   q_acc_5_3 = _mm256_add_pd(q_acc_5_3,q_tmp_5_3);
                   q_acc_5_4 = _mm256_add_pd(q_acc_5_4,q_tmp_5_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_0 = _mm256_add_pd(q_acc_6_0,q_tmp_6_0);
                   q_acc_6_1 = _mm256_add_pd(q_acc_6_1,q_tmp_6_1);
                   q_acc_6_2 = _mm256_add_pd(q_acc_6_2,q_tmp_6_2);
                   q_acc_6_3 = _mm256_add_pd(q_acc_6_3,q_tmp_6_3);
                   q_acc_6_4 = _mm256_add_pd(q_acc_6_4,q_tmp_6_4);
                   q_acc_6_5 = _mm256_add_pd(q_acc_6_5,q_tmp_6_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_0 = _mm256_add_pd(q_acc_7_0,q_tmp_7_0);
                   q_acc_7_1 = _mm256_add_pd(q_acc_7_1,q_tmp_7_1);
                   q_acc_7_2 = _mm256_add_pd(q_acc_7_2,q_tmp_7_2);
                   q_acc_7_3 = _mm256_add_pd(q_acc_7_3,q_tmp_7_3);
                   q_acc_7_4 = _mm256_add_pd(q_acc_7_4,q_tmp_7_4);
                   q_acc_7_5 = _mm256_add_pd(q_acc_7_5,q_tmp_7_5);
                   q_acc_7_6 = _mm256_add_pd(q_acc_7_6,q_tmp_7_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_0 = _mm256_add_pd(q_acc_8_0,q_tmp_8_0);
                   q_acc_8_1 = _mm256_add_pd(q_acc_8_1,q_tmp_8_1);
                   q_acc_8_2 = _mm256_add_pd(q_acc_8_2,q_tmp_8_2);
                   q_acc_8_3 = _mm256_add_pd(q_acc_8_3,q_tmp_8_3);
                   q_acc_8_4 = _mm256_add_pd(q_acc_8_4,q_tmp_8_4);
                   q_acc_8_5 = _mm256_add_pd(q_acc_8_5,q_tmp_8_5);
                   q_acc_8_6 = _mm256_add_pd(q_acc_8_6,q_tmp_8_6);
                   q_acc_8_7 = _mm256_add_pd(q_acc_8_7,q_tmp_8_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_0 = _mm256_add_pd(q_acc_9_0,q_tmp_9_0);
                   q_acc_9_1 = _mm256_add_pd(q_acc_9_1,q_tmp_9_1);
                   q_acc_9_2 = _mm256_add_pd(q_acc_9_2,q_tmp_9_2);
                   q_acc_9_3 = _mm256_add_pd(q_acc_9_3,q_tmp_9_3);
                   q_acc_9_4 = _mm256_add_pd(q_acc_9_4,q_tmp_9_4);
                   q_acc_9_5 = _mm256_add_pd(q_acc_9_5,q_tmp_9_5);
                   q_acc_9_6 = _mm256_add_pd(q_acc_9_6,q_tmp_9_6);
                   q_acc_9_7 = _mm256_add_pd(q_acc_9_7,q_tmp_9_7);
                   q_acc_9_8 = _mm256_add_pd(q_acc_9_8,q_tmp_9_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_1_0,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_2_0,src_dof_0),_mm256_mul_pd(q_acc_2_1,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_3_0,src_dof_0),_mm256_mul_pd(q_acc_3_1,src_dof_1)),_mm256_mul_pd(q_acc_3_2,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_4_0,src_dof_0),_mm256_mul_pd(q_acc_4_1,src_dof_1)),_mm256_mul_pd(q_acc_4_2,src_dof_2)),_mm256_mul_pd(q_acc_4_3,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_5_0,src_dof_0),_mm256_mul_pd(q_acc_5_1,src_dof_1)),_mm256_mul_pd(q_acc_5_2,src_dof_2)),_mm256_mul_pd(q_acc_5_3,src_dof_3)),_mm256_mul_pd(q_acc_5_4,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_6_0,src_dof_0),_mm256_mul_pd(q_acc_6_1,src_dof_1)),_mm256_mul_pd(q_acc_6_2,src_dof_2)),_mm256_mul_pd(q_acc_6_3,src_dof_3)),_mm256_mul_pd(q_acc_6_4,src_dof_4)),_mm256_mul_pd(q_acc_6_5,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_7_0,src_dof_0),_mm256_mul_pd(q_acc_7_1,src_dof_1)),_mm256_mul_pd(q_acc_7_2,src_dof_2)),_mm256_mul_pd(q_acc_7_3,src_dof_3)),_mm256_mul_pd(q_acc_7_4,src_dof_4)),_mm256_mul_pd(q_acc_7_5,src_dof_5)),_mm256_mul_pd(q_acc_7_6,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_8_0,src_dof_0),_mm256_mul_pd(q_acc_8_1,src_dof_1)),_mm256_mul_pd(q_acc_8_2,src_dof_2)),_mm256_mul_pd(q_acc_8_3,src_dof_3)),_mm256_mul_pd(q_acc_8_4,src_dof_4)),_mm256_mul_pd(q_acc_8_5,src_dof_5)),_mm256_mul_pd(q_acc_8_6,src_dof_6)),_mm256_mul_pd(q_acc_8_7,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_9_0,src_dof_0),_mm256_mul_pd(q_acc_9_1,src_dof_1)),_mm256_mul_pd(q_acc_9_2,src_dof_2)),_mm256_mul_pd(q_acc_9_3,src_dof_3)),_mm256_mul_pd(q_acc_9_4,src_dof_4)),_mm256_mul_pd(q_acc_9_5,src_dof_5)),_mm256_mul_pd(q_acc_9_6,src_dof_6)),_mm256_mul_pd(q_acc_9_7,src_dof_7)),_mm256_mul_pd(q_acc_9_8,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_0 = 0.0;
                real_t q_acc_2_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_0 = 0.0;
                real_t q_acc_3_1 = 0.0;
                real_t q_acc_3_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_0 = 0.0;
                real_t q_acc_4_1 = 0.0;
                real_t q_acc_4_2 = 0.0;
                real_t q_acc_4_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_0 = 0.0;
                real_t q_acc_5_1 = 0.0;
                real_t q_acc_5_2 = 0.0;
                real_t q_acc_5_3 = 0.0;
                real_t q_acc_5_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_0 = 0.0;
                real_t q_acc_6_1 = 0.0;
                real_t q_acc_6_2 = 0.0;
                real_t q_acc_6_3 = 0.0;
                real_t q_acc_6_4 = 0.0;
                real_t q_acc_6_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_0 = 0.0;
                real_t q_acc_7_1 = 0.0;
                real_t q_acc_7_2 = 0.0;
                real_t q_acc_7_3 = 0.0;
                real_t q_acc_7_4 = 0.0;
                real_t q_acc_7_5 = 0.0;
                real_t q_acc_7_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_0 = 0.0;
                real_t q_acc_8_1 = 0.0;
                real_t q_acc_8_2 = 0.0;
                real_t q_acc_8_3 = 0.0;
                real_t q_acc_8_4 = 0.0;
                real_t q_acc_8_5 = 0.0;
                real_t q_acc_8_6 = 0.0;
                real_t q_acc_8_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_0 = 0.0;
                real_t q_acc_9_1 = 0.0;
                real_t q_acc_9_2 = 0.0;
                real_t q_acc_9_3 = 0.0;
                real_t q_acc_9_4 = 0.0;
                real_t q_acc_9_5 = 0.0;
                real_t q_acc_9_6 = 0.0;
                real_t q_acc_9_7 = 0.0;
                real_t q_acc_9_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t tmp_qloop_0 = (mu_dof_0*_data_phi_0_0_BLUE_UP[10*q] + mu_dof_1*_data_phi_0_0_BLUE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_UP[10*q + 9])*_data_q_w[q];
                   const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q];
                   const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 1];
                   const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 2];
                   const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 3];
                   const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 4];
                   const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 5];
                   const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 6];
                   const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 7];
                   const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 8];
                   const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 9];
                   const real_t q_tmp_1_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 10];
                   const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 11];
                   const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 12];
                   const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 13];
                   const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 14];
                   const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 15];
                   const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 16];
                   const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 17];
                   const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 18];
                   const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 19];
                   const real_t q_tmp_2_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 20];
                   const real_t q_tmp_2_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 21];
                   const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 22];
                   const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 23];
                   const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 24];
                   const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 25];
                   const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 26];
                   const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 27];
                   const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 28];
                   const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 29];
                   const real_t q_tmp_3_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 30];
                   const real_t q_tmp_3_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 31];
                   const real_t q_tmp_3_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 32];
                   const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 33];
                   const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 34];
                   const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 35];
                   const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 36];
                   const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 37];
                   const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 38];
                   const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 39];
                   const real_t q_tmp_4_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 40];
                   const real_t q_tmp_4_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 41];
                   const real_t q_tmp_4_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 42];
                   const real_t q_tmp_4_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 43];
                   const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 44];
                   const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 45];
                   const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 46];
                   const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 47];
                   const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 48];
                   const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 49];
                   const real_t q_tmp_5_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 50];
                   const real_t q_tmp_5_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 51];
                   const real_t q_tmp_5_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 52];
                   const real_t q_tmp_5_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 53];
                   const real_t q_tmp_5_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 54];
                   const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 55];
                   const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 56];
                   const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 57];
                   const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 58];
                   const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 59];
                   const real_t q_tmp_6_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 60];
                   const real_t q_tmp_6_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 61];
                   const real_t q_tmp_6_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 62];
                   const real_t q_tmp_6_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 63];
                   const real_t q_tmp_6_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 64];
                   const real_t q_tmp_6_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 65];
                   const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 66];
                   const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 67];
                   const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 68];
                   const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 69];
                   const real_t q_tmp_7_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 70];
                   const real_t q_tmp_7_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 71];
                   const real_t q_tmp_7_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 72];
                   const real_t q_tmp_7_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 73];
                   const real_t q_tmp_7_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 74];
                   const real_t q_tmp_7_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 75];
                   const real_t q_tmp_7_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 76];
                   const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 77];
                   const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 78];
                   const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 79];
                   const real_t q_tmp_8_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 80];
                   const real_t q_tmp_8_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 81];
                   const real_t q_tmp_8_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 82];
                   const real_t q_tmp_8_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 83];
                   const real_t q_tmp_8_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 84];
                   const real_t q_tmp_8_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 85];
                   const real_t q_tmp_8_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 86];
                   const real_t q_tmp_8_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 87];
                   const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 88];
                   const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 89];
                   const real_t q_tmp_9_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 90];
                   const real_t q_tmp_9_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 91];
                   const real_t q_tmp_9_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 92];
                   const real_t q_tmp_9_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 93];
                   const real_t q_tmp_9_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 94];
                   const real_t q_tmp_9_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 95];
                   const real_t q_tmp_9_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 96];
                   const real_t q_tmp_9_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 97];
                   const real_t q_tmp_9_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 98];
                   const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[100*q + 99];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                   q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                   q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                   q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                   q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                   q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                   q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                   q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                   q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                   q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                   q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                   q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                   q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                   q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                   q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                   q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                   q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                   q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                   q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                   q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                   q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                   q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                   q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                   q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                   q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                   q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                   q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                   q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                   q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                   q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                   q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                   q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                   q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                   q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                   q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                   q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                   q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN + jac_affine_1_1_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN - jac_affine_2_1_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_10_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN + tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_DOWN [] = {((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q]));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 1]));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 2]));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 3]));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 4]));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 5]));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 6]));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 7]));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 8]));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 9]));
                   const __m256d q_tmp_1_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 10]));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 11]));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 12]));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 13]));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 14]));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 15]));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 16]));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 17]));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 18]));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 19]));
                   const __m256d q_tmp_2_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 20]));
                   const __m256d q_tmp_2_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 21]));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 22]));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 23]));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 24]));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 25]));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 26]));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 27]));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 28]));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 29]));
                   const __m256d q_tmp_3_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 30]));
                   const __m256d q_tmp_3_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 31]));
                   const __m256d q_tmp_3_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 32]));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 33]));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 34]));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 35]));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 36]));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 37]));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 38]));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 39]));
                   const __m256d q_tmp_4_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 40]));
                   const __m256d q_tmp_4_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 41]));
                   const __m256d q_tmp_4_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 42]));
                   const __m256d q_tmp_4_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 43]));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 44]));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 45]));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 46]));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 47]));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 48]));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 49]));
                   const __m256d q_tmp_5_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 50]));
                   const __m256d q_tmp_5_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 51]));
                   const __m256d q_tmp_5_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 52]));
                   const __m256d q_tmp_5_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 53]));
                   const __m256d q_tmp_5_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 54]));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 55]));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 56]));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 57]));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 58]));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 59]));
                   const __m256d q_tmp_6_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 60]));
                   const __m256d q_tmp_6_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 61]));
                   const __m256d q_tmp_6_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 62]));
                   const __m256d q_tmp_6_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 63]));
                   const __m256d q_tmp_6_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 64]));
                   const __m256d q_tmp_6_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 65]));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 66]));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 67]));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 68]));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 69]));
                   const __m256d q_tmp_7_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 70]));
                   const __m256d q_tmp_7_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 71]));
                   const __m256d q_tmp_7_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 72]));
                   const __m256d q_tmp_7_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 73]));
                   const __m256d q_tmp_7_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 74]));
                   const __m256d q_tmp_7_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 75]));
                   const __m256d q_tmp_7_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 76]));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 77]));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 78]));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 79]));
                   const __m256d q_tmp_8_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 80]));
                   const __m256d q_tmp_8_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 81]));
                   const __m256d q_tmp_8_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 82]));
                   const __m256d q_tmp_8_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 83]));
                   const __m256d q_tmp_8_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 84]));
                   const __m256d q_tmp_8_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 85]));
                   const __m256d q_tmp_8_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 86]));
                   const __m256d q_tmp_8_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 87]));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 88]));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 89]));
                   const __m256d q_tmp_9_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 90]));
                   const __m256d q_tmp_9_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 91]));
                   const __m256d q_tmp_9_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 92]));
                   const __m256d q_tmp_9_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 93]));
                   const __m256d q_tmp_9_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 94]));
                   const __m256d q_tmp_9_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 95]));
                   const __m256d q_tmp_9_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 96]));
                   const __m256d q_tmp_9_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 97]));
                   const __m256d q_tmp_9_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 98]));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 99]));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_0 = _mm256_add_pd(q_acc_1_0,q_tmp_1_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_0 = _mm256_add_pd(q_acc_2_0,q_tmp_2_0);
                   q_acc_2_1 = _mm256_add_pd(q_acc_2_1,q_tmp_2_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_0 = _mm256_add_pd(q_acc_3_0,q_tmp_3_0);
                   q_acc_3_1 = _mm256_add_pd(q_acc_3_1,q_tmp_3_1);
                   q_acc_3_2 = _mm256_add_pd(q_acc_3_2,q_tmp_3_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_0 = _mm256_add_pd(q_acc_4_0,q_tmp_4_0);
                   q_acc_4_1 = _mm256_add_pd(q_acc_4_1,q_tmp_4_1);
                   q_acc_4_2 = _mm256_add_pd(q_acc_4_2,q_tmp_4_2);
                   q_acc_4_3 = _mm256_add_pd(q_acc_4_3,q_tmp_4_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_0 = _mm256_add_pd(q_acc_5_0,q_tmp_5_0);
                   q_acc_5_1 = _mm256_add_pd(q_acc_5_1,q_tmp_5_1);
                   q_acc_5_2 = _mm256_add_pd(q_acc_5_2,q_tmp_5_2);
                   q_acc_5_3 = _mm256_add_pd(q_acc_5_3,q_tmp_5_3);
                   q_acc_5_4 = _mm256_add_pd(q_acc_5_4,q_tmp_5_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_0 = _mm256_add_pd(q_acc_6_0,q_tmp_6_0);
                   q_acc_6_1 = _mm256_add_pd(q_acc_6_1,q_tmp_6_1);
                   q_acc_6_2 = _mm256_add_pd(q_acc_6_2,q_tmp_6_2);
                   q_acc_6_3 = _mm256_add_pd(q_acc_6_3,q_tmp_6_3);
                   q_acc_6_4 = _mm256_add_pd(q_acc_6_4,q_tmp_6_4);
                   q_acc_6_5 = _mm256_add_pd(q_acc_6_5,q_tmp_6_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_0 = _mm256_add_pd(q_acc_7_0,q_tmp_7_0);
                   q_acc_7_1 = _mm256_add_pd(q_acc_7_1,q_tmp_7_1);
                   q_acc_7_2 = _mm256_add_pd(q_acc_7_2,q_tmp_7_2);
                   q_acc_7_3 = _mm256_add_pd(q_acc_7_3,q_tmp_7_3);
                   q_acc_7_4 = _mm256_add_pd(q_acc_7_4,q_tmp_7_4);
                   q_acc_7_5 = _mm256_add_pd(q_acc_7_5,q_tmp_7_5);
                   q_acc_7_6 = _mm256_add_pd(q_acc_7_6,q_tmp_7_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_0 = _mm256_add_pd(q_acc_8_0,q_tmp_8_0);
                   q_acc_8_1 = _mm256_add_pd(q_acc_8_1,q_tmp_8_1);
                   q_acc_8_2 = _mm256_add_pd(q_acc_8_2,q_tmp_8_2);
                   q_acc_8_3 = _mm256_add_pd(q_acc_8_3,q_tmp_8_3);
                   q_acc_8_4 = _mm256_add_pd(q_acc_8_4,q_tmp_8_4);
                   q_acc_8_5 = _mm256_add_pd(q_acc_8_5,q_tmp_8_5);
                   q_acc_8_6 = _mm256_add_pd(q_acc_8_6,q_tmp_8_6);
                   q_acc_8_7 = _mm256_add_pd(q_acc_8_7,q_tmp_8_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_0 = _mm256_add_pd(q_acc_9_0,q_tmp_9_0);
                   q_acc_9_1 = _mm256_add_pd(q_acc_9_1,q_tmp_9_1);
                   q_acc_9_2 = _mm256_add_pd(q_acc_9_2,q_tmp_9_2);
                   q_acc_9_3 = _mm256_add_pd(q_acc_9_3,q_tmp_9_3);
                   q_acc_9_4 = _mm256_add_pd(q_acc_9_4,q_tmp_9_4);
                   q_acc_9_5 = _mm256_add_pd(q_acc_9_5,q_tmp_9_5);
                   q_acc_9_6 = _mm256_add_pd(q_acc_9_6,q_tmp_9_6);
                   q_acc_9_7 = _mm256_add_pd(q_acc_9_7,q_tmp_9_7);
                   q_acc_9_8 = _mm256_add_pd(q_acc_9_8,q_tmp_9_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_1_0,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_2_0,src_dof_0),_mm256_mul_pd(q_acc_2_1,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_3_0,src_dof_0),_mm256_mul_pd(q_acc_3_1,src_dof_1)),_mm256_mul_pd(q_acc_3_2,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_4_0,src_dof_0),_mm256_mul_pd(q_acc_4_1,src_dof_1)),_mm256_mul_pd(q_acc_4_2,src_dof_2)),_mm256_mul_pd(q_acc_4_3,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_5_0,src_dof_0),_mm256_mul_pd(q_acc_5_1,src_dof_1)),_mm256_mul_pd(q_acc_5_2,src_dof_2)),_mm256_mul_pd(q_acc_5_3,src_dof_3)),_mm256_mul_pd(q_acc_5_4,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_6_0,src_dof_0),_mm256_mul_pd(q_acc_6_1,src_dof_1)),_mm256_mul_pd(q_acc_6_2,src_dof_2)),_mm256_mul_pd(q_acc_6_3,src_dof_3)),_mm256_mul_pd(q_acc_6_4,src_dof_4)),_mm256_mul_pd(q_acc_6_5,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_7_0,src_dof_0),_mm256_mul_pd(q_acc_7_1,src_dof_1)),_mm256_mul_pd(q_acc_7_2,src_dof_2)),_mm256_mul_pd(q_acc_7_3,src_dof_3)),_mm256_mul_pd(q_acc_7_4,src_dof_4)),_mm256_mul_pd(q_acc_7_5,src_dof_5)),_mm256_mul_pd(q_acc_7_6,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_8_0,src_dof_0),_mm256_mul_pd(q_acc_8_1,src_dof_1)),_mm256_mul_pd(q_acc_8_2,src_dof_2)),_mm256_mul_pd(q_acc_8_3,src_dof_3)),_mm256_mul_pd(q_acc_8_4,src_dof_4)),_mm256_mul_pd(q_acc_8_5,src_dof_5)),_mm256_mul_pd(q_acc_8_6,src_dof_6)),_mm256_mul_pd(q_acc_8_7,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_9_0,src_dof_0),_mm256_mul_pd(q_acc_9_1,src_dof_1)),_mm256_mul_pd(q_acc_9_2,src_dof_2)),_mm256_mul_pd(q_acc_9_3,src_dof_3)),_mm256_mul_pd(q_acc_9_4,src_dof_4)),_mm256_mul_pd(q_acc_9_5,src_dof_5)),_mm256_mul_pd(q_acc_9_6,src_dof_6)),_mm256_mul_pd(q_acc_9_7,src_dof_7)),_mm256_mul_pd(q_acc_9_8,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_0 = 0.0;
                real_t q_acc_2_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_0 = 0.0;
                real_t q_acc_3_1 = 0.0;
                real_t q_acc_3_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_0 = 0.0;
                real_t q_acc_4_1 = 0.0;
                real_t q_acc_4_2 = 0.0;
                real_t q_acc_4_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_0 = 0.0;
                real_t q_acc_5_1 = 0.0;
                real_t q_acc_5_2 = 0.0;
                real_t q_acc_5_3 = 0.0;
                real_t q_acc_5_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_0 = 0.0;
                real_t q_acc_6_1 = 0.0;
                real_t q_acc_6_2 = 0.0;
                real_t q_acc_6_3 = 0.0;
                real_t q_acc_6_4 = 0.0;
                real_t q_acc_6_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_0 = 0.0;
                real_t q_acc_7_1 = 0.0;
                real_t q_acc_7_2 = 0.0;
                real_t q_acc_7_3 = 0.0;
                real_t q_acc_7_4 = 0.0;
                real_t q_acc_7_5 = 0.0;
                real_t q_acc_7_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_0 = 0.0;
                real_t q_acc_8_1 = 0.0;
                real_t q_acc_8_2 = 0.0;
                real_t q_acc_8_3 = 0.0;
                real_t q_acc_8_4 = 0.0;
                real_t q_acc_8_5 = 0.0;
                real_t q_acc_8_6 = 0.0;
                real_t q_acc_8_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_0 = 0.0;
                real_t q_acc_9_1 = 0.0;
                real_t q_acc_9_2 = 0.0;
                real_t q_acc_9_3 = 0.0;
                real_t q_acc_9_4 = 0.0;
                real_t q_acc_9_5 = 0.0;
                real_t q_acc_9_6 = 0.0;
                real_t q_acc_9_7 = 0.0;
                real_t q_acc_9_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t tmp_qloop_0 = (mu_dof_0*_data_phi_0_0_BLUE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_BLUE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_DOWN[10*q + 9])*_data_q_w[q];
                   const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q];
                   const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 1];
                   const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 2];
                   const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 3];
                   const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 4];
                   const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 5];
                   const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 6];
                   const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 7];
                   const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 8];
                   const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 9];
                   const real_t q_tmp_1_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 10];
                   const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 11];
                   const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 12];
                   const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 13];
                   const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 14];
                   const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 15];
                   const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 16];
                   const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 17];
                   const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 18];
                   const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 19];
                   const real_t q_tmp_2_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 20];
                   const real_t q_tmp_2_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 21];
                   const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 22];
                   const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 23];
                   const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 24];
                   const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 25];
                   const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 26];
                   const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 27];
                   const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 28];
                   const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 29];
                   const real_t q_tmp_3_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 30];
                   const real_t q_tmp_3_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 31];
                   const real_t q_tmp_3_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 32];
                   const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 33];
                   const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 34];
                   const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 35];
                   const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 36];
                   const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 37];
                   const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 38];
                   const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 39];
                   const real_t q_tmp_4_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 40];
                   const real_t q_tmp_4_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 41];
                   const real_t q_tmp_4_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 42];
                   const real_t q_tmp_4_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 43];
                   const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 44];
                   const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 45];
                   const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 46];
                   const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 47];
                   const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 48];
                   const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 49];
                   const real_t q_tmp_5_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 50];
                   const real_t q_tmp_5_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 51];
                   const real_t q_tmp_5_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 52];
                   const real_t q_tmp_5_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 53];
                   const real_t q_tmp_5_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 54];
                   const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 55];
                   const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 56];
                   const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 57];
                   const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 58];
                   const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 59];
                   const real_t q_tmp_6_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 60];
                   const real_t q_tmp_6_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 61];
                   const real_t q_tmp_6_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 62];
                   const real_t q_tmp_6_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 63];
                   const real_t q_tmp_6_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 64];
                   const real_t q_tmp_6_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 65];
                   const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 66];
                   const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 67];
                   const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 68];
                   const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 69];
                   const real_t q_tmp_7_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 70];
                   const real_t q_tmp_7_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 71];
                   const real_t q_tmp_7_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 72];
                   const real_t q_tmp_7_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 73];
                   const real_t q_tmp_7_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 74];
                   const real_t q_tmp_7_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 75];
                   const real_t q_tmp_7_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 76];
                   const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 77];
                   const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 78];
                   const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 79];
                   const real_t q_tmp_8_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 80];
                   const real_t q_tmp_8_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 81];
                   const real_t q_tmp_8_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 82];
                   const real_t q_tmp_8_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 83];
                   const real_t q_tmp_8_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 84];
                   const real_t q_tmp_8_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 85];
                   const real_t q_tmp_8_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 86];
                   const real_t q_tmp_8_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 87];
                   const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 88];
                   const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 89];
                   const real_t q_tmp_9_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 90];
                   const real_t q_tmp_9_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 91];
                   const real_t q_tmp_9_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 92];
                   const real_t q_tmp_9_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 93];
                   const real_t q_tmp_9_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 94];
                   const real_t q_tmp_9_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 95];
                   const real_t q_tmp_9_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 96];
                   const real_t q_tmp_9_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 97];
                   const real_t q_tmp_9_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 98];
                   const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[100*q + 99];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                   q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                   q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                   q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                   q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                   q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                   q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                   q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                   q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                   q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                   q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                   q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                   q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                   q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                   q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                   q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                   q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                   q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                   q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                   q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                   q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                   q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                   q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                   q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                   q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                   q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                   q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                   q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                   q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                   q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                   q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                   q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                   q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                   q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                   q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                   q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                   q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP + jac_affine_1_1_GREEN_UP*tmp_coords_jac_8_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP - jac_affine_2_1_GREEN_UP*tmp_coords_jac_10_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_7_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP + tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_UP [] = {((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q]));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 1]));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 2]));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 3]));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 4]));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 5]));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 6]));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 7]));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 8]));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 9]));
                   const __m256d q_tmp_1_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 10]));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 11]));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 12],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 12],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 12],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 12]));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 13],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 13],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 13],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 13]));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 14],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 14],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 14],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 14]));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 15],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 15],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 15],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 15]));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 16],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 16],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 16],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 16]));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 17],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 17],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 17],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 17]));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 18],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 18],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 18],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 18]));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 19],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 19],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 19],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 19]));
                   const __m256d q_tmp_2_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 20],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 20],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 20],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 20]));
                   const __m256d q_tmp_2_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 21],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 21],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 21],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 21]));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 22],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 22],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 22],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 22]));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 23],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 23],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 23],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 23]));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 24],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 24],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 24],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 24]));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 25],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 25],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 25],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 25]));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 26],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 26],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 26],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 26]));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 27],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 27],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 27],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 27]));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 28],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 28],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 28],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 28]));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 29],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 29],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 29],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 29]));
                   const __m256d q_tmp_3_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 30],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 30],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 30],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 30]));
                   const __m256d q_tmp_3_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 31],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 31],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 31],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 31]));
                   const __m256d q_tmp_3_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 32],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 32],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 32],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 32]));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 33],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 33],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 33],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 33]));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 34],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 34],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 34],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 34]));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 35],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 35],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 35],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 35]));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 36],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 36],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 36],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 36]));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 37],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 37],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 37],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 37]));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 38],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 38],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 38],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 38]));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 39],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 39],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 39],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 39]));
                   const __m256d q_tmp_4_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 40],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 40],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 40],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 40]));
                   const __m256d q_tmp_4_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 41],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 41],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 41],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 41]));
                   const __m256d q_tmp_4_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 42],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 42],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 42],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 42]));
                   const __m256d q_tmp_4_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 43],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 43],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 43],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 43]));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 44],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 44],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 44],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 44]));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 45],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 45],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 45],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 45]));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 46],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 46],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 46],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 46]));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 47],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 47],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 47],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 47]));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 48],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 48],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 48],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 48]));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 49],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 49],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 49],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 49]));
                   const __m256d q_tmp_5_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 50],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 50],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 50],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 50]));
                   const __m256d q_tmp_5_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 51],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 51],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 51],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 51]));
                   const __m256d q_tmp_5_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 52],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 52],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 52],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 52]));
                   const __m256d q_tmp_5_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 53],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 53],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 53],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 53]));
                   const __m256d q_tmp_5_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 54],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 54],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 54],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 54]));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 55],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 55],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 55],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 55]));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 56],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 56],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 56],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 56]));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 57],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 57],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 57],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 57]));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 58],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 58],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 58],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 58]));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 59],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 59],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 59],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 59]));
                   const __m256d q_tmp_6_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 60],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 60],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 60],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 60]));
                   const __m256d q_tmp_6_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 61],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 61],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 61],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 61]));
                   const __m256d q_tmp_6_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 62],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 62],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 62],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 62]));
                   const __m256d q_tmp_6_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 63],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 63],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 63],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 63]));
                   const __m256d q_tmp_6_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 64],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 64],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 64],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 64]));
                   const __m256d q_tmp_6_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 65],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 65],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 65],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 65]));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 66],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 66],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 66],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 66]));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 67],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 67],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 67],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 67]));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 68],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 68],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 68],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 68]));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 69],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 69],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 69],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 69]));
                   const __m256d q_tmp_7_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 70],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 70],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 70],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 70]));
                   const __m256d q_tmp_7_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 71],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 71],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 71],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 71]));
                   const __m256d q_tmp_7_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 72],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 72],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 72],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 72]));
                   const __m256d q_tmp_7_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 73],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 73],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 73],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 73]));
                   const __m256d q_tmp_7_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 74],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 74],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 74],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 74]));
                   const __m256d q_tmp_7_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 75],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 75],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 75],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 75]));
                   const __m256d q_tmp_7_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 76],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 76],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 76],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 76]));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 77],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 77],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 77],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 77]));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 78],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 78],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 78],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 78]));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 79],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 79],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 79],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 79]));
                   const __m256d q_tmp_8_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 80],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 80],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 80],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 80]));
                   const __m256d q_tmp_8_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 81],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 81],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 81],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 81]));
                   const __m256d q_tmp_8_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 82],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 82],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 82],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 82]));
                   const __m256d q_tmp_8_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 83],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 83],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 83],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 83]));
                   const __m256d q_tmp_8_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 84],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 84],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 84],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 84]));
                   const __m256d q_tmp_8_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 85],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 85],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 85],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 85]));
                   const __m256d q_tmp_8_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 86],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 86],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 86],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 86]));
                   const __m256d q_tmp_8_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 87],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 87],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 87],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 87]));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 88],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 88],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 88],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 88]));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 89],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 89],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 89],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 89]));
                   const __m256d q_tmp_9_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 90],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 90],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 90],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 90]));
                   const __m256d q_tmp_9_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 91],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 91],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 91],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 91]));
                   const __m256d q_tmp_9_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 92],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 92],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 92],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 92]));
                   const __m256d q_tmp_9_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 93],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 93],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 93],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 93]));
                   const __m256d q_tmp_9_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 94],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 94],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 94],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 94]));
                   const __m256d q_tmp_9_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 95],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 95],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 95],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 95]));
                   const __m256d q_tmp_9_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 96],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 96],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 96],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 96]));
                   const __m256d q_tmp_9_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 97],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 97],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 97],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 97]));
                   const __m256d q_tmp_9_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 98],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 98],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 98],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 98]));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 99],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 99],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 99],_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 99]));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_0 = _mm256_add_pd(q_acc_1_0,q_tmp_1_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_0 = _mm256_add_pd(q_acc_2_0,q_tmp_2_0);
                   q_acc_2_1 = _mm256_add_pd(q_acc_2_1,q_tmp_2_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_0 = _mm256_add_pd(q_acc_3_0,q_tmp_3_0);
                   q_acc_3_1 = _mm256_add_pd(q_acc_3_1,q_tmp_3_1);
                   q_acc_3_2 = _mm256_add_pd(q_acc_3_2,q_tmp_3_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_0 = _mm256_add_pd(q_acc_4_0,q_tmp_4_0);
                   q_acc_4_1 = _mm256_add_pd(q_acc_4_1,q_tmp_4_1);
                   q_acc_4_2 = _mm256_add_pd(q_acc_4_2,q_tmp_4_2);
                   q_acc_4_3 = _mm256_add_pd(q_acc_4_3,q_tmp_4_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_0 = _mm256_add_pd(q_acc_5_0,q_tmp_5_0);
                   q_acc_5_1 = _mm256_add_pd(q_acc_5_1,q_tmp_5_1);
                   q_acc_5_2 = _mm256_add_pd(q_acc_5_2,q_tmp_5_2);
                   q_acc_5_3 = _mm256_add_pd(q_acc_5_3,q_tmp_5_3);
                   q_acc_5_4 = _mm256_add_pd(q_acc_5_4,q_tmp_5_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_0 = _mm256_add_pd(q_acc_6_0,q_tmp_6_0);
                   q_acc_6_1 = _mm256_add_pd(q_acc_6_1,q_tmp_6_1);
                   q_acc_6_2 = _mm256_add_pd(q_acc_6_2,q_tmp_6_2);
                   q_acc_6_3 = _mm256_add_pd(q_acc_6_3,q_tmp_6_3);
                   q_acc_6_4 = _mm256_add_pd(q_acc_6_4,q_tmp_6_4);
                   q_acc_6_5 = _mm256_add_pd(q_acc_6_5,q_tmp_6_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_0 = _mm256_add_pd(q_acc_7_0,q_tmp_7_0);
                   q_acc_7_1 = _mm256_add_pd(q_acc_7_1,q_tmp_7_1);
                   q_acc_7_2 = _mm256_add_pd(q_acc_7_2,q_tmp_7_2);
                   q_acc_7_3 = _mm256_add_pd(q_acc_7_3,q_tmp_7_3);
                   q_acc_7_4 = _mm256_add_pd(q_acc_7_4,q_tmp_7_4);
                   q_acc_7_5 = _mm256_add_pd(q_acc_7_5,q_tmp_7_5);
                   q_acc_7_6 = _mm256_add_pd(q_acc_7_6,q_tmp_7_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_0 = _mm256_add_pd(q_acc_8_0,q_tmp_8_0);
                   q_acc_8_1 = _mm256_add_pd(q_acc_8_1,q_tmp_8_1);
                   q_acc_8_2 = _mm256_add_pd(q_acc_8_2,q_tmp_8_2);
                   q_acc_8_3 = _mm256_add_pd(q_acc_8_3,q_tmp_8_3);
                   q_acc_8_4 = _mm256_add_pd(q_acc_8_4,q_tmp_8_4);
                   q_acc_8_5 = _mm256_add_pd(q_acc_8_5,q_tmp_8_5);
                   q_acc_8_6 = _mm256_add_pd(q_acc_8_6,q_tmp_8_6);
                   q_acc_8_7 = _mm256_add_pd(q_acc_8_7,q_tmp_8_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_0 = _mm256_add_pd(q_acc_9_0,q_tmp_9_0);
                   q_acc_9_1 = _mm256_add_pd(q_acc_9_1,q_tmp_9_1);
                   q_acc_9_2 = _mm256_add_pd(q_acc_9_2,q_tmp_9_2);
                   q_acc_9_3 = _mm256_add_pd(q_acc_9_3,q_tmp_9_3);
                   q_acc_9_4 = _mm256_add_pd(q_acc_9_4,q_tmp_9_4);
                   q_acc_9_5 = _mm256_add_pd(q_acc_9_5,q_tmp_9_5);
                   q_acc_9_6 = _mm256_add_pd(q_acc_9_6,q_tmp_9_6);
                   q_acc_9_7 = _mm256_add_pd(q_acc_9_7,q_tmp_9_7);
                   q_acc_9_8 = _mm256_add_pd(q_acc_9_8,q_tmp_9_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_1_0,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_2_0,src_dof_0),_mm256_mul_pd(q_acc_2_1,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_3_0,src_dof_0),_mm256_mul_pd(q_acc_3_1,src_dof_1)),_mm256_mul_pd(q_acc_3_2,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_4_0,src_dof_0),_mm256_mul_pd(q_acc_4_1,src_dof_1)),_mm256_mul_pd(q_acc_4_2,src_dof_2)),_mm256_mul_pd(q_acc_4_3,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_5_0,src_dof_0),_mm256_mul_pd(q_acc_5_1,src_dof_1)),_mm256_mul_pd(q_acc_5_2,src_dof_2)),_mm256_mul_pd(q_acc_5_3,src_dof_3)),_mm256_mul_pd(q_acc_5_4,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_6_0,src_dof_0),_mm256_mul_pd(q_acc_6_1,src_dof_1)),_mm256_mul_pd(q_acc_6_2,src_dof_2)),_mm256_mul_pd(q_acc_6_3,src_dof_3)),_mm256_mul_pd(q_acc_6_4,src_dof_4)),_mm256_mul_pd(q_acc_6_5,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_7_0,src_dof_0),_mm256_mul_pd(q_acc_7_1,src_dof_1)),_mm256_mul_pd(q_acc_7_2,src_dof_2)),_mm256_mul_pd(q_acc_7_3,src_dof_3)),_mm256_mul_pd(q_acc_7_4,src_dof_4)),_mm256_mul_pd(q_acc_7_5,src_dof_5)),_mm256_mul_pd(q_acc_7_6,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_8_0,src_dof_0),_mm256_mul_pd(q_acc_8_1,src_dof_1)),_mm256_mul_pd(q_acc_8_2,src_dof_2)),_mm256_mul_pd(q_acc_8_3,src_dof_3)),_mm256_mul_pd(q_acc_8_4,src_dof_4)),_mm256_mul_pd(q_acc_8_5,src_dof_5)),_mm256_mul_pd(q_acc_8_6,src_dof_6)),_mm256_mul_pd(q_acc_8_7,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_9_0,src_dof_0),_mm256_mul_pd(q_acc_9_1,src_dof_1)),_mm256_mul_pd(q_acc_9_2,src_dof_2)),_mm256_mul_pd(q_acc_9_3,src_dof_3)),_mm256_mul_pd(q_acc_9_4,src_dof_4)),_mm256_mul_pd(q_acc_9_5,src_dof_5)),_mm256_mul_pd(q_acc_9_6,src_dof_6)),_mm256_mul_pd(q_acc_9_7,src_dof_7)),_mm256_mul_pd(q_acc_9_8,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_0 = 0.0;
                real_t q_acc_2_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_0 = 0.0;
                real_t q_acc_3_1 = 0.0;
                real_t q_acc_3_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_0 = 0.0;
                real_t q_acc_4_1 = 0.0;
                real_t q_acc_4_2 = 0.0;
                real_t q_acc_4_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_0 = 0.0;
                real_t q_acc_5_1 = 0.0;
                real_t q_acc_5_2 = 0.0;
                real_t q_acc_5_3 = 0.0;
                real_t q_acc_5_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_0 = 0.0;
                real_t q_acc_6_1 = 0.0;
                real_t q_acc_6_2 = 0.0;
                real_t q_acc_6_3 = 0.0;
                real_t q_acc_6_4 = 0.0;
                real_t q_acc_6_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_0 = 0.0;
                real_t q_acc_7_1 = 0.0;
                real_t q_acc_7_2 = 0.0;
                real_t q_acc_7_3 = 0.0;
                real_t q_acc_7_4 = 0.0;
                real_t q_acc_7_5 = 0.0;
                real_t q_acc_7_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_0 = 0.0;
                real_t q_acc_8_1 = 0.0;
                real_t q_acc_8_2 = 0.0;
                real_t q_acc_8_3 = 0.0;
                real_t q_acc_8_4 = 0.0;
                real_t q_acc_8_5 = 0.0;
                real_t q_acc_8_6 = 0.0;
                real_t q_acc_8_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_0 = 0.0;
                real_t q_acc_9_1 = 0.0;
                real_t q_acc_9_2 = 0.0;
                real_t q_acc_9_3 = 0.0;
                real_t q_acc_9_4 = 0.0;
                real_t q_acc_9_5 = 0.0;
                real_t q_acc_9_6 = 0.0;
                real_t q_acc_9_7 = 0.0;
                real_t q_acc_9_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t tmp_qloop_0 = (mu_dof_0*_data_phi_0_0_GREEN_UP[10*q] + mu_dof_1*_data_phi_0_0_GREEN_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_UP[10*q + 9])*_data_q_w[q];
                   const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q];
                   const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 1];
                   const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 2];
                   const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 3];
                   const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 4];
                   const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 5];
                   const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 6];
                   const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 7];
                   const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 8];
                   const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 9];
                   const real_t q_tmp_1_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 10];
                   const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 11];
                   const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 12];
                   const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 13];
                   const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 14];
                   const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 15];
                   const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 16];
                   const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 17];
                   const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 18];
                   const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 19];
                   const real_t q_tmp_2_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 20];
                   const real_t q_tmp_2_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 21];
                   const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 22];
                   const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 23];
                   const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 24];
                   const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 25];
                   const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 26];
                   const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 27];
                   const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 28];
                   const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 29];
                   const real_t q_tmp_3_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 30];
                   const real_t q_tmp_3_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 31];
                   const real_t q_tmp_3_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 32];
                   const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 33];
                   const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 34];
                   const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 35];
                   const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 36];
                   const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 37];
                   const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 38];
                   const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 39];
                   const real_t q_tmp_4_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 40];
                   const real_t q_tmp_4_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 41];
                   const real_t q_tmp_4_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 42];
                   const real_t q_tmp_4_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 43];
                   const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 44];
                   const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 45];
                   const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 46];
                   const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 47];
                   const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 48];
                   const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 49];
                   const real_t q_tmp_5_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 50];
                   const real_t q_tmp_5_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 51];
                   const real_t q_tmp_5_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 52];
                   const real_t q_tmp_5_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 53];
                   const real_t q_tmp_5_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 54];
                   const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 55];
                   const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 56];
                   const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 57];
                   const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 58];
                   const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 59];
                   const real_t q_tmp_6_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 60];
                   const real_t q_tmp_6_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 61];
                   const real_t q_tmp_6_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 62];
                   const real_t q_tmp_6_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 63];
                   const real_t q_tmp_6_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 64];
                   const real_t q_tmp_6_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 65];
                   const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 66];
                   const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 67];
                   const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 68];
                   const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 69];
                   const real_t q_tmp_7_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 70];
                   const real_t q_tmp_7_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 71];
                   const real_t q_tmp_7_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 72];
                   const real_t q_tmp_7_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 73];
                   const real_t q_tmp_7_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 74];
                   const real_t q_tmp_7_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 75];
                   const real_t q_tmp_7_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 76];
                   const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 77];
                   const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 78];
                   const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 79];
                   const real_t q_tmp_8_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 80];
                   const real_t q_tmp_8_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 81];
                   const real_t q_tmp_8_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 82];
                   const real_t q_tmp_8_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 83];
                   const real_t q_tmp_8_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 84];
                   const real_t q_tmp_8_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 85];
                   const real_t q_tmp_8_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 86];
                   const real_t q_tmp_8_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 87];
                   const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 88];
                   const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 89];
                   const real_t q_tmp_9_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 90];
                   const real_t q_tmp_9_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 91];
                   const real_t q_tmp_9_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 92];
                   const real_t q_tmp_9_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 93];
                   const real_t q_tmp_9_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 94];
                   const real_t q_tmp_9_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 95];
                   const real_t q_tmp_9_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 96];
                   const real_t q_tmp_9_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 97];
                   const real_t q_tmp_9_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 98];
                   const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[100*q + 99];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                   q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                   q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                   q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                   q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                   q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                   q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                   q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                   q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                   q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                   q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                   q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                   q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                   q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                   q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                   q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                   q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                   q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                   q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                   q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                   q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                   q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                   q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                   q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                   q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                   q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                   q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                   q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                   q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                   q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                   q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                   q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                   q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                   q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                   q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                   q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                   q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN + jac_affine_1_1_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN - jac_affine_2_1_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_10_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN + tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_DOWN [] = {((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q]));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 1]));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 2]));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 3]));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 4]));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 5]));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 6]));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 7]));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 8]));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 9]));
                   const __m256d q_tmp_1_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 10]));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 11]));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 12],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 12]));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 13],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 13]));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 14],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 14]));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 15],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 15]));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 16],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 16]));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 17],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 17]));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 18],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 18]));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 19],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 19]));
                   const __m256d q_tmp_2_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 20],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 20]));
                   const __m256d q_tmp_2_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 21],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 21]));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 22],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 22]));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 23],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 23]));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 24],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 24]));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 25],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 25]));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 26],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 26]));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 27],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 27]));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 28],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 28]));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 29],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 29]));
                   const __m256d q_tmp_3_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 30],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 30]));
                   const __m256d q_tmp_3_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 31],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 31]));
                   const __m256d q_tmp_3_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 32],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 32]));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 33],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 33]));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 34],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 34]));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 35],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 35]));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 36],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 36]));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 37],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 37]));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 38],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 38]));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 39],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 39]));
                   const __m256d q_tmp_4_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 40],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 40]));
                   const __m256d q_tmp_4_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 41],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 41]));
                   const __m256d q_tmp_4_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 42],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 42]));
                   const __m256d q_tmp_4_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 43],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 43]));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 44],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 44]));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 45],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 45]));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 46],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 46]));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 47],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 47]));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 48],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 48]));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 49],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 49]));
                   const __m256d q_tmp_5_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 50],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 50]));
                   const __m256d q_tmp_5_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 51],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 51]));
                   const __m256d q_tmp_5_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 52],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 52]));
                   const __m256d q_tmp_5_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 53],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 53]));
                   const __m256d q_tmp_5_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 54],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 54]));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 55],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 55]));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 56],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 56]));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 57],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 57]));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 58],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 58]));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 59],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 59]));
                   const __m256d q_tmp_6_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 60],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 60]));
                   const __m256d q_tmp_6_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 61],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 61]));
                   const __m256d q_tmp_6_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 62],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 62]));
                   const __m256d q_tmp_6_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 63],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 63]));
                   const __m256d q_tmp_6_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 64],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 64]));
                   const __m256d q_tmp_6_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 65],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 65]));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 66],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 66]));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 67],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 67]));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 68],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 68]));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 69],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 69]));
                   const __m256d q_tmp_7_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 70],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 70]));
                   const __m256d q_tmp_7_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 71],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 71]));
                   const __m256d q_tmp_7_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 72],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 72]));
                   const __m256d q_tmp_7_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 73],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 73]));
                   const __m256d q_tmp_7_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 74],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 74]));
                   const __m256d q_tmp_7_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 75],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 75]));
                   const __m256d q_tmp_7_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 76],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 76]));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 77],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 77]));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 78],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 78]));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 79],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 79]));
                   const __m256d q_tmp_8_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 80],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 80]));
                   const __m256d q_tmp_8_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 81],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 81]));
                   const __m256d q_tmp_8_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 82],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 82]));
                   const __m256d q_tmp_8_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 83],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 83]));
                   const __m256d q_tmp_8_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 84],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 84]));
                   const __m256d q_tmp_8_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 85],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 85]));
                   const __m256d q_tmp_8_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 86],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 86]));
                   const __m256d q_tmp_8_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 87],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 87]));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 88],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 88]));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 89],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 89]));
                   const __m256d q_tmp_9_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 90],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 90]));
                   const __m256d q_tmp_9_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 91],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 91]));
                   const __m256d q_tmp_9_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 92],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 92]));
                   const __m256d q_tmp_9_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 93],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 93]));
                   const __m256d q_tmp_9_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 94],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 94]));
                   const __m256d q_tmp_9_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 95],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 95]));
                   const __m256d q_tmp_9_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 96],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 96]));
                   const __m256d q_tmp_9_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 97],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 97]));
                   const __m256d q_tmp_9_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 98],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 98]));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 99],_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 99]));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_0 = _mm256_add_pd(q_acc_1_0,q_tmp_1_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_0 = _mm256_add_pd(q_acc_2_0,q_tmp_2_0);
                   q_acc_2_1 = _mm256_add_pd(q_acc_2_1,q_tmp_2_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_0 = _mm256_add_pd(q_acc_3_0,q_tmp_3_0);
                   q_acc_3_1 = _mm256_add_pd(q_acc_3_1,q_tmp_3_1);
                   q_acc_3_2 = _mm256_add_pd(q_acc_3_2,q_tmp_3_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_0 = _mm256_add_pd(q_acc_4_0,q_tmp_4_0);
                   q_acc_4_1 = _mm256_add_pd(q_acc_4_1,q_tmp_4_1);
                   q_acc_4_2 = _mm256_add_pd(q_acc_4_2,q_tmp_4_2);
                   q_acc_4_3 = _mm256_add_pd(q_acc_4_3,q_tmp_4_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_0 = _mm256_add_pd(q_acc_5_0,q_tmp_5_0);
                   q_acc_5_1 = _mm256_add_pd(q_acc_5_1,q_tmp_5_1);
                   q_acc_5_2 = _mm256_add_pd(q_acc_5_2,q_tmp_5_2);
                   q_acc_5_3 = _mm256_add_pd(q_acc_5_3,q_tmp_5_3);
                   q_acc_5_4 = _mm256_add_pd(q_acc_5_4,q_tmp_5_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_0 = _mm256_add_pd(q_acc_6_0,q_tmp_6_0);
                   q_acc_6_1 = _mm256_add_pd(q_acc_6_1,q_tmp_6_1);
                   q_acc_6_2 = _mm256_add_pd(q_acc_6_2,q_tmp_6_2);
                   q_acc_6_3 = _mm256_add_pd(q_acc_6_3,q_tmp_6_3);
                   q_acc_6_4 = _mm256_add_pd(q_acc_6_4,q_tmp_6_4);
                   q_acc_6_5 = _mm256_add_pd(q_acc_6_5,q_tmp_6_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_0 = _mm256_add_pd(q_acc_7_0,q_tmp_7_0);
                   q_acc_7_1 = _mm256_add_pd(q_acc_7_1,q_tmp_7_1);
                   q_acc_7_2 = _mm256_add_pd(q_acc_7_2,q_tmp_7_2);
                   q_acc_7_3 = _mm256_add_pd(q_acc_7_3,q_tmp_7_3);
                   q_acc_7_4 = _mm256_add_pd(q_acc_7_4,q_tmp_7_4);
                   q_acc_7_5 = _mm256_add_pd(q_acc_7_5,q_tmp_7_5);
                   q_acc_7_6 = _mm256_add_pd(q_acc_7_6,q_tmp_7_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_0 = _mm256_add_pd(q_acc_8_0,q_tmp_8_0);
                   q_acc_8_1 = _mm256_add_pd(q_acc_8_1,q_tmp_8_1);
                   q_acc_8_2 = _mm256_add_pd(q_acc_8_2,q_tmp_8_2);
                   q_acc_8_3 = _mm256_add_pd(q_acc_8_3,q_tmp_8_3);
                   q_acc_8_4 = _mm256_add_pd(q_acc_8_4,q_tmp_8_4);
                   q_acc_8_5 = _mm256_add_pd(q_acc_8_5,q_tmp_8_5);
                   q_acc_8_6 = _mm256_add_pd(q_acc_8_6,q_tmp_8_6);
                   q_acc_8_7 = _mm256_add_pd(q_acc_8_7,q_tmp_8_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_0 = _mm256_add_pd(q_acc_9_0,q_tmp_9_0);
                   q_acc_9_1 = _mm256_add_pd(q_acc_9_1,q_tmp_9_1);
                   q_acc_9_2 = _mm256_add_pd(q_acc_9_2,q_tmp_9_2);
                   q_acc_9_3 = _mm256_add_pd(q_acc_9_3,q_tmp_9_3);
                   q_acc_9_4 = _mm256_add_pd(q_acc_9_4,q_tmp_9_4);
                   q_acc_9_5 = _mm256_add_pd(q_acc_9_5,q_tmp_9_5);
                   q_acc_9_6 = _mm256_add_pd(q_acc_9_6,q_tmp_9_6);
                   q_acc_9_7 = _mm256_add_pd(q_acc_9_7,q_tmp_9_7);
                   q_acc_9_8 = _mm256_add_pd(q_acc_9_8,q_tmp_9_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_1_0,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_2_0,src_dof_0),_mm256_mul_pd(q_acc_2_1,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_3_0,src_dof_0),_mm256_mul_pd(q_acc_3_1,src_dof_1)),_mm256_mul_pd(q_acc_3_2,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_4_0,src_dof_0),_mm256_mul_pd(q_acc_4_1,src_dof_1)),_mm256_mul_pd(q_acc_4_2,src_dof_2)),_mm256_mul_pd(q_acc_4_3,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_5_0,src_dof_0),_mm256_mul_pd(q_acc_5_1,src_dof_1)),_mm256_mul_pd(q_acc_5_2,src_dof_2)),_mm256_mul_pd(q_acc_5_3,src_dof_3)),_mm256_mul_pd(q_acc_5_4,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_6_0,src_dof_0),_mm256_mul_pd(q_acc_6_1,src_dof_1)),_mm256_mul_pd(q_acc_6_2,src_dof_2)),_mm256_mul_pd(q_acc_6_3,src_dof_3)),_mm256_mul_pd(q_acc_6_4,src_dof_4)),_mm256_mul_pd(q_acc_6_5,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_7_0,src_dof_0),_mm256_mul_pd(q_acc_7_1,src_dof_1)),_mm256_mul_pd(q_acc_7_2,src_dof_2)),_mm256_mul_pd(q_acc_7_3,src_dof_3)),_mm256_mul_pd(q_acc_7_4,src_dof_4)),_mm256_mul_pd(q_acc_7_5,src_dof_5)),_mm256_mul_pd(q_acc_7_6,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_8_0,src_dof_0),_mm256_mul_pd(q_acc_8_1,src_dof_1)),_mm256_mul_pd(q_acc_8_2,src_dof_2)),_mm256_mul_pd(q_acc_8_3,src_dof_3)),_mm256_mul_pd(q_acc_8_4,src_dof_4)),_mm256_mul_pd(q_acc_8_5,src_dof_5)),_mm256_mul_pd(q_acc_8_6,src_dof_6)),_mm256_mul_pd(q_acc_8_7,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_9_0,src_dof_0),_mm256_mul_pd(q_acc_9_1,src_dof_1)),_mm256_mul_pd(q_acc_9_2,src_dof_2)),_mm256_mul_pd(q_acc_9_3,src_dof_3)),_mm256_mul_pd(q_acc_9_4,src_dof_4)),_mm256_mul_pd(q_acc_9_5,src_dof_5)),_mm256_mul_pd(q_acc_9_6,src_dof_6)),_mm256_mul_pd(q_acc_9_7,src_dof_7)),_mm256_mul_pd(q_acc_9_8,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_0 = 0.0;
                real_t q_acc_2_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_0 = 0.0;
                real_t q_acc_3_1 = 0.0;
                real_t q_acc_3_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_0 = 0.0;
                real_t q_acc_4_1 = 0.0;
                real_t q_acc_4_2 = 0.0;
                real_t q_acc_4_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_0 = 0.0;
                real_t q_acc_5_1 = 0.0;
                real_t q_acc_5_2 = 0.0;
                real_t q_acc_5_3 = 0.0;
                real_t q_acc_5_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_0 = 0.0;
                real_t q_acc_6_1 = 0.0;
                real_t q_acc_6_2 = 0.0;
                real_t q_acc_6_3 = 0.0;
                real_t q_acc_6_4 = 0.0;
                real_t q_acc_6_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_0 = 0.0;
                real_t q_acc_7_1 = 0.0;
                real_t q_acc_7_2 = 0.0;
                real_t q_acc_7_3 = 0.0;
                real_t q_acc_7_4 = 0.0;
                real_t q_acc_7_5 = 0.0;
                real_t q_acc_7_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_0 = 0.0;
                real_t q_acc_8_1 = 0.0;
                real_t q_acc_8_2 = 0.0;
                real_t q_acc_8_3 = 0.0;
                real_t q_acc_8_4 = 0.0;
                real_t q_acc_8_5 = 0.0;
                real_t q_acc_8_6 = 0.0;
                real_t q_acc_8_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_0 = 0.0;
                real_t q_acc_9_1 = 0.0;
                real_t q_acc_9_2 = 0.0;
                real_t q_acc_9_3 = 0.0;
                real_t q_acc_9_4 = 0.0;
                real_t q_acc_9_5 = 0.0;
                real_t q_acc_9_6 = 0.0;
                real_t q_acc_9_7 = 0.0;
                real_t q_acc_9_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t tmp_qloop_0 = (mu_dof_0*_data_phi_0_0_GREEN_DOWN[10*q] + mu_dof_1*_data_phi_0_0_GREEN_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_DOWN[10*q + 9])*_data_q_w[q];
                   const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q];
                   const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 1];
                   const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 2];
                   const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 3];
                   const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 4];
                   const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 5];
                   const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 6];
                   const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 7];
                   const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 8];
                   const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 9];
                   const real_t q_tmp_1_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 10];
                   const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 11];
                   const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 12];
                   const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 13];
                   const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 14];
                   const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 15];
                   const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 16];
                   const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 17];
                   const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 18];
                   const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 19];
                   const real_t q_tmp_2_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 20];
                   const real_t q_tmp_2_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 21];
                   const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 22];
                   const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 23];
                   const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 24];
                   const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 25];
                   const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 26];
                   const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 27];
                   const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 28];
                   const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 29];
                   const real_t q_tmp_3_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 30];
                   const real_t q_tmp_3_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 31];
                   const real_t q_tmp_3_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 32];
                   const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 33];
                   const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 34];
                   const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 35];
                   const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 36];
                   const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 37];
                   const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 38];
                   const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 39];
                   const real_t q_tmp_4_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 40];
                   const real_t q_tmp_4_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 41];
                   const real_t q_tmp_4_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 42];
                   const real_t q_tmp_4_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 43];
                   const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 44];
                   const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 45];
                   const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 46];
                   const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 47];
                   const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 48];
                   const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 49];
                   const real_t q_tmp_5_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 50];
                   const real_t q_tmp_5_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 51];
                   const real_t q_tmp_5_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 52];
                   const real_t q_tmp_5_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 53];
                   const real_t q_tmp_5_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 54];
                   const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 55];
                   const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 56];
                   const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 57];
                   const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 58];
                   const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 59];
                   const real_t q_tmp_6_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 60];
                   const real_t q_tmp_6_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 61];
                   const real_t q_tmp_6_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 62];
                   const real_t q_tmp_6_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 63];
                   const real_t q_tmp_6_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 64];
                   const real_t q_tmp_6_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 65];
                   const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 66];
                   const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 67];
                   const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 68];
                   const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 69];
                   const real_t q_tmp_7_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 70];
                   const real_t q_tmp_7_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 71];
                   const real_t q_tmp_7_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 72];
                   const real_t q_tmp_7_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 73];
                   const real_t q_tmp_7_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 74];
                   const real_t q_tmp_7_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 75];
                   const real_t q_tmp_7_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 76];
                   const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 77];
                   const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 78];
                   const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 79];
                   const real_t q_tmp_8_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 80];
                   const real_t q_tmp_8_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 81];
                   const real_t q_tmp_8_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 82];
                   const real_t q_tmp_8_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 83];
                   const real_t q_tmp_8_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 84];
                   const real_t q_tmp_8_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 85];
                   const real_t q_tmp_8_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 86];
                   const real_t q_tmp_8_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 87];
                   const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 88];
                   const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 89];
                   const real_t q_tmp_9_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 90];
                   const real_t q_tmp_9_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 91];
                   const real_t q_tmp_9_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 92];
                   const real_t q_tmp_9_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 93];
                   const real_t q_tmp_9_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 94];
                   const real_t q_tmp_9_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 95];
                   const real_t q_tmp_9_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 96];
                   const real_t q_tmp_9_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 97];
                   const real_t q_tmp_9_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 98];
                   const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[100*q + 99];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                   q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                   q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                   q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                   q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                   q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                   q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                   q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                   q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                   q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                   q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                   q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                   q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                   q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                   q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                   q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                   q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                   q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                   q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                   q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                   q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                   q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                   q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                   q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                   q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                   q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                   q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                   q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                   q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                   q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                   q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                   q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                   q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                   q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                   q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                   q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                   q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
