/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2VectorElementwiseEpsilon.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseEpsilon::apply_P2VectorElementwiseEpsilon_macro_2D( real_t * RESTRICT  _data_dst_edge_0, real_t * RESTRICT  _data_dst_edge_1, real_t * RESTRICT  _data_dst_vertex_0, real_t * RESTRICT  _data_dst_vertex_1, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t * RESTRICT  _data_src_edge_0, real_t * RESTRICT  _data_src_edge_1, real_t * RESTRICT  _data_src_vertex_0, real_t * RESTRICT  _data_src_vertex_1, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t _data_q_w [] = {0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       {
          /* FaceType.GRAY */
          const real_t _data_phi_0_0_GRAY [] = {-0.11111111111111116, -0.1111111111111111, 0.22222222222222221, 0.44444444444444442, 0.44444444444444442, 0.11111111111111116, -0.11111111111111116, 0.22222222222222221, -0.1111111111111111, 0.44444444444444442, 0.11111111111111116, 0.44444444444444442, 0.22222222222222221, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.44444444444444448, 0.44444444444444448};
      
          const real_t _data_tabulated_and_untitled_0_0_GRAY [] = {((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.22222222222222227 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-1.1111111111111112 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*5.5555555555555545 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*2.7777777777777772)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.11111111111111113 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*2.7777777777777772 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315) + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*5.5555555555555545 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-1.1111111111111112 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*2.7777777777777772)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.22222222222222227 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*2.7777777777777772 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.11111111111111113 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.22222222222222227 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*0.22222222222222227 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.22222222222222227 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.11111111111111113 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*0.11111111111111113 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.11111111111111113 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333))))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 3; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_GRAY[6*q],_data_phi_0_0_GRAY[6*q],_data_phi_0_0_GRAY[6*q],_data_phi_0_0_GRAY[6*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_GRAY[6*q + 1],_data_phi_0_0_GRAY[6*q + 1],_data_phi_0_0_GRAY[6*q + 1],_data_phi_0_0_GRAY[6*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_GRAY[6*q + 2],_data_phi_0_0_GRAY[6*q + 2],_data_phi_0_0_GRAY[6*q + 2],_data_phi_0_0_GRAY[6*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_GRAY[6*q + 3],_data_phi_0_0_GRAY[6*q + 3],_data_phi_0_0_GRAY[6*q + 3],_data_phi_0_0_GRAY[6*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_GRAY[6*q + 4],_data_phi_0_0_GRAY[6*q + 4],_data_phi_0_0_GRAY[6*q + 4],_data_phi_0_0_GRAY[6*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_GRAY[6*q + 5],_data_phi_0_0_GRAY[6*q + 5],_data_phi_0_0_GRAY[6*q + 5],_data_phi_0_0_GRAY[6*q + 5]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q],_data_tabulated_and_untitled_0_0_GRAY[138*q],_data_tabulated_and_untitled_0_0_GRAY[138*q],_data_tabulated_and_untitled_0_0_GRAY[138*q]));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 1],_data_tabulated_and_untitled_0_0_GRAY[138*q + 1],_data_tabulated_and_untitled_0_0_GRAY[138*q + 1],_data_tabulated_and_untitled_0_0_GRAY[138*q + 1]));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 2],_data_tabulated_and_untitled_0_0_GRAY[138*q + 2],_data_tabulated_and_untitled_0_0_GRAY[138*q + 2],_data_tabulated_and_untitled_0_0_GRAY[138*q + 2]));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 3],_data_tabulated_and_untitled_0_0_GRAY[138*q + 3],_data_tabulated_and_untitled_0_0_GRAY[138*q + 3],_data_tabulated_and_untitled_0_0_GRAY[138*q + 3]));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 4],_data_tabulated_and_untitled_0_0_GRAY[138*q + 4],_data_tabulated_and_untitled_0_0_GRAY[138*q + 4],_data_tabulated_and_untitled_0_0_GRAY[138*q + 4]));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 5],_data_tabulated_and_untitled_0_0_GRAY[138*q + 5],_data_tabulated_and_untitled_0_0_GRAY[138*q + 5],_data_tabulated_and_untitled_0_0_GRAY[138*q + 5]));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 6],_data_tabulated_and_untitled_0_0_GRAY[138*q + 6],_data_tabulated_and_untitled_0_0_GRAY[138*q + 6],_data_tabulated_and_untitled_0_0_GRAY[138*q + 6]));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 7],_data_tabulated_and_untitled_0_0_GRAY[138*q + 7],_data_tabulated_and_untitled_0_0_GRAY[138*q + 7],_data_tabulated_and_untitled_0_0_GRAY[138*q + 7]));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 8],_data_tabulated_and_untitled_0_0_GRAY[138*q + 8],_data_tabulated_and_untitled_0_0_GRAY[138*q + 8],_data_tabulated_and_untitled_0_0_GRAY[138*q + 8]));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 9],_data_tabulated_and_untitled_0_0_GRAY[138*q + 9],_data_tabulated_and_untitled_0_0_GRAY[138*q + 9],_data_tabulated_and_untitled_0_0_GRAY[138*q + 9]));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 10],_data_tabulated_and_untitled_0_0_GRAY[138*q + 10],_data_tabulated_and_untitled_0_0_GRAY[138*q + 10],_data_tabulated_and_untitled_0_0_GRAY[138*q + 10]));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 11],_data_tabulated_and_untitled_0_0_GRAY[138*q + 11],_data_tabulated_and_untitled_0_0_GRAY[138*q + 11],_data_tabulated_and_untitled_0_0_GRAY[138*q + 11]));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 13],_data_tabulated_and_untitled_0_0_GRAY[138*q + 13],_data_tabulated_and_untitled_0_0_GRAY[138*q + 13],_data_tabulated_and_untitled_0_0_GRAY[138*q + 13]));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 14],_data_tabulated_and_untitled_0_0_GRAY[138*q + 14],_data_tabulated_and_untitled_0_0_GRAY[138*q + 14],_data_tabulated_and_untitled_0_0_GRAY[138*q + 14]));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 15],_data_tabulated_and_untitled_0_0_GRAY[138*q + 15],_data_tabulated_and_untitled_0_0_GRAY[138*q + 15],_data_tabulated_and_untitled_0_0_GRAY[138*q + 15]));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 16],_data_tabulated_and_untitled_0_0_GRAY[138*q + 16],_data_tabulated_and_untitled_0_0_GRAY[138*q + 16],_data_tabulated_and_untitled_0_0_GRAY[138*q + 16]));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 17],_data_tabulated_and_untitled_0_0_GRAY[138*q + 17],_data_tabulated_and_untitled_0_0_GRAY[138*q + 17],_data_tabulated_and_untitled_0_0_GRAY[138*q + 17]));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 18],_data_tabulated_and_untitled_0_0_GRAY[138*q + 18],_data_tabulated_and_untitled_0_0_GRAY[138*q + 18],_data_tabulated_and_untitled_0_0_GRAY[138*q + 18]));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 19],_data_tabulated_and_untitled_0_0_GRAY[138*q + 19],_data_tabulated_and_untitled_0_0_GRAY[138*q + 19],_data_tabulated_and_untitled_0_0_GRAY[138*q + 19]));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 20],_data_tabulated_and_untitled_0_0_GRAY[138*q + 20],_data_tabulated_and_untitled_0_0_GRAY[138*q + 20],_data_tabulated_and_untitled_0_0_GRAY[138*q + 20]));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 21],_data_tabulated_and_untitled_0_0_GRAY[138*q + 21],_data_tabulated_and_untitled_0_0_GRAY[138*q + 21],_data_tabulated_and_untitled_0_0_GRAY[138*q + 21]));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 22],_data_tabulated_and_untitled_0_0_GRAY[138*q + 22],_data_tabulated_and_untitled_0_0_GRAY[138*q + 22],_data_tabulated_and_untitled_0_0_GRAY[138*q + 22]));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 23],_data_tabulated_and_untitled_0_0_GRAY[138*q + 23],_data_tabulated_and_untitled_0_0_GRAY[138*q + 23],_data_tabulated_and_untitled_0_0_GRAY[138*q + 23]));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 25],_data_tabulated_and_untitled_0_0_GRAY[138*q + 25],_data_tabulated_and_untitled_0_0_GRAY[138*q + 25],_data_tabulated_and_untitled_0_0_GRAY[138*q + 25]));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 26],_data_tabulated_and_untitled_0_0_GRAY[138*q + 26],_data_tabulated_and_untitled_0_0_GRAY[138*q + 26],_data_tabulated_and_untitled_0_0_GRAY[138*q + 26]));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 27],_data_tabulated_and_untitled_0_0_GRAY[138*q + 27],_data_tabulated_and_untitled_0_0_GRAY[138*q + 27],_data_tabulated_and_untitled_0_0_GRAY[138*q + 27]));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 28],_data_tabulated_and_untitled_0_0_GRAY[138*q + 28],_data_tabulated_and_untitled_0_0_GRAY[138*q + 28],_data_tabulated_and_untitled_0_0_GRAY[138*q + 28]));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 29],_data_tabulated_and_untitled_0_0_GRAY[138*q + 29],_data_tabulated_and_untitled_0_0_GRAY[138*q + 29],_data_tabulated_and_untitled_0_0_GRAY[138*q + 29]));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 30],_data_tabulated_and_untitled_0_0_GRAY[138*q + 30],_data_tabulated_and_untitled_0_0_GRAY[138*q + 30],_data_tabulated_and_untitled_0_0_GRAY[138*q + 30]));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 31],_data_tabulated_and_untitled_0_0_GRAY[138*q + 31],_data_tabulated_and_untitled_0_0_GRAY[138*q + 31],_data_tabulated_and_untitled_0_0_GRAY[138*q + 31]));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 32],_data_tabulated_and_untitled_0_0_GRAY[138*q + 32],_data_tabulated_and_untitled_0_0_GRAY[138*q + 32],_data_tabulated_and_untitled_0_0_GRAY[138*q + 32]));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 33],_data_tabulated_and_untitled_0_0_GRAY[138*q + 33],_data_tabulated_and_untitled_0_0_GRAY[138*q + 33],_data_tabulated_and_untitled_0_0_GRAY[138*q + 33]));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 34],_data_tabulated_and_untitled_0_0_GRAY[138*q + 34],_data_tabulated_and_untitled_0_0_GRAY[138*q + 34],_data_tabulated_and_untitled_0_0_GRAY[138*q + 34]));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 38],_data_tabulated_and_untitled_0_0_GRAY[138*q + 38],_data_tabulated_and_untitled_0_0_GRAY[138*q + 38],_data_tabulated_and_untitled_0_0_GRAY[138*q + 38]));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 39],_data_tabulated_and_untitled_0_0_GRAY[138*q + 39],_data_tabulated_and_untitled_0_0_GRAY[138*q + 39],_data_tabulated_and_untitled_0_0_GRAY[138*q + 39]));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 40],_data_tabulated_and_untitled_0_0_GRAY[138*q + 40],_data_tabulated_and_untitled_0_0_GRAY[138*q + 40],_data_tabulated_and_untitled_0_0_GRAY[138*q + 40]));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 41],_data_tabulated_and_untitled_0_0_GRAY[138*q + 41],_data_tabulated_and_untitled_0_0_GRAY[138*q + 41],_data_tabulated_and_untitled_0_0_GRAY[138*q + 41]));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 42],_data_tabulated_and_untitled_0_0_GRAY[138*q + 42],_data_tabulated_and_untitled_0_0_GRAY[138*q + 42],_data_tabulated_and_untitled_0_0_GRAY[138*q + 42]));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 43],_data_tabulated_and_untitled_0_0_GRAY[138*q + 43],_data_tabulated_and_untitled_0_0_GRAY[138*q + 43],_data_tabulated_and_untitled_0_0_GRAY[138*q + 43]));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 44],_data_tabulated_and_untitled_0_0_GRAY[138*q + 44],_data_tabulated_and_untitled_0_0_GRAY[138*q + 44],_data_tabulated_and_untitled_0_0_GRAY[138*q + 44]));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 45],_data_tabulated_and_untitled_0_0_GRAY[138*q + 45],_data_tabulated_and_untitled_0_0_GRAY[138*q + 45],_data_tabulated_and_untitled_0_0_GRAY[138*q + 45]));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 46],_data_tabulated_and_untitled_0_0_GRAY[138*q + 46],_data_tabulated_and_untitled_0_0_GRAY[138*q + 46],_data_tabulated_and_untitled_0_0_GRAY[138*q + 46]));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 51],_data_tabulated_and_untitled_0_0_GRAY[138*q + 51],_data_tabulated_and_untitled_0_0_GRAY[138*q + 51],_data_tabulated_and_untitled_0_0_GRAY[138*q + 51]));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 52],_data_tabulated_and_untitled_0_0_GRAY[138*q + 52],_data_tabulated_and_untitled_0_0_GRAY[138*q + 52],_data_tabulated_and_untitled_0_0_GRAY[138*q + 52]));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 53],_data_tabulated_and_untitled_0_0_GRAY[138*q + 53],_data_tabulated_and_untitled_0_0_GRAY[138*q + 53],_data_tabulated_and_untitled_0_0_GRAY[138*q + 53]));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 54],_data_tabulated_and_untitled_0_0_GRAY[138*q + 54],_data_tabulated_and_untitled_0_0_GRAY[138*q + 54],_data_tabulated_and_untitled_0_0_GRAY[138*q + 54]));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 55],_data_tabulated_and_untitled_0_0_GRAY[138*q + 55],_data_tabulated_and_untitled_0_0_GRAY[138*q + 55],_data_tabulated_and_untitled_0_0_GRAY[138*q + 55]));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 56],_data_tabulated_and_untitled_0_0_GRAY[138*q + 56],_data_tabulated_and_untitled_0_0_GRAY[138*q + 56],_data_tabulated_and_untitled_0_0_GRAY[138*q + 56]));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 57],_data_tabulated_and_untitled_0_0_GRAY[138*q + 57],_data_tabulated_and_untitled_0_0_GRAY[138*q + 57],_data_tabulated_and_untitled_0_0_GRAY[138*q + 57]));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 58],_data_tabulated_and_untitled_0_0_GRAY[138*q + 58],_data_tabulated_and_untitled_0_0_GRAY[138*q + 58],_data_tabulated_and_untitled_0_0_GRAY[138*q + 58]));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 64],_data_tabulated_and_untitled_0_0_GRAY[138*q + 64],_data_tabulated_and_untitled_0_0_GRAY[138*q + 64],_data_tabulated_and_untitled_0_0_GRAY[138*q + 64]));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 65],_data_tabulated_and_untitled_0_0_GRAY[138*q + 65],_data_tabulated_and_untitled_0_0_GRAY[138*q + 65],_data_tabulated_and_untitled_0_0_GRAY[138*q + 65]));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 66],_data_tabulated_and_untitled_0_0_GRAY[138*q + 66],_data_tabulated_and_untitled_0_0_GRAY[138*q + 66],_data_tabulated_and_untitled_0_0_GRAY[138*q + 66]));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 67],_data_tabulated_and_untitled_0_0_GRAY[138*q + 67],_data_tabulated_and_untitled_0_0_GRAY[138*q + 67],_data_tabulated_and_untitled_0_0_GRAY[138*q + 67]));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 68],_data_tabulated_and_untitled_0_0_GRAY[138*q + 68],_data_tabulated_and_untitled_0_0_GRAY[138*q + 68],_data_tabulated_and_untitled_0_0_GRAY[138*q + 68]));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 69],_data_tabulated_and_untitled_0_0_GRAY[138*q + 69],_data_tabulated_and_untitled_0_0_GRAY[138*q + 69],_data_tabulated_and_untitled_0_0_GRAY[138*q + 69]));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 70],_data_tabulated_and_untitled_0_0_GRAY[138*q + 70],_data_tabulated_and_untitled_0_0_GRAY[138*q + 70],_data_tabulated_and_untitled_0_0_GRAY[138*q + 70]));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 77],_data_tabulated_and_untitled_0_0_GRAY[138*q + 77],_data_tabulated_and_untitled_0_0_GRAY[138*q + 77],_data_tabulated_and_untitled_0_0_GRAY[138*q + 77]));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 78],_data_tabulated_and_untitled_0_0_GRAY[138*q + 78],_data_tabulated_and_untitled_0_0_GRAY[138*q + 78],_data_tabulated_and_untitled_0_0_GRAY[138*q + 78]));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 79],_data_tabulated_and_untitled_0_0_GRAY[138*q + 79],_data_tabulated_and_untitled_0_0_GRAY[138*q + 79],_data_tabulated_and_untitled_0_0_GRAY[138*q + 79]));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 80],_data_tabulated_and_untitled_0_0_GRAY[138*q + 80],_data_tabulated_and_untitled_0_0_GRAY[138*q + 80],_data_tabulated_and_untitled_0_0_GRAY[138*q + 80]));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 81],_data_tabulated_and_untitled_0_0_GRAY[138*q + 81],_data_tabulated_and_untitled_0_0_GRAY[138*q + 81],_data_tabulated_and_untitled_0_0_GRAY[138*q + 81]));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 82],_data_tabulated_and_untitled_0_0_GRAY[138*q + 82],_data_tabulated_and_untitled_0_0_GRAY[138*q + 82],_data_tabulated_and_untitled_0_0_GRAY[138*q + 82]));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 88],_data_tabulated_and_untitled_0_0_GRAY[138*q + 88],_data_tabulated_and_untitled_0_0_GRAY[138*q + 88],_data_tabulated_and_untitled_0_0_GRAY[138*q + 88]));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 89],_data_tabulated_and_untitled_0_0_GRAY[138*q + 89],_data_tabulated_and_untitled_0_0_GRAY[138*q + 89],_data_tabulated_and_untitled_0_0_GRAY[138*q + 89]));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 90],_data_tabulated_and_untitled_0_0_GRAY[138*q + 90],_data_tabulated_and_untitled_0_0_GRAY[138*q + 90],_data_tabulated_and_untitled_0_0_GRAY[138*q + 90]));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 91],_data_tabulated_and_untitled_0_0_GRAY[138*q + 91],_data_tabulated_and_untitled_0_0_GRAY[138*q + 91],_data_tabulated_and_untitled_0_0_GRAY[138*q + 91]));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 92],_data_tabulated_and_untitled_0_0_GRAY[138*q + 92],_data_tabulated_and_untitled_0_0_GRAY[138*q + 92],_data_tabulated_and_untitled_0_0_GRAY[138*q + 92]));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 98],_data_tabulated_and_untitled_0_0_GRAY[138*q + 98],_data_tabulated_and_untitled_0_0_GRAY[138*q + 98],_data_tabulated_and_untitled_0_0_GRAY[138*q + 98]));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 99],_data_tabulated_and_untitled_0_0_GRAY[138*q + 99],_data_tabulated_and_untitled_0_0_GRAY[138*q + 99],_data_tabulated_and_untitled_0_0_GRAY[138*q + 99]));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 100],_data_tabulated_and_untitled_0_0_GRAY[138*q + 100],_data_tabulated_and_untitled_0_0_GRAY[138*q + 100],_data_tabulated_and_untitled_0_0_GRAY[138*q + 100]));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 101],_data_tabulated_and_untitled_0_0_GRAY[138*q + 101],_data_tabulated_and_untitled_0_0_GRAY[138*q + 101],_data_tabulated_and_untitled_0_0_GRAY[138*q + 101]));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 111],_data_tabulated_and_untitled_0_0_GRAY[138*q + 111],_data_tabulated_and_untitled_0_0_GRAY[138*q + 111],_data_tabulated_and_untitled_0_0_GRAY[138*q + 111]));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 112],_data_tabulated_and_untitled_0_0_GRAY[138*q + 112],_data_tabulated_and_untitled_0_0_GRAY[138*q + 112],_data_tabulated_and_untitled_0_0_GRAY[138*q + 112]));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 113],_data_tabulated_and_untitled_0_0_GRAY[138*q + 113],_data_tabulated_and_untitled_0_0_GRAY[138*q + 113],_data_tabulated_and_untitled_0_0_GRAY[138*q + 113]));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 124],_data_tabulated_and_untitled_0_0_GRAY[138*q + 124],_data_tabulated_and_untitled_0_0_GRAY[138*q + 124],_data_tabulated_and_untitled_0_0_GRAY[138*q + 124]));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 125],_data_tabulated_and_untitled_0_0_GRAY[138*q + 125],_data_tabulated_and_untitled_0_0_GRAY[138*q + 125],_data_tabulated_and_untitled_0_0_GRAY[138*q + 125]));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[138*q + 137],_data_tabulated_and_untitled_0_0_GRAY[138*q + 137],_data_tabulated_and_untitled_0_0_GRAY[138*q + 137],_data_tabulated_and_untitled_0_0_GRAY[138*q + 137]));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_3 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t src_dof_6 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t src_dof_7 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_8 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_9 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_10 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_11 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t mu_dof_3 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_11_11 = 0.0;
                for (int64_t q = 0; q < 3; q += 1)
                {
                   const real_t tmp_qloop_0 = (mu_dof_0*_data_phi_0_0_GRAY[6*q] + mu_dof_1*_data_phi_0_0_GRAY[6*q + 1] + mu_dof_2*_data_phi_0_0_GRAY[6*q + 2] + mu_dof_3*_data_phi_0_0_GRAY[6*q + 3] + mu_dof_4*_data_phi_0_0_GRAY[6*q + 4] + mu_dof_5*_data_phi_0_0_GRAY[6*q + 5])*_data_q_w[q];
                   const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q];
                   const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 1];
                   const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 2];
                   const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 3];
                   const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 4];
                   const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 5];
                   const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 6];
                   const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 7];
                   const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 8];
                   const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 9];
                   const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 10];
                   const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 11];
                   const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 13];
                   const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 14];
                   const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 15];
                   const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 16];
                   const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 17];
                   const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 18];
                   const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 19];
                   const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 20];
                   const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 21];
                   const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 22];
                   const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 23];
                   const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 25];
                   const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 26];
                   const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 27];
                   const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 28];
                   const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 29];
                   const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 30];
                   const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 31];
                   const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 32];
                   const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 33];
                   const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 34];
                   const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 38];
                   const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 39];
                   const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 40];
                   const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 41];
                   const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 42];
                   const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 43];
                   const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 44];
                   const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 45];
                   const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 46];
                   const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 51];
                   const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 52];
                   const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 53];
                   const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 54];
                   const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 55];
                   const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 56];
                   const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 57];
                   const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 58];
                   const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 64];
                   const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 65];
                   const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 66];
                   const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 67];
                   const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 68];
                   const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 69];
                   const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 70];
                   const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 77];
                   const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 78];
                   const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 79];
                   const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 80];
                   const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 81];
                   const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 82];
                   const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 88];
                   const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 89];
                   const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 90];
                   const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 91];
                   const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 92];
                   const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 98];
                   const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 99];
                   const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 100];
                   const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 101];
                   const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 111];
                   const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 112];
                   const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 113];
                   const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 124];
                   const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 125];
                   const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 137];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_3 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_6 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_7 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_8 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_9 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_10 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_11 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       {
          /* FaceType.BLUE */
          const real_t _data_phi_0_0_BLUE [] = {-0.11111111111111116, -0.1111111111111111, 0.22222222222222221, 0.44444444444444442, 0.44444444444444442, 0.11111111111111116, -0.11111111111111116, 0.22222222222222221, -0.1111111111111111, 0.44444444444444442, 0.11111111111111116, 0.44444444444444442, 0.22222222222222221, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.44444444444444448, 0.44444444444444448};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE [] = {((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.22222222222222227 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-1.1111111111111112 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*5.5555555555555545 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*2.7777777777777772)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.11111111111111113 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*2.7777777777777772 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315) + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*5.5555555555555545 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-1.1111111111111112 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*2.7777777777777772)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.22222222222222227 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*2.7777777777777772 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.11111111111111113 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.22222222222222227 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*0.22222222222222227 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.22222222222222227 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.11111111111111113 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*0.11111111111111113 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.11111111111111113 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333))))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 3; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_BLUE[6*q],_data_phi_0_0_BLUE[6*q],_data_phi_0_0_BLUE[6*q],_data_phi_0_0_BLUE[6*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_BLUE[6*q + 1],_data_phi_0_0_BLUE[6*q + 1],_data_phi_0_0_BLUE[6*q + 1],_data_phi_0_0_BLUE[6*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_BLUE[6*q + 2],_data_phi_0_0_BLUE[6*q + 2],_data_phi_0_0_BLUE[6*q + 2],_data_phi_0_0_BLUE[6*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_BLUE[6*q + 3],_data_phi_0_0_BLUE[6*q + 3],_data_phi_0_0_BLUE[6*q + 3],_data_phi_0_0_BLUE[6*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_BLUE[6*q + 4],_data_phi_0_0_BLUE[6*q + 4],_data_phi_0_0_BLUE[6*q + 4],_data_phi_0_0_BLUE[6*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_BLUE[6*q + 5],_data_phi_0_0_BLUE[6*q + 5],_data_phi_0_0_BLUE[6*q + 5],_data_phi_0_0_BLUE[6*q + 5]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q],_data_tabulated_and_untitled_0_0_BLUE[138*q],_data_tabulated_and_untitled_0_0_BLUE[138*q],_data_tabulated_and_untitled_0_0_BLUE[138*q]));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 1],_data_tabulated_and_untitled_0_0_BLUE[138*q + 1],_data_tabulated_and_untitled_0_0_BLUE[138*q + 1],_data_tabulated_and_untitled_0_0_BLUE[138*q + 1]));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 2],_data_tabulated_and_untitled_0_0_BLUE[138*q + 2],_data_tabulated_and_untitled_0_0_BLUE[138*q + 2],_data_tabulated_and_untitled_0_0_BLUE[138*q + 2]));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 3],_data_tabulated_and_untitled_0_0_BLUE[138*q + 3],_data_tabulated_and_untitled_0_0_BLUE[138*q + 3],_data_tabulated_and_untitled_0_0_BLUE[138*q + 3]));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 4],_data_tabulated_and_untitled_0_0_BLUE[138*q + 4],_data_tabulated_and_untitled_0_0_BLUE[138*q + 4],_data_tabulated_and_untitled_0_0_BLUE[138*q + 4]));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 5],_data_tabulated_and_untitled_0_0_BLUE[138*q + 5],_data_tabulated_and_untitled_0_0_BLUE[138*q + 5],_data_tabulated_and_untitled_0_0_BLUE[138*q + 5]));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 6],_data_tabulated_and_untitled_0_0_BLUE[138*q + 6],_data_tabulated_and_untitled_0_0_BLUE[138*q + 6],_data_tabulated_and_untitled_0_0_BLUE[138*q + 6]));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 7],_data_tabulated_and_untitled_0_0_BLUE[138*q + 7],_data_tabulated_and_untitled_0_0_BLUE[138*q + 7],_data_tabulated_and_untitled_0_0_BLUE[138*q + 7]));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 8],_data_tabulated_and_untitled_0_0_BLUE[138*q + 8],_data_tabulated_and_untitled_0_0_BLUE[138*q + 8],_data_tabulated_and_untitled_0_0_BLUE[138*q + 8]));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 9],_data_tabulated_and_untitled_0_0_BLUE[138*q + 9],_data_tabulated_and_untitled_0_0_BLUE[138*q + 9],_data_tabulated_and_untitled_0_0_BLUE[138*q + 9]));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 10],_data_tabulated_and_untitled_0_0_BLUE[138*q + 10],_data_tabulated_and_untitled_0_0_BLUE[138*q + 10],_data_tabulated_and_untitled_0_0_BLUE[138*q + 10]));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 11],_data_tabulated_and_untitled_0_0_BLUE[138*q + 11],_data_tabulated_and_untitled_0_0_BLUE[138*q + 11],_data_tabulated_and_untitled_0_0_BLUE[138*q + 11]));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 13],_data_tabulated_and_untitled_0_0_BLUE[138*q + 13],_data_tabulated_and_untitled_0_0_BLUE[138*q + 13],_data_tabulated_and_untitled_0_0_BLUE[138*q + 13]));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 14],_data_tabulated_and_untitled_0_0_BLUE[138*q + 14],_data_tabulated_and_untitled_0_0_BLUE[138*q + 14],_data_tabulated_and_untitled_0_0_BLUE[138*q + 14]));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 15],_data_tabulated_and_untitled_0_0_BLUE[138*q + 15],_data_tabulated_and_untitled_0_0_BLUE[138*q + 15],_data_tabulated_and_untitled_0_0_BLUE[138*q + 15]));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 16],_data_tabulated_and_untitled_0_0_BLUE[138*q + 16],_data_tabulated_and_untitled_0_0_BLUE[138*q + 16],_data_tabulated_and_untitled_0_0_BLUE[138*q + 16]));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 17],_data_tabulated_and_untitled_0_0_BLUE[138*q + 17],_data_tabulated_and_untitled_0_0_BLUE[138*q + 17],_data_tabulated_and_untitled_0_0_BLUE[138*q + 17]));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 18],_data_tabulated_and_untitled_0_0_BLUE[138*q + 18],_data_tabulated_and_untitled_0_0_BLUE[138*q + 18],_data_tabulated_and_untitled_0_0_BLUE[138*q + 18]));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 19],_data_tabulated_and_untitled_0_0_BLUE[138*q + 19],_data_tabulated_and_untitled_0_0_BLUE[138*q + 19],_data_tabulated_and_untitled_0_0_BLUE[138*q + 19]));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 20],_data_tabulated_and_untitled_0_0_BLUE[138*q + 20],_data_tabulated_and_untitled_0_0_BLUE[138*q + 20],_data_tabulated_and_untitled_0_0_BLUE[138*q + 20]));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 21],_data_tabulated_and_untitled_0_0_BLUE[138*q + 21],_data_tabulated_and_untitled_0_0_BLUE[138*q + 21],_data_tabulated_and_untitled_0_0_BLUE[138*q + 21]));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 22],_data_tabulated_and_untitled_0_0_BLUE[138*q + 22],_data_tabulated_and_untitled_0_0_BLUE[138*q + 22],_data_tabulated_and_untitled_0_0_BLUE[138*q + 22]));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 23],_data_tabulated_and_untitled_0_0_BLUE[138*q + 23],_data_tabulated_and_untitled_0_0_BLUE[138*q + 23],_data_tabulated_and_untitled_0_0_BLUE[138*q + 23]));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 25],_data_tabulated_and_untitled_0_0_BLUE[138*q + 25],_data_tabulated_and_untitled_0_0_BLUE[138*q + 25],_data_tabulated_and_untitled_0_0_BLUE[138*q + 25]));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 26],_data_tabulated_and_untitled_0_0_BLUE[138*q + 26],_data_tabulated_and_untitled_0_0_BLUE[138*q + 26],_data_tabulated_and_untitled_0_0_BLUE[138*q + 26]));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 27],_data_tabulated_and_untitled_0_0_BLUE[138*q + 27],_data_tabulated_and_untitled_0_0_BLUE[138*q + 27],_data_tabulated_and_untitled_0_0_BLUE[138*q + 27]));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 28],_data_tabulated_and_untitled_0_0_BLUE[138*q + 28],_data_tabulated_and_untitled_0_0_BLUE[138*q + 28],_data_tabulated_and_untitled_0_0_BLUE[138*q + 28]));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 29],_data_tabulated_and_untitled_0_0_BLUE[138*q + 29],_data_tabulated_and_untitled_0_0_BLUE[138*q + 29],_data_tabulated_and_untitled_0_0_BLUE[138*q + 29]));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 30],_data_tabulated_and_untitled_0_0_BLUE[138*q + 30],_data_tabulated_and_untitled_0_0_BLUE[138*q + 30],_data_tabulated_and_untitled_0_0_BLUE[138*q + 30]));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 31],_data_tabulated_and_untitled_0_0_BLUE[138*q + 31],_data_tabulated_and_untitled_0_0_BLUE[138*q + 31],_data_tabulated_and_untitled_0_0_BLUE[138*q + 31]));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 32],_data_tabulated_and_untitled_0_0_BLUE[138*q + 32],_data_tabulated_and_untitled_0_0_BLUE[138*q + 32],_data_tabulated_and_untitled_0_0_BLUE[138*q + 32]));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 33],_data_tabulated_and_untitled_0_0_BLUE[138*q + 33],_data_tabulated_and_untitled_0_0_BLUE[138*q + 33],_data_tabulated_and_untitled_0_0_BLUE[138*q + 33]));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 34],_data_tabulated_and_untitled_0_0_BLUE[138*q + 34],_data_tabulated_and_untitled_0_0_BLUE[138*q + 34],_data_tabulated_and_untitled_0_0_BLUE[138*q + 34]));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 38],_data_tabulated_and_untitled_0_0_BLUE[138*q + 38],_data_tabulated_and_untitled_0_0_BLUE[138*q + 38],_data_tabulated_and_untitled_0_0_BLUE[138*q + 38]));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 39],_data_tabulated_and_untitled_0_0_BLUE[138*q + 39],_data_tabulated_and_untitled_0_0_BLUE[138*q + 39],_data_tabulated_and_untitled_0_0_BLUE[138*q + 39]));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 40],_data_tabulated_and_untitled_0_0_BLUE[138*q + 40],_data_tabulated_and_untitled_0_0_BLUE[138*q + 40],_data_tabulated_and_untitled_0_0_BLUE[138*q + 40]));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 41],_data_tabulated_and_untitled_0_0_BLUE[138*q + 41],_data_tabulated_and_untitled_0_0_BLUE[138*q + 41],_data_tabulated_and_untitled_0_0_BLUE[138*q + 41]));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 42],_data_tabulated_and_untitled_0_0_BLUE[138*q + 42],_data_tabulated_and_untitled_0_0_BLUE[138*q + 42],_data_tabulated_and_untitled_0_0_BLUE[138*q + 42]));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 43],_data_tabulated_and_untitled_0_0_BLUE[138*q + 43],_data_tabulated_and_untitled_0_0_BLUE[138*q + 43],_data_tabulated_and_untitled_0_0_BLUE[138*q + 43]));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 44],_data_tabulated_and_untitled_0_0_BLUE[138*q + 44],_data_tabulated_and_untitled_0_0_BLUE[138*q + 44],_data_tabulated_and_untitled_0_0_BLUE[138*q + 44]));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 45],_data_tabulated_and_untitled_0_0_BLUE[138*q + 45],_data_tabulated_and_untitled_0_0_BLUE[138*q + 45],_data_tabulated_and_untitled_0_0_BLUE[138*q + 45]));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 46],_data_tabulated_and_untitled_0_0_BLUE[138*q + 46],_data_tabulated_and_untitled_0_0_BLUE[138*q + 46],_data_tabulated_and_untitled_0_0_BLUE[138*q + 46]));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 51],_data_tabulated_and_untitled_0_0_BLUE[138*q + 51],_data_tabulated_and_untitled_0_0_BLUE[138*q + 51],_data_tabulated_and_untitled_0_0_BLUE[138*q + 51]));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 52],_data_tabulated_and_untitled_0_0_BLUE[138*q + 52],_data_tabulated_and_untitled_0_0_BLUE[138*q + 52],_data_tabulated_and_untitled_0_0_BLUE[138*q + 52]));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 53],_data_tabulated_and_untitled_0_0_BLUE[138*q + 53],_data_tabulated_and_untitled_0_0_BLUE[138*q + 53],_data_tabulated_and_untitled_0_0_BLUE[138*q + 53]));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 54],_data_tabulated_and_untitled_0_0_BLUE[138*q + 54],_data_tabulated_and_untitled_0_0_BLUE[138*q + 54],_data_tabulated_and_untitled_0_0_BLUE[138*q + 54]));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 55],_data_tabulated_and_untitled_0_0_BLUE[138*q + 55],_data_tabulated_and_untitled_0_0_BLUE[138*q + 55],_data_tabulated_and_untitled_0_0_BLUE[138*q + 55]));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 56],_data_tabulated_and_untitled_0_0_BLUE[138*q + 56],_data_tabulated_and_untitled_0_0_BLUE[138*q + 56],_data_tabulated_and_untitled_0_0_BLUE[138*q + 56]));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 57],_data_tabulated_and_untitled_0_0_BLUE[138*q + 57],_data_tabulated_and_untitled_0_0_BLUE[138*q + 57],_data_tabulated_and_untitled_0_0_BLUE[138*q + 57]));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 58],_data_tabulated_and_untitled_0_0_BLUE[138*q + 58],_data_tabulated_and_untitled_0_0_BLUE[138*q + 58],_data_tabulated_and_untitled_0_0_BLUE[138*q + 58]));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 64],_data_tabulated_and_untitled_0_0_BLUE[138*q + 64],_data_tabulated_and_untitled_0_0_BLUE[138*q + 64],_data_tabulated_and_untitled_0_0_BLUE[138*q + 64]));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 65],_data_tabulated_and_untitled_0_0_BLUE[138*q + 65],_data_tabulated_and_untitled_0_0_BLUE[138*q + 65],_data_tabulated_and_untitled_0_0_BLUE[138*q + 65]));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 66],_data_tabulated_and_untitled_0_0_BLUE[138*q + 66],_data_tabulated_and_untitled_0_0_BLUE[138*q + 66],_data_tabulated_and_untitled_0_0_BLUE[138*q + 66]));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 67],_data_tabulated_and_untitled_0_0_BLUE[138*q + 67],_data_tabulated_and_untitled_0_0_BLUE[138*q + 67],_data_tabulated_and_untitled_0_0_BLUE[138*q + 67]));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 68],_data_tabulated_and_untitled_0_0_BLUE[138*q + 68],_data_tabulated_and_untitled_0_0_BLUE[138*q + 68],_data_tabulated_and_untitled_0_0_BLUE[138*q + 68]));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 69],_data_tabulated_and_untitled_0_0_BLUE[138*q + 69],_data_tabulated_and_untitled_0_0_BLUE[138*q + 69],_data_tabulated_and_untitled_0_0_BLUE[138*q + 69]));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 70],_data_tabulated_and_untitled_0_0_BLUE[138*q + 70],_data_tabulated_and_untitled_0_0_BLUE[138*q + 70],_data_tabulated_and_untitled_0_0_BLUE[138*q + 70]));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 77],_data_tabulated_and_untitled_0_0_BLUE[138*q + 77],_data_tabulated_and_untitled_0_0_BLUE[138*q + 77],_data_tabulated_and_untitled_0_0_BLUE[138*q + 77]));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 78],_data_tabulated_and_untitled_0_0_BLUE[138*q + 78],_data_tabulated_and_untitled_0_0_BLUE[138*q + 78],_data_tabulated_and_untitled_0_0_BLUE[138*q + 78]));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 79],_data_tabulated_and_untitled_0_0_BLUE[138*q + 79],_data_tabulated_and_untitled_0_0_BLUE[138*q + 79],_data_tabulated_and_untitled_0_0_BLUE[138*q + 79]));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 80],_data_tabulated_and_untitled_0_0_BLUE[138*q + 80],_data_tabulated_and_untitled_0_0_BLUE[138*q + 80],_data_tabulated_and_untitled_0_0_BLUE[138*q + 80]));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 81],_data_tabulated_and_untitled_0_0_BLUE[138*q + 81],_data_tabulated_and_untitled_0_0_BLUE[138*q + 81],_data_tabulated_and_untitled_0_0_BLUE[138*q + 81]));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 82],_data_tabulated_and_untitled_0_0_BLUE[138*q + 82],_data_tabulated_and_untitled_0_0_BLUE[138*q + 82],_data_tabulated_and_untitled_0_0_BLUE[138*q + 82]));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 88],_data_tabulated_and_untitled_0_0_BLUE[138*q + 88],_data_tabulated_and_untitled_0_0_BLUE[138*q + 88],_data_tabulated_and_untitled_0_0_BLUE[138*q + 88]));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 89],_data_tabulated_and_untitled_0_0_BLUE[138*q + 89],_data_tabulated_and_untitled_0_0_BLUE[138*q + 89],_data_tabulated_and_untitled_0_0_BLUE[138*q + 89]));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 90],_data_tabulated_and_untitled_0_0_BLUE[138*q + 90],_data_tabulated_and_untitled_0_0_BLUE[138*q + 90],_data_tabulated_and_untitled_0_0_BLUE[138*q + 90]));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 91],_data_tabulated_and_untitled_0_0_BLUE[138*q + 91],_data_tabulated_and_untitled_0_0_BLUE[138*q + 91],_data_tabulated_and_untitled_0_0_BLUE[138*q + 91]));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 92],_data_tabulated_and_untitled_0_0_BLUE[138*q + 92],_data_tabulated_and_untitled_0_0_BLUE[138*q + 92],_data_tabulated_and_untitled_0_0_BLUE[138*q + 92]));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 98],_data_tabulated_and_untitled_0_0_BLUE[138*q + 98],_data_tabulated_and_untitled_0_0_BLUE[138*q + 98],_data_tabulated_and_untitled_0_0_BLUE[138*q + 98]));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 99],_data_tabulated_and_untitled_0_0_BLUE[138*q + 99],_data_tabulated_and_untitled_0_0_BLUE[138*q + 99],_data_tabulated_and_untitled_0_0_BLUE[138*q + 99]));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 100],_data_tabulated_and_untitled_0_0_BLUE[138*q + 100],_data_tabulated_and_untitled_0_0_BLUE[138*q + 100],_data_tabulated_and_untitled_0_0_BLUE[138*q + 100]));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 101],_data_tabulated_and_untitled_0_0_BLUE[138*q + 101],_data_tabulated_and_untitled_0_0_BLUE[138*q + 101],_data_tabulated_and_untitled_0_0_BLUE[138*q + 101]));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 111],_data_tabulated_and_untitled_0_0_BLUE[138*q + 111],_data_tabulated_and_untitled_0_0_BLUE[138*q + 111],_data_tabulated_and_untitled_0_0_BLUE[138*q + 111]));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 112],_data_tabulated_and_untitled_0_0_BLUE[138*q + 112],_data_tabulated_and_untitled_0_0_BLUE[138*q + 112],_data_tabulated_and_untitled_0_0_BLUE[138*q + 112]));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 113],_data_tabulated_and_untitled_0_0_BLUE[138*q + 113],_data_tabulated_and_untitled_0_0_BLUE[138*q + 113],_data_tabulated_and_untitled_0_0_BLUE[138*q + 113]));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 124],_data_tabulated_and_untitled_0_0_BLUE[138*q + 124],_data_tabulated_and_untitled_0_0_BLUE[138*q + 124],_data_tabulated_and_untitled_0_0_BLUE[138*q + 124]));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 125],_data_tabulated_and_untitled_0_0_BLUE[138*q + 125],_data_tabulated_and_untitled_0_0_BLUE[138*q + 125],_data_tabulated_and_untitled_0_0_BLUE[138*q + 125]));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[138*q + 137],_data_tabulated_and_untitled_0_0_BLUE[138*q + 137],_data_tabulated_and_untitled_0_0_BLUE[138*q + 137],_data_tabulated_and_untitled_0_0_BLUE[138*q + 137]));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t src_dof_3 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_6 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_7 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_8 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t src_dof_9 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_10 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t src_dof_11 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t mu_dof_3 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_11_11 = 0.0;
                for (int64_t q = 0; q < 3; q += 1)
                {
                   const real_t tmp_qloop_0 = (mu_dof_0*_data_phi_0_0_BLUE[6*q] + mu_dof_1*_data_phi_0_0_BLUE[6*q + 1] + mu_dof_2*_data_phi_0_0_BLUE[6*q + 2] + mu_dof_3*_data_phi_0_0_BLUE[6*q + 3] + mu_dof_4*_data_phi_0_0_BLUE[6*q + 4] + mu_dof_5*_data_phi_0_0_BLUE[6*q + 5])*_data_q_w[q];
                   const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q];
                   const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 1];
                   const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 2];
                   const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 3];
                   const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 4];
                   const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 5];
                   const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 6];
                   const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 7];
                   const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 8];
                   const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 9];
                   const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 10];
                   const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 11];
                   const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 13];
                   const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 14];
                   const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 15];
                   const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 16];
                   const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 17];
                   const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 18];
                   const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 19];
                   const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 20];
                   const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 21];
                   const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 22];
                   const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 23];
                   const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 25];
                   const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 26];
                   const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 27];
                   const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 28];
                   const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 29];
                   const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 30];
                   const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 31];
                   const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 32];
                   const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 33];
                   const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 34];
                   const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 38];
                   const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 39];
                   const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 40];
                   const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 41];
                   const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 42];
                   const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 43];
                   const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 44];
                   const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 45];
                   const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 46];
                   const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 51];
                   const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 52];
                   const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 53];
                   const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 54];
                   const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 55];
                   const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 56];
                   const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 57];
                   const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 58];
                   const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 64];
                   const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 65];
                   const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 66];
                   const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 67];
                   const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 68];
                   const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 69];
                   const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 70];
                   const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 77];
                   const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 78];
                   const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 79];
                   const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 80];
                   const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 81];
                   const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 82];
                   const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 88];
                   const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 89];
                   const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 90];
                   const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 91];
                   const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 92];
                   const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 98];
                   const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 99];
                   const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 100];
                   const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 101];
                   const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 111];
                   const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 112];
                   const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 113];
                   const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 124];
                   const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 125];
                   const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 137];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_3 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_6 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_7 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_8 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_9 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatVec_10 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_11 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
