/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

































#include "../P2VectorElementwiseFullStokesIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseFullStokesIcosahedralShellMap::computeInverseDiagonalOperatorValues_P2VectorElementwiseFullStokesIcosahedralShellMap_macro_3D( real_t * RESTRICT  _data_invDiag__edge_0, real_t * RESTRICT  _data_invDiag__edge_1, real_t * RESTRICT  _data_invDiag__edge_2, real_t * RESTRICT  _data_invDiag__vertex_0, real_t * RESTRICT  _data_invDiag__vertex_1, real_t * RESTRICT  _data_invDiag__vertex_2, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {-0.1333333333333333, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983};
   
       const real_t _data_q_p_0 [] = {0.25, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.25, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_2 [] = {0.25, 0.5, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_1 = -rayVertex_0;
       const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
       const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
       const real_t tmp_qloop_8 = -rayVertex_1;
       const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
       const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_12 = -rayVertex_2;
       const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
       const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
       const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
       const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
       const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
       const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
       const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
       const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_39 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
       const real_t tmp_qloop_40 = tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_45 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
       const real_t tmp_qloop_46 = -tmp_qloop_21*tmp_qloop_45;
       const real_t tmp_qloop_53 = -tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_68 = tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_72 = tmp_qloop_21*tmp_qloop_45;
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_UP [] = {0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(abs_det_jac_affine_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(abs_det_jac_affine_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(abs_det_jac_affine_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5]));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6]));
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7]));
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8]));
                   const __m256d tmp_qloop_212 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9]));
                   const __m256d tmp_qloop_221 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10]));
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_297 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_354 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q]));
                   const __m256d tmp_qloop_137 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2]));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9]));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10]));
                   const __m256d tmp_qloop_230 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_243 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_303 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_312 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_402 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_411 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_420 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_429 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q]));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2]));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3]));
                   const __m256d tmp_qloop_173 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4]));
                   const __m256d tmp_qloop_182 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5]));
                   const __m256d tmp_qloop_191 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6]));
                   const __m256d tmp_qloop_200 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_252 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11]));
                   const __m256d tmp_qloop_264 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_273 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_282 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_291 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_318 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_327 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_336 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_360 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_369 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_378 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_387 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_396 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_186 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_195 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_204 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_213 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_234 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_280 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_289 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_298 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_345 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_355 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_364 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_373 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_382 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_225 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_304 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_313 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_322 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_331 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_430 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_128 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_265 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_340 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_388 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_397 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_406 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_415 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_424 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_122,tmp_qloop_123),tmp_qloop_124);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_169 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_178 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_187 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_236 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_233,tmp_qloop_234),tmp_qloop_235);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_251 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_281 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_290 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_299 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_308 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_317 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_326 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_346 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_374 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_383 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_392 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_401 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_410 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_137,tmp_qloop_138),tmp_qloop_139);
                   const __m256d tmp_qloop_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_138,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_199 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_208 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_217 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_226 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_246 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_243,tmp_qloop_244),tmp_qloop_245);
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_243,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_244,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_245,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_260 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_269 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_296 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_332 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_342 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_236);
                   const __m256d tmp_qloop_343 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_238);
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_246),_mm256_add_pd(tmp_qloop_126,tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_251);
                   const __m256d tmp_qloop_359 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_368 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_129 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_144 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_141,tmp_qloop_142),tmp_qloop_143);
                   const __m256d tmp_qloop_146 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_141,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_142,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_143,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_144),_mm256_add_pd(tmp_qloop_145,tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_136);
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_237 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_236);
                   const __m256d tmp_qloop_239 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_238);
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_255 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_252,tmp_qloop_253),tmp_qloop_254);
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_253,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_254,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_257 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_255),_mm256_add_pd(tmp_qloop_134,tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_136),tmp_qloop_251);
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_341 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_416 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_425 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10]));
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_119,tmp_qloop_120),tmp_qloop_121),tmp_qloop_125),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_120,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_121,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_128),tmp_qloop_129),tmp_qloop_133),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_129,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_114)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_152),tmp_qloop_153),tmp_qloop_154),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_154,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_155),tmp_qloop_156),tmp_qloop_157),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_155,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_156,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_149),tmp_qloop_150),tmp_qloop_151)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_161),tmp_qloop_162),tmp_qloop_163),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_162,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_163,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_164),tmp_qloop_165),tmp_qloop_166),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_164,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_165,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_166,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_158),tmp_qloop_159),tmp_qloop_160)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_173),tmp_qloop_174),tmp_qloop_175),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_173,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_174,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_175,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_167),tmp_qloop_168),tmp_qloop_169)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_179,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_180,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_181,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_182),tmp_qloop_183),tmp_qloop_184),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_182,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_176),tmp_qloop_177),tmp_qloop_178)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_188,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_189,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_190,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_191),tmp_qloop_192),tmp_qloop_193),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_191,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_192,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_193,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_185),tmp_qloop_186),tmp_qloop_187)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_197),tmp_qloop_198),tmp_qloop_199),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_199,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_200),tmp_qloop_201),tmp_qloop_202),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_201,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_202,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_194),tmp_qloop_195),tmp_qloop_196)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_206),tmp_qloop_207),tmp_qloop_208),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_206,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_207,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_208,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_203),tmp_qloop_204),tmp_qloop_205)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_215),tmp_qloop_216),tmp_qloop_217),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_215,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_216,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_217,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_218,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_219,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_220,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_212),tmp_qloop_213),tmp_qloop_214)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_224),tmp_qloop_225),tmp_qloop_226),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_225,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_226,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_227,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_228,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_229,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_221),tmp_qloop_222),tmp_qloop_223)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_240,tmp_qloop_241),tmp_qloop_242),tmp_qloop_246),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_240,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_241,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_242,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_230,tmp_qloop_231),tmp_qloop_232),tmp_qloop_237)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_264),tmp_qloop_265),tmp_qloop_266),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_264,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_265,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_266,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_258),tmp_qloop_259),tmp_qloop_260)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_270,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_271,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_272,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_273),tmp_qloop_274),tmp_qloop_275),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_273,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_267),tmp_qloop_268),tmp_qloop_269)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_279),tmp_qloop_280),tmp_qloop_281),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_280,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_281,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_282),tmp_qloop_283),tmp_qloop_284),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_282,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_283,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_284,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_276),tmp_qloop_277),tmp_qloop_278)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_288),tmp_qloop_289),tmp_qloop_290),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_289,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_290,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_291),tmp_qloop_292),tmp_qloop_293),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_291,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_292,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_285),tmp_qloop_286),tmp_qloop_287)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_297),tmp_qloop_298),tmp_qloop_299),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_298,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_299,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_300,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_301,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_302,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_294),tmp_qloop_295),tmp_qloop_296)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_306),tmp_qloop_307),tmp_qloop_308),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_308,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_309,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_310,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_311,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_303),tmp_qloop_304),tmp_qloop_305)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_315),tmp_qloop_316),tmp_qloop_317),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_315,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_316,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_317,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_318),tmp_qloop_319),tmp_qloop_320),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_318,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_312),tmp_qloop_313),tmp_qloop_314)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_324),tmp_qloop_325),tmp_qloop_326),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_324,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_325,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_326,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_327),tmp_qloop_328),tmp_qloop_329),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_327,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_328,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_329,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_321),tmp_qloop_322),tmp_qloop_323)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_333),tmp_qloop_334),tmp_qloop_335),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_336),tmp_qloop_337),tmp_qloop_338),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_336,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_337,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_338,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_330),tmp_qloop_331),tmp_qloop_332)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_344),tmp_qloop_345),tmp_qloop_346),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_344,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_345,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_346,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_347),tmp_qloop_348),tmp_qloop_349),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_339,tmp_qloop_340),tmp_qloop_341),tmp_qloop_342)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_354),tmp_qloop_355),tmp_qloop_356),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_355,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_356,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_357),tmp_qloop_358),tmp_qloop_359),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_357,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_358,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_359,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_363),tmp_qloop_364),tmp_qloop_365),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_364,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_365,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_366),tmp_qloop_367),tmp_qloop_368),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_366,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_367,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_368,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_360),tmp_qloop_361),tmp_qloop_362)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_372),tmp_qloop_373),tmp_qloop_374),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_372,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_373,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_374,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_375),tmp_qloop_376),tmp_qloop_377),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_369),tmp_qloop_370),tmp_qloop_371)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_381),tmp_qloop_382),tmp_qloop_383),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_381,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_382,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_383,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_384,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_385,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_386,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_378),tmp_qloop_379),tmp_qloop_380)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_390),tmp_qloop_391),tmp_qloop_392),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_392,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_393,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_394,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_395,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_387),tmp_qloop_388),tmp_qloop_389)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_399),tmp_qloop_400),tmp_qloop_401),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_399,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_400,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_401,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_402),tmp_qloop_403),tmp_qloop_404),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_402,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_396),tmp_qloop_397),tmp_qloop_398)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_408),tmp_qloop_409),tmp_qloop_410),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_408,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_409,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_410,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_411),tmp_qloop_412),tmp_qloop_413),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_411,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_412,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_413,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_405),tmp_qloop_406),tmp_qloop_407)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_417),tmp_qloop_418),tmp_qloop_419),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_420),tmp_qloop_421),tmp_qloop_422),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_420,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_421,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_422,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_414),tmp_qloop_415),tmp_qloop_416)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_426,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_427,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_428,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_429),tmp_qloop_430),tmp_qloop_431),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_429,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_430,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_423),tmp_qloop_424),tmp_qloop_425)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                const __m256d elMatDiag_4 = q_acc_4_4;
                const __m256d elMatDiag_5 = q_acc_5_5;
                const __m256d elMatDiag_6 = q_acc_6_6;
                const __m256d elMatDiag_7 = q_acc_7_7;
                const __m256d elMatDiag_8 = q_acc_8_8;
                const __m256d elMatDiag_9 = q_acc_9_9;
                const __m256d elMatDiag_10 = q_acc_10_10;
                const __m256d elMatDiag_11 = q_acc_11_11;
                const __m256d elMatDiag_12 = q_acc_12_12;
                const __m256d elMatDiag_13 = q_acc_13_13;
                const __m256d elMatDiag_14 = q_acc_14_14;
                const __m256d elMatDiag_15 = q_acc_15_15;
                const __m256d elMatDiag_16 = q_acc_16_16;
                const __m256d elMatDiag_17 = q_acc_17_17;
                const __m256d elMatDiag_18 = q_acc_18_18;
                const __m256d elMatDiag_19 = q_acc_19_19;
                const __m256d elMatDiag_20 = q_acc_20_20;
                const __m256d elMatDiag_21 = q_acc_21_21;
                const __m256d elMatDiag_22 = q_acc_22_22;
                const __m256d elMatDiag_23 = q_acc_23_23;
                const __m256d elMatDiag_24 = q_acc_24_24;
                const __m256d elMatDiag_25 = q_acc_25_25;
                const __m256d elMatDiag_26 = q_acc_26_26;
                const __m256d elMatDiag_27 = q_acc_27_27;
                const __m256d elMatDiag_28 = q_acc_28_28;
                const __m256d elMatDiag_29 = q_acc_29_29;
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_10,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_11,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_12,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_13,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_14,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_15,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_16,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_17,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_18,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_19,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_20,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_21,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_22,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_23,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_24,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_25,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_26,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_27,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_28,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_29,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_148 = (mu_dof_0*_data_phi_0_0_WHITE_UP[10*q] + mu_dof_1*_data_phi_0_0_WHITE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_UP[10*q + 9])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2];
                   const real_t tmp_qloop_158 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3];
                   const real_t tmp_qloop_167 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4];
                   const real_t tmp_qloop_176 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5];
                   const real_t tmp_qloop_185 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6];
                   const real_t tmp_qloop_194 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7];
                   const real_t tmp_qloop_203 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8];
                   const real_t tmp_qloop_212 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9];
                   const real_t tmp_qloop_221 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10];
                   const real_t tmp_qloop_233 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_279 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_288 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_297 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_306 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_315 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_324 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_344 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_354 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_363 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_372 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_381 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_390 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_399 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_408 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_119 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q];
                   const real_t tmp_qloop_137 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_152 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2];
                   const real_t tmp_qloop_161 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6];
                   const real_t tmp_qloop_197 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7];
                   const real_t tmp_qloop_206 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8];
                   const real_t tmp_qloop_215 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9];
                   const real_t tmp_qloop_224 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10];
                   const real_t tmp_qloop_230 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_243 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11];
                   const real_t tmp_qloop_258 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_267 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_276 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_285 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_294 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_303 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_312 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_321 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_330 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_357 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_366 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_402 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_411 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_420 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_429 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_127 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q];
                   const real_t tmp_qloop_141 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_155 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2];
                   const real_t tmp_qloop_164 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3];
                   const real_t tmp_qloop_173 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4];
                   const real_t tmp_qloop_182 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5];
                   const real_t tmp_qloop_191 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6];
                   const real_t tmp_qloop_200 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_252 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11];
                   const real_t tmp_qloop_264 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_273 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_282 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_291 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_318 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_327 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_336 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_339 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_360 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_369 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_378 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_387 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_396 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_405 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_414 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_123 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_150 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_159 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_168 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_177 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_186 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_195 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_204 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_213 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_222 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_234 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_280 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_289 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_298 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_307 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_316 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_325 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_345 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_355 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_364 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_373 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_382 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_391 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_400 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_409 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_120 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_138 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_153 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_162 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_198 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_207 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_216 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_225 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_231 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_244 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_259 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_268 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_277 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_286 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_295 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_304 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_313 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_322 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_331 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_358 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_367 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_403 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_412 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_421 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_430 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_128 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_142 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_156 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_165 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_174 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_192 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_201 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_253 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_265 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_274 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_283 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_292 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_319 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_328 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_337 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_340 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_361 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_370 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_379 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_388 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_397 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_406 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_415 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_424 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_125 = tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_124;
                   const real_t tmp_qloop_126 = tmp_qloop_122*0.5 + tmp_qloop_123*0.5 + tmp_qloop_124*0.5;
                   const real_t tmp_qloop_132 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_133 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132;
                   const real_t tmp_qloop_134 = tmp_qloop_130*0.5 + tmp_qloop_131*0.5 + tmp_qloop_132*0.5;
                   const real_t tmp_qloop_151 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_160 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_169 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_178 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_187 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_196 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_205 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_214 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_223 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_235 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_236 = tmp_qloop_233 + tmp_qloop_234 + tmp_qloop_235;
                   const real_t tmp_qloop_238 = tmp_qloop_233*0.66666666666666663 + tmp_qloop_234*0.66666666666666663 + tmp_qloop_235*0.66666666666666663;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_251 = (tmp_qloop_233*1.0 + tmp_qloop_234*1.0 + tmp_qloop_235*1.0)*(tmp_qloop_233*2.0 + tmp_qloop_234*2.0 + tmp_qloop_235*2.0);
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_272 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_281 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_290 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_299 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_308 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_317 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_326 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_335 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_346 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_356 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_365 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_374 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_383 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_392 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_401 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_410 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_419 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_428 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_116 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_121 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_135 = (tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0)*(tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0);
                   const real_t tmp_qloop_139 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_140 = tmp_qloop_137 + tmp_qloop_138 + tmp_qloop_139;
                   const real_t tmp_qloop_145 = tmp_qloop_137*0.5 + tmp_qloop_138*0.5 + tmp_qloop_139*0.5;
                   const real_t tmp_qloop_154 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_163 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_172 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_181 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_199 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_208 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_217 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_226 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_232 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_245 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_246 = tmp_qloop_243 + tmp_qloop_244 + tmp_qloop_245;
                   const real_t tmp_qloop_247 = tmp_qloop_243*0.5 + tmp_qloop_244*0.5 + tmp_qloop_245*0.5;
                   const real_t tmp_qloop_260 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_269 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_278 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_287 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_296 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_305 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_314 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_323 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_332 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_342 = tmp_qloop_113 + tmp_qloop_236;
                   const real_t tmp_qloop_343 = tmp_qloop_116 + tmp_qloop_238;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_350 = tmp_qloop_135 + tmp_qloop_251 + (tmp_qloop_125 + tmp_qloop_246)*(tmp_qloop_126 + tmp_qloop_247)*2.0;
                   const real_t tmp_qloop_359 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_368 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_386 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_404 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_413 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_422 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_431 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_129 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_136 = (tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_143 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_144 = tmp_qloop_141 + tmp_qloop_142 + tmp_qloop_143;
                   const real_t tmp_qloop_146 = tmp_qloop_141*0.5 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5;
                   const real_t tmp_qloop_147 = tmp_qloop_135 + tmp_qloop_136 + (tmp_qloop_140 + tmp_qloop_144)*(tmp_qloop_145 + tmp_qloop_146)*2.0;
                   const real_t tmp_qloop_157 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_166 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_184 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_193 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_202 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_211 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_229 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_237 = tmp_qloop_109 + tmp_qloop_236;
                   const real_t tmp_qloop_239 = tmp_qloop_115 + tmp_qloop_238;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_254 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_255 = tmp_qloop_252 + tmp_qloop_253 + tmp_qloop_254;
                   const real_t tmp_qloop_256 = tmp_qloop_252*0.5 + tmp_qloop_253*0.5 + tmp_qloop_254*0.5;
                   const real_t tmp_qloop_257 = tmp_qloop_136 + tmp_qloop_251 + (tmp_qloop_133 + tmp_qloop_255)*(tmp_qloop_134 + tmp_qloop_256)*2.0;
                   const real_t tmp_qloop_266 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_275 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_284 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_293 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_311 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_320 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_329 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_338 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_341 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_362 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_371 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_380 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_389 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_398 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_407 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_416 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_425 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10];
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_114)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_117) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_119 + tmp_qloop_120 + tmp_qloop_121 + tmp_qloop_125)*(tmp_qloop_119*0.5 + tmp_qloop_120*0.5 + tmp_qloop_121*0.5 + tmp_qloop_126)*2.0 + (tmp_qloop_127 + tmp_qloop_128 + tmp_qloop_129 + tmp_qloop_133)*(tmp_qloop_127*0.5 + tmp_qloop_128*0.5 + tmp_qloop_129*0.5 + tmp_qloop_134)*2.0));
                   const real_t q_tmp_1_1 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_149 + tmp_qloop_150 + tmp_qloop_151)*(tmp_qloop_117 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663 + tmp_qloop_151*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_149*1.0 + tmp_qloop_150*1.0 + tmp_qloop_151*1.0)*(tmp_qloop_149*2.0 + tmp_qloop_150*2.0 + tmp_qloop_151*2.0) + (tmp_qloop_125 + tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_154)*(tmp_qloop_126 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5 + tmp_qloop_154*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_155 + tmp_qloop_156 + tmp_qloop_157)*(tmp_qloop_134 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5 + tmp_qloop_157*0.5)*2.0));
                   const real_t q_tmp_2_2 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_158 + tmp_qloop_159 + tmp_qloop_160)*(tmp_qloop_117 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663 + tmp_qloop_160*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_158*1.0 + tmp_qloop_159*1.0 + tmp_qloop_160*1.0)*(tmp_qloop_158*2.0 + tmp_qloop_159*2.0 + tmp_qloop_160*2.0) + (tmp_qloop_125 + tmp_qloop_161 + tmp_qloop_162 + tmp_qloop_163)*(tmp_qloop_126 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5 + tmp_qloop_163*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_164 + tmp_qloop_165 + tmp_qloop_166)*(tmp_qloop_134 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5 + tmp_qloop_166*0.5)*2.0));
                   const real_t q_tmp_3_3 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_167 + tmp_qloop_168 + tmp_qloop_169)*(tmp_qloop_117 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663 + tmp_qloop_169*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_167*1.0 + tmp_qloop_168*1.0 + tmp_qloop_169*1.0)*(tmp_qloop_167*2.0 + tmp_qloop_168*2.0 + tmp_qloop_169*2.0) + (tmp_qloop_125 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172)*(tmp_qloop_126 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5 + tmp_qloop_172*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_173 + tmp_qloop_174 + tmp_qloop_175)*(tmp_qloop_134 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5 + tmp_qloop_175*0.5)*2.0));
                   const real_t q_tmp_4_4 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_176 + tmp_qloop_177 + tmp_qloop_178)*(tmp_qloop_117 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663 + tmp_qloop_178*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_176*1.0 + tmp_qloop_177*1.0 + tmp_qloop_178*1.0)*(tmp_qloop_176*2.0 + tmp_qloop_177*2.0 + tmp_qloop_178*2.0) + (tmp_qloop_125 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181)*(tmp_qloop_126 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5 + tmp_qloop_181*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_182 + tmp_qloop_183 + tmp_qloop_184)*(tmp_qloop_134 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5 + tmp_qloop_184*0.5)*2.0));
                   const real_t q_tmp_5_5 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187)*(tmp_qloop_117 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663 + tmp_qloop_187*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_185*1.0 + tmp_qloop_186*1.0 + tmp_qloop_187*1.0)*(tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0) + (tmp_qloop_125 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190)*(tmp_qloop_126 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5 + tmp_qloop_190*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_191 + tmp_qloop_192 + tmp_qloop_193)*(tmp_qloop_134 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5 + tmp_qloop_193*0.5)*2.0));
                   const real_t q_tmp_6_6 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_194 + tmp_qloop_195 + tmp_qloop_196)*(tmp_qloop_117 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663 + tmp_qloop_196*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_194*1.0 + tmp_qloop_195*1.0 + tmp_qloop_196*1.0)*(tmp_qloop_194*2.0 + tmp_qloop_195*2.0 + tmp_qloop_196*2.0) + (tmp_qloop_125 + tmp_qloop_197 + tmp_qloop_198 + tmp_qloop_199)*(tmp_qloop_126 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5 + tmp_qloop_199*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_200 + tmp_qloop_201 + tmp_qloop_202)*(tmp_qloop_134 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5 + tmp_qloop_202*0.5)*2.0));
                   const real_t q_tmp_7_7 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_203 + tmp_qloop_204 + tmp_qloop_205)*(tmp_qloop_117 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663 + tmp_qloop_205*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_203*1.0 + tmp_qloop_204*1.0 + tmp_qloop_205*1.0)*(tmp_qloop_203*2.0 + tmp_qloop_204*2.0 + tmp_qloop_205*2.0) + (tmp_qloop_125 + tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208)*(tmp_qloop_126 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5 + tmp_qloop_208*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211)*(tmp_qloop_134 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5 + tmp_qloop_211*0.5)*2.0));
                   const real_t q_tmp_8_8 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_212 + tmp_qloop_213 + tmp_qloop_214)*(tmp_qloop_117 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663 + tmp_qloop_214*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_212*1.0 + tmp_qloop_213*1.0 + tmp_qloop_214*1.0)*(tmp_qloop_212*2.0 + tmp_qloop_213*2.0 + tmp_qloop_214*2.0) + (tmp_qloop_125 + tmp_qloop_215 + tmp_qloop_216 + tmp_qloop_217)*(tmp_qloop_126 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5 + tmp_qloop_217*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220)*(tmp_qloop_134 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5 + tmp_qloop_220*0.5)*2.0));
                   const real_t q_tmp_9_9 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_221 + tmp_qloop_222 + tmp_qloop_223)*(tmp_qloop_117 + tmp_qloop_221*0.66666666666666663 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_221*1.0 + tmp_qloop_222*1.0 + tmp_qloop_223*1.0)*(tmp_qloop_221*2.0 + tmp_qloop_222*2.0 + tmp_qloop_223*2.0) + (tmp_qloop_125 + tmp_qloop_224 + tmp_qloop_225 + tmp_qloop_226)*(tmp_qloop_126 + tmp_qloop_224*0.5 + tmp_qloop_225*0.5 + tmp_qloop_226*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229)*(tmp_qloop_134 + tmp_qloop_227*0.5 + tmp_qloop_228*0.5 + tmp_qloop_229*0.5)*2.0));
                   const real_t q_tmp_10_10 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_230 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_237)*(tmp_qloop_230*0.66666666666666663 + tmp_qloop_231*0.66666666666666663 + tmp_qloop_232*0.66666666666666663 + tmp_qloop_239) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_230*1.0 + tmp_qloop_231*1.0 + tmp_qloop_232*1.0)*(tmp_qloop_230*2.0 + tmp_qloop_231*2.0 + tmp_qloop_232*2.0) + (tmp_qloop_140 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250)*(tmp_qloop_145 + tmp_qloop_248*0.5 + tmp_qloop_249*0.5 + tmp_qloop_250*0.5)*2.0 + (tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242 + tmp_qloop_246)*(tmp_qloop_240*0.5 + tmp_qloop_241*0.5 + tmp_qloop_242*0.5 + tmp_qloop_247)*2.0));
                   const real_t q_tmp_11_11 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_258 + tmp_qloop_259 + tmp_qloop_260)*(tmp_qloop_239 + tmp_qloop_258*0.66666666666666663 + tmp_qloop_259*0.66666666666666663 + tmp_qloop_260*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_258*1.0 + tmp_qloop_259*1.0 + tmp_qloop_260*1.0)*(tmp_qloop_258*2.0 + tmp_qloop_259*2.0 + tmp_qloop_260*2.0) + (tmp_qloop_140 + tmp_qloop_264 + tmp_qloop_265 + tmp_qloop_266)*(tmp_qloop_145 + tmp_qloop_264*0.5 + tmp_qloop_265*0.5 + tmp_qloop_266*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263)*(tmp_qloop_247 + tmp_qloop_261*0.5 + tmp_qloop_262*0.5 + tmp_qloop_263*0.5)*2.0));
                   const real_t q_tmp_12_12 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_267 + tmp_qloop_268 + tmp_qloop_269)*(tmp_qloop_239 + tmp_qloop_267*0.66666666666666663 + tmp_qloop_268*0.66666666666666663 + tmp_qloop_269*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_267*1.0 + tmp_qloop_268*1.0 + tmp_qloop_269*1.0)*(tmp_qloop_267*2.0 + tmp_qloop_268*2.0 + tmp_qloop_269*2.0) + (tmp_qloop_140 + tmp_qloop_273 + tmp_qloop_274 + tmp_qloop_275)*(tmp_qloop_145 + tmp_qloop_273*0.5 + tmp_qloop_274*0.5 + tmp_qloop_275*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272)*(tmp_qloop_247 + tmp_qloop_270*0.5 + tmp_qloop_271*0.5 + tmp_qloop_272*0.5)*2.0));
                   const real_t q_tmp_13_13 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_276 + tmp_qloop_277 + tmp_qloop_278)*(tmp_qloop_239 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0)*(tmp_qloop_276*2.0 + tmp_qloop_277*2.0 + tmp_qloop_278*2.0) + (tmp_qloop_140 + tmp_qloop_282 + tmp_qloop_283 + tmp_qloop_284)*(tmp_qloop_145 + tmp_qloop_282*0.5 + tmp_qloop_283*0.5 + tmp_qloop_284*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_279 + tmp_qloop_280 + tmp_qloop_281)*(tmp_qloop_247 + tmp_qloop_279*0.5 + tmp_qloop_280*0.5 + tmp_qloop_281*0.5)*2.0));
                   const real_t q_tmp_14_14 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_285 + tmp_qloop_286 + tmp_qloop_287)*(tmp_qloop_239 + tmp_qloop_285*0.66666666666666663 + tmp_qloop_286*0.66666666666666663 + tmp_qloop_287*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_285*1.0 + tmp_qloop_286*1.0 + tmp_qloop_287*1.0)*(tmp_qloop_285*2.0 + tmp_qloop_286*2.0 + tmp_qloop_287*2.0) + (tmp_qloop_140 + tmp_qloop_291 + tmp_qloop_292 + tmp_qloop_293)*(tmp_qloop_145 + tmp_qloop_291*0.5 + tmp_qloop_292*0.5 + tmp_qloop_293*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_288 + tmp_qloop_289 + tmp_qloop_290)*(tmp_qloop_247 + tmp_qloop_288*0.5 + tmp_qloop_289*0.5 + tmp_qloop_290*0.5)*2.0));
                   const real_t q_tmp_15_15 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_294 + tmp_qloop_295 + tmp_qloop_296)*(tmp_qloop_239 + tmp_qloop_294*0.66666666666666663 + tmp_qloop_295*0.66666666666666663 + tmp_qloop_296*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_294*1.0 + tmp_qloop_295*1.0 + tmp_qloop_296*1.0)*(tmp_qloop_294*2.0 + tmp_qloop_295*2.0 + tmp_qloop_296*2.0) + (tmp_qloop_140 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302)*(tmp_qloop_145 + tmp_qloop_300*0.5 + tmp_qloop_301*0.5 + tmp_qloop_302*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_297 + tmp_qloop_298 + tmp_qloop_299)*(tmp_qloop_247 + tmp_qloop_297*0.5 + tmp_qloop_298*0.5 + tmp_qloop_299*0.5)*2.0));
                   const real_t q_tmp_16_16 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_303 + tmp_qloop_304 + tmp_qloop_305)*(tmp_qloop_239 + tmp_qloop_303*0.66666666666666663 + tmp_qloop_304*0.66666666666666663 + tmp_qloop_305*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_303*1.0 + tmp_qloop_304*1.0 + tmp_qloop_305*1.0)*(tmp_qloop_303*2.0 + tmp_qloop_304*2.0 + tmp_qloop_305*2.0) + (tmp_qloop_140 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311)*(tmp_qloop_145 + tmp_qloop_309*0.5 + tmp_qloop_310*0.5 + tmp_qloop_311*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_308)*(tmp_qloop_247 + tmp_qloop_306*0.5 + tmp_qloop_307*0.5 + tmp_qloop_308*0.5)*2.0));
                   const real_t q_tmp_17_17 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_312 + tmp_qloop_313 + tmp_qloop_314)*(tmp_qloop_239 + tmp_qloop_312*0.66666666666666663 + tmp_qloop_313*0.66666666666666663 + tmp_qloop_314*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_312*1.0 + tmp_qloop_313*1.0 + tmp_qloop_314*1.0)*(tmp_qloop_312*2.0 + tmp_qloop_313*2.0 + tmp_qloop_314*2.0) + (tmp_qloop_140 + tmp_qloop_318 + tmp_qloop_319 + tmp_qloop_320)*(tmp_qloop_145 + tmp_qloop_318*0.5 + tmp_qloop_319*0.5 + tmp_qloop_320*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_315 + tmp_qloop_316 + tmp_qloop_317)*(tmp_qloop_247 + tmp_qloop_315*0.5 + tmp_qloop_316*0.5 + tmp_qloop_317*0.5)*2.0));
                   const real_t q_tmp_18_18 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_321 + tmp_qloop_322 + tmp_qloop_323)*(tmp_qloop_239 + tmp_qloop_321*0.66666666666666663 + tmp_qloop_322*0.66666666666666663 + tmp_qloop_323*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_321*1.0 + tmp_qloop_322*1.0 + tmp_qloop_323*1.0)*(tmp_qloop_321*2.0 + tmp_qloop_322*2.0 + tmp_qloop_323*2.0) + (tmp_qloop_140 + tmp_qloop_327 + tmp_qloop_328 + tmp_qloop_329)*(tmp_qloop_145 + tmp_qloop_327*0.5 + tmp_qloop_328*0.5 + tmp_qloop_329*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_326)*(tmp_qloop_247 + tmp_qloop_324*0.5 + tmp_qloop_325*0.5 + tmp_qloop_326*0.5)*2.0));
                   const real_t q_tmp_19_19 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_330 + tmp_qloop_331 + tmp_qloop_332)*(tmp_qloop_239 + tmp_qloop_330*0.66666666666666663 + tmp_qloop_331*0.66666666666666663 + tmp_qloop_332*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_330*1.0 + tmp_qloop_331*1.0 + tmp_qloop_332*1.0)*(tmp_qloop_330*2.0 + tmp_qloop_331*2.0 + tmp_qloop_332*2.0) + (tmp_qloop_140 + tmp_qloop_336 + tmp_qloop_337 + tmp_qloop_338)*(tmp_qloop_145 + tmp_qloop_336*0.5 + tmp_qloop_337*0.5 + tmp_qloop_338*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335)*(tmp_qloop_247 + tmp_qloop_333*0.5 + tmp_qloop_334*0.5 + tmp_qloop_335*0.5)*2.0));
                   const real_t q_tmp_20_20 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_339 + tmp_qloop_340 + tmp_qloop_341 + tmp_qloop_342)*(tmp_qloop_339*0.66666666666666663 + tmp_qloop_340*0.66666666666666663 + tmp_qloop_341*0.66666666666666663 + tmp_qloop_343) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_339*1.0 + tmp_qloop_340*1.0 + tmp_qloop_341*1.0)*(tmp_qloop_339*2.0 + tmp_qloop_340*2.0 + tmp_qloop_341*2.0) + (tmp_qloop_144 + tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349)*(tmp_qloop_146 + tmp_qloop_347*0.5 + tmp_qloop_348*0.5 + tmp_qloop_349*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_344 + tmp_qloop_345 + tmp_qloop_346)*(tmp_qloop_256 + tmp_qloop_344*0.5 + tmp_qloop_345*0.5 + tmp_qloop_346*0.5)*2.0));
                   const real_t q_tmp_21_21 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353)*(tmp_qloop_343 + tmp_qloop_351*0.66666666666666663 + tmp_qloop_352*0.66666666666666663 + tmp_qloop_353*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_351*1.0 + tmp_qloop_352*1.0 + tmp_qloop_353*1.0)*(tmp_qloop_351*2.0 + tmp_qloop_352*2.0 + tmp_qloop_353*2.0) + (tmp_qloop_144 + tmp_qloop_357 + tmp_qloop_358 + tmp_qloop_359)*(tmp_qloop_146 + tmp_qloop_357*0.5 + tmp_qloop_358*0.5 + tmp_qloop_359*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_354 + tmp_qloop_355 + tmp_qloop_356)*(tmp_qloop_256 + tmp_qloop_354*0.5 + tmp_qloop_355*0.5 + tmp_qloop_356*0.5)*2.0));
                   const real_t q_tmp_22_22 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_360 + tmp_qloop_361 + tmp_qloop_362)*(tmp_qloop_343 + tmp_qloop_360*0.66666666666666663 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_360*1.0 + tmp_qloop_361*1.0 + tmp_qloop_362*1.0)*(tmp_qloop_360*2.0 + tmp_qloop_361*2.0 + tmp_qloop_362*2.0) + (tmp_qloop_144 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_368)*(tmp_qloop_146 + tmp_qloop_366*0.5 + tmp_qloop_367*0.5 + tmp_qloop_368*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_363 + tmp_qloop_364 + tmp_qloop_365)*(tmp_qloop_256 + tmp_qloop_363*0.5 + tmp_qloop_364*0.5 + tmp_qloop_365*0.5)*2.0));
                   const real_t q_tmp_23_23 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_369 + tmp_qloop_370 + tmp_qloop_371)*(tmp_qloop_343 + tmp_qloop_369*0.66666666666666663 + tmp_qloop_370*0.66666666666666663 + tmp_qloop_371*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_369*1.0 + tmp_qloop_370*1.0 + tmp_qloop_371*1.0)*(tmp_qloop_369*2.0 + tmp_qloop_370*2.0 + tmp_qloop_371*2.0) + (tmp_qloop_144 + tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377)*(tmp_qloop_146 + tmp_qloop_375*0.5 + tmp_qloop_376*0.5 + tmp_qloop_377*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_372 + tmp_qloop_373 + tmp_qloop_374)*(tmp_qloop_256 + tmp_qloop_372*0.5 + tmp_qloop_373*0.5 + tmp_qloop_374*0.5)*2.0));
                   const real_t q_tmp_24_24 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_378 + tmp_qloop_379 + tmp_qloop_380)*(tmp_qloop_343 + tmp_qloop_378*0.66666666666666663 + tmp_qloop_379*0.66666666666666663 + tmp_qloop_380*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_378*1.0 + tmp_qloop_379*1.0 + tmp_qloop_380*1.0)*(tmp_qloop_378*2.0 + tmp_qloop_379*2.0 + tmp_qloop_380*2.0) + (tmp_qloop_144 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386)*(tmp_qloop_146 + tmp_qloop_384*0.5 + tmp_qloop_385*0.5 + tmp_qloop_386*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_381 + tmp_qloop_382 + tmp_qloop_383)*(tmp_qloop_256 + tmp_qloop_381*0.5 + tmp_qloop_382*0.5 + tmp_qloop_383*0.5)*2.0));
                   const real_t q_tmp_25_25 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_387 + tmp_qloop_388 + tmp_qloop_389)*(tmp_qloop_343 + tmp_qloop_387*0.66666666666666663 + tmp_qloop_388*0.66666666666666663 + tmp_qloop_389*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_387*1.0 + tmp_qloop_388*1.0 + tmp_qloop_389*1.0)*(tmp_qloop_387*2.0 + tmp_qloop_388*2.0 + tmp_qloop_389*2.0) + (tmp_qloop_144 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395)*(tmp_qloop_146 + tmp_qloop_393*0.5 + tmp_qloop_394*0.5 + tmp_qloop_395*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_392)*(tmp_qloop_256 + tmp_qloop_390*0.5 + tmp_qloop_391*0.5 + tmp_qloop_392*0.5)*2.0));
                   const real_t q_tmp_26_26 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_396 + tmp_qloop_397 + tmp_qloop_398)*(tmp_qloop_343 + tmp_qloop_396*0.66666666666666663 + tmp_qloop_397*0.66666666666666663 + tmp_qloop_398*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_396*1.0 + tmp_qloop_397*1.0 + tmp_qloop_398*1.0)*(tmp_qloop_396*2.0 + tmp_qloop_397*2.0 + tmp_qloop_398*2.0) + (tmp_qloop_144 + tmp_qloop_402 + tmp_qloop_403 + tmp_qloop_404)*(tmp_qloop_146 + tmp_qloop_402*0.5 + tmp_qloop_403*0.5 + tmp_qloop_404*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_399 + tmp_qloop_400 + tmp_qloop_401)*(tmp_qloop_256 + tmp_qloop_399*0.5 + tmp_qloop_400*0.5 + tmp_qloop_401*0.5)*2.0));
                   const real_t q_tmp_27_27 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_405 + tmp_qloop_406 + tmp_qloop_407)*(tmp_qloop_343 + tmp_qloop_405*0.66666666666666663 + tmp_qloop_406*0.66666666666666663 + tmp_qloop_407*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_405*1.0 + tmp_qloop_406*1.0 + tmp_qloop_407*1.0)*(tmp_qloop_405*2.0 + tmp_qloop_406*2.0 + tmp_qloop_407*2.0) + (tmp_qloop_144 + tmp_qloop_411 + tmp_qloop_412 + tmp_qloop_413)*(tmp_qloop_146 + tmp_qloop_411*0.5 + tmp_qloop_412*0.5 + tmp_qloop_413*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_410)*(tmp_qloop_256 + tmp_qloop_408*0.5 + tmp_qloop_409*0.5 + tmp_qloop_410*0.5)*2.0));
                   const real_t q_tmp_28_28 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_414 + tmp_qloop_415 + tmp_qloop_416)*(tmp_qloop_343 + tmp_qloop_414*0.66666666666666663 + tmp_qloop_415*0.66666666666666663 + tmp_qloop_416*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_414*1.0 + tmp_qloop_415*1.0 + tmp_qloop_416*1.0)*(tmp_qloop_414*2.0 + tmp_qloop_415*2.0 + tmp_qloop_416*2.0) + (tmp_qloop_144 + tmp_qloop_420 + tmp_qloop_421 + tmp_qloop_422)*(tmp_qloop_146 + tmp_qloop_420*0.5 + tmp_qloop_421*0.5 + tmp_qloop_422*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419)*(tmp_qloop_256 + tmp_qloop_417*0.5 + tmp_qloop_418*0.5 + tmp_qloop_419*0.5)*2.0));
                   const real_t q_tmp_29_29 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_423 + tmp_qloop_424 + tmp_qloop_425)*(tmp_qloop_343 + tmp_qloop_423*0.66666666666666663 + tmp_qloop_424*0.66666666666666663 + tmp_qloop_425*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_423*1.0 + tmp_qloop_424*1.0 + tmp_qloop_425*1.0)*(tmp_qloop_423*2.0 + tmp_qloop_424*2.0 + tmp_qloop_425*2.0) + (tmp_qloop_144 + tmp_qloop_429 + tmp_qloop_430 + tmp_qloop_431)*(tmp_qloop_146 + tmp_qloop_429*0.5 + tmp_qloop_430*0.5 + tmp_qloop_431*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428)*(tmp_qloop_256 + tmp_qloop_426*0.5 + tmp_qloop_427*0.5 + tmp_qloop_428*0.5)*2.0));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                const real_t elMatDiag_4 = q_acc_4_4;
                const real_t elMatDiag_5 = q_acc_5_5;
                const real_t elMatDiag_6 = q_acc_6_6;
                const real_t elMatDiag_7 = q_acc_7_7;
                const real_t elMatDiag_8 = q_acc_8_8;
                const real_t elMatDiag_9 = q_acc_9_9;
                const real_t elMatDiag_10 = q_acc_10_10;
                const real_t elMatDiag_11 = q_acc_11_11;
                const real_t elMatDiag_12 = q_acc_12_12;
                const real_t elMatDiag_13 = q_acc_13_13;
                const real_t elMatDiag_14 = q_acc_14_14;
                const real_t elMatDiag_15 = q_acc_15_15;
                const real_t elMatDiag_16 = q_acc_16_16;
                const real_t elMatDiag_17 = q_acc_17_17;
                const real_t elMatDiag_18 = q_acc_18_18;
                const real_t elMatDiag_19 = q_acc_19_19;
                const real_t elMatDiag_20 = q_acc_20_20;
                const real_t elMatDiag_21 = q_acc_21_21;
                const real_t elMatDiag_22 = q_acc_22_22;
                const real_t elMatDiag_23 = q_acc_23_23;
                const real_t elMatDiag_24 = q_acc_24_24;
                const real_t elMatDiag_25 = q_acc_25_25;
                const real_t elMatDiag_26 = q_acc_26_26;
                const real_t elMatDiag_27 = q_acc_27_27;
                const real_t elMatDiag_28 = q_acc_28_28;
                const real_t elMatDiag_29 = q_acc_29_29;
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_10 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_11 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_12 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_13 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_14 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_15 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_16 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_17 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_18 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_19 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_20 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_21 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_22 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_23 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_24 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_25 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_26 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_27 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_28 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_29 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(abs_det_jac_affine_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(abs_det_jac_affine_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(abs_det_jac_affine_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_212 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_221 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_297 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_354 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q]));
                   const __m256d tmp_qloop_137 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_230 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_243 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_303 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_312 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_402 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_411 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_420 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_429 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q]));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_173 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_182 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_191 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_200 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_252 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_264 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_273 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_282 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_291 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_318 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_327 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_336 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_360 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_369 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_378 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_387 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_396 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_186 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_195 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_204 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_213 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_234 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_280 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_289 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_298 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_345 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_355 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_364 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_373 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_382 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_225 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_304 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_313 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_322 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_331 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_430 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_128 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_265 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_340 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_388 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_397 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_406 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_415 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_424 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_122,tmp_qloop_123),tmp_qloop_124);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_169 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_178 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_187 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_236 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_233,tmp_qloop_234),tmp_qloop_235);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_251 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_281 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_290 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_299 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_308 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_317 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_326 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_346 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_374 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_383 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_392 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_401 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_410 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_137,tmp_qloop_138),tmp_qloop_139);
                   const __m256d tmp_qloop_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_138,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_199 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_208 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_217 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_226 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_246 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_243,tmp_qloop_244),tmp_qloop_245);
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_243,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_244,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_245,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_260 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_269 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_296 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_332 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_342 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_236);
                   const __m256d tmp_qloop_343 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_238);
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_246),_mm256_add_pd(tmp_qloop_126,tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_251);
                   const __m256d tmp_qloop_359 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_368 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_129 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_144 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_141,tmp_qloop_142),tmp_qloop_143);
                   const __m256d tmp_qloop_146 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_141,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_142,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_143,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_144),_mm256_add_pd(tmp_qloop_145,tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_136);
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_237 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_236);
                   const __m256d tmp_qloop_239 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_238);
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_255 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_252,tmp_qloop_253),tmp_qloop_254);
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_253,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_254,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_257 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_255),_mm256_add_pd(tmp_qloop_134,tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_136),tmp_qloop_251);
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_341 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_416 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_425 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10]));
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_119,tmp_qloop_120),tmp_qloop_121),tmp_qloop_125),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_120,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_121,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_128),tmp_qloop_129),tmp_qloop_133),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_129,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_114)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_152),tmp_qloop_153),tmp_qloop_154),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_154,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_155),tmp_qloop_156),tmp_qloop_157),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_155,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_156,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_149),tmp_qloop_150),tmp_qloop_151)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_161),tmp_qloop_162),tmp_qloop_163),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_162,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_163,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_164),tmp_qloop_165),tmp_qloop_166),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_164,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_165,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_166,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_158),tmp_qloop_159),tmp_qloop_160)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_173),tmp_qloop_174),tmp_qloop_175),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_173,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_174,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_175,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_167),tmp_qloop_168),tmp_qloop_169)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_179,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_180,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_181,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_182),tmp_qloop_183),tmp_qloop_184),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_182,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_176),tmp_qloop_177),tmp_qloop_178)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_188,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_189,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_190,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_191),tmp_qloop_192),tmp_qloop_193),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_191,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_192,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_193,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_185),tmp_qloop_186),tmp_qloop_187)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_197),tmp_qloop_198),tmp_qloop_199),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_199,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_200),tmp_qloop_201),tmp_qloop_202),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_201,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_202,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_194),tmp_qloop_195),tmp_qloop_196)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_206),tmp_qloop_207),tmp_qloop_208),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_206,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_207,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_208,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_203),tmp_qloop_204),tmp_qloop_205)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_215),tmp_qloop_216),tmp_qloop_217),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_215,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_216,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_217,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_218,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_219,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_220,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_212),tmp_qloop_213),tmp_qloop_214)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_224),tmp_qloop_225),tmp_qloop_226),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_225,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_226,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_227,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_228,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_229,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_221),tmp_qloop_222),tmp_qloop_223)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_240,tmp_qloop_241),tmp_qloop_242),tmp_qloop_246),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_240,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_241,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_242,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_230,tmp_qloop_231),tmp_qloop_232),tmp_qloop_237)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_264),tmp_qloop_265),tmp_qloop_266),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_264,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_265,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_266,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_258),tmp_qloop_259),tmp_qloop_260)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_270,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_271,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_272,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_273),tmp_qloop_274),tmp_qloop_275),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_273,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_267),tmp_qloop_268),tmp_qloop_269)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_279),tmp_qloop_280),tmp_qloop_281),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_280,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_281,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_282),tmp_qloop_283),tmp_qloop_284),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_282,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_283,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_284,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_276),tmp_qloop_277),tmp_qloop_278)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_288),tmp_qloop_289),tmp_qloop_290),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_289,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_290,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_291),tmp_qloop_292),tmp_qloop_293),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_291,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_292,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_285),tmp_qloop_286),tmp_qloop_287)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_297),tmp_qloop_298),tmp_qloop_299),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_298,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_299,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_300,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_301,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_302,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_294),tmp_qloop_295),tmp_qloop_296)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_306),tmp_qloop_307),tmp_qloop_308),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_308,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_309,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_310,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_311,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_303),tmp_qloop_304),tmp_qloop_305)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_315),tmp_qloop_316),tmp_qloop_317),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_315,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_316,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_317,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_318),tmp_qloop_319),tmp_qloop_320),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_318,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_312),tmp_qloop_313),tmp_qloop_314)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_324),tmp_qloop_325),tmp_qloop_326),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_324,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_325,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_326,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_327),tmp_qloop_328),tmp_qloop_329),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_327,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_328,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_329,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_321),tmp_qloop_322),tmp_qloop_323)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_333),tmp_qloop_334),tmp_qloop_335),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_336),tmp_qloop_337),tmp_qloop_338),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_336,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_337,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_338,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_330),tmp_qloop_331),tmp_qloop_332)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_344),tmp_qloop_345),tmp_qloop_346),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_344,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_345,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_346,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_347),tmp_qloop_348),tmp_qloop_349),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_339,tmp_qloop_340),tmp_qloop_341),tmp_qloop_342)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_354),tmp_qloop_355),tmp_qloop_356),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_355,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_356,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_357),tmp_qloop_358),tmp_qloop_359),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_357,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_358,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_359,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_363),tmp_qloop_364),tmp_qloop_365),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_364,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_365,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_366),tmp_qloop_367),tmp_qloop_368),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_366,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_367,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_368,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_360),tmp_qloop_361),tmp_qloop_362)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_372),tmp_qloop_373),tmp_qloop_374),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_372,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_373,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_374,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_375),tmp_qloop_376),tmp_qloop_377),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_369),tmp_qloop_370),tmp_qloop_371)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_381),tmp_qloop_382),tmp_qloop_383),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_381,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_382,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_383,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_384,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_385,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_386,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_378),tmp_qloop_379),tmp_qloop_380)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_390),tmp_qloop_391),tmp_qloop_392),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_392,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_393,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_394,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_395,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_387),tmp_qloop_388),tmp_qloop_389)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_399),tmp_qloop_400),tmp_qloop_401),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_399,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_400,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_401,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_402),tmp_qloop_403),tmp_qloop_404),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_402,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_396),tmp_qloop_397),tmp_qloop_398)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_408),tmp_qloop_409),tmp_qloop_410),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_408,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_409,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_410,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_411),tmp_qloop_412),tmp_qloop_413),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_411,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_412,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_413,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_405),tmp_qloop_406),tmp_qloop_407)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_417),tmp_qloop_418),tmp_qloop_419),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_420),tmp_qloop_421),tmp_qloop_422),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_420,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_421,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_422,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_414),tmp_qloop_415),tmp_qloop_416)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_426,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_427,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_428,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_429),tmp_qloop_430),tmp_qloop_431),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_429,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_430,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_423),tmp_qloop_424),tmp_qloop_425)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                const __m256d elMatDiag_4 = q_acc_4_4;
                const __m256d elMatDiag_5 = q_acc_5_5;
                const __m256d elMatDiag_6 = q_acc_6_6;
                const __m256d elMatDiag_7 = q_acc_7_7;
                const __m256d elMatDiag_8 = q_acc_8_8;
                const __m256d elMatDiag_9 = q_acc_9_9;
                const __m256d elMatDiag_10 = q_acc_10_10;
                const __m256d elMatDiag_11 = q_acc_11_11;
                const __m256d elMatDiag_12 = q_acc_12_12;
                const __m256d elMatDiag_13 = q_acc_13_13;
                const __m256d elMatDiag_14 = q_acc_14_14;
                const __m256d elMatDiag_15 = q_acc_15_15;
                const __m256d elMatDiag_16 = q_acc_16_16;
                const __m256d elMatDiag_17 = q_acc_17_17;
                const __m256d elMatDiag_18 = q_acc_18_18;
                const __m256d elMatDiag_19 = q_acc_19_19;
                const __m256d elMatDiag_20 = q_acc_20_20;
                const __m256d elMatDiag_21 = q_acc_21_21;
                const __m256d elMatDiag_22 = q_acc_22_22;
                const __m256d elMatDiag_23 = q_acc_23_23;
                const __m256d elMatDiag_24 = q_acc_24_24;
                const __m256d elMatDiag_25 = q_acc_25_25;
                const __m256d elMatDiag_26 = q_acc_26_26;
                const __m256d elMatDiag_27 = q_acc_27_27;
                const __m256d elMatDiag_28 = q_acc_28_28;
                const __m256d elMatDiag_29 = q_acc_29_29;
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_10,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_11,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_12,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_13,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_14,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatDiag_15,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_16,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_17,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_18,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_19,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_20,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_21,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_22,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_23,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_24,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatDiag_25,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_26,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_27,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_28,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_29,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_148 = (mu_dof_0*_data_phi_0_0_WHITE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_WHITE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_DOWN[10*q + 9])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2];
                   const real_t tmp_qloop_158 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3];
                   const real_t tmp_qloop_167 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4];
                   const real_t tmp_qloop_176 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5];
                   const real_t tmp_qloop_185 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6];
                   const real_t tmp_qloop_194 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7];
                   const real_t tmp_qloop_203 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8];
                   const real_t tmp_qloop_212 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9];
                   const real_t tmp_qloop_221 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10];
                   const real_t tmp_qloop_233 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_279 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_288 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_297 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_306 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_315 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_324 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_344 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_354 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_363 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_372 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_381 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_390 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_399 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_408 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_119 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q];
                   const real_t tmp_qloop_137 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_152 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2];
                   const real_t tmp_qloop_161 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6];
                   const real_t tmp_qloop_197 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7];
                   const real_t tmp_qloop_206 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8];
                   const real_t tmp_qloop_215 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9];
                   const real_t tmp_qloop_224 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10];
                   const real_t tmp_qloop_230 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_243 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11];
                   const real_t tmp_qloop_258 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_267 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_276 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_285 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_294 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_303 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_312 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_321 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_330 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_357 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_366 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_402 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_411 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_420 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_429 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_127 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q];
                   const real_t tmp_qloop_141 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_155 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2];
                   const real_t tmp_qloop_164 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3];
                   const real_t tmp_qloop_173 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4];
                   const real_t tmp_qloop_182 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5];
                   const real_t tmp_qloop_191 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6];
                   const real_t tmp_qloop_200 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_252 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11];
                   const real_t tmp_qloop_264 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_273 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_282 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_291 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_318 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_327 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_336 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_339 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_360 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_369 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_378 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_387 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_396 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_405 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_414 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_123 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_150 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_159 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_168 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_177 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_186 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_195 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_204 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_213 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_222 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_234 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_280 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_289 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_298 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_307 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_316 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_325 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_345 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_355 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_364 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_373 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_382 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_391 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_400 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_409 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_120 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_138 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_153 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_162 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_198 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_207 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_216 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_225 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_231 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_244 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_259 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_268 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_277 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_286 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_295 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_304 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_313 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_322 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_331 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_358 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_367 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_403 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_412 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_421 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_430 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_128 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_142 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_156 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_165 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_174 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_192 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_201 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_253 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_265 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_274 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_283 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_292 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_319 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_328 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_337 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_340 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_361 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_370 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_379 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_388 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_397 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_406 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_415 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_424 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_125 = tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_124;
                   const real_t tmp_qloop_126 = tmp_qloop_122*0.5 + tmp_qloop_123*0.5 + tmp_qloop_124*0.5;
                   const real_t tmp_qloop_132 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_133 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132;
                   const real_t tmp_qloop_134 = tmp_qloop_130*0.5 + tmp_qloop_131*0.5 + tmp_qloop_132*0.5;
                   const real_t tmp_qloop_151 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_160 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_169 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_178 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_187 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_196 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_205 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_214 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_223 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_235 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_236 = tmp_qloop_233 + tmp_qloop_234 + tmp_qloop_235;
                   const real_t tmp_qloop_238 = tmp_qloop_233*0.66666666666666663 + tmp_qloop_234*0.66666666666666663 + tmp_qloop_235*0.66666666666666663;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_251 = (tmp_qloop_233*1.0 + tmp_qloop_234*1.0 + tmp_qloop_235*1.0)*(tmp_qloop_233*2.0 + tmp_qloop_234*2.0 + tmp_qloop_235*2.0);
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_272 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_281 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_290 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_299 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_308 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_317 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_326 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_335 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_346 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_356 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_365 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_374 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_383 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_392 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_401 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_410 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_419 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_428 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_116 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_121 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_135 = (tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0)*(tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0);
                   const real_t tmp_qloop_139 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_140 = tmp_qloop_137 + tmp_qloop_138 + tmp_qloop_139;
                   const real_t tmp_qloop_145 = tmp_qloop_137*0.5 + tmp_qloop_138*0.5 + tmp_qloop_139*0.5;
                   const real_t tmp_qloop_154 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_163 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_172 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_181 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_199 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_208 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_217 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_226 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_232 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_245 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_246 = tmp_qloop_243 + tmp_qloop_244 + tmp_qloop_245;
                   const real_t tmp_qloop_247 = tmp_qloop_243*0.5 + tmp_qloop_244*0.5 + tmp_qloop_245*0.5;
                   const real_t tmp_qloop_260 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_269 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_278 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_287 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_296 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_305 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_314 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_323 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_332 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_342 = tmp_qloop_113 + tmp_qloop_236;
                   const real_t tmp_qloop_343 = tmp_qloop_116 + tmp_qloop_238;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_350 = tmp_qloop_135 + tmp_qloop_251 + (tmp_qloop_125 + tmp_qloop_246)*(tmp_qloop_126 + tmp_qloop_247)*2.0;
                   const real_t tmp_qloop_359 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_368 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_386 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_404 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_413 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_422 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_431 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_129 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_136 = (tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_143 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_144 = tmp_qloop_141 + tmp_qloop_142 + tmp_qloop_143;
                   const real_t tmp_qloop_146 = tmp_qloop_141*0.5 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5;
                   const real_t tmp_qloop_147 = tmp_qloop_135 + tmp_qloop_136 + (tmp_qloop_140 + tmp_qloop_144)*(tmp_qloop_145 + tmp_qloop_146)*2.0;
                   const real_t tmp_qloop_157 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_166 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_184 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_193 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_202 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_211 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_229 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_237 = tmp_qloop_109 + tmp_qloop_236;
                   const real_t tmp_qloop_239 = tmp_qloop_115 + tmp_qloop_238;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_254 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_255 = tmp_qloop_252 + tmp_qloop_253 + tmp_qloop_254;
                   const real_t tmp_qloop_256 = tmp_qloop_252*0.5 + tmp_qloop_253*0.5 + tmp_qloop_254*0.5;
                   const real_t tmp_qloop_257 = tmp_qloop_136 + tmp_qloop_251 + (tmp_qloop_133 + tmp_qloop_255)*(tmp_qloop_134 + tmp_qloop_256)*2.0;
                   const real_t tmp_qloop_266 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_275 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_284 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_293 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_311 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_320 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_329 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_338 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_341 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_362 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_371 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_380 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_389 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_398 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_407 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_416 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_425 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10];
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_114)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_117) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_119 + tmp_qloop_120 + tmp_qloop_121 + tmp_qloop_125)*(tmp_qloop_119*0.5 + tmp_qloop_120*0.5 + tmp_qloop_121*0.5 + tmp_qloop_126)*2.0 + (tmp_qloop_127 + tmp_qloop_128 + tmp_qloop_129 + tmp_qloop_133)*(tmp_qloop_127*0.5 + tmp_qloop_128*0.5 + tmp_qloop_129*0.5 + tmp_qloop_134)*2.0));
                   const real_t q_tmp_1_1 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_149 + tmp_qloop_150 + tmp_qloop_151)*(tmp_qloop_117 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663 + tmp_qloop_151*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_149*1.0 + tmp_qloop_150*1.0 + tmp_qloop_151*1.0)*(tmp_qloop_149*2.0 + tmp_qloop_150*2.0 + tmp_qloop_151*2.0) + (tmp_qloop_125 + tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_154)*(tmp_qloop_126 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5 + tmp_qloop_154*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_155 + tmp_qloop_156 + tmp_qloop_157)*(tmp_qloop_134 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5 + tmp_qloop_157*0.5)*2.0));
                   const real_t q_tmp_2_2 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_158 + tmp_qloop_159 + tmp_qloop_160)*(tmp_qloop_117 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663 + tmp_qloop_160*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_158*1.0 + tmp_qloop_159*1.0 + tmp_qloop_160*1.0)*(tmp_qloop_158*2.0 + tmp_qloop_159*2.0 + tmp_qloop_160*2.0) + (tmp_qloop_125 + tmp_qloop_161 + tmp_qloop_162 + tmp_qloop_163)*(tmp_qloop_126 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5 + tmp_qloop_163*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_164 + tmp_qloop_165 + tmp_qloop_166)*(tmp_qloop_134 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5 + tmp_qloop_166*0.5)*2.0));
                   const real_t q_tmp_3_3 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_167 + tmp_qloop_168 + tmp_qloop_169)*(tmp_qloop_117 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663 + tmp_qloop_169*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_167*1.0 + tmp_qloop_168*1.0 + tmp_qloop_169*1.0)*(tmp_qloop_167*2.0 + tmp_qloop_168*2.0 + tmp_qloop_169*2.0) + (tmp_qloop_125 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172)*(tmp_qloop_126 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5 + tmp_qloop_172*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_173 + tmp_qloop_174 + tmp_qloop_175)*(tmp_qloop_134 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5 + tmp_qloop_175*0.5)*2.0));
                   const real_t q_tmp_4_4 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_176 + tmp_qloop_177 + tmp_qloop_178)*(tmp_qloop_117 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663 + tmp_qloop_178*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_176*1.0 + tmp_qloop_177*1.0 + tmp_qloop_178*1.0)*(tmp_qloop_176*2.0 + tmp_qloop_177*2.0 + tmp_qloop_178*2.0) + (tmp_qloop_125 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181)*(tmp_qloop_126 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5 + tmp_qloop_181*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_182 + tmp_qloop_183 + tmp_qloop_184)*(tmp_qloop_134 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5 + tmp_qloop_184*0.5)*2.0));
                   const real_t q_tmp_5_5 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187)*(tmp_qloop_117 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663 + tmp_qloop_187*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_185*1.0 + tmp_qloop_186*1.0 + tmp_qloop_187*1.0)*(tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0) + (tmp_qloop_125 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190)*(tmp_qloop_126 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5 + tmp_qloop_190*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_191 + tmp_qloop_192 + tmp_qloop_193)*(tmp_qloop_134 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5 + tmp_qloop_193*0.5)*2.0));
                   const real_t q_tmp_6_6 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_194 + tmp_qloop_195 + tmp_qloop_196)*(tmp_qloop_117 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663 + tmp_qloop_196*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_194*1.0 + tmp_qloop_195*1.0 + tmp_qloop_196*1.0)*(tmp_qloop_194*2.0 + tmp_qloop_195*2.0 + tmp_qloop_196*2.0) + (tmp_qloop_125 + tmp_qloop_197 + tmp_qloop_198 + tmp_qloop_199)*(tmp_qloop_126 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5 + tmp_qloop_199*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_200 + tmp_qloop_201 + tmp_qloop_202)*(tmp_qloop_134 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5 + tmp_qloop_202*0.5)*2.0));
                   const real_t q_tmp_7_7 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_203 + tmp_qloop_204 + tmp_qloop_205)*(tmp_qloop_117 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663 + tmp_qloop_205*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_203*1.0 + tmp_qloop_204*1.0 + tmp_qloop_205*1.0)*(tmp_qloop_203*2.0 + tmp_qloop_204*2.0 + tmp_qloop_205*2.0) + (tmp_qloop_125 + tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208)*(tmp_qloop_126 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5 + tmp_qloop_208*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211)*(tmp_qloop_134 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5 + tmp_qloop_211*0.5)*2.0));
                   const real_t q_tmp_8_8 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_212 + tmp_qloop_213 + tmp_qloop_214)*(tmp_qloop_117 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663 + tmp_qloop_214*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_212*1.0 + tmp_qloop_213*1.0 + tmp_qloop_214*1.0)*(tmp_qloop_212*2.0 + tmp_qloop_213*2.0 + tmp_qloop_214*2.0) + (tmp_qloop_125 + tmp_qloop_215 + tmp_qloop_216 + tmp_qloop_217)*(tmp_qloop_126 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5 + tmp_qloop_217*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220)*(tmp_qloop_134 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5 + tmp_qloop_220*0.5)*2.0));
                   const real_t q_tmp_9_9 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_221 + tmp_qloop_222 + tmp_qloop_223)*(tmp_qloop_117 + tmp_qloop_221*0.66666666666666663 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_221*1.0 + tmp_qloop_222*1.0 + tmp_qloop_223*1.0)*(tmp_qloop_221*2.0 + tmp_qloop_222*2.0 + tmp_qloop_223*2.0) + (tmp_qloop_125 + tmp_qloop_224 + tmp_qloop_225 + tmp_qloop_226)*(tmp_qloop_126 + tmp_qloop_224*0.5 + tmp_qloop_225*0.5 + tmp_qloop_226*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229)*(tmp_qloop_134 + tmp_qloop_227*0.5 + tmp_qloop_228*0.5 + tmp_qloop_229*0.5)*2.0));
                   const real_t q_tmp_10_10 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_230 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_237)*(tmp_qloop_230*0.66666666666666663 + tmp_qloop_231*0.66666666666666663 + tmp_qloop_232*0.66666666666666663 + tmp_qloop_239) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_230*1.0 + tmp_qloop_231*1.0 + tmp_qloop_232*1.0)*(tmp_qloop_230*2.0 + tmp_qloop_231*2.0 + tmp_qloop_232*2.0) + (tmp_qloop_140 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250)*(tmp_qloop_145 + tmp_qloop_248*0.5 + tmp_qloop_249*0.5 + tmp_qloop_250*0.5)*2.0 + (tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242 + tmp_qloop_246)*(tmp_qloop_240*0.5 + tmp_qloop_241*0.5 + tmp_qloop_242*0.5 + tmp_qloop_247)*2.0));
                   const real_t q_tmp_11_11 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_258 + tmp_qloop_259 + tmp_qloop_260)*(tmp_qloop_239 + tmp_qloop_258*0.66666666666666663 + tmp_qloop_259*0.66666666666666663 + tmp_qloop_260*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_258*1.0 + tmp_qloop_259*1.0 + tmp_qloop_260*1.0)*(tmp_qloop_258*2.0 + tmp_qloop_259*2.0 + tmp_qloop_260*2.0) + (tmp_qloop_140 + tmp_qloop_264 + tmp_qloop_265 + tmp_qloop_266)*(tmp_qloop_145 + tmp_qloop_264*0.5 + tmp_qloop_265*0.5 + tmp_qloop_266*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263)*(tmp_qloop_247 + tmp_qloop_261*0.5 + tmp_qloop_262*0.5 + tmp_qloop_263*0.5)*2.0));
                   const real_t q_tmp_12_12 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_267 + tmp_qloop_268 + tmp_qloop_269)*(tmp_qloop_239 + tmp_qloop_267*0.66666666666666663 + tmp_qloop_268*0.66666666666666663 + tmp_qloop_269*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_267*1.0 + tmp_qloop_268*1.0 + tmp_qloop_269*1.0)*(tmp_qloop_267*2.0 + tmp_qloop_268*2.0 + tmp_qloop_269*2.0) + (tmp_qloop_140 + tmp_qloop_273 + tmp_qloop_274 + tmp_qloop_275)*(tmp_qloop_145 + tmp_qloop_273*0.5 + tmp_qloop_274*0.5 + tmp_qloop_275*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272)*(tmp_qloop_247 + tmp_qloop_270*0.5 + tmp_qloop_271*0.5 + tmp_qloop_272*0.5)*2.0));
                   const real_t q_tmp_13_13 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_276 + tmp_qloop_277 + tmp_qloop_278)*(tmp_qloop_239 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0)*(tmp_qloop_276*2.0 + tmp_qloop_277*2.0 + tmp_qloop_278*2.0) + (tmp_qloop_140 + tmp_qloop_282 + tmp_qloop_283 + tmp_qloop_284)*(tmp_qloop_145 + tmp_qloop_282*0.5 + tmp_qloop_283*0.5 + tmp_qloop_284*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_279 + tmp_qloop_280 + tmp_qloop_281)*(tmp_qloop_247 + tmp_qloop_279*0.5 + tmp_qloop_280*0.5 + tmp_qloop_281*0.5)*2.0));
                   const real_t q_tmp_14_14 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_285 + tmp_qloop_286 + tmp_qloop_287)*(tmp_qloop_239 + tmp_qloop_285*0.66666666666666663 + tmp_qloop_286*0.66666666666666663 + tmp_qloop_287*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_285*1.0 + tmp_qloop_286*1.0 + tmp_qloop_287*1.0)*(tmp_qloop_285*2.0 + tmp_qloop_286*2.0 + tmp_qloop_287*2.0) + (tmp_qloop_140 + tmp_qloop_291 + tmp_qloop_292 + tmp_qloop_293)*(tmp_qloop_145 + tmp_qloop_291*0.5 + tmp_qloop_292*0.5 + tmp_qloop_293*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_288 + tmp_qloop_289 + tmp_qloop_290)*(tmp_qloop_247 + tmp_qloop_288*0.5 + tmp_qloop_289*0.5 + tmp_qloop_290*0.5)*2.0));
                   const real_t q_tmp_15_15 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_294 + tmp_qloop_295 + tmp_qloop_296)*(tmp_qloop_239 + tmp_qloop_294*0.66666666666666663 + tmp_qloop_295*0.66666666666666663 + tmp_qloop_296*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_294*1.0 + tmp_qloop_295*1.0 + tmp_qloop_296*1.0)*(tmp_qloop_294*2.0 + tmp_qloop_295*2.0 + tmp_qloop_296*2.0) + (tmp_qloop_140 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302)*(tmp_qloop_145 + tmp_qloop_300*0.5 + tmp_qloop_301*0.5 + tmp_qloop_302*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_297 + tmp_qloop_298 + tmp_qloop_299)*(tmp_qloop_247 + tmp_qloop_297*0.5 + tmp_qloop_298*0.5 + tmp_qloop_299*0.5)*2.0));
                   const real_t q_tmp_16_16 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_303 + tmp_qloop_304 + tmp_qloop_305)*(tmp_qloop_239 + tmp_qloop_303*0.66666666666666663 + tmp_qloop_304*0.66666666666666663 + tmp_qloop_305*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_303*1.0 + tmp_qloop_304*1.0 + tmp_qloop_305*1.0)*(tmp_qloop_303*2.0 + tmp_qloop_304*2.0 + tmp_qloop_305*2.0) + (tmp_qloop_140 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311)*(tmp_qloop_145 + tmp_qloop_309*0.5 + tmp_qloop_310*0.5 + tmp_qloop_311*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_308)*(tmp_qloop_247 + tmp_qloop_306*0.5 + tmp_qloop_307*0.5 + tmp_qloop_308*0.5)*2.0));
                   const real_t q_tmp_17_17 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_312 + tmp_qloop_313 + tmp_qloop_314)*(tmp_qloop_239 + tmp_qloop_312*0.66666666666666663 + tmp_qloop_313*0.66666666666666663 + tmp_qloop_314*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_312*1.0 + tmp_qloop_313*1.0 + tmp_qloop_314*1.0)*(tmp_qloop_312*2.0 + tmp_qloop_313*2.0 + tmp_qloop_314*2.0) + (tmp_qloop_140 + tmp_qloop_318 + tmp_qloop_319 + tmp_qloop_320)*(tmp_qloop_145 + tmp_qloop_318*0.5 + tmp_qloop_319*0.5 + tmp_qloop_320*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_315 + tmp_qloop_316 + tmp_qloop_317)*(tmp_qloop_247 + tmp_qloop_315*0.5 + tmp_qloop_316*0.5 + tmp_qloop_317*0.5)*2.0));
                   const real_t q_tmp_18_18 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_321 + tmp_qloop_322 + tmp_qloop_323)*(tmp_qloop_239 + tmp_qloop_321*0.66666666666666663 + tmp_qloop_322*0.66666666666666663 + tmp_qloop_323*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_321*1.0 + tmp_qloop_322*1.0 + tmp_qloop_323*1.0)*(tmp_qloop_321*2.0 + tmp_qloop_322*2.0 + tmp_qloop_323*2.0) + (tmp_qloop_140 + tmp_qloop_327 + tmp_qloop_328 + tmp_qloop_329)*(tmp_qloop_145 + tmp_qloop_327*0.5 + tmp_qloop_328*0.5 + tmp_qloop_329*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_326)*(tmp_qloop_247 + tmp_qloop_324*0.5 + tmp_qloop_325*0.5 + tmp_qloop_326*0.5)*2.0));
                   const real_t q_tmp_19_19 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_330 + tmp_qloop_331 + tmp_qloop_332)*(tmp_qloop_239 + tmp_qloop_330*0.66666666666666663 + tmp_qloop_331*0.66666666666666663 + tmp_qloop_332*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_330*1.0 + tmp_qloop_331*1.0 + tmp_qloop_332*1.0)*(tmp_qloop_330*2.0 + tmp_qloop_331*2.0 + tmp_qloop_332*2.0) + (tmp_qloop_140 + tmp_qloop_336 + tmp_qloop_337 + tmp_qloop_338)*(tmp_qloop_145 + tmp_qloop_336*0.5 + tmp_qloop_337*0.5 + tmp_qloop_338*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335)*(tmp_qloop_247 + tmp_qloop_333*0.5 + tmp_qloop_334*0.5 + tmp_qloop_335*0.5)*2.0));
                   const real_t q_tmp_20_20 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_339 + tmp_qloop_340 + tmp_qloop_341 + tmp_qloop_342)*(tmp_qloop_339*0.66666666666666663 + tmp_qloop_340*0.66666666666666663 + tmp_qloop_341*0.66666666666666663 + tmp_qloop_343) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_339*1.0 + tmp_qloop_340*1.0 + tmp_qloop_341*1.0)*(tmp_qloop_339*2.0 + tmp_qloop_340*2.0 + tmp_qloop_341*2.0) + (tmp_qloop_144 + tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349)*(tmp_qloop_146 + tmp_qloop_347*0.5 + tmp_qloop_348*0.5 + tmp_qloop_349*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_344 + tmp_qloop_345 + tmp_qloop_346)*(tmp_qloop_256 + tmp_qloop_344*0.5 + tmp_qloop_345*0.5 + tmp_qloop_346*0.5)*2.0));
                   const real_t q_tmp_21_21 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353)*(tmp_qloop_343 + tmp_qloop_351*0.66666666666666663 + tmp_qloop_352*0.66666666666666663 + tmp_qloop_353*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_351*1.0 + tmp_qloop_352*1.0 + tmp_qloop_353*1.0)*(tmp_qloop_351*2.0 + tmp_qloop_352*2.0 + tmp_qloop_353*2.0) + (tmp_qloop_144 + tmp_qloop_357 + tmp_qloop_358 + tmp_qloop_359)*(tmp_qloop_146 + tmp_qloop_357*0.5 + tmp_qloop_358*0.5 + tmp_qloop_359*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_354 + tmp_qloop_355 + tmp_qloop_356)*(tmp_qloop_256 + tmp_qloop_354*0.5 + tmp_qloop_355*0.5 + tmp_qloop_356*0.5)*2.0));
                   const real_t q_tmp_22_22 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_360 + tmp_qloop_361 + tmp_qloop_362)*(tmp_qloop_343 + tmp_qloop_360*0.66666666666666663 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_360*1.0 + tmp_qloop_361*1.0 + tmp_qloop_362*1.0)*(tmp_qloop_360*2.0 + tmp_qloop_361*2.0 + tmp_qloop_362*2.0) + (tmp_qloop_144 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_368)*(tmp_qloop_146 + tmp_qloop_366*0.5 + tmp_qloop_367*0.5 + tmp_qloop_368*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_363 + tmp_qloop_364 + tmp_qloop_365)*(tmp_qloop_256 + tmp_qloop_363*0.5 + tmp_qloop_364*0.5 + tmp_qloop_365*0.5)*2.0));
                   const real_t q_tmp_23_23 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_369 + tmp_qloop_370 + tmp_qloop_371)*(tmp_qloop_343 + tmp_qloop_369*0.66666666666666663 + tmp_qloop_370*0.66666666666666663 + tmp_qloop_371*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_369*1.0 + tmp_qloop_370*1.0 + tmp_qloop_371*1.0)*(tmp_qloop_369*2.0 + tmp_qloop_370*2.0 + tmp_qloop_371*2.0) + (tmp_qloop_144 + tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377)*(tmp_qloop_146 + tmp_qloop_375*0.5 + tmp_qloop_376*0.5 + tmp_qloop_377*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_372 + tmp_qloop_373 + tmp_qloop_374)*(tmp_qloop_256 + tmp_qloop_372*0.5 + tmp_qloop_373*0.5 + tmp_qloop_374*0.5)*2.0));
                   const real_t q_tmp_24_24 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_378 + tmp_qloop_379 + tmp_qloop_380)*(tmp_qloop_343 + tmp_qloop_378*0.66666666666666663 + tmp_qloop_379*0.66666666666666663 + tmp_qloop_380*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_378*1.0 + tmp_qloop_379*1.0 + tmp_qloop_380*1.0)*(tmp_qloop_378*2.0 + tmp_qloop_379*2.0 + tmp_qloop_380*2.0) + (tmp_qloop_144 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386)*(tmp_qloop_146 + tmp_qloop_384*0.5 + tmp_qloop_385*0.5 + tmp_qloop_386*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_381 + tmp_qloop_382 + tmp_qloop_383)*(tmp_qloop_256 + tmp_qloop_381*0.5 + tmp_qloop_382*0.5 + tmp_qloop_383*0.5)*2.0));
                   const real_t q_tmp_25_25 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_387 + tmp_qloop_388 + tmp_qloop_389)*(tmp_qloop_343 + tmp_qloop_387*0.66666666666666663 + tmp_qloop_388*0.66666666666666663 + tmp_qloop_389*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_387*1.0 + tmp_qloop_388*1.0 + tmp_qloop_389*1.0)*(tmp_qloop_387*2.0 + tmp_qloop_388*2.0 + tmp_qloop_389*2.0) + (tmp_qloop_144 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395)*(tmp_qloop_146 + tmp_qloop_393*0.5 + tmp_qloop_394*0.5 + tmp_qloop_395*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_392)*(tmp_qloop_256 + tmp_qloop_390*0.5 + tmp_qloop_391*0.5 + tmp_qloop_392*0.5)*2.0));
                   const real_t q_tmp_26_26 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_396 + tmp_qloop_397 + tmp_qloop_398)*(tmp_qloop_343 + tmp_qloop_396*0.66666666666666663 + tmp_qloop_397*0.66666666666666663 + tmp_qloop_398*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_396*1.0 + tmp_qloop_397*1.0 + tmp_qloop_398*1.0)*(tmp_qloop_396*2.0 + tmp_qloop_397*2.0 + tmp_qloop_398*2.0) + (tmp_qloop_144 + tmp_qloop_402 + tmp_qloop_403 + tmp_qloop_404)*(tmp_qloop_146 + tmp_qloop_402*0.5 + tmp_qloop_403*0.5 + tmp_qloop_404*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_399 + tmp_qloop_400 + tmp_qloop_401)*(tmp_qloop_256 + tmp_qloop_399*0.5 + tmp_qloop_400*0.5 + tmp_qloop_401*0.5)*2.0));
                   const real_t q_tmp_27_27 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_405 + tmp_qloop_406 + tmp_qloop_407)*(tmp_qloop_343 + tmp_qloop_405*0.66666666666666663 + tmp_qloop_406*0.66666666666666663 + tmp_qloop_407*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_405*1.0 + tmp_qloop_406*1.0 + tmp_qloop_407*1.0)*(tmp_qloop_405*2.0 + tmp_qloop_406*2.0 + tmp_qloop_407*2.0) + (tmp_qloop_144 + tmp_qloop_411 + tmp_qloop_412 + tmp_qloop_413)*(tmp_qloop_146 + tmp_qloop_411*0.5 + tmp_qloop_412*0.5 + tmp_qloop_413*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_410)*(tmp_qloop_256 + tmp_qloop_408*0.5 + tmp_qloop_409*0.5 + tmp_qloop_410*0.5)*2.0));
                   const real_t q_tmp_28_28 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_414 + tmp_qloop_415 + tmp_qloop_416)*(tmp_qloop_343 + tmp_qloop_414*0.66666666666666663 + tmp_qloop_415*0.66666666666666663 + tmp_qloop_416*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_414*1.0 + tmp_qloop_415*1.0 + tmp_qloop_416*1.0)*(tmp_qloop_414*2.0 + tmp_qloop_415*2.0 + tmp_qloop_416*2.0) + (tmp_qloop_144 + tmp_qloop_420 + tmp_qloop_421 + tmp_qloop_422)*(tmp_qloop_146 + tmp_qloop_420*0.5 + tmp_qloop_421*0.5 + tmp_qloop_422*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419)*(tmp_qloop_256 + tmp_qloop_417*0.5 + tmp_qloop_418*0.5 + tmp_qloop_419*0.5)*2.0));
                   const real_t q_tmp_29_29 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_423 + tmp_qloop_424 + tmp_qloop_425)*(tmp_qloop_343 + tmp_qloop_423*0.66666666666666663 + tmp_qloop_424*0.66666666666666663 + tmp_qloop_425*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_423*1.0 + tmp_qloop_424*1.0 + tmp_qloop_425*1.0)*(tmp_qloop_423*2.0 + tmp_qloop_424*2.0 + tmp_qloop_425*2.0) + (tmp_qloop_144 + tmp_qloop_429 + tmp_qloop_430 + tmp_qloop_431)*(tmp_qloop_146 + tmp_qloop_429*0.5 + tmp_qloop_430*0.5 + tmp_qloop_431*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428)*(tmp_qloop_256 + tmp_qloop_426*0.5 + tmp_qloop_427*0.5 + tmp_qloop_428*0.5)*2.0));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                const real_t elMatDiag_4 = q_acc_4_4;
                const real_t elMatDiag_5 = q_acc_5_5;
                const real_t elMatDiag_6 = q_acc_6_6;
                const real_t elMatDiag_7 = q_acc_7_7;
                const real_t elMatDiag_8 = q_acc_8_8;
                const real_t elMatDiag_9 = q_acc_9_9;
                const real_t elMatDiag_10 = q_acc_10_10;
                const real_t elMatDiag_11 = q_acc_11_11;
                const real_t elMatDiag_12 = q_acc_12_12;
                const real_t elMatDiag_13 = q_acc_13_13;
                const real_t elMatDiag_14 = q_acc_14_14;
                const real_t elMatDiag_15 = q_acc_15_15;
                const real_t elMatDiag_16 = q_acc_16_16;
                const real_t elMatDiag_17 = q_acc_17_17;
                const real_t elMatDiag_18 = q_acc_18_18;
                const real_t elMatDiag_19 = q_acc_19_19;
                const real_t elMatDiag_20 = q_acc_20_20;
                const real_t elMatDiag_21 = q_acc_21_21;
                const real_t elMatDiag_22 = q_acc_22_22;
                const real_t elMatDiag_23 = q_acc_23_23;
                const real_t elMatDiag_24 = q_acc_24_24;
                const real_t elMatDiag_25 = q_acc_25_25;
                const real_t elMatDiag_26 = q_acc_26_26;
                const real_t elMatDiag_27 = q_acc_27_27;
                const real_t elMatDiag_28 = q_acc_28_28;
                const real_t elMatDiag_29 = q_acc_29_29;
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_9 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_10 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_11 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_12 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_13 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_14 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_15 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_16 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_17 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_18 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_19 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_20 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_21 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_22 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_23 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_24 + _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_25 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_26 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_27 + _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_28 + _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_29 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_UP [] = {0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(abs_det_jac_affine_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(abs_det_jac_affine_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(abs_det_jac_affine_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5]));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6]));
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7]));
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8]));
                   const __m256d tmp_qloop_212 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9]));
                   const __m256d tmp_qloop_221 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10]));
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_297 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_354 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q]));
                   const __m256d tmp_qloop_137 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2]));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9]));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10]));
                   const __m256d tmp_qloop_230 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_243 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_303 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_312 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_402 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_411 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_420 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_429 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q]));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2]));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3]));
                   const __m256d tmp_qloop_173 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4]));
                   const __m256d tmp_qloop_182 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5]));
                   const __m256d tmp_qloop_191 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6]));
                   const __m256d tmp_qloop_200 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_252 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11]));
                   const __m256d tmp_qloop_264 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_273 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_282 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_291 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_318 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_327 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_336 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_360 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_369 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_378 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_387 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_396 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_186 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_195 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_204 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_213 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_234 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_280 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_289 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_298 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_345 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_355 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_364 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_373 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_382 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_225 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_304 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_313 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_322 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_331 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_430 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_128 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_265 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_340 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_388 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_397 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_406 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_415 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_424 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_122,tmp_qloop_123),tmp_qloop_124);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_169 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_178 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_187 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_236 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_233,tmp_qloop_234),tmp_qloop_235);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_251 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_281 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_290 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_299 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_308 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_317 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_326 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_346 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_374 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_383 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_392 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_401 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_410 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_137,tmp_qloop_138),tmp_qloop_139);
                   const __m256d tmp_qloop_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_138,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_199 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_208 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_217 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_226 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_246 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_243,tmp_qloop_244),tmp_qloop_245);
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_243,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_244,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_245,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_260 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_269 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_296 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_332 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_342 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_236);
                   const __m256d tmp_qloop_343 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_238);
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_246),_mm256_add_pd(tmp_qloop_126,tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_251);
                   const __m256d tmp_qloop_359 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_368 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_129 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_144 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_141,tmp_qloop_142),tmp_qloop_143);
                   const __m256d tmp_qloop_146 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_141,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_142,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_143,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_144),_mm256_add_pd(tmp_qloop_145,tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_136);
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_237 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_236);
                   const __m256d tmp_qloop_239 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_238);
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_255 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_252,tmp_qloop_253),tmp_qloop_254);
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_253,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_254,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_257 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_255),_mm256_add_pd(tmp_qloop_134,tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_136),tmp_qloop_251);
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_341 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_416 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_425 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10]));
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_119,tmp_qloop_120),tmp_qloop_121),tmp_qloop_125),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_120,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_121,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_128),tmp_qloop_129),tmp_qloop_133),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_129,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_114)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_152),tmp_qloop_153),tmp_qloop_154),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_154,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_155),tmp_qloop_156),tmp_qloop_157),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_155,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_156,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_149),tmp_qloop_150),tmp_qloop_151)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_161),tmp_qloop_162),tmp_qloop_163),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_162,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_163,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_164),tmp_qloop_165),tmp_qloop_166),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_164,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_165,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_166,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_158),tmp_qloop_159),tmp_qloop_160)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_173),tmp_qloop_174),tmp_qloop_175),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_173,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_174,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_175,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_167),tmp_qloop_168),tmp_qloop_169)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_179,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_180,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_181,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_182),tmp_qloop_183),tmp_qloop_184),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_182,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_176),tmp_qloop_177),tmp_qloop_178)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_188,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_189,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_190,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_191),tmp_qloop_192),tmp_qloop_193),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_191,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_192,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_193,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_185),tmp_qloop_186),tmp_qloop_187)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_197),tmp_qloop_198),tmp_qloop_199),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_199,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_200),tmp_qloop_201),tmp_qloop_202),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_201,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_202,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_194),tmp_qloop_195),tmp_qloop_196)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_206),tmp_qloop_207),tmp_qloop_208),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_206,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_207,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_208,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_203),tmp_qloop_204),tmp_qloop_205)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_215),tmp_qloop_216),tmp_qloop_217),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_215,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_216,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_217,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_218,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_219,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_220,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_212),tmp_qloop_213),tmp_qloop_214)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_224),tmp_qloop_225),tmp_qloop_226),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_225,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_226,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_227,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_228,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_229,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_221),tmp_qloop_222),tmp_qloop_223)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_240,tmp_qloop_241),tmp_qloop_242),tmp_qloop_246),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_240,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_241,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_242,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_230,tmp_qloop_231),tmp_qloop_232),tmp_qloop_237)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_264),tmp_qloop_265),tmp_qloop_266),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_264,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_265,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_266,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_258),tmp_qloop_259),tmp_qloop_260)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_270,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_271,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_272,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_273),tmp_qloop_274),tmp_qloop_275),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_273,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_267),tmp_qloop_268),tmp_qloop_269)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_279),tmp_qloop_280),tmp_qloop_281),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_280,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_281,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_282),tmp_qloop_283),tmp_qloop_284),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_282,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_283,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_284,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_276),tmp_qloop_277),tmp_qloop_278)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_288),tmp_qloop_289),tmp_qloop_290),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_289,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_290,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_291),tmp_qloop_292),tmp_qloop_293),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_291,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_292,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_285),tmp_qloop_286),tmp_qloop_287)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_297),tmp_qloop_298),tmp_qloop_299),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_298,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_299,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_300,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_301,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_302,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_294),tmp_qloop_295),tmp_qloop_296)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_306),tmp_qloop_307),tmp_qloop_308),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_308,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_309,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_310,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_311,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_303),tmp_qloop_304),tmp_qloop_305)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_315),tmp_qloop_316),tmp_qloop_317),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_315,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_316,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_317,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_318),tmp_qloop_319),tmp_qloop_320),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_318,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_312),tmp_qloop_313),tmp_qloop_314)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_324),tmp_qloop_325),tmp_qloop_326),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_324,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_325,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_326,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_327),tmp_qloop_328),tmp_qloop_329),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_327,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_328,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_329,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_321),tmp_qloop_322),tmp_qloop_323)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_333),tmp_qloop_334),tmp_qloop_335),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_336),tmp_qloop_337),tmp_qloop_338),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_336,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_337,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_338,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_330),tmp_qloop_331),tmp_qloop_332)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_344),tmp_qloop_345),tmp_qloop_346),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_344,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_345,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_346,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_347),tmp_qloop_348),tmp_qloop_349),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_339,tmp_qloop_340),tmp_qloop_341),tmp_qloop_342)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_354),tmp_qloop_355),tmp_qloop_356),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_355,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_356,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_357),tmp_qloop_358),tmp_qloop_359),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_357,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_358,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_359,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_363),tmp_qloop_364),tmp_qloop_365),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_364,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_365,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_366),tmp_qloop_367),tmp_qloop_368),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_366,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_367,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_368,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_360),tmp_qloop_361),tmp_qloop_362)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_372),tmp_qloop_373),tmp_qloop_374),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_372,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_373,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_374,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_375),tmp_qloop_376),tmp_qloop_377),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_369),tmp_qloop_370),tmp_qloop_371)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_381),tmp_qloop_382),tmp_qloop_383),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_381,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_382,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_383,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_384,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_385,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_386,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_378),tmp_qloop_379),tmp_qloop_380)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_390),tmp_qloop_391),tmp_qloop_392),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_392,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_393,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_394,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_395,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_387),tmp_qloop_388),tmp_qloop_389)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_399),tmp_qloop_400),tmp_qloop_401),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_399,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_400,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_401,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_402),tmp_qloop_403),tmp_qloop_404),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_402,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_396),tmp_qloop_397),tmp_qloop_398)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_408),tmp_qloop_409),tmp_qloop_410),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_408,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_409,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_410,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_411),tmp_qloop_412),tmp_qloop_413),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_411,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_412,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_413,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_405),tmp_qloop_406),tmp_qloop_407)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_417),tmp_qloop_418),tmp_qloop_419),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_420),tmp_qloop_421),tmp_qloop_422),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_420,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_421,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_422,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_414),tmp_qloop_415),tmp_qloop_416)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_426,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_427,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_428,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_429),tmp_qloop_430),tmp_qloop_431),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_429,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_430,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_423),tmp_qloop_424),tmp_qloop_425)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                const __m256d elMatDiag_4 = q_acc_4_4;
                const __m256d elMatDiag_5 = q_acc_5_5;
                const __m256d elMatDiag_6 = q_acc_6_6;
                const __m256d elMatDiag_7 = q_acc_7_7;
                const __m256d elMatDiag_8 = q_acc_8_8;
                const __m256d elMatDiag_9 = q_acc_9_9;
                const __m256d elMatDiag_10 = q_acc_10_10;
                const __m256d elMatDiag_11 = q_acc_11_11;
                const __m256d elMatDiag_12 = q_acc_12_12;
                const __m256d elMatDiag_13 = q_acc_13_13;
                const __m256d elMatDiag_14 = q_acc_14_14;
                const __m256d elMatDiag_15 = q_acc_15_15;
                const __m256d elMatDiag_16 = q_acc_16_16;
                const __m256d elMatDiag_17 = q_acc_17_17;
                const __m256d elMatDiag_18 = q_acc_18_18;
                const __m256d elMatDiag_19 = q_acc_19_19;
                const __m256d elMatDiag_20 = q_acc_20_20;
                const __m256d elMatDiag_21 = q_acc_21_21;
                const __m256d elMatDiag_22 = q_acc_22_22;
                const __m256d elMatDiag_23 = q_acc_23_23;
                const __m256d elMatDiag_24 = q_acc_24_24;
                const __m256d elMatDiag_25 = q_acc_25_25;
                const __m256d elMatDiag_26 = q_acc_26_26;
                const __m256d elMatDiag_27 = q_acc_27_27;
                const __m256d elMatDiag_28 = q_acc_28_28;
                const __m256d elMatDiag_29 = q_acc_29_29;
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_10,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_11,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_12,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_13,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_14,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_15,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_16,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_17,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_18,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_19,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_20,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_21,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_22,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_23,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_24,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_25,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_26,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_27,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_28,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_29,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_148 = (mu_dof_0*_data_phi_0_0_BLUE_UP[10*q] + mu_dof_1*_data_phi_0_0_BLUE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_UP[10*q + 9])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2];
                   const real_t tmp_qloop_158 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3];
                   const real_t tmp_qloop_167 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4];
                   const real_t tmp_qloop_176 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5];
                   const real_t tmp_qloop_185 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6];
                   const real_t tmp_qloop_194 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7];
                   const real_t tmp_qloop_203 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8];
                   const real_t tmp_qloop_212 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9];
                   const real_t tmp_qloop_221 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10];
                   const real_t tmp_qloop_233 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_279 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_288 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_297 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_306 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_315 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_324 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_344 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_354 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_363 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_372 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_381 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_390 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_399 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_408 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_119 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q];
                   const real_t tmp_qloop_137 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_152 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2];
                   const real_t tmp_qloop_161 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6];
                   const real_t tmp_qloop_197 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7];
                   const real_t tmp_qloop_206 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8];
                   const real_t tmp_qloop_215 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9];
                   const real_t tmp_qloop_224 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10];
                   const real_t tmp_qloop_230 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_243 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11];
                   const real_t tmp_qloop_258 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_267 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_276 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_285 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_294 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_303 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_312 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_321 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_330 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_357 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_366 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_402 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_411 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_420 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_429 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_127 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q];
                   const real_t tmp_qloop_141 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_155 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2];
                   const real_t tmp_qloop_164 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3];
                   const real_t tmp_qloop_173 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4];
                   const real_t tmp_qloop_182 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5];
                   const real_t tmp_qloop_191 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6];
                   const real_t tmp_qloop_200 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_252 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11];
                   const real_t tmp_qloop_264 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_273 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_282 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_291 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_318 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_327 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_336 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_339 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_360 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_369 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_378 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_387 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_396 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_405 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_414 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_123 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_150 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_159 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_168 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_177 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_186 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_195 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_204 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_213 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_222 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_234 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_280 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_289 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_298 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_307 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_316 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_325 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_345 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_355 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_364 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_373 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_382 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_391 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_400 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_409 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_120 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_138 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_153 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_162 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_198 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_207 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_216 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_225 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_231 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_244 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_259 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_268 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_277 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_286 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_295 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_304 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_313 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_322 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_331 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_358 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_367 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_403 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_412 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_421 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_430 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_128 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_142 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_156 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_165 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_174 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_192 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_201 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_253 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_265 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_274 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_283 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_292 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_319 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_328 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_337 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_340 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_361 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_370 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_379 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_388 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_397 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_406 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_415 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_424 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_125 = tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_124;
                   const real_t tmp_qloop_126 = tmp_qloop_122*0.5 + tmp_qloop_123*0.5 + tmp_qloop_124*0.5;
                   const real_t tmp_qloop_132 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_133 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132;
                   const real_t tmp_qloop_134 = tmp_qloop_130*0.5 + tmp_qloop_131*0.5 + tmp_qloop_132*0.5;
                   const real_t tmp_qloop_151 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_160 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_169 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_178 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_187 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_196 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_205 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_214 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_223 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_235 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_236 = tmp_qloop_233 + tmp_qloop_234 + tmp_qloop_235;
                   const real_t tmp_qloop_238 = tmp_qloop_233*0.66666666666666663 + tmp_qloop_234*0.66666666666666663 + tmp_qloop_235*0.66666666666666663;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_251 = (tmp_qloop_233*1.0 + tmp_qloop_234*1.0 + tmp_qloop_235*1.0)*(tmp_qloop_233*2.0 + tmp_qloop_234*2.0 + tmp_qloop_235*2.0);
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_272 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_281 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_290 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_299 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_308 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_317 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_326 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_335 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_346 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_356 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_365 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_374 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_383 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_392 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_401 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_410 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_419 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_428 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_116 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_121 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_135 = (tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0)*(tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0);
                   const real_t tmp_qloop_139 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_140 = tmp_qloop_137 + tmp_qloop_138 + tmp_qloop_139;
                   const real_t tmp_qloop_145 = tmp_qloop_137*0.5 + tmp_qloop_138*0.5 + tmp_qloop_139*0.5;
                   const real_t tmp_qloop_154 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_163 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_172 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_181 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_199 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_208 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_217 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_226 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_232 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_245 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_246 = tmp_qloop_243 + tmp_qloop_244 + tmp_qloop_245;
                   const real_t tmp_qloop_247 = tmp_qloop_243*0.5 + tmp_qloop_244*0.5 + tmp_qloop_245*0.5;
                   const real_t tmp_qloop_260 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_269 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_278 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_287 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_296 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_305 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_314 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_323 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_332 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_342 = tmp_qloop_113 + tmp_qloop_236;
                   const real_t tmp_qloop_343 = tmp_qloop_116 + tmp_qloop_238;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_350 = tmp_qloop_135 + tmp_qloop_251 + (tmp_qloop_125 + tmp_qloop_246)*(tmp_qloop_126 + tmp_qloop_247)*2.0;
                   const real_t tmp_qloop_359 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_368 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_386 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_404 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_413 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_422 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_431 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_129 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_136 = (tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_143 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_144 = tmp_qloop_141 + tmp_qloop_142 + tmp_qloop_143;
                   const real_t tmp_qloop_146 = tmp_qloop_141*0.5 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5;
                   const real_t tmp_qloop_147 = tmp_qloop_135 + tmp_qloop_136 + (tmp_qloop_140 + tmp_qloop_144)*(tmp_qloop_145 + tmp_qloop_146)*2.0;
                   const real_t tmp_qloop_157 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_166 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_184 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_193 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_202 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_211 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_229 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_237 = tmp_qloop_109 + tmp_qloop_236;
                   const real_t tmp_qloop_239 = tmp_qloop_115 + tmp_qloop_238;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_254 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_255 = tmp_qloop_252 + tmp_qloop_253 + tmp_qloop_254;
                   const real_t tmp_qloop_256 = tmp_qloop_252*0.5 + tmp_qloop_253*0.5 + tmp_qloop_254*0.5;
                   const real_t tmp_qloop_257 = tmp_qloop_136 + tmp_qloop_251 + (tmp_qloop_133 + tmp_qloop_255)*(tmp_qloop_134 + tmp_qloop_256)*2.0;
                   const real_t tmp_qloop_266 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_275 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_284 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_293 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_311 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_320 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_329 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_338 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_341 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_362 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_371 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_380 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_389 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_398 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_407 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_416 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_425 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10];
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_114)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_117) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_119 + tmp_qloop_120 + tmp_qloop_121 + tmp_qloop_125)*(tmp_qloop_119*0.5 + tmp_qloop_120*0.5 + tmp_qloop_121*0.5 + tmp_qloop_126)*2.0 + (tmp_qloop_127 + tmp_qloop_128 + tmp_qloop_129 + tmp_qloop_133)*(tmp_qloop_127*0.5 + tmp_qloop_128*0.5 + tmp_qloop_129*0.5 + tmp_qloop_134)*2.0));
                   const real_t q_tmp_1_1 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_149 + tmp_qloop_150 + tmp_qloop_151)*(tmp_qloop_117 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663 + tmp_qloop_151*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_149*1.0 + tmp_qloop_150*1.0 + tmp_qloop_151*1.0)*(tmp_qloop_149*2.0 + tmp_qloop_150*2.0 + tmp_qloop_151*2.0) + (tmp_qloop_125 + tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_154)*(tmp_qloop_126 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5 + tmp_qloop_154*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_155 + tmp_qloop_156 + tmp_qloop_157)*(tmp_qloop_134 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5 + tmp_qloop_157*0.5)*2.0));
                   const real_t q_tmp_2_2 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_158 + tmp_qloop_159 + tmp_qloop_160)*(tmp_qloop_117 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663 + tmp_qloop_160*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_158*1.0 + tmp_qloop_159*1.0 + tmp_qloop_160*1.0)*(tmp_qloop_158*2.0 + tmp_qloop_159*2.0 + tmp_qloop_160*2.0) + (tmp_qloop_125 + tmp_qloop_161 + tmp_qloop_162 + tmp_qloop_163)*(tmp_qloop_126 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5 + tmp_qloop_163*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_164 + tmp_qloop_165 + tmp_qloop_166)*(tmp_qloop_134 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5 + tmp_qloop_166*0.5)*2.0));
                   const real_t q_tmp_3_3 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_167 + tmp_qloop_168 + tmp_qloop_169)*(tmp_qloop_117 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663 + tmp_qloop_169*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_167*1.0 + tmp_qloop_168*1.0 + tmp_qloop_169*1.0)*(tmp_qloop_167*2.0 + tmp_qloop_168*2.0 + tmp_qloop_169*2.0) + (tmp_qloop_125 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172)*(tmp_qloop_126 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5 + tmp_qloop_172*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_173 + tmp_qloop_174 + tmp_qloop_175)*(tmp_qloop_134 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5 + tmp_qloop_175*0.5)*2.0));
                   const real_t q_tmp_4_4 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_176 + tmp_qloop_177 + tmp_qloop_178)*(tmp_qloop_117 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663 + tmp_qloop_178*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_176*1.0 + tmp_qloop_177*1.0 + tmp_qloop_178*1.0)*(tmp_qloop_176*2.0 + tmp_qloop_177*2.0 + tmp_qloop_178*2.0) + (tmp_qloop_125 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181)*(tmp_qloop_126 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5 + tmp_qloop_181*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_182 + tmp_qloop_183 + tmp_qloop_184)*(tmp_qloop_134 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5 + tmp_qloop_184*0.5)*2.0));
                   const real_t q_tmp_5_5 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187)*(tmp_qloop_117 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663 + tmp_qloop_187*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_185*1.0 + tmp_qloop_186*1.0 + tmp_qloop_187*1.0)*(tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0) + (tmp_qloop_125 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190)*(tmp_qloop_126 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5 + tmp_qloop_190*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_191 + tmp_qloop_192 + tmp_qloop_193)*(tmp_qloop_134 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5 + tmp_qloop_193*0.5)*2.0));
                   const real_t q_tmp_6_6 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_194 + tmp_qloop_195 + tmp_qloop_196)*(tmp_qloop_117 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663 + tmp_qloop_196*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_194*1.0 + tmp_qloop_195*1.0 + tmp_qloop_196*1.0)*(tmp_qloop_194*2.0 + tmp_qloop_195*2.0 + tmp_qloop_196*2.0) + (tmp_qloop_125 + tmp_qloop_197 + tmp_qloop_198 + tmp_qloop_199)*(tmp_qloop_126 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5 + tmp_qloop_199*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_200 + tmp_qloop_201 + tmp_qloop_202)*(tmp_qloop_134 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5 + tmp_qloop_202*0.5)*2.0));
                   const real_t q_tmp_7_7 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_203 + tmp_qloop_204 + tmp_qloop_205)*(tmp_qloop_117 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663 + tmp_qloop_205*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_203*1.0 + tmp_qloop_204*1.0 + tmp_qloop_205*1.0)*(tmp_qloop_203*2.0 + tmp_qloop_204*2.0 + tmp_qloop_205*2.0) + (tmp_qloop_125 + tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208)*(tmp_qloop_126 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5 + tmp_qloop_208*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211)*(tmp_qloop_134 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5 + tmp_qloop_211*0.5)*2.0));
                   const real_t q_tmp_8_8 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_212 + tmp_qloop_213 + tmp_qloop_214)*(tmp_qloop_117 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663 + tmp_qloop_214*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_212*1.0 + tmp_qloop_213*1.0 + tmp_qloop_214*1.0)*(tmp_qloop_212*2.0 + tmp_qloop_213*2.0 + tmp_qloop_214*2.0) + (tmp_qloop_125 + tmp_qloop_215 + tmp_qloop_216 + tmp_qloop_217)*(tmp_qloop_126 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5 + tmp_qloop_217*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220)*(tmp_qloop_134 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5 + tmp_qloop_220*0.5)*2.0));
                   const real_t q_tmp_9_9 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_221 + tmp_qloop_222 + tmp_qloop_223)*(tmp_qloop_117 + tmp_qloop_221*0.66666666666666663 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_221*1.0 + tmp_qloop_222*1.0 + tmp_qloop_223*1.0)*(tmp_qloop_221*2.0 + tmp_qloop_222*2.0 + tmp_qloop_223*2.0) + (tmp_qloop_125 + tmp_qloop_224 + tmp_qloop_225 + tmp_qloop_226)*(tmp_qloop_126 + tmp_qloop_224*0.5 + tmp_qloop_225*0.5 + tmp_qloop_226*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229)*(tmp_qloop_134 + tmp_qloop_227*0.5 + tmp_qloop_228*0.5 + tmp_qloop_229*0.5)*2.0));
                   const real_t q_tmp_10_10 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_230 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_237)*(tmp_qloop_230*0.66666666666666663 + tmp_qloop_231*0.66666666666666663 + tmp_qloop_232*0.66666666666666663 + tmp_qloop_239) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_230*1.0 + tmp_qloop_231*1.0 + tmp_qloop_232*1.0)*(tmp_qloop_230*2.0 + tmp_qloop_231*2.0 + tmp_qloop_232*2.0) + (tmp_qloop_140 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250)*(tmp_qloop_145 + tmp_qloop_248*0.5 + tmp_qloop_249*0.5 + tmp_qloop_250*0.5)*2.0 + (tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242 + tmp_qloop_246)*(tmp_qloop_240*0.5 + tmp_qloop_241*0.5 + tmp_qloop_242*0.5 + tmp_qloop_247)*2.0));
                   const real_t q_tmp_11_11 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_258 + tmp_qloop_259 + tmp_qloop_260)*(tmp_qloop_239 + tmp_qloop_258*0.66666666666666663 + tmp_qloop_259*0.66666666666666663 + tmp_qloop_260*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_258*1.0 + tmp_qloop_259*1.0 + tmp_qloop_260*1.0)*(tmp_qloop_258*2.0 + tmp_qloop_259*2.0 + tmp_qloop_260*2.0) + (tmp_qloop_140 + tmp_qloop_264 + tmp_qloop_265 + tmp_qloop_266)*(tmp_qloop_145 + tmp_qloop_264*0.5 + tmp_qloop_265*0.5 + tmp_qloop_266*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263)*(tmp_qloop_247 + tmp_qloop_261*0.5 + tmp_qloop_262*0.5 + tmp_qloop_263*0.5)*2.0));
                   const real_t q_tmp_12_12 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_267 + tmp_qloop_268 + tmp_qloop_269)*(tmp_qloop_239 + tmp_qloop_267*0.66666666666666663 + tmp_qloop_268*0.66666666666666663 + tmp_qloop_269*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_267*1.0 + tmp_qloop_268*1.0 + tmp_qloop_269*1.0)*(tmp_qloop_267*2.0 + tmp_qloop_268*2.0 + tmp_qloop_269*2.0) + (tmp_qloop_140 + tmp_qloop_273 + tmp_qloop_274 + tmp_qloop_275)*(tmp_qloop_145 + tmp_qloop_273*0.5 + tmp_qloop_274*0.5 + tmp_qloop_275*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272)*(tmp_qloop_247 + tmp_qloop_270*0.5 + tmp_qloop_271*0.5 + tmp_qloop_272*0.5)*2.0));
                   const real_t q_tmp_13_13 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_276 + tmp_qloop_277 + tmp_qloop_278)*(tmp_qloop_239 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0)*(tmp_qloop_276*2.0 + tmp_qloop_277*2.0 + tmp_qloop_278*2.0) + (tmp_qloop_140 + tmp_qloop_282 + tmp_qloop_283 + tmp_qloop_284)*(tmp_qloop_145 + tmp_qloop_282*0.5 + tmp_qloop_283*0.5 + tmp_qloop_284*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_279 + tmp_qloop_280 + tmp_qloop_281)*(tmp_qloop_247 + tmp_qloop_279*0.5 + tmp_qloop_280*0.5 + tmp_qloop_281*0.5)*2.0));
                   const real_t q_tmp_14_14 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_285 + tmp_qloop_286 + tmp_qloop_287)*(tmp_qloop_239 + tmp_qloop_285*0.66666666666666663 + tmp_qloop_286*0.66666666666666663 + tmp_qloop_287*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_285*1.0 + tmp_qloop_286*1.0 + tmp_qloop_287*1.0)*(tmp_qloop_285*2.0 + tmp_qloop_286*2.0 + tmp_qloop_287*2.0) + (tmp_qloop_140 + tmp_qloop_291 + tmp_qloop_292 + tmp_qloop_293)*(tmp_qloop_145 + tmp_qloop_291*0.5 + tmp_qloop_292*0.5 + tmp_qloop_293*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_288 + tmp_qloop_289 + tmp_qloop_290)*(tmp_qloop_247 + tmp_qloop_288*0.5 + tmp_qloop_289*0.5 + tmp_qloop_290*0.5)*2.0));
                   const real_t q_tmp_15_15 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_294 + tmp_qloop_295 + tmp_qloop_296)*(tmp_qloop_239 + tmp_qloop_294*0.66666666666666663 + tmp_qloop_295*0.66666666666666663 + tmp_qloop_296*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_294*1.0 + tmp_qloop_295*1.0 + tmp_qloop_296*1.0)*(tmp_qloop_294*2.0 + tmp_qloop_295*2.0 + tmp_qloop_296*2.0) + (tmp_qloop_140 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302)*(tmp_qloop_145 + tmp_qloop_300*0.5 + tmp_qloop_301*0.5 + tmp_qloop_302*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_297 + tmp_qloop_298 + tmp_qloop_299)*(tmp_qloop_247 + tmp_qloop_297*0.5 + tmp_qloop_298*0.5 + tmp_qloop_299*0.5)*2.0));
                   const real_t q_tmp_16_16 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_303 + tmp_qloop_304 + tmp_qloop_305)*(tmp_qloop_239 + tmp_qloop_303*0.66666666666666663 + tmp_qloop_304*0.66666666666666663 + tmp_qloop_305*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_303*1.0 + tmp_qloop_304*1.0 + tmp_qloop_305*1.0)*(tmp_qloop_303*2.0 + tmp_qloop_304*2.0 + tmp_qloop_305*2.0) + (tmp_qloop_140 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311)*(tmp_qloop_145 + tmp_qloop_309*0.5 + tmp_qloop_310*0.5 + tmp_qloop_311*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_308)*(tmp_qloop_247 + tmp_qloop_306*0.5 + tmp_qloop_307*0.5 + tmp_qloop_308*0.5)*2.0));
                   const real_t q_tmp_17_17 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_312 + tmp_qloop_313 + tmp_qloop_314)*(tmp_qloop_239 + tmp_qloop_312*0.66666666666666663 + tmp_qloop_313*0.66666666666666663 + tmp_qloop_314*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_312*1.0 + tmp_qloop_313*1.0 + tmp_qloop_314*1.0)*(tmp_qloop_312*2.0 + tmp_qloop_313*2.0 + tmp_qloop_314*2.0) + (tmp_qloop_140 + tmp_qloop_318 + tmp_qloop_319 + tmp_qloop_320)*(tmp_qloop_145 + tmp_qloop_318*0.5 + tmp_qloop_319*0.5 + tmp_qloop_320*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_315 + tmp_qloop_316 + tmp_qloop_317)*(tmp_qloop_247 + tmp_qloop_315*0.5 + tmp_qloop_316*0.5 + tmp_qloop_317*0.5)*2.0));
                   const real_t q_tmp_18_18 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_321 + tmp_qloop_322 + tmp_qloop_323)*(tmp_qloop_239 + tmp_qloop_321*0.66666666666666663 + tmp_qloop_322*0.66666666666666663 + tmp_qloop_323*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_321*1.0 + tmp_qloop_322*1.0 + tmp_qloop_323*1.0)*(tmp_qloop_321*2.0 + tmp_qloop_322*2.0 + tmp_qloop_323*2.0) + (tmp_qloop_140 + tmp_qloop_327 + tmp_qloop_328 + tmp_qloop_329)*(tmp_qloop_145 + tmp_qloop_327*0.5 + tmp_qloop_328*0.5 + tmp_qloop_329*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_326)*(tmp_qloop_247 + tmp_qloop_324*0.5 + tmp_qloop_325*0.5 + tmp_qloop_326*0.5)*2.0));
                   const real_t q_tmp_19_19 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_330 + tmp_qloop_331 + tmp_qloop_332)*(tmp_qloop_239 + tmp_qloop_330*0.66666666666666663 + tmp_qloop_331*0.66666666666666663 + tmp_qloop_332*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_330*1.0 + tmp_qloop_331*1.0 + tmp_qloop_332*1.0)*(tmp_qloop_330*2.0 + tmp_qloop_331*2.0 + tmp_qloop_332*2.0) + (tmp_qloop_140 + tmp_qloop_336 + tmp_qloop_337 + tmp_qloop_338)*(tmp_qloop_145 + tmp_qloop_336*0.5 + tmp_qloop_337*0.5 + tmp_qloop_338*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335)*(tmp_qloop_247 + tmp_qloop_333*0.5 + tmp_qloop_334*0.5 + tmp_qloop_335*0.5)*2.0));
                   const real_t q_tmp_20_20 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_339 + tmp_qloop_340 + tmp_qloop_341 + tmp_qloop_342)*(tmp_qloop_339*0.66666666666666663 + tmp_qloop_340*0.66666666666666663 + tmp_qloop_341*0.66666666666666663 + tmp_qloop_343) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_339*1.0 + tmp_qloop_340*1.0 + tmp_qloop_341*1.0)*(tmp_qloop_339*2.0 + tmp_qloop_340*2.0 + tmp_qloop_341*2.0) + (tmp_qloop_144 + tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349)*(tmp_qloop_146 + tmp_qloop_347*0.5 + tmp_qloop_348*0.5 + tmp_qloop_349*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_344 + tmp_qloop_345 + tmp_qloop_346)*(tmp_qloop_256 + tmp_qloop_344*0.5 + tmp_qloop_345*0.5 + tmp_qloop_346*0.5)*2.0));
                   const real_t q_tmp_21_21 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353)*(tmp_qloop_343 + tmp_qloop_351*0.66666666666666663 + tmp_qloop_352*0.66666666666666663 + tmp_qloop_353*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_351*1.0 + tmp_qloop_352*1.0 + tmp_qloop_353*1.0)*(tmp_qloop_351*2.0 + tmp_qloop_352*2.0 + tmp_qloop_353*2.0) + (tmp_qloop_144 + tmp_qloop_357 + tmp_qloop_358 + tmp_qloop_359)*(tmp_qloop_146 + tmp_qloop_357*0.5 + tmp_qloop_358*0.5 + tmp_qloop_359*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_354 + tmp_qloop_355 + tmp_qloop_356)*(tmp_qloop_256 + tmp_qloop_354*0.5 + tmp_qloop_355*0.5 + tmp_qloop_356*0.5)*2.0));
                   const real_t q_tmp_22_22 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_360 + tmp_qloop_361 + tmp_qloop_362)*(tmp_qloop_343 + tmp_qloop_360*0.66666666666666663 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_360*1.0 + tmp_qloop_361*1.0 + tmp_qloop_362*1.0)*(tmp_qloop_360*2.0 + tmp_qloop_361*2.0 + tmp_qloop_362*2.0) + (tmp_qloop_144 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_368)*(tmp_qloop_146 + tmp_qloop_366*0.5 + tmp_qloop_367*0.5 + tmp_qloop_368*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_363 + tmp_qloop_364 + tmp_qloop_365)*(tmp_qloop_256 + tmp_qloop_363*0.5 + tmp_qloop_364*0.5 + tmp_qloop_365*0.5)*2.0));
                   const real_t q_tmp_23_23 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_369 + tmp_qloop_370 + tmp_qloop_371)*(tmp_qloop_343 + tmp_qloop_369*0.66666666666666663 + tmp_qloop_370*0.66666666666666663 + tmp_qloop_371*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_369*1.0 + tmp_qloop_370*1.0 + tmp_qloop_371*1.0)*(tmp_qloop_369*2.0 + tmp_qloop_370*2.0 + tmp_qloop_371*2.0) + (tmp_qloop_144 + tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377)*(tmp_qloop_146 + tmp_qloop_375*0.5 + tmp_qloop_376*0.5 + tmp_qloop_377*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_372 + tmp_qloop_373 + tmp_qloop_374)*(tmp_qloop_256 + tmp_qloop_372*0.5 + tmp_qloop_373*0.5 + tmp_qloop_374*0.5)*2.0));
                   const real_t q_tmp_24_24 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_378 + tmp_qloop_379 + tmp_qloop_380)*(tmp_qloop_343 + tmp_qloop_378*0.66666666666666663 + tmp_qloop_379*0.66666666666666663 + tmp_qloop_380*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_378*1.0 + tmp_qloop_379*1.0 + tmp_qloop_380*1.0)*(tmp_qloop_378*2.0 + tmp_qloop_379*2.0 + tmp_qloop_380*2.0) + (tmp_qloop_144 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386)*(tmp_qloop_146 + tmp_qloop_384*0.5 + tmp_qloop_385*0.5 + tmp_qloop_386*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_381 + tmp_qloop_382 + tmp_qloop_383)*(tmp_qloop_256 + tmp_qloop_381*0.5 + tmp_qloop_382*0.5 + tmp_qloop_383*0.5)*2.0));
                   const real_t q_tmp_25_25 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_387 + tmp_qloop_388 + tmp_qloop_389)*(tmp_qloop_343 + tmp_qloop_387*0.66666666666666663 + tmp_qloop_388*0.66666666666666663 + tmp_qloop_389*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_387*1.0 + tmp_qloop_388*1.0 + tmp_qloop_389*1.0)*(tmp_qloop_387*2.0 + tmp_qloop_388*2.0 + tmp_qloop_389*2.0) + (tmp_qloop_144 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395)*(tmp_qloop_146 + tmp_qloop_393*0.5 + tmp_qloop_394*0.5 + tmp_qloop_395*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_392)*(tmp_qloop_256 + tmp_qloop_390*0.5 + tmp_qloop_391*0.5 + tmp_qloop_392*0.5)*2.0));
                   const real_t q_tmp_26_26 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_396 + tmp_qloop_397 + tmp_qloop_398)*(tmp_qloop_343 + tmp_qloop_396*0.66666666666666663 + tmp_qloop_397*0.66666666666666663 + tmp_qloop_398*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_396*1.0 + tmp_qloop_397*1.0 + tmp_qloop_398*1.0)*(tmp_qloop_396*2.0 + tmp_qloop_397*2.0 + tmp_qloop_398*2.0) + (tmp_qloop_144 + tmp_qloop_402 + tmp_qloop_403 + tmp_qloop_404)*(tmp_qloop_146 + tmp_qloop_402*0.5 + tmp_qloop_403*0.5 + tmp_qloop_404*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_399 + tmp_qloop_400 + tmp_qloop_401)*(tmp_qloop_256 + tmp_qloop_399*0.5 + tmp_qloop_400*0.5 + tmp_qloop_401*0.5)*2.0));
                   const real_t q_tmp_27_27 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_405 + tmp_qloop_406 + tmp_qloop_407)*(tmp_qloop_343 + tmp_qloop_405*0.66666666666666663 + tmp_qloop_406*0.66666666666666663 + tmp_qloop_407*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_405*1.0 + tmp_qloop_406*1.0 + tmp_qloop_407*1.0)*(tmp_qloop_405*2.0 + tmp_qloop_406*2.0 + tmp_qloop_407*2.0) + (tmp_qloop_144 + tmp_qloop_411 + tmp_qloop_412 + tmp_qloop_413)*(tmp_qloop_146 + tmp_qloop_411*0.5 + tmp_qloop_412*0.5 + tmp_qloop_413*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_410)*(tmp_qloop_256 + tmp_qloop_408*0.5 + tmp_qloop_409*0.5 + tmp_qloop_410*0.5)*2.0));
                   const real_t q_tmp_28_28 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_414 + tmp_qloop_415 + tmp_qloop_416)*(tmp_qloop_343 + tmp_qloop_414*0.66666666666666663 + tmp_qloop_415*0.66666666666666663 + tmp_qloop_416*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_414*1.0 + tmp_qloop_415*1.0 + tmp_qloop_416*1.0)*(tmp_qloop_414*2.0 + tmp_qloop_415*2.0 + tmp_qloop_416*2.0) + (tmp_qloop_144 + tmp_qloop_420 + tmp_qloop_421 + tmp_qloop_422)*(tmp_qloop_146 + tmp_qloop_420*0.5 + tmp_qloop_421*0.5 + tmp_qloop_422*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419)*(tmp_qloop_256 + tmp_qloop_417*0.5 + tmp_qloop_418*0.5 + tmp_qloop_419*0.5)*2.0));
                   const real_t q_tmp_29_29 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_423 + tmp_qloop_424 + tmp_qloop_425)*(tmp_qloop_343 + tmp_qloop_423*0.66666666666666663 + tmp_qloop_424*0.66666666666666663 + tmp_qloop_425*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_423*1.0 + tmp_qloop_424*1.0 + tmp_qloop_425*1.0)*(tmp_qloop_423*2.0 + tmp_qloop_424*2.0 + tmp_qloop_425*2.0) + (tmp_qloop_144 + tmp_qloop_429 + tmp_qloop_430 + tmp_qloop_431)*(tmp_qloop_146 + tmp_qloop_429*0.5 + tmp_qloop_430*0.5 + tmp_qloop_431*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428)*(tmp_qloop_256 + tmp_qloop_426*0.5 + tmp_qloop_427*0.5 + tmp_qloop_428*0.5)*2.0));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                const real_t elMatDiag_4 = q_acc_4_4;
                const real_t elMatDiag_5 = q_acc_5_5;
                const real_t elMatDiag_6 = q_acc_6_6;
                const real_t elMatDiag_7 = q_acc_7_7;
                const real_t elMatDiag_8 = q_acc_8_8;
                const real_t elMatDiag_9 = q_acc_9_9;
                const real_t elMatDiag_10 = q_acc_10_10;
                const real_t elMatDiag_11 = q_acc_11_11;
                const real_t elMatDiag_12 = q_acc_12_12;
                const real_t elMatDiag_13 = q_acc_13_13;
                const real_t elMatDiag_14 = q_acc_14_14;
                const real_t elMatDiag_15 = q_acc_15_15;
                const real_t elMatDiag_16 = q_acc_16_16;
                const real_t elMatDiag_17 = q_acc_17_17;
                const real_t elMatDiag_18 = q_acc_18_18;
                const real_t elMatDiag_19 = q_acc_19_19;
                const real_t elMatDiag_20 = q_acc_20_20;
                const real_t elMatDiag_21 = q_acc_21_21;
                const real_t elMatDiag_22 = q_acc_22_22;
                const real_t elMatDiag_23 = q_acc_23_23;
                const real_t elMatDiag_24 = q_acc_24_24;
                const real_t elMatDiag_25 = q_acc_25_25;
                const real_t elMatDiag_26 = q_acc_26_26;
                const real_t elMatDiag_27 = q_acc_27_27;
                const real_t elMatDiag_28 = q_acc_28_28;
                const real_t elMatDiag_29 = q_acc_29_29;
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_8 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_10 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_11 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_12 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_13 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_14 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_15 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_16 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_17 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_18 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_19 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_20 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_21 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_22 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_23 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_24 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_25 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_26 + _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_27 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_28 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_29 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(abs_det_jac_affine_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(abs_det_jac_affine_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(abs_det_jac_affine_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_212 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_221 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_297 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_354 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q]));
                   const __m256d tmp_qloop_137 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_230 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_243 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_303 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_312 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_402 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_411 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_420 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_429 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q]));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_173 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_182 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_191 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_200 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_252 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_264 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_273 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_282 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_291 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_318 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_327 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_336 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_360 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_369 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_378 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_387 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_396 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_186 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_195 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_204 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_213 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_234 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_280 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_289 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_298 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_345 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_355 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_364 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_373 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_382 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_225 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_304 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_313 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_322 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_331 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_430 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_128 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_265 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_340 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_388 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_397 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_406 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_415 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_424 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_122,tmp_qloop_123),tmp_qloop_124);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_169 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_178 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_187 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_236 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_233,tmp_qloop_234),tmp_qloop_235);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_251 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_281 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_290 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_299 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_308 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_317 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_326 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_346 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_374 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_383 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_392 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_401 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_410 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_137,tmp_qloop_138),tmp_qloop_139);
                   const __m256d tmp_qloop_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_138,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_199 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_208 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_217 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_226 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_246 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_243,tmp_qloop_244),tmp_qloop_245);
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_243,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_244,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_245,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_260 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_269 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_296 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_332 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_342 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_236);
                   const __m256d tmp_qloop_343 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_238);
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_246),_mm256_add_pd(tmp_qloop_126,tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_251);
                   const __m256d tmp_qloop_359 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_368 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_129 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_144 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_141,tmp_qloop_142),tmp_qloop_143);
                   const __m256d tmp_qloop_146 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_141,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_142,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_143,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_144),_mm256_add_pd(tmp_qloop_145,tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_136);
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_237 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_236);
                   const __m256d tmp_qloop_239 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_238);
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_255 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_252,tmp_qloop_253),tmp_qloop_254);
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_253,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_254,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_257 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_255),_mm256_add_pd(tmp_qloop_134,tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_136),tmp_qloop_251);
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_341 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_416 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_425 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10]));
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_119,tmp_qloop_120),tmp_qloop_121),tmp_qloop_125),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_120,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_121,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_128),tmp_qloop_129),tmp_qloop_133),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_129,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_114)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_152),tmp_qloop_153),tmp_qloop_154),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_154,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_155),tmp_qloop_156),tmp_qloop_157),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_155,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_156,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_149),tmp_qloop_150),tmp_qloop_151)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_161),tmp_qloop_162),tmp_qloop_163),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_162,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_163,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_164),tmp_qloop_165),tmp_qloop_166),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_164,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_165,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_166,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_158),tmp_qloop_159),tmp_qloop_160)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_173),tmp_qloop_174),tmp_qloop_175),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_173,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_174,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_175,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_167),tmp_qloop_168),tmp_qloop_169)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_179,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_180,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_181,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_182),tmp_qloop_183),tmp_qloop_184),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_182,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_176),tmp_qloop_177),tmp_qloop_178)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_188,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_189,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_190,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_191),tmp_qloop_192),tmp_qloop_193),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_191,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_192,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_193,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_185),tmp_qloop_186),tmp_qloop_187)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_197),tmp_qloop_198),tmp_qloop_199),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_199,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_200),tmp_qloop_201),tmp_qloop_202),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_201,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_202,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_194),tmp_qloop_195),tmp_qloop_196)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_206),tmp_qloop_207),tmp_qloop_208),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_206,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_207,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_208,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_203),tmp_qloop_204),tmp_qloop_205)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_215),tmp_qloop_216),tmp_qloop_217),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_215,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_216,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_217,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_218,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_219,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_220,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_212),tmp_qloop_213),tmp_qloop_214)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_224),tmp_qloop_225),tmp_qloop_226),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_225,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_226,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_227,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_228,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_229,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_221),tmp_qloop_222),tmp_qloop_223)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_240,tmp_qloop_241),tmp_qloop_242),tmp_qloop_246),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_240,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_241,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_242,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_230,tmp_qloop_231),tmp_qloop_232),tmp_qloop_237)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_264),tmp_qloop_265),tmp_qloop_266),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_264,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_265,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_266,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_258),tmp_qloop_259),tmp_qloop_260)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_270,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_271,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_272,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_273),tmp_qloop_274),tmp_qloop_275),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_273,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_267),tmp_qloop_268),tmp_qloop_269)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_279),tmp_qloop_280),tmp_qloop_281),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_280,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_281,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_282),tmp_qloop_283),tmp_qloop_284),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_282,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_283,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_284,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_276),tmp_qloop_277),tmp_qloop_278)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_288),tmp_qloop_289),tmp_qloop_290),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_289,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_290,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_291),tmp_qloop_292),tmp_qloop_293),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_291,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_292,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_285),tmp_qloop_286),tmp_qloop_287)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_297),tmp_qloop_298),tmp_qloop_299),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_298,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_299,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_300,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_301,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_302,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_294),tmp_qloop_295),tmp_qloop_296)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_306),tmp_qloop_307),tmp_qloop_308),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_308,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_309,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_310,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_311,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_303),tmp_qloop_304),tmp_qloop_305)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_315),tmp_qloop_316),tmp_qloop_317),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_315,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_316,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_317,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_318),tmp_qloop_319),tmp_qloop_320),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_318,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_312),tmp_qloop_313),tmp_qloop_314)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_324),tmp_qloop_325),tmp_qloop_326),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_324,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_325,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_326,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_327),tmp_qloop_328),tmp_qloop_329),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_327,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_328,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_329,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_321),tmp_qloop_322),tmp_qloop_323)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_333),tmp_qloop_334),tmp_qloop_335),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_336),tmp_qloop_337),tmp_qloop_338),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_336,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_337,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_338,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_330),tmp_qloop_331),tmp_qloop_332)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_344),tmp_qloop_345),tmp_qloop_346),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_344,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_345,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_346,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_347),tmp_qloop_348),tmp_qloop_349),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_339,tmp_qloop_340),tmp_qloop_341),tmp_qloop_342)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_354),tmp_qloop_355),tmp_qloop_356),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_355,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_356,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_357),tmp_qloop_358),tmp_qloop_359),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_357,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_358,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_359,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_363),tmp_qloop_364),tmp_qloop_365),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_364,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_365,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_366),tmp_qloop_367),tmp_qloop_368),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_366,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_367,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_368,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_360),tmp_qloop_361),tmp_qloop_362)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_372),tmp_qloop_373),tmp_qloop_374),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_372,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_373,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_374,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_375),tmp_qloop_376),tmp_qloop_377),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_369),tmp_qloop_370),tmp_qloop_371)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_381),tmp_qloop_382),tmp_qloop_383),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_381,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_382,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_383,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_384,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_385,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_386,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_378),tmp_qloop_379),tmp_qloop_380)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_390),tmp_qloop_391),tmp_qloop_392),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_392,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_393,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_394,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_395,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_387),tmp_qloop_388),tmp_qloop_389)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_399),tmp_qloop_400),tmp_qloop_401),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_399,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_400,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_401,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_402),tmp_qloop_403),tmp_qloop_404),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_402,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_396),tmp_qloop_397),tmp_qloop_398)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_408),tmp_qloop_409),tmp_qloop_410),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_408,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_409,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_410,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_411),tmp_qloop_412),tmp_qloop_413),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_411,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_412,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_413,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_405),tmp_qloop_406),tmp_qloop_407)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_417),tmp_qloop_418),tmp_qloop_419),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_420),tmp_qloop_421),tmp_qloop_422),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_420,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_421,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_422,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_414),tmp_qloop_415),tmp_qloop_416)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_426,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_427,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_428,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_429),tmp_qloop_430),tmp_qloop_431),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_429,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_430,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_423),tmp_qloop_424),tmp_qloop_425)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                const __m256d elMatDiag_4 = q_acc_4_4;
                const __m256d elMatDiag_5 = q_acc_5_5;
                const __m256d elMatDiag_6 = q_acc_6_6;
                const __m256d elMatDiag_7 = q_acc_7_7;
                const __m256d elMatDiag_8 = q_acc_8_8;
                const __m256d elMatDiag_9 = q_acc_9_9;
                const __m256d elMatDiag_10 = q_acc_10_10;
                const __m256d elMatDiag_11 = q_acc_11_11;
                const __m256d elMatDiag_12 = q_acc_12_12;
                const __m256d elMatDiag_13 = q_acc_13_13;
                const __m256d elMatDiag_14 = q_acc_14_14;
                const __m256d elMatDiag_15 = q_acc_15_15;
                const __m256d elMatDiag_16 = q_acc_16_16;
                const __m256d elMatDiag_17 = q_acc_17_17;
                const __m256d elMatDiag_18 = q_acc_18_18;
                const __m256d elMatDiag_19 = q_acc_19_19;
                const __m256d elMatDiag_20 = q_acc_20_20;
                const __m256d elMatDiag_21 = q_acc_21_21;
                const __m256d elMatDiag_22 = q_acc_22_22;
                const __m256d elMatDiag_23 = q_acc_23_23;
                const __m256d elMatDiag_24 = q_acc_24_24;
                const __m256d elMatDiag_25 = q_acc_25_25;
                const __m256d elMatDiag_26 = q_acc_26_26;
                const __m256d elMatDiag_27 = q_acc_27_27;
                const __m256d elMatDiag_28 = q_acc_28_28;
                const __m256d elMatDiag_29 = q_acc_29_29;
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_10,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_11,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_12,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_13,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_14,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_15,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_16,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_17,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_18,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_19,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_20,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_21,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_22,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_23,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_24,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_25,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_26,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_27,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_28,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_29,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_148 = (mu_dof_0*_data_phi_0_0_BLUE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_BLUE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_DOWN[10*q + 9])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2];
                   const real_t tmp_qloop_158 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3];
                   const real_t tmp_qloop_167 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4];
                   const real_t tmp_qloop_176 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5];
                   const real_t tmp_qloop_185 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6];
                   const real_t tmp_qloop_194 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7];
                   const real_t tmp_qloop_203 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8];
                   const real_t tmp_qloop_212 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9];
                   const real_t tmp_qloop_221 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10];
                   const real_t tmp_qloop_233 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_279 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_288 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_297 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_306 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_315 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_324 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_344 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_354 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_363 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_372 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_381 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_390 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_399 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_408 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_119 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q];
                   const real_t tmp_qloop_137 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_152 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2];
                   const real_t tmp_qloop_161 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6];
                   const real_t tmp_qloop_197 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7];
                   const real_t tmp_qloop_206 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8];
                   const real_t tmp_qloop_215 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9];
                   const real_t tmp_qloop_224 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10];
                   const real_t tmp_qloop_230 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_243 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11];
                   const real_t tmp_qloop_258 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_267 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_276 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_285 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_294 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_303 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_312 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_321 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_330 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_357 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_366 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_402 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_411 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_420 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_429 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_127 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q];
                   const real_t tmp_qloop_141 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_155 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2];
                   const real_t tmp_qloop_164 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3];
                   const real_t tmp_qloop_173 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4];
                   const real_t tmp_qloop_182 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5];
                   const real_t tmp_qloop_191 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6];
                   const real_t tmp_qloop_200 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_252 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11];
                   const real_t tmp_qloop_264 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_273 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_282 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_291 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_318 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_327 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_336 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_339 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_360 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_369 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_378 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_387 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_396 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_405 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_414 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_123 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_150 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_159 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_168 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_177 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_186 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_195 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_204 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_213 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_222 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_234 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_280 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_289 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_298 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_307 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_316 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_325 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_345 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_355 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_364 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_373 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_382 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_391 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_400 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_409 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_120 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_138 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_153 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_162 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_198 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_207 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_216 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_225 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_231 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_244 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_259 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_268 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_277 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_286 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_295 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_304 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_313 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_322 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_331 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_358 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_367 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_403 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_412 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_421 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_430 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_128 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_142 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_156 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_165 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_174 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_192 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_201 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_253 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_265 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_274 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_283 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_292 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_319 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_328 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_337 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_340 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_361 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_370 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_379 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_388 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_397 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_406 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_415 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_424 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_125 = tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_124;
                   const real_t tmp_qloop_126 = tmp_qloop_122*0.5 + tmp_qloop_123*0.5 + tmp_qloop_124*0.5;
                   const real_t tmp_qloop_132 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_133 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132;
                   const real_t tmp_qloop_134 = tmp_qloop_130*0.5 + tmp_qloop_131*0.5 + tmp_qloop_132*0.5;
                   const real_t tmp_qloop_151 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_160 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_169 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_178 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_187 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_196 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_205 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_214 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_223 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_235 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_236 = tmp_qloop_233 + tmp_qloop_234 + tmp_qloop_235;
                   const real_t tmp_qloop_238 = tmp_qloop_233*0.66666666666666663 + tmp_qloop_234*0.66666666666666663 + tmp_qloop_235*0.66666666666666663;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_251 = (tmp_qloop_233*1.0 + tmp_qloop_234*1.0 + tmp_qloop_235*1.0)*(tmp_qloop_233*2.0 + tmp_qloop_234*2.0 + tmp_qloop_235*2.0);
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_272 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_281 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_290 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_299 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_308 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_317 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_326 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_335 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_346 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_356 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_365 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_374 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_383 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_392 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_401 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_410 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_419 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_428 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_116 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_121 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_135 = (tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0)*(tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0);
                   const real_t tmp_qloop_139 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_140 = tmp_qloop_137 + tmp_qloop_138 + tmp_qloop_139;
                   const real_t tmp_qloop_145 = tmp_qloop_137*0.5 + tmp_qloop_138*0.5 + tmp_qloop_139*0.5;
                   const real_t tmp_qloop_154 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_163 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_172 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_181 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_199 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_208 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_217 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_226 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_232 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_245 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_246 = tmp_qloop_243 + tmp_qloop_244 + tmp_qloop_245;
                   const real_t tmp_qloop_247 = tmp_qloop_243*0.5 + tmp_qloop_244*0.5 + tmp_qloop_245*0.5;
                   const real_t tmp_qloop_260 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_269 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_278 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_287 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_296 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_305 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_314 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_323 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_332 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_342 = tmp_qloop_113 + tmp_qloop_236;
                   const real_t tmp_qloop_343 = tmp_qloop_116 + tmp_qloop_238;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_350 = tmp_qloop_135 + tmp_qloop_251 + (tmp_qloop_125 + tmp_qloop_246)*(tmp_qloop_126 + tmp_qloop_247)*2.0;
                   const real_t tmp_qloop_359 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_368 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_386 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_404 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_413 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_422 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_431 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_129 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_136 = (tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_143 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_144 = tmp_qloop_141 + tmp_qloop_142 + tmp_qloop_143;
                   const real_t tmp_qloop_146 = tmp_qloop_141*0.5 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5;
                   const real_t tmp_qloop_147 = tmp_qloop_135 + tmp_qloop_136 + (tmp_qloop_140 + tmp_qloop_144)*(tmp_qloop_145 + tmp_qloop_146)*2.0;
                   const real_t tmp_qloop_157 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_166 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_184 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_193 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_202 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_211 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_229 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_237 = tmp_qloop_109 + tmp_qloop_236;
                   const real_t tmp_qloop_239 = tmp_qloop_115 + tmp_qloop_238;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_254 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_255 = tmp_qloop_252 + tmp_qloop_253 + tmp_qloop_254;
                   const real_t tmp_qloop_256 = tmp_qloop_252*0.5 + tmp_qloop_253*0.5 + tmp_qloop_254*0.5;
                   const real_t tmp_qloop_257 = tmp_qloop_136 + tmp_qloop_251 + (tmp_qloop_133 + tmp_qloop_255)*(tmp_qloop_134 + tmp_qloop_256)*2.0;
                   const real_t tmp_qloop_266 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_275 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_284 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_293 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_311 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_320 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_329 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_338 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_341 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_362 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_371 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_380 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_389 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_398 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_407 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_416 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_425 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10];
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_114)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_117) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_119 + tmp_qloop_120 + tmp_qloop_121 + tmp_qloop_125)*(tmp_qloop_119*0.5 + tmp_qloop_120*0.5 + tmp_qloop_121*0.5 + tmp_qloop_126)*2.0 + (tmp_qloop_127 + tmp_qloop_128 + tmp_qloop_129 + tmp_qloop_133)*(tmp_qloop_127*0.5 + tmp_qloop_128*0.5 + tmp_qloop_129*0.5 + tmp_qloop_134)*2.0));
                   const real_t q_tmp_1_1 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_149 + tmp_qloop_150 + tmp_qloop_151)*(tmp_qloop_117 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663 + tmp_qloop_151*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_149*1.0 + tmp_qloop_150*1.0 + tmp_qloop_151*1.0)*(tmp_qloop_149*2.0 + tmp_qloop_150*2.0 + tmp_qloop_151*2.0) + (tmp_qloop_125 + tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_154)*(tmp_qloop_126 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5 + tmp_qloop_154*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_155 + tmp_qloop_156 + tmp_qloop_157)*(tmp_qloop_134 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5 + tmp_qloop_157*0.5)*2.0));
                   const real_t q_tmp_2_2 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_158 + tmp_qloop_159 + tmp_qloop_160)*(tmp_qloop_117 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663 + tmp_qloop_160*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_158*1.0 + tmp_qloop_159*1.0 + tmp_qloop_160*1.0)*(tmp_qloop_158*2.0 + tmp_qloop_159*2.0 + tmp_qloop_160*2.0) + (tmp_qloop_125 + tmp_qloop_161 + tmp_qloop_162 + tmp_qloop_163)*(tmp_qloop_126 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5 + tmp_qloop_163*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_164 + tmp_qloop_165 + tmp_qloop_166)*(tmp_qloop_134 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5 + tmp_qloop_166*0.5)*2.0));
                   const real_t q_tmp_3_3 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_167 + tmp_qloop_168 + tmp_qloop_169)*(tmp_qloop_117 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663 + tmp_qloop_169*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_167*1.0 + tmp_qloop_168*1.0 + tmp_qloop_169*1.0)*(tmp_qloop_167*2.0 + tmp_qloop_168*2.0 + tmp_qloop_169*2.0) + (tmp_qloop_125 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172)*(tmp_qloop_126 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5 + tmp_qloop_172*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_173 + tmp_qloop_174 + tmp_qloop_175)*(tmp_qloop_134 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5 + tmp_qloop_175*0.5)*2.0));
                   const real_t q_tmp_4_4 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_176 + tmp_qloop_177 + tmp_qloop_178)*(tmp_qloop_117 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663 + tmp_qloop_178*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_176*1.0 + tmp_qloop_177*1.0 + tmp_qloop_178*1.0)*(tmp_qloop_176*2.0 + tmp_qloop_177*2.0 + tmp_qloop_178*2.0) + (tmp_qloop_125 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181)*(tmp_qloop_126 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5 + tmp_qloop_181*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_182 + tmp_qloop_183 + tmp_qloop_184)*(tmp_qloop_134 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5 + tmp_qloop_184*0.5)*2.0));
                   const real_t q_tmp_5_5 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187)*(tmp_qloop_117 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663 + tmp_qloop_187*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_185*1.0 + tmp_qloop_186*1.0 + tmp_qloop_187*1.0)*(tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0) + (tmp_qloop_125 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190)*(tmp_qloop_126 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5 + tmp_qloop_190*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_191 + tmp_qloop_192 + tmp_qloop_193)*(tmp_qloop_134 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5 + tmp_qloop_193*0.5)*2.0));
                   const real_t q_tmp_6_6 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_194 + tmp_qloop_195 + tmp_qloop_196)*(tmp_qloop_117 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663 + tmp_qloop_196*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_194*1.0 + tmp_qloop_195*1.0 + tmp_qloop_196*1.0)*(tmp_qloop_194*2.0 + tmp_qloop_195*2.0 + tmp_qloop_196*2.0) + (tmp_qloop_125 + tmp_qloop_197 + tmp_qloop_198 + tmp_qloop_199)*(tmp_qloop_126 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5 + tmp_qloop_199*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_200 + tmp_qloop_201 + tmp_qloop_202)*(tmp_qloop_134 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5 + tmp_qloop_202*0.5)*2.0));
                   const real_t q_tmp_7_7 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_203 + tmp_qloop_204 + tmp_qloop_205)*(tmp_qloop_117 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663 + tmp_qloop_205*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_203*1.0 + tmp_qloop_204*1.0 + tmp_qloop_205*1.0)*(tmp_qloop_203*2.0 + tmp_qloop_204*2.0 + tmp_qloop_205*2.0) + (tmp_qloop_125 + tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208)*(tmp_qloop_126 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5 + tmp_qloop_208*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211)*(tmp_qloop_134 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5 + tmp_qloop_211*0.5)*2.0));
                   const real_t q_tmp_8_8 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_212 + tmp_qloop_213 + tmp_qloop_214)*(tmp_qloop_117 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663 + tmp_qloop_214*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_212*1.0 + tmp_qloop_213*1.0 + tmp_qloop_214*1.0)*(tmp_qloop_212*2.0 + tmp_qloop_213*2.0 + tmp_qloop_214*2.0) + (tmp_qloop_125 + tmp_qloop_215 + tmp_qloop_216 + tmp_qloop_217)*(tmp_qloop_126 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5 + tmp_qloop_217*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220)*(tmp_qloop_134 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5 + tmp_qloop_220*0.5)*2.0));
                   const real_t q_tmp_9_9 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_221 + tmp_qloop_222 + tmp_qloop_223)*(tmp_qloop_117 + tmp_qloop_221*0.66666666666666663 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_221*1.0 + tmp_qloop_222*1.0 + tmp_qloop_223*1.0)*(tmp_qloop_221*2.0 + tmp_qloop_222*2.0 + tmp_qloop_223*2.0) + (tmp_qloop_125 + tmp_qloop_224 + tmp_qloop_225 + tmp_qloop_226)*(tmp_qloop_126 + tmp_qloop_224*0.5 + tmp_qloop_225*0.5 + tmp_qloop_226*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229)*(tmp_qloop_134 + tmp_qloop_227*0.5 + tmp_qloop_228*0.5 + tmp_qloop_229*0.5)*2.0));
                   const real_t q_tmp_10_10 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_230 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_237)*(tmp_qloop_230*0.66666666666666663 + tmp_qloop_231*0.66666666666666663 + tmp_qloop_232*0.66666666666666663 + tmp_qloop_239) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_230*1.0 + tmp_qloop_231*1.0 + tmp_qloop_232*1.0)*(tmp_qloop_230*2.0 + tmp_qloop_231*2.0 + tmp_qloop_232*2.0) + (tmp_qloop_140 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250)*(tmp_qloop_145 + tmp_qloop_248*0.5 + tmp_qloop_249*0.5 + tmp_qloop_250*0.5)*2.0 + (tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242 + tmp_qloop_246)*(tmp_qloop_240*0.5 + tmp_qloop_241*0.5 + tmp_qloop_242*0.5 + tmp_qloop_247)*2.0));
                   const real_t q_tmp_11_11 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_258 + tmp_qloop_259 + tmp_qloop_260)*(tmp_qloop_239 + tmp_qloop_258*0.66666666666666663 + tmp_qloop_259*0.66666666666666663 + tmp_qloop_260*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_258*1.0 + tmp_qloop_259*1.0 + tmp_qloop_260*1.0)*(tmp_qloop_258*2.0 + tmp_qloop_259*2.0 + tmp_qloop_260*2.0) + (tmp_qloop_140 + tmp_qloop_264 + tmp_qloop_265 + tmp_qloop_266)*(tmp_qloop_145 + tmp_qloop_264*0.5 + tmp_qloop_265*0.5 + tmp_qloop_266*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263)*(tmp_qloop_247 + tmp_qloop_261*0.5 + tmp_qloop_262*0.5 + tmp_qloop_263*0.5)*2.0));
                   const real_t q_tmp_12_12 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_267 + tmp_qloop_268 + tmp_qloop_269)*(tmp_qloop_239 + tmp_qloop_267*0.66666666666666663 + tmp_qloop_268*0.66666666666666663 + tmp_qloop_269*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_267*1.0 + tmp_qloop_268*1.0 + tmp_qloop_269*1.0)*(tmp_qloop_267*2.0 + tmp_qloop_268*2.0 + tmp_qloop_269*2.0) + (tmp_qloop_140 + tmp_qloop_273 + tmp_qloop_274 + tmp_qloop_275)*(tmp_qloop_145 + tmp_qloop_273*0.5 + tmp_qloop_274*0.5 + tmp_qloop_275*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272)*(tmp_qloop_247 + tmp_qloop_270*0.5 + tmp_qloop_271*0.5 + tmp_qloop_272*0.5)*2.0));
                   const real_t q_tmp_13_13 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_276 + tmp_qloop_277 + tmp_qloop_278)*(tmp_qloop_239 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0)*(tmp_qloop_276*2.0 + tmp_qloop_277*2.0 + tmp_qloop_278*2.0) + (tmp_qloop_140 + tmp_qloop_282 + tmp_qloop_283 + tmp_qloop_284)*(tmp_qloop_145 + tmp_qloop_282*0.5 + tmp_qloop_283*0.5 + tmp_qloop_284*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_279 + tmp_qloop_280 + tmp_qloop_281)*(tmp_qloop_247 + tmp_qloop_279*0.5 + tmp_qloop_280*0.5 + tmp_qloop_281*0.5)*2.0));
                   const real_t q_tmp_14_14 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_285 + tmp_qloop_286 + tmp_qloop_287)*(tmp_qloop_239 + tmp_qloop_285*0.66666666666666663 + tmp_qloop_286*0.66666666666666663 + tmp_qloop_287*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_285*1.0 + tmp_qloop_286*1.0 + tmp_qloop_287*1.0)*(tmp_qloop_285*2.0 + tmp_qloop_286*2.0 + tmp_qloop_287*2.0) + (tmp_qloop_140 + tmp_qloop_291 + tmp_qloop_292 + tmp_qloop_293)*(tmp_qloop_145 + tmp_qloop_291*0.5 + tmp_qloop_292*0.5 + tmp_qloop_293*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_288 + tmp_qloop_289 + tmp_qloop_290)*(tmp_qloop_247 + tmp_qloop_288*0.5 + tmp_qloop_289*0.5 + tmp_qloop_290*0.5)*2.0));
                   const real_t q_tmp_15_15 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_294 + tmp_qloop_295 + tmp_qloop_296)*(tmp_qloop_239 + tmp_qloop_294*0.66666666666666663 + tmp_qloop_295*0.66666666666666663 + tmp_qloop_296*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_294*1.0 + tmp_qloop_295*1.0 + tmp_qloop_296*1.0)*(tmp_qloop_294*2.0 + tmp_qloop_295*2.0 + tmp_qloop_296*2.0) + (tmp_qloop_140 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302)*(tmp_qloop_145 + tmp_qloop_300*0.5 + tmp_qloop_301*0.5 + tmp_qloop_302*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_297 + tmp_qloop_298 + tmp_qloop_299)*(tmp_qloop_247 + tmp_qloop_297*0.5 + tmp_qloop_298*0.5 + tmp_qloop_299*0.5)*2.0));
                   const real_t q_tmp_16_16 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_303 + tmp_qloop_304 + tmp_qloop_305)*(tmp_qloop_239 + tmp_qloop_303*0.66666666666666663 + tmp_qloop_304*0.66666666666666663 + tmp_qloop_305*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_303*1.0 + tmp_qloop_304*1.0 + tmp_qloop_305*1.0)*(tmp_qloop_303*2.0 + tmp_qloop_304*2.0 + tmp_qloop_305*2.0) + (tmp_qloop_140 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311)*(tmp_qloop_145 + tmp_qloop_309*0.5 + tmp_qloop_310*0.5 + tmp_qloop_311*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_308)*(tmp_qloop_247 + tmp_qloop_306*0.5 + tmp_qloop_307*0.5 + tmp_qloop_308*0.5)*2.0));
                   const real_t q_tmp_17_17 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_312 + tmp_qloop_313 + tmp_qloop_314)*(tmp_qloop_239 + tmp_qloop_312*0.66666666666666663 + tmp_qloop_313*0.66666666666666663 + tmp_qloop_314*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_312*1.0 + tmp_qloop_313*1.0 + tmp_qloop_314*1.0)*(tmp_qloop_312*2.0 + tmp_qloop_313*2.0 + tmp_qloop_314*2.0) + (tmp_qloop_140 + tmp_qloop_318 + tmp_qloop_319 + tmp_qloop_320)*(tmp_qloop_145 + tmp_qloop_318*0.5 + tmp_qloop_319*0.5 + tmp_qloop_320*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_315 + tmp_qloop_316 + tmp_qloop_317)*(tmp_qloop_247 + tmp_qloop_315*0.5 + tmp_qloop_316*0.5 + tmp_qloop_317*0.5)*2.0));
                   const real_t q_tmp_18_18 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_321 + tmp_qloop_322 + tmp_qloop_323)*(tmp_qloop_239 + tmp_qloop_321*0.66666666666666663 + tmp_qloop_322*0.66666666666666663 + tmp_qloop_323*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_321*1.0 + tmp_qloop_322*1.0 + tmp_qloop_323*1.0)*(tmp_qloop_321*2.0 + tmp_qloop_322*2.0 + tmp_qloop_323*2.0) + (tmp_qloop_140 + tmp_qloop_327 + tmp_qloop_328 + tmp_qloop_329)*(tmp_qloop_145 + tmp_qloop_327*0.5 + tmp_qloop_328*0.5 + tmp_qloop_329*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_326)*(tmp_qloop_247 + tmp_qloop_324*0.5 + tmp_qloop_325*0.5 + tmp_qloop_326*0.5)*2.0));
                   const real_t q_tmp_19_19 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_330 + tmp_qloop_331 + tmp_qloop_332)*(tmp_qloop_239 + tmp_qloop_330*0.66666666666666663 + tmp_qloop_331*0.66666666666666663 + tmp_qloop_332*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_330*1.0 + tmp_qloop_331*1.0 + tmp_qloop_332*1.0)*(tmp_qloop_330*2.0 + tmp_qloop_331*2.0 + tmp_qloop_332*2.0) + (tmp_qloop_140 + tmp_qloop_336 + tmp_qloop_337 + tmp_qloop_338)*(tmp_qloop_145 + tmp_qloop_336*0.5 + tmp_qloop_337*0.5 + tmp_qloop_338*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335)*(tmp_qloop_247 + tmp_qloop_333*0.5 + tmp_qloop_334*0.5 + tmp_qloop_335*0.5)*2.0));
                   const real_t q_tmp_20_20 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_339 + tmp_qloop_340 + tmp_qloop_341 + tmp_qloop_342)*(tmp_qloop_339*0.66666666666666663 + tmp_qloop_340*0.66666666666666663 + tmp_qloop_341*0.66666666666666663 + tmp_qloop_343) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_339*1.0 + tmp_qloop_340*1.0 + tmp_qloop_341*1.0)*(tmp_qloop_339*2.0 + tmp_qloop_340*2.0 + tmp_qloop_341*2.0) + (tmp_qloop_144 + tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349)*(tmp_qloop_146 + tmp_qloop_347*0.5 + tmp_qloop_348*0.5 + tmp_qloop_349*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_344 + tmp_qloop_345 + tmp_qloop_346)*(tmp_qloop_256 + tmp_qloop_344*0.5 + tmp_qloop_345*0.5 + tmp_qloop_346*0.5)*2.0));
                   const real_t q_tmp_21_21 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353)*(tmp_qloop_343 + tmp_qloop_351*0.66666666666666663 + tmp_qloop_352*0.66666666666666663 + tmp_qloop_353*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_351*1.0 + tmp_qloop_352*1.0 + tmp_qloop_353*1.0)*(tmp_qloop_351*2.0 + tmp_qloop_352*2.0 + tmp_qloop_353*2.0) + (tmp_qloop_144 + tmp_qloop_357 + tmp_qloop_358 + tmp_qloop_359)*(tmp_qloop_146 + tmp_qloop_357*0.5 + tmp_qloop_358*0.5 + tmp_qloop_359*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_354 + tmp_qloop_355 + tmp_qloop_356)*(tmp_qloop_256 + tmp_qloop_354*0.5 + tmp_qloop_355*0.5 + tmp_qloop_356*0.5)*2.0));
                   const real_t q_tmp_22_22 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_360 + tmp_qloop_361 + tmp_qloop_362)*(tmp_qloop_343 + tmp_qloop_360*0.66666666666666663 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_360*1.0 + tmp_qloop_361*1.0 + tmp_qloop_362*1.0)*(tmp_qloop_360*2.0 + tmp_qloop_361*2.0 + tmp_qloop_362*2.0) + (tmp_qloop_144 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_368)*(tmp_qloop_146 + tmp_qloop_366*0.5 + tmp_qloop_367*0.5 + tmp_qloop_368*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_363 + tmp_qloop_364 + tmp_qloop_365)*(tmp_qloop_256 + tmp_qloop_363*0.5 + tmp_qloop_364*0.5 + tmp_qloop_365*0.5)*2.0));
                   const real_t q_tmp_23_23 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_369 + tmp_qloop_370 + tmp_qloop_371)*(tmp_qloop_343 + tmp_qloop_369*0.66666666666666663 + tmp_qloop_370*0.66666666666666663 + tmp_qloop_371*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_369*1.0 + tmp_qloop_370*1.0 + tmp_qloop_371*1.0)*(tmp_qloop_369*2.0 + tmp_qloop_370*2.0 + tmp_qloop_371*2.0) + (tmp_qloop_144 + tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377)*(tmp_qloop_146 + tmp_qloop_375*0.5 + tmp_qloop_376*0.5 + tmp_qloop_377*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_372 + tmp_qloop_373 + tmp_qloop_374)*(tmp_qloop_256 + tmp_qloop_372*0.5 + tmp_qloop_373*0.5 + tmp_qloop_374*0.5)*2.0));
                   const real_t q_tmp_24_24 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_378 + tmp_qloop_379 + tmp_qloop_380)*(tmp_qloop_343 + tmp_qloop_378*0.66666666666666663 + tmp_qloop_379*0.66666666666666663 + tmp_qloop_380*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_378*1.0 + tmp_qloop_379*1.0 + tmp_qloop_380*1.0)*(tmp_qloop_378*2.0 + tmp_qloop_379*2.0 + tmp_qloop_380*2.0) + (tmp_qloop_144 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386)*(tmp_qloop_146 + tmp_qloop_384*0.5 + tmp_qloop_385*0.5 + tmp_qloop_386*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_381 + tmp_qloop_382 + tmp_qloop_383)*(tmp_qloop_256 + tmp_qloop_381*0.5 + tmp_qloop_382*0.5 + tmp_qloop_383*0.5)*2.0));
                   const real_t q_tmp_25_25 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_387 + tmp_qloop_388 + tmp_qloop_389)*(tmp_qloop_343 + tmp_qloop_387*0.66666666666666663 + tmp_qloop_388*0.66666666666666663 + tmp_qloop_389*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_387*1.0 + tmp_qloop_388*1.0 + tmp_qloop_389*1.0)*(tmp_qloop_387*2.0 + tmp_qloop_388*2.0 + tmp_qloop_389*2.0) + (tmp_qloop_144 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395)*(tmp_qloop_146 + tmp_qloop_393*0.5 + tmp_qloop_394*0.5 + tmp_qloop_395*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_392)*(tmp_qloop_256 + tmp_qloop_390*0.5 + tmp_qloop_391*0.5 + tmp_qloop_392*0.5)*2.0));
                   const real_t q_tmp_26_26 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_396 + tmp_qloop_397 + tmp_qloop_398)*(tmp_qloop_343 + tmp_qloop_396*0.66666666666666663 + tmp_qloop_397*0.66666666666666663 + tmp_qloop_398*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_396*1.0 + tmp_qloop_397*1.0 + tmp_qloop_398*1.0)*(tmp_qloop_396*2.0 + tmp_qloop_397*2.0 + tmp_qloop_398*2.0) + (tmp_qloop_144 + tmp_qloop_402 + tmp_qloop_403 + tmp_qloop_404)*(tmp_qloop_146 + tmp_qloop_402*0.5 + tmp_qloop_403*0.5 + tmp_qloop_404*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_399 + tmp_qloop_400 + tmp_qloop_401)*(tmp_qloop_256 + tmp_qloop_399*0.5 + tmp_qloop_400*0.5 + tmp_qloop_401*0.5)*2.0));
                   const real_t q_tmp_27_27 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_405 + tmp_qloop_406 + tmp_qloop_407)*(tmp_qloop_343 + tmp_qloop_405*0.66666666666666663 + tmp_qloop_406*0.66666666666666663 + tmp_qloop_407*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_405*1.0 + tmp_qloop_406*1.0 + tmp_qloop_407*1.0)*(tmp_qloop_405*2.0 + tmp_qloop_406*2.0 + tmp_qloop_407*2.0) + (tmp_qloop_144 + tmp_qloop_411 + tmp_qloop_412 + tmp_qloop_413)*(tmp_qloop_146 + tmp_qloop_411*0.5 + tmp_qloop_412*0.5 + tmp_qloop_413*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_410)*(tmp_qloop_256 + tmp_qloop_408*0.5 + tmp_qloop_409*0.5 + tmp_qloop_410*0.5)*2.0));
                   const real_t q_tmp_28_28 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_414 + tmp_qloop_415 + tmp_qloop_416)*(tmp_qloop_343 + tmp_qloop_414*0.66666666666666663 + tmp_qloop_415*0.66666666666666663 + tmp_qloop_416*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_414*1.0 + tmp_qloop_415*1.0 + tmp_qloop_416*1.0)*(tmp_qloop_414*2.0 + tmp_qloop_415*2.0 + tmp_qloop_416*2.0) + (tmp_qloop_144 + tmp_qloop_420 + tmp_qloop_421 + tmp_qloop_422)*(tmp_qloop_146 + tmp_qloop_420*0.5 + tmp_qloop_421*0.5 + tmp_qloop_422*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419)*(tmp_qloop_256 + tmp_qloop_417*0.5 + tmp_qloop_418*0.5 + tmp_qloop_419*0.5)*2.0));
                   const real_t q_tmp_29_29 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_423 + tmp_qloop_424 + tmp_qloop_425)*(tmp_qloop_343 + tmp_qloop_423*0.66666666666666663 + tmp_qloop_424*0.66666666666666663 + tmp_qloop_425*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_423*1.0 + tmp_qloop_424*1.0 + tmp_qloop_425*1.0)*(tmp_qloop_423*2.0 + tmp_qloop_424*2.0 + tmp_qloop_425*2.0) + (tmp_qloop_144 + tmp_qloop_429 + tmp_qloop_430 + tmp_qloop_431)*(tmp_qloop_146 + tmp_qloop_429*0.5 + tmp_qloop_430*0.5 + tmp_qloop_431*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428)*(tmp_qloop_256 + tmp_qloop_426*0.5 + tmp_qloop_427*0.5 + tmp_qloop_428*0.5)*2.0));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                const real_t elMatDiag_4 = q_acc_4_4;
                const real_t elMatDiag_5 = q_acc_5_5;
                const real_t elMatDiag_6 = q_acc_6_6;
                const real_t elMatDiag_7 = q_acc_7_7;
                const real_t elMatDiag_8 = q_acc_8_8;
                const real_t elMatDiag_9 = q_acc_9_9;
                const real_t elMatDiag_10 = q_acc_10_10;
                const real_t elMatDiag_11 = q_acc_11_11;
                const real_t elMatDiag_12 = q_acc_12_12;
                const real_t elMatDiag_13 = q_acc_13_13;
                const real_t elMatDiag_14 = q_acc_14_14;
                const real_t elMatDiag_15 = q_acc_15_15;
                const real_t elMatDiag_16 = q_acc_16_16;
                const real_t elMatDiag_17 = q_acc_17_17;
                const real_t elMatDiag_18 = q_acc_18_18;
                const real_t elMatDiag_19 = q_acc_19_19;
                const real_t elMatDiag_20 = q_acc_20_20;
                const real_t elMatDiag_21 = q_acc_21_21;
                const real_t elMatDiag_22 = q_acc_22_22;
                const real_t elMatDiag_23 = q_acc_23_23;
                const real_t elMatDiag_24 = q_acc_24_24;
                const real_t elMatDiag_25 = q_acc_25_25;
                const real_t elMatDiag_26 = q_acc_26_26;
                const real_t elMatDiag_27 = q_acc_27_27;
                const real_t elMatDiag_28 = q_acc_28_28;
                const real_t elMatDiag_29 = q_acc_29_29;
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_10 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_11 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_12 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_13 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_14 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_15 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_16 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_17 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_18 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_19 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_20 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_21 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_22 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_23 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_24 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_25 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_26 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_27 + _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_28 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_29 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_UP [] = {0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(abs_det_jac_affine_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(abs_det_jac_affine_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(abs_det_jac_affine_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5]));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6]));
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7]));
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8]));
                   const __m256d tmp_qloop_212 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9]));
                   const __m256d tmp_qloop_221 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10]));
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_297 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_354 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q]));
                   const __m256d tmp_qloop_137 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2]));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9]));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10]));
                   const __m256d tmp_qloop_230 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_243 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_303 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_312 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_402 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_411 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_420 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_429 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q]));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2]));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3]));
                   const __m256d tmp_qloop_173 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4]));
                   const __m256d tmp_qloop_182 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5]));
                   const __m256d tmp_qloop_191 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6]));
                   const __m256d tmp_qloop_200 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_252 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11]));
                   const __m256d tmp_qloop_264 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_273 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_282 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_291 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_318 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_327 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_336 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_360 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_369 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_378 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_387 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_396 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_186 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_195 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_204 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_213 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_234 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_280 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_289 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_298 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_345 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_355 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_364 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_373 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_382 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_225 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_304 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_313 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_322 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_331 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_430 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_128 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_265 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_340 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_388 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_397 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_406 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_415 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_424 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_122,tmp_qloop_123),tmp_qloop_124);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_169 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_178 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_187 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_236 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_233,tmp_qloop_234),tmp_qloop_235);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_251 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_281 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_290 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_299 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_308 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_317 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_326 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_346 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_374 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_383 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_392 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_401 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_410 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_137,tmp_qloop_138),tmp_qloop_139);
                   const __m256d tmp_qloop_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_138,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_199 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_208 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_217 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_226 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_246 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_243,tmp_qloop_244),tmp_qloop_245);
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_243,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_244,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_245,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_260 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_269 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_296 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_332 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_342 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_236);
                   const __m256d tmp_qloop_343 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_238);
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_246),_mm256_add_pd(tmp_qloop_126,tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_251);
                   const __m256d tmp_qloop_359 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_368 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_129 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_144 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_141,tmp_qloop_142),tmp_qloop_143);
                   const __m256d tmp_qloop_146 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_141,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_142,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_143,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_144),_mm256_add_pd(tmp_qloop_145,tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_136);
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_237 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_236);
                   const __m256d tmp_qloop_239 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_238);
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_255 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_252,tmp_qloop_253),tmp_qloop_254);
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_253,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_254,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_257 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_255),_mm256_add_pd(tmp_qloop_134,tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_136),tmp_qloop_251);
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_341 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_416 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_425 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10]));
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_119,tmp_qloop_120),tmp_qloop_121),tmp_qloop_125),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_120,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_121,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_128),tmp_qloop_129),tmp_qloop_133),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_129,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_114)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_152),tmp_qloop_153),tmp_qloop_154),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_154,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_155),tmp_qloop_156),tmp_qloop_157),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_155,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_156,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_149),tmp_qloop_150),tmp_qloop_151)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_161),tmp_qloop_162),tmp_qloop_163),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_162,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_163,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_164),tmp_qloop_165),tmp_qloop_166),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_164,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_165,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_166,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_158),tmp_qloop_159),tmp_qloop_160)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_173),tmp_qloop_174),tmp_qloop_175),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_173,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_174,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_175,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_167),tmp_qloop_168),tmp_qloop_169)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_179,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_180,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_181,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_182),tmp_qloop_183),tmp_qloop_184),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_182,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_176),tmp_qloop_177),tmp_qloop_178)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_188,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_189,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_190,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_191),tmp_qloop_192),tmp_qloop_193),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_191,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_192,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_193,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_185),tmp_qloop_186),tmp_qloop_187)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_197),tmp_qloop_198),tmp_qloop_199),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_199,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_200),tmp_qloop_201),tmp_qloop_202),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_201,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_202,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_194),tmp_qloop_195),tmp_qloop_196)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_206),tmp_qloop_207),tmp_qloop_208),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_206,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_207,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_208,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_203),tmp_qloop_204),tmp_qloop_205)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_215),tmp_qloop_216),tmp_qloop_217),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_215,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_216,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_217,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_218,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_219,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_220,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_212),tmp_qloop_213),tmp_qloop_214)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_224),tmp_qloop_225),tmp_qloop_226),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_225,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_226,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_227,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_228,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_229,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_221),tmp_qloop_222),tmp_qloop_223)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_240,tmp_qloop_241),tmp_qloop_242),tmp_qloop_246),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_240,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_241,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_242,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_230,tmp_qloop_231),tmp_qloop_232),tmp_qloop_237)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_264),tmp_qloop_265),tmp_qloop_266),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_264,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_265,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_266,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_258),tmp_qloop_259),tmp_qloop_260)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_270,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_271,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_272,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_273),tmp_qloop_274),tmp_qloop_275),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_273,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_267),tmp_qloop_268),tmp_qloop_269)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_279),tmp_qloop_280),tmp_qloop_281),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_280,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_281,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_282),tmp_qloop_283),tmp_qloop_284),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_282,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_283,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_284,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_276),tmp_qloop_277),tmp_qloop_278)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_288),tmp_qloop_289),tmp_qloop_290),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_289,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_290,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_291),tmp_qloop_292),tmp_qloop_293),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_291,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_292,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_285),tmp_qloop_286),tmp_qloop_287)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_297),tmp_qloop_298),tmp_qloop_299),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_298,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_299,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_300,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_301,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_302,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_294),tmp_qloop_295),tmp_qloop_296)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_306),tmp_qloop_307),tmp_qloop_308),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_308,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_309,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_310,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_311,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_303),tmp_qloop_304),tmp_qloop_305)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_315),tmp_qloop_316),tmp_qloop_317),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_315,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_316,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_317,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_318),tmp_qloop_319),tmp_qloop_320),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_318,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_312),tmp_qloop_313),tmp_qloop_314)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_324),tmp_qloop_325),tmp_qloop_326),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_324,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_325,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_326,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_327),tmp_qloop_328),tmp_qloop_329),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_327,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_328,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_329,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_321),tmp_qloop_322),tmp_qloop_323)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_333),tmp_qloop_334),tmp_qloop_335),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_336),tmp_qloop_337),tmp_qloop_338),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_336,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_337,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_338,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_330),tmp_qloop_331),tmp_qloop_332)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_344),tmp_qloop_345),tmp_qloop_346),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_344,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_345,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_346,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_347),tmp_qloop_348),tmp_qloop_349),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_339,tmp_qloop_340),tmp_qloop_341),tmp_qloop_342)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_354),tmp_qloop_355),tmp_qloop_356),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_355,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_356,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_357),tmp_qloop_358),tmp_qloop_359),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_357,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_358,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_359,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_363),tmp_qloop_364),tmp_qloop_365),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_364,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_365,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_366),tmp_qloop_367),tmp_qloop_368),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_366,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_367,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_368,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_360),tmp_qloop_361),tmp_qloop_362)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_372),tmp_qloop_373),tmp_qloop_374),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_372,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_373,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_374,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_375),tmp_qloop_376),tmp_qloop_377),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_369),tmp_qloop_370),tmp_qloop_371)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_381),tmp_qloop_382),tmp_qloop_383),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_381,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_382,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_383,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_384,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_385,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_386,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_378),tmp_qloop_379),tmp_qloop_380)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_390),tmp_qloop_391),tmp_qloop_392),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_392,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_393,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_394,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_395,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_387),tmp_qloop_388),tmp_qloop_389)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_399),tmp_qloop_400),tmp_qloop_401),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_399,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_400,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_401,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_402),tmp_qloop_403),tmp_qloop_404),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_402,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_396),tmp_qloop_397),tmp_qloop_398)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_408),tmp_qloop_409),tmp_qloop_410),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_408,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_409,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_410,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_411),tmp_qloop_412),tmp_qloop_413),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_411,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_412,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_413,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_405),tmp_qloop_406),tmp_qloop_407)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_417),tmp_qloop_418),tmp_qloop_419),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_420),tmp_qloop_421),tmp_qloop_422),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_420,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_421,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_422,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_414),tmp_qloop_415),tmp_qloop_416)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_426,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_427,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_428,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_429),tmp_qloop_430),tmp_qloop_431),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_429,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_430,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_423),tmp_qloop_424),tmp_qloop_425)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                const __m256d elMatDiag_4 = q_acc_4_4;
                const __m256d elMatDiag_5 = q_acc_5_5;
                const __m256d elMatDiag_6 = q_acc_6_6;
                const __m256d elMatDiag_7 = q_acc_7_7;
                const __m256d elMatDiag_8 = q_acc_8_8;
                const __m256d elMatDiag_9 = q_acc_9_9;
                const __m256d elMatDiag_10 = q_acc_10_10;
                const __m256d elMatDiag_11 = q_acc_11_11;
                const __m256d elMatDiag_12 = q_acc_12_12;
                const __m256d elMatDiag_13 = q_acc_13_13;
                const __m256d elMatDiag_14 = q_acc_14_14;
                const __m256d elMatDiag_15 = q_acc_15_15;
                const __m256d elMatDiag_16 = q_acc_16_16;
                const __m256d elMatDiag_17 = q_acc_17_17;
                const __m256d elMatDiag_18 = q_acc_18_18;
                const __m256d elMatDiag_19 = q_acc_19_19;
                const __m256d elMatDiag_20 = q_acc_20_20;
                const __m256d elMatDiag_21 = q_acc_21_21;
                const __m256d elMatDiag_22 = q_acc_22_22;
                const __m256d elMatDiag_23 = q_acc_23_23;
                const __m256d elMatDiag_24 = q_acc_24_24;
                const __m256d elMatDiag_25 = q_acc_25_25;
                const __m256d elMatDiag_26 = q_acc_26_26;
                const __m256d elMatDiag_27 = q_acc_27_27;
                const __m256d elMatDiag_28 = q_acc_28_28;
                const __m256d elMatDiag_29 = q_acc_29_29;
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_10,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_11,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_12,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_13,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_14,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_15,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_16,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_17,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_18,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_19,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_20,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_21,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_22,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_23,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_24,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_25,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_26,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_27,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_28,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_29,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_148 = (mu_dof_0*_data_phi_0_0_GREEN_UP[10*q] + mu_dof_1*_data_phi_0_0_GREEN_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_UP[10*q + 9])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2];
                   const real_t tmp_qloop_158 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3];
                   const real_t tmp_qloop_167 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4];
                   const real_t tmp_qloop_176 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5];
                   const real_t tmp_qloop_185 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6];
                   const real_t tmp_qloop_194 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7];
                   const real_t tmp_qloop_203 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8];
                   const real_t tmp_qloop_212 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9];
                   const real_t tmp_qloop_221 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10];
                   const real_t tmp_qloop_233 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_279 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_288 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_297 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_306 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_315 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_324 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_344 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_354 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_363 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_372 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_381 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_390 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_399 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_408 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_119 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q];
                   const real_t tmp_qloop_137 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_152 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2];
                   const real_t tmp_qloop_161 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6];
                   const real_t tmp_qloop_197 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7];
                   const real_t tmp_qloop_206 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8];
                   const real_t tmp_qloop_215 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9];
                   const real_t tmp_qloop_224 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10];
                   const real_t tmp_qloop_230 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_243 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11];
                   const real_t tmp_qloop_258 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_267 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_276 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_285 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_294 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_303 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_312 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_321 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_330 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_357 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_366 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_402 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_411 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_420 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_429 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_127 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q];
                   const real_t tmp_qloop_141 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_155 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2];
                   const real_t tmp_qloop_164 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3];
                   const real_t tmp_qloop_173 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4];
                   const real_t tmp_qloop_182 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5];
                   const real_t tmp_qloop_191 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6];
                   const real_t tmp_qloop_200 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_252 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11];
                   const real_t tmp_qloop_264 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_273 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_282 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_291 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_318 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_327 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_336 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_339 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_360 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_369 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_378 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_387 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_396 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_405 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_414 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_123 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_150 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_159 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_168 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_177 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_186 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_195 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_204 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_213 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_222 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_234 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_280 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_289 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_298 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_307 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_316 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_325 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_345 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_355 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_364 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_373 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_382 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_391 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_400 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_409 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_120 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_138 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_153 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_162 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_198 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_207 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_216 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_225 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_231 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_244 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_259 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_268 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_277 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_286 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_295 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_304 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_313 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_322 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_331 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_358 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_367 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_403 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_412 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_421 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_430 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_128 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_142 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_156 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_165 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_174 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_192 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_201 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_253 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_265 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_274 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_283 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_292 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_319 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_328 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_337 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_340 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_361 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_370 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_379 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_388 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_397 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_406 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_415 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_424 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_125 = tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_124;
                   const real_t tmp_qloop_126 = tmp_qloop_122*0.5 + tmp_qloop_123*0.5 + tmp_qloop_124*0.5;
                   const real_t tmp_qloop_132 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_133 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132;
                   const real_t tmp_qloop_134 = tmp_qloop_130*0.5 + tmp_qloop_131*0.5 + tmp_qloop_132*0.5;
                   const real_t tmp_qloop_151 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_160 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_169 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_178 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_187 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_196 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_205 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_214 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_223 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_235 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_236 = tmp_qloop_233 + tmp_qloop_234 + tmp_qloop_235;
                   const real_t tmp_qloop_238 = tmp_qloop_233*0.66666666666666663 + tmp_qloop_234*0.66666666666666663 + tmp_qloop_235*0.66666666666666663;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_251 = (tmp_qloop_233*1.0 + tmp_qloop_234*1.0 + tmp_qloop_235*1.0)*(tmp_qloop_233*2.0 + tmp_qloop_234*2.0 + tmp_qloop_235*2.0);
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_272 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_281 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_290 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_299 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_308 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_317 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_326 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_335 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_346 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_356 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_365 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_374 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_383 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_392 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_401 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_410 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_419 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_428 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_116 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_121 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_135 = (tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0)*(tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0);
                   const real_t tmp_qloop_139 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_140 = tmp_qloop_137 + tmp_qloop_138 + tmp_qloop_139;
                   const real_t tmp_qloop_145 = tmp_qloop_137*0.5 + tmp_qloop_138*0.5 + tmp_qloop_139*0.5;
                   const real_t tmp_qloop_154 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_163 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_172 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_181 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_199 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_208 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_217 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_226 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_232 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_245 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_246 = tmp_qloop_243 + tmp_qloop_244 + tmp_qloop_245;
                   const real_t tmp_qloop_247 = tmp_qloop_243*0.5 + tmp_qloop_244*0.5 + tmp_qloop_245*0.5;
                   const real_t tmp_qloop_260 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_269 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_278 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_287 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_296 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_305 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_314 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_323 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_332 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_342 = tmp_qloop_113 + tmp_qloop_236;
                   const real_t tmp_qloop_343 = tmp_qloop_116 + tmp_qloop_238;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_350 = tmp_qloop_135 + tmp_qloop_251 + (tmp_qloop_125 + tmp_qloop_246)*(tmp_qloop_126 + tmp_qloop_247)*2.0;
                   const real_t tmp_qloop_359 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_368 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_386 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_404 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_413 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_422 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_431 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_129 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_136 = (tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_143 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_144 = tmp_qloop_141 + tmp_qloop_142 + tmp_qloop_143;
                   const real_t tmp_qloop_146 = tmp_qloop_141*0.5 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5;
                   const real_t tmp_qloop_147 = tmp_qloop_135 + tmp_qloop_136 + (tmp_qloop_140 + tmp_qloop_144)*(tmp_qloop_145 + tmp_qloop_146)*2.0;
                   const real_t tmp_qloop_157 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_166 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_184 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_193 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_202 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_211 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_229 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_237 = tmp_qloop_109 + tmp_qloop_236;
                   const real_t tmp_qloop_239 = tmp_qloop_115 + tmp_qloop_238;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_254 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_255 = tmp_qloop_252 + tmp_qloop_253 + tmp_qloop_254;
                   const real_t tmp_qloop_256 = tmp_qloop_252*0.5 + tmp_qloop_253*0.5 + tmp_qloop_254*0.5;
                   const real_t tmp_qloop_257 = tmp_qloop_136 + tmp_qloop_251 + (tmp_qloop_133 + tmp_qloop_255)*(tmp_qloop_134 + tmp_qloop_256)*2.0;
                   const real_t tmp_qloop_266 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_275 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_284 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_293 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_311 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_320 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_329 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_338 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_341 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_362 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_371 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_380 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_389 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_398 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_407 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_416 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_425 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10];
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_114)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_117) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_119 + tmp_qloop_120 + tmp_qloop_121 + tmp_qloop_125)*(tmp_qloop_119*0.5 + tmp_qloop_120*0.5 + tmp_qloop_121*0.5 + tmp_qloop_126)*2.0 + (tmp_qloop_127 + tmp_qloop_128 + tmp_qloop_129 + tmp_qloop_133)*(tmp_qloop_127*0.5 + tmp_qloop_128*0.5 + tmp_qloop_129*0.5 + tmp_qloop_134)*2.0));
                   const real_t q_tmp_1_1 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_149 + tmp_qloop_150 + tmp_qloop_151)*(tmp_qloop_117 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663 + tmp_qloop_151*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_149*1.0 + tmp_qloop_150*1.0 + tmp_qloop_151*1.0)*(tmp_qloop_149*2.0 + tmp_qloop_150*2.0 + tmp_qloop_151*2.0) + (tmp_qloop_125 + tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_154)*(tmp_qloop_126 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5 + tmp_qloop_154*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_155 + tmp_qloop_156 + tmp_qloop_157)*(tmp_qloop_134 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5 + tmp_qloop_157*0.5)*2.0));
                   const real_t q_tmp_2_2 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_158 + tmp_qloop_159 + tmp_qloop_160)*(tmp_qloop_117 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663 + tmp_qloop_160*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_158*1.0 + tmp_qloop_159*1.0 + tmp_qloop_160*1.0)*(tmp_qloop_158*2.0 + tmp_qloop_159*2.0 + tmp_qloop_160*2.0) + (tmp_qloop_125 + tmp_qloop_161 + tmp_qloop_162 + tmp_qloop_163)*(tmp_qloop_126 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5 + tmp_qloop_163*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_164 + tmp_qloop_165 + tmp_qloop_166)*(tmp_qloop_134 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5 + tmp_qloop_166*0.5)*2.0));
                   const real_t q_tmp_3_3 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_167 + tmp_qloop_168 + tmp_qloop_169)*(tmp_qloop_117 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663 + tmp_qloop_169*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_167*1.0 + tmp_qloop_168*1.0 + tmp_qloop_169*1.0)*(tmp_qloop_167*2.0 + tmp_qloop_168*2.0 + tmp_qloop_169*2.0) + (tmp_qloop_125 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172)*(tmp_qloop_126 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5 + tmp_qloop_172*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_173 + tmp_qloop_174 + tmp_qloop_175)*(tmp_qloop_134 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5 + tmp_qloop_175*0.5)*2.0));
                   const real_t q_tmp_4_4 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_176 + tmp_qloop_177 + tmp_qloop_178)*(tmp_qloop_117 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663 + tmp_qloop_178*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_176*1.0 + tmp_qloop_177*1.0 + tmp_qloop_178*1.0)*(tmp_qloop_176*2.0 + tmp_qloop_177*2.0 + tmp_qloop_178*2.0) + (tmp_qloop_125 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181)*(tmp_qloop_126 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5 + tmp_qloop_181*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_182 + tmp_qloop_183 + tmp_qloop_184)*(tmp_qloop_134 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5 + tmp_qloop_184*0.5)*2.0));
                   const real_t q_tmp_5_5 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187)*(tmp_qloop_117 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663 + tmp_qloop_187*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_185*1.0 + tmp_qloop_186*1.0 + tmp_qloop_187*1.0)*(tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0) + (tmp_qloop_125 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190)*(tmp_qloop_126 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5 + tmp_qloop_190*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_191 + tmp_qloop_192 + tmp_qloop_193)*(tmp_qloop_134 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5 + tmp_qloop_193*0.5)*2.0));
                   const real_t q_tmp_6_6 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_194 + tmp_qloop_195 + tmp_qloop_196)*(tmp_qloop_117 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663 + tmp_qloop_196*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_194*1.0 + tmp_qloop_195*1.0 + tmp_qloop_196*1.0)*(tmp_qloop_194*2.0 + tmp_qloop_195*2.0 + tmp_qloop_196*2.0) + (tmp_qloop_125 + tmp_qloop_197 + tmp_qloop_198 + tmp_qloop_199)*(tmp_qloop_126 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5 + tmp_qloop_199*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_200 + tmp_qloop_201 + tmp_qloop_202)*(tmp_qloop_134 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5 + tmp_qloop_202*0.5)*2.0));
                   const real_t q_tmp_7_7 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_203 + tmp_qloop_204 + tmp_qloop_205)*(tmp_qloop_117 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663 + tmp_qloop_205*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_203*1.0 + tmp_qloop_204*1.0 + tmp_qloop_205*1.0)*(tmp_qloop_203*2.0 + tmp_qloop_204*2.0 + tmp_qloop_205*2.0) + (tmp_qloop_125 + tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208)*(tmp_qloop_126 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5 + tmp_qloop_208*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211)*(tmp_qloop_134 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5 + tmp_qloop_211*0.5)*2.0));
                   const real_t q_tmp_8_8 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_212 + tmp_qloop_213 + tmp_qloop_214)*(tmp_qloop_117 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663 + tmp_qloop_214*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_212*1.0 + tmp_qloop_213*1.0 + tmp_qloop_214*1.0)*(tmp_qloop_212*2.0 + tmp_qloop_213*2.0 + tmp_qloop_214*2.0) + (tmp_qloop_125 + tmp_qloop_215 + tmp_qloop_216 + tmp_qloop_217)*(tmp_qloop_126 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5 + tmp_qloop_217*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220)*(tmp_qloop_134 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5 + tmp_qloop_220*0.5)*2.0));
                   const real_t q_tmp_9_9 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_221 + tmp_qloop_222 + tmp_qloop_223)*(tmp_qloop_117 + tmp_qloop_221*0.66666666666666663 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_221*1.0 + tmp_qloop_222*1.0 + tmp_qloop_223*1.0)*(tmp_qloop_221*2.0 + tmp_qloop_222*2.0 + tmp_qloop_223*2.0) + (tmp_qloop_125 + tmp_qloop_224 + tmp_qloop_225 + tmp_qloop_226)*(tmp_qloop_126 + tmp_qloop_224*0.5 + tmp_qloop_225*0.5 + tmp_qloop_226*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229)*(tmp_qloop_134 + tmp_qloop_227*0.5 + tmp_qloop_228*0.5 + tmp_qloop_229*0.5)*2.0));
                   const real_t q_tmp_10_10 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_230 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_237)*(tmp_qloop_230*0.66666666666666663 + tmp_qloop_231*0.66666666666666663 + tmp_qloop_232*0.66666666666666663 + tmp_qloop_239) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_230*1.0 + tmp_qloop_231*1.0 + tmp_qloop_232*1.0)*(tmp_qloop_230*2.0 + tmp_qloop_231*2.0 + tmp_qloop_232*2.0) + (tmp_qloop_140 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250)*(tmp_qloop_145 + tmp_qloop_248*0.5 + tmp_qloop_249*0.5 + tmp_qloop_250*0.5)*2.0 + (tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242 + tmp_qloop_246)*(tmp_qloop_240*0.5 + tmp_qloop_241*0.5 + tmp_qloop_242*0.5 + tmp_qloop_247)*2.0));
                   const real_t q_tmp_11_11 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_258 + tmp_qloop_259 + tmp_qloop_260)*(tmp_qloop_239 + tmp_qloop_258*0.66666666666666663 + tmp_qloop_259*0.66666666666666663 + tmp_qloop_260*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_258*1.0 + tmp_qloop_259*1.0 + tmp_qloop_260*1.0)*(tmp_qloop_258*2.0 + tmp_qloop_259*2.0 + tmp_qloop_260*2.0) + (tmp_qloop_140 + tmp_qloop_264 + tmp_qloop_265 + tmp_qloop_266)*(tmp_qloop_145 + tmp_qloop_264*0.5 + tmp_qloop_265*0.5 + tmp_qloop_266*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263)*(tmp_qloop_247 + tmp_qloop_261*0.5 + tmp_qloop_262*0.5 + tmp_qloop_263*0.5)*2.0));
                   const real_t q_tmp_12_12 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_267 + tmp_qloop_268 + tmp_qloop_269)*(tmp_qloop_239 + tmp_qloop_267*0.66666666666666663 + tmp_qloop_268*0.66666666666666663 + tmp_qloop_269*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_267*1.0 + tmp_qloop_268*1.0 + tmp_qloop_269*1.0)*(tmp_qloop_267*2.0 + tmp_qloop_268*2.0 + tmp_qloop_269*2.0) + (tmp_qloop_140 + tmp_qloop_273 + tmp_qloop_274 + tmp_qloop_275)*(tmp_qloop_145 + tmp_qloop_273*0.5 + tmp_qloop_274*0.5 + tmp_qloop_275*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272)*(tmp_qloop_247 + tmp_qloop_270*0.5 + tmp_qloop_271*0.5 + tmp_qloop_272*0.5)*2.0));
                   const real_t q_tmp_13_13 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_276 + tmp_qloop_277 + tmp_qloop_278)*(tmp_qloop_239 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0)*(tmp_qloop_276*2.0 + tmp_qloop_277*2.0 + tmp_qloop_278*2.0) + (tmp_qloop_140 + tmp_qloop_282 + tmp_qloop_283 + tmp_qloop_284)*(tmp_qloop_145 + tmp_qloop_282*0.5 + tmp_qloop_283*0.5 + tmp_qloop_284*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_279 + tmp_qloop_280 + tmp_qloop_281)*(tmp_qloop_247 + tmp_qloop_279*0.5 + tmp_qloop_280*0.5 + tmp_qloop_281*0.5)*2.0));
                   const real_t q_tmp_14_14 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_285 + tmp_qloop_286 + tmp_qloop_287)*(tmp_qloop_239 + tmp_qloop_285*0.66666666666666663 + tmp_qloop_286*0.66666666666666663 + tmp_qloop_287*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_285*1.0 + tmp_qloop_286*1.0 + tmp_qloop_287*1.0)*(tmp_qloop_285*2.0 + tmp_qloop_286*2.0 + tmp_qloop_287*2.0) + (tmp_qloop_140 + tmp_qloop_291 + tmp_qloop_292 + tmp_qloop_293)*(tmp_qloop_145 + tmp_qloop_291*0.5 + tmp_qloop_292*0.5 + tmp_qloop_293*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_288 + tmp_qloop_289 + tmp_qloop_290)*(tmp_qloop_247 + tmp_qloop_288*0.5 + tmp_qloop_289*0.5 + tmp_qloop_290*0.5)*2.0));
                   const real_t q_tmp_15_15 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_294 + tmp_qloop_295 + tmp_qloop_296)*(tmp_qloop_239 + tmp_qloop_294*0.66666666666666663 + tmp_qloop_295*0.66666666666666663 + tmp_qloop_296*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_294*1.0 + tmp_qloop_295*1.0 + tmp_qloop_296*1.0)*(tmp_qloop_294*2.0 + tmp_qloop_295*2.0 + tmp_qloop_296*2.0) + (tmp_qloop_140 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302)*(tmp_qloop_145 + tmp_qloop_300*0.5 + tmp_qloop_301*0.5 + tmp_qloop_302*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_297 + tmp_qloop_298 + tmp_qloop_299)*(tmp_qloop_247 + tmp_qloop_297*0.5 + tmp_qloop_298*0.5 + tmp_qloop_299*0.5)*2.0));
                   const real_t q_tmp_16_16 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_303 + tmp_qloop_304 + tmp_qloop_305)*(tmp_qloop_239 + tmp_qloop_303*0.66666666666666663 + tmp_qloop_304*0.66666666666666663 + tmp_qloop_305*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_303*1.0 + tmp_qloop_304*1.0 + tmp_qloop_305*1.0)*(tmp_qloop_303*2.0 + tmp_qloop_304*2.0 + tmp_qloop_305*2.0) + (tmp_qloop_140 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311)*(tmp_qloop_145 + tmp_qloop_309*0.5 + tmp_qloop_310*0.5 + tmp_qloop_311*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_308)*(tmp_qloop_247 + tmp_qloop_306*0.5 + tmp_qloop_307*0.5 + tmp_qloop_308*0.5)*2.0));
                   const real_t q_tmp_17_17 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_312 + tmp_qloop_313 + tmp_qloop_314)*(tmp_qloop_239 + tmp_qloop_312*0.66666666666666663 + tmp_qloop_313*0.66666666666666663 + tmp_qloop_314*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_312*1.0 + tmp_qloop_313*1.0 + tmp_qloop_314*1.0)*(tmp_qloop_312*2.0 + tmp_qloop_313*2.0 + tmp_qloop_314*2.0) + (tmp_qloop_140 + tmp_qloop_318 + tmp_qloop_319 + tmp_qloop_320)*(tmp_qloop_145 + tmp_qloop_318*0.5 + tmp_qloop_319*0.5 + tmp_qloop_320*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_315 + tmp_qloop_316 + tmp_qloop_317)*(tmp_qloop_247 + tmp_qloop_315*0.5 + tmp_qloop_316*0.5 + tmp_qloop_317*0.5)*2.0));
                   const real_t q_tmp_18_18 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_321 + tmp_qloop_322 + tmp_qloop_323)*(tmp_qloop_239 + tmp_qloop_321*0.66666666666666663 + tmp_qloop_322*0.66666666666666663 + tmp_qloop_323*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_321*1.0 + tmp_qloop_322*1.0 + tmp_qloop_323*1.0)*(tmp_qloop_321*2.0 + tmp_qloop_322*2.0 + tmp_qloop_323*2.0) + (tmp_qloop_140 + tmp_qloop_327 + tmp_qloop_328 + tmp_qloop_329)*(tmp_qloop_145 + tmp_qloop_327*0.5 + tmp_qloop_328*0.5 + tmp_qloop_329*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_326)*(tmp_qloop_247 + tmp_qloop_324*0.5 + tmp_qloop_325*0.5 + tmp_qloop_326*0.5)*2.0));
                   const real_t q_tmp_19_19 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_330 + tmp_qloop_331 + tmp_qloop_332)*(tmp_qloop_239 + tmp_qloop_330*0.66666666666666663 + tmp_qloop_331*0.66666666666666663 + tmp_qloop_332*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_330*1.0 + tmp_qloop_331*1.0 + tmp_qloop_332*1.0)*(tmp_qloop_330*2.0 + tmp_qloop_331*2.0 + tmp_qloop_332*2.0) + (tmp_qloop_140 + tmp_qloop_336 + tmp_qloop_337 + tmp_qloop_338)*(tmp_qloop_145 + tmp_qloop_336*0.5 + tmp_qloop_337*0.5 + tmp_qloop_338*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335)*(tmp_qloop_247 + tmp_qloop_333*0.5 + tmp_qloop_334*0.5 + tmp_qloop_335*0.5)*2.0));
                   const real_t q_tmp_20_20 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_339 + tmp_qloop_340 + tmp_qloop_341 + tmp_qloop_342)*(tmp_qloop_339*0.66666666666666663 + tmp_qloop_340*0.66666666666666663 + tmp_qloop_341*0.66666666666666663 + tmp_qloop_343) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_339*1.0 + tmp_qloop_340*1.0 + tmp_qloop_341*1.0)*(tmp_qloop_339*2.0 + tmp_qloop_340*2.0 + tmp_qloop_341*2.0) + (tmp_qloop_144 + tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349)*(tmp_qloop_146 + tmp_qloop_347*0.5 + tmp_qloop_348*0.5 + tmp_qloop_349*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_344 + tmp_qloop_345 + tmp_qloop_346)*(tmp_qloop_256 + tmp_qloop_344*0.5 + tmp_qloop_345*0.5 + tmp_qloop_346*0.5)*2.0));
                   const real_t q_tmp_21_21 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353)*(tmp_qloop_343 + tmp_qloop_351*0.66666666666666663 + tmp_qloop_352*0.66666666666666663 + tmp_qloop_353*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_351*1.0 + tmp_qloop_352*1.0 + tmp_qloop_353*1.0)*(tmp_qloop_351*2.0 + tmp_qloop_352*2.0 + tmp_qloop_353*2.0) + (tmp_qloop_144 + tmp_qloop_357 + tmp_qloop_358 + tmp_qloop_359)*(tmp_qloop_146 + tmp_qloop_357*0.5 + tmp_qloop_358*0.5 + tmp_qloop_359*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_354 + tmp_qloop_355 + tmp_qloop_356)*(tmp_qloop_256 + tmp_qloop_354*0.5 + tmp_qloop_355*0.5 + tmp_qloop_356*0.5)*2.0));
                   const real_t q_tmp_22_22 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_360 + tmp_qloop_361 + tmp_qloop_362)*(tmp_qloop_343 + tmp_qloop_360*0.66666666666666663 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_360*1.0 + tmp_qloop_361*1.0 + tmp_qloop_362*1.0)*(tmp_qloop_360*2.0 + tmp_qloop_361*2.0 + tmp_qloop_362*2.0) + (tmp_qloop_144 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_368)*(tmp_qloop_146 + tmp_qloop_366*0.5 + tmp_qloop_367*0.5 + tmp_qloop_368*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_363 + tmp_qloop_364 + tmp_qloop_365)*(tmp_qloop_256 + tmp_qloop_363*0.5 + tmp_qloop_364*0.5 + tmp_qloop_365*0.5)*2.0));
                   const real_t q_tmp_23_23 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_369 + tmp_qloop_370 + tmp_qloop_371)*(tmp_qloop_343 + tmp_qloop_369*0.66666666666666663 + tmp_qloop_370*0.66666666666666663 + tmp_qloop_371*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_369*1.0 + tmp_qloop_370*1.0 + tmp_qloop_371*1.0)*(tmp_qloop_369*2.0 + tmp_qloop_370*2.0 + tmp_qloop_371*2.0) + (tmp_qloop_144 + tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377)*(tmp_qloop_146 + tmp_qloop_375*0.5 + tmp_qloop_376*0.5 + tmp_qloop_377*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_372 + tmp_qloop_373 + tmp_qloop_374)*(tmp_qloop_256 + tmp_qloop_372*0.5 + tmp_qloop_373*0.5 + tmp_qloop_374*0.5)*2.0));
                   const real_t q_tmp_24_24 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_378 + tmp_qloop_379 + tmp_qloop_380)*(tmp_qloop_343 + tmp_qloop_378*0.66666666666666663 + tmp_qloop_379*0.66666666666666663 + tmp_qloop_380*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_378*1.0 + tmp_qloop_379*1.0 + tmp_qloop_380*1.0)*(tmp_qloop_378*2.0 + tmp_qloop_379*2.0 + tmp_qloop_380*2.0) + (tmp_qloop_144 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386)*(tmp_qloop_146 + tmp_qloop_384*0.5 + tmp_qloop_385*0.5 + tmp_qloop_386*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_381 + tmp_qloop_382 + tmp_qloop_383)*(tmp_qloop_256 + tmp_qloop_381*0.5 + tmp_qloop_382*0.5 + tmp_qloop_383*0.5)*2.0));
                   const real_t q_tmp_25_25 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_387 + tmp_qloop_388 + tmp_qloop_389)*(tmp_qloop_343 + tmp_qloop_387*0.66666666666666663 + tmp_qloop_388*0.66666666666666663 + tmp_qloop_389*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_387*1.0 + tmp_qloop_388*1.0 + tmp_qloop_389*1.0)*(tmp_qloop_387*2.0 + tmp_qloop_388*2.0 + tmp_qloop_389*2.0) + (tmp_qloop_144 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395)*(tmp_qloop_146 + tmp_qloop_393*0.5 + tmp_qloop_394*0.5 + tmp_qloop_395*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_392)*(tmp_qloop_256 + tmp_qloop_390*0.5 + tmp_qloop_391*0.5 + tmp_qloop_392*0.5)*2.0));
                   const real_t q_tmp_26_26 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_396 + tmp_qloop_397 + tmp_qloop_398)*(tmp_qloop_343 + tmp_qloop_396*0.66666666666666663 + tmp_qloop_397*0.66666666666666663 + tmp_qloop_398*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_396*1.0 + tmp_qloop_397*1.0 + tmp_qloop_398*1.0)*(tmp_qloop_396*2.0 + tmp_qloop_397*2.0 + tmp_qloop_398*2.0) + (tmp_qloop_144 + tmp_qloop_402 + tmp_qloop_403 + tmp_qloop_404)*(tmp_qloop_146 + tmp_qloop_402*0.5 + tmp_qloop_403*0.5 + tmp_qloop_404*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_399 + tmp_qloop_400 + tmp_qloop_401)*(tmp_qloop_256 + tmp_qloop_399*0.5 + tmp_qloop_400*0.5 + tmp_qloop_401*0.5)*2.0));
                   const real_t q_tmp_27_27 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_405 + tmp_qloop_406 + tmp_qloop_407)*(tmp_qloop_343 + tmp_qloop_405*0.66666666666666663 + tmp_qloop_406*0.66666666666666663 + tmp_qloop_407*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_405*1.0 + tmp_qloop_406*1.0 + tmp_qloop_407*1.0)*(tmp_qloop_405*2.0 + tmp_qloop_406*2.0 + tmp_qloop_407*2.0) + (tmp_qloop_144 + tmp_qloop_411 + tmp_qloop_412 + tmp_qloop_413)*(tmp_qloop_146 + tmp_qloop_411*0.5 + tmp_qloop_412*0.5 + tmp_qloop_413*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_410)*(tmp_qloop_256 + tmp_qloop_408*0.5 + tmp_qloop_409*0.5 + tmp_qloop_410*0.5)*2.0));
                   const real_t q_tmp_28_28 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_414 + tmp_qloop_415 + tmp_qloop_416)*(tmp_qloop_343 + tmp_qloop_414*0.66666666666666663 + tmp_qloop_415*0.66666666666666663 + tmp_qloop_416*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_414*1.0 + tmp_qloop_415*1.0 + tmp_qloop_416*1.0)*(tmp_qloop_414*2.0 + tmp_qloop_415*2.0 + tmp_qloop_416*2.0) + (tmp_qloop_144 + tmp_qloop_420 + tmp_qloop_421 + tmp_qloop_422)*(tmp_qloop_146 + tmp_qloop_420*0.5 + tmp_qloop_421*0.5 + tmp_qloop_422*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419)*(tmp_qloop_256 + tmp_qloop_417*0.5 + tmp_qloop_418*0.5 + tmp_qloop_419*0.5)*2.0));
                   const real_t q_tmp_29_29 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_423 + tmp_qloop_424 + tmp_qloop_425)*(tmp_qloop_343 + tmp_qloop_423*0.66666666666666663 + tmp_qloop_424*0.66666666666666663 + tmp_qloop_425*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_423*1.0 + tmp_qloop_424*1.0 + tmp_qloop_425*1.0)*(tmp_qloop_423*2.0 + tmp_qloop_424*2.0 + tmp_qloop_425*2.0) + (tmp_qloop_144 + tmp_qloop_429 + tmp_qloop_430 + tmp_qloop_431)*(tmp_qloop_146 + tmp_qloop_429*0.5 + tmp_qloop_430*0.5 + tmp_qloop_431*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428)*(tmp_qloop_256 + tmp_qloop_426*0.5 + tmp_qloop_427*0.5 + tmp_qloop_428*0.5)*2.0));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                const real_t elMatDiag_4 = q_acc_4_4;
                const real_t elMatDiag_5 = q_acc_5_5;
                const real_t elMatDiag_6 = q_acc_6_6;
                const real_t elMatDiag_7 = q_acc_7_7;
                const real_t elMatDiag_8 = q_acc_8_8;
                const real_t elMatDiag_9 = q_acc_9_9;
                const real_t elMatDiag_10 = q_acc_10_10;
                const real_t elMatDiag_11 = q_acc_11_11;
                const real_t elMatDiag_12 = q_acc_12_12;
                const real_t elMatDiag_13 = q_acc_13_13;
                const real_t elMatDiag_14 = q_acc_14_14;
                const real_t elMatDiag_15 = q_acc_15_15;
                const real_t elMatDiag_16 = q_acc_16_16;
                const real_t elMatDiag_17 = q_acc_17_17;
                const real_t elMatDiag_18 = q_acc_18_18;
                const real_t elMatDiag_19 = q_acc_19_19;
                const real_t elMatDiag_20 = q_acc_20_20;
                const real_t elMatDiag_21 = q_acc_21_21;
                const real_t elMatDiag_22 = q_acc_22_22;
                const real_t elMatDiag_23 = q_acc_23_23;
                const real_t elMatDiag_24 = q_acc_24_24;
                const real_t elMatDiag_25 = q_acc_25_25;
                const real_t elMatDiag_26 = q_acc_26_26;
                const real_t elMatDiag_27 = q_acc_27_27;
                const real_t elMatDiag_28 = q_acc_28_28;
                const real_t elMatDiag_29 = q_acc_29_29;
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_10 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_11 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_12 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_13 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_14 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_15 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_16 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_17 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_18 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_19 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_20 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_21 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_22 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_23 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_24 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_25 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_26 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_27 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_28 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_29 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(abs_det_jac_affine_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(abs_det_jac_affine_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(abs_det_jac_affine_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(mu_dof_4,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(mu_dof_5,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(mu_dof_6,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(mu_dof_7,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(mu_dof_8,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(mu_dof_9,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_212 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_221 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_297 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_354 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q]));
                   const __m256d tmp_qloop_137 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_230 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_243 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_303 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_312 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_402 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_411 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_420 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_429 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q]));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_173 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_182 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_191 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_200 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_252 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_264 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_273 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_282 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_291 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_318 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_327 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_336 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_360 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_369 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_378 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_387 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_396 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_186 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_195 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_204 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_213 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_234 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_280 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_289 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_298 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_345 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_355 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_364 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_373 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_382 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_225 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_304 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_313 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_322 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_331 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_430 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_128 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_265 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_340 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_388 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_397 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_406 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_415 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_424 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_122,tmp_qloop_123),tmp_qloop_124);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_169 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_178 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_187 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_236 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_233,tmp_qloop_234),tmp_qloop_235);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_251 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_233,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_234,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_281 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_290 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_299 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_308 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_317 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_326 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_346 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_374 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_383 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_392 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_401 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_410 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_137,tmp_qloop_138),tmp_qloop_139);
                   const __m256d tmp_qloop_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_138,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_199 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_208 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_217 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_226 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_246 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_243,tmp_qloop_244),tmp_qloop_245);
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_243,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_244,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_245,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_260 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_269 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_296 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_332 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_342 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_236);
                   const __m256d tmp_qloop_343 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_238);
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_246),_mm256_add_pd(tmp_qloop_126,tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_251);
                   const __m256d tmp_qloop_359 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_368 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_129 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_144 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_141,tmp_qloop_142),tmp_qloop_143);
                   const __m256d tmp_qloop_146 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_141,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_142,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_143,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_144),_mm256_add_pd(tmp_qloop_145,tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_135),tmp_qloop_136);
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_237 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_236);
                   const __m256d tmp_qloop_239 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_238);
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_255 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_252,tmp_qloop_253),tmp_qloop_254);
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_253,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_254,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_257 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_255),_mm256_add_pd(tmp_qloop_134,tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_136),tmp_qloop_251);
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_341 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_416 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_425 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10]));
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_119,tmp_qloop_120),tmp_qloop_121),tmp_qloop_125),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_120,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_121,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_128),tmp_qloop_129),tmp_qloop_133),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_129,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_114)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_152),tmp_qloop_153),tmp_qloop_154),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_154,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_155),tmp_qloop_156),tmp_qloop_157),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_155,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_156,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_149),tmp_qloop_150),tmp_qloop_151)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_151,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_161),tmp_qloop_162),tmp_qloop_163),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_162,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_163,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_164),tmp_qloop_165),tmp_qloop_166),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_164,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_165,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_166,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_158),tmp_qloop_159),tmp_qloop_160)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_160,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_173),tmp_qloop_174),tmp_qloop_175),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_173,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_174,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_175,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_167),tmp_qloop_168),tmp_qloop_169)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_167,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_168,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_169,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_179,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_180,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_181,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_182),tmp_qloop_183),tmp_qloop_184),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_182,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_176),tmp_qloop_177),tmp_qloop_178)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_176,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_177,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_178,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_188,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_189,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_190,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_191),tmp_qloop_192),tmp_qloop_193),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_191,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_192,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_193,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_185),tmp_qloop_186),tmp_qloop_187)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_186,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_187,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_197),tmp_qloop_198),tmp_qloop_199),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_199,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_200),tmp_qloop_201),tmp_qloop_202),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_201,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_202,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_194),tmp_qloop_195),tmp_qloop_196)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_194,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_195,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_206),tmp_qloop_207),tmp_qloop_208),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_206,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_207,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_208,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_203),tmp_qloop_204),tmp_qloop_205)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_203,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_204,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_205,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_215),tmp_qloop_216),tmp_qloop_217),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_215,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_216,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_217,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_218,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_219,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_220,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_212),tmp_qloop_213),tmp_qloop_214)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_212,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_213,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_214,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_125,tmp_qloop_224),tmp_qloop_225),tmp_qloop_226),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_225,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_226,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_126)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_227,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_228,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_229,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_134)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_147)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_114,tmp_qloop_221),tmp_qloop_222),tmp_qloop_223)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_221,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_117)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_240,tmp_qloop_241),tmp_qloop_242),tmp_qloop_246),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_240,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_241,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_242,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_230,tmp_qloop_231),tmp_qloop_232),tmp_qloop_237)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_230,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_231,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_232,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_264),tmp_qloop_265),tmp_qloop_266),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_264,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_265,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_266,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_258),tmp_qloop_259),tmp_qloop_260)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_258,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_259,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_260,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_270,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_271,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_272,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_273),tmp_qloop_274),tmp_qloop_275),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_273,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_267),tmp_qloop_268),tmp_qloop_269)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_267,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_268,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_269,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_279),tmp_qloop_280),tmp_qloop_281),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_280,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_281,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_282),tmp_qloop_283),tmp_qloop_284),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_282,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_283,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_284,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_276),tmp_qloop_277),tmp_qloop_278)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_288),tmp_qloop_289),tmp_qloop_290),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_289,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_290,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_291),tmp_qloop_292),tmp_qloop_293),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_291,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_292,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_285),tmp_qloop_286),tmp_qloop_287)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_285,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_297),tmp_qloop_298),tmp_qloop_299),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_298,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_299,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_300,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_301,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_302,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_294),tmp_qloop_295),tmp_qloop_296)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_296,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_306),tmp_qloop_307),tmp_qloop_308),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_308,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_309,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_310,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_311,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_303),tmp_qloop_304),tmp_qloop_305)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_303,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_304,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_315),tmp_qloop_316),tmp_qloop_317),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_315,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_316,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_317,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_318),tmp_qloop_319),tmp_qloop_320),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_318,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_312),tmp_qloop_313),tmp_qloop_314)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_313,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_314,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_324),tmp_qloop_325),tmp_qloop_326),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_324,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_325,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_326,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_327),tmp_qloop_328),tmp_qloop_329),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_327,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_328,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_329,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_321),tmp_qloop_322),tmp_qloop_323)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_322,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_323,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_246,tmp_qloop_333),tmp_qloop_334),tmp_qloop_335),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_247)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_140,tmp_qloop_336),tmp_qloop_337),tmp_qloop_338),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_336,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_337,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_338,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_145)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_257)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_237,tmp_qloop_330),tmp_qloop_331),tmp_qloop_332)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_330,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_331,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_332,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_239)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_344),tmp_qloop_345),tmp_qloop_346),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_344,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_345,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_346,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_347),tmp_qloop_348),tmp_qloop_349),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_339,tmp_qloop_340),tmp_qloop_341),tmp_qloop_342)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_339,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_340,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_341,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_354),tmp_qloop_355),tmp_qloop_356),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_355,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_356,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_357),tmp_qloop_358),tmp_qloop_359),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_357,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_358,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_359,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_351,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_352,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_353,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_363),tmp_qloop_364),tmp_qloop_365),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_364,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_365,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_366),tmp_qloop_367),tmp_qloop_368),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_366,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_367,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_368,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_360),tmp_qloop_361),tmp_qloop_362)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_360,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_372),tmp_qloop_373),tmp_qloop_374),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_372,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_373,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_374,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_375),tmp_qloop_376),tmp_qloop_377),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_369),tmp_qloop_370),tmp_qloop_371)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_369,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_370,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_371,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_381),tmp_qloop_382),tmp_qloop_383),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_381,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_382,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_383,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_384,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_385,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_386,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_378),tmp_qloop_379),tmp_qloop_380)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_378,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_379,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_380,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_390),tmp_qloop_391),tmp_qloop_392),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_392,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_393,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_394,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_395,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_387),tmp_qloop_388),tmp_qloop_389)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_387,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_388,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_399),tmp_qloop_400),tmp_qloop_401),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_399,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_400,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_401,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_402),tmp_qloop_403),tmp_qloop_404),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_402,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_396),tmp_qloop_397),tmp_qloop_398)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_397,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_398,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_408),tmp_qloop_409),tmp_qloop_410),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_408,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_409,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_410,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_411),tmp_qloop_412),tmp_qloop_413),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_411,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_412,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_413,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_405),tmp_qloop_406),tmp_qloop_407)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_406,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_407,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_417),tmp_qloop_418),tmp_qloop_419),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_420),tmp_qloop_421),tmp_qloop_422),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_420,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_421,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_422,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_414),tmp_qloop_415),tmp_qloop_416)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_414,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_415,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_416,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_148,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_255,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_426,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_427,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_428,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_256)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_429),tmp_qloop_430),tmp_qloop_431),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_429,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_430,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_146)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_350)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_342,tmp_qloop_423),tmp_qloop_424),tmp_qloop_425)),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_423,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_424,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_425,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_343)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                const __m256d elMatDiag_4 = q_acc_4_4;
                const __m256d elMatDiag_5 = q_acc_5_5;
                const __m256d elMatDiag_6 = q_acc_6_6;
                const __m256d elMatDiag_7 = q_acc_7_7;
                const __m256d elMatDiag_8 = q_acc_8_8;
                const __m256d elMatDiag_9 = q_acc_9_9;
                const __m256d elMatDiag_10 = q_acc_10_10;
                const __m256d elMatDiag_11 = q_acc_11_11;
                const __m256d elMatDiag_12 = q_acc_12_12;
                const __m256d elMatDiag_13 = q_acc_13_13;
                const __m256d elMatDiag_14 = q_acc_14_14;
                const __m256d elMatDiag_15 = q_acc_15_15;
                const __m256d elMatDiag_16 = q_acc_16_16;
                const __m256d elMatDiag_17 = q_acc_17_17;
                const __m256d elMatDiag_18 = q_acc_18_18;
                const __m256d elMatDiag_19 = q_acc_19_19;
                const __m256d elMatDiag_20 = q_acc_20_20;
                const __m256d elMatDiag_21 = q_acc_21_21;
                const __m256d elMatDiag_22 = q_acc_22_22;
                const __m256d elMatDiag_23 = q_acc_23_23;
                const __m256d elMatDiag_24 = q_acc_24_24;
                const __m256d elMatDiag_25 = q_acc_25_25;
                const __m256d elMatDiag_26 = q_acc_26_26;
                const __m256d elMatDiag_27 = q_acc_27_27;
                const __m256d elMatDiag_28 = q_acc_28_28;
                const __m256d elMatDiag_29 = q_acc_29_29;
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_10,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_11,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_12,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_13,_mm256_loadu_pd(& _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_14,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_15,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_16,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_17,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_18,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_19,_mm256_loadu_pd(& _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_20,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_21,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_22,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_23,_mm256_loadu_pd(& _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_24,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_25,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_26,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_27,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_28,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_29,_mm256_loadu_pd(& _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_148 = (mu_dof_0*_data_phi_0_0_GREEN_DOWN[10*q] + mu_dof_1*_data_phi_0_0_GREEN_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_DOWN[10*q + 9])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2];
                   const real_t tmp_qloop_158 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3];
                   const real_t tmp_qloop_167 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4];
                   const real_t tmp_qloop_176 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5];
                   const real_t tmp_qloop_185 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6];
                   const real_t tmp_qloop_194 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7];
                   const real_t tmp_qloop_203 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8];
                   const real_t tmp_qloop_212 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9];
                   const real_t tmp_qloop_221 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10];
                   const real_t tmp_qloop_233 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_279 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_288 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_297 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_306 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_315 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_324 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_344 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_354 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_363 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_372 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_381 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_390 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_399 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_408 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_119 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q];
                   const real_t tmp_qloop_137 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_152 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2];
                   const real_t tmp_qloop_161 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6];
                   const real_t tmp_qloop_197 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7];
                   const real_t tmp_qloop_206 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8];
                   const real_t tmp_qloop_215 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9];
                   const real_t tmp_qloop_224 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10];
                   const real_t tmp_qloop_230 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_243 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11];
                   const real_t tmp_qloop_258 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_267 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_276 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_285 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_294 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_303 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_312 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_321 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_330 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_357 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_366 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_402 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_411 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_420 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_429 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_127 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q];
                   const real_t tmp_qloop_141 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_155 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2];
                   const real_t tmp_qloop_164 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3];
                   const real_t tmp_qloop_173 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4];
                   const real_t tmp_qloop_182 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5];
                   const real_t tmp_qloop_191 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6];
                   const real_t tmp_qloop_200 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_252 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11];
                   const real_t tmp_qloop_264 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_273 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_282 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_291 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_318 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_327 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_336 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_339 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_360 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_369 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_378 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_387 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_396 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_405 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_414 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_123 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_150 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_159 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_168 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_177 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_186 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_195 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_204 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_213 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_222 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_234 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_280 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_289 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_298 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_307 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_316 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_325 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_345 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_355 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_364 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_373 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_382 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_391 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_400 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_409 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_120 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_138 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_153 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_162 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_198 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_207 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_216 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_225 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_231 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_244 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_259 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_268 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_277 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_286 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_295 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_304 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_313 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_322 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_331 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_358 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_367 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_403 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_412 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_421 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_430 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_128 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_142 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_156 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_165 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_174 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_192 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_201 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_253 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_265 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_274 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_283 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_292 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_319 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_328 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_337 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_340 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_361 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_370 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_379 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_388 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_397 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_406 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_415 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_424 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_125 = tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_124;
                   const real_t tmp_qloop_126 = tmp_qloop_122*0.5 + tmp_qloop_123*0.5 + tmp_qloop_124*0.5;
                   const real_t tmp_qloop_132 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_133 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132;
                   const real_t tmp_qloop_134 = tmp_qloop_130*0.5 + tmp_qloop_131*0.5 + tmp_qloop_132*0.5;
                   const real_t tmp_qloop_151 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_160 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_169 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_178 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_187 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_196 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_205 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_214 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_223 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_235 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_236 = tmp_qloop_233 + tmp_qloop_234 + tmp_qloop_235;
                   const real_t tmp_qloop_238 = tmp_qloop_233*0.66666666666666663 + tmp_qloop_234*0.66666666666666663 + tmp_qloop_235*0.66666666666666663;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_251 = (tmp_qloop_233*1.0 + tmp_qloop_234*1.0 + tmp_qloop_235*1.0)*(tmp_qloop_233*2.0 + tmp_qloop_234*2.0 + tmp_qloop_235*2.0);
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_272 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_281 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_290 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_299 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_308 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_317 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_326 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_335 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_346 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_356 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_365 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_374 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_383 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_392 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_401 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_410 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_419 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_428 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_116 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_121 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_135 = (tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0)*(tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0);
                   const real_t tmp_qloop_139 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_140 = tmp_qloop_137 + tmp_qloop_138 + tmp_qloop_139;
                   const real_t tmp_qloop_145 = tmp_qloop_137*0.5 + tmp_qloop_138*0.5 + tmp_qloop_139*0.5;
                   const real_t tmp_qloop_154 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_163 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_172 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_181 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_199 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_208 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_217 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_226 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_232 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_245 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_246 = tmp_qloop_243 + tmp_qloop_244 + tmp_qloop_245;
                   const real_t tmp_qloop_247 = tmp_qloop_243*0.5 + tmp_qloop_244*0.5 + tmp_qloop_245*0.5;
                   const real_t tmp_qloop_260 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_269 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_278 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_287 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_296 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_305 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_314 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_323 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_332 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_342 = tmp_qloop_113 + tmp_qloop_236;
                   const real_t tmp_qloop_343 = tmp_qloop_116 + tmp_qloop_238;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_350 = tmp_qloop_135 + tmp_qloop_251 + (tmp_qloop_125 + tmp_qloop_246)*(tmp_qloop_126 + tmp_qloop_247)*2.0;
                   const real_t tmp_qloop_359 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_368 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_386 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_404 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_413 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_422 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_431 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_129 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_136 = (tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_143 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_144 = tmp_qloop_141 + tmp_qloop_142 + tmp_qloop_143;
                   const real_t tmp_qloop_146 = tmp_qloop_141*0.5 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5;
                   const real_t tmp_qloop_147 = tmp_qloop_135 + tmp_qloop_136 + (tmp_qloop_140 + tmp_qloop_144)*(tmp_qloop_145 + tmp_qloop_146)*2.0;
                   const real_t tmp_qloop_157 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_166 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_184 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_193 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_202 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_211 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_229 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_237 = tmp_qloop_109 + tmp_qloop_236;
                   const real_t tmp_qloop_239 = tmp_qloop_115 + tmp_qloop_238;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_254 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_255 = tmp_qloop_252 + tmp_qloop_253 + tmp_qloop_254;
                   const real_t tmp_qloop_256 = tmp_qloop_252*0.5 + tmp_qloop_253*0.5 + tmp_qloop_254*0.5;
                   const real_t tmp_qloop_257 = tmp_qloop_136 + tmp_qloop_251 + (tmp_qloop_133 + tmp_qloop_255)*(tmp_qloop_134 + tmp_qloop_256)*2.0;
                   const real_t tmp_qloop_266 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_275 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_284 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_293 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_311 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_320 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_329 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_338 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_341 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_362 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_371 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_380 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_389 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_398 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_407 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_416 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_425 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10];
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_114)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_117) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_119 + tmp_qloop_120 + tmp_qloop_121 + tmp_qloop_125)*(tmp_qloop_119*0.5 + tmp_qloop_120*0.5 + tmp_qloop_121*0.5 + tmp_qloop_126)*2.0 + (tmp_qloop_127 + tmp_qloop_128 + tmp_qloop_129 + tmp_qloop_133)*(tmp_qloop_127*0.5 + tmp_qloop_128*0.5 + tmp_qloop_129*0.5 + tmp_qloop_134)*2.0));
                   const real_t q_tmp_1_1 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_149 + tmp_qloop_150 + tmp_qloop_151)*(tmp_qloop_117 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663 + tmp_qloop_151*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_149*1.0 + tmp_qloop_150*1.0 + tmp_qloop_151*1.0)*(tmp_qloop_149*2.0 + tmp_qloop_150*2.0 + tmp_qloop_151*2.0) + (tmp_qloop_125 + tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_154)*(tmp_qloop_126 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5 + tmp_qloop_154*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_155 + tmp_qloop_156 + tmp_qloop_157)*(tmp_qloop_134 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5 + tmp_qloop_157*0.5)*2.0));
                   const real_t q_tmp_2_2 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_158 + tmp_qloop_159 + tmp_qloop_160)*(tmp_qloop_117 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663 + tmp_qloop_160*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_158*1.0 + tmp_qloop_159*1.0 + tmp_qloop_160*1.0)*(tmp_qloop_158*2.0 + tmp_qloop_159*2.0 + tmp_qloop_160*2.0) + (tmp_qloop_125 + tmp_qloop_161 + tmp_qloop_162 + tmp_qloop_163)*(tmp_qloop_126 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5 + tmp_qloop_163*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_164 + tmp_qloop_165 + tmp_qloop_166)*(tmp_qloop_134 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5 + tmp_qloop_166*0.5)*2.0));
                   const real_t q_tmp_3_3 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_167 + tmp_qloop_168 + tmp_qloop_169)*(tmp_qloop_117 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663 + tmp_qloop_169*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_167*1.0 + tmp_qloop_168*1.0 + tmp_qloop_169*1.0)*(tmp_qloop_167*2.0 + tmp_qloop_168*2.0 + tmp_qloop_169*2.0) + (tmp_qloop_125 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172)*(tmp_qloop_126 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5 + tmp_qloop_172*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_173 + tmp_qloop_174 + tmp_qloop_175)*(tmp_qloop_134 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5 + tmp_qloop_175*0.5)*2.0));
                   const real_t q_tmp_4_4 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_176 + tmp_qloop_177 + tmp_qloop_178)*(tmp_qloop_117 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663 + tmp_qloop_178*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_176*1.0 + tmp_qloop_177*1.0 + tmp_qloop_178*1.0)*(tmp_qloop_176*2.0 + tmp_qloop_177*2.0 + tmp_qloop_178*2.0) + (tmp_qloop_125 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181)*(tmp_qloop_126 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5 + tmp_qloop_181*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_182 + tmp_qloop_183 + tmp_qloop_184)*(tmp_qloop_134 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5 + tmp_qloop_184*0.5)*2.0));
                   const real_t q_tmp_5_5 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187)*(tmp_qloop_117 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663 + tmp_qloop_187*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_185*1.0 + tmp_qloop_186*1.0 + tmp_qloop_187*1.0)*(tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0) + (tmp_qloop_125 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190)*(tmp_qloop_126 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5 + tmp_qloop_190*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_191 + tmp_qloop_192 + tmp_qloop_193)*(tmp_qloop_134 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5 + tmp_qloop_193*0.5)*2.0));
                   const real_t q_tmp_6_6 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_194 + tmp_qloop_195 + tmp_qloop_196)*(tmp_qloop_117 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663 + tmp_qloop_196*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_194*1.0 + tmp_qloop_195*1.0 + tmp_qloop_196*1.0)*(tmp_qloop_194*2.0 + tmp_qloop_195*2.0 + tmp_qloop_196*2.0) + (tmp_qloop_125 + tmp_qloop_197 + tmp_qloop_198 + tmp_qloop_199)*(tmp_qloop_126 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5 + tmp_qloop_199*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_200 + tmp_qloop_201 + tmp_qloop_202)*(tmp_qloop_134 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5 + tmp_qloop_202*0.5)*2.0));
                   const real_t q_tmp_7_7 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_203 + tmp_qloop_204 + tmp_qloop_205)*(tmp_qloop_117 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663 + tmp_qloop_205*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_203*1.0 + tmp_qloop_204*1.0 + tmp_qloop_205*1.0)*(tmp_qloop_203*2.0 + tmp_qloop_204*2.0 + tmp_qloop_205*2.0) + (tmp_qloop_125 + tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208)*(tmp_qloop_126 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5 + tmp_qloop_208*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211)*(tmp_qloop_134 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5 + tmp_qloop_211*0.5)*2.0));
                   const real_t q_tmp_8_8 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_212 + tmp_qloop_213 + tmp_qloop_214)*(tmp_qloop_117 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663 + tmp_qloop_214*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_212*1.0 + tmp_qloop_213*1.0 + tmp_qloop_214*1.0)*(tmp_qloop_212*2.0 + tmp_qloop_213*2.0 + tmp_qloop_214*2.0) + (tmp_qloop_125 + tmp_qloop_215 + tmp_qloop_216 + tmp_qloop_217)*(tmp_qloop_126 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5 + tmp_qloop_217*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220)*(tmp_qloop_134 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5 + tmp_qloop_220*0.5)*2.0));
                   const real_t q_tmp_9_9 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_114 + tmp_qloop_221 + tmp_qloop_222 + tmp_qloop_223)*(tmp_qloop_117 + tmp_qloop_221*0.66666666666666663 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_147 + (tmp_qloop_221*1.0 + tmp_qloop_222*1.0 + tmp_qloop_223*1.0)*(tmp_qloop_221*2.0 + tmp_qloop_222*2.0 + tmp_qloop_223*2.0) + (tmp_qloop_125 + tmp_qloop_224 + tmp_qloop_225 + tmp_qloop_226)*(tmp_qloop_126 + tmp_qloop_224*0.5 + tmp_qloop_225*0.5 + tmp_qloop_226*0.5)*2.0 + (tmp_qloop_133 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229)*(tmp_qloop_134 + tmp_qloop_227*0.5 + tmp_qloop_228*0.5 + tmp_qloop_229*0.5)*2.0));
                   const real_t q_tmp_10_10 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_230 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_237)*(tmp_qloop_230*0.66666666666666663 + tmp_qloop_231*0.66666666666666663 + tmp_qloop_232*0.66666666666666663 + tmp_qloop_239) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_230*1.0 + tmp_qloop_231*1.0 + tmp_qloop_232*1.0)*(tmp_qloop_230*2.0 + tmp_qloop_231*2.0 + tmp_qloop_232*2.0) + (tmp_qloop_140 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250)*(tmp_qloop_145 + tmp_qloop_248*0.5 + tmp_qloop_249*0.5 + tmp_qloop_250*0.5)*2.0 + (tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242 + tmp_qloop_246)*(tmp_qloop_240*0.5 + tmp_qloop_241*0.5 + tmp_qloop_242*0.5 + tmp_qloop_247)*2.0));
                   const real_t q_tmp_11_11 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_258 + tmp_qloop_259 + tmp_qloop_260)*(tmp_qloop_239 + tmp_qloop_258*0.66666666666666663 + tmp_qloop_259*0.66666666666666663 + tmp_qloop_260*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_258*1.0 + tmp_qloop_259*1.0 + tmp_qloop_260*1.0)*(tmp_qloop_258*2.0 + tmp_qloop_259*2.0 + tmp_qloop_260*2.0) + (tmp_qloop_140 + tmp_qloop_264 + tmp_qloop_265 + tmp_qloop_266)*(tmp_qloop_145 + tmp_qloop_264*0.5 + tmp_qloop_265*0.5 + tmp_qloop_266*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263)*(tmp_qloop_247 + tmp_qloop_261*0.5 + tmp_qloop_262*0.5 + tmp_qloop_263*0.5)*2.0));
                   const real_t q_tmp_12_12 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_267 + tmp_qloop_268 + tmp_qloop_269)*(tmp_qloop_239 + tmp_qloop_267*0.66666666666666663 + tmp_qloop_268*0.66666666666666663 + tmp_qloop_269*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_267*1.0 + tmp_qloop_268*1.0 + tmp_qloop_269*1.0)*(tmp_qloop_267*2.0 + tmp_qloop_268*2.0 + tmp_qloop_269*2.0) + (tmp_qloop_140 + tmp_qloop_273 + tmp_qloop_274 + tmp_qloop_275)*(tmp_qloop_145 + tmp_qloop_273*0.5 + tmp_qloop_274*0.5 + tmp_qloop_275*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272)*(tmp_qloop_247 + tmp_qloop_270*0.5 + tmp_qloop_271*0.5 + tmp_qloop_272*0.5)*2.0));
                   const real_t q_tmp_13_13 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_276 + tmp_qloop_277 + tmp_qloop_278)*(tmp_qloop_239 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0)*(tmp_qloop_276*2.0 + tmp_qloop_277*2.0 + tmp_qloop_278*2.0) + (tmp_qloop_140 + tmp_qloop_282 + tmp_qloop_283 + tmp_qloop_284)*(tmp_qloop_145 + tmp_qloop_282*0.5 + tmp_qloop_283*0.5 + tmp_qloop_284*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_279 + tmp_qloop_280 + tmp_qloop_281)*(tmp_qloop_247 + tmp_qloop_279*0.5 + tmp_qloop_280*0.5 + tmp_qloop_281*0.5)*2.0));
                   const real_t q_tmp_14_14 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_285 + tmp_qloop_286 + tmp_qloop_287)*(tmp_qloop_239 + tmp_qloop_285*0.66666666666666663 + tmp_qloop_286*0.66666666666666663 + tmp_qloop_287*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_285*1.0 + tmp_qloop_286*1.0 + tmp_qloop_287*1.0)*(tmp_qloop_285*2.0 + tmp_qloop_286*2.0 + tmp_qloop_287*2.0) + (tmp_qloop_140 + tmp_qloop_291 + tmp_qloop_292 + tmp_qloop_293)*(tmp_qloop_145 + tmp_qloop_291*0.5 + tmp_qloop_292*0.5 + tmp_qloop_293*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_288 + tmp_qloop_289 + tmp_qloop_290)*(tmp_qloop_247 + tmp_qloop_288*0.5 + tmp_qloop_289*0.5 + tmp_qloop_290*0.5)*2.0));
                   const real_t q_tmp_15_15 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_294 + tmp_qloop_295 + tmp_qloop_296)*(tmp_qloop_239 + tmp_qloop_294*0.66666666666666663 + tmp_qloop_295*0.66666666666666663 + tmp_qloop_296*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_294*1.0 + tmp_qloop_295*1.0 + tmp_qloop_296*1.0)*(tmp_qloop_294*2.0 + tmp_qloop_295*2.0 + tmp_qloop_296*2.0) + (tmp_qloop_140 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302)*(tmp_qloop_145 + tmp_qloop_300*0.5 + tmp_qloop_301*0.5 + tmp_qloop_302*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_297 + tmp_qloop_298 + tmp_qloop_299)*(tmp_qloop_247 + tmp_qloop_297*0.5 + tmp_qloop_298*0.5 + tmp_qloop_299*0.5)*2.0));
                   const real_t q_tmp_16_16 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_303 + tmp_qloop_304 + tmp_qloop_305)*(tmp_qloop_239 + tmp_qloop_303*0.66666666666666663 + tmp_qloop_304*0.66666666666666663 + tmp_qloop_305*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_303*1.0 + tmp_qloop_304*1.0 + tmp_qloop_305*1.0)*(tmp_qloop_303*2.0 + tmp_qloop_304*2.0 + tmp_qloop_305*2.0) + (tmp_qloop_140 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311)*(tmp_qloop_145 + tmp_qloop_309*0.5 + tmp_qloop_310*0.5 + tmp_qloop_311*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_308)*(tmp_qloop_247 + tmp_qloop_306*0.5 + tmp_qloop_307*0.5 + tmp_qloop_308*0.5)*2.0));
                   const real_t q_tmp_17_17 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_312 + tmp_qloop_313 + tmp_qloop_314)*(tmp_qloop_239 + tmp_qloop_312*0.66666666666666663 + tmp_qloop_313*0.66666666666666663 + tmp_qloop_314*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_312*1.0 + tmp_qloop_313*1.0 + tmp_qloop_314*1.0)*(tmp_qloop_312*2.0 + tmp_qloop_313*2.0 + tmp_qloop_314*2.0) + (tmp_qloop_140 + tmp_qloop_318 + tmp_qloop_319 + tmp_qloop_320)*(tmp_qloop_145 + tmp_qloop_318*0.5 + tmp_qloop_319*0.5 + tmp_qloop_320*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_315 + tmp_qloop_316 + tmp_qloop_317)*(tmp_qloop_247 + tmp_qloop_315*0.5 + tmp_qloop_316*0.5 + tmp_qloop_317*0.5)*2.0));
                   const real_t q_tmp_18_18 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_321 + tmp_qloop_322 + tmp_qloop_323)*(tmp_qloop_239 + tmp_qloop_321*0.66666666666666663 + tmp_qloop_322*0.66666666666666663 + tmp_qloop_323*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_321*1.0 + tmp_qloop_322*1.0 + tmp_qloop_323*1.0)*(tmp_qloop_321*2.0 + tmp_qloop_322*2.0 + tmp_qloop_323*2.0) + (tmp_qloop_140 + tmp_qloop_327 + tmp_qloop_328 + tmp_qloop_329)*(tmp_qloop_145 + tmp_qloop_327*0.5 + tmp_qloop_328*0.5 + tmp_qloop_329*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_326)*(tmp_qloop_247 + tmp_qloop_324*0.5 + tmp_qloop_325*0.5 + tmp_qloop_326*0.5)*2.0));
                   const real_t q_tmp_19_19 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_237 + tmp_qloop_330 + tmp_qloop_331 + tmp_qloop_332)*(tmp_qloop_239 + tmp_qloop_330*0.66666666666666663 + tmp_qloop_331*0.66666666666666663 + tmp_qloop_332*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_257 + (tmp_qloop_330*1.0 + tmp_qloop_331*1.0 + tmp_qloop_332*1.0)*(tmp_qloop_330*2.0 + tmp_qloop_331*2.0 + tmp_qloop_332*2.0) + (tmp_qloop_140 + tmp_qloop_336 + tmp_qloop_337 + tmp_qloop_338)*(tmp_qloop_145 + tmp_qloop_336*0.5 + tmp_qloop_337*0.5 + tmp_qloop_338*0.5)*2.0 + (tmp_qloop_246 + tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335)*(tmp_qloop_247 + tmp_qloop_333*0.5 + tmp_qloop_334*0.5 + tmp_qloop_335*0.5)*2.0));
                   const real_t q_tmp_20_20 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_339 + tmp_qloop_340 + tmp_qloop_341 + tmp_qloop_342)*(tmp_qloop_339*0.66666666666666663 + tmp_qloop_340*0.66666666666666663 + tmp_qloop_341*0.66666666666666663 + tmp_qloop_343) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_339*1.0 + tmp_qloop_340*1.0 + tmp_qloop_341*1.0)*(tmp_qloop_339*2.0 + tmp_qloop_340*2.0 + tmp_qloop_341*2.0) + (tmp_qloop_144 + tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349)*(tmp_qloop_146 + tmp_qloop_347*0.5 + tmp_qloop_348*0.5 + tmp_qloop_349*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_344 + tmp_qloop_345 + tmp_qloop_346)*(tmp_qloop_256 + tmp_qloop_344*0.5 + tmp_qloop_345*0.5 + tmp_qloop_346*0.5)*2.0));
                   const real_t q_tmp_21_21 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353)*(tmp_qloop_343 + tmp_qloop_351*0.66666666666666663 + tmp_qloop_352*0.66666666666666663 + tmp_qloop_353*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_351*1.0 + tmp_qloop_352*1.0 + tmp_qloop_353*1.0)*(tmp_qloop_351*2.0 + tmp_qloop_352*2.0 + tmp_qloop_353*2.0) + (tmp_qloop_144 + tmp_qloop_357 + tmp_qloop_358 + tmp_qloop_359)*(tmp_qloop_146 + tmp_qloop_357*0.5 + tmp_qloop_358*0.5 + tmp_qloop_359*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_354 + tmp_qloop_355 + tmp_qloop_356)*(tmp_qloop_256 + tmp_qloop_354*0.5 + tmp_qloop_355*0.5 + tmp_qloop_356*0.5)*2.0));
                   const real_t q_tmp_22_22 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_360 + tmp_qloop_361 + tmp_qloop_362)*(tmp_qloop_343 + tmp_qloop_360*0.66666666666666663 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_360*1.0 + tmp_qloop_361*1.0 + tmp_qloop_362*1.0)*(tmp_qloop_360*2.0 + tmp_qloop_361*2.0 + tmp_qloop_362*2.0) + (tmp_qloop_144 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_368)*(tmp_qloop_146 + tmp_qloop_366*0.5 + tmp_qloop_367*0.5 + tmp_qloop_368*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_363 + tmp_qloop_364 + tmp_qloop_365)*(tmp_qloop_256 + tmp_qloop_363*0.5 + tmp_qloop_364*0.5 + tmp_qloop_365*0.5)*2.0));
                   const real_t q_tmp_23_23 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_369 + tmp_qloop_370 + tmp_qloop_371)*(tmp_qloop_343 + tmp_qloop_369*0.66666666666666663 + tmp_qloop_370*0.66666666666666663 + tmp_qloop_371*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_369*1.0 + tmp_qloop_370*1.0 + tmp_qloop_371*1.0)*(tmp_qloop_369*2.0 + tmp_qloop_370*2.0 + tmp_qloop_371*2.0) + (tmp_qloop_144 + tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377)*(tmp_qloop_146 + tmp_qloop_375*0.5 + tmp_qloop_376*0.5 + tmp_qloop_377*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_372 + tmp_qloop_373 + tmp_qloop_374)*(tmp_qloop_256 + tmp_qloop_372*0.5 + tmp_qloop_373*0.5 + tmp_qloop_374*0.5)*2.0));
                   const real_t q_tmp_24_24 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_378 + tmp_qloop_379 + tmp_qloop_380)*(tmp_qloop_343 + tmp_qloop_378*0.66666666666666663 + tmp_qloop_379*0.66666666666666663 + tmp_qloop_380*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_378*1.0 + tmp_qloop_379*1.0 + tmp_qloop_380*1.0)*(tmp_qloop_378*2.0 + tmp_qloop_379*2.0 + tmp_qloop_380*2.0) + (tmp_qloop_144 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386)*(tmp_qloop_146 + tmp_qloop_384*0.5 + tmp_qloop_385*0.5 + tmp_qloop_386*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_381 + tmp_qloop_382 + tmp_qloop_383)*(tmp_qloop_256 + tmp_qloop_381*0.5 + tmp_qloop_382*0.5 + tmp_qloop_383*0.5)*2.0));
                   const real_t q_tmp_25_25 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_387 + tmp_qloop_388 + tmp_qloop_389)*(tmp_qloop_343 + tmp_qloop_387*0.66666666666666663 + tmp_qloop_388*0.66666666666666663 + tmp_qloop_389*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_387*1.0 + tmp_qloop_388*1.0 + tmp_qloop_389*1.0)*(tmp_qloop_387*2.0 + tmp_qloop_388*2.0 + tmp_qloop_389*2.0) + (tmp_qloop_144 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395)*(tmp_qloop_146 + tmp_qloop_393*0.5 + tmp_qloop_394*0.5 + tmp_qloop_395*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_392)*(tmp_qloop_256 + tmp_qloop_390*0.5 + tmp_qloop_391*0.5 + tmp_qloop_392*0.5)*2.0));
                   const real_t q_tmp_26_26 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_396 + tmp_qloop_397 + tmp_qloop_398)*(tmp_qloop_343 + tmp_qloop_396*0.66666666666666663 + tmp_qloop_397*0.66666666666666663 + tmp_qloop_398*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_396*1.0 + tmp_qloop_397*1.0 + tmp_qloop_398*1.0)*(tmp_qloop_396*2.0 + tmp_qloop_397*2.0 + tmp_qloop_398*2.0) + (tmp_qloop_144 + tmp_qloop_402 + tmp_qloop_403 + tmp_qloop_404)*(tmp_qloop_146 + tmp_qloop_402*0.5 + tmp_qloop_403*0.5 + tmp_qloop_404*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_399 + tmp_qloop_400 + tmp_qloop_401)*(tmp_qloop_256 + tmp_qloop_399*0.5 + tmp_qloop_400*0.5 + tmp_qloop_401*0.5)*2.0));
                   const real_t q_tmp_27_27 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_405 + tmp_qloop_406 + tmp_qloop_407)*(tmp_qloop_343 + tmp_qloop_405*0.66666666666666663 + tmp_qloop_406*0.66666666666666663 + tmp_qloop_407*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_405*1.0 + tmp_qloop_406*1.0 + tmp_qloop_407*1.0)*(tmp_qloop_405*2.0 + tmp_qloop_406*2.0 + tmp_qloop_407*2.0) + (tmp_qloop_144 + tmp_qloop_411 + tmp_qloop_412 + tmp_qloop_413)*(tmp_qloop_146 + tmp_qloop_411*0.5 + tmp_qloop_412*0.5 + tmp_qloop_413*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_410)*(tmp_qloop_256 + tmp_qloop_408*0.5 + tmp_qloop_409*0.5 + tmp_qloop_410*0.5)*2.0));
                   const real_t q_tmp_28_28 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_414 + tmp_qloop_415 + tmp_qloop_416)*(tmp_qloop_343 + tmp_qloop_414*0.66666666666666663 + tmp_qloop_415*0.66666666666666663 + tmp_qloop_416*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_414*1.0 + tmp_qloop_415*1.0 + tmp_qloop_416*1.0)*(tmp_qloop_414*2.0 + tmp_qloop_415*2.0 + tmp_qloop_416*2.0) + (tmp_qloop_144 + tmp_qloop_420 + tmp_qloop_421 + tmp_qloop_422)*(tmp_qloop_146 + tmp_qloop_420*0.5 + tmp_qloop_421*0.5 + tmp_qloop_422*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419)*(tmp_qloop_256 + tmp_qloop_417*0.5 + tmp_qloop_418*0.5 + tmp_qloop_419*0.5)*2.0));
                   const real_t q_tmp_29_29 = tmp_qloop_148*(-tmp_qloop_118*(tmp_qloop_342 + tmp_qloop_423 + tmp_qloop_424 + tmp_qloop_425)*(tmp_qloop_343 + tmp_qloop_423*0.66666666666666663 + tmp_qloop_424*0.66666666666666663 + tmp_qloop_425*0.66666666666666663) + tmp_qloop_118*(tmp_qloop_350 + (tmp_qloop_423*1.0 + tmp_qloop_424*1.0 + tmp_qloop_425*1.0)*(tmp_qloop_423*2.0 + tmp_qloop_424*2.0 + tmp_qloop_425*2.0) + (tmp_qloop_144 + tmp_qloop_429 + tmp_qloop_430 + tmp_qloop_431)*(tmp_qloop_146 + tmp_qloop_429*0.5 + tmp_qloop_430*0.5 + tmp_qloop_431*0.5)*2.0 + (tmp_qloop_255 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428)*(tmp_qloop_256 + tmp_qloop_426*0.5 + tmp_qloop_427*0.5 + tmp_qloop_428*0.5)*2.0));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                const real_t elMatDiag_4 = q_acc_4_4;
                const real_t elMatDiag_5 = q_acc_5_5;
                const real_t elMatDiag_6 = q_acc_6_6;
                const real_t elMatDiag_7 = q_acc_7_7;
                const real_t elMatDiag_8 = q_acc_8_8;
                const real_t elMatDiag_9 = q_acc_9_9;
                const real_t elMatDiag_10 = q_acc_10_10;
                const real_t elMatDiag_11 = q_acc_11_11;
                const real_t elMatDiag_12 = q_acc_12_12;
                const real_t elMatDiag_13 = q_acc_13_13;
                const real_t elMatDiag_14 = q_acc_14_14;
                const real_t elMatDiag_15 = q_acc_15_15;
                const real_t elMatDiag_16 = q_acc_16_16;
                const real_t elMatDiag_17 = q_acc_17_17;
                const real_t elMatDiag_18 = q_acc_18_18;
                const real_t elMatDiag_19 = q_acc_19_19;
                const real_t elMatDiag_20 = q_acc_20_20;
                const real_t elMatDiag_21 = q_acc_21_21;
                const real_t elMatDiag_22 = q_acc_22_22;
                const real_t elMatDiag_23 = q_acc_23_23;
                const real_t elMatDiag_24 = q_acc_24_24;
                const real_t elMatDiag_25 = q_acc_25_25;
                const real_t elMatDiag_26 = q_acc_26_26;
                const real_t elMatDiag_27 = q_acc_27_27;
                const real_t elMatDiag_28 = q_acc_28_28;
                const real_t elMatDiag_29 = q_acc_29_29;
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_6 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag__edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_10 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_11 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_12 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_13 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_14 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_15 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_16 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_17 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_18 + _data_invDiag__edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_19 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_20 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_21 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_22 + _data_invDiag__vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_23 + _data_invDiag__vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_24 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_25 + _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_26 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_27 + _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_28 + _data_invDiag__edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_29 + _data_invDiag__edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
